#include "ones.h"
#include <iostream>
#include <chrono>
#include <vector>

#define maxn 200005
#define maxlog 20
#define INF 1000000010
#define LINF 1000000000000000005
#define endl '\n'
#define pb(x) push_back(x)
#define X first
#define Y second
#define control cerr<<"passed"<<endl;

#pragma GCC optimize("O3" , "Ofast" , "unroll-loops" , "fast-math")
#pragma GCC target("avx2")

using namespace std;

std::chrono::high_resolution_clock::time_point startT, currT;
constexpr double TIME_MULT = 1;

double timePassed()
{
    using namespace std::chrono;
    currT = high_resolution_clock::now();
    double time = duration_cast<duration<double>>(currT - startT).count();
    return time * TIME_MULT;
}

typedef long long ll;
typedef pair <int , int> pii;


vector <pii> interval;
vector <int> ans;


void handle(int l , int r)
{
    int mid = (l + r) / 2;

    if(l == r)
    {
        if(hasOnes(l , r) == 1)
            ans.pb(l);
        return;
    }


    if(hasOnes(l , mid) != 0)
        handle(l , mid);

    if(hasOnes(mid + 1 , r) != 0)
        handle(mid + 1 , r);
}




std::vector<int> guessOnes(int n, int k)
{
    /**int block = n / 2.71828;




    for(int i = 1; i <= n; i += (block + 1))
    {
        int sz = min(block , n - i);

        if(hasOnes(i , i + sz) == 0)
            continue;

        for(int j = i; j <= min(n , i + block); j++)
            if(hasOnes(j , j) == 1)
                ans.pb(j);

    }*/

    handle(1 , n);

    return ans;
}






/**int main()
{

    #ifdef ONLINE_JUDGE /// promeni
        freopen("input.in", "r", stdin);
        freopen("taxi.out", "w", stdout);
    #endif

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    //startT = std::chrono::high_resolution_clock::now();





    return 0;
}*/
