#include "ones.h"
//#include "Lgrader.cpp"
#include <iostream>
#include <chrono>
#include <vector>
#include <algorithm>
#include <cmath>

#define maxn 200005
#define maxlog 20
#define INF 1000000010
#define LINF 1000000000000000005
//#define endl '\n'
#define pb(x) push_back(x)
#define X first
#define Y second
#define control cerr<<"passed"<<endl;

#pragma GCC optimize("O3" , "Ofast" , "unroll-loops" , "fast-math")
#pragma GCC target("avx2")

using namespace std;

std::chrono::high_resolution_clock::time_point startT, currT;
constexpr double TIME_MULT = 1;

double timePassed()
{
    using namespace std::chrono;
    currT = high_resolution_clock::now();
    double time = duration_cast<duration<double>>(currT - startT).count();
    return time * TIME_MULT;
}

typedef long long ll;
typedef pair <int , int> pii;
int n , k;

/**int pref[100000];


void pre()
{
    for(int i = 1; i <= n; i++)
        pref[i] += pref[i - 1];
}


bool hasOnes(int l , int r)
{
    return ((pref[r] - pref[l - 1]) != 0)? true : false;
}

*/
vector <pii> interval;


void handle(int l , int r , vector <int> &ans)
{
    //cout << "---------------" << endl;
    //cout << "-> " << l << " " << r << endl;

    int mid = (l + r) / 2;

    if(l == r)
    {
        if(hasOnes(l , r) == 1)
            ans.pb(l);
        //cout << "---------------" << endl;
        return;
    }

    int ansr = hasOnes(mid + 1 , r);

    if(ansr != 0)
    {
        /**if((r - (mid + 1) + 1) == ansr)
        {
            for(int i = mid + 1; i <= r; i++)
                ans.pb(i);
            return;
        }*/

        handle(mid + 1 , r , ans);
    }
    else
    {
        handle(l , mid , ans);
        return;
    }


    int ansl = hasOnes(l , mid);

    //cout << l << " " << mid << " " << ansl << endl;
    //cout << mid + 1 << " " << r << " " << ansr << endl;

    //cout << "---------------" << endl;



    if(ansl != 0)
    {
        /**if((mid - l + 1) == ansl)
        {
            for(int i = l; i <= mid; i++)
                ans.pb(i);
            return;
        }*/

        handle(l , mid , ans);
    }
}



int find_first_one(int l ,int r , vector <int> &ans)
{
    int mid = (l + r) / 2;
    
    if(l == r)
    {
        ans.pb(l);
        return;
    }
    
    if(hasOnes(l , mid) == 1)
        find_first_one(l , mid);
    else
        find_first_one(mid + 1 , r);
}




std::vector<int> guessOnes(int n, int k)
{
    vector <int> ans;

    int block = n / k;




    /**for(int i = 1; i <= n; i += (block + 1))
    {
        int sz = min(block , n - i);

        if(hasOnes(i , i + sz) == 0)
            continue;

        for(int j = i; j <= min(n , i + block); j++)
            if(hasOnes(j , j) == 1)
                ans.pb(j);

        handle(i , min(i + block , n) , ans);
    }*/
    
    
    
    for(int i = 0; i < k; i++)
    {
        if(i == 0)
            find_first_one(1 , n , ans);
        else
            find_first_one(ans.back() , n , ans);
    }
    
    
    //handle(1 , n , ans);

    sort(ans.begin() , ans.end());

    return ans;
}






/**int main()
{

    #ifdef ONLINE_JUDGE /// promeni
        freopen("input.in", "r", stdin);
        freopen("taxi.out", "w", stdout);
    #endif

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    //startT = std::chrono::high_resolution_clock::now();

    //int n , k;
    cin >> n >> k;

    int x;

    for(int i = 0; i < k; i++)
    {
        cin >> x;
        pref[x]++;
    }
    pre();

    vector <int> q = guessOnes(n , k);

    cout << q.size() << endl;
    for(const auto& e : q)
        cout << e << " ";
    cout << endl;

    return 0;
}*/
