#include "ones.h"

#include<bits/stdc++.h>
#define pb push_back

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

const int maxn=1e6+3;
const int mod=1e9+7;

vector<int> ans;
bool in[maxn];


void ask(int n, int k, int l, int r){
    if(l==r or n==1){
        if(hasOnes(l, l) and !in[l]){
            ans.pb(l);
            in[l]=true;
        }

        return ;
    }

    if(l==r-1){
        if(hasOnes(l, l) and !in[l]){
            ans.pb(l);
            in[l]=true;
        }
        if(hasOnes(r, r) and !in[r]){
            ans.pb(r);
            in[r]=true;
        }

        return ;
    }

    //cerr<<"from "<<l<<" to "<<r<<endl;

    int buck_sz = ceil(sqrt(n));
    //cerr<<"buck_sz="<<buck_sz<<endl;

    for(int i=l; i<=r; i+=buck_sz){
        int ending=i+buck_sz-1;
        ending = min(ending, r);

        //cerr<<"try from "<<i<<" to "<<ending<<endl;

        if(hasOnes(i, ending)){
            //cerr<<"know that somewhere betw "<<i<<" and "<<ending<<endl;
            //cerr<<"ok, go from "<<i<<" to "<<ending;
            ask(buck_sz, k, i, ending);
        }else{
            //cerr<<"no 1's"<<endl;
        }
    }

    return ;
}

vector<int> guessOnes(int n, int k){
    ans.clear();
    for(int i=0; i<maxn; i++) in[i]=false;
    //ask(n, k, 1, n);

    std::random_device rd;
    std::map<int, int> hist;
    std::uniform_int_distribution<int> dist(1, n);
    vector<int> tried;

    for(int i=0; i<=max(n/10, k*10); i++){
        int curr=dist(rd);
        while(in[curr]){
            int curr=dist(rd);
        }
        in[curr]=true;
        tried.pb(curr);
    }

    for(int i=0; i<maxn; i++) in[i]=false;

    for(auto x: tried){
        if(hasOnes(x, x) and !in[x]){
            ans.pb(x);
            if(ans.size()==k) break;
        }
    }

    sort(ans.begin(), ans.end());
    //cerr<<"FINAL"<<endl;
    //for(auto x: ans) cout<<x<<" ";
    //cout<<endl;

    return ans;
}
