#include "ones.h"

#include<bits/stdc++.h>
#define pb push_back

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

const int maxn=1e6+3;
const int mod=1e9+7;

vector<int> ans;
bool in[maxn];

void ask(int n, int k, int l, int r){
    if(l==r or n==1){
        if(hasOnes(l, l) and !in[l]){
            ans.pb(l);
            in[l]=true;
        }

        return ;
    }

    if(l==r-1){
        if(hasOnes(l, l) and !in[l]){
            ans.pb(l);
            in[l]=true;
        }
        if(hasOnes(r, r) and !in[r]){
            ans.pb(r);
            in[r]=true;
        }

        return ;
    }

    //cerr<<"from "<<l<<" to "<<r<<endl;

    int buck_sz = ceil(sqrt(n));
    //cerr<<"buck_sz="<<buck_sz<<endl;

    for(int i=l; i<=r; i+=buck_sz){
        int ending=i+buck_sz-1;
        ending = min(ending, r);

        //cerr<<"try from "<<i<<" to "<<ending<<endl;

        if(hasOnes(i, ending)){
            //cerr<<"know that somewhere betw "<<i<<" and "<<ending<<endl;
            //cerr<<"ok, go from "<<i<<" to "<<ending;
            ask(buck_sz, k, i, ending);
        }else{
            //cerr<<"no 1's"<<endl;
        }
    }

    return ;
}
int times=0;

void ask_bin(int n, int k, int l, int r){
    times++;
    int mid=(l+r)/2;

    if(ans.size()==k) return ;

    if(l==r){
        //cerr<<"l=r="<<l<<endl;
        if(!in[l]){
            if(hasOnes(l, l)){
                ans.pb(l);
                in[l]=true;
            }
        }
        return ;
    }
    //cerr<<"came to l="<<l<<" r="<<r<<endl;

    if(hasOnes(l, mid)){
        if(times>=3){
            ask(n, k, l, mid);
        }else ask_bin(n, k, l, mid);
    }
    if(hasOnes(mid+1, r)){
        if(times>=3){
            ask(n, k, mid+1, r);
        }else ask_bin(n, k, mid+1, r);
    }
}

vector<int> guessOnes(int n, int k){
    ans.clear();
    for(int i=0; i<maxn; i++) in[i]=false;
    ask_bin(n, k, 1, n);

    sort(ans.begin(), ans.end());
    //cerr<<"FINAL"<<endl;
    //for(auto x: ans) cout<<x<<" ";
    //cout<<endl;

    return ans;
}
