#include <bits/stdc++.h>
using namespace std;
const int mod=1e8+543;
struct help
{
    long long o,d,t,f;
    help(){}
    help(long long _o,long long _d,long long _t,long long _f)
    {
        o=_o;
        d=_d;
        t=_t;
        f=_f;
    }
};
vector<help> v;
long long b[1000001];
void prec()
{
    v.push_back({0,0,0,0});
    v.push_back({1,0,0,0});
    v.push_back({0,1,0,0});
    v.push_back({0,0,1,0});
    v.push_back({0,0,0,1});
    b[1]=1;
    b[2]=2;
    b[3]=3;
    b[4]=4;

    for(long long i=5;i<=1e6;i++)
    {
        help h={0,0,0,0};
        for(long long y=1;y<=5;y++)
        {
            long long j=5-y+1;
            h.o+=j*v[i-y].o;
            h.d+=j*v[i-y].d;
            h.t+=j*v[i-y].t;
            h.f+=j*v[i-y].f;
            h.o%=mod;
            h.d%=mod;
            h.t%=mod;
            h.f%=mod;
        }

        v.push_back(h);
        b[i]=(h.o+h.d*2+h.t*3+h.f*4)%mod;
        //cout<<i<<" "<<b[i]<<endl;
        //cout<<h.o<<" "<<h.d<<" "<<h.t<<" "<<h.f<<endl;
    }
}


long long n;
long long q;

long long a[1000001];

help change(long long x)
{
    return v[x];
}


long long t[4000001][5];
void update(long long i,long long l,long long r,long long idx,long long val,long long num)
{
    if(l==r)
    {
        //cout<<t[i][num]<<endl;
        t[i][num]+=val;
        t[i][num]%=mod;
        //cout<<i<<" "<<num<<" "<<t[i][num]<<endl;
        return;
    }
    long long m=(l+r)/2;
    if(idx<=m)update(i*2,l,m,idx,val,num);
    else update(i*2+1,m+1,r,idx,val,num);
    t[i][num]=t[i*2][num]+t[i*2+1][num];
    t[i][num]%=mod;
}
long long value(long long i)
{
    return (t[i][1]+t[i][2]*2+t[i][3]*3+t[i][4]*4)%mod;
}
long long query(long long i,long long l,long long r,long long ql,long long qr)
{
    if(ql>qr)return 0;
    if(ql<=l&&r<=qr)
    {
        //cout<<i<<" "<<l<<" "<<r<<" "<<t[i][1]<<" "<<t[i][2]<<" "<<t[i][3]<<" "<<t[i][4]<<endl;
        return value(i);
    }
    long long m=(l+r)/2;
    return (query(i*2,l,m,ql,min(qr,m))+query(i*2+1,m+1,r,max(ql,m+1),qr))%mod;
}
void read()
{
    cin>>n>>q;
    for(long long i=1;i<=n;i++)
    {
        cin>>a[i];
        help cr=change(a[i]);
        //cout<<cr.o<<" "<<cr.d<<" "<<cr.t<<" "<<cr.f<<endl;
        update(1,1,n,i,cr.o,1);
        update(1,1,n,i,cr.d,2);
        update(1,1,n,i,cr.t,3);
        update(1,1,n,i,cr.f,4);
    }
}

void solve()
{
    for(long long i=1;i<=q;i++)
    {
        long long tp,l,r,val;
        cin>>tp;
        if(tp==1)
        {
            cin>>l>>r;
            cout<<query(1,1,n,l,r)<<endl;
        }
        else
        {
            cin>>l>>r>>val;
        }
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    prec();
    memset(t,0,sizeof(t));
    read();
    solve();
    return 0;
}
