#include <bits/stdc++.h>
#define endl "\n"

using namespace std;

const long long mod = 1e8 + 543;
const int maxn = 1e5+5;

struct matrix
{
    long long c[5][5];
    matrix()
    {
        for(int i = 0; i < 5; i++)
            for(int j = 0; j < 5; j++) c[i][j] = 0;
    }
    matrix mult(matrix &b)
    {
        matrix res;
        for(int i = 0; i < 5; i++)
        {
            for(int j = 0; j < 5; j++)
            {
                res.c[i][j] = 0;
                for(int k = 0; k < 5; k++)
                {
                    res.c[i][j] += (c[i][k]*b.c[k][j])%mod;
                    res.c[i][j] %= mod;
                }
            }
        }
        return res;
    }
};

matrix base;

int n,q;
long long a[maxn];

int ql,qr;
long long val;

int viii[25] = {1,2,3,4,5,5,11,17,23,29,29,63,98,133,168,168,365,567,770,973,973,2114,3284,4459,5635};

void pre()
{
    int ind = 0;
    for(int j = 0; j < 5; j++)
    {
        for(int i = 0; i < 5; i++)
        {
            base.c[i][j] = viii[ind];
            ind++;
        }
    }
    /*for(int i = 0; i < 5; i++)
    {
        for(int j = 0; j < 5; j++)
        {
            cout << base.c[i][j] << " ";
        }
        cout << endl;
    }*/
}

long long step(long long b, int ost)
{
    matrix res;
    matrix sss = base;
    for(int j = 0; j < 5; j++) res.c[0][j] = j;
    while(b>0)
    {
        if(b%2) res = res.mult(sss);
        b /= 2;
        sss = sss.mult(sss);
    }
    return res.c[0][ost];
}

long long find_x(long long ch)
{
    return step(ch/(long long)5,ch%5);
}

void update(int v, int l, int r)
{
    a[qr] += val;
    a[qr] %= mod;
}

long long query(int v, int l, int r)
{
    return find_x(a[qr]);
}

void read()
{
    pre();
    cin >> n >> q;
    for(int i = 1; i <= n; i++) cin >> a[i];
    int type;
    for(int i = 1; i <= q; i++)
    {
        cin >> type >> ql >> qr;
        if(type==1)
        {
            cout << query(1,1,n) << endl;
        }
        else
        {
            cin >> val;
            update(1,1,n);
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    return 0;
}
