#include <bits/stdc++.h>
#define MAXN 100016
#define MAXQ 200016
#define MAXX 1000008
#define endl '\n'
using namespace std;
long long a[MAXN];
const long long mod = 100000543;
map<long long,long long> x;
long long xa[MAXN];
long long n;
void build()
{
    for (long long i=0; i<=n; i++)
    {
        long long p = i + (i & -i);
        if ( p <= n )
        {
            xa[p] = ((long long)xa[p] + xa[i]) % mod;
            //  ////cerr << "xa[" << p << "]=" << xa[p] << endl;
            //   xa[p] %= mod;
        }
    }
}
long long sum(long long i)
{
    long long ret = 0;
    while ( i > 0 )///
    {
        ret = ((long long)ret + xa[i] ) % mod;
        //    ret %= mod;
        i -= (i & -i);
    }
    return ret;
}
void update(long long i, long long val)
{
    while (i <= n )
    {
        xa[i] += val;
        xa[i] %= mod;
        i += (i & -i);
    }
}
long long query(long long l, long long r)
{
    ////cerr <<  sum(r) << " "<< sum(l-1) << endl;
    long long ret = sum(r) - sum(l-1);
    if ( ret < 0 ) ret += mod;
    return ret;
}
long long ca[MAXN];
pair<long long,pair<long long,long long>> q[MAXQ];
long long ch[MAXQ];
set<long long> vals;
int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    long long  Q;
    cin >> n >> Q;
    for (long long i=1; i<=n; i++)
    {
        cin >> a[i];
        ca[i] = a[i];
        vals.insert(a[i]);
    }

    for (long long h=0; h<Q; h++)
    {
        long long t, l, r;
        cin >> t >> l >> r;

        if ( t == 2 )
        {
            long long val;

            cin >> val;
            ch[h] = val;
            ca[l] += val;
            vals.insert(ca[l]);
        }

        q[h].first = t;
        q[h].second = {l, r};
    }
    long long x0, x1, x2, x3, x4;
    x0 = 0;
    x1 = 1;
    x2 = 2;
    x3 = 3;
    x4 = 4;
    x[0] = 0;
    x[1] = 1;
    x[2] = 2;
    x[3] = 3;
    x[4] = 4;
    long long xk;
    for (long long k=5; k<MAXX-4; k++)
    {
        xk = ( (long long)x4*5 + 4*x3 + 3*x2 + 2*x1 + 1*x0 ) % mod;
        x0 =x1;
        x1 = x2;
        x2 = x3;
        x3 = x4;
        x4 = xk;

        if ( vals.find(k) != vals.end() )
        {
            x[k] = xk;
        }

        //  x[k] %= mod;
    }
    for (long long i=1; i<=n; i++)
    {
        xa[i] = x[ a[i] ];
    }

    build();


    for (long long h=0; h<Q; h++)
    {
        long long t, l, r;
        t = q[h].first;
        l = q[h].second.first;
        r = q[h].second.second;

        if ( t == 1 )
        {
            cout << query(l, r) << endl;
        }
        else
        {
            a[l] += ch[h]; // l == r

            long long change = x[ a[l] ] - xa[l];
            //cerr <<  ch[h] << endl;;
            //cerr << "change = " << xa[l] << "-"  << x[ a[l] ] << endl;

            //xa[l] = x[ a[l] ];
            update(l, change);
        }


    }

}
/**
1 5
1
1 1 1
2 1 1 6
1 1 1
2 1 1 -1
1 1 1
----------
1
1330
230
===========
1 1
1
1 1 1
--------------
1
*/
