#include<iostream>
#define MAXN 100010
#define MOD 100000543
#define MAXV 10000001
using namespace std;
int a[MAXN];
long long p[MAXV];
long long tree[4*MAXN];
void calc()
{
    p[1]=1;
    p[2]=2;
    p[3]=3;
    p[4]=4;
    for(int i=5;i<=MAXV;i++)
    {
        long long val=(5*p[i-1])%MOD;
        p[i]=val;
        val=(4*p[i-2])%MOD;
        p[i]+=val;
        p[i]%=MOD;
        val=(3*p[i-3])%MOD;
        p[i]+=val;
        p[i]%=MOD;
        val=(2*p[i-4])%MOD;
        p[i]+=val;
        p[i]%=MOD;
        p[i]+=p[i-5];
        p[i]%=MOD;
    }
}
void build(int ind, int l, int r)
{
    if(l==r){tree[ind]=p[a[l]];return;}
    int mid=(l+r)>>1;
    int left=ind<<1,right=left|1;
    build(left,l,mid);
    build(right,mid+1,r);
    tree[ind]=(tree[left]+tree[right])%MOD;
}
long long query(int ind, int l, int r, int ql, int qr)
{
    if(qr<l || r<ql)return 0;
    if(ql<=l && r<=qr)return tree[ind]%MOD;
    int mid=(l+r)>>1;
    int left=ind<<1,right=left|1;
    return (query(left,l,mid,ql,qr)+query(right,mid+1,r,ql,qr))%MOD;
}
int main()
{
    int n,q;
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin>>n>>q;
    for(int i=1;i<=n;i++)
    {
        cin>>a[i];
    }
    calc();
    build(1,1,n);
    for(int i=0;i<q;i++)
    {
        int t,l,r;
        cin>>t>>l>>r;
        if(t==1)
        {
            cout<<query(1,1,n,l,r)%MOD<<"\n";
        }
        else
        {
            int val;
            cin>>val;
            a[l]+=val;
        }
    }
}