#include<iostream>
using namespace std;
const int MAXN = 1e6+7;
const int MOD = 1e8+543;
int x[MAXN],a[MAXN];
int tree[4*MAXN];
void build_tree(int ind,int l,int r){
    if(l==r){
        tree[ind]=x[a[l]];
        return;
    }
    int m = (l+r)/2;
    build_tree(2*ind,l,m);
    build_tree(2*ind+1,m+1,r);
    tree[ind]=tree[2*ind]+tree[2*ind+1];
    tree[ind]%=MOD;
}
int query(int ind,int l,int r,int ql,int qr){
    if(ql<=l and r<=qr){
        return tree[ind];
    }
    int m = (l+r)/2;
    int sum = 0;
    if(ql<=m) sum=query(2*ind,l,m,ql,qr);
    if(qr>m) sum+=query(2*ind+1,m+1,r,ql,qr);
    return sum%MOD;
}
int main () {
    x[0]=0;
    x[1]=1;
    x[2]=2;
    x[3]=3;
    x[4]=4;
    x[5]=40;
    for(int i=6;i<=MAXN;i++){
        x[i]=5*x[i-1]+4*x[i-2]+3*x[i-3]+2*x[i-4]+x[i-5];
        x[i]%=MOD;
    }
    int n,q;
    cin>>n>>q;
    for(int i=0;i<n;i++) cin>>a[i];
    build_tree(1,0,n-1);
    int type,ql,qr;
    while(q--){
        cin>>type>>ql>>qr;
        ql--;
        qr--;
        cout<<query(1,0,n-1,ql,qr)<<"\n";
    }
}
