#include<iostream>
#include<algorithm>
#include "ones.h"
using namespace std;
const double coeff=0.50001;
int rem;
vector<int> rez;

void solve(int l,int r)
{
    if(rem==0 || l>r) return;
    if(l==r)
    {
        if(hasOnes(l,r))
        {
        rez.push_back(l);
        rem--;
        }
        return;
    }
    if(rem==0) return;
    double d1=coeff*((double)r-l+1);
    int d=d1;

    if(l+d<r) d++;

    int l1=l,r1=l1+d-1;
    int l2=r-d+1,r2=r;

   // cout<<l1<<" "<<r1<<" "<<l2<<" "<<r2<<endl;

    if(l1==r1 && l2==r2)
    {
        solve(l1,r1);
        solve(l2,r2);
        return;
    }
    bool is01=hasOnes(l1,r1),is02=hasOnes(l2,r2);

    if(!is01 && !is02)
       {
           return;
       }

    if(!is01)
    {
        if(r1+1==r)
        {
            rez.push_back(r);
            rem--;
        }
        else solve(r1+1,r);
        return;
    }
    if(!is02)
    {
        if(l==l2-1)
        {
            rez.push_back(l);
            rem--;
        }
        solve(l,l2-1);
        return;
    }
    int mid=(l+r)/2;

    if(l==mid && mid+1==r)
    {
        rem-=2;
        rez.push_back(l);
        rez.push_back(r);
        return;
    }
    solve(l,mid);
    solve(mid+1,r);
}
std::vector<int> guessOnes(int n, int k)
{
    rem=k;
    rez.clear();
    solve(1,n);
    sort(rez.begin(),rez.end());

    return rez;

}
/*
87 4 3
1 7 23 78

765 8 2
3 8 76 278 732 745 755 765
*/
