#include <iostream>
#include "ones.h"
#include <vector>
using namespace std;

vector <int> ans;

void binary(int l, int r, int k)
{
    if(l==r)
    {
        if(hasOnes(l, r))
        {
            ans.push_back(l);
        }
        return;
    }
    if(k==ans.size())
    {
        return;
    }
    else if(l-r>1)
    {
        int mid1=(l*2+r)/3;
        int mid2=(l+r*2)/3;
        if(hasOnes(l, mid1))
        {
            binary(l, mid1, k);
        }
        if(hasOnes(mid1+1, mid2))
        {
            binary(mid1+1, mid2, k);
        }
        if(hasOnes(mid2+1, r))
        {
            binary(mid2+1, r, k);
        }
    }
    else
    {
        int mid=(l+r)/2;
        if(hasOnes(l, mid))
        {
            binary(l, mid, k);
        }
        if(hasOnes(mid+1, r))
        {
            binary(mid+1, r, k);
        }
    }
}

vector<int> guessOnes(int n, int k)
{
    ans.clear();
    int p=n/k;
    for(int i=1; i<=n; i+=k)
    {
        if(hasOnes(i, min(i+k-1, n)))
        {
            binary(i, min(i+k-1, n), k);
        }
        if(ans.size()==k)
        {
            break;
        }
    }
    return ans;
}
