#include <iostream>
#include "ones.h"
#include <vector>
using namespace std;

vector <int> ans;

void binary(int l, int r, int n, int k)
{
    if(l==r)
    {
        if(hasOnes(l, r))
        {
            ans.push_back(l);
        }
        return;
    }
    if(k==ans.size())
    {
        return;
    }
    else if(l-r>1)
    {
        int p=n/(k-ans.size());
        for(int i=1; i<=n; i+=k)
        {
            if(hasOnes(i, min(i+k-1, n)))
            {
                binary(i, min(i+k-1, n), p, k);
            }
        }
    }
    else
    {
        int mid=(l+r)/2;
        if(hasOnes(l, mid))
        {
            binary(l, mid, mid-l+1, k);
        }
        if(hasOnes(mid+1, r))
        {
            binary(mid+1, r, r-mid, k);
        }
    }
}

vector<int> guessOnes(int n, int k)
{
    ans.clear();

    binary(1, n, n, k);

    return ans;
}
