#include <iostream>
#include <vector>
#include "ones.h"
using namespace std;

vector <int> ans;

void binary(int l, int r)
{
    if(l==r)
    {
        if(hasOnes(l, r))
        {
            ans.push_back(l);
        }
        return;
    }
    else
    {
        int mid=(l+r)/2;
        if(hasOnes(l, mid))
        {
            binary(l, mid);
        }
        if(hasOnes(mid+1, r))
        {
            binary(mid+1, r);
        }
    }
}

vector<int> guessOnes(int n, int k)
{
    ans.clear();
    int l, r;
    l=1;
    r=1;
    while(ans.size()!=k)
    {
        if(hasOnes(l, r))
        {
            binary((l+r+1)/2, r);
            r=min(n, r+1);
            l=r;
        }
        else
        {
            r=min(n, r+(r-l+1));
        }
    }
    return ans;
}
