#include <iostream>
#include <vector>
#define MAX_N 100005
using namespace std;

const long long M = 1e8+543;
vector<long long> nums;
int a[MAX_N];
long long sum[MAX_N];
int biggest;
int n, q;

int calc_x(int ai)
{
    if(ai<=biggest)
    {
        return nums[ai];
    }
    else
    {
        for(int i=biggest+1; i<=ai; i++)
        {
            nums.push_back(((5*nums[i-1])%M+(4*nums[i-2])%M+(3*nums[i-3])%M+(2*nums[i-4])%M+nums[i-5])%M);
        }
    }
    biggest=ai;
    return nums[ai];
}

void update(int index)
{
    long long add=calc_x(a[index]);
    for(int i=index; i<=n; i+=(i&(-i)))
    {
        //cout << sum[i] << endl;
        sum[i]=(sum[i]+add)%M;
    }
}

long long qu(int s)
{
    long long ans=0;
    for(int i=s; i>=1; i-=(i&(-i)))
    {
        ans=(ans+sum[i])%M;
    }
    return ans;
}

long long query(int l, int r)
{
    return ((qu(r)-qu(l-1)+M)%M);
}

int main()
{
    //cout << M << endl;
    nums.resize(7);
    nums[0]=0;
    nums[1]=1;
    nums[2]=2;
    nums[3]=3;
    nums[4]=4;
    nums[5]=40;
    nums[6]=230;
    biggest=6;

    cin >> n >> q;
    for(int i=1; i<=n; i++)
    {
        cin >> a[i];
        update(i);
    }

    /*for(int i=1; i<=n; i++)
    {
        cout << sum[i] << endl;
    }*/

    int t, r, l, value;

    for(int i=0; i<q; i++)
    {
        cin >> t >> l >> r;
        if(t==1)
        {
            cout << query(l, r) << endl;
        }
        else if(t==2 and r==l)
        {
            cin >> value;
            a[r]=a[r]+value;
            update(r);
        }
    }

    return 0;
}
