#include<iostream>
#include<algorithm>
#include<cmath>
#include<queue>
#include<deque>
#include<vector>
#include<stack>
using namespace std;
const long long MOD=1e8+543;
long long initp[5][5]={{5,1,0,0,0},{4,0,1,0,0},{3,0,0,1,0},{2,0,0,0,1},{1,0,0,0,0}};
long long initbeg[5][5]={{4,3,2,1,0},{0,0,0,0,0},{0,0,0,0,0},{0,0,0,0,0},{0,0,0,0,0}};
long long add(long long a,long long b)
{
    long long res=1LL*a+1LL*b;
    res%=MOD;
    return res;
}
long long mul(long long a,long long b)
{
    long long res=1LL*a*1LL*b;
    res%=MOD;
    return res;
}
struct T
{
    long long matri[5][5];
};
T p,beg,nul;
T multa(T a,T b)
{
    T c=nul;
    for(long long i=0;i<5;i++)
    {
        for(long long j=0;j<5;j++)
        {
            for(long long k=0;k<5;k++)
            {
                c.matri[i][j]=add(c.matri[i][j],mul(a.matri[i][k],b.matri[k][j]));
            }
        }
    }
    return c;
}
T st(T cur,long long step)
{
    if(step==1LL)return cur;
    T ne=st(cur,step/2LL);
    ne=multa(ne,ne);
    if(step%2LL==1LL)ne=multa(ne,cur);
    return ne;
}
long long kth(long long pos)
{
    if(pos<=4LL)return pos;
    long long step=pos-4LL;
    /*T ne=beg;
    while(step--)
    {
        ne=multa(ne,p);
    }
    return ne.matri[0][0];*/
    T ne=beg;
    ne=multa(ne,st(p,step));
    //ne=multa(ne,beg);
    return ne.matri[0][0];
}

const long long MAX_N=1e6+4;
long long a[MAX_N];
long long n,q;
signed main ()
{
    for(long long i=0;i<5;i++)
    {
        for(long long j=0;j<5;j++)
        {
            nul.matri[i][j]=0;
            p.matri[i][j]=initp[i][j];
            beg.matri[i][j]=initbeg[i][j];
        }
    }
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n>>q;
    for(long long i=1;i<=n;i++)
    {
        cin>>a[i];
    }
    while(q--)
    {
        long long type,l,r,value;
        cin>>type>>l>>r;
        if(type==1)
        {
            cout<<kth(a[l])<<"\n";
        }
        else
        {
            cin>>value;
            a[l]=value;
        }
    }
    return 0;
}
