#include<iostream>
#include<algorithm>
#include<cmath>
#include<queue>
#include<deque>
#include<vector>
#include<stack>
using namespace std;
const int MOD=1e8+543;
int initp[5][5]={{5,1,0,0,0},{4,0,1,0,0},{3,0,0,1,0},{2,0,0,0,1},{1,0,0,0,0}};
int initbeg[5][5]={{4,3,2,1,0},{0,0,0,0,0},{0,0,0,0,0},{0,0,0,0,0},{0,0,0,0,0}};
int add(int a,int b)
{
    int res=a+b;
    res%=MOD;
    return res;
}
int mul(int a,int b)
{
    long long res=1LL*a*1LL*b;
    res%=MOD;
    return res;
}
struct T
{
    int matri[5][5];
};
T p,beg,nul;
T c;
int i,j,k;
T multa(const T a,const T b)
{
    c=nul;
    i,j,k;
    for(i=0;i<5;++i)
    {
        for(j=0;j<5;++j)
        {
            for(k=0;k<5;++k)
            {
                c.matri[i][j]=add(c.matri[i][j],mul(a.matri[i][k],b.matri[k][j]));
            }
        }
    }
    return c;
}
T st(const T cur,const int step)
{
    if(step==1)return cur;
    T ne=st(cur,step/2);
    ne=multa(ne,ne);
    if(step%2==1)ne=multa(ne,cur);
    return ne;
}
int kth(int pos)
{
    if(pos<=4)return pos;
    int step=pos-4;
    T ne=beg;
    ne=multa(ne,st(p,step));
    return ne.matri[0][0];
}

const int MAX_N=1e5+4;
int a[MAX_N];
int n,q;
signed main ()
{
    for(int i=0;i<5;i++)
    {
        for(int j=0;j<5;j++)
        {
            nul.matri[i][j]=0;
            p.matri[i][j]=initp[i][j];
            beg.matri[i][j]=initbeg[i][j];
        }
    }
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n>>q;
    for(int i=1;i<=n;i++)
    {
        cin>>a[i];
    }
    while(q--)
    {
        int type,l,r,value;
        cin>>type>>l>>r;
        if(type==1)
        {
            cout<<kth(a[l])<<"\n";
        }
        else
        {
            cin>>value;
            a[l]=value;
        }
    }
    return 0;
}
