#include <iostream>
#include <vector>
#include "ones.h"

using namespace std;

int last_index(int i, int n) {
    int l = i;
    int r = n;

    while (l <= r) {
        int m = (l + r) / 2;
        if (hasOnes(i, m)) {
            r = m - 1;
        }
        else {
            l = m;
        }
    }

    return l;
}

vector <int> guessOnes(int n, int k) {
    vector <int> result;

    int idx = 0;
    while (true) {
        int l = last_index(idx, n);
        for (idx = l + 1; idx <= n && hasOnes(idx, idx); idx++) result.push_back(idx);
    }
}
