#include "ones.h"

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

void find_ones(int l, int r, int k, vector<int> &result) {
    if (l > r) {
        return;
    }

    if (l == r) {
        if (hasOnes(l, r)) {
            result.push_back(l);
        }

        return ;
    }

    int mid = (l + r) / 2;

    find_ones(l, mid, k, result);

    if ((int) result.size() == k) {
        return;
    }
    
    find_ones(mid + 1, r, k, result);
}

vector<int> guessOnes(int n, int k) {
    vector<int> result;

    find_ones(1, n, k, result);

    sort(result.begin(), result.end());

    return result;
}
