#include<iostream>
using namespace std;
long long x[1000001];
const long long MOD = 1e8 + 543;
long long n, q, orgN;
long long a[100000];
long long type, l, r, value;

long long segmentTree[131072*3]; ///131,072
void setup(long long ind, long long otK, long long doK){
    //cout<<"setup "<<ind<<" "<<otK<<" "<<doK<<"\n";
    if(otK == doK-1){
        if(otK<orgN){
            segmentTree[ind] = x[a[otK]];
        }else{
            segmentTree[ind] = 0;
        }
        return;
    }

    setup(ind*2+1, otK, (otK+doK)/2);
    setup(ind*2+2, (otK+doK)/2, doK);
    segmentTree[ind] = (segmentTree[ind*2+1] + segmentTree[ind*2+2])%MOD;
}
long long query(long long l, long long r, long long ind, long long otK, long long doK){
    if(l<=otK && doK-1<=r){
        return segmentTree[ind]%MOD;
    }
    if(r<otK || doK<=l){
        return 0;
    }
    return (query(l, r, ind*2+1, otK, (otK+doK)/2) + query(l, r, ind*2+2, (otK+doK)/2, doK))%MOD;
}


void extend(){
    long long newN = 1;
    while(newN<n){
        newN *= 2;
    }
    n = newN;
}

int main(){
    x[0] = 0;
    x[1] = 1;
    x[2] = 2;
    x[3] = 3;
    x[4] = 4;
    for(long long i=5; i<=1000000; i++){
        x[i] = 5*x[i-1] + 4*x[i-2] + 3*x[i-3]+ 2*x[i-4] + 1*x[i-5];
        x[i] %= MOD;
        //cout<<i<<" - "<<x[i]<<"\n";
    }

    cin>>n>>q;
    for(long long i=0; i<n; i++){
        cin>>a[i];
    }
    orgN = n;
    extend();
    ///cout<<n<<"\n";
    setup(0, 0, n);

    for(long long br=0; br<q; br++){
        cin>>type>>l>>r;
        l--; r--;
        if(type==1){
            cout<<query(l, r, 0, 0, n)<<"\n";
        }else{
            cin>>value;
        }
    }
    return 0;
}
/*
5 2
1 2 3 4 5
1 2 3
1 2 5


5
49
*/
