#include<bits/stdc++.h>
using namespace std;
const int M = 100000543;
int N, Q;
int indexi[1000000];
int dp[10000000];
void build()
{
    dp[0] = 0;
    dp[1] = 1;
    dp[2] = 2;
    dp[3] = 3;
    dp[4] = 4;
    for(int i = 5; i < 40000; i++)
    {
        dp[i] = (((((5 * dp[i-1]) % M + 4 * dp[i-2]) % M + 3 * dp[i-3]) % M + 2 * dp[i-4]) % M + dp[i-5]) % M;
    }
}
int query(int l, int r)
{
    int sum = 0;
    for(int i = l; i <= r; i++)
    {
        sum += dp[indexi[i]] % M;
    }
    return sum;
}
void update(int l, int r, int v)
{
    for(int i = l; i <= r; i++)
    {
        indexi[i] += v;
    }
}
int main ()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> N >> Q;
    for(int i = 1; i <= N; i++)
    {
        cin >> indexi[i];
    }
    build();
    for(int i = 0; i < Q; i++)
    {
        int A, l, r, v;
        cin >> A >> l >> r;
        if(A == 1)
        {
            cout << query(l, r) << endl;
        }
        else
        {
            cin >> v;
            update(l, r, v);
        }
    }
    return 0;
}

