#include<bits/stdc++.h>
using namespace std;
const int M = 100000543;
int N, Q;
int masiv[1000002];
int indexi[1000002];
int dp[1000002];
int dp_max = 4;
int calc(int n)
{
    if(dp[n] != 0)
    {
        return dp[n];
    }
    for(int i = dp_max+1; i <= n; i++)
    {
        dp[i] = (((((5 * dp[i-1]) % M + 4 * dp[i-2]) % M + 3 * dp[i-3]) % M + 2 * dp[i-4]) % M + dp[i-5]) % M;
    }
    dp_max = n;
    return dp[n];
}
int build(int nach, int kraj, int index)
{
    if(nach == kraj)
    {
        masiv[index] = calc(indexi[nach]);
        return masiv[index];
    }
    int mid = (nach + kraj - 1) / 2;
    masiv[index] = (build(nach, mid, mid*2) + build(mid+1, kraj, mid*2+1)) % M;
    return masiv[index];
}
int query(int l, int r, int nach, int kraj, int index)
{
    if(nach <= l and nach <= r and kraj <= r and kraj >= l)
    {
        return masiv[index];
    }
    if(l > kraj or r < nach)
    {
        return 0;
    }
    int mid = (nach + kraj - 1) / 2;
    return (query(l, r, nach, mid, mid*2) + query(l, r, mid+1, kraj, mid*2+1)) % M;
}
int update(int l, int r, int nach, int kraj, int index, int v)
{
    if(nach == kraj)
    {
        indexi[nach] += v;
        masiv[index] = calc(indexi[nach]);
        return masiv[index];
    }
    if(kraj < l or nach > r)
    {
        return masiv[index];
    }
    int mid = (nach + kraj - 1) / 2;
    masiv[index] = (update(l, r, nach, mid, mid*2, v) + update(l, r, mid+1, kraj, mid*2+1, v)) % M;
    return masiv[index];
}
int main ()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> N >> Q;
    dp[0] = 0;
    dp[1] = 1;
    dp[2] = 2;
    dp[3] = 3;
    dp[4] = 4;
    for(int i = 1; i <= N; i++)
    {
        cin >> indexi[i];
    }
    build(1, N, 0);
    for(int i = 0; i < Q; i++)
    {
        int A, l, r, v;
        cin >> A >> l >> r;
        if(A == 1)
        {
            cout << query(l, r, 1, N, 0) << endl;
        }
        else
        {
            cin >> v;
            update(l, r, 1, N, 0, v);
        }
    }
    return 0;
}

