#include <bits/stdc++.h>
#include<chrono>
using namespace std;

long long const mod=1e8+543;
map<long long, long long>memo;

long long modf(long long x)
{
    return (x+mod)%mod;
}

long long x(long long n)
{
    int sz=memo.size();
    auto it=memo.find(n);
    if(it!=memo.end())
    {
        return it->second;
    }
    //if(n>=0&&n<=4){br+=1;return n;}
    if(n<0)
    {
        //br+=5;
        int res = modf(modf(x(n+5))-((5*modf(x(n+4)))%mod+(4*modf(x(n+3)))%mod+3*x(n+2)%mod+(2*modf(x(n+1))))%mod);
        if(sz<1000000)memo.insert({n, res});
        return res;
    }
    if(n>4)
    {
        //br+=5;
        int res = modf(modf(x(n-5))+((2*modf(x(n-4)))%mod)+(3*modf(x(n-3)))%mod+(4*modf(x(n-2)))%mod+(5*modf(x(n-1)))%mod);
        if(sz<1000000)memo.insert({n, res});
        return res;
    }
}

long long tree[400001];
long long a[100001];

void build_tree(int i, int l, int r)
{
    if(l==r)
    {
        tree[i]=x(a[l]);
        return;
    }
    int m=(l+r)/2;
    build_tree(2*i, l, m);
    build_tree(2*i+1, m+1, r);
    tree[i]=modf(tree[2*i]+tree[2*i+1]);
}

long long query(int i, int l, int r, int ql, int qr)
{
    if(l==ql&&r==qr)return tree[i];
    int m=(l+r)/2;
    if(qr<=m)
    {
        return query(2*i, l, m, ql, qr);
    }
    if(ql>m)
    {
        return query(2*i+1, m+1, r, ql, qr);
    }
    long long res=modf(query(2*i, l, m, ql, m))+modf(query(2*i+1, m+1, r, m+1, qr));
    return modf(res);

}

void update(int i, int l, int r, int ql, int qr, int val)
{
    if(l==r)
    {
        a[l]+=val;
        tree[i]=x(a[l]);
        return;
    }
    int m=(l+r)/2;
    if(qr<=m)
    {
        update(2*i, l, m, ql, qr, val);
    }
    else if(ql>m)
    {
        update(2*i+1, m+1, r, ql, qr, val);
    }
    else
    {
        update(2*i, l, m, ql, m, val);
        update(2*i+1, m+1, r, m+1, qr, val);
    }
    tree[i]=modf(tree[2*i]+tree[2*i+1]);
}
int n, q;
void read()
{
    cin>>n>>q;
    for(int i=1;i<=n;i++)
    {
        cin>>a[i];
    }
    build_tree(1, 1, n);
    int type, l, r, v;
    while(q--)
    {
        cin>>type>>l>>r;
        if(type==1)
        {
            cout<<query(1, 1, n, l, r)<<endl;
        }
        else
        {
            cin>>v;
            update(1, 1, n, l, r, v);
            /*
            for(int i=l;i<=r;i++)
            {
                cout<<a[i]<<" ";
            }
            cout<<endl;
            for(int i=l;i<=r;i++)
            {
                cout<<x(a[i])<<" ";
            }
            cout<<endl;
            */
        }
    }

}

int main()
{
    memo.insert({0, 0});
    memo.insert({1, 1});
    memo.insert({2, 2});
    memo.insert({3, 3});
    memo.insert({4, 4});
    read();
    return 0;
}
