#include <bits/stdc++.h>
using namespace std;
typedef signed long long ll;

const ll MOD = 1e8+543;
ll mod(ll n){
    return (n%MOD+MOD)%MOD;
}

ll n;
vector<ll> a;
vector<ll> xa;

vector<ll> x0 = {0,1,2,3,4};
void prevX(){
    ll px = 2*x0[0] + 3*x0[1] + 4*x0[2] + 5*x0[3] - x0[4];
    for(ll i = 1; i < 5; i++){ x0[i] = x0[i-1]; }
    x0[0] = -px;
}
void nextX(){
    ll nx = 5*x0[4] + 4*x0[3] + 3*x0[2] + 2*x0[1] + x0[0];
    for(ll i = 0; i < 5; i++){ x0[i] = x0[i+1]; }
    x0[4] = nx;
}

vector<ll> getXs(const vector<ll>& idxs){
    vector<ll> neg, pos;
    for(ll i = 0; i < idxs.size(); i++){
        if(idxs[i] < 0){ neg.push_back(idxs[i]); }
        else           { pos.push_back(idxs[i]); }
    }
    vector<ll> ret;
    if(neg.size() > 0){
        x0 = {0,1,2,3,4};
        ll f = 0, l = 4, idx = neg.size()-1;
        for(; f > neg[idx]; f--, l--){ prevX(); }
        while(f >= neg[0] && idx >= 0){
            if(neg[idx] == f){ neg[idx] = mod(x0[0]); idx--; }
            prevX();
            f--; l--;
        }
        for(int i = 0; i < neg.size(); i++){ ret.push_back(neg[i]); }
    }
    if(pos.size() > 0){
        x0 = {0,1,2,3,4};
        ll f = 0, l = 4, idx = 0;
        for(; l < pos[idx]; f++, l++){ nextX(); }
        while(l <= pos[pos.size()-1] && idx < pos.size()){
            if(pos[idx] == l){
                pos[idx] = mod(x0[ pos[idx] - f ]);
                idx++;
            }
            nextX();
            f++; l++;
        }
        for(int i = 0; i < pos.size(); i++){ ret.push_back(pos[i]); }
    }
    return ret;
}

void build(){
//    ll mn = a[0], mx = a[0];
//    for(ll i = 0; i < n; i++){
//        if(a[i] < mn){ mn = a[i]; }
//        if(a[i] > mx){ mx = a[i]; }
//    }
    vector<pair<int, int>> pos;
    vector<ll> a2(a);
    for(int i = 0; i < n; i++){ pos.push_back({a[i], i}); }
    sort(a2.begin(), a2.end());
    sort(pos.begin(), pos.end());
    vector<ll> xs = getXs(a2);
    for(int i = 0; i < n; i++){
        xa[pos[i].second] = xs[i];
    }
}

void update(ll left, ll right, ll value){
    for(ll i = left; i <= right; i++){
        a[i] += value;
    }
    vector<pair<int, int>> pos;
    vector<ll> a2(a.begin()+left, a.begin()+right+1);
    for(int i = left; i <= right; i++){ pos.push_back({a[i], i}); }
    sort(a2.begin(), a2.end());
    sort(pos.begin(), pos.end());
    vector<ll> xs = getXs(a2);
    for(int i = 0; i < xs.size(); i++){
        xa[pos[i].second] = xs[i];
    }
}
ll query(ll left, ll right){
    ll sum = 0;
    for(ll i = left; i <= right; i++){
        sum = mod(sum + xa[i]);
    }
    return sum;
}

signed main(){
    ll Q;
    cin >> n >> Q;
    a.resize(n);
    xa.resize(n);
    for(ll i = 0; i < n; i++){ cin >> a[i]; }

    build();

    ll type, left, right, value;
    for(ll q = 1; q <= Q; q++){
//        cout << "{ "; for(int i = 0; i < xa.size(); i++){ cout << xa[i] << ' '; } cout << "}\n";
        cin >> type >> left >> right;
        left--; right--;
        if(type == 1){
            cout << query(left, right) << '\n';
        } else {
            cin >> value;
            update(left, right, value);
        }
    }
    return 0;
}
