#include<bits/stdc++.h>
#define endl '\n'
#pragma GCC optimize("O3,unroll-loops")
using namespace std;
typedef long long ll;
const int mod = 1e8 + 543;
const int maxn = 1e5+3;
ll i,j,p,q,n,m,k,Q,ch[maxn],l,r;
struct Matrix
{
    int n,m;
    ll a[5][5];
};
Matrix how,dp,cool[100];
Matrix mul(Matrix a,Matrix b)
{
    Matrix c;
    ///a.m == b.n
    c.n = a.n;c.m = b.m;
    for(int ii=0;ii<c.n;ii++)
        for(int jj=0;jj<c.m;jj++)
            c.a[ii][jj] = 0;
    for(int ii=0;ii<c.n;ii++)
    {
        for(int jj=0;jj<c.m;jj++)
        {
            for(int kk=0;kk<b.n;kk++)
            {
                c.a[ii][jj] += (a.a[ii][kk]*b.a[kk][jj]);
            }
            c.a[ii][jj] %= mod;
        }
    }
    return c;
}

Matrix st(Matrix a,ll n)
{
    Matrix ans;
    ans.n = ans.m = 5;
    for(int ii=0;ii<ans.n;ii++)
        for(int jj=0;jj<ans.m;jj++)
            ans.a[ii][jj] = 0;
    for(int ii=0;ii<5;ii++)
        ans.a[ii][ii] = 1;

    while(n>0)
    {
        if(n&1)
            ans = mul(ans,a);
        a = mul(a,a);
        n/=2;
    }
    return ans;
}
Matrix Find_num(ll who)
{
    dp.n = 5;dp.m = 1;
    dp.a[0][0] = 0;
    dp.a[1][0] = 1;
    dp.a[2][0] = 2;
    dp.a[3][0] = 3;
    dp.a[4][0] = 4;

    Matrix ans;
    ans.n = ans.m = 5;
    for(int ii=0;ii<ans.n;ii++)
        for(int jj=0;jj<ans.m;jj++)
            ans.a[ii][jj] = 0;
    for(int ii=0;ii<5;ii++)
        ans.a[ii][ii] = 1;

    for(long long j=0;(1ll<<j)<=who;j++)
    {
        if(((1ll<<j)&who))
            ans = mul(ans,cool[j]);
    }

    /**
    for(int ii=0;ii<ans.n;ii++)
    {
        for(int jj=0;jj<ans.m;jj++)
        {
            cout<<ans.a[ii][jj]<<" ";
        }
        cout<<endl;
    }
    */
    dp = mul(ans,dp);

    return dp;
}
Matrix a[4*maxn];
ll lz[4*maxn];
Matrix mergee(Matrix a,Matrix b)
{
    Matrix c = a;
    for(int ii=0;ii<5;ii++)
        c.a[ii][0]+=b.a[ii][0];
    return c;
}
void build(int p=1,int l=1,int r=n)
{
    if(l==r)
    {
        a[p] = Find_num(ch[l]-4);
        return ;
    }
    build(p*2,l,(l+r)/2);
    build(p*2+1,(l+r)/2+1,r);
    a[p] = mergee(a[p*2],a[p*2+1]);
}
void push_lazy(int p,int l,int r)
{
    if(lz[p]==0)
        return ;
    if(l!=r)
        lz[p*2]+=lz[p],lz[p*2+1]+=lz[p];


    Matrix ans;
    ans.n = ans.m = 5;
    for(int ii=0;ii<ans.n;ii++)
        for(int jj=0;jj<ans.m;jj++)
            ans.a[ii][jj] = 0;
    for(int ii=0;ii<5;ii++)
        ans.a[ii][ii] = 1;

    for(long long j=0;(1ll<<j)<=lz[p];j++)
    {
        if(((1ll<<j)&lz[p]))
            ans = mul(ans,cool[j]);
    }

    lz[p] = 0;

    a[p] = mul(ans,a[p]);
}
ll query(int ql,int qr,int p=1,int l=1,int r=n)
{
    push_lazy(p,l,r);
    if(ql>r || qr<l)
        return 0;
    if(l>=ql && r<=qr)
    {
        return a[p].a[4][0];
    }
    return (query(ql,qr,p*2,l,(l+r)/2)+query(ql,qr,p*2+1,(l+r)/2+1,r))%mod;
}
void upd(int ql,int qr,ll d,int p=1,int l=1,int r=n)
{
    push_lazy(p,l,r);
    if(ql>r || qr<l)
        return ;
    if(l>=ql && r<=qr)
    {
        lz[p]+=d;
        push_lazy(p,l,r);
        return ;
    }
    upd(ql,qr,d,p*2,l,(l+r)/2);
    upd(ql,qr,d,p*2+1,(l+r)/2+1,r);
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    ///test
 ///    dp = mul(how,dp);
    //cout<<dp.a[4][0]<<endl;
    ///test

    how.n = how.m = 5;
    how.a[0][0] = 0;how.a[0][1] = 1;how.a[0][2] = 0;how.a[0][3] = 0;how.a[0][4] = 0;
    how.a[1][0] = 0;how.a[1][1] = 0;how.a[1][2] = 1;how.a[1][3] = 0;how.a[1][4] = 0;
    how.a[2][0] = 0;how.a[2][1] = 0;how.a[2][2] = 0;how.a[2][3] = 1;how.a[2][4] = 0;
    how.a[3][0] = 0;how.a[3][1] = 0;how.a[3][2] = 0;how.a[3][3] = 0;how.a[3][4] = 1;
    how.a[4][0] = 1;how.a[4][1] = 2;how.a[4][2] = 3;how.a[4][3] = 4;how.a[4][4] = 5;

    ll maxx = 1e16;
    cool[0].n = cool[0].m = 5;
    for(int ii=0;ii<5;ii++)
    {
        for(int jj=0;jj<5;jj++)
        {
            cool[0].a[ii][jj] = how.a[ii][jj];
        }
    }
    for(long long i=1;(1ll<<i)<=maxx;i++)
    {
        cool[i] = mul(cool[i-1],cool[i-1]);
    }
    /*
    dp.n = 5;dp.m = 1;
    dp.a[0][0] = 0;
    dp.a[1][0] = 1;
    dp.a[2][0] = 2;
    dp.a[3][0] = 3;
    dp.a[4][0] = 4;

    dp = mul(cool[1],dp);
    dp = mul(cool[0],dp);
    cout<<dp.a[4][0]<<endl;
    */
    cin>>n>>Q;
    for(i=1;i<=n;i++)
        cin>>ch[i];
    build();
    while(Q--)
    {
        int type;
        cin>>type>>l>>r;
        if(type==1)
        {
            if(ch[l]<5)
            {
                cout<<ch[l]<<endl;
                continue;
            }
            cout<<query(l,r)<<endl;
        }
        else
        {
            cin>>p;
            upd(l,r,p);
        }
    }
    return 0;
}

/**

2 3
5 6
1 1 2
2 1 2 1
1 1 2

*/














