#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const ll mod = 1e8 + 543;
const int maxa = 5;
struct matrix
{
    ll mat[maxa][maxa];

    matrix()
    {
        for (int i = 0; i < maxa; i ++)
            for (int j = 0; j < maxa; j ++)
                mat[i][j] = 0;
    }

    matrix mult(matrix &p)
    {
        matrix res;
        for (int i = 0; i < maxa; i ++)
            for (int j = 0; j < maxa; j ++)
                for (int k = 0; k < maxa; k ++)
                {
                    res.mat[i][j] += mat[i][k] * p.mat[k][j];
                    res.mat[i][j] %= mod;
                }

        return res;
    }
};

/**matrix power(matrix base, ll st)
{

}*/

matrix base_transition;
void init()
{
    base_transition.mat[1][0] = 1;
    base_transition.mat[2][1] = 1;
    base_transition.mat[3][2] = 1;
    base_transition.mat[4][3] = 1;
    base_transition.mat[0][4] = 1;
    base_transition.mat[1][4] = 2;
    base_transition.mat[2][4] = 3;
    base_transition.mat[3][4] = 4;
    base_transition.mat[4][4] = 5;
}

vector < ll > vec_mult(vector < ll > base, matrix cur)
{
    vector < ll > res(maxa, 0);
    for (int i = 0; i < maxa; i ++)
    {
        for (int j = 0; j < maxa; j ++)
        {
            res[j] += base[i] * cur.mat[i][j];
            res[j] %= mod;
        }
    }

    return res;
}


ll values[1000010];
const int maxn = 1e5 + 10;
int n, q;
int a[maxn];
ll pref[maxn];
void input()
{
    cin >> n >> q;
    for (int i = 1; i <= n; i ++)
    {
        cin >> a[i];
    }
}

void compute()
{
    vector < ll > cur = {0, 1, 2, 3, 4};
    for (int i = 0; i < 5; i ++ )
        values[i] = i;
    for (int i = 5; i < 1000010; i ++)
    {
        cur = vec_mult(cur, base_transition);
        values[i] = cur.back();

    }

    for (int i = 1; i <= n; i ++)
    {
        pref[i] = pref[i - 1] + values[a[i]];
        if (pref[i] >= mod)
            pref[i] -= mod;
    }

}

void answer_queries()
{
    for (int i = 1; i <= q; i ++)
    {
        int t, l, r;
        cin >> t;
        assert(t == 1);
        cin >> l >> r;
        ll res = pref[r] - pref[l - 1];
        if (res < 0)
            res += mod;
        cout << res << endl;
    }
}

void solve()
{
    init();
    input();
    compute();
    answer_queries();
}

int main()
{
    ///speed();
    solve();
    return 0;
}
/**
4 1
3 5 6 4
1 2 3
*/
