#include<bits/stdc++.h>
#include "puzzle.h"
using namespace std;

const int maxn = 48, maxm = 802;
int tests;
double tl;
int myn, mym, p[maxm], c;
short int a[maxn][maxn], a1[maxn][maxn];
bool lampa;
struct edge
{
    int fromx, fromy;
    int tox, toy;
    int st1, st2;
};
vector <edge> v;
vector <pair<int, int>> problem;

void init(int numSubtests, double timeLimit)
{
    tests = numSubtests;
    tl = timeLimit;
}

void print(int&g)
{
    mym = g;
    //cout << "print" << '\n' ;
    int l, i, j, st;
    for (l=0; l<g; ++l)
    {
        st = p[l];
        if (st == 0) continue;
        if (v[l].fromx == v[l].tox)
        {
            if (st == 1) st = -1;
            else st = -3;
            i = v[l].fromx;
            for (j=v[l].fromy+1; j<v[l].toy; ++j)
            {
                a[i][j] = st;
            }
        }
        else
        {
            if (st == 1) st = -2;
            else st = -4;
            j = v[l].fromy;
            for (i=v[l].fromx+1; i<v[l].tox; ++i)
            {
                a[i][j] = st;
            }
        }
    }

    /*for (i=1; i<=myn; ++i)
    {
        for (j=1; j<=myn; ++j)
        {
            //cout << a[i][j] << " " ;
        }
        //cout << '\n' ;
    }*/
}

void check(int&g)
{
    mym = g;
    int i, j;
    for (i=1; i<=myn; ++i)
    {
        for (j=1; j<=myn; ++j)
        {
            a1[i][j] = a[i][j];
            //cout << a1[i][j] << " " ;
        }
        //cout << '\n' ;
    }
    //cout << '\n' << '\n' ;

    for (i=0; i<g; ++i)
    {
        a1[v[i].fromx][v[i].fromy] -= p[i];
        a1[v[i].tox][v[i].toy] -= p[i];
        if (a1[v[i].fromx][v[i].fromy] < 0 || a1[v[i].tox][v[i].toy] < 0)
            return;
    }

    for (i=1; i<=myn; ++i)
    {
        for (j=1; j<=myn; ++j)
        {
            if (a1[i][j] != 0)
                return;
        }
    }
    //cout << "problems: " << c << '\n' ;
    for (i=0; i<c; ++i)
    {
        if (p[problem[i].first] && p[problem[i].second])
            return;
    }
    lampa = true;
    //cout << "lamp: " << lampa << '\n' ;
    print(g);
}

void var(int pos, int&g)
{
    //cout << "&" << pos << " " << mym << '\n' ;
    if (lampa) return;
    if (pos > g)
    {
        check(g);
        return;
    }
    p[pos] = 0;
    var(pos+1, g);
    if (lampa) return;
    p[pos] = 1;
    var(pos+1, g);
    if (lampa) return;
    p[pos] = 2;
    var(pos+1, g);
    if (lampa) return;
}

bool solve(std::vector<std::vector<int>>& puzzle)
{
    myn = puzzle.size();
    int i, j;
    for (i=0; i<myn; ++i)
    {
        for (j=0; j<myn; ++j)
        {
            a[i+1][j+1] = puzzle[i][j];
        }
    }

    int last;
    for (i=1; i<=myn; ++i)
    {
        last = 0;
        for (j=1; j<=myn; ++j)
        {
            if (a[i][j])
            {
                if (last == 0)
                    last = j;
                else
                {
                    v.push_back({i,last, i,j, a[i][last], a[i][j]});
                    //cout << i << " " << last << " * " << i << " " << j << '\n' ;
                    last = j;
                }
            }
        }
    }

    for (j=1; j<=myn; ++j)
    {
        last = 0;
        for (i=1; i<=myn; ++i)
        {
            if (a[i][j])
            {
                if (last == 0)
                    last = i;
                else
                {
                    v.push_back({last,j, i,j, a[last][j], a[i][j]});
                    //cout << last << " " << j << " * " << i << " " << j << '\n' ;
                    last = i;
                }
            }
        }
    }

    int mym = v.size();
    for (i=0; i<mym-1; ++i)
    {
        for (j=i+1; j<mym; ++j)
        {
            if (v[i].fromx == v[i].tox && v[j].fromy == v[j].toy)
            {
                if (v[i].fromx < v[j].fromx && v[i].fromx > v[j].tox &&
                    v[i].fromy < v[j].fromy && v[i].toy > v[j].fromy)
                {
                    problem.push_back({i,j});
                    //cout << "problem: " << v[i].fromx << " " << v[i].tox << " " << v[i].fromy << " " << v[i].toy << '\n';
                    //cout << v[j].fromx << " " << v[j].tox << " " << v[j].fromy << " " << v[j].toy << '\n';
                }
            }
            else if (v[i].fromy == v[i].toy && v[j].fromx == v[j].tox)
            {
                if (v[i].fromy > v[j].fromy && v[i].fromy < v[j].toy &&
                    v[i].fromx < v[j].fromx && v[i].tox > v[j].fromx)
                {
                    problem.push_back({i,j});
                    //cout << "problem: " << v[i].fromx << " " << v[i].tox << " " << v[i].fromy << " " << v[i].toy << '\n';
                    //cout << v[j].fromx << " " << v[j].tox << " " << v[j].fromy << " " << v[j].toy << '\n';
                }
            }

        }
    }
    c = (int)(problem.size());

    //cout << c << " " << mym << '\n' ;
    int g = mym;
    lampa = false;
    var(0, g);

    for (i=1; i<=myn; ++i)
    {
        for (j=1; j<=myn; ++j)
        {
            puzzle[i-1][j-1] = a[i][j];
            //cout << a[i][j] << " " ;
        }
        //cout << '\n' ;
    }

    /*for (i=0; i<mym; ++i)
    {
        for (j=0; j<myn; ++j)
        {
            cout << puzzle[i][j] << " " ;
        }
        cout << '\n' ;
    }*/

    return true;
}