#include<bits/stdc++.h>
using namespace std;

const int maxn = 1e5, maxm = 1e6+2;
const long long mod = 1e8+543;

int n, q, a[maxn];
long long x[maxm], o[maxm];
struct tree
{
    long long st;
    int idx;
};
tree t[maxn];

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> q ;
    int i;
    for (i=1; i<=n; ++i)
        cin >> a[i] ;
}

void init()
{
    x[1] = 1;
    x[2] = 2;
    x[3] = 3;
    x[4] = 4;
    int i;
    for (i=5; i<maxm; ++i){
        x[i] = ((5*x[i-1])%mod + (4*x[i-2])%mod + (3*x[i-3])%mod + (2*x[i-4])%mod + x[i-5]) % mod;
        //if (x[i] <= 100)
            //cout << x[i] << '\n' ;
    }

    o[1] = -22;
    o[2] = 33;
    o[3] = -3;
    o[4] = -4;
    for (i=5; i<maxm; ++i)
        o[i] = (o[i-5] - (5*o[i-4])%mod - (4*o[i-3])%mod - (3*o[i-2])%mod - (2*o[i-1])%mod) % mod;
}

void make_tree(int i, int l, int r)
{
    if (l == r)
    {
        t[i].idx = a[i];
        t[i].st = (a[i] >= 0) ? x[a[i]] : o[a[i]*(-1)];
        return;
    }
    int mid = (l+r) >> 1;
    make_tree(2*i, l, mid);
    make_tree(2*i+1, mid+1, r);
    t[i].st = (t[2*i].st + t[2*i+1].st) % mod;
}

long long query(int i, int l, int r, int&ql, int&qr)
{
    if (l > qr || r < ql) return 0;
    if (l >= ql && r <= qr) return t[i].st;
    int mid = (l+r) >> 1;
    return (query(2*i, l, mid, ql, qr) + query(2*i+1, mid+1, r, ql, qr)) % mod;
}

void update(int i, int l, int r, int&pos, int&val)
{
    if (l == r)
    {
        t[i].idx += val;
        t[i].st = (t[i].idx >= 0) ? x[t[i].idx] : o[t[i].idx*(-1)];
        return;
    }
    int mid = (l+r) >> 1;
    if (pos <= mid) update(2*i, l, mid, pos, val);
    else update(2*i+1, mid+1, r, pos, val);
    t[i].st = (t[2*i].st + t[2*i+1].st) % mod;
}

void solve()
{
    make_tree(1, 1, n);
    int i, type, ql, qr, val, pos;
    long long ans;
    for (i=1; i<=q; ++i)
    {
        cin >> type >> ql >> qr ;
        if (type == 1)
        {
            ans = query(1, 1, n, ql, qr);
            if (ans < 0) ans += mod;
            cout << ans << '\n' ;
        }
        else
        {
            cin >> val ;
            pos = ql;
            update(1, 1, n, pos, val);
        }
    }
}

int main()
{
    read();
    init();
    solve();
    return 0;
}