#include<bits/stdc++.h>
#include "puzzle.h"
using namespace std;
int ind[50][50], curIndex, TL, sum;
struct state
{
    int br;
    pair<int, int> v;
};
vector<state> adj;
pair<int, int> inv[202];
int flag;
void init(int numSubtests, double timeLimit)
{
    TL = timeLimit;
}
void assignIndexes(vector<vector<int>>& puzzle)
{
    for(int i = 0; i < puzzle.size(); i ++)
    {
        for(int j = 0; j < puzzle[i].size(); j ++)
        {
            if(puzzle[i][j])
            {
                sum += puzzle[i][j];
                ind[i][j] = ++curIndex;
                inv[curIndex] = {i, j};
            }
        }
    }
    sum /= 2;
}
void findAdj(vector<vector<int>>& puzzle)
{
    int last = -1;
    int n = puzzle.size(), m = puzzle[0].size();
    for(int i = 0; i < puzzle.size(); i ++)
    {
        last = -1;
        for(int j = 0; j < puzzle[i].size(); j ++)
        {
            if(puzzle[i][j])
            {
                if(last == -1)
                {
                    last = ind[i][j];
                }
                else
                {
                    adj.push_back({0, {ind[i][j], last}});
                    last = ind[i][j];
                }
            }
        }
    }
    last = -1;
    for(int j = 0; j < m; j ++)
    {
        last = -1;
        for(int i = 0; i < n; i ++)
        {
            if(puzzle[i][j])
            {
                if(last == -1)
                {
                    last = ind[i][j];
                }
                else
                {
                    adj.push_back({0, {ind[i][j], last}});
                    last = ind[i][j];
                }
            }
        }
    }
}
void print()
{
    cout<<endl;
    for(auto item : adj) cout<<item.v.first<<" "<<item.v.second<<": "<<item.br<<endl;
}
void backtr(int i, int all, vector<vector<int>>& puzzle)
{
    if(timePassed() > TL - 0.4)
    {
        flag = 2;
        return;
    }
    if(all == sum || flag)
    {
        flag = 1;
        return;
    }
    if(i == adj.size()) return;
    state cur = adj[i];
    pair<int, int> coordinatesFirst = inv[cur.v.first];
    pair<int, int> coordinatesSecond = inv[cur.v.second];
    int mn = 2;
    mn = min(mn, min(puzzle[coordinatesFirst.first][coordinatesFirst.second], puzzle[coordinatesSecond.first][coordinatesSecond.second]));
    for(int it = 0; it <= mn; it ++)
    {
        puzzle[coordinatesFirst.first][coordinatesFirst.second] -= it;
        puzzle[coordinatesSecond.first][coordinatesSecond.second] -= it;
        adj[i].br = it;
        backtr(i + 1, all + it, puzzle);
        puzzle[coordinatesFirst.first][coordinatesFirst.second] += it;
        puzzle[coordinatesSecond.first][coordinatesSecond.second] += it;
        if(flag) return;
        adj[i].br = 0;

    }
}
void modify(vector<vector<int>>& puzzle)
{
    for(auto item : adj)
    {
        if(item.br)
        {
            pair<int, int> coordinatesFirst = inv[item.v.first];
            pair<int, int> coordinatesSecond = inv[item.v.second];
            if(coordinatesFirst.first == coordinatesSecond.first)
            {
                int num = 0;
                if(item.br == 1) num = -1;
                if(item.br == 2) num = -3;
                if(coordinatesFirst.second > coordinatesSecond.second) swap(coordinatesFirst, coordinatesSecond);
                for(int j = coordinatesFirst.second + 1; j < coordinatesSecond.second; j ++)
                {
                    puzzle[coordinatesFirst.first][j] = num;
                }
            }
            else
            {
                int num = 0;
                if(item.br == 1) num = -2;
                if(item.br == 2) num = -4;
                if(coordinatesFirst.first > coordinatesSecond.first) swap(coordinatesFirst, coordinatesSecond);
                for(int j = coordinatesFirst.first + 1; j < coordinatesSecond.first; j ++)
                {
                    puzzle[j][coordinatesFirst.second] = num;
                }
            }
        }
    }
}
bool solve(vector<vector<int>>& puzzle)
{
    curIndex = 0; sum = 0; adj.clear();
    flag = false;
    if(timePassed() > TL - 0.7) return false;
    assignIndexes(puzzle);
    findAdj(puzzle);
    backtr(0, 0, puzzle);
    if(flag == 2) return false;
    modify(puzzle);
    return true;
}

