#include "ones.h"
#include <bits/stdc++.h>

using namespace std;

vector<int> ans;

void dnc(int l, int r, int k)
{
    if (l > r)
    {
        return;
    }

    if (ans.size() == k || hasOnes(l, r) == false)
    {
        return;
    }

    int bsl = l;
    int bsr = r;

    while (bsl <= bsr)
    {
        int bsmid = (bsl + bsr) / 2;

        if (hasOnes(l, bsmid) == false)
        {
            bsl = bsmid + 1;
        }
        else
        {
            bsr = bsmid - 1;
        }
    }

    int first = bsl;

    bsl = l;
    bsr = r;

    while (bsl <= bsr)
    {
        int bsmid = (bsl + bsr) / 2;

        if (hasOnes(bsmid, r) == true)
        {
            bsl = bsmid + 1;
        }
        else
        {
            bsr = bsmid - 1;
        }
    }

    int last = bsr;

    //cout << l << " " << r << " :: " << first << " " << last << endl;

    ans.push_back(first);

    if (first != last)
    {
        ans.push_back(last);
    }
    else
    {
        return;
    }

    int mid = (first + last) / 2;

    dnc(first, mid, k);
    dnc(mid + 1, last, k);
}

vector<int> guessOnes(int n, int k)
{
    ans.clear();
    dnc(1, n, k);
    sort(ans.begin(), ans.end());
    return ans;
}
