#include "ones.h"
#include <iostream>

std::vector <int> guessOnes(int n, int k)
{
    std::vector <int> sol;
    sol.reserve(k);

    int bucketSize = n / k;
    for (int i = 1 ; i <= n ; i += bucketSize)
    {
        int from = i;
        int to = std::min(n, i + bucketSize - 1);

        while (from <= to)
        {
            int l = from - 1, r = to + 1, mid;
            while (l < r - 1)
            {
                mid = (l + r) / 2;
                if (!hasOnes(from, mid)) l = mid;
                else r = mid;
            }

            if (r <= to)
            {
                sol.push_back(r);
            }

            from = r + 1;
        }
    }

    return sol;
}