#include "ones.h"
#include <iostream>

std::vector <int> guessOnes(int n, int k)
{
    std::vector <int> sol;
    sol.reserve(k);

    int bucketSize = n / k;
    for (int i = 1 ; i <= n ; i += bucketSize)
    {
        int from = i;
        int to = std::min(n, i + bucketSize - 1);

        while (from <= to)
        {
            if (!hasOnes(from, to))
            {
                break;
            }

            int pw = 0;
            while (true)
            {
                if (hasOnes(from, std::min(to, from + (1 << pw) - 1)))
                {
                    break;
                }

                pw++;
            }

            int l = from + (pw == 0 ? -1 : (1 << pw - 1) - 1), r = std::min(to, from + (1 << pw) - 1), mid;
            while (l < r - 1)
            {
                mid = (l + r) / 2;
                if (!hasOnes(from, mid)) l = mid;
                else r = mid;
            }

            if (r <= to)
            {
                sol.push_back(r);
            }

            from = r + 1;
        }
    }

    return sol;
}