#include<bits/stdc++.h>
using namespace std;

const long long MOD = 1e8+543;
long long no[25] = {0,1,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,0,0,1,1,2,3,4,5};
long long yes[25] = {-2+MOD,-3+MOD,-4+MOD,-5+MOD,1,1,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,0,0,1,0};
vector<long long> wow[50];
vector<long long> inv[50];
vector<long long> seg[500000];
vector<long long> laz[500000];
vector<long long> haha(100001);

vector<long long> mul(vector<long long> a, vector<long long> b) {
    vector<long long> ans(25);
    for(long long i = 0; i < 5; i++) {
        for(long long j = 0; j < 5; j++) {
            for(long long k = 0; k < 5; k++) {
                ans[5*i+j]+=a[5*i+k]*b[5*k+j]+MOD*MOD;
                ans[5*i+j]%=MOD;
            }
        }
    }
    return ans;
}

vector<long long> mul2(vector<long long> a, vector<long long> b) {
    vector<long long> ans(5);
    for(int i = 0; i < 5; i++) {
        for(int j = 0; j < 5; j++) {
            ans[i]+=a[i*5+j]*b[j];
            ans[i]%=MOD;
        }
    }
    return ans;
}

vector<long long> dude(long long b, bool yeah) {
    vector<long long> ans(5);
    ans[0] = 0;
    ans[1] = 1;
    ans[2] = 2;
    ans[3] = 3;
    ans[4] = 4;
    for(int i = 49; i >= 0; i--) {
        if((1LL << i) <= b) {
            b-=(1LL << i);
            if(yeah) {
                ans = mul2(wow[i],ans);
            }
            else {
                ans = mul2(inv[i],ans);
            }
        }
    }
    return ans;
}

vector<long long> dude2(long long b, bool yeah) {
    vector<long long> ans(25);
    for(int i = 0; i < 5; i++) {
        for(int j = 0; j < 5; j++) {
            if(i == j) {
                ans[i*5+j] = 1;
            }
            else {
                ans[i*5+j] = 0;
            }
        }
    }
    for(int i = 49; i >= 0; i--) {
        if((1LL << i) <= b) {
            b-=(1LL << i);
            if(yeah) {
                ans = mul(wow[i],ans);
            }
            else {
                ans = mul(inv[i],ans);
            }
        }
    }
    return ans;
}

long long calc(long long x) {
    if(x == 4) {
        return 4;
    }
    vector<long long> ans;
    if(x > 4) {
        ans = dude(x-4,true);
    }
    else {
        ans = dude(4-x,false);
    }
    return ans[4];
}

void build(long long l, long long r, long long x) {
    for(int i = 0; i < 25; i++) {
        laz[x].push_back(0);
        if(i/5 == i%5) {
            laz[x][i] = 1;
        }
    }
    if(l == r) {
        seg[x] = dude(haha[l],haha[l] > 0);
        return;
    }
    int m = (l+r)/2;
    build(l,m,x*2);
    build(m+1,r,x*2+1);
    for(int i = 0; i < 5; i++) {
        seg[x].push_back((seg[x*2][i]+seg[x*2+1][i])%MOD);
    }
}

vector<long long> apple(0);

void upd(int l, int r, int ql, int qr, int x) {
    if(l == ql && r == qr) {
        laz[x] = mul(laz[x],apple);
        seg[x] = mul2(apple,seg[x]);
        return;
    }
    int m = (l+r)/2;
    if(qr <= m) {
        upd(l,m,ql,qr,x*2);
    }
    else if(ql > m) {
        upd(m+1,r,ql,qr,x*2+1);
    }
    else {
        upd(l,m,ql,m,x*2);
        upd(m+1,r,m+1,qr,x*2+1);
    }
    for(int i = 0; i < 5; i++) {
        seg[x][i] = seg[x*2][i]+seg[x*2+1][i];
    }
}

vector<long long> calc1(int l, int r, int ql, int qr, int x) {
    if(l == ql && r == qr) {
        return seg[x];
    }
    int m = (l+r)/2;
    vector<long long> a,b;
    if(qr <= m) {
        a = calc1(l,m,ql,qr,x*2);
    }
    else if(ql > m) {
        a = calc1(m+1,r,ql,qr,x*2+1);
    }
    else {
        a = calc1(l,m,ql,m,x*2);
        b = calc1(m+1,r,m+1,qr,x*2+1);
        for(int i = 0; i < 5; i++) {
            a[i]+=b[i];
            a[i]%=MOD;
        }
    }
    a = mul2(a,laz[x]);
    return a;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cout.tie(NULL);
    cin.tie(NULL);
    for(long long i = 0; i < 25; i++) {
        wow[0].push_back(no[i]);
        inv[0].push_back(yes[i]);
    }
    for(int i = 1; i < 50; i++) {
        wow[i] = mul(wow[i-1],wow[i-1]);
        inv[i] = mul(inv[i-1],inv[i-1]);
    }
    long long n,q;
    cin >> n >> q;
    for(long long i = 1; i <= n; i++) {
        cin >> haha[i];
    }
    build(1,n,1);
    for(int i = 0; i < q; i++) {
        int t,l,r,v;
        cin >> t >> l >> r;
        if(t == 1) {
            vector<long long> ans = calc1(1,n,l,r,1);
            cout << ans[0] << "\n";
        }
        else {
            cin >> v;
            apple = dude2(abs(v),v > 0);
            upd(1,n,l,r,1);
        }
    }
    return 0;
}
