#include "ones.h"
#include <vector>
#include <iostream>
#include <utility>
#include <algorithm>
#include <random>
#include <iomanip>
#include <numeric>
#include <cstring>
#include <bits/stdc++.h>
using namespace std;

#define out( x ) #x << " = " << x << "  "

#ifndef LOCAL
#define cerr if( false ) cerr
#endif

typedef long long ll;
typedef long double ld;

const int MAX_N = 1e6 + 42;
const int mod = 1e9 + 7;


static const int N = 1e5 + 3;

static int n, k, n_tests;
static int input[N];



mt19937 gen( 420 );
int randNum( int lb, int ub ){
	std::uniform_int_distribution< int > dist( lb, ub );
	return dist( gen );
}

bool use[MAX_N];
std::vector<int> guessOnes(int n, int k){

	for( int i=0 ; i <= n ; i++ ) use[i] = false;

	std::vector< int > nas;

	std::vector< int > indLeft( n );
	std::iota( indLeft.begin(), indLeft.end(), 1 );
	std::shuffle( indLeft.begin(), indLeft.end(), gen );

	//while( !indLeft.empty() ){
	for( int i=0 ; i < n ; i++ ){
		//int R = randNum( 0, indLeft.size()-1 );
		int currInd = indLeft[i];
		if( use[currInd] ) continue;

		cerr <<  out( currInd ) << endl;
		if( hasOnes( currInd, currInd ) ){
			cerr << " ONE " << endl;
			nas.push_back( currInd );
			use[currInd] = true;
		}else{
			cerr << " BS " << endl;
			int l = currInd-1, r = n + 1;
			r = std::min( l + 420, r );

			r = std::min( r, n +1 );
			while( l != r-1 ){
				int m = ( l + r ) >> 1;
				if( hasOnes( currInd, m ) ) r = m;
				else l = m;
			}

			cerr << " add " << out( l + 1 ) << endl;
			if( !use[l+1] ){
				use[l+1] = true;
				if( l+1 <= n ) nas.push_back( l+1 );
			}

			cerr << " rem " << out( currInd ) << out( l ) << endl;
			for( int j=currInd ; j <= l ; j++ ){
				use[j] = true;
			}


			l = 0; r = currInd + 1;
			l = std::max( l, r - 420 );
			while( l != r-1 ){
				int m = ( l + r) >> 1;
				if( hasOnes( m, currInd ) ) l = m;
				else r = m;
			}

			cerr << " add " << out( l ) << endl;
			if( !use[l] ){
				use[l] = true;
				if( l > 0 ) nas.push_back( l );
			}

			cerr << " rem " << out( r ) << out( currInd ) << endl;
			for( int j=r ; j <= currInd ; j ++ ){
				use[j] = true;
			}

		}

		if( nas.size() >= k ) break;
	}

	std::sort( nas.begin(), nas.end() );

	for( auto j : nas ) cerr << j << " ";
	cerr << endl;

	return nas;
}
