#include "ones.h"
#include <vector>
#include <iostream>
#include <utility>
#include <algorithm>
#include <random>
#include <iomanip>
#include <numeric>
#include <cstring>
#include <bits/stdc++.h>
using namespace std;

#define out( x ) #x << " = " << x << "  "

#ifndef LOCAL
#define cerr if( false ) cerr
#endif

typedef long long ll;
typedef long double ld;

const int MAX_N = 1e6 + 42;
const int mod = 1e9 + 7;


static const int N = 1e5 + 3;

static int n, k, n_tests;
static int input[N];

static long long number_of_queries;
bool hasOnes(int l,int r)
{
	//cerr << out( l ) << out( r ) << endl;
    number_of_queries++;

    if(1>l || l>n || 1>r || r>n || l>r)
    {
        std::cout << "Your program made an invalid query." << std::endl;
        exit(0);
    }

    return input[r] != input[l-1];
}


mt19937 gen( 113 );
int randNum( int lb, int ub ){
	std::uniform_int_distribution< int > dist( lb, ub );
	return dist( gen );
}

bool use[MAX_N];
std::vector<int> guessOnes(int n, int k){


	for( int i=0 ; i <= n ; i++ ) use[i] = false;

	std::vector< int > nas;

	std::vector< int > indLeft( n );
	std::iota( indLeft.begin(), indLeft.end(), 1 );
	std::shuffle( indLeft.begin(), indLeft.end(), gen );

	//while( !indLeft.empty() ){
	std::set< int > remInd;
	int left = n;
	for( int i=0 ; i < n ; i++ ){
		if( ( n - i ) + nas.size() == k ){
			cerr << "ungran " << endl;
			for( int j=i ; j < n ; j++ ) nas.push_back( indLeft[j] );
			break;
		}

		if( left + nas.size() == k ){
			cerr << "anansko " << endl;
			while( true );
			for( int j=1 ; j <= n ; j++ ){
				if( !use[j] ) nas.push_back( j );
			}
			break;
		}
		int currInd = indLeft[i];
		if( use[currInd] ) continue;

		cerr <<  out( currInd ) << endl;
		if( hasOnes( currInd, currInd ) ){
			cerr << " ONE " << endl;
			nas.push_back( currInd );
			use[currInd] = true;
			remInd.insert( currInd );

			left --;
		}else{
			cerr << " BS " << endl;
			int l = currInd-1, r = n + 1;
			auto it = remInd.lower_bound( currInd );
			if( it != remInd.end() ){
				r = *it;
			}

			while( l != r-1 ){
				int m = ( l + r ) >> 1;
				if( hasOnes( currInd, m ) ) r = m;
				else l = m;
			}

			cerr << " add " << out( l + 1 ) << endl;
			if( !use[l+1] ){
				use[l+1] = true;
				if( l+1 <= n ) nas.push_back( l+1 );
			}

			remInd.insert( l +1 );
			// [currInd, l+1]
			left -= ( std::min( n, l+1 ) - currInd	+1 );
			cerr << out( std::min( n, l+1) ) << " - " << out( currInd ) << " +1 " << endl;
			cerr << out( left ) << endl;

			cerr << " rem " << out( currInd ) << out( l ) << endl;
			for( int j=currInd ; j <= l ; j++ ){
				use[j] = true;
			}


			l = 0; r = currInd + 1;
			it = remInd.lower_bound( currInd );
			if( it == remInd.end() or it == remInd.begin() ) l = 0;
			else{
			       	it = prev( it );
				l = *it;
			}
			while( l != r-1 ){
				int m = ( l + r) >> 1;
				if( hasOnes( m, currInd ) ) l = m;
				else r = m;
			}

			cerr << " add " << out( l ) << endl;
			if( !use[l] ){
				use[l] = true;
				if( l > 0 ) nas.push_back( l );
			}
			// [l, currInd)
			left -= ( currInd - l);
			cerr << out( currInd ) << " - " << out( l ) << endl;
			cerr << out( left ) << endl;
			remInd.insert( l );

			cerr << " rem " << out( r ) << out( currInd ) << endl;
			for( int j=r ; j <= currInd ; j ++ ){
				use[j] = true;
			}

		}

		if( nas.size() >= k ) break;
	}

	std::sort( nas.begin(), nas.end() );

	for( auto j : nas ) cerr << j << " ";
	cerr << endl;

	return nas;
}
