#include <bits/stdc++.h>
using namespace std;

#define out( x ) #x << " = " << x << "  "

#ifndef LOCAL
#define cerr if( false ) cerr
#endif

typedef long long ll;
typedef long double ld;
#define ll int

const int MAX_N = 1e6 + 42;
const int mod = 1e8 + 543;

ll tree[3 * MAX_N];
ll x[MAX_N];
ll a[MAX_N];

int n;

void build( int X = 1, int l = 1, int r = n ){
	if( l == r ){
		tree[X] = x[a[l]];
		return;
	}

	int m = ( l + r ) >> 1;

	build( 2*X, l, m );
	build( 2*X +1, m+1, r );

	tree[X] = ( tree[2*X] + tree[2*X +1] ) % mod;
}

ll query( int l, int r, int x = 1, int lx = 1, int rx = n ){
	if( l > rx || lx > r ) return 0;

	if( l <= lx and rx <= r ) return tree[x];

	int m = ( l + r ) >> 1;
	ll left = query( l, r, 2*x, lx, m );
	ll right = query( l, r, 2*x +1, m+1, rx );

	return ( left + right ) % mod;
}


int main() {

#ifndef LOCAL
	std::ios_base::sync_with_stdio(false); std::cin.tie( NULL ); std::cout.tie( NULL );
#endif

	int q;
	std::cin >> n >> q;
	for( int i=1 ; i <= n ; i++ ) std::cin >> a[i];

	x[0] = 0;
	x[1] = 1;
	x[2] = 2;
	x[3] = 3;
	x[4] = 4;
	for( int i=5 ; i < MAX_N ; i++ ){
		x[i] = (5 * x[i-1] + 4 * x[i-2] + 3 * x[i-3] + 2 * x[i-4] + 1 * x[i-5] ) %mod;
	}
	cerr << out( x[5] ) << out( x[6] ) << endl;

	build( 1, 1, n );

	while( q --> 0 ){
		int type;
		std::cin >> type;
		if( type == 1 ){
			int l, r;
			std::cin >> l >> r;
			ll currNas = query( l, r, 1, 1, n );
			std::cout << currNas << endl;
		}
	}



	return 0;
}