#include "ones.h"
#include <iostream>
#include <algorithm>
#include <map>
#include <vector>
#include <string>
#include <unordered_map>
#include <cassert>
#include <set>
#include <stack>
#include <chrono>
#include <random>
#include <iomanip>
#include <fstream>
#include <chrono>
#include <random>
typedef long long ll;
typedef long double ld;
using namespace std;
/*
int p[20];
bool hasOnes(int l, int r) {
    cout << "?" << l << " " << r << "\n";
    for (int i = l; i <= r; i++) {
        if (p[i]) return true;
    }
    return false;
}*/
vector <int> solve(int l, int r) {
    if (l > r) return {};
    if (!hasOnes(l, r)) return {};
    if (l == r) return { l };
    int mid = (l + r) / 2;
    vector <int> a = solve(l, mid), b = solve(mid + 1, r);
    vector <int> ret = a;
    for (auto it : b) {
        ret.push_back(it);
    }
    return ret;
}
vector<int> guessOnes(int n, int k) {
    return solve(1, n);
}
/*
int main() {
    mt19937 rng(chrono::steady_clock().now().time_since_epoch().count());
    int n = 15, k = 0;
    cout << "#";
    for (int i = 1; i <= 15; i++) {
        p[i] = rand() % 2;
        if (p[i]) k++;
        cout << p[i] << " ";
    }
    cout << "\n";
    for (auto it : guessOnes(n, k)) {
        cout << it << " ";
    }
    cout << "\n";
}*/