#include "ones.h"
#include <iostream>
#include <algorithm>
#include <map>
#include <vector>
#include <string>
#include <unordered_map>
#include <cassert>
#include <set>
#include <stack>
#include <chrono>
#include <random>
#include <iomanip>
#include <fstream>
#include <chrono>
#include <random>
typedef long long ll;
typedef long double ld;
using namespace std;
/*
int p[20];
bool hasOnes(int l, int r) {
    cout << "?" << l << " " << r << "\n";
    for (int i = l; i <= r; i++) {
        if (p[i]) return true;
    }
    return false;
}*/
vector <int> solve(int cur_l, int cur_r) {
    vector <int> ret;
    while (1) {
        int l = cur_l, r = cur_r, ans = -1;
        while (l <= r) {
            int mid = (l + r) / 2;
            if (hasOnes(l, mid)) {
                ans = mid;
                r = mid - 1;
            }
            else l = mid + 1;
        }
        if (ans == -1) break;
        ret.push_back(ans);
    }
    return ret;
}
vector<int> guessOnes(int n, int k) {
    int block;
    if (k == 10) block = 6940;
    if (k == 20) block = 3470;
    if (k == 50) block = 1390;
    if (k == 100) block = 695;
    if (k == 200) block = 350;
    if (k == 500) block = 140;
    if (k == 1000) block = 70;
    if (k == 5000) block = 14;
    if (k == 10000) block = 7;
    vector <int> ans;
    for (int i = 1; i <= n; i += block) {
        vector <int> cur = solve(i, min(n, i + block - 1));
        for (auto it : cur) {
            ans.push_back(it);
        }
    }
    return ans;
}
/*
int main() {
    mt19937 rng(chrono::steady_clock().now().time_since_epoch().count());
    int n = 15, k = 0;
    cout << "#";
    for (int i = 1; i <= 15; i++) {
        p[i] = rand() % 2;
        if (p[i]) k++;
        cout << p[i] << " ";
    }
    cout << "\n";
    for (auto it : guessOnes(n, k)) {
        cout << it << " ";
    }
    cout << "\n";
}*/