#include "ones.h"
#include <iostream>
#include <algorithm>
#include <map>
#include <vector>
#include <string>
#include <unordered_map>
#include <cassert>
#include <set>
#include <stack>
#include <chrono>
#include <random>
#include <iomanip>
#include <fstream>
#include <chrono>
#include <random>
typedef long long ll;
typedef long double ld;
using namespace std;
/*int p[20];
bool hasOnes(int l, int r) {
    //cout << "?" << l << " " << r << "\n";
    for (int i = l; i <= r; i++) {
        if (p[i]) return true;
    }
    return false;
}*/
vector<int> guessOnes(int n, int k) {
    int block = 6940;
    int mx_non_zeros = n;
    if (k == 10) block = 6940;
    if (k == 20) block = 3470;
    if (k == 50) block = 1390;
    if (k == 100) block = 695;
    if (k == 200) block = 350;
    if (k == 500) block = 140;
    if (k == 1000) block = 70;
    if (k == 2000) block = 32;
    if (k == 5000) block = 16;
    if (k == 10000) block = 8;
    vector <int> ret;
    for (int i = 1; i <= n; i += block) {
        int cur_l = i, cur_r = min(n, i + block - 1);
        if (cur_r == n) {
            int w = k - (int)ret.size();
            while (w--) {
                int l = cur_l, r = min(cur_r, cur_l + mx_non_zeros), ans = -1;
                while (l <= r) {
                    int mid = (l + r) / 2;
                    if (hasOnes(cur_l, mid)) {
                        ans = mid;
                        r = mid - 1;
                    }
                    else l = mid + 1;
                }
                ret.push_back(ans);
                cur_l = ans + 1;
            }
            break;
        }
        while (cur_l <= cur_r) {
            int l = cur_l, r = min(cur_r, cur_l + mx_non_zeros), ans = -1;
            if (!hasOnes(cur_l, cur_r)) break;
            while (l <= r) {
                int mid = (l + r) / 2;
                if (hasOnes(cur_l, mid)) {
                    ans = mid;
                    r = mid - 1;
                }
                else l = mid + 1;
            }
            ret.push_back(ans);
            cur_l = ans + 1;
        }
    }
    return ret;
}
/*
int main() {
    mt19937 rng(chrono::steady_clock().now().time_since_epoch().count());
    int n = 15, k = 0;
    cout << "#";
    for (int i = 1; i <= 15; i++) {
        p[i] = rng() % 2;
        if (p[i]) k++;
        cout << p[i] << " ";
    }
    cout << "\n";
    for (auto it : guessOnes(n, k)) {
        cout << it << " ";
    }
    cout << "\n";
}*/