#include "puzzle.h"
#include <iostream>
#include <algorithm>
#include <map>
#include <vector>
#include <string>
#include <unordered_map>
#include <cassert>
#include <set>
#include <stack>
#include <chrono>
#include <random>
#include <iomanip>
#include <fstream>
#include <chrono>
#include <random>
typedef long long ll;
typedef long double ld;
using namespace std;
/*int p[20];
bool hasOnes(int l, int r) {
    //cout << "?" << l << " " << r << "\n";
    for (int i = l; i <= r; i++) {
        if (p[i]) return true;
    }
    return false;
}*/
/*
vector<int> guessOnes(int n, int k) {
    int block = 6940;
    if (k == 10) block = 6940;
    if (k == 20) block = 3470;
    if (k == 50) block = 1390;
    if (k == 100) block = 695;
    if (k == 200) block = 350;
    if (k == 500) block = 140;
    if (k == 1000) block = 70;
    if (k == 5000) block = 20;
    if (k == 10000) block = 10;
    vector <int> ret;
    for (int i = 1; i <= n; i += block) {
        int cur_l = i, cur_r = min(n, i + block - 1);
        while (cur_l <= cur_r) {
            int l = cur_l, r = cur_r, ans = -1;
            if (!hasOnes(cur_l, cur_r)) break;
            while (l <= r) {
                int mid = (l + r) / 2;
                if (hasOnes(cur_l, mid)) {
                    ans = mid;
                    r = mid - 1;
                }
                else l = mid + 1;
            }
            ret.push_back(ans);
            cur_l = ans + 1;
        }
    }
    return ret;
}*/
int iter;
int num;
double tl;
bool ch;
void init(int numSubtests, double timeLimit) {
    iter = 0;
    tl = timeLimit;
    num = numSubtests;
}
vector <vector<vector<pair<int, int>>>> harevan;
vector <vector<int>> deg;
int n, m;
int sm = 0;
bool solve(std::vector<std::vector<int>>& puzzle) {
    if (iter == 0) {
        n = (int)puzzle.size();
        m = (int)puzzle[0].size();
        ch = true;
        iter++;
        harevan.resize(n);
        deg.resize(n);
        for (int i = 0; i < n; i++) {
            harevan[i].resize(m);
            deg[i].resize(m);
        }
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                deg[i][j] = puzzle[i][j];
                sm += deg[i][j];
                if (puzzle[i][j]) {
                    for (int k = j + 1; k < m; k++) {
                        if (puzzle[i][k]) {
                            harevan[i][j].push_back({ i, k });
                            harevan[i][k].push_back({ i, j });
                            break;
                        }
                    }
                    for (int k = i + 1; k < n; k++) {
                        if (puzzle[k][j]) {
                            harevan[i][j].push_back({ k, j });
                            harevan[k][j].push_back({ i, j });
                            break;
                        }
                    }
                }
            }
        }
        sm /= 2;
        solve(puzzle);
    }
    if (sm == 0) {
        return true;
    }
    if (!ch) return true;
    if (iter >= 1000000) {
        ch = false;
        return false;
    }
    iter++;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (deg[i][j]) {
                for (auto it : harevan[i][j]) {
                    if (deg[it.first][it.second]) {
                        if (!ch) return true;
                        if (it.first == i) {
                            bool w = true;
                            bool z = true;
                            for (int col = min(j, it.second); col <= max(j, it.second); col++) {
                                if (puzzle[i][col] == -3 || puzzle[i][col] == -4) w = false;
                                if (puzzle[i][col] == -1) z = false;
                            }
                            if (w) {
                                if (!ch) return false;
                                sm--;
                                deg[i][j]--; deg[it.first][it.second]--;
                                for (int col = min(j, it.second) + 1; col < max(j, it.second); col++) {
                                    puzzle[i][col] -= 1;
                                }
                                solve(puzzle);
                                if (!ch) return false;
                                sm++;
                                deg[i][j]++; deg[it.first][it.second]++;
                                if (z) {
                                    for (int col = min(j, it.second) + 1; col < max(j, it.second); col++) {
                                        puzzle[i][col] = 0;
                                    }
                                }
                                else {
                                    for (int col = min(j, it.second) + 1; col < max(j, it.second); col++) {
                                        puzzle[i][col] = -1;
                                    }
                                }
                            }
                        }
                        else {
                            bool w = true;
                            bool z = true;
                            for (int row = min(i, it.first); row <= max(i, it.first); row++) {
                                if (puzzle[row][j] == -1 || puzzle[row][j] == -2) w = false;
                                if (puzzle[row][j] == -3) z = false;
                            }
                            if (w) {
                                if (!ch) return false;
                                sm--;
                                deg[i][j]--; deg[it.first][it.second]--;
                                if (z) {
                                    for (int row = min(i, it.first) + 1; row < max(i, it.first); row++) {
                                        puzzle[row][j] = -3;
                                    }
                                }
                                if (!ch) return false;
                                else {
                                    for (int row = min(i, it.first) + 1; row < max(i, it.first); row++) {
                                        puzzle[row][j] = -4;
                                    }
                                }
                                solve(puzzle);
                                if (!ch) return false;
                                sm++;
                                deg[i][j]++; deg[it.first][it.second]++;
                                if (z) {
                                    for (int col = min(j, it.second) + 1; col < max(j, it.second); col++) {
                                        puzzle[i][col] = 0;
                                    }
                                }
                                else {
                                    for (int col = min(j, it.second) + 1; col < max(j, it.second); col++) {
                                        puzzle[i][col] = -3;
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }
}
int main() {
    init(1, 2.0);
    vector <vector<int>> puzzle = {
    { 0, 0, 2, 0, 3, 0, 3},
    { 4, 0, 0, 0, 0, 2, 0},
    { 0, 0, 0, 0, 0, 0, 0},
    { 6, 0, 0, 0, 0, 2, 0},
    { 0, 0, 0, 0, 0, 0, 0},
    { 0, 0, 0, 0, 0, 0, 0},
    { 4, 0, 0, 0, 0, 0, 4}
    };
    solve(puzzle);
    for (auto it : puzzle) {
        for (auto j : it) {
            cout << j << " ";
        }
        cout << "\n";
    }
}