//#include "ones.h"
#include <iostream>
#include <algorithm>
#include <map>
#include <vector>
#include <string>
#include <unordered_map>
#include <cassert>
#include <set>
#include <stack>
#include <chrono>
#include <random>
#include <iomanip>
#include <fstream>
#include <chrono>
#include <random>
typedef long long ll;
typedef long double ld;
using namespace std;
const int N = 2e5 + 10;
const int M = 1e8 + 543;
int a[N], tree[4 * N];
int b[N];
int cur_mat[5][5], skzb[5][5], cur_ans[5][5], nxt_mat[5][5];
int skzb_vec[5] = { 0, 1, 2, 3, 4 };
int calc(int ind) {
    if (ind <= 4) return ind;
    int n = 5;
    int w = ind - 4;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i == j) cur_ans[i][j] = 1;
            else cur_ans[i][j] = 0;
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cur_mat[i][j] = skzb[i][j];
        }
    }
    while (w) {
        if (w % 2 == 1) {
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < n; j++) {
                    nxt_mat[i][j] = 0;
                    for (int k = 0; k < n; k++) {
                        nxt_mat[i][j] = (nxt_mat[i][j] + ((cur_ans[i][k] * 1ll * cur_mat[k][j]) % M)) % M;
                    }
                }
            }
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < n; j++) {
                    cur_ans[i][j] = nxt_mat[i][j];
                }
            }
        }
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                nxt_mat[i][j] = 0;
                for (int k = 0; k < n; k++) {
                    nxt_mat[i][j] = (nxt_mat[i][j] + ((cur_mat[i][k] * 1ll * cur_mat[k][j]) % M)) % M;
                }
            }
        }
        w >>= 1;
    }
    int ret = (cur_ans[n - 1][1] * 1 + cur_ans[n - 1][2] * 2 + cur_ans[n - 1][3] * 3 + cur_ans[n - 1][4] * 4) % M;
    return ret;
}
void build_tree(int v, int tl, int tr) {
    if (tl == tr) {
        tree[v] = calc(a[tl]);
        return;
    }
    int tm = (tl + tr) / 2;
    build_tree(2 * v, tl, tm);
    build_tree(2 * v + 1, tm + 1, tr);
    tree[v] = (tree[2 * v] + tree[2 * v + 1]) % M;
}
void update(int v, int tl, int tr, int pos, int val) {
    if (tl == tr) {
        tree[v] = val;
        return;
    }
    int tm = (tl + tr) / 2;
    if (pos <= tm) update(2 * v, tl, tm, pos, val);
    else update(2 * v + 1, tm + 1, tr, pos, val);
    tree[v] = (tree[2 * v] + tree[2 * v + 1]) % M;
}
int sm(int v, int tl, int tr, int l, int r) {
    if (tl >= l && tr <= r) return tree[v];
    if (tl > r || tr < l) return 0;
    int tm = (tl + tr) / 2;
    return (sm(2 * v, tl, tm, l, r) + sm(2 * v + 1, tm + 1, tr, l, r)) % M;
}
int main() {
    ios_base::sync_with_stdio(false); cin.tie(0);
    skzb[0][0] = 0; skzb[0][1] = 1; skzb[0][2] = 0; skzb[0][3] = 0; skzb[0][4] = 0;
    skzb[1][0] = 0; skzb[1][1] = 0; skzb[1][2] = 1; skzb[1][3] = 0; skzb[1][4] = 0;
    skzb[2][0] = 0; skzb[2][1] = 0; skzb[2][2] = 0; skzb[2][3] = 1; skzb[2][4] = 0;
    skzb[3][0] = 0; skzb[3][1] = 0; skzb[3][2] = 0; skzb[3][3] = 0; skzb[3][4] = 1;
    skzb[4][0] = 1; skzb[4][1] = 2; skzb[4][2] = 3; skzb[4][3] = 4; skzb[4][4] = 5;
    int n, q;
    cin >> n >> q;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }
    build_tree(1, 1, n);
    while (q--) {
        int type;
        cin >> type;     
        if (type == 1) {
            int l, r;
            cin >> l >> r;
            cout << sm(1, 1, n, l, r) << "\n";
        }
        else {
            int l, r, val;
            cin >> l >> r >> val;
            if (l == r) {
                update(1, 1, n, l, calc(a[l] + val));
                a[l] += val;
            }
        }
    }
}