//#include "ones.h"
#include <iostream>
#include <algorithm>
#include <map>
#include <vector>
#include <string>
#include <unordered_map>
#include <cassert>
#include <set>
#include <stack>
#include <chrono>
#include <random>
#include <iomanip>
#include <fstream>
#include <chrono>
#include <random>
typedef long long ll;
typedef long double ld;
using namespace std;
const int N = 1e5 + 10;
const int M = 1e8 + 543;
const int MX_N = M;
int n;
ll a[N];
int pref[N];
int fenwick[N];
int dp[MX_N];
void update(int pos, int diff) {
    while (pos <= n) {
        fenwick[pos] = (fenwick[pos] + diff) % M;
        pos += (pos & (-pos));
    }
}
int sm(int pos) {
    int ans = 0;
    while (pos) {
        ans = (ans + fenwick[pos]) % M;
        pos -= (pos & (-pos));
    }
    return ans;
}
int main() {
    ios_base::sync_with_stdio(false); cin.tie(0);
    int q;
    cin >> n >> q;
    for (int i = 0; i <= 4; i++) {
        dp[i] = i;
    }
    for (int i = 5; i <= M - 1; i++) {
        dp[i] = 5 * dp[i - 1] + 4 * dp[i - 2] + 3 * dp[i - 3] + 2 * dp[i - 4] + 1 * dp[i - 5];
        dp[i] %= M;
        if (dp[i - 4] == 0 && dp[i - 3] == 1 && dp[i - 2] == 2 && dp[i - 1] == 3 && dp[i] == 4) {
            cout << i << "\n";
        }
    }
    for (int i = 1; i <= n; i++) {
        cin >> a[i]; a[i] %= (M - 1);
        update(i, dp[a[i]]);
    }
    while (q--) {
        int type;
        cin >> type;
        if (type == 1) {
            int l, r;
            cin >> l >> r;
            cout << (sm(r) - sm(l - 1) + M) % M << "\n";
        }
        else {
            int l, r, val;
            cin >> l >> r >> val;
            int cur = dp[a[l]];
            a[l] = (a[l] + val) % (M - 1);
            update(l, (dp[a[l]] - cur + M) % M);
        }
    }
}