#include <vector>
#include <iostream>
#include <algorithm>
#include <random>
#include <iomanip>
#include <string>
#include <map>
#include <assert.h>
#include <set>
using namespace std;

#define ll long long
#define mod 100000543

const int N = 1000005;
ll a[N];
ll pref[N];

int main() {
	int n, q;
	cin >> n >> q;
	map<int, int> mp;
	int mm = 5000000;
	vector<ll> x(mm), g0(mm), g1(mm), g2(mm), g3(mm), g4(mm);
	g0[0] = 1;
	x[1] = 1; g1[1] = 1;
	x[2] = 2; g2[2] = 1;
	x[3] = 3; g3[3] = 1;
	x[4] = 4; g4[4] = 1;
	for (int i = 5; i < mm; ++i) {
		g0[i] = (5ll * g0[i - 1] + 4ll * g0[i - 2] + 3ll * g0[i - 3] + 2ll * g0[i - 4] + g0[i - 5]) % mod;
		g1[i] = (5ll * g1[i - 1] + 4ll * g1[i - 2] + 3ll * g1[i - 3] + 2ll * g1[i - 4] + g1[i - 5]) % mod;
		g2[i] = (5ll * g2[i - 1] + 4ll * g2[i - 2] + 3ll * g2[i - 3] + 2ll * g2[i - 4] + g2[i - 5]) % mod;
		g3[i] = (5ll * g3[i - 1] + 4ll * g3[i - 2] + 3ll * g3[i - 3] + 2ll * g3[i - 4] + g3[i - 5]) % mod;
		g4[i] = (5ll * g4[i - 1] + 4ll * g4[i - 2] + 3ll * g4[i - 3] + 2ll * g4[i - 4] + g4[i - 5]) % mod;
		//cout << g0[i] << ' ' << g1[i] << ' ' << g2[i] << ' ' << g3[i] << ' ' << g4[i] << "\n";
		x[i] = (4ll * g4[i] + 3ll * g3[i] + 2ll * g2[i] + g1[i]);
		//cout << x[i] << "\n";
	}
	for (int i = 1; i <= n; ++i) {
		cin >> a[i];
		a[i] = x[a[i]];
		pref[i] = pref[i - 1] + a[i];
		pref[i] %= mod;
	}
	while (q--) {
		int type, l, r;
		cin >> type >> l >> r;
		assert(type == 1);
		cout << (pref[r] - pref[l - 1] + 10ll * mod) % mod << "\n";
	}
}