#include <vector>
#include <iostream>
#include <algorithm>
#include <random>
#include <iomanip>
#include <string>
#include <map>
#include <assert.h>
#include <set>
using namespace std;

#define ll long long
#define mod 100000543

const int N = 1000005;
ll a[N], x0[5][N];
ll x[N + 10], g[5][N + 10];

int main() {
	int n, q;
	cin >> n >> q;
	map<int, int> mp;
	for (int i = 0; i < 5; ++i) {
		x[i] = i;
		g[i][i] = 1;
	}
	for (int i = 5; i < N + 5; ++i) {
		for (int j = 0; j < 5; ++j) {
			g[j][i] = (5ll * g[j][i - 1] + 4ll * g[j][i - 2] + 3ll * g[j][i - 3] + 2ll * g[j][i - 4] + g[j][i - 5]) % mod;
			x[i] += g[j][i] * (ll)j;
		}
		x[i] %= mod;
		//cout << x[i] << "\n";
	}
	for (int i = 1; i <= n; ++i) {
		cin >> a[i];
		if (a[i] <= N) {
			for (int j = 0; j < 5; ++j) {
				x0[j][i] = x[j + a[i]];
				x0[j][i] %= mod;
			}
		}
		else {
			int qan = a[i] / N;
			int mn = a[i] % N;
			ll num[5];
			for (int j = 0; j < 5; ++j) {
				num[j] = x[j + N];
				num[j] %= mod;
			}
			for (int j = 1; j < qan; ++j) {
				for (int r = 0; r < 5; ++r) {
					num[r] = num[0] * g[0][N + r] + num[1] * g[1][N + r] +
						num[2] * g[2][N + r] + num[3] * g[3][N + r] + num[4] * g[4][N + r];
					num[r] %= mod;
				}
			}
			for (int j = 0; j < 5; ++j) {
				x0[j][i] = num[0] * g[0][mn] + num[1] * g[1][mn] +
					num[2] * g[2][mn] + num[3] * g[3][mn] + num[4] * g[4][mn];
				x0[j][i] %= mod;
			}
		}
	}
	while (q--) {
		int type, l, r;
		cin >> type >> l >> r;
		assert(l == r);
		if (type == 1) {
			cout << x0[0][l] % mod << "\n";
		}
		else {
			ll val;
			cin >> val;
			ll num[5];
			if (val <= N) {
				for (int j = 0; j < 5; ++j) {
					num[j] = x0[j][l];
				}
				for (int j = 0; j < 5; ++j) {
					x0[j][l] = num[0] * g[0][val + j] + num[1] * g[1][val + j] +
						num[2] * g[2][val + j] + num[3] * g[3][val + j] + num[4] * g[4][val + j];
					x0[j][l] %= mod;
				}
			}
			else {
				int qan = val / N;
				int mn = val % N;
				for (int j = 0; j < 5; ++j) {
					num[j] = x0[j][l];
					num[j] %= mod;
				}
				for (int j = 1; j <= qan; ++j) {
					for (int r = 0; r < 5; ++r) {
						num[r] = num[0] * g[0][N + r] + num[1] * g[1][N + r] +
							num[2] * g[2][N + r] + num[3] * g[3][N + r] + num[4] * g[4][N + r];
						num[r] %= mod;
					}
				}
				for (int j = 0; j < 5; ++j) {
					x0[j][l] = num[0] * g[0][mn] + num[1] * g[1][mn] +
						num[2] * g[2][mn] + num[3] * g[3][mn] + num[4] * g[4][mn];
					x0[j][l] %= mod;
				}
			}
			/*cout << x0[0][l] << ' ' << x0[1][l] << ' ' << x0[2][l] << ' ' << x0[3][l] <<
				' ' << x0[4][l] << "\n";*/
		}
	}
}