#include "puzzle.h"
#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

#define ff first 
#define ss second 

ll ttt;
const ll INF = 1e18;
const ll MOD = 1e9;
const ll N = 50;
ll n,m,k;
int curvals[N][N];
int d[N][N];
vector<int>g[N*N];
unordered_map<int,pair<int,int>>dd;
int dirr[N*N][N*N];
bool pordz[N*N][N*N][2];
int TOTAL = 0;

void clear(int cur){
    TOTAL = 0;
    dd.clear();
    for(int v=0;v<cur;v++){
        g[v].clear();
        for(int u=0;u<cur;u++){
            dirr[v][u]=0;
            pordz[v][u][0]=pordz[v][u][1]=false;
        }
    }
    for(int i=0;i<n;i++){
        for(int j=0;j<m;j++){
            d[i][j]=0;
            curvals[i][j]=0;
        }
    }
}

int getcurval(int v){
    return curvals[dd[v].first][dd[v].second];
}

void subtractcurval(int v){
    curvals[dd[v].first][dd[v].second]--;
    TOTAL--;
}

void addcurval(int v){
    curvals[dd[v].first][dd[v].second]++;
    TOTAL++;
}

bool karamtanemkox(std::vector<std::vector<int>>& p, int v, int u){
    if(dirr[v][u]==2){
        for(int j=min(dd[v].second,dd[u].second)+1;j<max(dd[v].second,dd[u].second);j++){
            if(p[dd[v].first][j]!=0){
                return false;
            }
        }
        return true;
    }
    else{
        for(int i=min(dd[v].first,dd[u].first)+1;i<max(dd[v].first,dd[u].first);i++){
            if(p[i][dd[v].second]!=0){
                return false;
            }
        }
        return true;
    }
}

void tardoublekox(std::vector<std::vector<int>>& p, int v, int u){
    int vl;
    if(dirr[v][u]==2){
        vl = HOR_DOUBLE;
        for(int j=min(dd[v].second,dd[u].second)+1;j<max(dd[v].second,dd[u].second);j++){
            p[dd[v].first][j]=vl;
        }
    }
    else{
        vl = VERT_DOUBLE;
        for(int i=min(dd[v].first,dd[u].first)+1;i<max(dd[v].first,dd[u].first);i++){
            p[i][dd[v].second]=vl;
        }
    }
    subtractcurval(v);
    subtractcurval(v);
    subtractcurval(u);
    subtractcurval(u);
}

void jnjidoublekox(std::vector<std::vector<int>>& p, int v, int u){
    int vl;
    if(dirr[v][u]==2){
        vl = HOR_DOUBLE;
        for(int j=min(dd[v].second,dd[u].second)+1;j<max(dd[v].second,dd[u].second);j++){
            p[dd[v].first][j]=0;
        }
    }
    else{
        vl = VERT_DOUBLE;
        for(int i=min(dd[v].first,dd[u].first)+1;i<max(dd[v].first,dd[u].first);i++){
            p[i][dd[v].second]=0;
        }
    }
    addcurval(v);
    addcurval(v);
    addcurval(u);
    addcurval(u);
}

void tarsinglekox(std::vector<std::vector<int>>& p, int v, int u){
    int vl;
    if(dirr[v][u]==2){
        vl = HOR_SINGLE;
        for(int j=min(dd[v].second,dd[u].second)+1;j<max(dd[v].second,dd[u].second);j++){
            p[dd[v].first][j]=vl;
        }
    }
    else{
        vl = VERT_SINGLE;
        for(int i=min(dd[v].first,dd[u].first)+1;i<max(dd[v].first,dd[u].first);i++){
            p[i][dd[v].second]=vl;
        }
    }
    subtractcurval(v);
    subtractcurval(u);
}

void jnjisinglekox(std::vector<std::vector<int>>& p, int v, int u){
    int vl;
    if(dirr[v][u]==2){
        vl = HOR_SINGLE;
        for(int j=min(dd[v].second,dd[u].second)+1;j<max(dd[v].second,dd[u].second);j++){
            p[dd[v].first][j]=0;
        }
    }
    else{
        vl = VERT_SINGLE;
        for(int i=min(dd[v].first,dd[u].first)+1;i<max(dd[v].first,dd[u].first);i++){
            p[i][dd[v].second]=0;
        }
    }
    addcurval(v);
    addcurval(u);
}

void disconnect(int v, int u){
    g[v].erase(find(g[v].begin(),g[v].end(),u));
    g[u].erase(find(g[u].begin(),g[u].end(),v));
}

void connect(int v, int u){
    g[v].push_back(u);
    g[u].push_back(v);
}

bool mihatpordzi(vector<vector<int>>&p, int cur);

bool fnc(vector<vector<int>>&p, int cur, int vv, int u){
    if(getcurval(vv)>0&&getcurval(u)>0&&karamtanemkox(p,vv,u)){
        vector<pair<int,int>>dbls,sngls;
        //cout<<vv<<" "<<u<<endl;
        if(getcurval(vv)>1&&getcurval(u)>1){
            tardoublekox(p,vv,u);
            disconnect(vv,u);
            dbls.push_back({vv,u});
            for(int _=0;_<cur;_++){
                for(int v=1;v<cur;v++){
                    int sum=0;
                    for(int to:g[v]){
                        if(getcurval(to)>=2)sum+=2;
                        if(getcurval(to)==1)sum+=1;
                    }
                    if(sum<getcurval(v))return false;
                    if(sum==getcurval(v)){
                        for(int to:g[v]){
                            if(getcurval(to)>0&&!karamtanemkox(p,v,to))return false;
                            if(getcurval(to)>=2){
                                tardoublekox(p,v,to);
                                dbls.push_back({v,to});
                            }
                            else if(getcurval(to)==1){
                                tarsinglekox(p,v,to);
                                sngls.push_back({v,to});
                            }
                            g[to].erase(find(g[to].begin(),g[to].end(),v));
                        }
                        g[v].clear();
                    }
                }
                if(!TOTAL){
                    clear(cur);
                    return true;
                }
            }
            //if(mihatpordzi(p, cur))return true;
            for(auto pr:dbls){
                jnjidoublekox(p,pr.first,pr.second);
                connect(pr.first,pr.second);
            }
            for(auto pr:sngls){
                jnjisinglekox(p,pr.first,pr.second);
                connect(pr.first,pr.second);
            }
        }

        tarsinglekox(p,vv,u);
        disconnect(vv,u);
        dbls.clear(),sngls.clear();
        sngls.push_back({vv,u});
        for(int _=0;_<cur;_++){
            for(int v=1;v<cur;v++){
                int sum=0;
                for(int to:g[v]){
                    if(getcurval(to)>=2)sum+=2;
                    if(getcurval(to)==1)sum+=1;
                }
                if(sum<getcurval(v))return false;
                if(sum==getcurval(v)){
                    for(int to:g[v]){
                        if(getcurval(to)>0&&!karamtanemkox(p,v,to))return false;
                        if(getcurval(to)>=2){
                            tardoublekox(p,v,to);
                            dbls.push_back({v,to});
                        }
                        else if(getcurval(to)==1){
                            tarsinglekox(p,v,to);
                            sngls.push_back({v,to});
                        }
                        g[to].erase(find(g[to].begin(),g[to].end(),v));
                    }
                    g[v].clear();
                }
            }
            if(!TOTAL){
                clear(cur);
                return true;
            }
        }
        //if(mihatpordzi(p, cur))return true;
        for(auto pr:dbls){
            jnjidoublekox(p,pr.first,pr.second);
            connect(pr.first,pr.second);
        }
        for(auto pr:sngls){
            jnjisinglekox(p,pr.first,pr.second);
            connect(pr.first,pr.second);
        }
    }
    return false;
}

bool mihatpordzi(vector<vector<int>>&p, int cur){
    for(int vv=1;vv<cur;vv++){
        for(int iii=0;iii<g[vv].size();iii++){
            int u=g[vv][iii];
            if(fnc(p,cur,vv,u)){
                return true;
            }
        }
    }
    return false;
}

void init(int x, double y){}

bool solve(std::vector<std::vector<int>>& p){
    n = p.size();
    m = p[0].size();
    int cur=1;
    for(int i=0;i<n;i++){
        for(int j=0;j<m;j++){
            curvals[i][j]=p[i][j];
            TOTAL += p[i][j];
            if(p[i][j]){
                d[i][j]=cur;
                dd[cur++] = {i,j};
            }
        }
    }
    for(int i=0;i<n;i++){
        for(int j=0;j<m;j++){
            if(p[i][j]){
                int v=d[i][j];
                for(int ii=i-1;ii>=0;ii--){
                    if(p[ii][j]){
                        int u=d[ii][j];
                        g[v].push_back(u);
                        dirr[v][u]=1;
                        break;
                    }
                }
                for(int ii=i+1;ii<n;ii++){
                    if(p[ii][j]){
                        int u=d[ii][j];
                        g[v].push_back(u);
                        dirr[v][u]=1;
                        break;
                    }
                }
                for(int jj=j-1;jj>=0;jj--){
                    if(p[i][jj]){
                        int u=d[i][jj];
                        g[v].push_back(u);
                        dirr[v][u]=2;
                        break;
                    }
                }
                for(int jj=j+1;jj<m;jj++){
                    if(p[i][jj]){
                        int u=d[i][jj];
                        g[v].push_back(u);
                        dirr[v][u]=2;
                        break;
                    }
                }
            }
        }
    }
    // for(int v=1;v<cur;v++){
    //     cout<<v<<endl;
    //     cout<<"curval: "<<getcurval(v)<<endl;
    //     cout<<"g[v].size(): "<<g[v].size()<<endl<<endl;
    // }
    for(int _=0;_<cur;_++){
        for(int v=1;v<cur;v++){
            vector<int>er;
            for(int to:g[v]){
                if(!karamtanemkox(p,v,to)){
                    er.push_back(to);
                    g[to].erase(find(g[to].begin(),g[to].end(),v));
                }
            }
            for(int to:er){
                g[v].erase(find(g[v].begin(),g[v].end(),to));
            }
            int sum=0;
            for(int to:g[v]){
                if(getcurval(to)>=2)sum+=2;
                if(getcurval(to)==1)sum+=1;
            }
            if(sum==getcurval(v)){
                for(int to:g[v]){
                    if(getcurval(to)>=2)tardoublekox(p,v,to);
                    else if(getcurval(to)==1)tarsinglekox(p,v,to);
                    g[to].erase(find(g[to].begin(),g[to].end(),v));
                }
                g[v].clear();
            }
        }
    }
    // for(int v=1;v<cur;v++){
    //     cout<<v<<endl;
    //     cout<<"curval: "<<getcurval(v)<<endl;
    //     cout<<"g[v].size(): "<<g[v].size()<<endl<<endl;
    // }
    // for(int i=0;i<n;i++){
    //     for(int j=0;j<m;j++){
    //         cout<<p[i][j]<<" ";
    //     }
    //     cout<<endl;
    // }
    if(!TOTAL){
        clear(cur);
        return true;
    }
    mihatpordzi(p, cur);
    return true;
}
