#include "ones.h"
#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <cmath>
#include <algorithm>
#include <unordered_map>
#include <unordered_set>
using namespace std;
using vi = vector<int>;
#define pub push_back
#define all(x) (x).begin(), (x).end()
int n, k;

vi guessOnes(int N, int K) {
	n = N, k = K;
	int l = 1, r = n, mid;
	vi ans;
	int sq = n / k;
	vector<pair<int, int>> vec;
	for (int i = 1; i <= n; i += sq) {
		l = i, r = min(n, i + sq - 1);
		if (r == n) break;
		vec.pub({ l,r });
	}
	random_shuffle(all(vec));
	vec.pub({ l,r });
	for (auto elem : vec) {
		if (ans.size() == k) break;
		l = elem.first, r = elem.second;
		while (l <= r && hasOnes(l, r)) {
			int l1 = l, r1 = r, ind = r;
			while (l1 <= r1) {
				mid = (l1 + r1) / 2;
				if (hasOnes(mid, r1)) {
					l1 = mid + 1;
				}
				else {
					ind = mid - 1;
					r1 = mid - 1;
				}
			}
			ans.pub(ind);
			r = ind - 1;
		}
	}
	sort(all(ans));
	return ans;
}