#include "ones.h"
#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <cmath>
#include <algorithm>
#include <unordered_map>
#include <unordered_set>
#include <random>
using namespace std;
using vi = vector<int>;
#define pub push_back
#define all(x) (x).begin(), (x).end()
mt19937 rnd(7069);
const int N = 100005;
int used[N], one[N];
int n, k;

vi guessOnes(int N, int K) {
	n = N, k = K;
	int l = 1, r = n, mid;
	used[0] = 1;
	vi ans;
	int len = n;
	while (len && k >= len / 4) {
		int ind = rnd() % (n + 1);
		if (used[ind]) continue;
		used[ind] = 1;
		--len;
		if (hasOnes(ind, ind)) {
			ans.pub(ind);
			--k;
		}
	}
	if (!len) {
		sort(all(ans));
		return ans;
	}
	int sq = len / k;
	vector<pair<int, int>> vec;
	l = -1;
	for (int i = 1; i <= n; ++i) {
		if (used[i] && l == -1) {
			continue;
		}
		else if (used[i]) {
			for (int j = l; j <= i; j += sq) {
				int lx = j, rx = min(r, j + sq - 1);
				vec.pub({ lx,rx });
			}
		}
		else if (!used[i] && l == -1) {
			l = i;
		}
	}
	if (l != -1) {
		for (int j = l; j <= n; j += sq) {
			int lx = j, rx = min(r, j + sq - 1);
			vec.pub({ lx,rx });
		}
	}
	random_shuffle(all(vec));
	for (auto elem : vec) {
		if (ans.size() == k) break;
		l = elem.first, r = elem.second;
		while (l <= r && hasOnes(l, r)) {
			int l1 = l, r1 = r, ind = r;
			while (l1 <= r1) {
				mid = (l1 + r1) / 2;
				if (hasOnes(mid, r1)) {
					l1 = mid + 1;
				}
				else {
					ind = mid - 1;
					r1 = mid - 1;
				}
			}
			ans.pub(ind);
			r = ind - 1;
		}
	}
	sort(all(ans));
	return ans;
}