#include <vector>
#include <algorithm>
#include <iostream>
using namespace std;
bool hasOnes(int l, int r);

vector<int>res;
void find(int l, int r, int k)
{
    //cout << "q " << l << ' ' << r << endl;
    if (res.size() == k)
        return;
    if (l == r)
    {
        res.push_back(l);
        return;
    }
    if (l == r - 1)
    {
        if (hasOnes(l, l))
            res.push_back(l);

        if (hasOnes(r, r))
            res.push_back(r);

        return;
    }

    if (l == r - 2)
    {
        if (hasOnes(l, l))
            res.push_back(l);

        if (hasOnes(r, r))
            res.push_back(r);

        if (hasOnes(r - 1, r - 1))
            res.push_back(r);

        return;
    }
    int mid1 = l + (r - l + 1) / 3;
    int mid2 = mid1 + (r - l + 1) / 3;
    bool a, b, c, d, e;
    a = hasOnes(l, mid1);
    b = hasOnes(mid1, mid2);
    c = hasOnes(mid2 + 1, r);
    if (a)
    {
        find(l, mid1, k);
    }
    if (b)
    {
        find(mid1, mid2, k);
    }
    if (c)
    {
        find(mid2 + 1, r, k);
    }
}
std::vector<int> guessOnes(int n, int k)
{
    res.erase(res.begin(), res.end());
    int l, r;
    l = 1;
    r = n;
    if (n == 1)
    {
        if (k == 1)
        {
            res.push_back(1);
            return res;
        }
        else return res;
    }
    find(l, r, k);
    sort(res.begin(), res.end());
    k = res.size();
    /*for (int i = 0; i < k; i++)
        cout << res[i] << ' ';*/
    return res;
}