#include <vector>
#include <algorithm>
#include <iostream>
using namespace std;
bool hasOnes(int l, int r);

int log2(int k)
{
    int res = 0;
    while (k >= 2)
    {
        k >>= 1;
        res++;
    }
    return res;
}

vector<int>res;
int m;
void find(int l, int r, int pw, int k)
{
    if (res.size() == k)
        return;
    if (l == r)
    {
        res.push_back(l);
        return;
    }
    int e = (1 << pw);
    if (hasOnes(l, l + e - 1))
    {
        if (l == l + e - 1)
        {
            res.push_back(l);
        }
        else
        {
            find(l, l + e - 1, pw - 1, k);
        }

        if (hasOnes(l + e, r))
        {
            if (l + e == r)
            {
                res.push_back(r);
            }
            else
            {
                int uu = log2(r - l - e + 1);
                find(l + e, r, uu, k);
            }
        }
    }
    else
    {
        if (l + e == r)
        {
            res.push_back(r);
        }
        else
        {
            int uu = log2(r - l - e + 1);
            find(l + e, r, uu, k);
        }
    }
}
std::vector<int> guessOnes(int n, int k)
{
    res.erase(res.begin(), res.end());
    int l, r;
    m = n;
    l = 1;
    r = n;
    if (k == 0)
        return res;
    if (n == 1)
    {
        if (k == 1)
        {
            res.push_back(1);
            return res;
        }
        else return res;
    }
    int y = log2(n);
    find(1, n, y, k);
    sort(res.begin(), res.end());
   // cout << 'g';
    /*for (int i = 0; i < k; i++)
        cout << res[i] << ' ';*/

    return res;
}