#include <bits/stdc++.h>
using namespace std;
const int P=1e8+543;
struct Matrix{
    int n, m;
    int matrix[6][6];
};
long long arr[200005];
Matrix G, C;
Matrix mmult(Matrix a, Matrix b){
    int n1=a.n, m1=a.m, n2=b.n, m2=b.m;
    Matrix res;
    res.n=n1;
    res.m=m2;
    for(int i=1;i<=res.n;i++){
        for(int j=1;j<=res.m;j++){
            res.matrix[i][j]=0;
            for(int k=1;k<=n2;k++){
                res.matrix[i][j]+=((1ll*a.matrix[i][k]*b.matrix[k][j])%P);
                res.matrix[i][j]%=P;
            }
        }
    }
    return res;
}
Matrix binpow(Matrix M, long long a){
    if(a==1) return M;
    if(a&1) return mmult(M, binpow(M, a-1));
    return binpow(mmult(M, M), a/2);
}
int x(long long i){
    if(i==0) return 0;
    Matrix res=mmult(binpow(G, i), C);
    return res.matrix[1][1];
    return 1;
}
int main()
{
    iostream::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    int n, q;
    G.n=5;
    G.m=5;
    for(int i=1;i<=4;i++){
        for(int j=1;j<=5;j++){
            if(j==i+1) G.matrix[i][j]=1;
            else G.matrix[i][j]=0;
        }
    }
    for(int j=1;j<=5;j++){
        G.matrix[5][j]=j;
    }
    C.n=5;
    C.m=1;
    for(int i=1;i<=5;i++){
        C.matrix[i][1]=i-1;
    }
    Matrix M=mmult(mmult(G, G), C);
    cin>>n>>q;
    for(int i=1;i<=n;i++){
        cin>>arr[i];
    }
    while(q--){
        int t, l, r;
        cin>>t>>l>>r;
        if(t==1){
            cout<<x(arr[l])<<endl;
        }else{
            int val;
            cin>>val;
            arr[l]+=val;
        }
    }
    return 0;
}