#include "ones.h"

#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <vector>
#include <utility>
#include <random>
#include <numeric>
#include <cstring>
#include <set>
using namespace std;

typedef long long ll;

#define pb push_back
#define mpr make_pair
#define sz(x) (int(x.size()))
#define all(x) (x).begin(), (x).end()
#define clr(x) (x).clear()

mt19937 rnf(109);

bool ok[100005];

vector<int> ans;

int kk;
int e, e0;

void rec(int l, int r)
{
	if (sz(ans) == kk) return;

	if (!hasOnes(l, r)) return;

	if (l == r) {
		ans.pb(l);
		return;
	}

	int m = (l + r) / 2;

	rec(l, m);
	rec(m + 1, r);

	return;
}

void rec2(int l, int r)
{
	int i, j;

	if (sz(ans) == kk || l > r) return;

	if (!hasOnes(l, r)) return;

	int l0, r0, m0;

	l0 = l;
	r0 = r;

	while (l0 < r0) {
		m0 = (l0 + r0) / 2;

		if (hasOnes(l, m0)) r0 = m0;
		else l0 = m0 + 1;
	}

	ans.pb(l0);

	if (e0 <= 100) rec2(l0 + 1, r);
	else {
		/*int ul = l0 + 1, ur = r;

		rec2(ul, min(ur, ul + e0 / 4));
		rec2(ul + e0 / 4 + 1, ur);*/

		if (r - l0 >= 1000) rec2(l0 + 5, r);
		else rec2(l0 + 1, r);
	}

	return;
}

vector<int> guessOnes(int n, int k)
{
	int i, j;

	kk = k;

	clr(ans);

	for (i = 0; i <= n + 1; i++) ok[i] = 0;

	int l, r, m;

	e0 = n / k;
	e = n / k * 3 / 3;

	for (i = 1; i <= n; i += e) {
		rec2(i, min(i + e - 1, n));

		if (sz(ans) == k) break;
	}

	sort(all(ans));

	return ans;
}