#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <vector>
#include <utility>
#include <random>
#include <numeric>
#include <cstring>
#include <set>
#include <cassert>
#include <assert.h>
using namespace std;

typedef long long ll;

#define pb push_back
#define mpr make_pair
#define sz(x) (int(x.size()))
#define all(x) (x).begin(), (x).end()
#define clr(x) (x).clear()

// --------------------------------------------------- //

const ll M = (1e8 + 543);

const int N = 100005;
int a[N];
ll x[N];
int n;

ll f[N];

ll aa[12000000];

void upd(int ind, ll e)
{
	for (int i = ind; i < n; i |= (i + 1)) f[i] = (f[i] + M + e) % M;
	return;
}

ll qry(int l, int r)
{
	ll ans = 0;
	for (int i = r; i >= 0; i = (i & (i + 1)) - 1) ans = (ans + M + f[i]) % M;
	for (int i = l - 1; i >= 0; i = (i & (i + 1)) - 1) ans = (ans + M + M - f[i]) % M;


	return ans;
}

ll calc(int e)
{
	int i, j;

	int o = e / 50;
	o *= 5;

	if (e % 50 < 5) return aa[o + (e % 50)];

	ll x = aa[o], y = aa[o + 1], z = aa[o + 2], t = aa[o + 3], p = aa[o + 4], q;

	for (int i = 5; i <= (e % 50); i++) {
		q = (p * 5 + t * 4 + z * 3 + y * 2 + x) % M;

		x = y;
		y = z;
		z = t;
		t = p;
		p = q;
	}

	return p;
}

void solve()
{
	int i, j;

	int q;

	//cout << "dfkjsla\n";

	cin >> n >> q;

	for (i = 0; i < n; i++) {
		cin >> a[i];
		x[i] = calc(a[i]);

		upd(i, x[i]);
	}

	int tp, l, r, h;
	ll dd;

	for (int qq = 1; qq <= q; qq++) {
		cin >> tp >> l >> r;
		l--;
		r--;

		if (tp == 1) {
			cout << qry(l, r) << "\n";
		}
		else {
			cin >> h;

			h = (h + M - 1 + M - 1 + M - 1) % (M - 1);

			a[l] = (a[l] + h) % (M - 1);

			dd = calc(a[l]);

			upd(l, dd - x[l]);

			x[l] = dd;
		}
	}

	return;
}

void precalc()
{
	int i, j;

	for (i = 0; i < 5; i++) {
		aa[i] = i;
	}

	ll x = 0, y = 1, z = 2, t = 3, p = 4, q;

	for (ll i = 5; i < M + 100000; i++) {
		q = (p * 5 + t * 4 + z * 3 + y * 2 + x) % M;

		x = y;
		y = z;
		z = t;
		t = p;
		p = q;

		if (i % 50 == 4) {
			j = i / 50;
			j *= 5;


			aa[j] = x;
			aa[j + 1] = y;
			aa[j + 2] = z;
			aa[j + 3] = t;
			aa[j + 4] = p;
		}
	}

	return;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	precalc();

	solve();

	return 0;
}