#include "ones.h"
#include <bits/stdc++.h>

#define ll long long
#define endl "\n"

using namespace std;
mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());

std::vector<int> guessOnes(int n, int k)
{
    vector<int> ans, ansr;
    ll B = n / k;
    for (ll i = 0; i < k; i++)
    {
        ll st = ans.empty() ? 1 : ans.back() + 1, nd = ansr.empty() ? n : ansr.back() - 1;
        // B = (n + k - i - 1) / (k - i);
        if (i & 1)
        {
            for (; st + B - 1 < nd and !hasOnes(st, min(st + B - 1, nd)); st += B)
                ;
            ll l = st, r = min(st + B - 1, nd);
            while (l <= r)
            {
                ll mid = (l + r) >> 1;
                if (hasOnes(st, mid))
                    r = mid - 1;
                else
                    l = mid + 1;
            }
            ans.push_back(++r);
        }
        else
        {
            ll cur = max(st, nd - B + 1);
            for (; cur > st and !hasOnes(cur, nd); cur -= B)
                ;
            st = max(st, cur);
            ll l = st, r = min(st + B - 1, nd);
            while (l <= r)
            {
                ll mid = (l + r) >> 1;
                if (hasOnes(mid, nd))
                    l = mid + 1;
                else
                    r = mid - 1;
            }
            ansr.push_back(--l);
        }
    }
    reverse(ansr.begin(), ansr.end());
    for (ll i : ansr)
        ans.push_back(i);
    return ans;
}