#include <bits/stdc++.h>
using namespace std;

#define file \
            freopen("in.txt" , "r" , stdin); \
            freopen("out.txt" , "w" , stdout);


long long x[(int) 1e6 + 6];

const int mod = 1e8 + 543;

struct Segtree {
    vector<long long> tree;
    void dre(int n) {
        tree.assign(n * 4 + 1 , 0LL);
    }
    void update (int v,int l,int r,int pos,long long val) {
        if (l > r) {
            return;
        }
        if (l == r) {
            tree[v] = val;
            return;
        }
        int mid = (l + r) / 2;
        if (mid >= pos) {
            update(v*2 , l , mid , pos , val);
        } else {
            update (v*2 + 1 , mid + 1 , r , pos , val);
        }
        tree[v] = (tree[v*2] + tree[v*2 + 1]) % mod;
    }
    long long get(int v,int l,int r,int ml,int mr) {
        if (l > r || ml > r || l > mr) {
            return 0LL;
        }
        if (ml <= l && r <= mr) {
            return tree[v];
        }
        int mid = (l + r) / 2;
        return (get(v*2 , l , mid , ml , mr) + get(v*2 + 1 , mid + 1 , r , ml , mr)) % mod;
    }
};

void test_case () {

    Segtree S;
    
    int n , q;
    cin >> n >> q;

    S.dre(n);

    vector<int> a(n);
    x[0] = 0;
    x[1] = 1;
    x[2] = 2;
    x[3] = 3;
    x[4] = 4;
    
    for (int i = 5;i <= 1e6 + 2;i ++) {
        x[i] = (((x[i - 1] * 5 + x[i - 2] * 4) % mod + x[i - 3] * 3) % mod + x[i - 4] * 2 + x[i - 5]) % mod; 
    }

    for (int i = 0;i < n;i ++) {
        cin >> a[i];
        S.update (1 , 1 , n , i + 1 , x[a[i]]);
    }
    while (q --) {
        int typ , l , r;
        cin >> typ >> l >> r;
        cout << S.get(1 , 1 , n , l , r) % mod << "\n";
    }

}

int32_t main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    //   file


    int t = 1;
        // cin >> t;

    while (t --) {
        test_case();
    }
}