#include <bits/stdc++.h>
using namespace std;
const long long mod=1e8+543;
void mult(vector<vector<int>> &a, vector<vector<int>> &b) {
	int n = a.size();
	vector<vector<int>> res(n, vector<int> (n));
	for(int i = 0;i<n;i++) {
		for(int j = 0;j<n;j++) {
			for(int k = 0;k<n;k++) {
				res[i][j]=((long long)a[i][k]*b[k][j]+res[i][j])%mod;
			}
		}
	}
	swap(res,a);
}
long long get(long long x) {
	if(x<0) {
		return -1;
	}
	else {
		if(x<=4)return x;
		vector<vector<int>> base(4, vector<int> (4));
		base = {
			{5,4,3,2,1},
			{1,0,0,0,0},
			{0,1,0,0,0},
			{0,0,1,0,0},
			{0,0,0,1,0},
		};
		vector<vector<int>> res={
			{4,0,0,0,0},
			{3,0,0,0,0},
			{2,0,0,0,0},
			{1,0,0,0,0},
			{0,0,0,0,0}
		};
		x-=4;
		vector<vector<int>> rr={
			{1,0,0,0,0},
			{0,1,0,0,0},
			{0,0,1,0,0},
			{0,0,0,1,0},
			{0,0,0,0,1},
		};
		while(x>0) {
			if(x&1ll) {
				mult(rr, base);
			}
			mult(base, base);
			x>>=1ll;
		}
		mult(rr, res);
		return rr[0][0];
	}
}
signed main () {
	cin.tie(0)->sync_with_stdio(0);
	int n, q;
	cin >> n >> q;
	int a[n];
	for(int i = 0;i<n;i++)cin >> a[i];
	long long pref[n+1];
	pref[0]=0;
	for(int i = 0;i<n;i++) {
		pref[i+1]=get(a[i]);
		pref[i+1]+=pref[i];
		pref[i+1]%=mod;
	}
	while(q--) {
		int t;
		cin >> t;
		if(t==1) {
			int l, r;
			cin >> l >> r;
			cout << (pref[r]-pref[l-1]+mod)%mod << "\n";
		}
		else {
			int l, r, v;
			cin >> l >> r >> v;
		}
	}
}
