#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include "ones.h"

using namespace __gnu_pbds; 
using namespace std;

#define ll long long
#define pii pair<int, int>
#define oo 1e9
#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

vector<int> ones;
const int MAX = 1e5 + 5;

vector<int> guessOnes(int n, int k){
    ones.clear();
    int BLOCK = 320;
    for(int j = 1; j <= n; j += BLOCK){
        int i = j;
        int e = min(j + BLOCK - 1, n);
        while(i <= e){
            int l = i, r = e;
            if(ones.size() == k) break;
            while(l < r){
                int mid = (l + r) / 2;
                if(hasOnes(i, mid)){
                    r = mid;
                }
                else{
                    l = mid + 1;
                }
            }
            ones.push_back(l);
            i = l + 1;
        }
    }
    return ones;
}
