#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include "ones.h"

using namespace std;

vector<pair<int,int>> a;

void dfs(int l, int r, int k) {
    //cout << l << " " << r << "\n";
    if(l >= r) return;
    int mid = (l + r) / 2, flag = hasOnes(l, mid);
    if(!flag) {
        a.push_back({l, mid});
        dfs(mid + 1, r, k);
    } else {
        dfs(l, mid, k);
        flag = hasOnes(mid + 1, r);
        if(!flag) a.push_back({mid + 1, r});
        else dfs(mid + 1, r, k);
    }
}

vector<int> guessOnes(int n, int k) {
    a.clear();
    if(k) dfs(1, n, k);
    else a.push_back({1, n});
    sort(a.begin(), a.end());
    //
    vector<int> res;
    int prev = 1;
    for(int i = 0; i < a.size(); i++) {
        for(int j = prev; j < a[i].first; j++) res.push_back(j);
        prev = a[i].second + 1;
    }
    for(int j = prev; j <= n; j++) res.push_back(j);
    return res;
}