#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include "ones.h"

using namespace std;

vector<int> res;
vector<pair<int,int>> a;

void dfs1(int l, int r, int k) {
    //cout << l << " " << r << "\n";
    if(l > r) return;
    if(l == r) {
        res.push_back(l + 1);
        return;
    }
    int mid = (l + r) / 2, f = hasOnes(l + 1, mid + 1);
    if(!f) dfs1(mid + 1, r, k);
    else {
        dfs1(l, mid, k);
        if(hasOnes(mid + 2, r + 1)) dfs1(mid + 1, r, k);
    }
}
void dfs0(int l, int r, int k) {
    //cout << l << " " << r << "\n";
    if(l >= r) return;
    int mid = (l + r) / 2, flag = hasOnes(l, mid);
    if(!flag) {
        a.push_back({l, mid});
        dfs0(mid + 1, r, k);
    } else {
        dfs0(l, mid, k);
        flag = hasOnes(mid + 1, r);
        if(!flag) a.push_back({mid + 1, r});
        else dfs0(mid + 1, r, k);
    }
}

vector<int> guessOnes(int n, int k) {
    res.clear();
    a.clear();
    if(k <= n/2) {
        if(k) {
            dfs0(1, n, k);
        }
        else a.push_back({1, n});
        sort(a.begin(), a.end());
        //
        int prev = 1;
        for(int i = 0; i < a.size(); i++) {
            for(int j = prev; j < a[i].first; j++) res.push_back(j);
            prev = a[i].second + 1;
        }
        for(int j = prev; j <= n; j++) res.push_back(j);
    } else {
        if(k) dfs1(0, n - 1, k);
        sort(res.begin(), res.end());
    }
    return res;
}