#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include "ones.h"

using namespace std;

vector<int> res;

void dfs1(int l, int r, int k) {
    //cout << l << " " << r << "\n";
    if(l > r) return;
    if(l == r) {
        res.push_back(l);
        return;
    }
    int mid = (l + r) / 2, f = hasOnes(l, mid);
    if(!f) dfs1(mid + 1, r, k);
    else {
        dfs1(l, mid, k);
        if(hasOnes(mid + 1, r)) dfs1(mid + 1, r, k);
    }
}
void dfs0(int l, int r, int k) {
    //cout << l << " " << r << "\n";
    if(l >= r) return;
    int mid = (l + r) / 2, flag = hasOnes(l, mid);
    if(!flag) {
        a.push_back({l, mid});
        dfs0(mid + 1, r, k);
    } else {
        dfs0(l, mid, k);
        flag = hasOnes(mid + 1, r);
        if(!flag) a.push_back({mid + 1, r});
        else dfs0(mid + 1, r, k);
    }
}

vector<int> guessOnes(int n, int k) {
    res.clear();
    if(k == 10000) {
        int N = sqrt(n);
        for(int i = 1; i <= n; i += N + 1) {
            if(hasOnes(i, min(n, i + N))) dfs0(i, min(n, i + N), k);
        }
    } else if(k) dfs1(1, n, k);
    sort(res.begin(), res.end());
    return res;
}