#include <iostream>
#include <vector>
#include <map>
#define int long long

using namespace std;

int n, q;
const int N = 1e6, M = 15, MOD = 1e8 + 543;
vector<int> a, test;
vector<vector<int>> coef;
map<int,int> neu;

int mod(int i) {
    return (i + MOD) % MOD;
}
int calc(int d, int e, vector<int> cur, int cursum) {
    if(cursum > d) return 0;
    if(cursum < d) {
        int res = 0;
        for(int i = 1; i <= 5; i++) {
            cur.push_back(i);
            cursum += i;
            res = mod(res + calc(d, e, cur, cursum));
            cur.pop_back();
            cursum -= i;
        }
        return res;
    }
    int res = 1;
    for(int i = 0; i < cur.size(); i++) {
        if(i == cur.size() - 1) res = mod(res * (6 - cur[i] - e));
        else res = mod(res * (6 - cur[i]));
    }
    return res;
}
int need(int i) {
    if(i < N) return test[i];
    if(neu[i]) return neu[i];
    return neu[i] = mod(mod(coef[M - 1][0] * need(i - M + 1)) + mod(coef[M - 1][1] * need(i - M)) + mod(coef[M - 1][2] * need(i - M - 1)) + mod(coef[M - 1][3] * need(i - M - 2)) + mod(coef[M - 1][4] * need(i - M - 3)));
}

signed main() {
    cin >> n >> q;
    a = vector<int>(n);
    for(int i = 0; i < n; i++) cin >> a[i];
    //
    coef = vector<vector<int>>(M + 1, vector<int>(5));
    for(int i = 1; i <= M; i++) {
        for(int j = 0; j < 5; j++) coef[i][j] = calc(i, j, vector<int>(), 0);
    }
    //
    test = vector<int>(N);
    for(int i = 0; i < N; i++) {
        if(i < 5) test[i] = i;
        else test[i] = mod(1 * test[i - 5] + 2 * test[i - 4] + 3 * test[i - 3] + 4 * test[i - 2] + 5 * test[i - 1]);
    }
    //
    map<int,int> val;
    for(int i = 0; i < n; i++) {
        if(a[i] < N) {
            val[a[i]] = test[a[i]];
        }
        else val[i] = need(a[i]);
    }
    //
    int t, l, r;
    while(q--) {
        cin >> t >> l >> r;
        l--, r--;
        if(t == 1) {
            cout << val[a[l]] << "\n";
        } else {
            cin >> t;
            a[l] += t;
            val[a[l]] = need(a[l]);
        }
    }
}