#include <iostream>
#include <vector>
#include <map>
#define int long long

using namespace std;

int n, q;
const int N = 1e6, MOD = 1e8 + 543;
vector<int> a, test;

int mod(int i) {
    return (i + MOD) % MOD;
}

signed main() {
    cin >> n >> q;
    a = vector<int>(n);
    for(int i = 0; i < n; i++) cin >> a[i];
    //
    test = vector<int>(N);
    for(int i = 0; i < N; i++) {
        if(i < 5) test[i] = i;
        else test[i] = mod(1 * test[i - 5] + 2 * test[i - 4] + 3 * test[i - 3] + 4 * test[i - 2] + 5 * test[i - 1]);
    }
    //
    vector<int> prefix(n);
    for(int i = 0; i < n; i++) {
        prefix[i] = test[a[i]];
        if(i != 0) prefix[i] = mod(prefix[i] + prefix[i - 1]);
    }
    //
    
    int t, l, r;
    while(q--) {
        cin >> t >> l >> r;
        l--, r--;
        if(t == 1) {
            cout << mod(prefix[r] - (l == 0 ? 0 : prefix[l - 1])) << "\n";
        } else {
            cin >> t;
            
        }
    }
}