#include <bits/stdc++.h>
#define int long long
using namespace std;
const int mod = 100000543;
vector<array<int, 5>> arr(4000006);
vector<int> ez(500001, 0ll);

void init()
{
    arr[0] = {1, 0, 0, 0, 0};
    arr[1] = {0, 1, 0, 0, 0};
    arr[2] = {0, 0, 1, 0, 0};
    arr[3] = {0, 0, 0, 1, 0};
    arr[4] = {0, 0, 0, 0, 1};
    for (int i = 5; i < 4000006; i++)
        for (int m = 0; m < 5; m++)
            for (int k = 0; k < 5; k++)
            {
                arr[i][m] += (5 - k) * arr[i - k - 1][m];
                arr[i][m] %= mod;
            }
    ez[0] = 0ll;
    ez[1] = 1ll;
    ez[2] = 2ll;
    ez[3] = 3ll;
    ez[4] = 4ll;
    for (int i = 5; i <= 500000; i++)
        for (int k = 0; k < 5; k++)
        {
            ez[i] += (5 - k) * ez[i - k - 1];
            ez[i] %= mod;
        }
}

array<int, 5> get(array<int, 5> koeff, int add)
{
    array<int, 5> news;
    news = {0, 0, 0, 0, 0};
    while (add > 0)
        if (add > 4000000)
        {
            for (int i = 0; i < 5; i++)
                for (int j = 0; j < 5; j++)
                    news[i] = news[i] + koeff[j] * arr[4000000 + i][j];
            
            for (int i = 0; i < 5; i++)
                news[i]%=mod;
            add -= 4000000;
            koeff = news;
        }
        else
        {
            for (int i = 0; i < 5; i++)
                for (int j = 0; j < 5; j++)
                    news[i] = (news[i] + koeff[j] * arr[add + i][j]) % mod;
            

            return news;
        }
}
int convert(array<int, 5> koeff)
{
    int sum = 0;
    for (int i = 0; i < 5; i++)
        sum += koeff[i] * i;
    return sum % mod;
}
signed main()
{
    ios::sync_with_stdio(0);

    init();
   
    array<int, 5> mile = {0, 1, 2, 3, 4};

    int n, q;
    cin >> n >> q;
    vector<int> v(n);
    for (int i = 0; i < n; i++)
        cin >> v[i];

    vector<int> pref_sum(n);
    vector<array<int, 5>> pravi(n);
    
    for (int i = 0; i < n; i++)
    {
        if (v[i] > 5)
            pravi[i] = get({0, 1, 2, 3, 4}, v[i] - 5);
        else if (v[i] == 5)
            pravi[i] = {0, 1, 2, 3, 4};
    }

    pref_sum[0] = (v[0] <= 10000 ? ez[v[0]] : convert(get({0, 1, 2, 3, 4}, v[0])));
    for (int i = 1; i < n; i++)
        pref_sum[i] = (pref_sum[i - 1] + (v[i] <= 10000 ? ez[v[i]] : convert(get({0, 1, 2, 3, 4}, v[i])))) % mod;
    auto sum = [&](int l, int r)
    {
        return (l > 0 ? pref_sum[r] - pref_sum[l - 1] : pref_sum[r]);
    };

    while (q--)
    {
        char c;
        cin >> c;
        if (c == '1')
        {
            int l, r;
            cin >> l >> r;
            --l, --r;
            if (l != r)
                cout << (sum(l, r) + 6 * mod) % mod << endl;
            else
            {
                if (v[l] >= 5)
                    cout << convert(pravi[l]) << endl;
                else
                    cout << ez[v[l]] << endl;
            }
        }
        else
        {
            int l, r, x;
            cin >> l >> r >> x;
            --l;
            --r;
            if (l == r)
            {
               
                 if (v[l] >= 5)
                    pravi[l] = get(pravi[l], x);
                int old = v[l];
                v[l] += x;
                if (old < 5 && v[l] >= 5)
                {
                    pravi[l] = {0, 1, 2, 3, 4};
                    if (v[l] > 5)
                    pravi[l] = get(pravi[l], v[l] - 5);
                }
            }
        }
    }
}