#include <bits/stdc++.h>
#include "puzzle.h"
#pragma GCC optimize("Ofast")

using namespace std;

void init(int numSubtests, double timeLimit)
{
    return;
}
vector<vector<int>> p;
int vis[48][48];

bool check_path(int a, int b, int c, int d)
{
    // cout << a << ' ' << b << ' ' << c << ' ' << d << '\n';
    if(a != c && b != d)	return false;
    if(a == c && b == d)	return true;
    if(a == c)
    {
        if(b < d)
        {
            for(int i = b+1; i < d; i++)
            {
                if(p[a][i])	return false;
            }
        }
        else{
            for(int i = d+1; i < b; i++)
            {
                if(p[a][i])	return false;
            }
        }
    }
    else{
        if(a < c)
        {
            for(int i = a+1; i < c; i++)
            {
                if(p[i][b])	return false;
            }
        }
        else{
            for(int i = c+1; i < a; i++)
            {
                if(p[i][b])	return false;
            }
        }
    }
    return true;
}

void add_path(int a, int b, int c, int d, int x)
{
    if(a != c && b != d)	assert(0);
    if(a == c)
    {
        if(b < d)
        {
            for(int i = b+1; i < d; i++)
            {
                if(p[a][i])	assert(0);
                p[a][i] = -1-2*x;
            }
        }
        else{
            for(int i = d+1; i < b; i++)
            {
                if(p[a][i])	assert(0);
                p[a][i] = -1-2*x;
            }
        }
    }
    else{
        if(a < c)
        {
            for(int i = a+1; i < c; i++)
            {
                if(p[i][b])	assert(0);
                p[i][b] = -2-2*x;
            }
        }
        else{
            for(int i = c+1; i < a; i++)
            {
                if(p[i][b])	assert(0);
                p[i][b] = -2-2*x;
            }
        }
    }
}


void rem_path(int a, int b, int c, int d)
{
    if(a != c && b != d)	assert(0);
    if(a == c)
    {
        if(b < d)
        {
            for(int i = b+1; i < d; i++)
            {
                if(!p[a][i])	assert(0);
                p[a][i] = 0;
            }
        }
        else{
            for(int i = d+1; i < b; i++)
            {
                if(!p[a][i])	assert(0);
                p[a][i] = 0;
            }
        }
    }
    else{
        if(a < c)
        {
            for(int i = a+1; i < c; i++)
            {
                if(!p[i][b])	assert(0);
                p[i][b] = 0;
            }
        }
        else{
            for(int i = c+1; i < a; i++)
            {
                if(!p[i][b])	assert(0);
                p[i][b] = 0;
            }
        }
    }
}
vector<array<int, 4>>v;

bool cmp(array<int, 4> a, array<int, 4> b)
{
    int nA = 0, nB = 0;
    for(int i = 0; i < v.size(); i++)
    {
        if(check_path(a[1], a[2], v[i][1], v[i][2]))
        {
            nA++;
        }
        if(check_path(b[1], b[2], v[i][1], v[i][2]))
        {
            nB++;
        }
    }
    if(nA == nB)	return a[0] < b[0];
    return nA < nB;
}
int dx[] = {1, -1, 0, 0};
int dy[] = {0, 0, -1, 1};

bool valid_node(int i, int j)
{
    return i >= 0 && i < p.size() && j >= 0 && j < p[0].size() && (p[i][j] != 0) && !vis[i][j];
}

void con(int i, int j, int tmp)
{
    vis[i][j] = tmp;
    for(int k = 0; k < 4; k++)
    {
        int newI = i+dx[k], newJ = j+dy[k];
        if(valid_node(newI, newJ))
        {
            con(newI, newJ, tmp);
        }
    }
    return;
}

bool dfs(int idx)
{
    if(v.size() == 1)
    {
        memset(vis, 0, sizeof(vis));
        int tmp = 1;
        for(int i = 0; i < p.size(); i++)
        {
            for(int j = 0; j < p[i].size(); j++)
            {
                if(vis[i][j])	continue;
                if(!p[i][j])	continue;
                if(tmp == 2)	return false;
                con(i, j, tmp);
                tmp++;
            }
        }
        return (v[idx][3] == v[idx][0] && tmp <= 2);
    }
    // sort(v.begin(), v.end(), cmp);
    vector<int> neighbour;
    for(int i = 0; i+1 < v.size(); i++)
    {
        if(check_path(v[idx][1], v[idx][2], v[i][1], v[i][2]))
        {
            neighbour.push_back(i);
        }
    }
    for(int i = 0; i < (1ll << neighbour.size()); i++)
    {
        bool valid = true;
        vector<int> o;
        for(int j = 0; j < neighbour.size(); j++)
        {
            if(!((1ll << j)&i))	continue;
            int ol = neighbour[j];
            if(v[ol][3] == v[ol][0])	
            {
                valid = false;
                continue;
            }
            if(!check_path(v[idx][1], v[idx][2], v[ol][1], v[ol][2]))
            {
                valid = false;
                break;
            }
            o.push_back(ol);
        }
        if(!valid)	continue;
        for(int i = 0; i < (1ll << o.size()); i++)
        {
            int gh = __builtin_popcount(i);
            if(gh+o.size()+v[idx][3] != v[idx][0])	continue;
            for(int j = 0; j < o.size(); j++)
            {
                v[o[j]][3]++;
                if((1ll << j)&i)	v[o[j]][3]++;
                add_path(v[idx][1], v[idx][2], v[o[j]][1], v[o[j]][2], ((i >> j)&1));
            }
            array<int, 4> la = v.back();
            v.pop_back();
            if(dfs(idx-1))	return true;
            v.push_back(la);
            for(int j = 0; j < o.size(); j++)
            {
                v[o[j]][3]--;
                if((1ll << j)&i)	v[o[j]][3]--;
                rem_path(v[idx][1], v[idx][2], v[o[j]][1], v[o[j]][2]);
            }
        }
    }
    return false;
}


bool solve(vector<vector<int>>&puzzle)
{
    p = puzzle;
    int n = p.size();
    int m = p[0].size();
    v.clear();
    memset(vis, 0, sizeof(vis));
    for(int i = 0; i < n; i++)
    {
        for(int j = 0; j < m; j++)
        {
            if(p[i][j])	v.push_back({p[i][j], i, j});
        }
    }
    // sort(v.begin(), v.end(), cmp);
    dfs(v.size()-1);
    puzzle = p;
    return true;
}