#include "ones.h"
#include "bits/stdc++.h"
using namespace std;
bool hasOnes(int l,int r);
int next_one(int i,int n){
    int l=i,r=n,j=i-1;
    while(l<=r){
        int mid=l+r>>1;
        if(hasOnes(i,mid)){
            r=mid-1;
        }
        else{
            l=mid+1;
            j=mid;
        }
    }
    return j+1;
}
vector<int>divide(int l,int r,int n){
    if(l>r || r>n){
        return {};
    }
    int mid=l+r>>1;
    int nxt=next_one(mid,r);
    vector<int>ret;
    ret.push_back(nxt);
    vector<int>L=divide(l,nxt-1,nxt-1);
    vector<int>R=divide(nxt+1,r,r);
    for(auto i:L)ret.push_back(i);
    for(auto i:R)ret.push_back(i);
    return ret;
}
vector<int>guessOnes(int n,int k){
    vector<int>ret=divide(1,n,n);
    sort(ret.begin(),ret.end());
    while(ret.back()==n+1)ret.pop_back();
    return ret;
}