#include "ones.h"
#include "bits/stdc++.h"
using namespace std;
bool hasOnes(int l,int r);
int next_one(int i,int n){
    int l=i,r=n,j=i-1;
    while(l<=r){
        int mid=l+r>>1;
        if(hasOnes(i,mid)){
            r=mid-1;
        }
        else{
            l=mid+1;
            j=mid;
        }
    }
    return j+1;
}
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
vector<int>guessOnes(int n,int k){
    vector<int>ret;
    int jump=rng()%(n-1)+1;
    for(int i=1;i<=n;i+=jump){
        int l=i,r=min(n,i+jump-1);
        while(1){
            l=next_one(l,r);
            if(l==r+1)break;
            ret.push_back(l);
            l++;
        }
    }
    return ret;
}