#include "bits/stdc++.h"
using namespace std;
typedef long long ll;
#define row vector<ll>
#define matrix vector<row>
#define endl '\n'
const ll mod=1e8+543;
ll mul(ll a,ll b){
    return a%mod*(b%mod)%mod;
}
ll add(ll a,ll b){
    return ((a+b)%mod+mod)%mod;
}
ll sub(ll a,ll b){
    return ((a-b)%mod+mod)%mod;
}
matrix identity(int n){
    matrix ret(n,row(n));
    for(int i=0;i<n;i++)ret[i][i]=1;
    return ret;
}
matrix multiply(matrix a,matrix b){
    int n=a.size();
    matrix ret(n,row(n));
    for(int i=0;i<n;i++){
        for(int j=0;j<n;j++){
            for(int k=0;k<n;k++){
                ret[i][j]=add(ret[i][j],mul(a[i][k],b[k][j]));
            }
        }
    }
    return ret;
}
matrix power(matrix a,ll k){
    if(k==0)return identity(6);
    if(k==1)return a;
    matrix r=power(a,k/2);
    if(k&1){
        return multiply(multiply(r,r),a);
    }
    else{
        return multiply(r,r);
    }
}
matrix a(6,row(6)),b(6,row(6));
void build(){
    for(int i=0;i<5;i++)a[0][i]=i;
    a[0][5]=40;
    for(int i=0;i<5;i++)b[i+1][i]=1;
    for(int i=1;i<6;i++)b[i][5]=i;
}
ll get(ll n){
    a=multiply(a,power(b,n));
    return a[0][5];
}
int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);      cout.tie(0);
    int n,q;cin>>n>>q;
    vector<ll>arr(n+1);
    for(int i=1;i<=n;i++)cin>>arr[i];
    build();
    int type,l,r,v;
    int j=0;
    vector<pair<ll,int>>Q;
    while(q--){
        cin>>type>>l>>r;
        if(type==1){
            Q.push_back({arr[l],j});
            j++;
        }   
        else{
            cin>>v;
            arr[l]+=v;
        }     
    }
    vector<int>ans(j);
    ll prev=5;
    int f[6]={0,1,2,3,4,40};
    sort(Q.begin(),Q.end());
    for(auto i:Q){
        if(i.first<=5)ans[i.second]=f[i.first];
        else ans[i.second]=get(i.first-prev),prev=i.first;
    }
    for(auto i:ans)cout<<i<<endl;
}