#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
#define endl '\n'
const int mod = 1e8 + 543;
int add(int a,int b){
    return (a + b >= mod ? a + b - mod : a + b);
}
int sub(int a,int b){
    return (a < b ? a - b + mod : a - b);
}
int mult(ll a,ll b){
    return (a * b) % mod;
}
struct Matrix{
    int a[5][5];
    Matrix(){
        for(int i=0;i<5;i++) for(int j=0;j<5;j++) a[i][j] = 0;
    }
    Matrix operator *(const Matrix &b){
        Matrix ret;
        for(int i=0;i<5;i++){
            for(int j=0;j<5;j++) ret.a[i][j] = 0;
        }
        for(int i=0;i<5;i++){
            for(int j=0;j<5;j++){
                for(int k=0;k<5;k++){
                    ret.a[i][k] = add(ret.a[i][k],mult(a[i][j],b.a[j][k]));
                }
            }
        }
        return ret;
    };
};
Matrix trans;
Matrix power(Matrix a,ll k){
    Matrix ret;
    for(int i=0;i<5;i++) ret.a[i][i] = 1;
    while(k){
        if(k & 1){
            ret = ret * a;
        }
        a = a * a;
        k >>= 1;
    }
    return ret;
}
Matrix ini;
void solve(){
    int n,q;
    cin>>n>>q;
    vector<ll> v(n+1);
    for(int i=1;i<=n;i++) cin>>v[i];
    vector<Matrix> p(n+1);
    vector<int> rem(n+1);
    for(int i=1;i<=n;i++){
        p[i] = ini * power(trans,v[i]);
    }

    while(q--){
        int t,l,r;
        cin>>t>>l>>r;
        if(t == 2){
            ll x;
            cin>>x;
            x += rem[l];
            p[l] = p[l] * power(trans,(x/5) * 5);
            rem[l] = (x + rem[l]) % 5;
        }
        else {
            cout<<p[l].a[0][rem[l]]<<endl;
        }
    }
}
int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);      cout.tie(0);
    int t=1;
    //cin>>t;
    for(int i=1;i<5;i++) trans.a[i][i-1] = 1;
    for(int i=0;i<5;i++) trans.a[i][4] = i + 1 , ini.a[0][i] = i;
    while(t--){
        solve();
    }
    return 0;
}