#include <bits/stdc++.h>
using namespace std;
#define ll long long

const int mod = 1e8 + 543;
struct mint {
	int v;
	mint(ll x) {
		if (x >= mod) {
			x %= mod;
		}
		v = x;
	}
	mint() {
		v = 0;
	}
	mint& operator+=(const mint &b) {
		if ((v += b.v) >= mod) {
			v -= mod;
		}
		return *this;
	}
	mint& operator-=(const mint &b) {
		if ((v -= b.v) < 0) {
			v += mod;
		}
		return *this;
	}
	mint operator*=(const mint &b) {
		v = 1ll * v * b.v % mod;
		return *this;
	}
	friend mint operator+(mint a, mint b) {
		return a += b;
	}
	friend mint operator-(mint a, mint b) {
		return a -= b;
	}
	friend mint operator*(mint a, mint b) {
		return a *= b;
	}
	friend ostream& operator<<(ostream &os, mint a) {
		return os << a.v;
	}
	friend istream& operator>>(istream &is, mint &a) {
		return is >> a.v;
	}
};
const int N = 100'005;
const int M = 1'000'005;
mint x[M];
int main() {
	ios_base::sync_with_stdio(0), cin.tie(0);
	for (int i = 0; i < 5; i++) {
		x[i] = i;
	}
	for (int i = 5; i < M; i++) {
		x[i] = 5 * x[i - 1] + 4 * x[i - 2] + 3 * x[i - 3] + 2 * x[i - 4] + x[i - 5];
	}
	int n, q;
	cin >> n >> q;
	int a[n + 1];
	mint prf[n + 1];
	for (int i = 1; i <= n; i++) {
		cin >> a[i];
		prf[i] = prf[i - 1] + x[a[i]];
	}
	while (q--) {
		int t;
		cin >> t;
		if (t == 1) {
			int l, r;
			cin >> l >> r;
			cout << prf[r] - prf[l - 1] << '\n';
		} else {
			int l, r, p;
			cin >> l >> r >> p;
			for (int i = l; i <= r; i++) {
				a[i] += p;
			}
			for (int i = 1; i <= n; i++) {
				prf[i] = prf[i - 1] + (a[i] >= 0? x[a[i]] : 0);
			}
		}
	}
	return 0;
}

