#include <bits/stdc++.h>
//#include "Lgrader.cpp"
#include "puzzle.h"
using namespace std;
int counter = 2e7;
void init(int a, double b) {
    counter *= b;
}
vector < int > vals;
vector < pair < int , int >> pts;
vector < vector < int >> A, found;
void update(int i, int j, int x) {
    if(pts[i].first == pts[j].first) {
        for(int k = pts[i].second + 1 ; k < pts[j].second ; k++) {
            A[pts[i].first][k] = -x;
        }
    } else {
        for(int k = pts[i].first + 1 ; k < pts[j].first ; k++) {
            A[k][pts[i].second] = (x == 0? 0 : - (x + 1));
        }
    }
}
void solve(vector < int > vals) {
    if(found.size()) return;
    counter -= 1;
    if(counter == 0)
        return;
    int sum = 0;
    for(auto i : vals) sum += i;
    if(sum == 0) {
        found = A;
        return;
    }
    for(int i = 0 ; i < vals.size() ; i++) {
        for(int j = i + 1 ; j < vals.size() ; j++) {
            if(!vals[i] || !vals[j] || (pts[i].first != pts[j].first && pts[i].second != pts[j].second)) 
                continue;
            bool can = 1;
            if(pts[i].first == pts[j].first) {
                for(int k = pts[i].second + 1 ; k < pts[j].second ; k++) 
                    can &= (A[pts[i].first][k] == 0);
            } else {
                for(int k = pts[i].first + 1 ; k < pts[j].first ; k++) 
                    can &= (A[k][pts[i].second] == 0);
            }
            if(!can) continue;
            vals[i] -= 1, vals[j] -= 1;
            update(i, j, 1);
            solve(vals);
            if(found.size()) return;
            update(i, j, 0);
            vals[i] += 1, vals[j] += 1;
            if(vals[i] >= 2 && vals[j] >= 2) {
                vals[i] -= 2, vals[j] -= 2;
                update(i, j, 3);
                solve(vals);
                if(found.size()) return;
                update(i, j, 0);
                vals[i] += 2, vals[j] += 2;
            }
        }
    }
}
bool solve(vector < vector < int >> &a) {
    vals.clear();
    pts.clear();
    found.clear();
    A = a;
    for(int i = 0 ; i < a.size() ; i++) {
        for(int j = 0 ; j < a[i].size() ; j++) {
            if(a[i][j] != 0) {
                pts.push_back({i, j});
                vals.push_back(a[i][j]);
            }
        }
    }
    solve(vals);
    // cout << "found.size() : " << found.size() << endl;
    if(!found.size()) return 0;
    a = A;
    // for(auto i : a) {
    //     for(auto j : i) cout << j << "\t";
    //     cout << endl;
    // }
    return 1;
}