#include <bits/stdc++.h>
#pragma GCC optimize ("Ofast")
using namespace std;
#define ll long long
const int mod = 1e8 + 543;
vector < vector < int >> Mul(vector < vector < int >> &a, vector < vector < int >> b) {
    int n = a.size(), m = a[0].size();
    vector < vector < int >> ans(n, vector < int > (m));
    for(int i = 0 ; i < n ; i++) {
        for(int j = 0 ; j < n ; j++) {
            for(int k = 0 ; k < n ; k++) {
                ll val = a[i][k];
                val *= 1ll * b[k][j];
                val %= mod;
                ans[i][j] = val;
            }
        }
    }
    return ans;
}
const vector < vector < int >> ini = {{1, 0, 0, 0, 0},
                                      {0, 1, 0, 0, 0},
                                      {0, 0, 1, 0, 0},
                                      {0, 0, 0, 1, 0},
                                      {0, 0, 0, 0, 1}};
const vector < vector < int >> A = {{5, 1, 0, 0, 0}, 
                                    {4, 0, 1, 0, 0},
                                    {3, 0, 0, 1, 0},
                                    {2, 0, 0, 0, 1},
                                    {1, 0, 0, 0, 0}};
vector < vector < int >> power(int b) {
    if(!b) return ini;
    auto ans = power(b >> 1);
    ans = Mul(ans, ans);
    if(b & 1) ans = Mul(ans, A);
    return ans;
}
const int N = 2e7 + 6;
int values[N];
void init() {
    values[1] = 1, values[2] = 2, values[3] = 3, values[4] = 4;
    for(int i = 5 ; i < N ; i++) {
        ll value = (values[i - 1] * 5);
        value += (values[i - 2] * 4);
        value += (values[i - 3] * 3);
        value += (values[i - 4] * 2);
        value += (values[i - 5] * 1);
        value %= mod;
        values[i] = value;
    }
}
int query(int k) {
    if(k < N) {
        return values[k];
    }
    k = k - 4;
    auto a = power(k);
    vector < int > arr2;
    for(int i = 0 ; i < 5 ; i++)
        arr2.push_back(a[i][0]);
    vector < int > arr = {4, 3, 2, 1, 0};
    int ans = 0;
    for(int i = 0 ; i < 5 ; i++) {
        ll val = arr2[i] * 1ll * arr[i];
        val %= mod;
        ans = (ans + val) % mod;
    }
    return ans;
}
signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    init();
    int n, q;
    cin >> n >> q;
    vector < int > a(n), b(n);
    for(auto &i : a) cin >> i;
    for(int i = 0 ; i < n ; i++) 
        b[i] = query(a[i]);
    while(q--) {
        int ty;
        cin >> ty;
        if(ty == 1) {
            int l, r;
            cin >> l >> r;
            cout << b[l - 1] << endl;
        } else {
            int l, r, x;
            cin >> l >> r >> x;
            l -= 1;
            a[l] += x;
            b[l] = query(a[l]);
        }
    }
    return 0;
}