#include <bits/stdc++.h>
using namespace std;
const int MOD = 1e8 + 543;
const int MAXN = 1e6 + 25;
int add (int a, int b) {
	a += b; if (a >= MOD) a -= MOD;
	return a;
}
int sub (int a, int b) {
	a -= b; if (a < 0) a += MOD;
	return a;
}
int mul (int a, int b) {
	return (a * 1ll * b) % MOD;
}
using matr = vector <vector <int>>;
matr u = {
	{0, 1, 0, 0, 0},
	{0, 0, 1, 0, 0},
	{0, 0, 0, 1, 0},
	{0, 0, 0, 0, 1},
	{1, 2, 3, 4, 5}
};
matr iden = {
	{1, 0, 0, 0, 0},
	{0, 1, 0, 0, 0},
	{0, 0, 1, 0, 0},
	{0, 0, 0, 1, 0},
	{0, 0, 0, 0, 1}
};
matr mul2 (matr a, matr b) {
	matr ret; ret.resize(5); for (auto &i : ret) i.resize(5);
	for (int i = 0; i < 5; i++) for (int j = 0; j < 5; j++) ret[i][j] = 0;
	for (int i = 0; i < 5; i++) {
		for (int j = 0; j < 5; j++) {
			for (int k = 0; k < 5; k++) {
				ret[i][j] = add(ret[i][j], mul(a[i][k], b[k][j]));
			}
		}
	}
	return ret;
}
matr power (long long b) {
	if (!b) return iden;
	auto g = power(b >> 1);
	g = mul2(g, g);
	if (b & 1) g = mul2(g, u);
	return g;
}
int get (long long x) {
	auto g = power(x);
	int sum = 0;
	for (int i = 0; i < 5; i++) {
		sum = add(sum, mul(i, g[0][i]));
	}
	return sum;
}
int n, q;
long long a[MAXN];
signed main () {
	ios::sync_with_stdio(0); cin.tie(0);
	cin >> n >> q;
	for (int i = 1; i <= n; i++) {
		cin >> a[i];
	}
	for (int i = 1; i <= q; i++) {
		int t, l, r; cin >> t >> l >> r;
		assert(l == r);
		if (t == 2) {
			long long x; cin >> x;
			a[l] += x;
			continue;
		}
		cout << get(a[l]) << '\n';
	}
}