#include <bits/stdc++.h>
#define dbg(x) cout << (#x) << " : " << x << endl
#define dbeg(x) cout << (#x) << " : " << x << " "
#define sz(x) int(x.size())
#define fs first
#define sc second
#define LOOP(n) for(int rp=0;rp<n;rp++)
#define pb push_back
#define all(x) x.begin(),x.end()
using namespace std;
typedef long long ll;
const int SZ=1e5+7;
const ll INF=1e18+7;
int MOD=1e8+543;
mt19937_64 rng(time(0));
int rnd(int l,int r){
    return uniform_int_distribution<int>(l,r)(rng);
}
int getN(){
    int x;cin >> x;
    return x;
}
int add(int x,int y){
    x+=y;if(x>=MOD)x-=MOD;
    return x;
}
int sub(int x,int y){
    x-=y;if(x<0)x+=MOD;
    return x;
}
int mul(int x,int y){
    return(x*1ll*y)%MOD;
}
int pwr(int a,ll b){
    int ans=1;
    while(b>0){
        if(b&1)ans=mul(ans,a);
        a=mul(a,a),b>>=1;
    }
    return ans;
}
int inv(int a){
    return pwr(a,MOD-2);
}
vector<vector<int>>rmv(vector<vector<int>>&a,int x,int y){
    int n=sz(a);
    vector<vector<int>>b(n-1,vector<int>(n-1,0));
    for(int i=0;i<n;i++){
        for(int j=0;j<n;j++){
            if(i==x||j==y)continue;
            b[i-int(i>x)][j-int(j>y)]=a[i][j];
        }
    }
    return b;
}
int DET(vector<vector<int>>&a){
    int n=sz(a),D=0;
    vector<vector<int>>c;
    if(n==1)return a[0][0];
    for(int i=0;i<n;i++){
        c=rmv(a,0,i);
        D+=((i&1)?-1:1)*a[0][i]*DET(c);
    }
    return D;
}
vector<vector<int>>COF(vector<vector<int>>&a){
    int n=sz(a);
    vector<vector<int>>c(n,vector<int>(n,0)),z;
    for(int i=0;i<n;i++){
        for(int j=0;j<n;j++){
            z=rmv(a,i,j);
            c[i][j]=(((i+j)&1)?-1:1)*DET(z);
        }
    }
    return c;
}
#define MAT array<array<int,5>,5>
#pragma GCC optimize("unroll-loops","Ofast")
#pragma GCC target("avx2","popcnt")
void addm(MAT&a,MAT&b){
    for(int i=0;i<5;i++){
        for(int j=0;j<5;j++){
            a[i][j]+=b[i][j];
            if(a[i][j]>=MOD)a[i][j]-=MOD;
        }
    }
}
MAT mulm(MAT&a,MAT&b){
    MAT c;
    for(int i=0;i<5;i++)for(int j=0;j<5;j++)c[i][j]=0;
    for(int i=0;i<5;i++){
        for(int l=0;l<5;l++){
            if(a[i][l]==0)continue;
            for(int j=0;j<5;j++){
                if(b[l][j]==0)continue;
                c[i][j]+=(a[i][l]*1ll*b[l][j])%MOD;
                if(c[i][j]>=MOD)c[i][j]-=MOD;
            }
        }
    }
    return c;
}
vector<vector<int>>AA,BB;
MAT A,B;
int n,q,sq[SZ*10],ar[SZ];
MAT /*sg[SZ*2],lz[SZ*2],*/a[SZ];
MAT pwrm(ll b){
    MAT a=A;
    if(b<0)b=-b,a=B;
    MAT ans;
    for(int i=0;i<5;i++)for(int j=0;j<5;j++)ans[i][j]=(i==j);
    while(b>0){
        if(b&1)ans=mulm(ans,a);
        a=mulm(a,a),b>>=1;
    }
    return ans;
}
int main(){
    ios_base::sync_with_stdio(0);cin.tie(0);
    AA={{0,0,0,0,1},
      {1,0,0,0,2},
      {0,1,0,0,3},
      {0,0,1,0,4},
      {0,0,0,1,5}};
    //fill(sg,sg+SZ*2,vector<vector<int>>(5,vector<int>(5,0)));
    //fill(lz,lz+SZ*2,vector<vector<int>>(5,vector<int>(5,0)));
    for(int i=0;i<SZ*10;i++){
        if(i<5)sq[i]=i;
        else{
            LOOP(5)sq[i]=add(sq[i],mul(sq[i-rp-1],(5-rp)));
        }
    }
    BB=COF(AA);
    for(int i=0;i<5;i++){
        for(int j=0;j<i;j++)swap(BB[i][j],BB[j][i]);
    }
    for(int i=0;i<5;i++){
        for(int j=0;j<5;j++)BB[i][j]=add(BB[i][j],MOD);
    }
    for(int i=0;i<5;i++)for(int j=0;j<5;j++)A[i][j]=AA[i][j],B[i][j]=BB[i][j];
    cin >> n >> q;
    for(int i=0;i<n;i++){
        ar[i]=sq[getN()];
        if(i)ar[i]=add(ar[i],ar[i-1]);
    }
    LOOP(q){
        int T,l,r;cin >> T >> l >> r;l--,r--;
        if(T==1){
            int ans=0;
            /*for(int i=l;i<=r;i++){
                LOOP(5)ans=add(ans,mul(a[i][rp][0],rp));
            }*/
            cout << sub(ar[r],(l==0?0:ar[l-1])) << "\n";
        }
        else{
            int vl;cin >> vl;
            MAT C=pwrm(vl);
            for(int i=l;i<=r;i++){
                a[i]=mulm(a[i],C);
            }
            //cout << "DONE" << endl;
        }
    }
    return 0;
}
