#include <bits/stdc++.h>
#define dbg(x) cout << (#x) << " : " << x << endl
#define dbeg(x) cout << (#x) << " : " << x << " "
#define sz(x) int(x.size())
#define fs first
#define sc second
#define LOOP(n) for(int rp=0;rp<n;rp++)
#define pb push_back
#define all(x) x.begin(),x.end()
using namespace std;
typedef long long ll;
const int SZ=1e5+7;
const ll INF=1e18+7;
int MOD=1e8+543;
mt19937_64 rng(time(0));
int rnd(int l,int r){
    return uniform_int_distribution<int>(l,r)(rng);
}
int getN(){
    int x;cin >> x;
    return x;
}
int add(int x,int y){
    x+=y;if(x>=MOD)x-=MOD;
    return x;
}
int sub(int x,int y){
    x-=y;if(x<0)x+=MOD;
    return x;
}
int mul(int x,int y){
    return(x*1ll*y)%MOD;
}
int pwr(int a,ll b){
    int ans=1;
    while(b>0){
        if(b&1)ans=mul(ans,a);
        a=mul(a,a),b>>=1;
    }
    return ans;
}
int inv(int a){
    return pwr(a,MOD-2);
}
#define MAT array<array<int,5>,5>
#pragma GCC optimize("unroll-loops","Ofast")
#pragma GCC target("avx2","popcnt")
MAT mulm(MAT&a,MAT&b){
    MAT c;
    for(int i=0;i<5;i++){
        for(int j=0;j<5;j++){
            c[i][j]=((a[i][0]*1ll*b[0][j])+
                     (a[i][1]*1ll*b[1][j])+
                     (a[i][2]*1ll*b[2][j])+
                     (a[i][3]*1ll*b[3][j])+
                     (a[i][4]*1ll*b[4][j]))%MOD;
        }
    }
    return c;
}
MAT Ap[30],a[SZ],ans;
int n,q;
MAT pwrm(ll b){
    for(int i=0;i<5;i++)for(int j=0;j<5;j++)ans[i][j]=(i==j);
    int c=0;
    while(b>0){
        if(b&1)ans=mulm(ans,Ap[c]);
        b>>=1,c++;
    }
    return ans;
}
int main(){
    ios_base::sync_with_stdio(0);cin.tie(0);
    vector<vector<int>>lol={
       {0,0,0,0,1},
       {1,0,0,0,2},
       {0,1,0,0,3},
       {0,0,1,0,4},
       {0,0,0,1,5}};
    for(int i=0;i<5;i++)for(int j=0;j<5;j++)Ap[0][i][j]=lol[i][j];
    for(int i=1;i<30;i++)Ap[i]=mulm(Ap[i-1],Ap[i-1]);
    cin >> n >> q;
    for(int i=0;i<n;i++){
        a[i]=pwrm(getN());
    }
    LOOP(q){
        int T,l,r;cin >> T >> l >> r;l--,r--;
        if(T==1){
            int ans=0;
            /*for(int i=l;i<=r;i++){
                LOOP(5)ans=add(ans,mul(a[i][rp][0],rp));
            }*/
            cout << ans << "\n";
        }
        else{
            int vl;cin >> vl;
            MAT C=pwrm(vl);
            for(int i=l;i<=r;i++){
                a[i]=mulm(a[i],C);
            }
            //cout << "DONE" << endl;
        }
    }
    return 0;
}
