#include <bits/stdc++.h>

using namespace std;

#include "ones.h"


vector<int> ans;

int bins(int l,int r)
{
   // cout << l << ' ' << r << "\n";
    if(l == r)
        return l;
    int m = (l+r)/2;
    if(hasOnes(l+1,m+1))
        return bins(l,m);
    else
        return bins(m+1,r);
}

vector<int> guessOnes(int n,int k)
{
    ans.clear();
    int tpos = 0;
    int bl = n/k/sqrtl(3);
    while(ans.size() < k)
    {
        if(!hasOnes(tpos+1,min(tpos+bl-1,n-1)+1))
        {
            tpos += bl;
            continue;
        }
        int p = bins(tpos,min(tpos+bl-1,n-1));
       // cout << p << ' ';
        ans.push_back(p+1);
        tpos = p+1;
    }
    return ans;
}

/*
const int maxn = 100001;

const int mod = int(1e8)+543;

int binpow(int a,int b)
{
    int ans = 1;
    while(b)
    {
        if(b%2)
            ans = (int64_t(ans)*a)%mod;
        b /= 2;
        a = (int64_t(a)*a)%mod;
    }
    return ans;
}
int del(int a,int b)
{
    return (int64_t(a)*binpow(b,mod-2))%mod;
}

vector<int> root = {1405049,10002474,36684046,69727867,82181655};
vector<int> iroot;

int binpowc(int i,int b)
{
    if(b < 0)
        return binpow(iroot[i],-b);
    else
        return binpow(root[i],b);
}
vector<int> coeff = {4868204,92161528,51211683,37815043,13944628};
int a[maxn];
int segTree[5][4*maxn];
int p[5][4*maxn];

void build(int l,int r,int indV,int j)
{
    if(l == r)
    {
        segTree[j][indV] = (int64_t(coeff[j]) * binpowc(j,a[l]))%mod;
        p[j][indV] = 1;
        return ;
    }
    int m = (l+r)/2;
    build(l,m,indV*2+1,j);
    build(m+1,r,indV*2+2,j);
    segTree[j][indV] = (segTree[j][indV*2+1] + segTree[j][indV*2+2])%mod;
    p[j][indV] = 1;
    return ;
}
void push(int l,int r,int indV,int j)
{
    if(l == r)
    {
        segTree[j][indV] = (int64_t(segTree[j][indV]) * p[j][indV])%mod;
        p[j][indV] = 1;
        return ;
    }
    segTree[j][indV] = (int64_t(segTree[j][indV]) * p[j][indV])%mod;
    p[j][indV*2+1] = (int64_t(p[j][indV*2+1])*p[j][indV])%(mod);
    p[j][indV*2+2] = (int64_t(p[j][indV*2+2])*p[j][indV])%(mod);
    p[j][indV] = 1;
    return ;
}
void modify(int lx,int rx,int x,int l,int r,int indV,int j)
{
    push(l,r,indV,j);
    if(l > rx || r < lx)
        return ;
    else if(l >= lx && r <= rx)
    {
        p[j][indV] = (int64_t(p[j][indV])*x)%mod;
        push(l,r,indV,j);
        return ;
    }
    int m = (l+r)/2;
    modify(lx,rx,x,l,m,indV*2+1,j);
    modify(lx,rx,x,m+1,r,indV*2+2,j);
    segTree[j][indV] = (segTree[j][indV*2+1] + segTree[j][indV*2+2])%mod;
}
int get(int lx,int rx,int l,int r,int indV,int j)
{
    push(l,r,indV,j);
    if(l > rx || r < lx)
        return 0;
    else if(l >= lx && r <= rx)
    {
        return segTree[j][indV];
    }
    int m = (l+r)/2;
    int sl = get(lx,rx,l,m,indV*2+1,j);
    int sr = get(lx,rx,m+1,r,indV*2+2,j);
    return (sl+sr)%mod;
}
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    for(int i = 0;i < 5;++i)
        iroot.push_back(del(1,root[i]));
    int n,q;
    cin >> n >> q;
    for(int j = 0;j < n;++j)
    {
        cin >> a[j];
    }
    for(int j = 0;j < 5;++j)
        build(0,n-1,0,j);
    for(int j = 0;j < q;++j)
    {
        int t;
        cin >> t;
        if(t == 1)
        {
            int l,r;
            cin >> l >> r;
            l--;
            r--;
            int ans = 0;
            for(int u = 0;u < 5;++u)
            {
                ans = (ans + get(l,r,0,n-1,0,u))%mod;
            }
            cout << ans << "\n";
        }
        else
        {
            int l,r,v;
            cin >> l >> r >> v;
            l--;
            r--;
            for(int u = 0;u < 5;++u)
            {
                modify(l,r,binpowc(u,v),0,n-1,0,u);
            }
        }
    }
    return 0;
}*/
