#include <bits/stdc++.h>

using namespace std;

#define int int64_t

const int mod = int(1e8)+543;

int binpow(int a,int b)
{
    return (b == 0 ? 1 : (b%2 == 0 ? binpow((a*a)%mod,b/2) : (a*binpow(a,b-1))%mod));
}
int del(int a,int b)
{
    return (a*binpow(b,mod-2))%mod;
}
int binpowc(int a,int b)
{
    if(b < 0)
        return del(1,binpow(a,-b));
    else
        return binpow(a,b);
}

vector<int> root = {1405049,10002474,36684046,69727867,82181655};
vector<int> coeff = {4868204,92161528,51211683,37815043,13944628};

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n,q;
    cin >> n >> q;
    int a[n];
    int b[n];
    int pr[n+1];
    pr[0] = 0;
    for(int j = 0;j < n;++j)
    {
        cin >> a[j];
        b[j] = 0;
        for(int k = 0;k < 5;++k)
        {
            b[j] =(b[j] + coeff[k] * binpowc(root[k],a[j]))%mod;
        }
        pr[j+1] = (pr[j] + b[j])%mod;
    }
    for(int j = 0;j < q;++j)
    {
        int t;
        cin >> t;
        if(t == 1)
        {
            int l,r;
            cin >> l >> r;
            l--;
            r--;
            cout << b[l] << "\n";
        }
        else
        {
            int l,r,v;
            cin >> l >> r >> v;
            l--;
            r--;
            a[l] += v;
            b[l] = 0;
            for(int k = 0;k < 5;++k)
            {
                b[l] = (b[l] + coeff[k] * binpowc(root[k],a[l]))%mod;
            }
        }
    }
    return 0;
}
