#include <bits/stdc++.h>

using namespace std;
/*
mt19937 rnd(228);

const int maxn = 100001;
const int spl = (1<<14);

const int mod = int(1e8)+543;

int msum(int a,int b)
{
    return (a+b > mod ? a+b-mod : a+b);
}

int ps[5][(1<<14)+1];
int vs[5][(1<<14)+1];
int root[5] = {1405049,10002474,36684046,69727867,82181655};

int binpowc(int i,int b)
{
    if(b < 0)
        b += mod-1;
    return (int64_t(vs[i][b>>14])*ps[i][b&((1<<14)-1)])%mod;
}

int coeff[5] = {4868204,92161528,51211683,37815043,13944628};
int a[maxn];
int segTree[5][4*maxn];
int p[5][4*maxn];

void build(int l,int r,int indV,short j)
{
    if(l == r)
    {
        segTree[j][indV] = (int64_t(coeff[j]) * binpowc(j,a[l]))%mod;
        p[j][indV] = 1;
        return ;
    }
    int m = (l+r)/2;
    build(l,m,indV*2+1,j);
    build(m+1,r,indV*2+2,j);
    segTree[j][indV] = msum(segTree[j][indV*2+1],segTree[j][indV*2+2]);
    p[j][indV] = 1;
    return ;
}
void push(int l,int r,int indV,short j)
{
    if(l == r)
    {
        segTree[j][indV] = (int64_t(segTree[j][indV]) * p[j][indV])%mod;
        p[j][indV] = 1;
        return ;
    }
    segTree[j][indV] = (int64_t(segTree[j][indV]) * p[j][indV])%mod;
    p[j][indV*2+1] = (int64_t(p[j][indV*2+1])*p[j][indV])%(mod);
    p[j][indV*2+2] = (int64_t(p[j][indV*2+2])*p[j][indV])%(mod);
    p[j][indV] = 1;
    return ;
}
void modify(int lx,int rx,int x,int l,int r,int indV,short j)
{
    if(l > rx || r < lx)
        return ;
    else if(l >= lx && r <= rx)
    {
        p[j][indV] = (int64_t(p[j][indV])*x)%mod;
        push(l,r,indV,j);
        return ;
    }
    push(l,r,indV,j);
    int m = (l+r)/2;
    modify(lx,rx,x,l,m,indV*2+1,j);
    modify(lx,rx,x,m+1,r,indV*2+2,j);
    segTree[j][indV] = msum(segTree[j][indV*2+1],segTree[j][indV*2+2]);
}
int get(int lx,int rx,int l,int r,int indV,short j)
{
    if(l > rx || r < lx)
        return 0;
    else if(l >= lx && r <= rx)
    {
        return (int64_t(segTree[j][indV])*p[j][indV])%mod;
    }
    push(l,r,indV,j);
    int m = (l+r)/2;
    int sl = get(lx,rx,l,m,indV*2+1,j);
    int sr = get(lx,rx,m+1,r,indV*2+2,j);
    return msum(sl,sr);
}
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    for(int i = 0;i < 5;++i)
    {
        ps[i][0] = 1;
        for(int j = 1;j <= spl;++j)
        {
            ps[i][j] = (int64_t(ps[i][j-1])*root[i])%mod;
        }
    }
    for(int i = 0;i < 5;++i)
    {
        vs[i][0] = 1;
        vs[i][1] = ps[i][spl];
        for(int j = 2;j <= spl;++j)
        {
            vs[i][j] = (int64_t(vs[i][j-1])*ps[i][spl])%mod;
        }
    }
    int n = 100000,q = 200000;
   // cin >> n >> q;
    for(int j = 0;j < n;++j)
    {
        a[j] = rnd()%mod;
        //cin >> a[j];
    }
    for(int j = 0;j < 5;++j)
        build(0,n-1,0,j);
    for(int j = 0;j < q;++j)
    {
        int t = rnd()%2+1;
        //cin >> t;
        if(t == 1)
        {
            int l = rnd()%n,r = rnd()%n;
           // cin >> l >> r;
            //l--;
           // r--;
            if(l > r)
                swap(l,r);
            int ans = 0;
            for(short u = 0;u < 5;++u)
            {
                ans = (ans + get(l,r,0,n-1,0,u));
            }
           // cout << ans%mod << "\n";
        }
        else
        {
            int l = rnd()%n,r = rnd()%n,v = rnd()%mod;
            //cin >> l >> r >> v;
            //l--;
            //r--;
            if(l > r)
                swap(l,r);
            for(short u = 0;u < 5;++u)
            {
                modify(l,r,binpowc(u,v),0,n-1,0,u);
            }
        }
    }
    return 0;
}*/

const int maxn = 100001;
const int spl = (1<<14);

const int mod = int(1e8)+543;

inline int msum(int a,int b)
{
    return (a+b > mod ? a+b-mod : a+b);
}

int ps[5][(1<<14)+1];
int vs[5][(1<<14)+1];
int root[5] = {1405049,10002474,36684046,69727867,82181655};

inline int binpowc(int i,int b)
{
    if(b < 0)
        b += mod-1;
    return (int64_t(vs[i][b>>14])*ps[i][b&((1<<14)-1)])%mod;
}

int coeff[5] = {4868204,92161528,51211683,37815043,13944628};
int a[maxn];
int segTree[5][4*maxn];
int p[5][4*maxn];

inline void build(int l,int r,int indV,short j)
{
    if(l == r)
    {
        segTree[j][indV] = (int64_t(coeff[j]) * binpowc(j,a[l]))%mod;
        p[j][indV] = 1;
        return ;
    }
    int m = (l+r)/2;
    build(l,m,indV*2+1,j);
    build(m+1,r,indV*2+2,j);
    segTree[j][indV] = msum(segTree[j][indV*2+1],segTree[j][indV*2+2]);
    p[j][indV] = 1;
    return ;
}
inline void push(int l,int r,int indV,short j)
{
    if(l == r)
    {
        segTree[j][indV] = (int64_t(segTree[j][indV]) * p[j][indV])%mod;
        p[j][indV] = 1;
        return ;
    }
    segTree[j][indV] = (int64_t(segTree[j][indV]) * p[j][indV])%mod;
    p[j][indV*2+1] = (int64_t(p[j][indV*2+1])*p[j][indV])%(mod);
    p[j][indV*2+2] = (int64_t(p[j][indV*2+2])*p[j][indV])%(mod);
    p[j][indV] = 1;
    return ;
}
inline void modify(int lx,int rx,int x,int l,int r,int indV,short j)
{
    if(p[j][indV] != 1)
        push(l,r,indV,j);
    if(l > rx || r < lx)
        return ;
    else if(l >= lx && r <= rx)
    {
        p[j][indV] = (int64_t(p[j][indV])*x)%mod;
        push(l,r,indV,j);
        return ;
    }
    int m = (l+r)/2;
    modify(lx,rx,x,l,m,indV*2+1,j);
    modify(lx,rx,x,m+1,r,indV*2+2,j);
    segTree[j][indV] = msum(segTree[j][indV*2+1],segTree[j][indV*2+2]);
}
inline int get(int lx,int rx,int l,int r,int indV,short j)
{
    if(l > rx || r < lx)
        return 0;
    else if(l >= lx && r <= rx)
    {
        return (int64_t(segTree[j][indV])*p[j][indV])%mod;
    }
    if(p[j][indV] != 1)
        push(l,r,indV,j);
    int m = (l+r)/2;
    int sl = get(lx,rx,l,m,indV*2+1,j);
    int sr = get(lx,rx,m+1,r,indV*2+2,j);
    return msum(sl,sr);
}
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    for(int i = 0;i < 5;++i)
    {
        ps[i][0] = 1;
        for(int j = 1;j <= spl;++j)
        {
            ps[i][j] = (int64_t(ps[i][j-1])*root[i])%mod;
        }
    }
    for(int i = 0;i < 5;++i)
    {
        vs[i][0] = 1;
        vs[i][1] = ps[i][spl];
        for(int j = 2;j <= spl;++j)
        {
            vs[i][j] = (int64_t(vs[i][j-1])*ps[i][spl])%mod;
        }
    }
    int n,q;
    cin >> n >> q;
    for(int j = 0;j < n;++j)
    {
        cin >> a[j];
    }
    for(int j = 0;j < 5;++j)
        build(0,n-1,0,j);
    for(int j = 0;j < q;++j)
    {
        int t;
        cin >> t;
        if(t == 1)
        {
            int l,r;
            cin >> l >> r;
            l--;
            r--;
            int ans = 0;
            for(short u = 0;u < 5;++u)
            {
                ans = (ans + get(l,r,0,n-1,0,u));
            }
            cout << ans%mod << "\n";
        }
        else
        {
            int l,r,v;
            cin >> l >> r >> v;
            l--;
            r--;
            for(short u = 0;u < 5;++u)
            {
                modify(l,r,binpowc(u,v),0,n-1,0,u);
            }
        }
    }
    return 0;
}
