#include <bits/stdc++.h>
#include "puzzle.h"
#define pb push_back
#define dl(s) int(s.size())
using ll = long long;
using ld = long double;
using namespace std;

// It must place a -1 for a horizontal single bridge, -3 for a horizontal double bridge
//-2 for a vertical single bridge and -4 for a vertical double bridge

bool solve(vector <vector<int>>& puzzle) {
    vector <vector<int>> pu = puzzle;
    int n = dl(pu);
    int m = dl(pu[0]);
    vector <vector<int>> used(n, vector <int> (m));
    while (true) {
        int best = 1e9, mini = 1e9;
        char dir = 'U';
        int ii = -1, jj = -1;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (pu[i][j] <= 0 || pu[i][j] == used[i][j]) continue;
                int can = 0;
                int bet = 1e9;
                char D = 'U';
                int maxi = 0, fl = 0;
                for (int i2 = i - 1; i2 >= 0; i2--) {
                    if (pu[i2][j] == -1 || pu[i2][j] == -3 || pu[i2][j] == -4) {
                        maxi = 1e9;
                        break;
                    }
                    if (pu[i2][j] > 0) {
                        int plu = min(pu[i2][j] - used[i2][j], 2);
                        if (pu[i - 1][j] == -2) plu = min(plu, 1);
                        if (plu == 0) maxi = 1e9;
                        can += plu;
                        fl = 1;
                        break;
                    }
                    maxi++;
                }
                if (fl == 0) maxi = 1e9;
                if (bet > maxi) {
                    bet = maxi;
                    D = 'U';
                }

                maxi = 0, fl = 0;
                for (int i2 = i + 1; i2 < n; i2++) {
                    if (pu[i2][j] == -1 || pu[i2][j] == -3 || pu[i2][j] == -4) {
                        maxi = 1e9;
                        break;
                    }
                    if (pu[i2][j] > 0) {
                        int plu = min(pu[i2][j] - used[i2][j], 2);
                        if (pu[i + 1][j] == -2) plu = min(plu, 1);
                        if (plu == 0) maxi = 1e9;
                        can += plu;
                        fl = 1;
                        break;
                    }
                    maxi++;
                }
                if (fl == 0) maxi = 1e9;
                if (bet > maxi) {
                    bet = maxi;
                    D = 'D';
                }

                maxi = 0, fl = 0;
                for (int j2 = j - 1; j2 >= 0; j2--) {
                    if (pu[i][j2] == -2 || pu[i][j2] == -3 || pu[i][j2] == -4) {
                        maxi = 1e9;
                        break;
                    }
                    if (pu[i][j2] > 0) {
                        int plu = min(pu[i][j2] - used[i][j2], 2);
                        if (pu[i][j - 1] == -1) plu = min(plu, 1);
                        if (plu == 0) maxi = 1e9;
                        can += plu;
                        fl = 1;
                        break;
                    }
                    maxi++;
                }
                if (fl == 0) maxi = 1e9;
                if (bet > maxi) {
                    bet = maxi;
                    D = 'L';
                }

                maxi = 0, fl = 0;
                for (int j2 = j + 1; j2 < m; j2++) {
                    if (pu[i][j2] == -2 || pu[i][j2] == -3 || pu[i][j2] == -4) {
                        maxi = 1e9;
                        break;
                    }
                    if (pu[i][j2] > 0) {
                        int plu = min(pu[i][j2] - used[i][j2], 2);
                        if (pu[i][j + 1] == -1) plu = min(plu, 1);
                        if (plu == 0) maxi = 1e9;
                        can += plu;
                        fl = 1;
                        break;
                    }
                    maxi++;
                }
                if (fl == 0) maxi = 1e9;
                if (bet > maxi) {
                    bet = maxi;
                    D = 'R';
                }

                if (can < (pu[i][j] - used[i][j])) {
                    //assert(false);
                    return false;
                }
                if (best > can - (pu[i][j] - used[i][j])) {
                    best = can - (pu[i][j] - used[i][j]);
                    mini = 1e9;
                }
                if (best == can - (pu[i][j] - used[i][j]) && mini > bet) {
                    mini = bet;
                    dir = D;
                    ii = i, jj = j;
                }
            }
        }
        if (ii == -1 && jj == -1) break;
        used[ii][jj]++;
        int i = ii, j = jj;
        if (dir == 'U') {
            for (int i2 = ii - 1; i2 >= 0; i2--) {
                if (pu[i2][j] > 0) {
                    used[i2][j]++;
                    break;
                }
                if (pu[i2][j] == 0) {
                    pu[i2][j] = -2;
                } else {
                    pu[i2][j] = -4;
                }
            }
        } else if (dir == 'D') {
            for (int i2 = ii + 1; i2 < n; i2++) {
                if (pu[i2][j] > 0) {
                    used[i2][j]++;
                    break;
                }
                if (pu[i2][j] == 0) {
                    pu[i2][j] = -2;
                } else {
                    pu[i2][j] = -4;
                }
            }
        } else if (dir == 'L') {
            for (int j2 = jj - 1; j2 >= 0; j2--) {
                if (pu[i][j2] > 0) {
                    used[i][j2]++;
                    break;
                }
                if (pu[i][j2] == 0) {
                    pu[i][j2] = -1;
                } else {
                    pu[i][j2] = -3;
                }
            }
        } else if (dir == 'R') {
            for (int j2 = jj + 1; j2 < m; j2++) {
                if (pu[i][j2] > 0) {
                    used[i][j2]++;
                    break;
                }
                if (pu[i][j2] == 0) {
                    pu[i][j2] = -1;
                } else {
                    pu[i][j2] = -3;
                }
            }
        }
        /*
        cout << endl;
        cout << i << " " << j << " " << dir << " " << best << " " << mini << endl;
        for (auto spe : pu) {
            for (auto x : spe) {
                cout << x << " ";
            }
            cout << endl;
        }
        */
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (pu[i][j] != used[i][j] && pu[i][j] > 0) {
                //assert(false);
                return false;
            }
        }
    }
    puzzle = pu;
    /*
    for (auto p : puzzle) {
        for (auto e : p) {
            cout << e << "  ";
        }
        cout << endl;
    }
    */
    return true;
}

void init(int numSubtests, double timeLimit) {
    //
}

/*
signed main() {
    int p1, p2;
    cin >> p1 >> p2;
    int n, m;
    cin >> n >> m;
    vector <vector<int>> cum;
    cum.resize(n, vector <int> (m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> cum[i][j];
        }
    }
    if (solve(cum)) {
        cout << "wa";
    }
}
*/

