#include <bits/stdc++.h>
#include "puzzle.h"
#define pb push_back
#define dl(s) int(s.size())
#define all(s) s.begin(), s.end()
#define f first
#define s second
#define po pop_back
using ll = long long;
using ld = long double;
using namespace std;

// It must place a -1 for a horizontal single bridge, -3 for a horizontal double bridge
//-2 for a vertical single bridge and -4 for a vertical double bridge

mt19937 rnd(228);

vector <vector<vector<pair<int, int>>>> edge;
vector <vector<int>> uzi;
int soz = 0;

void dfs(int x, int y) {
    soz++;
    uzi[x][y] = 1;
    for (auto i : edge[x][y]) {
        if (uzi[i.f][i.s] == 1) continue;
        dfs(i.f, i.s);
    }
}

bool f(vector <vector<int>>& puzzle) {
    int n = dl(puzzle);
    int m = dl(puzzle[0]);
    soz = 0;
    edge.clear();
    uzi.clear();
    uzi.resize(n, vector <int> (m));
    edge.resize(n, vector <vector<pair<int, int>>> (m));
    vector <vector<int>> pu = puzzle;
    vector <vector<int>> used(n, vector <int> (m));
    while (true) {
        int best = 1e9, mini = 1e9;
        vector <pair<pair<int, char>, pair<int, int>>> woo;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (pu[i][j] <= 0 || pu[i][j] == used[i][j]) continue;
                int can = 0;
                int bet = 1e9;
                char D = 'U';
                int maxi = 0, fl = 0;
                vector <pair<int, char>> se;
                for (int i2 = i - 1; i2 >= 0; i2--) {
                    if (pu[i2][j] == -1 || pu[i2][j] == -3 || pu[i2][j] == -4) {
                        maxi = 1e9;
                        break;
                    }
                    if (pu[i2][j] > 0) {
                        int plu = min(pu[i2][j] - used[i2][j], 2);
                        if (pu[i - 1][j] == -2) plu = min(plu, 1);
                        if (plu == 0) maxi = 1e9;
                        can += plu;
                        fl = 1;
                        break;
                    }
                    maxi++;
                }
                if (fl == 0) maxi = 1e9;
                if (maxi != 1e9) {
                    se.pb({maxi, 'U'});
                }

                maxi = 0, fl = 0;
                for (int i2 = i + 1; i2 < n; i2++) {
                    if (pu[i2][j] == -1 || pu[i2][j] == -3 || pu[i2][j] == -4) {
                        maxi = 1e9;
                        break;
                    }
                    if (pu[i2][j] > 0) {
                        int plu = min(pu[i2][j] - used[i2][j], 2);
                        if (pu[i + 1][j] == -2) plu = min(plu, 1);
                        if (plu == 0) maxi = 1e9;
                        can += plu;
                        fl = 1;
                        break;
                    }
                    maxi++;
                }
                if (fl == 0) maxi = 1e9;
                if (maxi != 1e9) {
                    se.pb({maxi, 'D'});
                }

                maxi = 0, fl = 0;
                for (int j2 = j - 1; j2 >= 0; j2--) {
                    if (pu[i][j2] == -2 || pu[i][j2] == -3 || pu[i][j2] == -4) {
                        maxi = 1e9;
                        break;
                    }
                    if (pu[i][j2] > 0) {
                        int plu = min(pu[i][j2] - used[i][j2], 2);
                        if (pu[i][j - 1] == -1) plu = min(plu, 1);
                        if (plu == 0) maxi = 1e9;
                        can += plu;
                        fl = 1;
                        break;
                    }
                    maxi++;
                }
                if (fl == 0) maxi = 1e9;
                if (maxi != 1e9) {
                    se.pb({maxi, 'L'});
                }

                maxi = 0, fl = 0;
                for (int j2 = j + 1; j2 < m; j2++) {
                    if (pu[i][j2] == -2 || pu[i][j2] == -3 || pu[i][j2] == -4) {
                        maxi = 1e9;
                        break;
                    }
                    if (pu[i][j2] > 0) {
                        int plu = min(pu[i][j2] - used[i][j2], 2);
                        if (pu[i][j + 1] == -1) plu = min(plu, 1);
                        if (plu == 0) maxi = 1e9;
                        can += plu;
                        fl = 1;
                        break;
                    }
                    maxi++;
                }
                if (fl == 0) maxi = 1e9;
                if (maxi != 1e9) {
                    se.pb({maxi, 'R'});
                }

                if (can < (pu[i][j] - used[i][j])) {
                    //assert(false);
                    return false;
                }
                if (best > can - (pu[i][j] - used[i][j])) {
                    best = can - (pu[i][j] - used[i][j]);
                    mini = 1e9;
                    woo.clear();
                }
                if (best == can - (pu[i][j] - used[i][j])) {
                    for (auto ni : se) {
                        woo.pb({ni, {i, j}});
                    }
                }
            }
        }
        if (dl(woo) == 0) break;
        sort(all(woo));
        //while (woo.back().f.f - woo[0].f.f >= 50) woo.po();
        int kim = abs(ll(rnd())) % dl(woo);
        char dir = woo[kim].f.s;
        int ii = woo[kim].s.f;
        int jj = woo[kim].s.s;
        used[ii][jj]++;
        int i = ii, j = jj;
        if (dir == 'U') {
            for (int i2 = ii - 1; i2 >= 0; i2--) {
                if (pu[i2][j] > 0) {
                    used[i2][j]++;
                    edge[i][j].pb({i2, j});
                    edge[i2][j].pb({i, j});
                    break;
                }
                assert(pu[i2][j] == -2 || pu[i2][j] == 0);
                if (pu[i2][j] == 0) {
                    pu[i2][j] = -2;
                } else {
                    pu[i2][j] = -4;
                }
            }
        } else if (dir == 'D') {
            for (int i2 = ii + 1; i2 < n; i2++) {
                if (pu[i2][j] > 0) {
                    used[i2][j]++;
                    edge[i][j].pb({i2, j});
                    edge[i2][j].pb({i, j});
                    break;
                }
                assert(pu[i2][j] == -2 || pu[i2][j] == 0);
                if (pu[i2][j] == 0) {
                    pu[i2][j] = -2;
                } else {
                    pu[i2][j] = -4;
                }
            }
        } else if (dir == 'L') {
            for (int j2 = jj - 1; j2 >= 0; j2--) {
                if (pu[i][j2] > 0) {
                    used[i][j2]++;
                    edge[i][j].pb({i, j2});
                    edge[i][j2].pb({i, j});
                    break;
                }
                assert(pu[i][j2] == -1 || pu[i][j2] == 0);
                if (pu[i][j2] == 0) {
                    pu[i][j2] = -1;
                } else {
                    pu[i][j2] = -3;
                }
            }
        } else if (dir == 'R') {
            for (int j2 = jj + 1; j2 < m; j2++) {
                if (pu[i][j2] > 0) {
                    used[i][j2]++;
                    edge[i][j].pb({i, j2});
                    edge[i][j2].pb({i, j});
                    break;
                }
                assert(pu[i][j2] == -1 || pu[i][j2] == 0);
                if (pu[i][j2] == 0) {
                    pu[i][j2] = -1;
                } else {
                    pu[i][j2] = -3;
                }
            }
        }
        /*
        cout << endl;
        cout << i << " " << j << " " << dir << " " << best << " " << mini << endl;
        for (auto spe : pu) {
            for (auto x : spe) {
                cout << x << " ";
            }
            cout << endl;
        }
        */
    }
    int p1 = 0, p2 = 0, ans = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (pu[i][j] > 0) {
                p1 = i, p2 = j;
                ans++;
            }
            if (pu[i][j] != used[i][j] && pu[i][j] > 0) {
                //assert(false);
                return false;
            }
        }
    }
    dfs(p1, p2);
    if (soz != ans) return false;
    puzzle = pu;
    return true;
}


bool solve(vector <vector<int>>& puzzle) {
    int n = dl(puzzle);
    int m = dl(puzzle[0]);
    for (int i = 0; i < 2000; i++) {
        vector <vector<int>> dam = puzzle;
        if (f(dam)) {
            puzzle = dam;
            return true;
        }
    }
    return false;
}

void init(int numSubtests, double timeLimit) {
    //
}

/*
signed main() {
    int p1, p2;
    cin >> p1 >> p2;
    int n, m;
    cin >> n >> m;
    vector <vector<int>> cum;
    cum.resize(n, vector <int> (m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> cum[i][j];
        }
    }
    if (solve(cum)) {
        cout << "wa";
    }
}
*/

