﻿#include <bits/stdc++.h>
#ifndef LOCAL
#include "ones.h"
#endif
#ifdef LOCAL
#include "debug.h"
#else
#define debug(x...) 228
#endif

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#define fi first
#define se second

const int inf = int(1e9) + 1;
const ll infll = ll(1e18) + 1;
const int mod = 100000000 + 543;
mt19937_64 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

template<typename T1, typename T2>
bool chmin(T1 &a, T2 b) {
    if (a > b) return a = b, true;
    return false;
}
template<typename T1, typename T2>
bool chmax(T1 &a, T2 b) {
    if (a < b) return a = b, true;
    return false;
}
vector<int> pa;
int Q = 0;
#ifdef LOCAL
bool hasOnes(int l, int r) {
    Q += 1;
    return pa[r] != pa[l - 1];
}
#endif

int cnt = 0;
vector<int> guessOnes(int n, int k) {
    vector<int> ans;
    int bl = n / k;
    function<void(int, int)> solve = [&](int l, int r) {
        if (!hasOnes(l, r)) return;
        int prv = l - 1;
        while (true) {
            int left = l - 1, right = r;
            while (right - left > 1) {
                int mid = (left + right) / 2;
                if (prv < mid && hasOnes(prv + 1, mid)) {
                    right = mid;
                } else {
                    left = mid;
                }
            }
            prv = right;
            ans.push_back(right);
            if (prv == r) break;
            if (!hasOnes(prv + 1, r)) break;
        }
    };
    for (int l = 1; l <= n; l += bl) {
        int r = min(l + bl - 1, n);
        if (!hasOnes(l, r)) continue;
        int m = (l + r) / 2;
        bool is_l = false, is_r = false;
        if (m != l && hasOnes(l, m - 1)) is_l = true;
        if (m != r && hasOnes(m + 1, r)) is_r = true;
        if (hasOnes(m, m)) {
            ans.push_back(m);
            if (is_l) solve(l, m - 1);
            if (is_r) solve(m + 1, r);
            continue;
        }
        if (is_l && is_r) {
            solve(l, m - 1);
            solve(m + 1, r);
            continue;
        }
        if (!is_l && !is_r) continue;
        if (is_l) {
            int fst = 0;
            //while (m - (1 << fst) >= l && !hasOnes(m - (1 << fst), m)) fst++;
            //int j = sqrt(bl);
            for (int j = 19; j >= 0; j--) {
                if (m - (1 << j) >= l && !hasOnes(m - (1 << j), m)) {
                    m -= 1 << j;
                }
            }
            ans.push_back(m - 1);
        } else {
            int fst = 0;
            //while (m + (1 << fst) <= r && !hasOnes(m, m + (1 << fst))) fst++;
            for (int j = 19; j >= 0; j--) {
                if (m + (1 << j) <= r && !hasOnes(m, m + (1 << j))) {
                    m += 1 << j;
                }
            }
            ans.push_back(m + 1);
        }
    }
    sort(ans.begin(), ans.end());
    return ans;
}
#ifdef LOCAL
map<int, int> score = {
        {10, 14480},
        {20, 27201},
        {50, 61908},
        {100, 114144},
        {200, 208697},
        {500, 455937},
        {1000, 811792},
        {2000, 1422396},
        {5000, 2879675},
        {10000, 4723779}
};
void solve_case() {
    int n, k = 0; cin >> n >> k;
    pa.assign(n + 1, 0);
    vector<int> ord(n);
    iota(ord.begin(), ord.end(), 0);
    vector<int> who;
    shuffle(ord.begin(), ord.end(), rnd);
    for (int i = 0; i < n; i++) {
        int x = 0;
        if (ord[i] < k) {
            who.push_back(i + 1);
            x = 1;
        }
        pa[i + 1] = pa[i] + x;
    }
    guessOnes(n, k);
    //debug(who, );
    debug(ld(Q * 100) / score[k]);
    debug(min((ld)10, (1 - sqrt(sqrt(1 - score[k] / ld(Q * 100)))) * 10));
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
#ifdef LOCAL
    freopen("inputik.txt", "r", stdin);
    clock_t tStart = clock();
#endif
    int T = 1;
    while (T--) {
        solve_case();
    }
#ifdef LOCAL
    fprintf(stderr, "\n>> Runtime: %.10fs\n", (double) (clock() - tStart) / CLOCKS_PER_SEC);
#endif
}
#endif