
#include <bits/stdc++.h>


template<class t>
using vc = std::vector<t>;
typedef long double ld;

using namespace std;


// vc<vc<int> > ok = {
//     {40, 1, 0, 0, 0, 0},
//     {5, 0, 1, 0, 0, 0},
//     {4, 0, 0, 1, 0, 0},
//     {3, 0, 0, 0, 1, 0},
//     {2, 0, 0, 0, 0, 1},
//     {1, 0, 0, 0, 0, 0}
// };

vc<vc<int> > ok = {
    {5, 4, 3, 2, 1}, //40
    {1, 0, 0, 0, 0}, //4
    {0, 1, 0, 0, 0}, //3
    {0, 0, 1, 0, 0}, //2
    {0, 0, 0, 1, 0}, //1
};

typedef long long ll;

const int MOD = 1e8 + 543;

struct matrix {
    int a[5][5]{};

    int *operator[](size_t i) { return a[i]; }

    matrix(int h = 1) {
        a[0][0] = a[1][1] = a[2][2] = a[3][3] = a[4][4] = h;
    }

    friend matrix operator*(matrix &x, matrix &y) {
        matrix ans(0);
        matrix s;
        for (int i = 0; i < 5; ++i) for (int j = 0; j < 5; ++j) s[j][i] = y[i][j];
        for (int i = 0; i < 5; ++i) {
            for (int j = 0; j < 5; ++j) {
                ll ss = 0;
#pra\
gma ivdep
                for (int k = 0; k < 5; ++k) {
                    ss += (ll)x[i][k] * s[j][k];
                }
                ans[i][j] = ss % MOD;
            }
        }
        return ans;
    }
};

matrix base;

matrix pw(matrix x, int c) {
    matrix ans;
    if (c <= 0) return ans;
    for (; c; c /= 2, x = x * x) if (c & 1) ans = ans * x;
    return ans;
}

void print(matrix c) {
    for (int i = 0; i < 5; ++i) {
        for (int j = 0; j < 5; ++j) {
            cout << c[i][j] << ' ';
        }
        cout << '\n';
    }
}

ll get(matrix w) {
    vc<vc<int> > zo = {
        {40}, {4}, {3}, {2}, {1}
    };
    matrix ans(0);
    for (int i = 0; i < 1; ++i) {
        for (int j = 0; j < 1; ++j) {
            for (int k = 0; k < 5; ++k) {
                ans[i][j] += (ll)w[i][k] * zo[k][j] % MOD;
            }
        }
    }
    return ans[0][0] % MOD;
}

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    for (int i = 0; i < 5; ++i) for (int j = 0; j < 5; ++j) base[i][j] = ok[i][j];
    // print(pw(base, MOD - 3));
    // cout.flush();
    // cout << get(pw(base, MOD - 5)) << endl;;
    int n = 1, q = 100000;
    cin >> n >> q;
    vc<int> o(n);
    for (auto &i: o) cin >> i, i -= 5;
    vc<int> z = {0, 1, 2, 3, 4, 40};
    for (int t; q-- && cin >> t;) {
        if (t == 1) {
            int l = 0, r = 0;
            cin >> l >> r, --l, --r;
            ll ans = 0;
            for (int i = l; i <= r; ++i) {
                if (o[i] < 0) ans += get(pw(base, MOD + o[i] - 1));
                else ans += get(pw(base, o[i]));
            }
            cout << ans % MOD << '\n';
        } else {
            int l, r, x;
            cin >> l >> r >> x, --l, --r;
            for (int i = l; i <= r; ++i) o[i] += x;
        }
    }
}
