//#include "ones.h"
#include<bits/stdc++.h>
#include <vector>
//#include <iostream>
//#include <utility>
//#include <algorithm>
//#include <random>
//#include <iomanip>
//#include <numeric>
//#include <cstring>

static const int N = 1e5 + 3;

static int n, k, n_tests;
static int input[N];

static long long number_of_queries;

static std::vector<int> readOnes()
{
    for(int i=1;i<=n;i++)
        input[i]=0;

    std::vector<int> _ones(k,0);

    for(int i=0;i<k;i++)
    {
        std::cin>>_ones[i];
        input[_ones[i]]=1;
    }

    for(int i=1;i<=n;i++)input[i]+=input[i-1];

    sort(_ones.begin(),_ones.end());

    return _ones;
}

bool hasOnes(int l,int r)
{
    number_of_queries++;

    std::cout << "QUERY " << l << ' ' << r << std::endl;

    if(1>l || l>n || 1>r || r>n || l>r)
    {
        std::cout << "Your program made an invalid query." << std::endl;
        exit(0);
    }

    return input[r] != input[l-1];
}
//#include<bits/stdc++.h>
//#include "ones.h"
//
using namespace std;
mt19937 gen(time(0));

std::vector < int > ans;
int K;
map < pair < int, int >, int > mp;

bool get(int vl, int vr, int pl, int pr) {
     int l, r;
     if(vl == pl) {l = (pl + pr) >> 1 + 1, r = pr;}
     else {
        l = pl, r = (pl + pr) >> 1;
     }
     if(!mp.count({l, r})) return mp[{vl, vr}] = hasOnes(vl, vr);
     if(mp[{l, r}] == 0) return mp[{vl, vr}] = 1;
     return mp[{vl, vr}] = hasOnes(vl, vr);

}
void go(int vl, int vr, int pl, int pr) {
     if((int)(ans.size()) == K || !get(vl, vr, pl, pr)) return;
     if(vl == vr) {
            ans.push_back(vl);
            return;
     }

     int mid = (vl + vr) >> 1;

     if(gen() % 2 == 0) {
     go(vl, mid, vl, vr);
     go(mid + 1, vr, vl, vr);
     }
     else {
            go(mid + 1, vr, vl, vr);
            go(vl, mid, vl, vr);

     }


}
std::vector < int >  guessOnes(int n, int k) {
     mp.clear();
     ans.clear();
     K = k;
     go(1, n, 1, n);

     sort(ans.begin(), ans.end());
     return ans;

}


static long long runOneTest(){
    number_of_queries = 0;

    std::vector<int> _ones = readOnes();

    std::vector<int> guess = guessOnes(n,k);

    if(_ones != guess)
    {
        std::cout << "Your program returned an incorrect answer." << std::endl;
        exit(0);
    }

    std::cout << "Your program successfully returned the correct positions and used " << number_of_queries << " queries." << std::endl;

    return number_of_queries;
}

int main(){
    std::cin >> n >> k >> n_tests;

    long long sum_queries = 0;
    for(int i = 0; i < n_tests; ++i)
        sum_queries = sum_queries + runOneTest();

    std::cout << "Your program successfully returned the correct positions and used " << sum_queries << " queries in total." << std::endl;
}

