//#include "ones.h"
#include<bits/stdc++.h>
#include <vector>
//#include <iostream>
//#include <utility>
//#include <algorithm>
//#include <random>
//#include <iomanip>
//#include <numeric>
//#include <cstring>

static const int N = 1e5 + 3;

static int n, k, n_tests;
static int input[N];

static long long number_of_queries;
using namespace std;
//using namespace std;
mt19937 gen(time(0));
int S;
static std::vector<int> readOnes()
{
    for(int i=1;i<=n;i++)
        input[i]=0;

    std::vector<int> _ones(k,0);

    vector < int > pos;
    for(int i = 1; i <= n; i++) pos.push_back(i);

    shuffle(pos.begin(), pos.end(), gen);

    sort(pos.begin(), pos.begin() + k + 1);

//     vector < int > ones(k, 0);
    for(int i=0;i<k;i++)
    {
        _ones[i] = pos[i];
        input[_ones[i]]=1;
    }

    for(int i=1;i<=n;i++)input[i]+=input[i-1];

    sort(_ones.begin(),_ones.end());

    return _ones;
}

bool hasOnes(int l,int r)
{
    number_of_queries++;

//    std::cout << "QUERY " << l << ' ' << r << std::endl;

    if(1>l || l>n || 1>r || r>n || l>r)
    {
        std::cout << "Your program made an invalid query." << std::endl;
        exit(0);
    }

    return input[r] != input[l-1];
}

//#include<bits/stdc++.h>
//#include "ones.h"
//
//using namespace std;
////using namespace std;
//mt19937 gen(time(0));
int f(int iter, int n, int k, int sz) {
    return max(1, (n - iter) / (k - sz));
}
vector < int > d;
void get(int l, int r) {
          int res = 0;
          int iter = l;
          int R = r;

          while(iter <= R) {
                res = 0, l = iter, r = R;
          while(l <= r) {
               int mid = (l + r) >> 1;
               if(hasOnes(iter, mid)) {
                  res = mid, r = mid - 1;
               }
               else l = mid + 1;
          }

          if(res > 0) {d.push_back(res); iter = res + 1;}
          else break;
          }
}
std::vector < int > ans;
std::vector < int >  guessOnes(int n, int k) {

      ans.clear();
      d.clear();

      int iter = 0;
      while(iter + 1 <= n && (int)(ans.size()) != k) {
          int l = iter + 1, r = n;
          int res = 0;

          while(l <= r) {
               int mid = (l + r) >> 1;
               if(hasOnes(iter + 1, mid)) {
                  res = mid, r = mid - 1;
               }
               else l = mid + 1;
          }
          if(res > 0) ans.push_back(res);
          else break;

          if((int)(ans.size()) != k) iter = res + f(res, n, k, (int)(ans.size()));
      }
//           for(auto to : ans) cout << "!" << to << ' ';
//     cout << endl;
//    cout << (int)(ans.size()) << ' ' << d.size() << endl;
     vector < int > pos;

     for(int i = 1; i < (int)(ans.size()); i++) pos.push_back(i);

     sort(pos.begin(), pos.end(),
          [](const int &i, const int &j) {return ans[i] - ans[i - 1] > ans[j] - ans[j - 1];});
     if((int)(ans.size()) != k) {
        for(auto j : pos)
            if(ans[j - 1] < ans[j] - 1 && hasOnes(ans[j - 1] + 1, ans[j] - 1)) get(ans[j - 1] + 1, ans[j] - 1);
     }
     if((int)(ans.size() + d.size()) != k) get(ans.back() + 1, n);

//     for(auto to : d) cout << "!" << to << ' ';
//     cout << endl;

     for(auto to : d) ans.push_back(to);

     sort(ans.begin(), ans.end());
     return ans;

}

static long long runOneTest(){
    number_of_queries = 0;

    std::vector<int> _ones = readOnes();

    std::vector<int> guess = guessOnes(n,k);

    if(_ones != guess)
    {
        for(auto to : guess) cout << to << ' ';
        cout << endl;
        for(auto to :_ones) cout << to << ' ';
        cout << endl;

        std::cout << "Your program returned an incorrect answer." << std::endl;
        exit(0);
    }

    std::cout << "Your program successfully returned the correct positions and used " << number_of_queries << " queries." << std::endl;

    return number_of_queries;
}

int main(){
    std::cin >> n >> k >> n_tests;

    long long sum_queries = 0;
    for(int i = 0; i < n_tests; ++i)
        sum_queries = sum_queries + runOneTest();

    std::cout << "Your program successfully returned the correct positions and used " << sum_queries << " queries in total." << std::endl;
}

