#include<bits/stdc++.h>
#define int long long

using namespace std;
const int mod = 1e8 + 543;
const int N = 1e5 + 10;
const int M = 1e6 + 10;

typedef array < array < int, 5 >, 5> Matrix;


int a[N], pref[N];

Matrix mul(Matrix a, Matrix b) {
       Matrix c;

       for(int i = 0; i < 5; i++)
       for(int j = 0; j < 5; j++)
       c[i][j] = 0;

       for(int i = 0; i < 5; i++)
       for(int j = 0; j < 5; j++)
       for(int k = 0; k < 5; k++) {
           c[i][j] += (a[i][k] * b[k][j]) % mod;
           if(c[i][j] >= mod) c[i][j] -= mod;
       }

       return c;
}

Matrix bp(Matrix a, int k) {
       Matrix res;

       for(int i = 0; i < 5; i++)
       for(int j = 0; j < 5; j++)
       res[i][j] = (i == j);

       while(k > 0) {
          if((k & 1)) {
             res = mul(res, a);
             k--;
          }
          else {
             a = mul(a, a);
             k /= 2;
          }
       }

       return res;
}

int get(int x) {
    if(x < 5) return  x;

    Matrix a;
    a[0] = {0, 0, 0, 0, 1};
    a[1] = {1, 0, 0, 0, 2};
    a[2] = {0, 1, 0, 0, 3};
    a[3] = {0, 0, 1, 0, 4};
    a[4] = {0, 0, 0, 1, 5};

    x--;

    a = bp(a, x - 3);

    array < int, 5 > b, c;
    b = {0, 1, 2, 3, 4};
    c = {0, 0, 0, 0, 0};


    for(int k = 0; k < 5; k++)
    for(int j = 0; j < 6; j++) {
        c[j] += (b[k] * a[k][j]) % mod;
        if(c[j] >= mod) c[j] -= mod;
    }

    return c[4];

}

int dop[N * 4];

void push(int v, int vl, int vr) {
     if(vl == vr) a[vl] += dop[v];
     else {
        dop[v * 2] += dop[v], dop[v * 2 + 1] += dop[v];
     }
     dop[v] = 0;
}

void upd(int v, int vl, int vr, int l, int r, int x) {
     push(v, vl, vr);
     if(vl > r || vr < l) return;
     if(vl >= l && vr <= r) {
        dop[v] += x;
        push(v, vl, vr);
        return;
     }

     int mid = (vl + vr) >> 1;
     upd((v << 1), vl, mid, l, r, x);
     upd((v << 1) + 1, mid + 1, vr, l, r, x);

}

int one(int v, int vl, int vr, int pos) {
    push(v, vl, vr);
    if(vl == vr) return a[vl];
    int mid = (vl + vr) >> 1;
    if(pos <= mid) return one((v << 1), vl, mid, pos);
    else return one((v << 1) + 1, mid + 1, vr, pos);
}
void solve() {
     int n, q;
     cin >> n >> q;

     for(int i = 1; i <= n; i++) cin >> a[i];

     for(int i = 1; i <= q; i++) {
         int type, l, r;
         cin >> type >> l >> r;

         if(type == 1) cout << get(one(1, 1, n, l)) << endl;
         else {
            int x;
            cin >> x;

            upd(1, 1, n, l, r, x);
         }
     }





}

int32_t main() {
    #ifdef LOCAL
    freopen("input.txt","r",stdin);
    freopen("output.txt","w",stdout);
    #else

    #endif // LOCAL

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();
    return 0;
}



