//#pragma GCC target("avx2")
#include<bits/stdc++.h>
#define int long long

using namespace std;
const int mod = 1e8 + 543;
const int N = 1e5 + 10;
const int M = 1e6 + 10;

typedef array < array < int, 5 >, 5> Matrix;


int a[N];
Matrix calc[N];

Matrix mul(Matrix a, Matrix b) {
       Matrix c;

       for(int i = 0; i < 5; i++)
       for(int j = 0; j < 5; j++)
       c[i][j] = 0;

       for(int i = 0; i < 5; i++)
       for(int j = 0; j < 5; j++)
       for(int k = 0; k < 5; k++) {
           c[i][j] += (1ll * a[i][k] * b[k][j]) % mod;
           if(c[i][j] >= mod) c[i][j] -= mod;
       }

       return c;
}
Matrix res;
Matrix c;
Matrix A;

void bp(int k) {


if(k < N) {
        res = calc[k];
        return;
}
k -= N;
c = A;
       for(int i = 0; i < 5; i++)
       for(int j = 0; j < 5; j++)
       res[i][j] = (i == j);

       while(k >= N) {
          if((k & 1)) {
             res = mul(res, c);
             k--;
          }
          else {
             c = mul(c, c);
             k >>= 1;
          }
       }
       res = mul(res, calc[N]);

}

int get(int x) {
    if(x < 5) return  x;

    x--;

    bp(x - 3);

    int c = 0;
    for(int k = 0; k < 5; k++)
    for(int j = 4; j < 5; j++) {
        c += (1ll * k * res[k][j]) % mod;
        if(c >= mod) c -= mod;
    }

    return c;

}

int dop[N * 4];

void push(int v, int vl, int vr) {
     if(vl == vr) {
            a[vl] += dop[v];
            if(a[vl] >= mod - 1) a[vl] -= (mod - 1);
     }
     else {
        dop[v * 2] += dop[v], dop[v * 2 + 1] += dop[v];
        if(dop[v * 2] >= mod - 1) dop[v * 2] -= mod - 1;
        if(dop[v * 2 + 1] >= mod - 1) dop[v * 2 + 1] -= mod - 1;

     }
     dop[v] = 0;
}

void upd(int v, int vl, int vr, int l, int r, int x) {
     push(v, vl, vr);
     if(vl > r || vr < l) return;
     if(vl >= l && vr <= r) {
        dop[v] += x;
        push(v, vl, vr);
        return;
     }

     int mid = (vl + vr) >> 1;
     upd((v << 1), vl, mid, l, r, x);
     upd((v << 1) + 1, mid + 1, vr, l, r, x);

}

int one(int v, int vl, int vr, int pos) {
//    return a[pos];
    push(v, vl, vr);
    if(vl == vr) return a[vl];
    int mid = (vl + vr) >> 1;
    if(pos <= mid) return one((v << 1), vl, mid, pos);
    else return one((v << 1) + 1, mid + 1, vr, pos);
}
void solve() {


    A[0] = {0, 0, 0, 0, 1};
    A[1] = {1, 0, 0, 0, 2};
    A[2] = {0, 1, 0, 0, 3};
    A[3] = {0, 0, 1, 0, 4};
    A[4] = {0, 0, 0, 1, 5};
       for(int i = 0; i < 5; i++)
       for(int j = 0; j < 5; j++)
       res[i][j] = (i == j);
    calc[0] = res;


    for(int i = 0; i < N; i++) {
        calc[i] = mul(calc[i - 1], A);
//        cout << get(i) << ", ";
    }
//    cout << endl;
     int n, q;
     cin >> n >> q;

     for(int i = 1; i <= n; i++) {
         cin >> a[i];
     }



     for(int i = 1; i <= q; i++) {
         int type, l, r;
         cin >> type >> l >> r;

         if(type == 1) cout << get(one(1, 1, n, l)) << "\n";
         else {
            int x;
            cin >> x;

            upd(1, 1, n, l, r, x);
         }
     }





}

int32_t main() {
    #ifdef LOCAL
    freopen("input.txt","r",stdin);
    freopen("output.txt","w",stdout);
    #else

    #endif // LOCAL

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();
    return 0;
}
