#include <bits/stdc++.h>
using namespace std;
#define int long long
const int MOD = 1e8 + 543;
typedef vector < vector < int > > matrix;
matrix mult(matrix B, matrix C) {
    int N = B.size(), M = C[0].size(), K = C.size();
    assert(K == B[0].size());
    matrix A(N, vector < int > (M, 0));
    for (int i = 0; i < N; i++)
        for (int j = 0; j < M; j++)
            for (int k = 0; k < K; k++)
                (A[i][j] += B[i][k] * C[k][j] % MOD) %= MOD;
    return A;
}
matrix binp(matrix x, int y) {
    matrix res = x; y--;
    while (y) {
        if (y & 1) res = mult(res, x);
        x = mult(x, x);
        y /= 2;
    }
    return res;
}
main() {
    matrix st = {{0}, {1}, {2}, {3}, {4}};
    matrix X = {{0, 1, 0, 0, 0},
                {0, 0, 1, 0, 0},
                {0, 0, 0, 1, 0},
                {0, 0, 0, 0, 1},
                {1, 2, 3, 4, 5}};
    function < int(int) > get = [&](int N) {
        if (N < 5) return st[N][0];
        return mult(binp(X, N - 4), st)[4][0];
    };
    int n, q;
    cin >> n >> q;
    vector < int > a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    while (q--) {
        int t, l, r;
        cin >> t >> l >> r;
        l--; r--;
        if (t == 1) {
            int ans = 0;
            for (int i = l; i <= r; i++) ans = (ans + get(a[i]));
            cout << ans << '\n';
        } else {
            int x;
            cin >> x;
            for (int i = l; i <= r; i++) {
                a[i] += x;
            }
        }
    }
}
