#include <bits/stdc++.h>
using namespace std;
const int MOD = 1e8 + 543;
typedef vector < vector < int > > matrix;
matrix mult(matrix B, matrix C) {
    int N = B.size(), M = C[0].size(), K = C.size();
    assert(K == B[0].size());
    matrix A(N, vector < int > (M, 0));
    for (int i = 0; i < N; i++)
        for (int j = 0; j < M; j++)
            for (int k = 0; k < K; k++)
                (A[i][j] += 1LL * B[i][k] * C[k][j] % MOD) %= MOD;
    return A;
}
const int N = 1e6 + 1;
int x[N];
main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    matrix one = {{1, 0, 0, 0, 0},
                  {0, 1, 0, 0, 0},
                  {0, 0, 1, 0, 0},
                  {0, 0, 0, 1, 0},
                  {0, 0, 0, 0, 1}};
    matrix st = {{0}, {1}, {2}, {3}, {4}};
    matrix X = {{0, 1, 0, 0, 0},
                {0, 0, 1, 0, 0},
                {0, 0, 0, 1, 0},
                {0, 0, 0, 0, 1},
                {1, 2, 3, 4, 5}};
    const int M = sqrt(MOD);
    vector < matrix > A(M + 10), B(M);
    B[0] = one; for (int i = 1; i < M; i++) B[i] = mult(B[i - 1], X);
    matrix XX = mult(B[M - 1], X);
    A[0] = one; for (int i = 1; i < M + 10; i++) A[i] = mult(A[i - 1], XX);

    function < matrix(int) > get = [&](int p) {
        int k = p / M, o = p % M;
        return mult(A[k], B[o]);
    };
    int n, q;
    cin >> n >> q;
    vector < int > a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    vector < matrix > inp(n);
    for (int i = 0; i < n; i++) {
        if (a[i] - 4 > 0) inp[i] = get(a[i] - 4); else inp[i] = one;
    }
    while (q--) {
        int t, l, r;
        cin >> t >> l >> r;
        l--; r--;
        if (t == 1) {
            int ans = 0, ANS = 0;
            if (a[l] < 5) ans += a[l]; else ans += mult(inp[l], st)[4][0];
            cout << ans << '\n';
        } else {
            int x;
            cin >> x;
            int kk = x;
            if (a[l] < 4) {
                kk -= 4 - a[l];
            }
            if (a[l] < 100) {
                a[l] += x;
            }
            if (kk > 0) inp[l] = mult(inp[l], get(kk));
        }
    }
}
