#include <bits/stdc++.h>
#define int long long

using namespace std;

const int M = 1e8 + 543;
const int M1 = 60;
const int N = 1e5 + 100;

int *dp;

vector <vector <int> > pw[M1];

vector <vector <int> > base_matr = {
    {5, 4, 3, 2, 1},
    {1, 0, 0, 0, 0},
    {0, 1, 0, 0, 0},
    {0, 0, 1, 0, 0},
    {0, 0, 0, 1, 0}
};

vector <vector <int> > single_matrix = {
    {1, 0, 0, 0, 0},
    {0, 1, 0, 0, 0},
    {0, 0, 1, 0, 0},
    {0, 0, 0, 1, 0},
    {0, 0, 0, 0, 1}
};

vector <vector <int> > c = base_matr;

vector <vector <int> > base_dp = {
    {4},
    {3},
    {2},
    {1},
    {0}
};

vector <vector <int> > matrix_mult(vector <vector <int> > a, vector <vector <int> > b) {
    for (int i = 0; i < 5; i++)
        for (int j = 0; j < 5; j++) {
            c[i][j] = 0;
            for (int k = 0; k < 5; k++) c[i][j] += a[i][k] * b[k][j];
            c[i][j] %= M;
        }
    return c;
}

vector <vector <int> > binpow(int y) {
    vector <vector <int> > ans = single_matrix;
    for (int i = 0; i < M1 && y > 0; i++) {
        if (y & 1) ans = matrix_mult(pw[i], ans);
        y /= 2;
    }
    return ans;
}

int pref_sum[N];

int dpn(int n) {
    if (n < 5) {
        return n;
    }
    vector <vector <int> > c = matrix_mult(binpow(n - 4), base_dp);
    return c[0][0];
}

int *pref;
int a[N];

void init() {
    pw[0] = base_matr;
    for (int i = 1; i < M1; i++) pw[i] = matrix_mult(pw[i - 1], pw[i - 1]);
}

main()
{
    ios_base::sync_with_stdio(0);
    iostream::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    init();
    int n, q;
    cin >> n >> q;
    pref = (int*)calloc(sizeof(int), n + 1) + 1;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        pref[i] = pref[i - 1] + dpn(a[i]);
    }
    bool g = 1;
    while (q--) {
        int t;
        cin >> t;
        if (t == 1) {
            int l, r;
            cin >> l >> r, l--, r--;
            if (g) cout << pref[r] - pref[l - 1] << endl;
            else cout << dpn(a[l]) << endl;
        } else {
            int l, r, val;
            cin >> l >> r >> val, l--, r--;
            a[l] += val;
            g = 0;
        }
    }
}
