#include <bits/stdc++.h>
//#define int long long
#define pb push_back

using namespace std;

typedef long long ll;

const int M = 1e8 + 543;
const int M1 = 60;
const int N = 1e5 + 100;

ll *dp;

vector <vector <ll> > pw[M1];

vector <vector <ll> > base_matr = {
    {5, 4, 3, 2, 1},
    {1, 0, 0, 0, 0},
    {0, 1, 0, 0, 0},
    {0, 0, 1, 0, 0},
    {0, 0, 0, 1, 0}
};

vector <vector <ll> > single_matrix = {
    {1, 0, 0, 0, 0},
    {0, 1, 0, 0, 0},
    {0, 0, 1, 0, 0},
    {0, 0, 0, 1, 0},
    {0, 0, 0, 0, 1}
};

vector <vector <ll> > c = base_matr;

vector <vector <ll> > base_dp = {
    {4},
    {3},
    {2},
    {1},
    {0}
};

vector <vector <ll> > &matrix_mult(vector <vector <ll> > &a, vector <vector <ll> > &b) {
    for (int i = 0; i < 5; i++)
        for (int j = 0; j < 5; j++) {
            c[i][j] = 0;
            for (int k = 0; k < 5; k++) c[i][j] += a[i][k] * b[k][j];
            c[i][j] %= M;
        }
    return c;
}

vector <vector <ll> > ans;
vector <vector <ll> > &binpow(int y) {
    ans = single_matrix;
    for (int i = 0; i < M1 && y > 0; i++) {
        if (y & 1) ans = matrix_mult(pw[i], ans);
        y /= 2;
    }
    return ans;
}

ll pref_sum[N];

int dpn(int n) {
    if (n < 5) {
        return n;
    }
    return matrix_mult(binpow(n - 4), base_dp)[0][0];
}

ll *pref;
ll a[N];

void init() {
    pw[0] = base_matr;
    for (int i = 1; i < M1; i++) pw[i] = matrix_mult(pw[i - 1], pw[i - 1]);
}

main()
{
    ios_base::sync_with_stdio(0);
    iostream::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    init();
    int n, q;
    cin >> n >> q;

    pref = (ll*)calloc(sizeof(ll), n + 1) + 1;

    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    vector <vector <int> > qur;
    bool g = 1;
    for (int i = 0; i < q; i++) {
        int t;
        cin >> t;
        if (t == 1) {
            int l, r;
            cin >> l >> r;
            g &= (l == r);
            qur.pb({t, l, r});
        } else {
            int l, r, val;
            cin >> l >> r >> val;
            g &= (l == r);
            qur.pb({t, l, r, val});
        }
    }
    if (!g) {
        for (int i = 0; i < n; i++) {
            pref[i] = pref[i - 1] + dpn(a[i]);
        }
    }
    for (int i = 0; i < q; i++) {
        if (qur[i].size() == 3) {
            int l = qur[i][1], r = qur[i][2];
            l--, r--;
            if (!g) cout << (M + pref[r] - pref[l - 1]) % M << endl;
            else cout << dpn(a[l]) << endl;
        } else {
            int l = qur[i][1], r = qur[i][2], val = qur[i][3];
            l--, r--;
            a[l] += val;
        }
    }
}
