#include <bits/stdc++.h>
#include "ones.h"
#ifdef LOCAL
#include "Lgrader.cpp"
#endif // LOCAL

using namespace std;

vector<int> guessOnes(int n, int k) {
    vector<pair<int, int>> blocks;
    for (int i = 1; i <= n; i += n / k)
        if (hasOnes(i, min(n, i + n / k - 1)))
            blocks.push_back({i, min(n, i + n / k - 1)});
    vector<int> ans;
    for (auto u : blocks) {
        int lx = u.first, rx = u.second;
        int ll = lx;
        while (ll <= rx) {
            int l = ll, r = rx;
            while (l < r) {
                int md = (l + r) / 2;
                if (hasOnes(l, md))
                    r = md;
                else
                    l = md + 1;
            }
            if (l <= rx)
                ans.push_back(l);
            ll = l + 1;
        }
    }
    return ans;
}

