#include <bits/stdc++.h>
#include "puzzle.h"

#define pb push_back
#define sz(x) (int)(x).size()

using namespace std;

const int N = 205;

void init(int numSubtests, double timeLimit) {
}

int n, m;

int get (int x, int y) {
    return x * m + y;
}
pair < int , int > get (int h) {
    return {h / m, h % m};
}

vector < int > h[N];
vector < int > r[N];
vector < array < int , 4 > > par;

mt19937_64 rnd(13042023);

bool possible (vector<std::vector<int>>& p, vector < int > mask) {
    vector < vector < int > > pp = p;

    for (int bit = 0; bit < mask.size(); ++ bit) {
        if (mask[bit] == 0) continue;

        if (mask[bit] == 1) {
            pp[par[bit][0]][par[bit][1]] -= 1;
            pp[par[bit][2]][par[bit][3]] -= 1;
        }

        if (mask[bit] == 2) {
            pp[par[bit][0]][par[bit][1]] -= 2;
            pp[par[bit][2]][par[bit][3]] -= 2;
        }
    }

    bool ok = true;
    for (int i = 0; i < sz(p); ++ i) {
        for (int j = 0; j < sz(p[i]); ++ j) ok &= !pp[i][j];
    }

    if (ok) {

        for(int bit = 0; bit < sz(mask); ++ bit) {
            if (mask[bit] == 0) continue;

            if (mask[bit] == 1) {
                if (par[bit][0] == par[bit][2]) {
                    for (int j = par[bit][1] + 1; j <= par[bit][3] - 1; ++ j) p[par[bit][0]][j] = -1;
                } else {
                    for (int i = par[bit][0] + 1; i <= par[bit][2] - 1; ++ i) p[i][par[bit][1]] = -2;
                }
            }

            if (mask[bit] == 2) {
                if (par[bit][0] == par[bit][2]) {
                    for (int j = par[bit][1] + 1; j <= par[bit][3] - 1; ++ j) p[par[bit][0]][j] = -3;
                } else {
                    for (int i = par[bit][0] + 1; i <= par[bit][2] - 1; ++ i) p[i][par[bit][1]] = -4;
                }
            }
        }

    }

    return ok;
}

bool solve(std::vector<std::vector<int>>& puzzle) {

    n = puzzle.size();
    m = puzzle[0].size();


    int sum = 0;
    for (int i = 0; i < n; ++ i) {
        for (int j = 0; j < m; ++ j) {
            if (puzzle[i][j]) {
                h[i].push_back(j);
                r[j].push_back(i);
                sum += puzzle[i][j];
            }
        }
    }

    par.clear();

    for (int i = 0; i < n; ++ i) {
        for (int j = 0; j < (int)h[i].size() - 1; ++ j) par.push_back ({i, h[i][j], i, h[i][j + 1]});
    }

    for (int j = 0; j < m; ++ j) {
        for (int i = 0; i < (int)r[j].size() - 1; ++ i) par.push_back ({r[j][i], j, r[j][i + 1], j});
    }

    int up = 1;
    for (int i = 0; i < sz(par); ++ i) up *= 3;

    vector < int > ve_mask;

    for (int i = 0; i < 3*up; ++ i) {
        int s = 0, a = i;
        while (a) {
            s += a % 3;
            a /= 3;
        }

        if (s == sum) {
            ve_mask.pb (i);
        }
    }

//    sort (ve_mask.begin(), ve_mask.end(), [&](int a, int b){
//          int sa = 0; while (a) sa += a % 3, a /= 3;
//          int sb = 0; while (b) sb += b % 3, b /= 3;
//          return sa > sb;
//    });

    for(auto& _mask : ve_mask) {
        int mask = _mask;
        vector < int > ve;

        for (int i = 0; i < sz(par); ++ i) {
            ve.pb(mask % 3);
            mask /= 3;
        }

        if (possible(puzzle, ve)) {
//            for (auto& it : ve) cout << it << ", ";
//            cout << "\n";
            break;
        }
    }


    for (int i = 0; i < n; ++ i) h[i].clear();
    for (int i = 0; i < m; ++ i) r[i].clear();

    return true;
}
