#include <bits/stdc++.h>

using namespace std;

using ll = long long;
const int mod = 1e8 + 543;
const int N = 1e6 + 6;

int pref[N], n, tt, a[N];

int add (int a, int b) {
    return a + b >= mod ? a + b - mod : a + b;
}

int sub (int a, int b) {
    return a - b < 0 ? a - b + mod : a - b;
}

int mul (int a, int b) {
    return 1ll * a * b % mod;
}

int main() {
#ifdef localy
    freopen ("input.txt", "r", stdin);
    freopen ("output.txt", "w", stdout);
#endif // localy
    ios_base::sync_with_stdio(false); cin.tie(nullptr);

    vector < int > x((int)1e6 + 1, 0);
    iota(x.begin(), x.begin() + 5, 0);

    for (int i = 5; i <= (int)1e6; ++ i) {
        for (int k = 1; k <= 5; ++ k) {
            x[i] = add(x[i], mul(x[i - k], (5 - k + 1)));
        }
    }

//    for (int i = 0; i <= 7; ++ i) cout << x[i] << " ";
//    cout << "\n";


    cin >> n >> tt;
    for (int i = 1; i <= n; ++ i) {
        cin >> a[i];
    }

    for (int i = 1; i <= n; ++ i) {
        pref[i] = add(pref[i - 1], a[x[i]]);
    }

    while (tt --) {
        int type;
        cin >> type;
        if (type == 1) {
            int l, r;
            cin >> l >> r;
            cout << sub(pref[r], pref[l - 1]) << "\n";
        }
    }

    return 0;
}
