#include <bits/stdc++.h>

using namespace std;

using ll = long long;
const int mod = 1e8 + 543;
const int N = 1e6 + 6;

int n, tt;
long long a[N];

int add (int a, int b) {
    return a + b >= mod ? a + b - mod : a + b;
}

int sub (int a, int b) {
    return a - b < 0 ? a - b + mod : a - b;
}

int mul (int a, int b) {
    return 1ll * a * b % mod;
}

vector < vector < int > > A;
vector < vector < int > > B[50];

vector < vector < int > > mul_matrix (vector < vector < int > >& A, vector < vector < int > > &B) {
    vector < vector < int > > C (6, vector < int >(6));

    for (int i = 0; i < 6; ++ i) {
        for (int j = 0; j < 6; ++ j) { C[i][j] = 0;
            for (int k = 0; k < 6; ++ k) {
                C[i][j] = add (C[i][j], mul (A[i][k], B[k][j]));
            }
        }
    }

    return C;
}

void print (vector < vector < int > > A) {
    cout << "=====================\n";
    for (int i = 0; i < 6; ++ i) {
        for (int j = 0; j < 6; ++ j) cout << A[i][j] << " ";
        cout << "\n";
    }
    cout << "=====================\n";
}

int bpow (vector < vector < int > >& A, long long b) {
    vector < vector < int > > res = A;

    int lg = 0;
    bool flag = false;
    while (b){
        if (b & 1) {
            res = mul_matrix(res, B[lg]);
        }
        b >>= 1;
        ++ lg;
    }

//    print (B[0]);

    return res[0][5];
}

int main() {
#ifdef localy
    freopen ("input.txt", "r", stdin);
    freopen ("output.txt", "w", stdout);
#endif // localy
    ios_base::sync_with_stdio(false); cin.tie(nullptr);

    A.resize (6);
    for (int i = 0; i <= 5; ++ i) A[i].resize(6, 0);
    for (int i = 0; i <= 5; ++ i) A[0][i] = (i < 5 ? i : 40);

    for (int i = 0; i < 30; ++ i) {
        B[i].resize (6);
        for (int j = 0; j < 6; ++ j) B[i][j].resize (6);
    }

    for (int i = 0; i < 5; ++ i) B[0][i + 1][i] = 1;
    for (int i = 0; i < 6; ++ i) B[0][i][5] = i;

    for (int i = 1; i < 30; ++ i) B[i] = mul_matrix (B[i - 1], B[i - 1]);


    cin >> n >> tt;
    for (int i = 1; i <= n; ++ i) cin >> a[i];

    while (tt --) {
        int type;
        cin >> type;
        if (type == 1) {
            int l, r;
            cin >> l >> r;
            if (a[r] <= 5) cout << A[0][a[r]] << "\n";
            else cout << bpow (A, a[r] - 5) << "\n";
        } else {
            int val, l, r;
            cin >> l >> r >> val;
            for (int i = l; i <= r; ++ i) a[i] += val;
        }
    }

    return 0;
}
