#include <bits/stdc++.h>

//#pragma GCC optimize("O3")

using namespace std;

using ll = long long;
const int mod = 1e8 + 543;
const int N = 1e6 + 6;

int n, tt;
long long a[N];

int add (int a, int b) {
    return a + b >= mod ? a + b - mod : a + b;
}

int sub (int a, int b) {
    return a - b < 0 ? a - b + mod : a - b;
}

int mul (int a, int b) {
    return 1ll * a * b % mod;
}

int B[50][6][6];
int A[6][6];

int C[6][6], res[6][6];
void mul_matrix (int l) {
    for (int i = 0; i < 6; ++ i) {
        for (int j = 0; j < 6; ++ j) { C[i][j] = 0;
            for (int k = 0; k < 6; ++ k) {
                B[l][i][j] = add (B[l][i][j], mul (B[l - 1][i][k], B[l - 1][k][j]));
            }
        }
    }
}
void mul_matrix1 (int l) {
    for (int i = 0; i < 6; ++ i) {
        for (int j = 0; j < 6; ++ j) { C[i][j] = 0;
            for (int k = 0; k < 6; ++ k) {
                C[i][j] = add (C[i][j], mul (res[i][k], B[l][k][j]));
            }
        }
    }
}

void print (vector < vector < int > > A) {
    cout << "=====================\n";
    for (int i = 0; i < 6; ++ i) {
        for (int j = 0; j < 6; ++ j) cout << A[i][j] << " ";
        cout << "\n";
    }
    cout << "=====================\n";
}

int bpow (long long b) {
    for (int j = 0; j < 6; ++ j) {
        for (int z = 0; z < 6; ++ z) res[j][z] = A[j][z];
    }
    int lg = 0;
    while (b){
        if (b & 1) {
            mul_matrix1(lg);
            for (int j = 0; j < 6; ++ j) {
                for (int z = 0; z < 6; ++ z) res[j][z] = C[j][z];
            }
        }
        b >>= 1;
        ++ lg;
    }

//    print (B[0]);

    return res[0][5];
}

//#include <ext/pb_ds/assoc_container.hpp>
//using namespace __gnu_pbds;
//gp_hash_table < long long , int > mp;

int main() {
#ifdef localy
    freopen ("input.txt", "r", stdin);
    freopen ("output.txt", "w", stdout);
#endif // localy
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    for (int i = 0; i <= 5; ++ i) A[0][i] = (i < 5 ? i : 40);
    for (int i = 0; i < 5; ++ i) B[0][i + 1][i] = 1;
    for (int i = 0; i < 6; ++ i) B[0][i][5] = i;

    for (int i = 1; i < 50; ++ i) {
        mul_matrix (i);
    }

    cin >> n >> tt;
    for (int i = 1; i <= n; ++ i) cin >> a[i];

    while (tt --) {
        int type;
        cin >> type;
        if (type == 1) {
            int l, r;
            cin >> l >> r;

            else cout << (a[r] <= 5 ? A[0][a[r]] : bpow (a[r] - 5)) << "\n";
        } else {
            int val, l, r;
            cin >> l >> r >> val;
            for (int i = l; i <= r; ++ i) a[i] += val;
        }
    }

    return 0;
}
