#include <bits/stdc++.h>

#pragma GCC optimize("-O3")

using namespace std;

using ll = long long;
const int mod = 1e8 + 543;
const int N = 1e6 + 6;

int n, tt, x[N];
int a[100001];

int add (int a, int b) {
    return a + b >= mod ? a + b - mod : a + b;
}

int sub (int a, int b) {
    return a - b < 0 ? a - b + mod : a - b;
}

int mul (int a, int b) {
    return 1ll * a * b % mod;
}

int B[6][6][30];
int A[6][6], l, r, val, type;
int pref[N];

int C[6][6], res[6][6];
void mul_matrix (int l) {
    for (int i = 0; i < 6; ++ i) {
        for (int j = 0; j < 6; ++ j) { C[i][j] = 0;
            for (int k = 0; k < 6; ++ k) {
                B[i][j][l] = add (B[i][j][l], mul (B[i][k][l - 1], B[k][j][l - 1]));
            }
        }
    }
}
void mul_matrix1 (int l) {
    for (int i = 0; i < 6; ++ i) {
        for (int j = 0; j < 6; ++ j) { C[i][j] = 0;
            for (int k = 0; k < 6; ++ k) {
                C[i][j] = add (C[i][j], mul (res[i][k], B[k][j][l]));
            }
        }
    }
}

void print (vector < vector < int > > A) {
    cout << "=====================\n";
    for (int i = 0; i < 6; ++ i) {
        for (int j = 0; j < 6; ++ j) cout << A[i][j] << " ";
        cout << "\n";
    }
    cout << "=====================\n";
}

int bpow (int b, int id) {
    for (int j = 0; j < 6; ++ j) {
        for (int z = 0; z < 6; ++ z) res[j][z] = A[j][z];
    }
    int lg = 0;
    while (b){
        if (b & 1) {
            mul_matrix1(lg);
            for (int j = 0; j < 6; ++ j) {
                for (int z = 0; z < 6; ++ z) res[j][z] = C[j][z];
            }
        }
        b >>= 1;
        ++ lg;
    }

//    print (B[0]);

    return res[0][id];
}


int main() {
#ifdef localy
    freopen ("input.txt", "r", stdin);
    freopen ("output.txt", "w", stdout);
#endif // localy
    ios_base::sync_with_stdio(false); cin.tie(nullptr);

    for (int i = 0; i <= 5; ++ i) A[0][i] = (i < 5 ? i : 40);
    for (int i = 0; i < 5; ++ i) B[i + 1][i][0] = 1;
    for (int i = 0; i < 6; ++ i) B[i][5][0] = i;

    for (int i = 1; i < 30; ++ i) mul_matrix (i);
    bool flag = true;
    cin >> n >> tt;
    for (int i = 1; i <= n; ++ i) cin >> a[i], flag &= a[i] < N;

    while (tt --) {
        cin >> type;
        if (type == 1) {
            cin >> l >> r;

            if (a[r] <= 5) {
                cout << A[0][a[r]] << "\n";
                continue;
            }

            int mn = 1e9, idd, k = 0, id = 5;
            for (int i = 5; i > 0; -- i) {
                if (mn > __lg(a[r] - i)) mn = __lg(a[r] - i), idd = id, k = a[r] - i;
                -- id;
            }

            cout << bpow (k, idd) << "\n";


        } else {
            flag = false;
            cin >> l >> r >> val;
            for (int i = l; i <= r; ++ i) a[i] += val;
        }
    }

    return 0;
}
