#include "ones.h"

std::vector<int> guessOnes(int n, int k) {
    std::vector<int> positions;

    int cur_l = 1;
    while (cur_l <= n && positions.size() < k) {
        int l = cur_l, r = n + 1 - (k - positions.size());
        while (l < r) {
            int mid = (l + r) >> 1;
            if (hasOnes(cur_l, mid)) {
                r = mid;
            } else {
                l = mid + 1;
            }
        }
        if (l == n + 1) {
            break;
        }
        positions.push_back(l);
        cur_l = l + 1;
    }

    return positions;
}
