#include "ones.h"
#include <algorithm>

std::vector<int> positions;

void dfs(int l, int r, int k) {
    if (!hasOnes(l, r)) {
        return;
    }
    if (l == r) {
        positions.push_back(l);
        return;
    }

    int tm = (l + r) >> 1;
    dfs(l, tm, k);
    if (positions.size() < k) {
        dfs(tm + 1, r, k);
    }
}

std::vector<int> guessOnes(int n, int k) {
    int l = 1, r = n;
    int tm = (l + r) >> 1;
    dfs(l, tm, k);

    if (positions.size() < k) {
        dfs(tm + 1, r, k);
    }

    return positions;
}

