#include <bits/stdc++.h>
#include "ones.h"

using namespace std;

mt19937_64 rng(time(0));

int lf;
vector<int> slv(int L, int rka) {
    vector<int> res;
    while (L <= rka && lf && hasOnes(L, rka)) {
        int l = L, r = rka;
        while (l < r) {
            int mid = (l + r) / 2;
            if (!hasOnes(L, mid)) {
                l = mid + 1;
            } else {
                r = mid;
            }
        }
        res.push_back(l);
        lf--;
        L = l + 1;
    }
    return res;
}

vector<int> guessOnes(int n, int k) {
    lf = k;
    vector<int> res;
    int l = 1, r = 1;
    vector<pair<int, int>> st;
    while (l <= n) {
        r = l + (rng() % (n - l + 1));
        st.push_back({l, r});
        l = r + 1;
    }
    for (auto lr : st) {
        l = lr.first;
        r = lr.second;
        for (auto i : slv(l, r)) res.push_back(i);
        if ((int)(res.size()) == k) break;
    }
    sort(res.begin(), res.end());
    return res;
}