#include <bits/stdc++.h>
#include "puzzle.h"

using namespace std;
#define ve vector
#define ll long long
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define fi first
#define se second

typedef pair<int, int> pii;
const int M = 1e8+543;
const int N = 1e6+5;
ll x[N];
int T;
double TL;

static std::vector<std::vector<int>> puzzle2;
static std::vector<std::vector<int>> puzzleOut2;
static std::vector<std::vector<bool>> visited2;

ve<int>mas;

int gmas(int v){
    if(mas[v]==v)return v;
    mas[v] = gmas(mas[v]);
    return mas[v];
}

void unite(int v, int u){
    mas[gmas(v)] = gmas(u);
}

void init(int T_, double TL_){
    T = T_;
    TL = TL_;
}

//mt19937 rng(130293)

int rnd(){
    return rand();
}



bool solve(ve<ve<int>>& a){
    ve<ve<int>>b = a;
    srand(288);
//    cout<<"enter";

    int n = sz(a);
    int m = sz(a[0]);

    int k = 0;
    ve<pii>c;

    int cl = 0;

    for(int i=0;i<n;i++){
        for(int j=0;j<m;j++){
            if(a[i][j]){
                c.push_back({i, j});
                k++;
            }
        }
    }
    mas.clear();
    mas.resize(k);

    ve<int>cx = {1, 0, -1, 0}, cy = {0, 1, 0, -1};
    ve<set<int>>ex(k);
    ve<ve<int>>val_edge(k, ve<int>(k, 0));
    ve<ve<ve<pii>>>bad_boys(k, ve<ve<pii>>(k));


    for(int i=0;i<k;i++){
        auto t1 = c[i];
        for(int j=i+1;j<k;j++){
            auto t2 = c[j];
            if(!(t1==t2)){
                bool ok = 1;
                if(t1.fi != t2.fi && t2.se==t1.se){
                    for(int y = min(t1.fi, t2.fi)+1; y<max(t1.fi, t2.fi);y++)if(a[y][t1.se]>0)ok = 0;
                }
                else if(t1.fi==t2.fi && t2.se != t1.se){
                    for(int x = min(t1.se, t2.se)+1; x<max(t1.se, t2.se); x++)if(a[t1.fi][x]>0)ok = 0;
                }
                else ok = 0;
                if(ok){
//                    cout<<"ex "<<t1.fi<<' '<<t1.se<<' '<<t2.fi<<' '<<t2.se<<endl;
                ex[i].insert(j);
                ex[j].insert(i);
                }
            }
        }
    }
    for(int i=0;i<k;i++)
        for(int j=i+1;j<k;j++)
            if(ex[i].find(j) != ex[i].end()){
                auto t2 = c[j];
                auto t1 = c[i];
                for(int h = 0;h<k;h++)
                    for(int z =h+1;z<k;z++)if(z!=i&&z!=j && h!=i && h!=j && ex[z].find(h)!=ex[z].end()){
                        if(t1.fi != t2.fi){
                            if(c[z].fi==c[h].fi && c[z].fi < max(t1.fi, t2.fi) && c[z].fi > min(t1.fi, t2.fi)){
                                if(min(c[z].se, c[h].se) < t1.se && max(c[z].se, c[h].se)>t1.se){
                                    bad_boys[i][j].push_back({h, z});
                                    bad_boys[j][i].push_back({h, z});
                                }
                            }
                        }
                        else{
                            if(c[z].se == c[h].se && min(t1.se, t2.se) < c[z].se && c[z].se < max(t1.se, t2.se)){
                                if(min(c[z].fi, c[h].fi) < t1.fi && t1.fi < max(c[z].fi, c[h].fi)){
                                    bad_boys[i][j].push_back({h, z});
                                    bad_boys[j][i].push_back({h, z});
                                }
                            }
                        }

//                        if(t1.fi!=t2.fi && c[h].se!=c[z].se &&  || t1.se!=t2.se && c[h].fi!=c[z].fi){
//                            bad_boys[i][j].push_back({h, z});
//                            bad_boys[j][i].push_back({h, z});
//                        }
                    }
            }


    bool go = 1;
    while(go){

//        cout<<"go"<<endl;
        int ver = rnd()%k;
        if(!sz(ex[ver]))continue;

        ve<int>st(4);
        ve<int>neig;
        for(auto z : ex[ver])neig.push_back(z);

        int x = c[ver].se, y = c[ver].fi;
        int need = a[y][x];
        int cur = 0;

        for(auto son : ex[ver])val_edge[ver][son] = val_edge[son][ver] = 0;

        while(need){
            int id = rnd()%sz(neig);
            if(st[id]<2){
                st[id]++;
                need--;
            }
//            int h;
//            if(c[son].se > c[ver].se)h = 0;
//            else if(c[son].se < c[ver].se)h=2;
//            else if(c[son].fi > c[ver].fi)h = 1;
//            else h = 3;
        }
//        cout<<"ver = "<<ver<<endl;
//        for(auto i : st)cout<<i<<' ';
//        cout<<endl;


        for(int id = 0;id<sz(neig);id++){
            int son = neig[id];
            if(st[id]){
                for(auto [z, o] : bad_boys[ver][son]){
//                    cout<<"bother "<<z<<' '<<o<<endl;
                    val_edge[o][z] = val_edge[z][o] = 0;
                }
//                cout<<ver<<' '<<son<<endl;
                val_edge[ver][son] = val_edge[son][ver] = st[id];
            }
        }
        /// print
        b = a;
        for(int i=0;i<k;i++){
            for(auto j : ex[i])if(val_edge[i][j]){
                if(c[i].se < c[j].se){
                    for(int x = c[i].se+1; x<c[j].se; x++)b[c[i].fi][x] = (val_edge[i][j] == 2 ? -3 : -1);
                }
                else if(c[i].se > c[j].se){
                    for(int x = c[j].se+1; x<c[i].se; x++)b[c[i].fi][x] = (val_edge[i][j] == 2 ? -3 : -1);

                }
                else if(c[i].fi < c[j].fi){
                    for(int y = c[i].fi+1; y<c[j].fi; y++)b[y][c[i].se] = (val_edge[i][j] == 2 ? -4 : -2);
                }
                else{
                    for(int y = c[j].fi+1; y<c[i].fi; y++)b[y][c[i].se] = (val_edge[i][j] == 2 ? -4 : -2);
                }
            }
        }
//    for (const std::vector<int>& row : b)
//    {
//        for (int elem : row)
//        {
//            if (elem > 0 && elem <= 8) std::cerr << elem;
//            else if (elem == EMPTY) std::cerr << " ";
//            else if (elem == HOR_SINGLE) std::cerr << "-";
//            else if (elem == HOR_DOUBLE) std::cerr << "=";
//            else if (elem == VERT_SINGLE) std::cerr << "|";
//            else if (elem == VERT_DOUBLE) std::cerr << "$";
//            else std::cerr << "?";
//        }
//        std::cerr << std::endl;
//    }
//    std::cerr << std::endl;


        /// ----
        /// check
        bool ok = 1;
        for(int i=0;i<k;i++){
            int need = a[c[i].fi][c[i].se];
            for(auto son : ex[i]){
                need -= val_edge[i][son];
            }
            ok &= (need == 0);
        }
        iota(all(mas), 0);
        for(int i = 0;i<k;i++){
            for(auto j : ex[i])if(val_edge[i][j]){
                unite(i, j);
            }
        }
        for(int i = 0;i<k;i++){
            ok &= (gmas(i) == gmas(0));
        }
        if(ok){
            for(int i=0;i<k;i++){
                int need = a[c[i].fi][c[i].se];
                for(auto son : ex[i]){
                    need -= val_edge[i][son];
                }
//                cout<<i<<' '<<need<<endl;
                ok &= (need == 0);
            }
            /// final
            for(int i=0;i<k;i++){
                for(auto j : ex[i])if(val_edge[i][j]){
                    if(c[i].se < c[j].se){
                        for(int x = c[i].se+1; x<c[j].se; x++)a[c[i].fi][x] = (val_edge[i][j] == 2 ? -3 : -1);
                    }
                    else if(c[i].se > c[j].se){
                        for(int x = c[j].se+1; x<c[i].se; x++)a[c[i].fi][x] = (val_edge[i][j] == 2 ? -3 : -1);

                    }
                    else if(c[i].fi < c[j].fi){
                        for(int y = c[i].fi+1; y<c[j].fi; y++)a[y][c[i].se] = (val_edge[i][j] == 2 ? -4 : -2);
                    }
                    else{
                        for(int y = c[j].fi+1; y<c[i].fi; y++)a[y][c[i].se] = (val_edge[i][j] == 2 ? -4 : -2);
                    }
                }
            }
//            cout<<"OK"<<endl;
            return 1;
        }
        if(timePassed() > 9.5)return 0;
    }
    return 0;
}
