#include <bits/stdc++.h>
#include "ones.h"

using namespace std;

constexpr int N = 1e5 + 2;

int n;
vector<int> ans;

void solve(int l, int r) {
    bool need = true;
    if (l != 0 || r != n - 1)
        need = hasOnes(l + 1, r + 1);
    if (need) {
        if (l == r) {
            ans.push_back(l + 1);
            return;
        } else {
            int m = (l + r) / 2;
            solve(l, m);
            solve(m + 1, r);
        }
    }
}


void solve2(int l, int r) {
    int len = (r - l + 1);
    int block = sqrt(len);
    if (block < 1)
        return;
    for (int left = l; left <= r; left += block) {
        int right = min(r, left + block - 1);
//        cerr << left + 1 << ' ' << right + 1 << '\n';
        bool have = hasOnes(left + 1, right + 1);
        if (have) {
            if (left == right)
                ans.push_back(left + 1);
            else
                solve2 (left, right);
        }
    }
}

vector<int> guessOnes(int len, int k) {
    n = len;
    ans.clear();
    if (k >= 2000)
        solve2(0, n - 1);
    else
        solve(0, n - 1);
    sort(ans.begin(), ans.end());
    return ans;
}
