#include <bits/stdc++.h>
#include "ones.h"

using namespace std;

constexpr int N = 1e5 + 2;

int n, k;
vector<int> ans;

bool solve(int l, int r, bool noneed = true) {
    if (ans.size() == k)
        return false;
    bool need = true;
    if (!noneed) {
//        cerr << "ask " << l + 1 << ' ' << r + 1 << '\n';
        need = hasOnes(l + 1, r + 1);
    } if (need) {
        if (l == r) {
            ans.push_back(l + 1);
            return true;
        } else {
            int m = (l + r) / 2;
            bool left = solve(l, m, false);
            if (left)
                return left;
            return solve(m + 1, r, true);
        }
    }
    return false;
}


void solve2(int l, int r) {
    if (ans.size() == k)
        return;
    int len = (r - l + 1);
    int block = sqrt(len);
    if (block < 1)
        return;
    for (int left = l; left <= r; left += block) {
        int right = min(r, left + block - 1);
//        cerr << left + 1 << ' ' << right + 1 << '\n';
        bool have = hasOnes(left + 1, right + 1);
        if (have) {
            if (left == right)
                ans.push_back(left + 1);
            else
                solve2 (left, right);
        }
    }
}

void solve3(int l, int r) {
    if (ans.size() == k)
        return;
    int len = 1;
//    cerr << " > " << l << ' ' << r << '\n';
    for (int left = l; left <= r; ) {
        int right = min(r, left + len - 1);
//        cerr << left << ' ' << right << '\n';
        bool have = hasOnes(left + 1, right + 1);
        if (have) {
            if (left == right)
                ans.push_back(left + 1);
            else
                solve3(left, right);
        }
        left += len;
        len *= 3;
    }
}

vector<int> guessOnes(int len, int kk) {
    n = len;
    k = kk;
    ans.clear();
//    solve3(0, n - 1);
//    if (k >= 2000)
//        solve2(0, n - 1);
//    else
    solve(0, n - 1);
    for (int i = 1; i < k; i ++) {
        solve(ans.back(), n - 1);
    }
//    sort(ans.begin(), ans.end());
//    for (int pos : ans)
//        cerr << pos << ' ';
//    cerr << '\n';
    return ans;
}
