#include <bits/stdc++.h>

using namespace std;

#define int long long
#define vec vector
#define pb push_back()
#define all(x) (x).begin(), (x).end()
#define f first
#define s second
#define sz(x) (int)x.size()

const int mod = 1e8 + 543;
const int N = 2e5 + 5;
int n, q, a[N];

vec<vec<int>> pls = {{0, 0, 0, 0, 1}, {1, 0, 0, 0, 2}, {0, 1, 0, 0, 3}, {0, 0, 1, 0, 4}, {0, 0, 0, 1, 5}};
vec<vec<int>> mns = {{0, 0, 0, 0, 1}, {1, 0, 0, 0, mod - 5}, {0, 1, 0, 0, mod - 4}, {0, 0, 1, 0, mod - 3}, {0, 0, 0, 1, mod - 2}};
vec<vec<int>> base;
vec<vec<int>> mat[N];
const int MN = 1e15;
unordered_map<int, int> mapka;

vec<vec<int>> mult(vec<vec<int>> a, vec<vec<int>> b) {
    int n = sz(a), m = sz(a[0]), k = sz(b[0]);
    vec<vec<int>> res(n, vec<int>(k));

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < k; j++) {
            for (int l = 0; l < m; l++) {
                (res[i][j] += a[i][l] * b[l][j]) %= mod;
            }
        }
    }

    return res;
}

vec<vec<int>> I(int k) {
    vec<vec<int>> res(k, vec<int>(k));
    for (int i = 0; i < k; i++) {
        res[i][i] = 1;
    }
    return res;
}

vec<vec<int>> bin_pow(vec<vec<int>> a, int x) {
    if (x == 0) {
        return I(sz(a));
    }
    if (x & 1) {
        return mult(a, bin_pow(a, x - 1));
    }
    vec<vec<int>> half = bin_pow(a, x / 2);
    return mult(half, half);
}

vec<vec<int>> get(int i) {
    if (i < 1000001) {
        return {{mapka[i - 4], mapka[i - 3], mapka[i - 2], mapka[i - 1], mapka[i]}};
    }
    return mult(base, bin_pow(pls, i - 4));
}

void solve() {
    base = {{0, 1, 2, 3, 4}};
    mapka[0] = 0;
    mapka[1] = 1;
    mapka[2] = 2;
    mapka[3] = 3;
    mapka[4] = 4;
    mapka[-1] = (-22 + mod) % mod;
    mapka[-2] = 33;
    mapka[-3] = (mapka[2] - 5 * mapka[1] - 4 * mapka[0] - 3 * mapka[-1] - 2 * mapka[-2] + 10 * mod) % mod;
    mapka[-4] = (mapka[1] - 5 * mapka[0] - 4 * mapka[-1] - 3 * mapka[-2] - 2 * mapka[-3] + 10 * mod) % mod;
    for (int i = 5; i < 1000001; i++) {
        mapka[i] = 5 * mapka[i - 1] + 4 * mapka[i - 2] + 3 * mapka[i - 3] + 2 * mapka[i - 4] + 1 * mapka[i - 5];
    }
    cin >> n >> q;
    vec<int> p(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        mat[i] = get(a[i]);
        p[i] = (mat[i][0][4] + p[i - 1]) % mod;
    }

    while (q--) {
        int type;
        cin >> type;

        if (type == 1) {
            int l, r;
            cin >> l >> r;
            cout << (p[r] - p[l - 1] + mod) % mod << '\n';
        } else {
            int l, r, val;
            cin >> l >> r >> val;

        }
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();

    return 0;
}
