#include <bits/stdc++.h>
#include "ones.h"
///#define endl '\n'
///#define int ll
#define ve vector
#define pb push_back
#define F first
#define S second
#define all(x) x.begin(),x.end()

using namespace std;

typedef long long ll;

ve <int> ans;
int kk;

mt19937 gen(time(0));

ll bin_search(int lef , int righ)
{
    if(lef == righ)
    {
        ans.pb(lef);
        return lef;
    }
    ll answer = -1;
    ll iter = 0;
    while(lef <= righ)
    {
        ll mid = (lef + righ) / 2;
        ++ iter;
        if(iter % 2)
        {
            if(hasOnes(lef , mid))
            {
                answer = mid;
                righ = mid - 1;
            }
            else
            {
                lef = mid + 1;
            }
        }
        else
        {
            if(mid <= righ && hasOnes(mid , righ))
            {
                answer = mid;
                lef = mid + 1;
            }
            else
            {
                righ = mid - 1;
            }
        }
    }
    ans.pb(answer);
    return answer;
}

ll go_solve(int lef , int righ , int gl = 0)
{
    ll mid = (lef + righ) / 2;
    if(lef == righ)
    {
        ans.pb(lef);
        return lef;
    }

    if(hasOnes(lef , mid))
    {
        if(mid + 1 <= righ)
        {
            bool do_bin = (gl < 0);
            if(kk > 50)do_bin = (gl % 2);
            if(do_bin && hasOnes(mid + 1 , righ))
            {
                return go_solve(mid + 1 , righ , gl + 1);
            }
            else
            {
                return go_solve(lef , mid , gl + 1);
            }
        }
        else
        {
            return go_solve(lef , mid , gl + 1);
        }
    }
    else
    {
        return go_solve(mid + 1 , righ , gl + 1);
    }
}

void solve(int l , int r , int k)
{
    if(!hasOnes(l , r))return;
    if(l == r)
    {
        ans.pb(l);
        return;
    }
    ll sz = (r - l + 1);
    ll mid = (l + r) / 2;
    ll p1 = l;
    bool ok1 = 0 , ok2 = 0;
    if(hasOnes(l , mid))
    {
        ok1 = 1;
        p1 = bin_search(l , mid);
    }
    ll p2 = r;
    if(mid + 1 <= r)
    {
        if(!ok1)
        {
            ok2 = 1;
            p2 = bin_search(mid + 1 , r);
        }
        else
        {
            if(hasOnes(mid + 1 , r))
            {
                ok2 = 1;
                p2 = bin_search(mid + 1 , r);
            }
        }
    }
    if(ok1)
    {
        if(ans.size() < k && l <= p1 - 1)solve(l , p1 - 1 , k);
        if(ans.size() < k && p1 + 1 <= mid)solve(p1 + 1 , mid , k);
    }
    if(ok2)
    {
        if(ans.size() < k && mid + 1 <= p2 - 1)solve(mid + 1 , p2 - 1 , k);
        if(ans.size() < k && p2 + 1 <= r)solve(p2 + 1 , r , k);
    }
}

vector<int> guessOnes(int n, int k)
{
    kk = k;
    ans.clear();
    solve(1 , n , k);
    /**for(auto to : ans)
    {
        cout << to << ' ';
    }
    cout << endl;**/
    sort(all(ans));
    return ans;
}

#ifdef LOCAL
#include "ones.h"

#include <vector>
#include <iostream>
#include <utility>
#include <algorithm>
#include <random>
#include <iomanip>
#include <numeric>
#include <cstring>

static const int N = 1e5 + 3;

static int n, k, n_tests;
static int input[N];

static long long number_of_queries;

static std::vector<int> readOnes()
{
    for(int i=1;i<=n;i++)
        input[i]=0;

    std::vector<int> _ones(k,0);

    for(int i=0;i<k;i++)
    {
       // std::cin>>_ones[i];
        _ones[i] = gen() % n + 1;
        input[_ones[i]]=1;
    }

    for(int i=1;i<=n;i++)input[i]+=input[i-1];

    sort(_ones.begin(),_ones.end());

    return _ones;
}

bool hasOnes(int l,int r)
{
    number_of_queries++;

    if(1>l || l>n || 1>r || r>n || l>r)
    {
        std::cout << "Your program made an invalid query." << std::endl;
        exit(0);
    }

    return input[r] != input[l-1];
}

static long long runOneTest(){
    number_of_queries = 0;

    std::vector<int> _ones = readOnes();

    std::vector<int> guess = guessOnes(n,k);

    if(_ones != guess)
    {
        std::cout << "Your program returned an incorrect answer." << std::endl;
        exit(0);
    }

    std::cout << "Your program successfully returned the correct positions and used " << number_of_queries << " queries." << std::endl;

    return number_of_queries;
}

int32_t main(){
    ///std::cin >> n >> k >> n_tests;
    n = int(1e5) , k = 10 , n_tests = 100;
    long long sum_queries = 0;
    for(int i = 0; i < n_tests; ++i)
        sum_queries = sum_queries + runOneTest();

    std::cout << "Your program successfully returned the correct positions and used " << sum_queries << " queries in total." << std::endl;
}

#endif // LOCAL
