#include "ones.h"
#include <bits/stdc++.h>

#include <random>

using namespace std;
mt19937 rnd(438920);

bool hasOnes(int l, int r);

vector<int> ans;
int K;

inline void find_ans(int l, int r) {
    if (l == r) {
        ans.push_back(r + 1);
        K--;
        return;
    }
    int mid = (l + r) / 2;
    int l1 = l;
    int r1 = mid;
    int l2 = mid + 1;
    int r2 = r;
    if (rnd() % 2 == 0) {
        if (l1 <= r1 && K && hasOnes(l1 + 1, r1 + 1)) {
            find_ans(l1, r1);
        }
        if (l2 <= r2 && K && hasOnes(l2 + 1, r2 + 1)) {
            find_ans(l2, r2);
        }
    } else {
        if (l2 <= r2 && K && hasOnes(l2 + 1, r2 + 1)) {
            find_ans(l2, r2);
        }
        if (l1 <= r1 && K && hasOnes(l1 + 1, r1 + 1)) {
            find_ans(l1, r1);
        }
    }
}

vector<int> guessOnes(int n, int k) {
    int cn = 100;
    vector<pair<int, int>> z;
    for (int i = 0; i < k; i += cn) {
        z.push_back({i, i + cn - 1});
    }
    z.back().second = n - 1;
    K = k;
    shuffle(z.begin(), z.end(), std::mt19937(std::random_device()()));
    ans.clear();
    for (int i = 0; i < z.size() && K; ++i) {
        int L = z[i].first, R = z[i].second;
        if (hasOnes(L + 1, R + 1)) {
            find_ans(L, R);
        }
    }
    std::sort(ans.begin(), ans.end());
    return ans;
}