#include "puzzle.h"
#include <bits/stdc++.h>

using namespace std;
const double eps = 1e-2;
double LIM;

double timePassed();

vector<vector<int>> a;
vector<vector<int>> ans;
vector<vector<int>> hor, vert;
struct cell {
    int i, j, val;
};
vector<vector<int>> idx;
vector<cell> c;
vector<int> At_all;
vector<int> cnt;
int C;
bool Can;

inline void change_vert(int j, int l, int r, int val) {
    for (int i = l; i <= r; ++i) {
        a[i][j] = val;
    }
}

inline void change_hor(int i, int l, int r, int val) {
    for (int j = l; j <= r; ++j) {
        a[i][j] = val;
    }
}

inline bool check_vert(int j, int l, int r) {
    for (int i = l; i <= r; ++i) {
        if (a[i][j] != 0)return false;
    }
    return true;
}

inline bool check_hor(int i, int l, int r) {
    for (int j = l; j <= r; ++j) {
        if (a[i][j] != 0)return false;
    }
    return true;
}

inline void rec(int id) {
    if (id == C) {
        ans = a;
        Can = true;
        return;
    }
    int i = c[id].i, j = c[id].j, val = c[id].val;
    if (hor[i][j] == -1 && !Can) {
        for (int k = 0; k <= min(val - cnt[id], c[idx[vert[i][j]][j]].val - cnt[idx[vert[i][j]][j]]); ++k) {
            if (k == 0) {
                if (At_all[idx[vert[i][j]][j]] == 1 && cnt[idx[vert[i][j]][j]] != c[idx[vert[i][j]][j]].val)continue;
                At_all[idx[vert[i][j]][j]]--;
                rec(id + 1);
                if (Can)return;
                At_all[idx[vert[i][j]][j]]++;
            }
            if (check_vert(j, vert[i][j] + 1, i - 1)) {
                if (k == 1) {
                    if (At_all[idx[vert[i][j]][j]] == 1 &&
                        cnt[idx[vert[i][j]][j]] + 1 != c[idx[vert[i][j]][j]].val) {
                        continue;
                    }
                    At_all[idx[vert[i][j]][j]]--;
                    change_vert(j, vert[i][j] + 1, i - 1, -2);
                    cnt[id]++;
                    cnt[idx[vert[i][j]][j]]++;
                    rec(id + 1);
                    if (Can)return;
                    At_all[idx[vert[i][j]][j]]++;
                    cnt[id]--;
                    cnt[idx[vert[i][j]][j]]--;
                    change_vert(j, vert[i][j] + 1, i - 1, 0);
                } else {
                    if (At_all[idx[vert[i][j]][j]] == 1 &&
                        cnt[idx[vert[i][j]][j]] + 2 != c[idx[vert[i][j]][j]].val) {
                        continue;
                    }
                    change_vert(j, vert[i][j] + 1, i - 1, -4);
                    cnt[id] += 2;
                    cnt[idx[vert[i][j]][j]] += 2;
                    At_all[idx[vert[i][j]][j]]--;
                    rec(id + 1);
                    if (Can)return;
                    At_all[idx[vert[i][j]][j]]++;
                    cnt[id] -= 2;
                    cnt[idx[vert[i][j]][j]] -= 2;
                    change_vert(j, vert[i][j] + 1, i - 1, 0);
                }
            }
        }
    } else if (vert[i][j] == -1 && !Can) {
        for (int k = 0; k <= min(val - cnt[id], c[idx[i][hor[i][j]]].val - cnt[idx[i][hor[i][j]]]); ++k) {
            if (k == 0) {
                if (At_all[idx[i][hor[i][j]]] == 1 && cnt[idx[i][hor[i][j]]] != c[idx[i][hor[i][j]]].val)continue;
                At_all[idx[i][hor[i][j]]]--;
                rec(id + 1);
                if (Can)return;
                At_all[idx[i][hor[i][j]]]++;
            }
            if (check_hor(i, hor[i][j] + 1, j - 1)) {
                if (k == 1) {
                    if (At_all[idx[i][hor[i][j]]] == 1 &&
                        cnt[idx[i][hor[i][j]]] + 1 != c[idx[i][hor[i][j]]].val)
                        continue;
                    At_all[idx[i][hor[i][j]]]--;
                    change_hor(i, hor[i][j] + 1, j - 1, -1);
                    cnt[id]++;
                    cnt[idx[i][hor[i][j]]]++;
                    rec(id + 1);
                    if (Can)return;
                    At_all[idx[i][hor[i][j]]]++;
                    cnt[id]--;
                    cnt[idx[i][hor[i][j]]]--;
                    change_hor(i, hor[i][j] + 1, j - 1, 0);
                } else {
                    if (At_all[idx[i][hor[i][j]]] == 1 &&
                        cnt[idx[i][hor[i][j]]] + 2 != c[idx[i][hor[i][j]]].val)
                        continue;
                    At_all[idx[i][hor[i][j]]]--;
                    change_hor(i, hor[i][j] + 1, j - 1, -3);
                    cnt[id] += 2;
                    cnt[idx[i][hor[i][j]]] += 2;
                    rec(id + 1);
                    if (Can)return;
                    At_all[idx[i][hor[i][j]]]++;
                    cnt[id] -= 2;
                    cnt[idx[i][hor[i][j]]] -= 2;
                    change_hor(i, hor[i][j] + 1, j - 1, 0);
                }
            }
        }
    } else if (!Can) {
        for (int k = 0; k <= min(val - cnt[id], c[idx[vert[i][j]][j]].val - cnt[idx[vert[i][j]][j]]); ++k) {
            for (int k1 = 0; k1 <= min(val - cnt[id] - k, c[idx[i][hor[i][j]]].val - cnt[idx[i][hor[i][j]]]); ++k1) {
                if (k == 0 && k1 == 0) {
                    if ((At_all[idx[vert[i][j]][j]] == 1 && cnt[idx[vert[i][j]][j]] != c[idx[vert[i][j]][j]].val) ||
                        (At_all[idx[i][hor[i][j]]] == 1 && cnt[idx[i][hor[i][j]]] != c[idx[i][hor[i][j]]].val))
                        continue;
                    At_all[idx[vert[i][j]][j]]--;
                    At_all[idx[i][hor[i][j]]]--;
                    rec(id + 1);
                    if (Can)return;
                    At_all[idx[i][hor[i][j]]]++;
                    At_all[idx[vert[i][j]][j]]++;
                }
                if (check_vert(j, vert[i][j] + 1, i - 1)) {
                    if (k == 1 && k1 == 0) {
                        if ((At_all[idx[vert[i][j]][j]] == 1 &&
                             cnt[idx[vert[i][j]][j]] + 1 != c[idx[vert[i][j]][j]].val) ||
                            (At_all[idx[i][hor[i][j]]] == 1 && cnt[idx[i][hor[i][j]]] != c[idx[i][hor[i][j]]].val))
                            continue;
                        At_all[idx[vert[i][j]][j]]--;
                        At_all[idx[i][hor[i][j]]]--;
                        change_vert(j, vert[i][j] + 1, i - 1, -2);
                        cnt[id]++;
                        cnt[idx[vert[i][j]][j]]++;
                        rec(id + 1);
                        if (Can)return;
                        At_all[idx[i][hor[i][j]]]++;
                        At_all[idx[vert[i][j]][j]]++;
                        cnt[id]--;
                        cnt[idx[vert[i][j]][j]]--;
                        change_vert(j, vert[i][j] + 1, i - 1, 0);
                    } else if (k == 2 && k1 == 0) {
                        if ((At_all[idx[vert[i][j]][j]] == 1 &&
                             cnt[idx[vert[i][j]][j]] + 2 != c[idx[vert[i][j]][j]].val) ||
                            (At_all[idx[i][hor[i][j]]] == 1 && cnt[idx[i][hor[i][j]]] != c[idx[i][hor[i][j]]].val))
                            continue;
                        At_all[idx[vert[i][j]][j]]--;
                        At_all[idx[i][hor[i][j]]]--;
                        change_vert(j, vert[i][j] + 1, i - 1, -4);
                        cnt[id] += 2;
                        cnt[idx[vert[i][j]][j]] += 2;
                        rec(id + 1);
                        if (Can)return;
                        At_all[idx[i][hor[i][j]]]++;
                        At_all[idx[vert[i][j]][j]]++;
                        cnt[id] -= 2;
                        cnt[idx[vert[i][j]][j]] -= 2;
                        change_vert(j, vert[i][j] + 1, i - 1, 0);
                    }
                }
                if (check_hor(i, hor[i][j] + 1, j - 1)) {
                    if (k == 0 && k1 == 1) {
                        if ((At_all[idx[vert[i][j]][j]] == 1 &&
                             cnt[idx[vert[i][j]][j]] != c[idx[vert[i][j]][j]].val) ||
                            (At_all[idx[i][hor[i][j]]] == 1 && cnt[idx[i][hor[i][j]]] + 1 != c[idx[i][hor[i][j]]].val))
                            continue;
                        At_all[idx[i][hor[i][j]]]--;
                        At_all[idx[vert[i][j]][j]]--;
                        change_hor(i, hor[i][j] + 1, j - 1, -1);
                        cnt[id]++;
                        cnt[idx[i][hor[i][j]]]++;
                        rec(id + 1);
                        if (Can)return;
                        At_all[idx[i][hor[i][j]]]++;
                        At_all[idx[vert[i][j]][j]]++;
                        cnt[id]--;
                        cnt[idx[i][hor[i][j]]]--;
                        change_hor(i, hor[i][j] + 1, j - 1, 0);
                    } else if (k == 0 && k1 == 2) {
                        if ((At_all[idx[vert[i][j]][j]] == 1 &&
                             cnt[idx[vert[i][j]][j]] != c[idx[vert[i][j]][j]].val) ||
                            (At_all[idx[i][hor[i][j]]] == 1 && cnt[idx[i][hor[i][j]]] + 2 != c[idx[i][hor[i][j]]].val))
                            continue;
                        At_all[idx[i][hor[i][j]]]--;
                        At_all[idx[vert[i][j]][j]]--;
                        change_hor(i, hor[i][j] + 1, j - 1, -3);
                        cnt[id] += 2;
                        cnt[idx[i][hor[i][j]]] += 2;
                        rec(id + 1);
                        if (Can)return;
                        At_all[idx[i][hor[i][j]]]++;
                        At_all[idx[vert[i][j]][j]]++;
                        cnt[id] -= 2;
                        cnt[idx[i][hor[i][j]]] -= 2;
                        change_hor(i, hor[i][j] + 1, j - 1, 0);
                    }
                }
                if (check_vert(j, vert[i][j] + 1, i - 1) && check_hor(i, hor[i][j] + 1, j - 1)) {
                    if (k == 1 && k1 == 1) {
                        if ((At_all[idx[vert[i][j]][j]] == 1 &&
                             cnt[idx[vert[i][j]][j]] + 1 != c[idx[vert[i][j]][j]].val) ||
                            (At_all[idx[i][hor[i][j]]] == 1 && cnt[idx[i][hor[i][j]]] + 1 != c[idx[i][hor[i][j]]].val))
                            continue;
                        At_all[idx[i][hor[i][j]]]--;
                        At_all[idx[vert[i][j]][j]]--;
                        change_vert(j, vert[i][j] + 1, i - 1, -2);
                        change_hor(i, hor[i][j] + 1, j - 1, -1);
                        cnt[id] += 2;
                        cnt[idx[vert[i][j]][j]]++;
                        cnt[idx[i][hor[i][j]]]++;
                        rec(id + 1);
                        if (Can)return;
                        At_all[idx[i][hor[i][j]]]++;
                        At_all[idx[vert[i][j]][j]]++;
                        cnt[id] -= 2;
                        cnt[idx[vert[i][j]][j]]--;
                        cnt[idx[i][hor[i][j]]]--;
                        change_vert(j, vert[i][j] + 1, i - 1, 0);
                        change_hor(i, hor[i][j] + 1, j - 1, 0);
                    } else if (k == 1 && k1 == 2) {
                        if ((At_all[idx[vert[i][j]][j]] == 1 &&
                             cnt[idx[vert[i][j]][j]] + 1 != c[idx[vert[i][j]][j]].val) ||
                            (At_all[idx[i][hor[i][j]]] == 1 && cnt[idx[i][hor[i][j]]] + 2 != c[idx[i][hor[i][j]]].val))
                            continue;
                        At_all[idx[i][hor[i][j]]]--;
                        At_all[idx[vert[i][j]][j]]--;
                        change_vert(j, vert[i][j] + 1, i - 1, -2);
                        change_hor(i, hor[i][j] + 1, j - 1, -3);
                        cnt[id] += 3;
                        cnt[idx[vert[i][j]][j]] += 1;
                        cnt[idx[i][hor[i][j]]] += 2;
                        rec(id + 1);
                        if (Can)return;
                        At_all[idx[i][hor[i][j]]]++;
                        At_all[idx[vert[i][j]][j]]++;
                        cnt[id] -= 3;
                        cnt[idx[vert[i][j]][j]] -= 1;
                        cnt[idx[i][hor[i][j]]] -= 2;
                        change_vert(j, vert[i][j] + 1, i - 1, 0);
                        change_hor(i, hor[i][j] + 1, j - 1, 0);
                    } else if (k == 2 && k1 == 1) {
                        if ((At_all[idx[vert[i][j]][j]] == 1 &&
                             cnt[idx[vert[i][j]][j]] + 2 != c[idx[vert[i][j]][j]].val) ||
                            (At_all[idx[i][hor[i][j]]] == 1 && cnt[idx[i][hor[i][j]]] + 1 != c[idx[i][hor[i][j]]].val))
                            continue;
                        At_all[idx[i][hor[i][j]]]--;
                        At_all[idx[vert[i][j]][j]]--;
                        change_vert(j, vert[i][j] + 1, i - 1, -4);
                        change_hor(i, hor[i][j] + 1, j - 1, -1);
                        cnt[id] += 3;
                        cnt[idx[vert[i][j]][j]] += 2;
                        cnt[idx[i][hor[i][j]]] += 1;
                        rec(id + 1);
                        if (Can)return;
                        At_all[idx[i][hor[i][j]]]++;
                        At_all[idx[vert[i][j]][j]]++;
                        cnt[id] -= 3;
                        cnt[idx[vert[i][j]][j]] -= 2;
                        cnt[idx[i][hor[i][j]]] -= 1;
                        change_vert(j, vert[i][j] + 1, i - 1, 0);
                        change_hor(i, hor[i][j] + 1, j - 1, 0);
                    } else {
                        if ((At_all[idx[vert[i][j]][j]] == 1 &&
                             cnt[idx[vert[i][j]][j]] + 2 != c[idx[vert[i][j]][j]].val) ||
                            (At_all[idx[i][hor[i][j]]] == 1 && cnt[idx[i][hor[i][j]]] + 2 != c[idx[i][hor[i][j]]].val))
                            continue;
                        At_all[idx[i][hor[i][j]]]--;
                        At_all[idx[vert[i][j]][j]]--;
                        change_vert(j, vert[i][j] + 1, i - 1, -4);
                        change_hor(i, hor[i][j] + 1, j - 1, -3);
                        cnt[id] += 4;
                        cnt[idx[vert[i][j]][j]] += 2;
                        cnt[idx[i][hor[i][j]]] += 2;
                        rec(id + 1);
                        if (Can)return;
                        At_all[idx[i][hor[i][j]]]++;
                        At_all[idx[vert[i][j]][j]]++;
                        cnt[id] -= 4;
                        cnt[idx[vert[i][j]][j]] -= 2;
                        cnt[idx[i][hor[i][j]]] -= 2;
                        change_vert(j, vert[i][j] + 1, i - 1, 0);
                        change_hor(i, hor[i][j] + 1, j - 1, 0);
                    }
                }
            }
        }
    }
}

void init(int numSubtests, double timeLimit) {
    LIM = timeLimit;
}

bool solve(vector<vector<int >> &puzzle) {
    if (timePassed() + eps > LIM) {
        return false;
    }
    a = puzzle;
    int n = (int) puzzle.size();
    int m = (int) puzzle[0].size();
    c.clear();
    hor.assign(n, vector<int>(m, -1));
    vert.assign(n, vector<int>(m, -1));
    idx.assign(n, vector<int>(m, -1));
    int Id = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (a[i][j] != 0) {
                idx[i][j] = Id;
                Id++;
                c.push_back({i, j, a[i][j]});
                for (int k = j - 1; k >= 0; --k) {
                    if (a[i][k] != 0) {
                        hor[i][j] = k;
                        break;
                    }
                }
                for (int k = i - 1; k >= 0; --k) {
                    if (a[k][j] != 0) {
                        vert[i][j] = k;
                        break;
                    }
                }
            }
        }
    }
    C = (int) c.size();
    cnt.assign(C, 0);
    At_all.assign(C, 0);
    for (int i = 0; i < C; ++i) {
        if (hor[c[i].i][c[i].j] != -1) {
            At_all[idx[c[i].i][hor[c[i].i][c[i].j]]]++;
        }
        if (vert[c[i].i][c[i].j] != -1) {
            At_all[idx[vert[c[i].i][c[i].j]][c[i].j]]++;
        }
    }
    Can = false;
    rec(0);
    puzzle = ans;
    return true;
}