#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define ld long double
#define all(x) x.begin(), x.end()
#define pb push_back
#define sz(x) (int)x.size()
#define int long long

int f[(int) 1e6 + 1];
const int M = 1e8 + 543;

vector<int> a;
int d[(int) 4e5 + 1];

void build(int v, int l, int r) {
    if (l == r) {
        d[v] = a[l];
        return;
    }
    int m = (l + r) / 2;
    build(2 * v, l, m);
    build(2 * v + 1, m + 1, r);
    d[v] = d[2 * v] + d[2 * v + 1];
    d[v] %= M;
}

int find_ans(int v, int l, int r, int x, int y) {
    if (l > y || x > r) {
        return 0;
    }
    if (l >= x && r <= y) {
        return d[v];
    }
    int m = (l + r) / 2;
    return (find_ans(2 * v, l, m, x, y) + find_ans(2 * v + 1, m + 1, r, x, y)) % M;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, q;
    cin >> n >> q;
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    f[0] = 0;
    f[1] = 1;
    f[2] = 2;
    f[3] = 3;
    f[4] = 4;
    for (int i = 5; i <= 1e6; ++i) {
        f[i] = f[i - 1] * 5ll + f[i - 2] * 4ll + f[i - 3] * 3ll + f[i - 4] * 2ll + f[i - 5];
        f[i] %= M;
    }
    for (int i = 0; i < n; ++i) {
        a[i] = f[a[i]];
    }
    build(1, 0, n - 1);
    while (q--) {
        int type, l, r;
        cin >> type >> l >> r;
        l--;
        r--;
        cout << find_ans(1, 0, n - 1, l, r) << "\n";
    }
    return 0;
}