#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define int long long
const ll mod = 100000543;

struct node {
    int sum;
};
vector<node> tree;
void build(int v, int l, int r, vector<int> &a, vector<int> &ch) {
    if (r - l == 1) {
        tree[v].sum = ch[a[l]];
        return;
    }
    int m = (l + r) / 2;
    build(2 * v + 1, l, m, a, ch);
    build(2 * v + 2, m, r, a, ch);
    tree[v].sum = tree[2 * v + 1].sum + tree[2 * v + 2].sum;
}

ll query(int v, int l, int r, int ql, int qr) {
    if (ql >= r || qr <= l) {
        return 0;
    }
    if (ql >= l && qr <= r) {
        return tree[v].sum;
    }
    int m = (l + r) / 2;
    return query(2 * v + 1, l, m, ql, qr) + query(2 * v + 2, m, r, ql, qr);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for(int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<int> ch(5000001);
    ch[0] = 0;
    ch[1] = 1;
    ch[2] = 2;
    ch[3] = 3;
    ch[4] = 4;
    for(int i = 5; i < 5000001; ++i) {
        
        ch[i] = ch[i - 1] * 5 + ch[i - 2] * 4 + ch[i - 3] * 3 + ch[i - 4] * 2 + ch[i - 5];
        ch[i] %= mod;
    }
    tree.resize(4 * n);
    build(0, 0, n, a, ch);
    for(int i = 0; i < q; ++i) {
        int type;
        cin >> type;
        if (type == 1) {
            int l, r;
            cin >> l >> r;
            l--;
            cout << query(0, 0, n, l, r) % mod << '\n';
        } else {
            ll val;
            cin >> val;
        }
    }
}
