#include "ones.h"

std::vector<int> answer;

int splitFind(int l, int r, int mx) {
	if (l + 1 == r) {
		if (hasOnes(l + 1, l + 1)) {
			answer.push_back(l + 1);
			return 1;
		} else {
			return 0;
		}
	}
	int mg = (l + r) / 2;
	int res = 0;
	if (hasOnes(l + 1, mg)) {
		res = splitFind(l, mg, mx);
		if (res >= mx)
			return res;
	}
	if (hasOnes(mg + 1, r)) {
		res += splitFind(mg, r, mx - res);
	}
	return res;
}

std::vector<int> guessOnes(int n, int k) {
	answer.clear();
	splitFind(0, n, k);
	return answer;
}