#include "ones.h"

std::vector<int> answer;

const int blockSZ = 377;

int splitFind(int l, int r, int mx) {
	if (l + 1 == r) {
		if (hasOnes(l + 1, l + 1)) {
			answer.push_back(l + 1);
			return 1;
		} else {
			return 0;
		}
	}
	int mg = (l + r) / 2;
	int res = 0;
	if (hasOnes(l + 1, mg)) {
		res = splitFind(l, mg, mx);
		if (res >= mx)
			return res;
	}
	if (hasOnes(mg + 1, r)) {
		res += splitFind(mg, r, mx - res);
	}
	return res;
}

void splitBlocks(int l, int r, int mx) {
	int res = 0;
	for (int i = l; i < r; i += blockSZ) {
		if (hasOnes(i + 1, min(r, i + blockSZ))) {
			res += splitFind(i + 1, min(r, i + blockSZ), mx - res);
		}
		if (res >= mx) {
			return;
		}
	}
}

std::vector<int> guessOnes(int n, int k) {
	answer.clear();
	splitFind(0, n, k);
	return answer;
}