#include <bits/stdc++.h>
#include "ones.h"
#define f first
#define s second

using namespace std;
using ld = double;
using pld = pair<ld,ld>;

// std::vector<int> guessOnes(int l, int r,int k) {
//     if(k == 0) { return {}; }
//     int m = (l+r)/2;
//     int cntL = 
// }

const int MAX = 1e5+5;
bool ready = false;
ld fact[MAX];

ld logChoose(int n, int k) {
    if(n < 0 || k > n || k < 0) { return -1e100; }
    return fact[n] - fact[k] - fact[n-k];
}

ld logSum(int a, int b, int n, int k) {
    if(a > b) { return 0; }
    ld logA = logChoose(n-a-1,k);
    ld logB = logChoose(n-b,k);
    ld ext = 1.0L + expl(logB-logA);
    return logA+logl(ext);
}
ld logSum(ld logA, ld logB) {
    if(logA < logB) { swap(logA,logB); }
    ld ext = 1.0L + expl(logB-logA);
    return logA+logl(ext);
}

pld rangeLogs(int a, int b, int n, int k) {
    if(a > b) { return pld{-1e100,0}; }
    ld logA = logChoose(n-a-1,k);
    ld logB = logChoose(n-b,k);
    return pld{logA, logB};
}

int optM(int a, int b, int n, int k) {
    int l = a, r = (a+b)/2;
    if(b == n) {
        r = a+(b-a)/k;
    }
    // cout << "~~~ OPT M " << a << ' ' << b << ' ' << n << ' ' << k << endl;
    while(l < r) {
        int m = (l+r+1)/2;
        pld L = rangeLogs(a,m,n,k);
        pld R = rangeLogs(m+1,b,n,k);
        // cout << m << ": " << endl; 
        // cout << "   " << expl(logSum(a,m,n,k)) << endl;
        // cout << "   " << expl(logSum(m+1,b,n,k)) << endl;
        if(logSum(L.f,R.s) > logSum(R.f,L.s)) {
            r = m - 1;
        } else {
            l = m;
        }
    }
    return l;
}

std::vector<int> guessOnes(int n,int k) {
    if(!ready) {
        ready = true;
        for(int i = 1; i < MAX; i ++) {
            fact[i] = fact[i-1] + logl(i);
        }
    }
    // cout << optM(1,100000,100000,1) << endl;
    // if(false){
    //     int m = 50001;
    //     int a = 1, b = 100000;
    //     cout << m << endl;
    //     cout << "L: " << logSum(a,m,n,k) << endl;
    //     cout << "  e^ " << logChoose(n-a-1,k) << " + e^ " << logChoose(n-m,k) << endl;
    //     cout << "R: " << logSum(m+1,b,n,k) << endl;
    //     cout << "  e^ " << logChoose(n-(m+1)-1,k) << " + e^ " << logChoose(n-b,k) << endl;
    // }
    // // cout << optM(1,100000,100000,10000) << endl;
    // exit(0);
    int lst = 0;
    vector<int> res;
    for(int i = 0; i < k; i ++) {
        int l = lst+1, r = n, m;

        while(l < r) {
            m = optM(l,r,n,k-i);
            if(m == r) {
                m--;
            }
            // cout << i << ' ' << l << ' ' << r << ' ' << m << endl;
            if(hasOnes(lst+1,m)) {
                r = m;
            } else {
                l = m + 1;
            }
        }
        lst = l;
        res.push_back(l);
    }
    return res;
}
