
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using vll = vector<ll>;
using vvll = vector<vll>;
ll sz = 1e6+1;
const ll MOD = 1e8 + 543;
vll u(sz);

struct Seg {
    ll n;
    vll s;
   
    Seg(vll a) :n(a.size()) {
        s = vll(2 * n);
        for (ll i = 0; i < n; i++) {
            s[i + n] = a[i];
        }
        for (ll i = n - 1; i >= 0; i--) {
            s[i] = s[2 * i] + s[2 * i + 1];
            s[i] %= MOD;
        }
   }
    ll qu(ll l, ll r) {
        ll ans = 0;
        for (l += n, r += n; l < r; l /= 2, r /= 2) {
            if (l % 2) {
                ans += s[l++];
            }
            if (r % 2) {
                ans += s[--r];
            }
            ans %= MOD;
        }
        return ans;
   }
};

int main()
{
    ll n, q; cin >> n>>q;
    for (ll i = 0; i < 5; i++) {
        u[i] = i;
    }
    for (ll i = 5; i < sz; i++) {
        u[i] = u[i - 1] * 5 + u[i - 2] * 4 + u[i - 3] * 3 + u[i - 4] * 2 + u[i - 5];
        u[i] %= MOD;
    }
    vll a(n);
    for (ll &i : a) {
        cin >> i;
    }
    for (ll i = 0; i < n; i++) {
        a[i] = u[a[i]];
    }
    Seg s = Seg(a);
    while (q--) {
        ll k1, k2, k3; cin >> k1 >> k2 >> k3;
        k2--, k3--;
        cout << s.qu(k2, k3 + 1)<<'\n';
    }
}

/*

1 5
1
1 1 1
2 1 1 -2
1 1 1
2 1 1 8
1 1 1

*/