#include <vector>
#include <algorithm>
#include <iostream>
#include "ones.h"
using namespace std;

vector<int> guessOnes(int n, int k)
{
	vector <int> answer;
	int start = 0, now = k;

	for (int a = 0; a < k; a++)
	{
		int sizeAsk = (n - start) / now + 1;
		int l = start, r = start + sizeAsk;
		r = min(r, n - 1);

		while (l != r)
		{
			int mid = (l + r) / 2;
			if (hasOnes(l, mid))
				r = mid;
			else
				l = mid + 1;
		}

		answer.push_back(l);
		start = l + 1;
		now--;
	}

	sort(answer.begin(), answer.end());

	return answer;
}