#include <vector>
#include <algorithm>
#include <iostream>
#include "ones.h"
using namespace std;

vector<int> guessOnes(int n, int k)
{
	vector <int> answer;
	int start = 1, now = k;

	for (int a = 0; a < k; a++)
	{
		int sizeAsk = (n - start) / now + 1;
		int l = start, r = start + sizeAsk * 3 / 4;
		r = min(r, n);
		
		if (hasOnes(l, r))
		{
			while (l != r)
			{
				int mid = (l + r) / 2;
				if (hasOnes(l, mid))
					r = mid;
				else
					l = mid + 1;
			}
			answer.push_back(l);
			now--;
		}
		else
		{
			l = r;
			a--;
		}
		start = l + 1;
	}

	return answer;
}