using namespace std;
#include <vector>
#define vi vector<int>
#include <iostream>
#define ll long long
#define vll vector<ll>
const int m = 1e8 + 543;
const int siz = 2e5 + 2;
ll a[siz];
vector<vi> pre[30];
const vector<vi> uni =  { {1,0,0,0,0,},
             {0,1,0,0,0,},
             {0,0,1,0,0,},
            {0,0,0,1,0,},
            {0,0,0,0,1,}, };

ll x[] = { 0,1,2,3,4 };

vector<vi> mul(vector<vi> v1, vector<vi> v2) {
    vector<vi> ans(5, vi(5));
    for (int i = 0; i < 5; i++) {
        for (int j = 0; j < 5; j++) {
            ll t = v1[i][j];
            for (int k = 0; k < 5; k++) {
                ans[i][k] += (t * v2[j][k])%m;
            }
        }
    }
    for (int i = 0; i < 5; i++) {
        for (int j = 0; j < 5; j++) {
            ans[i][j] %= m;
        }
    }
    return ans;
}
vector<vi> powi(vector<vi>& a, int po) {
    if (po == 0) {
        return uni;
    }
    vector<vi> ans = powi(a, po / 2);
    ans = mul(ans, ans);
    if (po % 2) {
        ans = mul(ans, a);
    }
    return ans;
}
vi get(vi v, vector<vi> w) {
    vi ans(5);
    for (int i = 0; i < 5; i++) {
        for (int j = 0; j < 5; j++) {
            ll k = w[i][j];
            ans[i] += (k * v[j])%m;
        }
    }
    for (int i = 0; i < 5; i++)ans[i] %= m;
    return ans;
}
void calc(int dis, vi& b) {
    ll nei[5]; for (int j = 0; j < 5; j++)nei[j] = 0;
    for (int k = 0; k < 30; k++) {
        if ((dis / (1 << k)) % 2) {
            for (int j = 0; j < 5; j++) {
                for (int t= 0; t < 5; t++) {
                    ll f = b[t];
                    nei[j] += (pre[k][j][t] * f)%m;
                }
            }
            for (int j = 0; j < 5; j++) {
                b[j] = (nei[j]) % m;
                nei[j] = 0;
            }
        }
    }

}
struct node {
    int l, r, mid;
    bool f;
    vi sum; vector<vi> p;
    node *sl, * sr;
    node(int li, int ri) {
        l = li, r = ri, mid = (l + r) / 2, f=0;
        p = uni;
        if (l < r) {
            sum.resize(5);
            sl = new node(l, mid);
            sr = new node(mid + 1, r);
            for (int i = 0; i < 5; i++) {
                sum[i] = (sl->sum[i] + sr->sum[i])%m;
            }
        }
        else {
            sum = { 0,1,2,3,4 };
            calc(a[l],sum);
        }
    }
    void push() {
        if (f==0)return;
        sum = get(sum, p);
        if (l < r) {
            sl->p = mul(sl->p, p);
            sr->p = mul(sl->p, p);
            sl->f = 1;
            sr->f = 1;
        }
        f = 0;
        p = uni;
    }
    ll query(int a, int b) {
        if (a > r || b < l)return 0;
        push();
        if (a <= l && b >= r)return sum[0];
        return (sl->query(a, b) + sr->query(a, b))%m;
    }
    void up(int a, int b, vector<vi>&mat) {
        if (a > r || b < l)return;
        if (a <= l && b >= r) {
            p = mul(mat, p);
            f = 1;
            push();
        }
        else {
            push();
            sl->up(a, b, mat);
            sr->up(a, b, mat);
            for (int i = 0; i < 5; i++) {
                sum[i] = (sl->sum[i] + sr->sum[i])%m;
            }
        }
    }
};
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    pre[0] = { { 0,1,0,0,0, },
    { 0,0,1,0,0, },
    { 0,0,0,1,0, },
    { 0,0,0,0,1,},
    {1,2,3,4,5 } };
    for (int k = 1; k < 30; k++) {
        pre[k] = mul(pre[k - 1], pre[k - 1]);
    }

    int n, q;
    cin >> n >> q;
    for (int i = 0; i < n; i++)cin >> a[i];
    for (int i = 0; i < n; i++) {
        a[i] = (a[i] + m - 1) % (m - 1);
    }
    node* seg = new node(0, n-1);

    for (int i = 0; i < q; i++) {
        int t; cin >> t;
        int l, r; cin >> l >> r;
        l--, r--;
        if (t == 1) {
            cout << seg->query(l,r);
            if (i != q - 1)cout << "\n";
        }
        else {
            int val;
            cin >> val;
            val = (val + m - 1) % (m - 1);
            vector<vi> mat = powi(pre[0], val);
            seg->up(l, r, mat);
        }
    }
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
