#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
#define rep(i,s,e) for(ll i=s;i<e;i++)
#define all(a) a.begin(),a.end()
const ll mod = 1e8 + 543;

vector<vector<ll>>ip5(5, vector<ll>(5));
vector<vector<ll>>in5(5, vector<ll>(5));

vector<ll> hib(vector<ll> a, vector<ll> b) {
    vector<ll>ans(5,0);
    rep(i, 0, 5) ans[i] = ((a[i] + b[i]) % mod + mod) % mod;
    return ans;

}


vector<ll>mvec(vector<vector<ll>>mat, vector<ll>vec) {
    vector<ll>ans(5, 0);
    rep(i, 0, 5) {
        rep(j, 0, 5) {
            ans[i] += ((mat[i][j] * vec[j]) % mod + mod) % mod;
            ans[i] %= mod;
        }
    }
    return ans;
}

vector<vector<ll>>mmat(vector<vector<ll>>mat1, vector<vector<ll>>mat2) {
    vector<vector<ll>>ans(5, vector<ll>(5, 0));
    rep(i, 0, 5) {
        rep(j, 0, 5) {
            rep(k, 0, 5) {
                ans[i][j] += ((mat1[i][k] * mat2[k][j]) % mod + mod % mod);
                ans[i][j] %= mod;
            }
        }
    }
    return ans;
}

vector<vector<ll>>binpow(vector<vector<ll>>mat, ll hez) {
    if (hez == 1) return mat;
    vector<vector<ll>>ans = binpow(mat, hez / 2);
    ans = mmat(ans, ans);
    if (hez % 2) ans = mmat(mat, ans);
    return ans;
}


struct Seg {
    ll l, r, mid, add = 0;
    vector<ll>val = { 0,0,0,0,0 };
    Seg* lp, * rp;
    Seg(ll l, ll r) :l(l), r(r), mid((l + r) / 2) {
        if (l != r) {
            lp = new Seg(l, mid);
            rp = new Seg(mid + 1, r);
        }
    }
    //אולי פה לא טוב
    void pull() {
        val = hib(lp->val, rp->val);
    }
    void push() {
        vector<vector<ll>>mat;
        if (add > 0)
            mat = binpow(ip5, add);
        if(add<0)
            mat = binpow(in5, -add);
        lp->val = mvec(mat, lp->val);
        rp->val = mvec(mat, rp->val);
        lp->add += add;
        rp->add += add;
        add = 0;
    }
    void upd(ll a, ll b, ll v) {
        if (a <= l and r <= b) {
            vector<vector<ll>>mat;
            if (v > 0)
                mat = binpow(ip5, v);
            if (v < 0)
                mat = binpow(in5, -v);
            val = mvec(mat, val);
            add += v;
            return;
        }
        if (a > r or b < l) return;
        lp->upd(a, b, v);
        rp->upd(a, b, v);
        pull();
    }
    void set(ll a, vector<ll>v) {
        if (l == r and r == a) {
            val = v;
            return;
        }
        if (a <= mid) lp->set(a, v);
        else rp->set(a, v);
        pull();
    }
    vector<ll> query(ll a, ll b) {
        if (a <= l and r <= b)
            return val;
        if (a > r or b < l)
            return { 0,0,0,0,0 };
        push();
        return hib(lp->query(a, b), rp->query(a, b));
    }
};

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    ll n, q;
    cin >> n >> q;
    vector<ll>a(n);
    rep(i, 0, n) cin >> a[i];
    vector<vector<ll>>vec(n);
    //can make faster if sort a but problems
    vector<ll>base = { -4,-3,33,-22,0 };

    rep(i, 0, 4) ip5[i][i + 1] = 1;
    rep(i, 0, 5) ip5[4][i] = i + 1;
    
    rep(i, 1, 5) in5[i][i - 1] = 1;
    in5[0] = { -2,-3,-4,-5,1 };

    Seg seg(0, n - 1);
    rep(i, 0, n) {
        if (a[i] == 0)
            vec[i] = base;
        else {
            vector<vector<ll>>mat;
            if(a[i]>0)
                mat = binpow(ip5, a[i]);
            if(a[i]<0)
                mat = binpow(in5, -a[i]);
            vec[i] = mvec(mat, base);
        }
        seg.set(i, vec[i]);
    }
    while (q--) {
        ll t;
        cin >> t;
        if (t == 1) {
            ll l, r;
            cin >> l >> r;
            l--, r--;
            cout << (seg.query(l, r)[4])<< "\n";
        }
        else {
            ll l, r, v;
            cin >> l >> r >> v;
            l--, r--;
            seg.upd(l, r, v);
        }
    }
    return 0;
}