#include <cmath>
#include <vector>
#include "ones.h"
using namespace std;
//half
int N;
bool hasOne(int a,int b) {
    if(b>N) b=N;
    return hasOnes(a,b);
}
void binary(int a,int b,vector<int> &res) {
    if(a+1==b) {
        res.push_back(a);
        return;
    }
    int mid = (a+b)/2;
    if(hasOne(a,mid-1)) {
        binary(a,mid,res);
    }
    if(hasOne(mid,b-1)) {
        binary(mid,b,res);
    }
}
vector<int> guessOnes(int n, int k) {
    vector<int> res;
    N=n;
    double d = (n-k)/((double)k);
    int u = n/((int)(floor(log2(d))+1));
    for(int i =0; i<u;i++) {
        if(hasOne(i*(n/u)+1,(i+1)*(n/u))) binary(i*(n/u)+1,(i+1)*(n/u)+1,res);
    }
    return res;
}