#include <cmath>
#include <vector>
#include "ones.h"
using namespace std;
void binary(int a,int b,vector<int> &res) {
    if(a+1==b) {
        res.push_back(a);
        return;
    }
    int mid = (a+b)/2;
    if(hasOnes(a,mid-1)) {
        binary(a,mid,res);
    }
    if(hasOnes(mid,b-1)) {
        binary(mid,b,res);
    }
}
vector<int> guessOnes(int n, int k) {
    vector<int> res;
    int i =1;
    while(i<n&&res.size()!=k){
        int l = k-res.size();
        double d = (n)/((double)n-l);
        int u = min(max((int)(floor(1/log2(d))),4),n-i+1);
        if(hasOnes(i,i+u-1)) binary(i,i+u,res);
        i+=u;
    }
    return res;
}