#include <bits/stdc++.h>
#include "ones.h"
using namespace std;

vector<int> naive(int s, int e, int n, int k) {
    int count = 0, cur = s;
    vector<int> ans(k);
    while (count < k) {
        int lo = cur, hi = cur;
        if (hasOnes(lo, hi)) {
            ans[count++] = lo;
            ++cur;
            continue;
        }
        while (hi <= e) {
            if (2*hi >= e) {
                lo = hi; hi = e; break;
            }
            if (hasOnes(lo, 2*hi)) {
                lo = hi; hi = 2*hi;
                break;
            }
            else hi *= 2;
        }
        while (lo < hi) {
          int mid = (lo+hi)/2;
          if (hasOnes(cur, mid)) hi = mid;
          else lo = mid+1;
        }
        ans[count++] = lo;
        cur = lo+1;
    }
    return ans;
}
vector<int> guess(int start, int end, int sz, int k) {
    if (k == 1) return naive(start, end, sz, k);
    int val = hasOnes(start+sz/2, end);
    vector<int> ans;
    if (val) {
        vector<int> temp = guess(start, start + sz / 2-1, sz / 2, k-val);
        for (int i : temp) ans.push_back(i);
    }
    if (val < k) {
        vector<int> temp = guess(start+sz/2, end, sz-sz/2, val);
        for (int i : temp) ans.push_back(i);
    }

    return ans;
}
vector<int> guessOnes(int n, int k) {
    return naive(1, n, n, k);
}