#include <bits/stdc++.h>
#include "ones.h"
using namespace std;

vector<int> naive(int s, int e, int n, int k) {
    int count = 0, cur = s;
    vector<int> ans(k);
    while (count < k) {
        int lo = cur, hi = cur;
        if (hasOnes(lo, hi)) {
            ans[count++] = lo;
            cur = lo+1;
            continue;
        }
        hi = e;
        while (lo < hi) {
          int mid = (lo+hi)/2;
          if (hasOnes(cur, mid)) hi = mid;
          else lo = mid+1;
        }
        ans[count++] = lo;
        cur = lo+1;
    }
    return ans;
}
vector<int> guess(int start, int end, int sz, int k) {
    if (start == end) return {start};
    bool right = hasOnes(start, start + sz / 2 -1);
    vector<int> ans;
    if (right) {
        vector<int> temp = guess(start, start + sz / 2-1, sz / 2, k);
        for (int i : temp) ans.push_back(i);
    }
    if (ans.size() < k && hasOnes(start+sz/2, end)) {
        vector<int> temp = guess(start+sz/2, end, sz-sz/2, k);
        for (int i : temp) ans.push_back(i);
    }

    return ans;
}
vector<int> guessOnes(int n, int k) {
    return guess(1, n, n, k);
}