#include <bits/stdc++.h>
#include "ones.h"
using namespace std;
typedef long long ll;


bool hasOnes(int l,int r);


vector<int> onesPlaces(int start, int end)
{
    vector<int> ans;

    for (int i = start; i <= end; i++) if (hasOnes(i, i)) ans.push_back(i);

    return ans;
}


vector<int> guessOnes(int n, int k)
{
    vector<int> ans;
    int sqr = (int) sqrtl(n);

    for (int i = 0; i < sqr; i++)
    {
        if (hasOnes(i * sqr + 1, sqr * (i + 1)))
        {
            vector<int> temp = onesPlaces(i * sqr + 1, sqr * (i + 1));
            for (int j : temp) ans.push_back(j);
        }
    }

    if (hasOnes(sqr * sqr + 1, n))
    {
        vector<int> temp = onesPlaces(n - sqr * sqr, n);
        for (int j : temp) ans.push_back(j);
    }


    return ans;
}















// #include <vector>
// #include <iostream>
// #include <utility>
// #include <algorithm>
// #include <random>
// #include <iomanip>
// #include <numeric>
// #include <cstring>

// static const int N = 1e5 + 3;

// static int n, k, n_tests;
// static int input[N];

// static long long number_of_queries;

// static std::vector<int> readOnes()
// {
//     for(int i=1;i<=n;i++)
//         input[i]=0;

//     std::vector<int> _ones(k,0);

//     vector<int> temp = {1, 7, 100, 1800, 50000, 18, 999, 654, 786, 13478};
//     for(int i=0;i<k;i++)
//     {
//         // std::cin>>_ones[i];
//         _ones[i] = temp[i];
//         input[_ones[i]]=1;
//     }

//     for(int i=1;i<=n;i++)input[i]+=input[i-1];

//     sort(_ones.begin(),_ones.end());

//     return _ones;
// }

// bool hasOnes(int l,int r)
// {
//     number_of_queries++;

//     if(1>l || l>n || 1>r || r>n || l>r)
//     {
//         std::cout << "Your program made an invalid query." << std::endl;
//         exit(0);
//     }

//     return input[r] != input[l-1];
// }

// static long long runOneTest(){
//     number_of_queries = 0;

//     std::vector<int> _ones = readOnes();

//     std::vector<int> guess = guessOnes(n,k);

//     if(_ones != guess)
//     {
//         std::cout << "Your program returned an incorrect answer." << std::endl;
//         exit(0);
//     }

//     std::cout << "Your program successfully returned the correct positions and used " << number_of_queries << " queries." << std::endl;

//     return number_of_queries;
// }

// int main(){
//     std::cin >> n >> k >> n_tests;

//     long long sum_queries = 0;
//     for(int i = 0; i < n_tests; ++i)
//         sum_queries = sum_queries + runOneTest();

//     std::cout << "Your program successfully returned the correct positions and used " << sum_queries << " queries in total." << std::endl;
// }
