#include <iostream>
#include <vector>
#include "ones.h"
using namespace std;

void solve(int l, int r, int d, vector<int> &res, int &idx) {
    if (d == 1) {
        for (; l <= r; ++l) if (hasOnes(l,l)) res[idx++] = l;
        return;
    }

    for (; l <= r - d && idx < res.size(); l += d + 1)
        if (hasOnes(l, l + d))
            solve(l, l + d, d / 2, res, idx);

    if (l - d - 1 < r - d && idx < res.size()) solve(l, r, max(d/2, 1), res, idx);
}

std::vector<int> guessOnes(int n, int k) {
    vector<int> res(k);
    int idx = 0;
    //solve(1, n, n/2, res, idx);

    for (int i = 1;  i <= n; ++i)
        if (hasOnes(i,i))
            res[idx++] = i;

    return res;
}
