#include <bits/stdc++.h>
#include "ones.h"
/*
static const int N = 1e5 + 3;

static int n, k, n_tests;
static int input[N];

static long long number_of_queries;

static std::vector<int> readOnes()
{
    for(int i=1;i<=n;i++)
        input[i]=0;

    std::vector<int> _ones(k,0);

    for(int i=0;i<k;i++)
    {
        std::cin>>_ones[i];
        input[_ones[i]]=1;
    }

    for(int i=1;i<=n;i++)input[i]+=input[i-1];

    sort(_ones.begin(),_ones.end());

    return _ones;
}

bool hasOnes(int l,int r)
{
    number_of_queries++;

    if(1>l || l>n || 1>r || r>n || l>r)
    {
        std::cout << "Your program made an invalid query." << std::endl;
        exit(0);
    }

    return input[r] != input[l-1];
}
*/
std::vector < int > ans;
int K;

inline int binSearch(int id, int l, int r, int add) {
    while (r - l > 1) {
        int m = (l + r) / 2;

        int left = id, right = id + add * m;

        if (left > right)
            std::swap(left, right);

        if (hasOnes(left, right))
            r = m;
        else
            l = m;
    }

    return id + add * r;
}

void getOnes(int L, int R) {
    if (L > R || ans.size() == K)
        return;

    int len = (R - L + 1) / (K - ans.size());

    if (len == 0) {
        if (!hasOnes(L, R))
            return;

        for (int cur = L; cur <= R; cur++)
            if (hasOnes(cur, cur)) {
                ans.push_back(cur);
                K--;
            }

        return;
    }

    for (int i = L; i <= R; i += len) {
        int j = std::min(i + len - 1, R);

        int m = (i + j) / 2;

        int r = (hasOnes(i, m) ? binSearch(m, -1, m - i + 1, -1) : i - 1);

        if (i <= r) {
            ans.push_back(r);
            K--;

            getOnes(i, r - 1);
        }

        int l = (m + 1 <= j && hasOnes(m + 1, j) ? binSearch(m + 1, -1, j - m, 1) : j + 1);

        if (l <= j) {
            ans.push_back(l);
            K--;

            getOnes(l + 1, j);
        }
    }
}

std::vector < int > guessOnes(int n, int k) {
    K = k;
    ans.clear();
    getOnes(1, n);

    std::sort(ans.begin(), ans.end());

    return ans;
}
/*
static long long runOneTest(){
    number_of_queries = 0;

    std::vector<int> _ones = readOnes();

    std::vector<int> guess = guessOnes(n,k);

    if(_ones != guess)
    {
        std::cout << "Your program returned an incorrect answer." << std::endl;
        exit(0);
    }

    std::cout << "Your program successfully returned the correct positions and used " << number_of_queries << " queries." << std::endl;

    return number_of_queries;
}

int main(){
    std::cin >> n >> k >> n_tests;

    long long sum_queries = 0;
    for(int i = 0; i < n_tests; ++i)
        sum_queries = sum_queries + runOneTest();

    std::cout << "Your program successfully returned the correct positions and used " << sum_queries << " queries in total." << std::endl;
}
*/
