#include <bits/stdc++.h>

typedef long long ll;

int n;
const int M = 1e+8 + 543;

int power[50][5][5];

inline int add(int a, int b) {
    return a + b >= M ? a + b - M : a + b;
}

ll a[100001];

int t[400020][5];

inline void build(int x, int lx, int rx) {
    if (lx == rx) {
        int ans[5], res[5] { };

        ans[0] = 0;
        ans[1] = M - 22;
        ans[2] = 33;
        ans[3] = M - 3;
        ans[4] = M - 4;

        for (int p = 49; p >= 0; p--)
            if (a[lx] >> p & 1) {
                memset(res, 0, sizeof(res));

                for (int j = 0; j < 5; j++)
                    for (int k = 0; k < 5; k++)
                        res[j] = add(res[j], (ll)ans[k] * power[p][k][j] % M);

                for (int j = 0; j < 5; j++)
                    ans[j] = res[j];
            }

        for (int j = 0; j < 5; j++)
            t[x][j] = ans[j];
    } else {
        int m = (lx + rx) / 2;

        build(x + x, lx, m);
        build(x + x + 1, m + 1, rx);

        for (int j = 0; j < 5; j++)
            t[x][j] = add(t[x + x][j], t[x + x + 1][j]);
    }
}

inline int get(int x, int lx, int rx, int l, int r) {
    if (rx < l || lx > r)
        return 0;

    if (l <= lx && rx <= r)
        return t[x][0];

    int m = (lx + rx) / 2;

    return add(get(x + x, lx, m, l, r), get(x + x + 1, m + 1, rx, l, r));
}

int main() {
    std::ios::sync_with_stdio(0); std::cin.tie(0);

    for (int i = 0; i < 4; i++)
        power[0][i][i + 1] = 1;

    for (int i = 0; i < 5; i++)
        power[0][i][0] = 5 - i;

    int res[5][5] { };

    for (int p = 1; p < 50; p++) {
        for (int i = 0; i < 5; i++)
            for (int j = 0; j < 5; j++)
                res[i][j] = 0;

        for (int i = 0; i < 5; i++)
            for (int j = 0; j < 5; j++)
                for (int k = 0; k < 5; k++)
                    res[i][j] = add(res[i][j], (ll)power[p - 1][i][k] * power[p - 1][k][j] % M);

        for (int i = 0; i < 5; i++)
            for (int j = 0; j < 5; j++)
                power[p][i][j] = res[i][j];
    }

    int q; std::cin >> n >> q;

    for (int i = 1; i <= n; i++)
        std::cin >> a[i];

    build(1, 1, n);

    for (int qi = 1, type, l, r, val; qi <= q; qi++) {
        std::cin >> type;

        if (type == 1) {
            std::cin >> l >> r;

            std::cout << get(1, 1, n, l, r) << "\n";
        } else {
            std::cin >> l >> r >> val;

            //update(1, 1, n, l, r, val);
        }
    }
}
