#include <bits/stdc++.h>
#include "ones.h"

using namespace std;

std::vector<int> guessOnes(int n, int k) {
    vector<int> v;
    if (k == 0) {
        return v;
    }
    queue<pair<int, int>> q;
    q.push({1, n});
    while (!q.empty()) {
        int l = q.front().first, r = q.front().second;
        q.pop();
        if (r == l) {
            v.push_back(l);
            continue;
        }
        int m1 = l + (r - l + 1) / 3;
        int m2 = r - (r - l + 1) / 3;
        if (hasOnes(l, m1)) {
            q.push({l, m1});
        }
        if (m1 + 1 <= m2) {
            if (hasOnes(m1 + 1, m2)) {
                q.push({m1 + 1, m2})
            }
        }
        if (m2 + 1 <= r) {
            if (hasOnes(m2 + 1, r) {
                q.push({m2 + 1, r});
            }
        }
    }
    sort(v.begin(), v.end());
    return v;
}
