#include "ones.h"
#include <bits/stdc++.h>
using namespace std;
const int UND = 1e9 + 7;
vector<int> idx;
bool hasOnes(int l, int r);


int f(int l, int r, int need){
    if(l > r) return 0;
    if(!need) return 0;
    
    if(need == UND && !hasOnes(l + 1, r + 1)) return 0;
    if(l == r){
        idx.push_back(l);
        return 1;
    }
    int mid = (l + r)>>1;
    int c1, c2;
    if(need == UND){
        c1 = f(l, mid, UND);
        c2 = f(mid+1, r, UND);
    }else{
       c1 = f(l, mid, UND);
       c2 = f(mid+1, r, need - c1);
    }
    return c1 + c2;
}


vector<int> bin(int Left, int Right){
    vector<int> ans;
    int start = Left;
    while(start <= Right){
        int l = start-1, r = Right + 1;
        while(l + 1 < r){
            int mid = (l + r)>>1;
            if(hasOnes(start, mid)){
                r = mid;
            }else l = mid;
        }
        if(r <= Right){
            ans.push_back(r);
            if((int)ans.size() == k) break;
        }
        start = r + 1;
    }
    return ans;
}

vector<int> guessOnes(int n, int k){
    
    return bin(1, n);
}

