#include <bits/stdc++.h>

using namespace std;
#define int long long
const int mod=1e8+543;
const int N=1e7;
vector<int> x(N+5, 0), a(1e5+5, 0);
int sgt[4*N+4];
void build(int i, int l, int r){
    if(l==r){

        sgt[i]=x[a[l]];
        return ;
    }int mid=(l+r)/2;
    build(2*i, l, mid);
    build(2*i+1, mid+1, r);
    sgt[i]=(sgt[2*i]+sgt[2*i+1])%mod;
    return ;
}void updt(int i, int l, int r,int index){
    if(index>=l && index<=r){
        if(l==r && r==index){

                    sgt[i]=x[a[index]];
                    return;

        }int mid=(l+r)/2;
        updt(2*i, l, mid, index);
        updt(2*i+1, mid+1, r, index);
        sgt[i]=(sgt[2*i]+sgt[2*i+1])%mod;
        return ;
    }return;
}
int query(int i, int l, int r, int tl, int tr){
    if(l>=tl && r<=tr){
        return sgt[i];
    }else if(r<tl || l>tr)return 0;
    int mid=(l+r)/2;
    int a=query(2*i, l, mid, tl, tr);
    int b=query(2*i+1, mid+1, r, tl, tr);
    return (a+b)%mod;
}
int32_t main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    x[0]=0;
    x[1]=1;
    x[2]=2;
    x[3]=3;
    x[4]=4;
    for(int k=5; k<=N; k++){
        x[k]=(5*x[k-1]+4*x[k-2]+3*x[k-3]+2*x[k-4]+x[k-5])%mod;
    }
    int n,q;
    cin>>n>>q;
    int mx=0;
    for(int i=1; i<=n; i++){
        cin>>a[i];
        mx=max(a[i], mx);
        
    }build(1, 1, n);
    for(int i=1; i<=q; i++){
        int t;
        cin>>t;
        if(t==1){
            int l,r;
            cin>>l>>r;
            cout<<query(1, 1, n, l, r)<<endl;
        }else{
            int l, r, val;
            cin>>l>>r>>val;
            a[l]=a[l]+val;
            mx=max(mx, a[l]);
            if(mx<=N) updt(1, 1, n, l);
        }
    }
    return 0;
}
