#include <iostream>
#include <algorithm>
#include <vector>
#include <array>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <list>
#include <chrono>
#include <random>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <iomanip>
#include <bitset>
#include <cassert>
#include "ones.h"

#define ld long double

using namespace std;

std::vector<int> guessOnes(int n, int k)
{
    int last = 1;
    vector<int> ans;
    int copk = k;
    while(ans.size() < copk)
    {
        ld chance = (ld)k/(ld)(n-last);
        ld chance_not = (ld)1-chance;
        ld chance_not_chain = (ld)1;
        int len = 0;
        while(true)
        {
            chance_not_chain*=chance_not;
            len++;
            if(chance_not_chain <= (ld)1/(ld)10000)
            {
                break;
            }
        }
        int l = last, r = min(n, last+len);
        while(l <= r)
        {
            int mid = l+r>>1;
            bool got = hasOnes(last, mid);
            if(got)
            {
                r = mid-1;
            }
            else
            {
                l = mid+1;
            }
        }
        ans.push_back(l);
        k--;
        last = l+1;
    }
    return ans;
}
