//             _
//   ^ ^      //
// >(O_O)<___//
//   \ __ __  \
//    \\ \\ \\\\

#include "puzzle.h"
#include <bits/stdc++.h>
using namespace std;

#pragma GCC optimize("O3")
#pragma GCC target("popcnt")

//#define int long long
#define forn(i,n) for(int i=0; i<n; ++i)
#define pb push_back
#define vii(a,n) vector<int>a(n);forn(i,n)cin>>a[i];
#define pi pair<int,int>
#define f first
#define s second

void init(int numSubtests, double timeLimit) {

}

struct DSU {
	vector<int> p,sz;
	DSU(int n) {forn(i,n)p.pb(i),sz.pb(1);}
	int get(int u) {return p[u]==u?u:p[u]=get(p[u]);}
	void uni(int u, int v) {
		u=get(u),v=get(v); if (u==v) return;
		if (sz[u]<sz[v]) swap(u,v); p[v]=u, sz[u]+=sz[v];
	}
};

bool solve(vector<vector<int>>& puzzle) {

	int n=puzzle.size();
	auto a = puzzle;
	auto ans = a;

	vector<vector<int>> vis(n,vector<int>(n,0));

	int k=0; forn(i,n) forn(j,n) k+=!!a[i][j];

	forn(it,k) {
		pi ok = {-1,-1};
		forn(i,n) {
			forn(j,n) {
				if (!puzzle[i][j]) continue;
				if (vis[i][j]) continue;
				if (!a[i][j]) {ok={i,j}; continue;}
				int s=0;
				for(int z=i-1; z>=0; --z) {
					if (ans[z][j]<0) break;
					if (vis[z][j]) break;
					if (puzzle[z][j]) {
						s+=min({a[i][j],a[z][j],2}); break;
					}
				}
				for(int z=i+1; z<n; ++z) {
					if (ans[z][j]<0) break;
					if (vis[z][j]) break;
					if (puzzle[z][j]) {
						s+=min({a[i][j],a[z][j],2}); break;
					}
				}
				for(int z=j-1; z>=0; --z) {
					if (ans[i][z]<0) break;
					if (vis[i][z]) break;
					if (puzzle[i][z]) {
						s+=min({a[i][j],a[i][z],2}); break;
					}
				}
				for(int z=j+1; z<n; ++z) {
					if (ans[i][z]<0) break;
					if (vis[i][z]) break;
					if (puzzle[i][z]) {
						s+=min({a[i][j],a[i][z],2}); break;
					}
				}
				if (s==a[i][j]) {
					ok={i,j};
				}
			}
		}
		if (ok.f==-1) {
			forn(i,n) forn(j,n) {
				if (!puzzle[i][j]) continue;
				if (vis[i][j]) continue;
				if (ok.f==-1) ok={i,j};
				if (a[i][j] < a[ok.f][ok.s]) ok={i,j};
			}
			int i=ok.f, j=ok.s;
			pi mx={-1,-1};
			for(int z=i-1; z>=0; --z) {
				if (ans[z][j]<0) break;
				if (vis[z][j]) break;
				if (puzzle[z][j]) {
					if (!a[z][j]) break;
					if (mx.f==-1) mx={z,j};
					if (a[z][j] > a[mx.f][mx.s]) mx={z,j};
					break;
				}
			}
			for(int z=i+1; z<n; ++z) {
				if (ans[z][j]<0) break;
				if (vis[z][j]) break;
				if (puzzle[z][j]) {
					if (!a[z][j]) break;
					if (mx.f==-1) mx={z,j};
					if (a[z][j] > a[mx.f][mx.s]) mx={z,j};
					break;
				}
			}
			for(int z=j-1; z>=0; --z) {
				if (ans[i][z]<0) break;
				if (vis[i][z]) break;
				if (puzzle[i][z]) {
					if (!a[i][z]) break;
					if (mx.f==-1) mx={i,z};
					if (a[i][z] > a[mx.f][mx.s]) mx={i,z};
					break;
				}
			}
			for(int z=j+1; z<n; ++z) {
				if (ans[i][z]<0) break;
				if (vis[i][z]) break;
				if (puzzle[i][z]) {
					if (!a[i][z]) break;
					if (mx.f==-1) mx={i,z};
					if (a[i][z] > a[mx.f][mx.s]) mx={i,z};
					break;
				}
			}
			if (mx.f==-1) return false;
			int t=min({a[i][j],a[mx.f][mx.s],2});
			a[i][j]-=t; a[mx.f][mx.s]-=t;
			if (mx.f==i) {
				if (mx.s < j) {
					for(int q=j-1; q>mx.s; --q) ans[i][q]=-2*t+1;
				} else {
					for(int q=j+1; q<mx.s; ++q) ans[i][q]=-2*t+1;
				}
			} else {
				if (mx.f < i) {
					for(int q=i-1; q>mx.f; --q) ans[q][j]=-2*t;
				} else {
					for(int q=i+1; q<mx.f; ++q) ans[q][j]=-2*t;
				}
			}
			--it;
			continue;
		}

		int i=ok.f, j=ok.s;
		//cout<<"? "<<it<<"  "<<i<<' '<<j<<'\n';
		vis[i][j]=1;
		if (!a[i][j]) continue;
		for(int z=i-1; z>=0; --z) {
			if (ans[z][j]<0) break;
			if (vis[z][j]) break;
			if (puzzle[z][j]) {
				int t=min({a[z][j],a[i][j],2});
				if (!t) break;
				for(int q=i-1; q>z; --q) ans[q][j]=-2*t;
				a[i][j]-=t;
				a[z][j]-=t;
				break;
			}
		}
		for(int z=i+1; z<n; ++z) {
			if (ans[z][j]<0) break;
			if (vis[z][j]) break;
			if (puzzle[z][j]) {
				int t=min({a[z][j],a[i][j],2});
				if (!t) break;
				for(int q=i+1; q<z; ++q) ans[q][j]=-2*t;
				a[i][j]-=t;
				a[z][j]-=t;
				break;
			}
		}
		for(int z=j-1; z>=0; --z) {
			if (ans[i][z]<0) break;
			if (vis[i][z]) break;
			if (puzzle[i][z]) {
				int t=min({a[i][z],a[i][j],2});
				if (!t) break;
				for(int q=j-1; q>z; --q) ans[i][q]=-2*t+1;
				a[i][j]-=t;
				a[i][z]-=t;
				break;
			}
		}
		for(int z=j+1; z<n; ++z) {
			if (ans[i][z]<0) break;
			if (vis[i][z]) break;
			if (puzzle[i][z]) {
				int t=min({a[i][z],a[i][j],2});
				if (!t) break;
				for(int q=j+1; q<z; ++q) ans[i][q]=-2*t+1;
				a[i][j]-=t;
				a[i][z]-=t;
				break;
			}
		}
		//forn(i,n) {
		//	forn(j,n) cout<<ans[i][j]<<' '; cout<<'\n';
		//}
	}
	forn(i,n) forn(j,n) puzzle[i][j]=ans[i][j];

	return true;
}