#include <bits/stdc++.h>
#include "Lgrader.cpp"
using namespace std;

vector<int> ans;
void recur(int l, int r){
    if (l == r){
        ans.push_back(l);
        return;
    }
    
    int mid = (l + r) / 2;
    if (hasOnes(l, mid)){
        recur(l, mid);
        if (hasOnes(mid + 1, r))
            recur(mid + 1, r);
    }
    else
        recur(mid + 1, r);
}

vector<int> guessOnes(int n, int k){
    int block_sz = n / k;
    vector<pair<int, int>> blocks;
    for (int i = 1; i <= n;){
        int r = min(i + block_sz - 1, n);
        blocks.push_back({i, r});
        i += block_sz;
    }

    ans.clear();
    for (int i = 0; i < blocks.size(); i ++){
        int l = blocks[i].first;
        int r = blocks[i].second;

        bool have = hasOnes(l, r);
        
        if (!have) continue;

        recur(l, r);
    }

    return ans;
}