#include <bits/stdc++.h>
#include "ones.h"
using namespace std;

int myn, myk;
vector<int> ans;
queue<pair<int, int>> q;

void bfs(){
    while (q.size() != myk){
        auto p = q.front();
        q.pop();

        int l = p.first;
        int r = p.second;
    
        if (l == r){
            q.push({l, r});
            continue;
        }

        int mid = (l + r) / 2;
        if (hasOnes(l, mid)){
            q.push({l, mid});
            if (hasOnes(mid + 1, r))
                q.push({mid + 1, r});
        }
        else
            q.push({mid + 1, r});
    }

    while (q.size()){
        auto p = q.front();
        q.pop();

        int l = p.first;
        int r = p.second;

        while (l != r){
            int mid = (l + r) / 2;
            if (hasOnes(l, mid))
                r = mid;
            else
                l = mid + 1;
        }

        ans.push_back(l);
    }
}

vector<int> guessOnes(int N, int K){
    myn = N;
    myk = K;
    int block_sz = myn / (myk * 2);

    vector<pair<int, int>> blocks;
    for (int i = 1; i <= myn;){
        int r = min(i + block_sz - 1, myn);
        blocks.push_back({i, r});
        i += block_sz;
    }

    ans.clear();
    for (int i = 0; i < blocks.size(); i ++){
        int l = blocks[i].first;
        int r = blocks[i].second;

        bool have = hasOnes(l, r);
        
        if (!have) continue;

        q.push({l, r});
    }

    bfs();

    sort(ans.begin(), ans.end());
    return ans;
}