#include <bits/stdc++.h>
#include "ones.h"
using namespace std;

int myn, myk, mymoves;
vector<int> ans;

vector<int> guessOnes(int N, int K){
    myn = N;
    myk = K;

    ans.clear();
    mymoves = 0;

    int start = 1;

    while (myk){
        int len = min(myn - start + 1, max(1, (int)((myn - start + 1) / (0.5 * myk))));
        if (!hasOnes(start, start + len - 1)){
            start += len;
            continue;
        }

        int l = start;
        int r = start + len - 1;
        while (l != r){
            int mid = (l + r) / 2;
            if (hasOnes(l, mid))
                r = mid;
            else
                l = mid + 1;
        }

        ans.push_back(l);

        start = l + 1;
        myk--;
    }

    return ans;
}

/*
#include <bits/stdc++.h>
#include "Lgrader.cpp"
using namespace std;

int myn, myk, mymoves;
vector<int> ans;
queue<pair<int, int>> q;

void bfs(){
    while (q.size() != myk){
        auto p = q.front();
        q.pop();

        int l = p.first;
        int r = p.second;
    
        if (l == r){
            q.push({l, r});
            continue;
        }

        int mid = (l + r) / 2;
        mymoves++;
        if (hasOnes(l, mid)){
            mymoves++;
            q.push({l, mid});
            if (hasOnes(mid + 1, r))
                q.push({mid + 1, r});
        }
        else
            q.push({mid + 1, r});
    }
    cout << "--" << mymoves << endl;

    while (q.size()){
        auto p = q.front();
        q.pop();

        int l = p.first;
        int r = p.second;

        while (l != r){
            int mid = (l + r) / 2;
            mymoves++;
            if (hasOnes(l, mid))
                r = mid;
            else
                l = mid + 1;
        }

        ans.push_back(l);
    }

    cout << "--" << mymoves << endl;
}

vector<int> guessOnes(int N, int K){
    myn = N;
    myk = K;

    int block_sz = myn / (2 * myk);

    vector<pair<int, int>> blocks;
    for (int i = 1; i <= myn;){
        int r = min(i + block_sz - 1, myn);
        blocks.push_back({i, r});
        i += block_sz;
    }

    ans.clear();
    mymoves = 0;
    for (int i = 0; i < blocks.size(); i ++){
        int l = blocks[i].first;
        int r = blocks[i].second;

        bool have = hasOnes(l, r);
        mymoves++;
        
        if (!have) continue;

        q.push({l, r});
    }

    cout << "--" << mymoves << endl;

    bfs();

    sort(ans.begin(), ans.end());
    return ans;
}
*/