#include <bits/stdc++.h>
#include "puzzle.h"
//#include "Lgrader.cpp"
using namespace std;
typedef pair<int,int> pii;
mt19937 rng(chrono::steady_clock().now().time_since_epoch().count());
double TL;
int tests;
void init(int numSubtests,double timeLimit)
{
    tests=numSubtests;
    TL=timeLimit;
}
int N,M;
vector<vector<int>> v;
vector<vector<int>> sol;
vector<pii> edges[51][51];
int who[51][51];
vector<pii> ord;
bool use[2500];
int cnt[2500];
bool found=0;
bool block(int i1,int j1,int i2,int j2)
{
    if(i1==i2)
    {
        if(j1>j2)
            swap(j1,j2);
        for(int j=j1+1;j<j2;j++)
            if(v[i1][j]!=0)
                return 1;
        return 0;
    }
    if(j1==j2)
    {
        if(i1>i2)
            swap(i1,i2);
        for(int i=i1+1;i<i2;i++)
            if(v[i][j1]!=0)
                return 1;
        return 0;
    }
    return 0;
}
void put(int i1,int j1,int i2,int j2,int val)
{
    if(i1==i2)
    {
        if(j1>j2)
            swap(j1,j2);
        if(val==1)
            val=-1;
        else if(val==2)
            val=-3;
        for(int j=j1+1;j<j2;j++)
            v[i1][j]=val;
    }
    else
    {
        if(i1>i2)
            swap(i1,i2);
        if(val==1)
            val=-2;
        else if(val==2)
            val=-4;
        for(int i=i1+1;i<i2;i++)
            v[i][j1]=val;
    }
}
void print(vector<vector<int>> A)
{
    for(int i=0;i<N;i++,cout<<'\n')
        for(int j=0;j<M;j++)
        {
            if(v[i][j]>=0)
                cout<<' ';
            cout<<A[i][j]<<' ';
        }
}
void bkt(int poz)
{
    if(found)
        return;
    if(poz==ord.size())
    {
        found=1;
        sol=v;
        return;
    }
    int i=ord[poz].first;
    int j=ord[poz].second;
    use[poz]=1;
    if(cnt[poz]==v[i][j])
    {
        bkt(poz+1);
        return;
    }
    int need=v[i][j]-cnt[poz];
    if(found)
        return;
    vector<pii> have;
    for(pii p:edges[i][j])
    {
        int a=p.first;
        int b=p.second;
        int ind=who[a][b];
        if(!use[ind])
        {
            have.push_back({a,b});
            have.push_back({a,b});
        }
    }
    int lg=have.size();
    for(int mask=0;mask<(1<<lg);mask++)
        if(__builtin_popcount(mask)==need)
        {
            vector<pii> add;
            for(int bit=0;bit<lg;bit++)
                if((mask>>bit)&1)
                    add.push_back(have[bit]);
            bool ok=1;
            for(int z=0;z<add.size();z++)
            {
                int x=add[z].first,y=add[z].second;
                int ind=who[x][y];
                if(block(i,j,x,y))
                {
                    ok=0;
                    break;
                }
                int g=1;
                if(z+1<add.size()&&add[z+1]==add[z])
                    g++;
                if(cnt[ind]+g>v[x][y])
                {
                    ok=0;
                    break;
                }
            }
            if(!ok)
                continue;
            for(int z=0;z<add.size();z++)
            {
                int x=add[z].first,y=add[z].second;
                int ind=who[x][y];
                int g=1;
                if(z+1<add.size()&&add[z+1]==add[z])
                {
                    g++;
                    z++;
                }
                cnt[ind]+=g;
                cnt[poz]+=g;
                put(i,j,x,y,g);
            }
            bkt(poz+1);
            if(found)
                return;
            for(int z=0;z<add.size();z++)
            {
                int x=add[z].first,y=add[z].second;
                int ind=who[x][y];
                int g=1;
                if(z+1<add.size()&&add[z+1]==add[z])
                {
                    g++;
                    z++;
                }
                cnt[ind]-=g;
                cnt[poz]-=g;
                put(i,j,x,y,0);
            }
        }
    use[poz]=0;
}
bool solve(vector<vector<int>> &mat)
{
    v=mat;
    N=mat.size();
    M=mat[0].size();
    for(int i=0;i<N;i++)
        for(int j=0;j<M;j++)
            edges[i][j].clear();
    ord.clear();
    for(int i=0;i<N;i++)
        for(int j=0;j<M;j++)
            if(v[i][j]!=0)
            {
                who[i][j]=ord.size();
                ord.push_back({i,j});
                for(int k=i-1;k>=0;k--)
                    if(v[k][j]!=0)
                    {
                        edges[i][j].push_back({k,j});
                        break;
                    }
                for(int k=i+1;k<N;k++)
                    if(v[k][j]!=0)
                    {
                        edges[i][j].push_back({k,j});
                        break;
                    }
                for(int k=j-1;k>=0;k--)
                    if(v[i][k]!=0)
                    {
                        edges[i][j].push_back({i,k});
                        break;
                    }
                for(int k=j+1;k<M;k++)
                    if(v[i][k]!=0)
                    {
                        edges[i][j].push_back({i,k});
                        break;
                    }
            }
    //shuffle(ord.begin(),ord.end(),rng);
    found=0;
    bkt(0);
    mat=sol;
    //print(mat);
    return found;
}
