#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
const int mod=1e8+543;
int n,q,v[100005];
int toprop[4*100005][6][6];
int arb[4*100005][6];
int init[100005][6];
int M1[6][6],M2[6][6],p1[31][6][6],p2[31][6][6],c[6][6],r[6][6],vv[6],sol,mat[6][6],pval[6][6];
void multvec(int a[6],int b[6][6])
{
    for(int j=1;j<=5;j++)
    {
        vv[j]=0;
        for(int i=1;i<=5;i++)
        {
            ll val=(1LL*a[i]*b[i][j])%mod;
            vv[j]=(vv[j]+val)%mod;
        }
    }
}
void mult(int a[6][6],int b[6][6])
{
    for(int i=1;i<=5;i++)
        for(int j=1;j<=5;j++)
        {
            c[i][j]=0;
            for(int k=1;k<=5;k++)
            {
                ll val=(1LL*a[i][k]*b[k][j])%mod;
                c[i][j]=(c[i][j]+val)%mod;
            }
        }
}
void pw1(int x)
{
    for(int i=1;i<=5;i++)
        for(int j=1;j<=5;j++)
        {
            r[i][j]=0;
            if(i==j)
                r[i][j]=1;
        }
    for(int bit=0;bit<=26;bit++)
        if((x>>bit)&1)
        {
            mult(r,p1[bit]);
            for(int i=1;i<=5;i++)
                for(int j=1;j<=5;j++)
                    r[i][j]=c[i][j];
        }
}
void pw2(int x)
{
    for(int i=1;i<=5;i++)
        for(int j=1;j<=5;j++)
        {
            r[i][j]=0;
            if(i==j)
                r[i][j]=1;
        }
    for(int bit=0;bit<=26;bit++)
        if((x>>bit)&1)
        {
            mult(r,p2[bit]);
            for(int i=1;i<=5;i++)
                for(int j=1;j<=5;j++)
                    r[i][j]=c[i][j];
        }
}
void make1()
{
    M1[1][5]=1;
    M1[2][1]=1;
    M1[2][5]=2;
    M1[3][2]=1;
    M1[3][5]=3;
    M1[4][3]=1;
    M1[4][5]=4;
    M1[5][4]=1;
    M1[5][5]=5;
    for(int i=1;i<=5;i++)
        for(int j=1;j<=5;j++)
            p1[0][i][j]=M1[i][j];
    for(int j=1;j<=30;j++)
    {
        mult(p1[j-1],p1[j-1]);
        for(int a=1;a<=5;a++)
            for(int b=1;b<=5;b++)
                p1[j][a][b]=c[a][b];
    }
}
void make2()
{
    M2[1][1]=mod-2;
    M2[1][2]=1;
    M2[2][1]=mod-3;
    M2[2][3]=1;
    M2[3][1]=mod-4;
    M2[3][4]=1;
    M2[4][1]=mod-5;
    M2[4][5]=1;
    M2[5][1]=1;
    for(int i=1;i<=5;i++)
        for(int j=1;j<=5;j++)
            p2[0][i][j]=M2[i][j];
    for(int j=1;j<=30;j++)
    {
        mult(p2[j-1],p2[j-1]);
        for(int a=1;a<=5;a++)
            for(int b=1;b<=5;b++)
                p2[j][a][b]=c[a][b];
    }
}
void build(int nod,int st,int dr)
{
    for(int i=1;i<=5;i++)
        for(int j=1;j<=5;j++)
        {
            toprop[nod][i][j]=0;
            if(i==j)
                toprop[nod][i][j]=1;
        }
    if(st==dr)
    {
        for(int i=1;i<=5;i++)
            arb[nod][i]=init[st][i];
        return;
    }
    int mij=(st+dr)/2;
    build(nod*2,st,mij);
    build(nod*2+1,mij+1,dr);
    for(int i=1;i<=5;i++)
        arb[nod][i]=(arb[nod*2][i]+arb[nod*2+1][i])%mod;
}
void reset(int nod)
{
    for(int i=1;i<=5;i++)
        for(int j=1;j<=5;j++)
        {
            toprop[nod][i][j]=0;
            if(i==j)
                toprop[nod][i][j]=1;
        }
}
void prop(int nod)
{
    multvec(arb[nod*2],toprop[nod]);
    for(int i=1;i<=5;i++)
        arb[nod*2][i]=vv[i];
    mult(toprop[nod*2],toprop[nod]);
    for(int i=1;i<=5;i++)
        for(int j=1;j<=5;j++)
            toprop[nod*2][i][j]=c[i][j];

    multvec(arb[nod*2+1],toprop[nod]);
    for(int i=1;i<=5;i++)
        arb[nod*2+1][i]=vv[i];
    mult(toprop[nod*2+1],toprop[nod]);
    for(int i=1;i<=5;i++)
        for(int j=1;j<=5;j++)
            toprop[nod*2+1][i][j]=c[i][j];
}
void update(int nod,int st,int dr,int a,int b)
{
    if(st!=dr)
        prop(nod);
    reset(nod);
    if(st>=a&&dr<=b)
    {
        multvec(arb[nod],mat);
        for(int i=1;i<=5;i++)
            arb[nod][i]=vv[i];
        mult(toprop[nod],mat);
        for(int i=1;i<=5;i++)
            for(int j=1;j<=5;j++)
                toprop[nod][i][j]=c[i][j];
        return;
    }
    int mij=(st+dr)/2;
    if(a<=mij)
        update(nod*2,st,mij,a,b);
    if(b>mij)
        update(nod*2+1,mij+1,dr,a,b);
    for(int i=1;i<=5;i++)
        arb[nod][i]=(arb[nod*2][i]+arb[nod*2+1][i])%mod;
}
int query(int nod,int st,int dr,int a,int b)
{
    if(st!=dr)
        prop(nod);
    reset(nod);
    if(st>=a&&dr<=b)
        return arb[nod][1];
    int rez=0;
    int mij=(st+dr)/2;
    if(a<=mij)
        rez=(rez+query(nod*2,st,mij,a,b))%mod;
    if(b>mij)
        rez=(rez+query(nod*2+1,mij+1,dr,a,b))%mod;
    return rez;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin>>n>>q;
    make1();
    make2();
    for(int i=1;i<=n;i++)
    {
        cin>>v[i];
        for(int j=1;j<=5;j++)
            init[i][j]=j-1;
        if(v[i]==0)
            continue;
        if(v[i]>0)
        {
            pw1(v[i]);
            multvec(init[i],r);
            for(int j=1;j<=5;j++)
                init[i][j]=vv[j];
        }
        else
        {
            pw2(abs(v[i]));
            multvec(init[i],r);
            for(int j=1;j<=5;j++)
                init[i][j]=vv[j];
        }
    }
    build(1,1,n);
    while(q--)
    {
        int tip,st,dr;
        cin>>tip>>st>>dr;
        if(tip==1)
            cout<<query(1,1,n,st,dr)<<'\n';
        else
        {
            int val;
            cin>>val;
            if(val>0)
            {
                pw1(val);
                for(int i=1;i<=5;i++)
                    for(int j=1;j<=5;j++)
                        mat[i][j]=r[i][j];
            }
            else
            {
                pw2(abs(val));
                for(int i=1;i<=5;i++)
                    for(int j=1;j<=5;j++)
                        mat[i][j]=r[i][j];
            }
            update(1,1,n,st,dr);
        }
    }
    return 0;
}
