#include "ones.h"
#include <queue>
#include <algorithm>

std::vector <int> guessOnes( int n, int k ) {

    std::vector <int> v;

    std::queue< std::pair<int, int>> q;

    q.push({1, n / 2});
    q.push({n / 2 + 1, n});

    while ( q.size() != 0 && v.size() < k ) {

        int st = q.front().first;
        int dr = q.front().second;

        q.pop();

        if ( hasOnes(st, dr) == 1 ) {
            if ( st == dr )
                v.push_back(st);
            else {
                q.push ({st, (st + dr) / 2});
                q.push ({(st + dr) / 2 + 1, dr});
            }
        }
    }

    sort ( v.begin(), v.end() );

    return v;
}
