#include "ones.h"
#include <algorithm>
#include <queue>

std::vector <int> guessOnes( int n, int k ) {

    std::vector <int> v;

    if ( k * 2 < n ) {

        std::queue< std::pair<int, int>> q;

        int st = 1, dr = n / k;

        while ( dr != n ) {

            q.push({st, dr});

            st = dr + 1;
            dr = dr + n / k;

            if ( dr > n )
                dr = n;
        }

        q.push({st, dr});

        while ( q.size() != 0 && v.size() < k ) {

            st = q.front().first;
            dr = q.front().second;

            q.pop();

            if ( hasOnes(st, dr) == 1 ) {
                for ( int i = st; i <= dr; i++ )
                    if ( hasOnes (i, i) == 1 )
                    v.push_back (i);
            }
        }

        sort ( v.begin(), v.end() );
    }

    else {
        for ( int i = 1; i <= n && v.size() < k; i++ ) {
            if ( hasOnes (i, i) == true )
                v.push_back (i);
        }
    }

    return v;
}
