#include <bits/stdc++.h>
#include "ones.h"

using namespace std;

int lg2(int x) {
    return 31 - __builtin_clz(x);
}

vector<int> positions;

int find_first_in_range(int posl, int posr, int rem, int n, int k) {
    //>= pos
    int p = n / k * 15;

    int st = posl;
    int dr = min(posr, posl + p);
    int first = 0;

    while (st <= dr) {
        int mij = (st + dr) / 2;
        if (hasOnes(posl, mij)) {
            first = mij;
            dr = mij - 1;
        } else {
            st = mij + 1;
        }
    }
    return first;
}


int find_last_in_range(int posl, int posr, int rem, int n, int k) {

    int p = n / k * 15;

    int st = max(posl, posr - p);
    int dr = posr;
    int last = 0;

    while (st <= dr) {
        int mij = (st + dr) / 2;
        if (hasOnes(mij, posr)) {
            last = mij;
            st = mij + 1;
        } else {
            dr = mij - 1;
        }
    }
    return last;
}

mt19937 mt(time(0));

int gen_range(int st, int dr) {
    return st + mt() % (dr - st + 1);
}

void divideGreedy(int st, int dr) {
    if (st == dr) {
        positions.push_back(st);
        return;
    }
    int mij = (st + dr) / 2;
    if (hasOnes(st, mij))
        divideGreedy(st, mij);
    if (hasOnes(mij + 1, dr))
        divideGreedy(mij + 1, dr);
}

const int BSIZE = 10;

void go(int st, int dr) {
    if (st > dr)
        return;
    if (!hasOnes(st, dr))
        return;
    while (1) {
        int nr = gen_range(st, dr);
        if (hasOnes(nr, min(dr, nr + BSIZE - 1))) {
            divideGreedy(nr, min(dr, nr + BSIZE - 1));
            go(st, nr - 1);
            go(nr + BSIZE, dr);
            break;
        }
    }
}


vector<int> guessOnes(int n, int k) {
    positions.clear();

    go(1, n);

    sort(positions.begin(), positions.end());

    return positions;
}
