#include <bits/stdc++.h>
#include "ones.h"

using namespace std;

int lg2(int x) {
    return 31 - __builtin_clz(x);
}

vector<int> positions;

int find_first_in_range(int posl, int posr, int n, int k) {
    //>= pos
    int p = n / k * 15;

    int st = posl;
    int dr = min(posr, posl + p);
    int first = 0;

    while (st <= dr) {
        int mij = (st + dr) / 2;
        if (hasOnes(posl, mij)) {
            first = mij;
            dr = mij - 1;
        } else {
            st = mij + 1;
        }
    }
    return first;
}


int find_last_in_range(int posl, int posr, int n, int k) {

    int p = n / k * 15;

    int st = max(posl, posr - p);
    int dr = posr;
    int last = 0;

    while (st <= dr) {
        int mij = (st + dr) / 2;
        if (hasOnes(mij, posr)) {
            last = mij;
            st = mij + 1;
        } else {
            dr = mij - 1;
        }
    }
    return last;
}

mt19937 mt(time(0));

int gen_range(int st, int dr) {
    return st + mt() % (dr - st + 1);
}

void divideGreedy(int st, int dr) {
    if (st == dr) {
        positions.push_back(st);
        return;
    }
    int mij = (st + dr) / 2;
    if (hasOnes(st, mij))
        divideGreedy(st, mij);
    if (hasOnes(mij + 1, dr))
        divideGreedy(mij + 1, dr);
}

void parcurgeBinSearch(int st, int dr, int n, int k) {
    int last = st - 1;
    while (1) {
        int primul = find_first_in_range(last + 1, dr, n, k);
        positions.push_back(primul);
        if (primul + 1 > dr)
            break;
        if (!hasOnes(primul + 1, dr))
            break;
        last = primul;
    }
}

const int BSIZE = 10;

void go(int st, int dr, int n, int k) {
    if (st > dr)
        return;
    if (!hasOnes(st, dr))
        return;
    if (dr - st + 1 <= BSIZE) {
        parcurgeBinSearch(st, dr, n, k);
        return;
    }
    while (1) {
        int nr = gen_range(st, dr - BSIZE + 1);
        if (hasOnes(nr, nr + BSIZE - 1)) {
            parcurgeBinSearch(nr, nr + BSIZE - 1, n, k);
            go(st, nr - 1, n, k);
            go(nr + BSIZE, dr, n, k);
            break;
        }
    }
}


vector<int> guessOnes(int n, int k) {
    positions.clear();

    go(1, n, n, k);

    sort(positions.begin(), positions.end());

    return positions;
}
