#include <bits/stdc++.h>
#pragma GCC optimize("O2")
#pragma GCC optimize("unroll-loops")

using namespace std;
using ll = long long;

const ll MOD = 1e8 + 543;
const int NMAX = 1e5 + 5;
const int QMAX = 2e5 + 5;

//ll x[NMAX];

ll matsus[5][5];
ll matjos[5][5];

ll val[NMAX + 5][5];
ll a[NMAX + 5];
int n, q;

///MATRIX STUFF BEGIN

void constructSus() {
    matsus[1 - 1][2 - 1] = 1;
    matsus[2 - 1][3 - 1] = 1;
    matsus[3 - 1][4 - 1] = 1;
    matsus[4 - 1][5 - 1] = 1;


    matsus[5 - 1][1 - 1] = 1;
    matsus[5 - 1][2 - 1] = 2;
    matsus[5 - 1][3 - 1] = 3;
    matsus[5 - 1][4 - 1] = 4;
    matsus[5 - 1][5 - 1] = 5;
}

void constructJos() {
    matjos[1 - 1][1 - 1] = (-2 + MOD) % MOD;
    matjos[1 - 1][2 - 1] = (-3 + MOD) % MOD;
    matjos[1 - 1][3 - 1] = (-4 + MOD) % MOD;
    matjos[1 - 1][4 - 1] = (-5 + MOD) % MOD;
    matjos[1 - 1][5 - 1] = 1;


    matjos[2 - 1][1 - 1] = 1;
    matjos[3 - 1][2 - 1] = 1;
    matjos[4 - 1][3 - 1] = 1;
    matjos[5 - 1][4 - 1] = 1;
}

void inmSelf(ll a[5][5]) {
    ll b[5][5];

    for (int i = 0; i < 5; i++)
        for (int j = 0; j < 5; j++)
            b[i][j] = 0;

    for (int i = 0; i < 5; i++)
        for (int k = 0; k < 5; k++)
            for (int j = 0; j < 5; j++)
                b[i][j] += a[i][k] * a[k][j];
    for (int i = 0; i < 5; i++)
        for (int j = 0; j < 5; j++)
            a[i][j] = b[i][j] % MOD;
    // a devine a * a
}

void inmSame(ll a[5][5], ll b[5][5]) {
    ll c[5][5];
    for (int i = 0; i < 5; i++)
        for (int j = 0; j < 5; j++)
            c[i][j] = 0;

    for (int i = 0; i < 5; i++)
        for (int k = 0; k < 5; k++)
            for (int j = 0; j < 5; j++)
                c[i][j] += a[i][k] * b[k][j];
    for (int i = 0; i < 5; i++)
        for (int j = 0; j < 5; j++)
            a[i][j] = c[i][j] % MOD;
    //a devine a * b
}

void inm(ll a[5][5], ll b[5], ll c[5]) {
    for (int i = 0; i < 5; i++)
        c[i] = 0;

    for (int i = 0; i < 5; i++) {
        for (int k = 0; k < 5; k++) {
            //j = 0
            c[i] += a[i][k] * b[k];
        }
        c[i] %= MOD;
    }
    //c devine a * b
}

void InmSus(int idx, int v) {
    ll r[5][5];
    for (int i = 0; i < 5; i++)
        for (int j = 0; j < 5; j++)
            r[i][j] = 0;
    r[0][0] = r[1][1] = r[2][2] = r[3][3] = r[4][4] = 1;

    //r - matricea de identitate

    ll ma[5][5]; // matsus
    for (int i = 0; i < 5; i++)
        for (int j = 0; j < 5; j++)
            ma[i][j] = matsus[i][j];
    while (v > 0) {
        if (v & 1) {
            inmSame(r, ma);

        }
        inmSelf(ma);
        v >>= 1;
    }

    ll nval[5];

    inm(r, val[idx], nval);

    for (int i = 0; i < 5; i++)
        val[idx][i] = nval[i];
}

void InmJos(int idx, int v) {
    ll r[5][5];

    for (int i = 0; i < 5; i++)
        for (int j = 0; j < 5; j++)
            r[i][j] = 0;

    r[0][0] = r[1][1] = r[2][2] = r[3][3] = r[4][4] = 1;

    //r - matricea de identitate

    ll ma[5][5]; // matsus
    for (int i = 0; i < 5; i++)
        for (int j = 0; j < 5; j++)
            ma[i][j] = matjos[i][j];
    while (v > 0) {
        if (v & 1) {
            inmSame(r, ma);
        }
        inmSelf(ma);
        v >>= 1;
    }

    ll nval[5];

    inm(r, val[idx], nval);

    for (int i = 0; i < 5; i++)
        val[idx][i] = nval[i];
}

///MATRIX STUFF END

ll sp[NMAX + 1];

ll querySP(int st, int dr) {
    return (sp[dr] - sp[st - 1] + MOD) % MOD;
}


struct Node {
    ll mat[5];
    bool isLazy = 0;
    ll toInm[5][5];
} aint[NMAX * 4 + 5];

void propag(int node, bool fii) {
    if (!aint[node].isLazy)
        return;
    aint[node].isLazy = 0;
    ll rez[5];
    inm(aint[node].toInm, aint[node].mat, rez);
    for (int i = 0; i < 5; i++)
        aint[node].mat[i] = rez[i];

    if (!fii) {
        for (int i = 0; i < 5; i++) {
            for (int j = 0; j < 5; j++) {
                aint[node].toInm[i][j] = 0;
            }
            aint[node].toInm[i][i] = 1;
        }
        return;
    }

    aint[node * 2].isLazy = 1;
    aint[node * 2 + 1].isLazy = 1;

    inmSame(aint[node * 2].toInm, aint[node].toInm);
    inmSame(aint[node * 2 + 1].toInm, aint[node].toInm);

    for (int i = 0; i < 5; i++) {
        for (int j = 0; j < 5; j++) {
            aint[node].toInm[i][j] = 0;
        }
        aint[node].toInm[i][i] = 1;
    }
}

ll queryAint(int node, int st, int dr, int l, int r) {

    propag(node, st != dr);
    if (l <= st && dr <= r) {
        return aint[node].mat[4];
    }

    int mij = (st + dr) / 2;
    ll ans = 0;

    if (l <= mij) {
        ans += queryAint(node * 2, st, mij, l, r);
    }

    if (mij < r) {
        ans += queryAint(node * 2 + 1, mij + 1, dr, l, r);
    }

    return ans % MOD;
}

void updateAint(int node, int st, int dr, int l, int r, ll special[5][5]) {
    propag(node, st != dr);
    if (l <= st && dr <= r) {
        for (int i = 0; i < 5; i++)
            for (int j = 0; j < 5; j++)
                aint[node].toInm[i][j] = special[i][j];
        aint[node].isLazy = 1;
        propag(node, st != dr);
        return;
    }
    int mij = (st + dr) / 2;
    if (l <= mij)
        updateAint(node * 2, st, mij, l, r, special);
    else propag(node * 2, st != mij);

    if (mij < r)
        updateAint(node * 2 + 1, mij + 1, dr, l, r, special);
    else propag(node * 2 + 1, (mij + 1) != dr);

    for (int i = 0; i < 5; i++) {
        aint[node].mat[i] = aint[node * 2].mat[i] + aint[node * 2 + 1].mat[i];
    }
}

ll query(int st, int dr) {
    return queryAint(1, 1, n, st, dr);
}

void update(int stanga, int dreapta, int v) {
    if (v == 0)
        return;

    //construiesc matricea cu care inmultesc

    ll r[5][5];
    for (int i = 0; i < 5; i++)
        for (int j = 0; j < 5; j++)
            r[i][j] = 0;
    r[0][0] = r[1][1] = r[2][2] = r[3][3] = r[4][4] = 1;

    //r - matricea de identitate

    ll ma[5][5]; // matsus/jos

    if (v > 0) {
        for (int i = 0; i < 5; i++)
            for (int j = 0; j < 5; j++)
                ma[i][j] = matsus[i][j];
    } else {
        for (int i = 0; i < 5; i++)
            for (int j = 0; j < 5; j++)
                ma[i][j] = matjos[i][j];
        v = -v;
    }

    while (v > 0) {
        if (v & 1) {
            inmSame(r, ma);
        }
        inmSelf(ma);
        v >>= 1;
    }

    //am matricea r

    updateAint(1, 1, n, stanga, dreapta, r);
}

void buildAint(int node, int st, int dr) {
    if (st == dr) {
        for (int i = 0; i < 5; i++)
            aint[node].mat[i] = val[st][i];
        for (int i = 0; i < 5; i++) {
            for (int j = 0; j < 5; j++) {
                aint[node].toInm[i][j] = 0;
            }
            aint[node].toInm[i][i] = 1;
        }
        aint[node].isLazy = 0;
        return;
    }
    int mij = (st + dr) / 2;
    buildAint(node * 2, st, mij);
    buildAint(node * 2 + 1, mij + 1, dr);
    for (int i = 0; i < 5; i++)
        aint[node].mat[i] = (aint[node * 2].mat[i] + aint[node * 2 + 1].mat[i]) % MOD;
    aint[node].isLazy = 0;
    for (int i = 0; i < 5; i++) {
        for (int j = 0; j < 5; j++)
            aint[node].toInm[i][j] = 0;
        aint[node].toInm[i][i] = 1;
    }
}

struct Operation {
    int tip, l, r, v;
} op[QMAX + 5];

void solve() {



    constructSus();
    constructJos();

    cin >> n >> q;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        val[i][0] = 0;
        val[i][1] = 1;
        val[i][2] = 2;
        val[i][3] = 3;
        val[i][4] = 4;
        if (a[i] > 4)
            InmSus(i, a[i] - 4);
        else if (a[i] < 4)
            InmJos(i, 4 - a[i]);

        sp[i] = (sp[i - 1] + val[i][4]) % MOD;
    }

    bool justQueries = 1;

    for (int i = 1; i <= q; i++) {
        cin >> op[i].tip;
        if (op[i].tip == 1) {
            cin >> op[i].l >> op[i].r;
            //cout << query(l, r) << '\n';
        } else {
            cin >> op[i].l >> op[i].r >> op[i].v;
            //update(l, r, v);
            justQueries = false;
        }
    }

    if (justQueries) {
        for (int i = 1; i <= q; i++) {
            cout << querySP(op[i].l, op[i].r) << '\n';
        }
        return;
    }

    buildAint(1, 1, n);

    for (int i = 1; i <= q; i++) {
        if (op[i].tip == 1) {
            cout << query(op[i].l, op[i].r) << '\n';
        } else {
            update(op[i].l, op[i].r, op[i].v);
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}
