#include "puzzle.h"
#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef pair<ll,ll> pll;
const ll NMAX=50;
ll dx[4]={0,0,-1,1},dy[4]={-1,1,0,0};
ll cnt[NMAX][NMAX][4],n,cntcells=0;
pll edg[NMAX][NMAX][4];
bool fnd=0;
void bkt(ll x, ll y, ll visited, vector<vector<int>>& puzzle){
    if(visited==cntcells-1){
        ll s=0;
        for(ll d=0;d<4;d++){
            if(cnt[x][y][d]>=0) s+=cnt[x][y][d];
        }
        if(s==puzzle[x][y]) fnd=1;
        return;
    }
    ll tmp[4]{},canplace[4]{};
    for(ll d=0;d<4;d++){
        if(cnt[x][y][d]>=0){
            canplace[d]=0;
            continue;
        }
        ll nx=x+dx[d],ny=y+dy[d];
        while(nx>=0 && nx<n && ny>=0 && ny<n){
            if(puzzle[nx][ny]<0){
                canplace[d]=0;
                break;
            }
            if(puzzle[nx][ny]>0){
                canplace[d]=2;
                break;
            }
            nx+=dx[d],ny+=dy[d];
        }
    }
    for(tmp[0]=0;tmp[0]<=canplace[0];tmp[0]++){
        for(tmp[1]=0;tmp[1]<=canplace[1];tmp[1]++){
            for(tmp[2]=0;tmp[2]<=canplace[2];tmp[2]++){
                tmp[3]=puzzle[x][y]-tmp[0]-tmp[1]-tmp[2];
                for(ll d=0;d<4;d++) if(cnt[x][y][d]>=0) tmp[3]-=cnt[x][y][d];
                if(tmp[3]<0 || tmp[3]>canplace[3]) continue;
                for(ll d=0;d<4;d++){
                    if(canplace[d]){
                        cnt[x][y][d]=tmp[d];
                        cnt[edg[x][y][d].first][edg[x][y][d].second][d^1]=tmp[d];
                        ll nx=x+dx[d],ny=y+dy[d];
                        while(nx>=0 && nx<n && ny>=0 && ny<n){
                            if(puzzle[nx][ny]>0) break;
                            puzzle[nx][ny]=(tmp[d]?-((d&2)+tmp[d]):0);
                            nx+=dx[d],ny+=dy[d];
                        }
                    }
                }
                for(ll d=0;d<4;d++){
                    if(canplace[d]){
                        bkt(edg[x][y][d].first,edg[x][y][d].second,visited+1,puzzle);
                        if(fnd) return;
                        break;
                    }
                }

                for(ll d=0;d<4;d++){
                    if(canplace[d]){
                        cnt[x][y][d]=-1;
                        cnt[edg[x][y][d].first][edg[x][y][d].second][d^1]=-1;
                        ll nx=x+dx[d],ny=y+dy[d];
                        while(nx>=0 && nx<n && ny>=0 && ny<n){
                            if(puzzle[nx][ny]>0) break;
                            puzzle[nx][ny]=0;
                            nx+=dx[d],ny+=dy[d];
                        }
                    }
                }
            }
        }
    }
}
bool solve(vector<vector<int>>& puzzle){
    n=puzzle.size();
    for(ll i=0;i<n;i++){
        for(ll j=0;j<n;j++){
            if(puzzle[i][j]==0) continue;
            ++cntcells;
            for(ll d=0;d<4;d++){
                edg[i][j][d]={-1,-1};
                cnt[i][j][d]=-1;
                ll nx=i+dx[d],ny=j+dy[d];
                while(nx>=0 && nx<n && ny>=0 && ny<n){
                    if(puzzle[nx][ny]>0){
                        edg[i][j][d]={nx,ny};
                        break;
                    }
                    nx+=dx[d],ny+=dy[d];
                }
            }
        }
    }
    for(ll i=0;i<n;i++){
        for(ll j=0;j<n;j++){
            if(puzzle[i][j]){
                bkt(i,j,0,puzzle);
                for(ll i2=0;i2<n;i2++){
                    for(ll j2=0;j2<n;j2++){
                        cerr<<puzzle[i2][j2]<<" \n"[j2==n-1];
                    }
                }
                return true;
            }
        }
    }
}
void init(int _N, double TL){

}

