#include<bits/stdc++.h>

using namespace std;
typedef long long ll;
const ll NMAX=1e5+5,STMAX=(1<<19)+5,MOD=1e8+543,buffsize=1<<13;
char buff[buffsize+5];
int bpos=buffsize;
int read(){
    int n=0;
    if(bpos==buffsize) fread(buff,1,buffsize,stdin),bpos=0;

    while(buff[bpos]!='-' && (buff[bpos]<'0' || buff[bpos]>'9')){
        ++bpos;
        if(bpos==buffsize) fread(buff,1,buffsize,stdin),bpos=0;
    }
    int sgn=1;
    if(buff[bpos]=='-'){
        sgn=-1;
        ++bpos;
        if(bpos==buffsize) fread(buff,1,buffsize,stdin),bpos=0;
    }
    while(buff[bpos]>='0' && buff[bpos]<='9'){
        n=(n<<1)+(n<<3)+(buff[bpos++]^48);
        if(bpos==buffsize) fread(buff,1,buffsize,stdin),bpos=0;
    }
    return n*sgn;
}
struct matrix{
    ll data[5][5]{};
}unit,invunit,i5;
struct row{
    ll data[5]{};
};
matrix operator * (matrix a, matrix b){
    matrix ans;
    for(ll i=0;i<5;i++){
        for(ll j=0;j<5;j++){
            for(ll k=0;k<5;k++){
                ans.data[i][k]+=a.data[i][j]*b.data[j][k];
            }
        }
    }
    for(ll i=0;i<5;i++) for(ll j=0;j<5;j++) ans.data[i][j]%=MOD;
    return ans;
}
row operator * (row a, matrix b){
    row ans;
    for(ll j=0;j<5;j++){
        for(ll k=0;k<5;k++){
            ans.data[k]+=a.data[j]*b.data[j][k];
        }
    }
    for(ll j=0;j<5;j++) ans.data[j]%=MOD;
    return ans;
}
row operator + (row a, row b){
    row c;
    for(ll i=0;i<5;i++){
        c.data[i]=a.data[i]+b.data[i];
        if(c.data[i]>=MOD) c.data[i]-=MOD;
    }
    return c;
}
ll precalc[9]={0,0,0,0,0,1,2,3,4};
matrix binPow(ll y){
    matrix x=unit,ans=i5;
    //for(ll i=0;i<5;i++) ans.data[0][i]=precalc[4-i];
    for(;y;y>>=1,x=x*x)
        if(y&1)
            ans=ans*x;
    return ans;
}
matrix invPow(ll y){
    matrix x=invunit,ans=i5;
    //for(ll i=0;i<5;i++) ans.data[0][i]=4-i;
    for(;y;y>>=1,x=x*x)
        if(y&1)
            ans=ans*x;
    return ans;
}

ll a[NMAX];
row bit[NMAX];
matrix tmp;

void add(ll x){
    while(x<NMAX) bit[x]=bit[x]*tmp,x+=x&-x;
}
ll query(ll x){
    ll ans=0;
    while(x) ans+=bit[x].data[0],x-=x&-x;
    return ans;
}
int main(){

    unit.data[0][0]=5;
    unit.data[1][0]=4;
    unit.data[2][0]=3;
    unit.data[3][0]=2;
    unit.data[4][0]=1;
    unit.data[0][1]=1;
    unit.data[1][2]=1;
    unit.data[2][3]=1;
    unit.data[3][4]=1;

    invunit.data[0][4]=1;
    invunit.data[1][4]=-5;
    invunit.data[2][4]=-4;
    invunit.data[3][4]=-3;
    invunit.data[4][4]=-2;
    invunit.data[1][0]=1;
    invunit.data[2][1]=1;
    invunit.data[3][2]=1;
    invunit.data[4][3]=1;
    for(ll i=0;i<5;i++) i5.data[i][i]=1;
    for(ll i=3;i>=0;i--) precalc[i]=precalc[i+5]-5*precalc[i+4]-4*precalc[i+3]-3*precalc[i+2]-2*precalc[i+1];
    for(ll i=0;i<NMAX;i++){
        for(ll j=0;j<5;j++) bit[i].data[j]=precalc[4-j];
    }
    //freopen("in.txt","r",stdin);
    //freopen("out.txt","w",stdout);
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    ll n=read(),q=read();
    for(ll i=1;i<=n;i++){
        a[i]=read();
        tmp=(a[i]>0?binPow(a[i]):invPow(-a[i]));
        add(i);
    }
    while(q--){
        ll t=read(),l=read(),r=read();
        if(t==1){
            ll ans=(query(r)-query(l-1))%MOD;
            cout<<(ans+MOD)%MOD<<'\n';
        }
        else{
            ll x=read();
            if(x==0) continue;
            if(x>0){
                tmp=binPow(x);
                add(l);
                tmp=invPow(x);
                add(r+1);
            }
            else{
                tmp=invPow(-x);
                add(l);
                tmp=binPow(-x);
                add(r+1);
            }
        }
    }
}
