#include<bits/stdc++.h>
#pragma GCC optimize("Ofast,unroll-loops")

using namespace std;
typedef long long ll;
const ll NMAX=1e5+5,NMAX2=1e4+5,STMAX=(1<<19)+5,MOD=1e8+543,buffsize=1<<13;
char buff[buffsize+5];
int bpos=buffsize;
int read(){
    int n=0;
    if(bpos==buffsize) fread(buff,1,buffsize,stdin),bpos=0;

    while(buff[bpos]!='-' && (buff[bpos]<'0' || buff[bpos]>'9')){
        ++bpos;
        if(bpos==buffsize) fread(buff,1,buffsize,stdin),bpos=0;
    }
    int sgn=1;
    if(buff[bpos]=='-'){
        sgn=-1;
        ++bpos;
        if(bpos==buffsize) fread(buff,1,buffsize,stdin),bpos=0;
    }
    while(buff[bpos]>='0' && buff[bpos]<='9'){
        n=(n<<1)+(n<<3)+(buff[bpos++]^48);
        if(bpos==buffsize) fread(buff,1,buffsize,stdin),bpos=0;
    }
    return n*sgn;
}
struct matrix{
    ll data[5][5]{};
}unit,i5,pwunit[NMAX2],pwchunkunit[NMAX2];
struct row{
    ll data[5]{};
};
matrix operator * (matrix a, matrix b){
    matrix ans;
    for(ll i=0;i<5;i++){
        for(ll j=0;j<5;j++){
            for(ll k=0;k<5;k++){
                ans.data[i][k]+=a.data[i][j]*b.data[j][k];
            }
        }
    }
    for(ll i=0;i<5;i++) for(ll j=0;j<5;j++){
        ans.data[i][j]=(ans.data[i][j]%MOD+MOD)%MOD;
    }
    return ans;
}
row operator * (row a, matrix b){
    row ans;
    for(ll j=0;j<5;j++){
        for(ll k=0;k<5;k++){
            ans.data[k]+=a.data[j]*b.data[j][k];
        }
    }
    for(ll j=0;j<5;j++){
        ans.data[j]=(ans.data[j]%MOD+MOD)%MOD;
    }
    return ans;
}
row operator + (row a, row b){
    row c;
    for(ll i=0;i<5;i++){
        c.data[i]=a.data[i]+b.data[i];
        if(c.data[i]>=MOD) c.data[i]-=MOD;
    }
    return c;
}
ll precalc[9]={0,0,0,0,0,1,2,3,4};
matrix binPow(int y){
    return pwchunkunit[y/(NMAX2-1)]*pwunit[y%(NMAX2-1)];
}

ll a[NMAX];
row st[STMAX];
ll lazy[STMAX];
void init(int l, int r, int node){
    if(l==r){
        for(ll j=0;j<5;j++) st[node].data[j]=precalc[4-j];
        st[node]=st[node]*binPow(a[l]);
        return;
    }
    init(l,(l+r)/2,node*2+1);
    init((l+r)/2+1,r,node*2+2);
    st[node]=st[node*2+1]+st[node*2+2];
}
void push_lazy(int node){
    int pw=(lazy[node]%(MOD-1)+(MOD-1))%(MOD-1);
    if(pw==0) return;
    st[node]=st[node]*binPow(pw);
    lazy[node*2+1]+=lazy[node],lazy[node*2+2]+=lazy[node];
    lazy[node]=0;
}
void add(int ql, int qr, int val, int l, int r, int node){
    push_lazy(node);
    if(ql>r || l>qr) return;
    if(ql<=l && r<=qr){
        lazy[node]+=val;
        push_lazy(node);
        return;
    }
    add(ql,qr,val,l,(l+r)/2,node*2+1);
    add(ql,qr,val,(l+r)/2+1,r,node*2+2);
    st[node]=st[node*2+1]+st[node*2+2];
}
ll query(int ql, int qr, int l, int r, int node){
    push_lazy(node);
    if(ql>r  || l>qr)
        return 0;
    if(ql<=l && r<=qr) return st[node].data[0];
    return query(ql,qr,l,(l+r)/2,node*2+1)+query(ql,qr,(l+r)/2+1,r,node*2+2);
}
int main(){

    unit.data[0][0]=5;
    unit.data[1][0]=4;
    unit.data[2][0]=3;
    unit.data[3][0]=2;
    unit.data[4][0]=1;
    unit.data[0][1]=1;
    unit.data[1][2]=1;
    unit.data[2][3]=1;
    unit.data[3][4]=1;
    for(ll i=0;i<5;i++) i5.data[i][i]=1;
    pwunit[0]=pwchunkunit[0]=i5;
    for(ll i=1;i<NMAX2;i++){
        pwunit[i]=pwunit[i-1]*unit;
    }
    for(ll i=1;i<NMAX2;i++){
        pwchunkunit[i]=pwchunkunit[i-1]*pwunit[NMAX2-1];
    }
    for(ll i=3;i>=0;i--){
        precalc[i]=precalc[i+5]-5*precalc[i+4]-4*precalc[i+3]-3*precalc[i+2]-2*precalc[i+1];
        precalc[i]=(precalc[i]%MOD+MOD)%MOD;
    }
    //freopen("in.txt","r",stdin);
    //freopen("out.txt","w",stdout);
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    matrix tmp=binPow(MOD-2);
    ll n=read(),q=read();
    for(ll i=0;i<n;i++){
        a[i]=(read()%(MOD-1)+(MOD-1))%(MOD-1);
    }
    init(0,n-1,0);
    while(q--){
        ll t=read(),l=read()-1,r=read()-1;
        if(t==1){
            cout<<(query(l,r,0,n-1,0)%MOD+MOD)%MOD<<'\n';
        }
        else{
            ll x=read();
            if(x==0) continue;
            add(l,r,x,0,n-1,0);
        }
    }
}
