#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
#define debug(x) cerr << #x << " " << x << "\n"
#define debugs(x) cerr << #x << " " << x << " "

using namespace std;
typedef long long ll;
typedef pair <int, int> pii;

const int NMAX = 100001;
const int BLOCK = 1001;
const int MOD = 100000543;
const int INF = 1e9;
const int VALMAX = MOD;

int v[NMAX];

int aint[NMAX * 4][5][5];
int lazy[NMAX * 4][5][5];
int lzy[NMAX * 4];
int rec[5][5];

void add(int &x, int val) {
    x += val;
    if(x >= MOD)
        x -= MOD;
    if(x < 0)
        x += MOD;
}
void add(ll &x, int val) {
    x += val;
    if(x >= MOD)
        x -= MOD;
    if(x < 0)
        x += MOD;
}

void clr(int node) {
    for(int i = 0; i < 5; i++) {
        for(int j = 0; j < 5; j++) {
            lazy[node][i][j] = (i == j);
        }
    }
}

void clra(int node) {
    for(int i = 0; i < 5; i++) {
        for(int j = 0; j < 5; j++) {
            aint[node][i][j] = (i == j);
        }
    }
}

ll prod[5][5];
ll rez[5][5];
ll rez2[5][5];
ll mat[5][5];

void ridica(ll put) {
    for(int i = 0; i < 5; i++) {
        for(int j = 0; j < 5; j++) {
            prod[i][j] = (i == j);
        }
    }
    while(put) {
        for(int i = 0; i < 5; i++) {
            for(int j = 0; j < 5; j++) {
                rez[i][j] = rez2[i][j] = 0;
                for(int k = 0; k < 5; k++) {
                    add(rez2[i][j], (1LL * mat[i][k] * mat[k][j]));
                    add(rez[i][j], (1LL * prod[i][k] * mat[k][j]));
                }
                rez[i][j] %= MOD;
                rez2[i][j] %= MOD;
            }
        }
        if(put%2) {
            for(int i = 0; i < 5; i++) {
                for(int j = 0; j < 5; j++) prod[i][j] = rez[i][j];
            }
        }
        for(int i = 0; i < 5; i++) {
            for(int j = 0; j < 5; j++) mat[i][j] = rez2[i][j];
        }
        put /= 2;
    }
}


void inm(int node) {
    for(int i = 0; i < 5; i++) {
        for(int j = 0; j < 5; j++) {
            rez[i][j] = 0;
            for(int k = 0; k < 5; k++) {
                add(rez[i][j], (1LL * aint[node][i][k] * lazy[node][k][j]));
            }
            rez[i][j] %= MOD;
        }
    }
    for(int i = 0; i < 5; i++) {
        for(int j = 0; j < 5; j++)
            aint[node][i][j] = rez[i][j];
    }
}

void propaga(int node, int st, int dr) {
    if(lzy[node] == 0) return;
    if(st != dr) {
        for(int i = 0; i < 5; i++) {
            for(int j = 0; j < 5; j++) {
                rez[i][j] = 0;
                for(int k = 0; k < 5; k++) {
                    add(rez[i][j], (1LL * lazy[node * 2][i][k] * lazy[node][k][j]));
                }
                rez[i][j] %= MOD;
            }
        }
        for(int i = 0; i < 5; i++) {
            for(int j = 0; j < 5; j++)
                lazy[node * 2][i][j] = rez[i][j];
        }
        for(int i = 0; i < 5; i++) {
            for(int j = 0; j < 5; j++) {
                rez[i][j] = 0;
                for(int k = 0; k < 5; k++) {
                    add(rez[i][j], (1LL * lazy[node * 2 + 1][i][k] * lazy[node][k][j]));
                }
                                rez[i][j] %= MOD;

            }
        }
        for(int i = 0; i < 5; i++) {
            for(int j = 0; j < 5; j++)
                lazy[node * 2 + 1][i][j] = rez[i][j];
        }
        lzy[node * 2] = lzy[node * 2 + 1] = 1;

    }
    lzy[node] = 0;
    inm(node);
    clr(node);
}

void update(int node, int st, int dr, int a, int b, int val) {
    propaga(node, st, dr);
    if(a <= st && dr <= b) {
        for(int i = 0; i < 5; i++) {
            for(int j = 0; j < 5; j++) {
                mat[i][j] = rec[i][j];
            }
        }
        ridica(val);
        for(int i = 0; i < 5; i++) {
            for(int j = 0; j < 5; j++) {
                rez[i][j] = 0;
                for(int k = 0; k < 5; k++) {
                    add(rez[i][j], (1LL * lazy[node][i][k] * prod[k][j]));
                }
                                rez[i][j] %= MOD;

            }
        }
        for(int i = 0; i < 5; i++) {
            for(int j = 0; j < 5; j++)
                lazy[node][i][j] = rez[i][j];
        }
        lzy[node] = 1;
        return;
    }
    int mid = (st + dr) / 2;
    if(a <= mid)
        update(node * 2, st, mid, a, b, val);
    if(b > mid)
        update(node * 2 + 1, mid + 1, dr, a, b, val);
    propaga(node * 2, st, mid);
    propaga(node * 2 + 1, mid + 1, dr);
    for(int i = 0; i < 5; i++)
        for(int j = 0; j < 5; j++)
            aint[node][i][j] = aint[node * 2][i][j] + aint[node * 2 + 1][i][j];
}

int query(int node, int st, int dr, int a, int b) {
    propaga(node, st, dr);
    if(a <= st && dr <= b) {
        int total = 0;

        add(total, (aint[node][0][0] * (-22)) % MOD);
        add(total, (aint[node][0][1] * (33)) % MOD);
        add(total, (aint[node][0][2] * (-3)) % MOD);
        add(total, (aint[node][0][3] * (-4)) % MOD);
        add(total, (aint[node][0][4] * (-5)) % MOD);
        return total;
    }
    int mid = (st + dr) / 2;
    int sum = 0;
    if(a <= mid)
        add(sum, query(node * 2, st, mid, a, b));
    if(b > mid)
        add(sum, query(node * 2 + 1, mid + 1, dr, a, b));
    return sum;
}


int compute(int cv) {
    if(cv >= 0 && cv <= 4)
        return cv;
    for(int i = 0; i < 5; i++) {
        for(int j = 0; j < 5; j++) {
            mat[i][j] = rec[i][j];
            //debug(rec[i][j]);
        }
    }
    ridica(cv);
    int total = 0;
    add(total, (prod[0][0] * (-22)) % MOD);
    add(total, (prod[0][1] * (33)) % MOD);
    add(total, (prod[0][2] * (-3)) % MOD);
    add(total, (prod[0][3] * (-4)) % MOD);
    add(total, (prod[0][4] * (-5)) % MOD);
    return total;
}

int main() {
#ifdef HOME
    ifstream cin(".in");
    ofstream cout(".out");
#endif // HOME
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, q, i;
    cin >> n >> q;
    rec[0][0] = 5;
    rec[0][1] = 4;
    rec[0][2] = 3;
    rec[0][3] = 2;
    rec[0][4] = 1;
    rec[1][0] = 1;
    rec[2][1] = 1;
    rec[3][2] = 1;
    rec[4][3] = 1;
    for(int i = 0; i < NMAX * 4; i++) {
        clr(i);
        clra(i);
    }
    for(i = 1; i <= n; i++) {
        cin >> v[i];
        update(1, 1, n, i, i, v[i] + 1);
    }
    for(i = 1; i <= q; i++) {
        int l, r, t, vl;
        cin >> t >> l >> r;
        if(t == 1) {
            cout << query(1, 1, n, l, r) << "\n";
        } else {
            int vl;
            cin >> vl;
            update(1, 1, n, l, r, vl);
        }
    }
    return 0;
}
