#include "ones.h"
#include <bits/stdc++.h>
using namespace std;

vector <int> guessOnes(int n, int k) {

    vector <int> ret;

    if (k >= 300) {

        int Start = 1;
        const int block = min(300, n);
        while (Start <= n) {
            int idx = Start;
            int End = min(Start + block - 1, n);
            if (!hasOnes(Start, End)) {
                Start = End + 1;
                continue;
            }
            while (idx <= End) {
                int l = idx, r = End, pos = -1;
                while (l <= r) {
                    int m = (l + r) >> 1;
                    if ((idx == Start && m == End) || hasOnes(idx, m)) {
                        pos = m;
                        r = m - 1;
                    }
                    else
                        l = m + 1;
                }
                if (pos == -1)
                    break;
                ret.push_back(pos);
                if (ret.size() == k)
                    return ret;
                idx = pos + 1;
            }
            Start = End + 1;
        }
        return ret;
    }
    int idx = 1;

    while (idx <= n) {

        int l = idx, r = n, pos = -1;

        while (l <= r) {

            int m = (l + r) >> 1;

            if (hasOnes(idx, m)) {

                pos = m;
                r = m - 1;
            }
            else
                l = m + 1;
        }

        if (pos == -1)
            break;

        ret.push_back(pos);
        if (ret.size() == k)
            return ret;
        idx = pos + 1;
    }
    return ret;
}

