#include "ones.h"



void divimp(int st,int dr,std::vector<int>& v)
{
    if(st==dr)
    {
        v.push_back(st);
        return;
    }
    if(st>dr)
        return;
    int mid = (st+dr)/2;
    bool x = hasOnes(st,mid);
    bool y = hasOnes(mid+1,dr);
    if(x)   divimp(st,mid,v);
    if(y)   divimp(mid+1,dr,v);
}

#include <algorithm>
#include <cmath>
std::vector<int> guessOnes(int n,int k){
    std::vector <int> sol;

    std::vector <std::pair<int,int>> bounds;
    int bl = std::max(1,(int)sqrt(n));
    int st = 1;
    while(st<=n)
    {
        bounds.push_back({st,std::min(n,st+bl)});
        st=std::min(n+1,st+bl+1);
    }
    for(auto& i : bounds)
        divimp(i.first,i.second,sol);
    //divimp(1,n,sol);
    sort(sol.begin(),sol.end());
    return sol;
}
