#include "ones.h"


#include <cmath>
void divimp(int st,int dr,std::vector<int>& v)
{

    if(st==dr)
    {
        v.push_back(st);
        return;
    }
    if(st+1==dr)
    {
        if(hasOnes(st,st))
            v.push_back(st);
        if(hasOnes(dr,dr))
            v.push_back(dr);
        return;
    }
    if(st>dr)
        return;
    int bl = std::max(1,(int)sqrt(dr-st+1));
    int x = st;
    while(x<=dr)
    {
        int y = std::min(dr,x + bl);
        if(hasOnes(x,y))
            divimp(x,y,v);
        x = y + 1;
    }
}

/**
20 10 1
1 2 3 6 8 9 13 14 18 20
**/


#include <algorithm>

std::vector<int> guessOnes(int n,int k)
{
    std::vector <int> sol;

    divimp(1,n,sol);

    sort(sol.begin(),sol.end());
    return sol;
}
