#include "ones.h"


#include <cmath>


/**
20 10 1
1 2 3 6 8 9 13 14 18 20
**/
void divimp(int st,int dr,std::vector<int>& v)
{
    if(st==dr)
    {
        v.push_back(st);
        return;
    }
    if(st>dr)
        return;
    int mid = (st+dr)/2;
    bool x = hasOnes(st,mid);
    if(!x)
        divimp(mid+1,dr,v);
    else
    {
        bool y = hasOnes(mid+1,dr);
        divimp(st,mid,v);
        if(y)   divimp(mid+1,dr,v);
    }
}


#include <algorithm>
#include <random>

std::vector<int> guessOnes(int n,int k)
{
    std::vector <int> sol;
    std::vector <int> x;
    x.push_back(0);
    x.push_back(n);
    for(int i = 1 ; i<=int(sqrt(n)/2);i++)
    {
        int val = std::rand()%(n-2);
        x.push_back(val);
    }
    sort(x.begin(),x.end());
    x.resize(unique(x.begin(),x.end())-x.begin());
    for(int i=1;i<x.size();i++)
        divimp(x[i-1]+1,x[i],sol);

    sort(sol.begin(),sol.end());
    return sol;
}
