#include <iostream>
#include <vector>
#include "park.h"
using namespace std;
long double tt;
int dx[5]={-1,0,1,0},dy[5]={0,1,0,-1};
void init(int numSubtests, double timeLimit)
{
    tt=timeLimit;
}
bool check(std::vector<std::vector<int>>& puzzle,int n,int m,int i,int j)
{
    int cnt=0;
    for (int ind=0;ind<4;++ind)
    {
        int x=i,y=j;
        while (true)
        {
            x+=dx[ind];
            y+=dy[ind];
            if (x<0||y<0||x>=n||y>=n) break;
            if (puzzle[x][y]<0) break;
            if (puzzle[x][y]>0) {cnt++; break;}
        }
    }
    if (cnt==1) return 1;
    return 0;
}
int getvalue(int a,int b)
{
    a=(a+1)%2;
    return -2*a-b;
}
void fillsingle(std::vector<std::vector<int>>& puzzle,int n,int m,int i,int j)
{
    int cnt=0;
    int id=0;
    for (int ind=0;ind<4;++ind)
    {
        int x=i,y=j;
        while (true)
        {
            x+=dx[ind];
            y+=dy[ind];
            if (x<0||y<0||x>=n||y>=n) break;
            if (puzzle[x][y]<0) break;
            if (puzzle[x][y]>0) {cnt++; break;}
        }
        if (cnt==1) {id=ind; break;}
    }
    int x=i,y=j;
    while (true)
    {
        x+=dx[id];
        y+=dy[id];
        if (puzzle[x][y]!=0) break;
        puzzle[x][y]=getvalue(id,puzzle[i][j]);
    }
}
pair<int,int> findsingle(std::vector<std::vector<int>>& puzzle,int n,int m)
{
    for (int i=0;i<n;++i)
        for (int j=0;j<m;++j)
    {
        if (check(puzzle,n,m,i,j)) {return make_pair(i,j);}
    }
    return make_pair(-1,-1);
}
bool bak(std::vector<std::vector<int>>& puzzle,int n,int m)
{
    while (true)
    {
        auto r=findsingle(puzzle,n,m);
        if (r.first==-1) break;
        fillsingle(puzzle,n,m,r.first,r.second);
    }
    return true;
}
bool solve(std::vector<std::vector<int>>& puzzle)
{
    int n=puzzle.size();
    int m=puzzle[0].size();
    bak(puzzle,n,m);
    return true;
}
