#include <iostream>
#include <vector>
#include "puzzle.h"

using namespace std;
long double tt;
int dx[5]={-1,0,1,0},dy[5]={0,1,0,-1},ram[1001][1001];
void init(int numSubtests, double timeLimit)
{
    tt=timeLimit;
}
bool check(int n,int m,int i,int j)
{
    int cnt=0;
    for (int ind=0;ind<4;++ind)
    {
        int x=i,y=j;
        while (true)
        {
            x+=dx[ind];
            y+=dy[ind];
            if (x<0||y<0||x>=n||y>=n) break;
            if (ram[x][y]<0) break;
            if (ram[x][y]>0) {cnt++; break;}
        }
    }
    if (cnt==1) return 1;
    if (cnt*2==ram[i][j]) {ram[i][j]=2; return 1;}
    return 0;
}
int getvalue(int a,int b)
{
    a=(a+1)%2;
    return -2*a-b;
}
void fillsingle(int n,int m,int i,int j)
{
    int cnt=0;
    int id=0;
    for (int ind=0;ind<4;++ind)
    {
        int x=i,y=j;
        while (true)
        {
            x+=dx[ind];
            y+=dy[ind];
            if (x<0||y<0||x>=n||y>=n) break;
            if (ram[x][y]<0) break;
            if (ram[x][y]>0) {cnt++; break;}
        }
        if (cnt) {cnt=0; id=ind; int x=i,y=j;
    while (true)
    {
        x+=dx[id];
        y+=dy[id];
        if (ram[x][y]!=0) break;
        ram[x][y]=getvalue(id,ram[i][j]);
    }
    ram[x][y]-=ram[i][j];
}
    }
    ram[i][j]=0;

}
pair<int,int> findsingle(int n,int m)
{
    for (int i=0;i<n;++i)
        for (int j=0;j<m;++j)
    {
        if (ram[i][j]<=0) continue;
        if (check(n,m,i,j)) {return make_pair(i,j);}
    }
    return make_pair(-1,-1);
}
bool bak(int n,int m)
{
    while (true)
    {
        auto r=findsingle(n,m);
        if (r.first==-1) break;
        fillsingle(n,m,r.first,r.second);
    }
    return true;
}
bool solve(std::vector<std::vector<int>>& puzzle)
{
    int n=puzzle.size();
    int m=puzzle[0].size();
    for (int i=0;i<n;++i)
        for (int j=0;j<m;++j)
        ram[i][j]=puzzle[i][j];
    bak(n,m);
    for (int i=0;i<n;++i)
        for (int j=0;j<m;++j)
        if (ram[i][j]<0) puzzle[i][j]=ram[i][j];
    return true;
}
