#include <bits/stdc++.h>

using namespace std;

const int mod = 1e8 + 543;

int n, q, maxA;
vector <int> v, elem;
int rec[6][6], a[6][6];

void copyMatrix(int a[][6], const int b[][6])
{
    for(int i = 1; i <= 5; i ++)
        for(int j = 1; j <= 5; j ++)
            a[i][j] = b[i][j];
}

void multiply(int a[][6], const int b[][6])
{
    int c[6][6];
    for(int i = 1; i <= 5; i ++)
    {
        for(int j = 1; j <= 5; j ++)
        {
            c[i][j] = 0;
            for(int k = 1; k <= 5; k ++)
            {
                c[i][j] += (1ll * a[i][k] * b[k][j]) % mod;
                c[i][j] %= mod;
            }

        }
    }

    copyMatrix(a, c);
}

void afis(const int a[][6])
{
    for(int i = 1; i <= 5; i ++)
    {
        for(int j = 1; j <= 5; j ++)
            cout << a[i][j] << " ";
        cout << "\n";
    }
    cout << "\n";
}

void init(int a[][6])
{
    for(int i = 1; i <= 5; i ++)
        for(int j = 1; j <= 5; j ++)
    {
        if(i == j)
            a[i][j] = 1;
        else
            a[i][j] = 0;
    }
}

int logPow(int exp, int ans[][6])
{
    int base[6][6];
    init(ans); copyMatrix(base, rec);
    while(exp)
    {
        if(exp & 1)
            multiply(ans, base);
        multiply(base, base);
        exp /= 2;
    }
}

int findNthElem(int x)
{
    if(x < 0)
        x = 10;
    if(x < 5)
        return x;
//    if(x < maxA)
//        return elem[x];
    logPow(x - 4, a);
//    afis(a);
    int nr = 0;
    for(int i = 1; i <= 5; i ++)
    {
        nr += (5 - i) * a[i][1];
        nr %= mod;
    }
    return nr;
}

int main()
{
    ios_base :: sync_with_stdio(0);
    cin.tie(0);

    freopen(".in", "r", stdin);
    freopen(".out", "w", stdout);

    cin >> n >> q;
    v.resize(n + 1);

    for(int i = 1; i <= 5; i ++)
        for(int j = 1; j <= 5; j ++)
           rec[i][j] = 0;

    rec[1][1] = 5; rec[1][2] = 1;
    rec[2][1] = 4; rec[2][3] = 1;
    rec[3][1] = 3; rec[3][4] = 1;
    rec[4][1] = 2; rec[4][5] = 1;
    rec[5][1] = 1;

    // sa nu uit sa adaug modul in aint
    for(int i = 1; i <= n; i ++)
    {
        cin >> v[i];
    }

    for(int i = 1; i <= q; i ++)
    {
        int type, l, r;
        cin >> type >> l >> r;
        if(type == 1)
        {
            cout << findNthElem(v[l]) << "\n";
//            cout << aint.query(1, 1, n, l, r) << "\n";
        }
        else
        {
            int value;
            cin >> value;
            v[l] += value;
        }
    }

    return 0;
}
