#include <bits/stdc++.h>

using namespace std;

const long long mod = 1e8 + 543;

long long n, q, maxA;
vector <long long> v, elem;
long long rec[6][6], a[6][6];

void copyMatrix(long long a[][6], const long long b[][6])
{
    for(int i = 1; i <= 5; i ++)
        for(int j = 1; j <= 5; j ++)
            a[i][j] = b[i][j];
}

void multiply(long long a[][6], const long long b[][6])
{
    long long c[6][6];
    for(int i = 1; i <= 5; i ++)
    {
        for(int j = 1; j <= 5; j ++)
        {
            c[i][j] = 0;
            for(int k = 1; k <= 5; k ++)
            {
                c[i][j] += (1ll * a[i][k] * b[k][j]) % mod;
                c[i][j] %= mod;
            }

        }
    }

    copyMatrix(a, c);
}

void afis(const long long a[][6])
{
    for(int i = 1; i <= 5; i ++)
    {
        for(int j = 1; j <= 5; j ++)
            cout << a[i][j] << " ";
        cout << "\n";
    }
    cout << "\n";
}

void init(long long a[][6])
{
    for(int i = 1; i <= 5; i ++)
        for(int j = 1; j <= 5; j ++)
        {
            if(i == j)
                a[i][j] = 1;
            else
                a[i][j] = 0;
        }
}

long long logPow(long long exp, long long ans[][6])
{
    long long base[6][6];
    init(ans);
    copyMatrix(base, rec);
    while(exp)
    {
        if(exp & 1)
            multiply(ans, base);
        multiply(base, base);
        exp /= 2;
    }
}

long long findNthElem(long long x)
{
    assert(x >= 0);
    if(x < 5)
        return x;
    if( x <= 100000)
        return elem[x];
    logPow(x - 4, a);
    long long nr = 0;
    for(int i = 1; i <= 5; i ++)
    {
        nr += ((5 - i) * a[i][1]) % mod;
        nr %= mod;
    }
    return nr;
}

int main()
{
    ios_base :: sync_with_stdio(0);
    cin.tie(0);

    freopen(".in", "r", stdin);
    freopen(".out", "w", stdout);

    cin >> n >> q;
    v.resize(n + 1);
    elem.resize(100001);

    for(int i = 1; i <= 5; i ++)
        for(int j = 1; j <= 5; j ++)
            rec[i][j] = 0;

    rec[1][1] = 5;
    rec[1][2] = 1;
    rec[2][1] = 4;
    rec[2][3] = 1;
    rec[3][1] = 3;
    rec[3][4] = 1;
    rec[4][1] = 2;
    rec[4][5] = 1;
    rec[5][1] = 1;

    // sa nu uit sa adaug modul in aint
    for(int i = 1; i <= n; i ++)
    {
        cin >> v[i];
    }

    for(int i = 1; i <= 4; i ++)
        elem[i] = i;
    for(int i = 5; i <= 100000; i ++)
    {
        elem[i] = 5 * elem[i - 1];
        elem[i] %= mod;
        elem[i] += 4 * elem[i - 2];
        elem[i] %= mod;
        elem[i] += 3 * elem[i - 3];
        elem[i] %= mod;
        elem[i] += 2 * elem[i - 4];
        elem[i] %= mod;
        elem[i] += elem[i - 5];
        elem[i] %= mod;
    }

    for(int i = 1; i <= q; i ++)
    {
        int type, l, r;
        cin >> type >> l >> r;
        if(type == 1)
        {
            cout << findNthElem(v[l]) << "\n";
        }
        else
        {
            long long value;
            cin >> value;
            v[l] += value;
        }
    }

    return 0;
}
