#include <bits/stdc++.h>
#include "ones.h"

using namespace std;
typedef long long ll;

bool hasOnes (int l, int r);

int n, k;

vector <int> answer;
int unknown;

void solve (int l, int r) {
    if (l == r) {
        answer.push_back(l);
        return;
    }
    int mid = (l + r) / 2;
    if (hasOnes(l, mid) == true) {
        unknown += (r - mid);
        solve(l, mid);
        unknown -= (r - mid);
        if ((int) answer.size() == k) {
            return;
        }
        if ((int) answer.size() + unknown - (r - mid) < k
             || hasOnes(mid + 1, r) == true) {
            solve(mid + 1, r);
        }
    } else {
        solve(mid + 1, r);
    }
}


vector <int> guessOnes (int _n, int _k) {
    answer.clear();
    n = _n; k = _k;
//    solve(1, n);
    int i = 0;
    while (k--) {
        int l = i + 1, r = n - k;
        int len = r - l + 1;
        int step = max(1, (int) (len * 0.65 / (k + 1)));
        int p = min(n - k, i + step);
        while (p < n - k && hasOnes(i + 1, p) == false) {
            l = p + 1;
            p = min(n - k, p + step);
        }
        r = p;
        while (l < r) {
            int mid = (l + r) / 2;
//            assert(l <= mid && mid < r);
            if (hasOnes(i + 1, mid) == true) {
                r = mid;
            } else {
                l = mid + 1;
            }
        }
        i = l;
        answer.push_back(i);
    }
    return answer;
}
