#include "ones.h"
#include <bits/stdc++.h>
#define all(x) (x).begin(),(x).end()

using namespace std;
using ll = long long;

// #define int ll
#define sz(x) ((int)(x).size())

using pii = pair<int,int>;
using tii = tuple<int,int,int>;

int query(int l, int r) {
	// cerr << l + 1 << ' ' << r + 1 << '\n';
	return hasOnes(l + 1, r + 1);
}

vector<int> sol;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

void divide(int l, int r, int& k) {
	if(k == 0) return;
	if(!query(l, r)) return;
	if(l == r) {
		k--;
		sol.emplace_back(l + 1);
		return;
	}
	
	int mid = l + r >> 1;
	if(rng() % 2 == 0)
		divide(l, mid, k), 
		divide(mid + 1, r, k);
	else 
		divide(mid + 1, r, k),
		divide(l, mid, k);
		
}

std::vector<int> guessOnes(int n,int k) {
	sol.clear();
	int B = n / k;
	for(int i = 0; i < n;) {
		divide(i, min(n - 1, i + B - 1), k);
		i += B;
		if(k > 0)
			B = n / k;
	}
	return sol;
}
