#include "ones.h"
#include <bits/stdc++.h>
#define all(x) (x).begin(),(x).end()

using namespace std;
using ll = long long;

// #define int ll
#define sz(x) ((int)(x).size())

using pii = pair<int,int>;
using tii = tuple<int,int,int>;

int query(int l, int r) {
	return hasOnes(l, r);
}

vector<int> sol;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

bool findfirst(int l, int r, int &k) {
	if(k == 0) return 0;
	if(!query(l, r)) return 0;
	if(l == r) {
		k--;
		sol.emplace_back(l);
		return 1;
	}
	
	int mid = l + r >> 1;
	if(!findfirst(l, mid, k))
		findfirst(mid + 1, r, k);
	return 1;
}

std::vector<int> guessOnes(int n,int k) {
	sol.clear();
	int B = n / k;
	for(int i = 1; k > 0 && i <= n;) {
		if(findfirst(i, min(n, i + (n - i + 1) / k - 1), k)) {
			i = sol.back() + 1;
		}
		else
			i = i + (n - i) / k;
	}
	return sol;
}
