#include "ones.h"
#include <bits/stdc++.h>
#define all(x) (x).begin(),(x).end()

using namespace std;
using ll = long long;

// #define int ll
#define sz(x) ((int)(x).size())

using pii = pair<int,int>;
using tii = tuple<int,int,int>;

int query(int l, int r) {
    // cerr << l + 1 << ' ' << r + 1 << '\n';
    return hasOnes(l, r);
}

vector<int> sol;

auto cmp = [](pii a, pii b) { return a.second - a.first < b.second - b.first; };

priority_queue<pii, vector<pii>, decltype(cmp)> st(cmp);
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

void divide(int l, int r, int& k) {
    st.emplace(l, r);
    
    auto push = [&](int a, int b) {
        st.emplace(a, b);
    };
    
    while(!st.empty()) {
        auto [l, r] = st.top();
        st.pop();
        if(l == r) {
            sol.emplace_back(l);
            k--;
            continue;
        }
        int mid = l + r >> 1;
        bool a;
        if(a = (query(l, mid)))
            push(l, mid);
        if(!a || (sz(st) < k && query(mid + 1, r)))
            push(mid + 1, r);
    }
    return;
}

std::vector<int> guessOnes(int n,int k) {
    sol.clear();
    divide(1, n, k);
    sort(all(sol));
    return sol;
}
