#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
//ifstream cin("a.in");
//ofstream cout("a.out");
#define  mlc __attribute__((target("avx2"),optimize("O3","unroll-loops")))
int a[200005];
long long mod=1e8+543;
int mat[11000][10][10];
int mm[11000][10][10];
long long ans[10];
mlc void mlt(vector<int> &vec,int pwer)
{
  int i,j;
  for(i=1;i<=5;i++)
  {
    ans[i-1]=0;
    for(j=1;j<=5;j++)
        ans[i-1]+=1ll*vec[j-1]*mat[pwer][i][j];
    ans[i-1]%=mod;
  }
  for(i=0;i<=4;i++)
    vec[i]=ans[i];
}
mlc void multiply(int pw)
{
  int i,j,z;
  long long sum;
  for(i=1;i<=5;i++)
  {
      for(j=1;j<=5;j++)
      {
         sum=0;
         for(z=1;z<=5;z++)
         {
           sum+=1ll*mat[pw-1][i][z]*mat[1][z][j];
         }
         sum%=mod;
         mat[pw][i][j]=sum;
      }
  }
}
mlc void multiplymare(int pw)
{
  int i,j,z;
  long long sum;
  for(i=1;i<=5;i++)
  {
      for(j=1;j<=5;j++)
      {
         sum=0;
         for(z=1;z<=5;z++)
         {
           sum+=1ll*mm[pw-1][i][z]*mm[1][z][j];
         }
         sum%=mod;
         mm[pw][i][j]=sum;
      }
  }
}
long long lz[300005];
int coef[300005][7];
mlc void mltc(int node,int pwer)
{
  int i,j;
  if(pwer==0)
  {
    return;
  }
  for(i=1;i<=5;i++)
  {
    ans[i-1]=0;
    for(j=1;j<=5;j++)
        ans[i-1]+=1ll*coef[node][j-1]*mat[pwer][i][j];
  }
  for(i=0;i<=4;i++)
    coef[node][i]=ans[i]%mod;
}
mlc void mtlcmm(int node,int pwer)
{
  int i,j;
  if(pwer==0)
  {
    return;
  }
  for(i=1;i<=5;i++)
  {
    ans[i-1]=0;
    for(j=1;j<=5;j++)
        ans[i-1]+=1ll*coef[node][j-1]*mm[pwer][i][j];
  }
  for(i=0;i<=4;i++)
    coef[node][i]=ans[i]%mod;
}
mlc void build(int node,int st,int dr)
{
  if(st!=dr)
  {
    int mij=(st+dr)/2;
    build(node*2,st,mij);
    build(node*2+1,mij+1,dr);
    for(int i=0;i<=4;i++)
      coef[node][i]=(coef[node*2][i]+coef[node*2+1][i])%mod;
    return;
  }
  for(int i=0;i<=4;i++)
  {
    coef[node][i]=4-i;
  }
}
mlc void push_lazy(int node,int st,int dr)
{
  if(lz[node]!=0)
  {
    lz[node]=(lz[node]+mod-1)%(mod-1);
    mltc(node,lz[node]%10000);
    mtlcmm(node,lz[node]/10000);
    if(st!=dr)
    {
      lz[node*2]+=lz[node];
      lz[node*2+1]+=lz[node];
    }
    lz[node]=0;
  }
}
mlc void update(int node,int st,int dr,int qst,int qdr,int val)
{
  push_lazy(node,st,dr);
  if(st>dr || st>qdr|| qst>dr ||qst>qdr)
  {
    return ;
  }
  if(qst<=st && dr<=qdr)
  {
    lz[node]=val;
    push_lazy(node,st,dr);
    return;
  }
  int mij=(st+dr)/2;
  update(node*2,st,mij,qst,qdr,val);
  update(node*2+1,mij+1,dr,qst,qdr,val);
  for(int i=0;i<=4;i++)
    coef[node][i]=(coef[node*2][i]+coef[node*2+1][i])%mod;
}
mlc long long qr(int node,int st,int dr,int qst,int qdr)
{
  push_lazy(node,st,dr);
  if(st>dr || st>qdr|| qst>dr ||qst>qdr)
  {
    return 0;
  }
  if(qst<=st && dr<=qdr)
  {
    return coef[node][4];
  }
  int mij=(st+dr)/2;
  return qr(node*2,st,mij,qst,qdr)+qr(node*2+1,mij+1,dr,qst,qdr);
}
mlc signed  main()
{
    int n,i,j,k,l,q;
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin>>n>>q;
    for(i=1;i<=5;i++)
    {
        mat[1][1][i]=6-i;
    }
    mat[1][2][1]=1;
    mat[1][3][2]=1;
    mat[1][4][3]=1;
    mat[1][5][4]=1;
    for(i=2;i<=10000;i++)
    {
        multiply(i);
    }
    for(i=1;i<=5;i++)
    {
      for(j=1;j<=5;j++)
      {
        mm[1][i][j]=mat[10000][i][j];
      }
    }
    for(i=2;i<=10001;i++)
    {
      multiplymare(i);
    }
    build(1,1,n);
    for(i=1;i<=n;i++)
    {
      cin>>a[i];
      a[i]=(a[i]+mod-1)%(mod-1);
      update(1,1,n,i,i,a[i]);
    }
    int tip,r;
    int x;
    for(i=1;i<=q;i++)
    {
      cin>>tip;
      if(tip==2)
      {
        cin>>l>>r>>x;
        x=(x+mod-1)%(mod-1);
        update(1,1,n,l,r,x);
      }
      else
      {
        cin>>l>>r;
        cout<<qr(1,1,n,l,r)%mod<<'\n';
      }
    }
    return 0;
}
