#include <iostream>

using namespace std;

const int NMAX = 1e6;
const int MOD = 1e8 + 543;

int a[NMAX + 1];
int x[NMAX + 1];
int sp[NMAX + 1];


int main(){

    int n, q;
    cin >> n >> q;

    x[0] = 0;
    x[1] = 1;
    x[2] = 2;
    x[3] = 3;
    x[4] = 4;

    for(int i = 5; i <= NMAX; i++){
        for(int j = 1; j <= 5; j++){
            (x[i] += (x[i - j] * (5 - j + 1)) % MOD) %= MOD;
        }
    }

    for(int i = 1; i <= n; i++){
        cin >> a[i];
        sp[i] = (sp[i - 1] + x[a[i]]) % MOD;
    }

    while(q--){
        int t, l, r;
        cin >> t >> l >> r;
        cout << (sp[r] + MOD - sp[l - 1]) % MOD << '\n';
    }

    return 0;
}
