#include <iostream>
#include <vector>
#include <assert.h>
#include <algorithm>
using namespace std;

bool hasOnes(int l,int r);

vector<int> ans;
int nn;

void solve(int l, int r, int maxy) {
  if (l == r) {
    ans.push_back(l);
    return;
  }

  if (maxy == 1) {
    int mij = (l + r) / 2;
    if (hasOnes(l, mij))
      solve(l, mij, maxy);
    else
      solve(mij + 1, r, maxy);
  } else {
    /// impart in k + 1 secvente
    int len, k = maxy + 1, a = l, q, cnt = 0;
    len = (r - l + 1) / (maxy + 1);
    vector<pair<int, int>> has;
    for (int i = 0; i < k; i++) {
      q = min(a + len - 1, nn);
      if (i == k - 1)
        q = r;

     // cout << a << ' ' << q << '\n';
     // assert(a <= q);
      if (hasOnes(a, q)) {
        has.push_back({a, q});
        cnt++;
      }

      a = q + 1;
    }
   // cout <<"MAXY SI CNT\n";
   // cout << maxy << ' ' << cnt << '\n';

    for (auto &x : has) {
    //  cout << "incerc sa rezolv: " << x.first << ", " << x.second << " si cnt = " << min(maxy - cnt + 1, x.second - x.first + 1) << '\n';
      solve(x.first, x.second, min(maxy - cnt + 1, x.second - x.first + 1));
    }
  }
}


vector<int> guessOnes(int n,int k) {
  nn = n;
  ans.clear();
  solve(1, n, k);
  sort(ans.begin(), ans.end());
  return ans;
}

/*
10 5 1
1 3 7 4 6

1 0 1 1 0 1 1 0 0 0
*/

/*
10 3 1
2 6 10

0 1 0 0 0 1 0 0 0 1
*/
