#include "ones.h"
using namespace std;

void get(vector<int>& res, int l, int r) {
	if (l == r) {
		res.push_back(l);
		return;
	}
	int m = (l + r) / 2;
	if (hasOnes(l, m)) {
		get(res, l, m);
		if (hasOnes(m + 1, r)) {
			get(res, m + 1, r);
		}
	}
	else {
		get(res, m + 1, r);
	}
}

void get(vector<int>& res, int l, int r, int k) {
	if (k == 0) return;
	if (l == r) {
		res.push_back(l);
		return;
	}
	int length = r-l+1, pref, f = (length + k - 1)/k;
	pref = res.size();
	if (hasOnes(l, l + f)) get(res, l, l + f);
	k -= res.size() - pref;
	get(res, l + f + 1, r, k);
}

vector<int> guessOnes(int n, int k) {
	vector<int> res;
	get(res, 1, n, k);
	return res;
}