#include <bits/stdc++.h>
#include <chrono>
#include "ones.h"

#define ll long long
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define watch(x) cout << (#x) << " : " << x << '\n'
#define boost ios_base::sync_with_stdio(0);

using namespace std;
using namespace chrono;

mt19937 rnd(steady_clock::now().time_since_epoch().count());

const int LOG = 17;

vector <int> ans;

void solve(int l, int r) {
    if (l == r) {
        ans.push_back(l);
        return;
    }
    if (l + 1 == r) {
        if (hasOnes(l, l))
            ans.push_back(l);
        if (l != r && hasOnes(r, r))
            ans.push_back(r);
        return;
    }

    int len3 = (r - l + 1) / 3;

    vector < pair<int, int> > seg;
    seg.push_back(make_pair(l, l + len3 - 1));
    seg.push_back(make_pair(l + len3, r - len3));
    seg.push_back(make_pair(r - len3 + 1, r));

    shuffle(all(seg), rnd);

    bool x = hasOnes(seg[0].first, seg[0].second);
    bool y = hasOnes(seg[1].first, seg[1].second);

    if (x)
        solve(seg[0].first, seg[0].second);

    if (y)
        solve(seg[1].first, seg[1].second);

    if ((!x && !y) || hasOnes(seg[2].first, seg[2].second))
        solve(seg[2].first, seg[2].second);

}

vector <int> guessOnes(int n, int k) {
    ans.clear();
    solve(1, n);
    sort(all(ans));
    return ans;
}
