#include <bits/stdc++.h>
#include <chrono>
#include "ones.h"

#define ll long long
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define watch(x) cout << (#x) << " : " << x << '\n'
#define boost ios_base::sync_with_stdio(0);

using namespace std;
using namespace chrono;

mt19937 rnd(steady_clock::now().time_since_epoch().count());

const int LOG = 17;

vector <int> ans;

void solve(int l, int r) {
    if (l == r) {
        ans.push_back(l);
        return;
    }

    int m = (l + r) >> 1;

    if (rnd() & 1) {
        if (hasOnes(l, m)) {
            solve(l, m);
            if (hasOnes(m + 1, r))
                solve(m + 1, r);
        } else {
            solve(m + 1, r);
        }
    } else {
        if (hasOnes(m + 1, r)) {
            solve(m + 1, r);
            if (hasOnes(l, m))
                solve(l, m);
        } else {
            solve(l, m);
        }
    }

}

const int B = 1000;

vector <int> guessOnes(int n, int k) {
    ans.clear();
    for (int i = 1; i <= n; i += B) {
        int r = min(i + B - 1, n);
        if (!hasOnes(i, r))
            continue;
        solve(i, r);
    }
    sort(all(ans));
    return ans;
}
