#include <bits/stdc++.h>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx,avx2")

#define ll long long
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define watch(x) cout << (#x) << " : " << x << '\n'
#define boost ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

using namespace std;

const int MOD = 1e8 + 543;

ll a[6][6], rs[6][6], res[6][6], ini[6][1];

void add_self(ll& a, ll b) {
    a = (a + b) % MOD;
}

void binpow(ll n) {
    int sz = 6;
    for (int i = 0; i < sz; i++)
        for (int j = 0; j < sz; j++)
            res[i][j] = (i == j);

    while (n) {
        if (n & 1) {
            for (int i = 0; i < sz; i++)
                for (int j = 0; j < sz; j++)
                    for (int k = 0; k < sz; k++)
                        add_self(rs[i][j], (res[i][k] * a[k][j]) % MOD);
            for (int i = 0; i < sz; i++)
                for (int j = 0; j < sz; j++)
                    res[i][j] = rs[i][j], rs[i][j] = 0;
        }
        for (int i = 0; i < sz; i++)
            for (int j = 0; j < sz; j++)
                for (int k = 0; k < sz; k++)
                    add_self(rs[i][j], a[i][k] * a[k][j]);
        for (int i = 0; i < sz; i++)
            for (int j = 0; j < sz; j++)
                a[i][j] = rs[i][j], rs[i][j] = 0;
        n >>= 1;
    }
}

//void print(matrix a) {
//    for (int i = 0; i < (int)a.size(); i++, cout << '\n')
//        for (int j = 0; j < (int)a[0].size(); j++)
//            cout << a[i][j] << ' ';
//}

unordered_map <int, ll> was;

ll get(ll idx) {
    if (idx <= 4)
        return idx;

    if (was.count(idx))
        return was[idx];

    a[0][0] = 0; a[0][1] = 1; a[0][2] = 0; a[0][3] = 0; a[0][4] = 0; a[0][5] = 0;
    a[1][0] = 0; a[1][1] = 0; a[1][2] = 1; a[1][3] = 0; a[1][4] = 0; a[1][5] = 0;
    a[2][0] = 0; a[2][1] = 0; a[2][2] = 0; a[2][3] = 1; a[2][4] = 0; a[2][5] = 0;
    a[3][0] = 0; a[3][1] = 0; a[3][2] = 0; a[3][3] = 0; a[3][4] = 1; a[3][5] = 0;
    a[4][0] = 1; a[4][1] = 2; a[4][2] = 3; a[4][3] = 4; a[4][4] = 5; a[4][5] = 0;
    a[5][0] = 0; a[5][1] = 0; a[5][2] = 0; a[5][3] = 0; a[5][4] = 1; a[5][5] = 1;
    binpow(idx - 4);

    for (int i = 0; i < 6; i++)
        for (int j = 0; j < 1; j++)
            for (int k = 0; k < 6; k++)
                add_self(rs[i][j], (res[i][k] * ini[k][j]) % MOD);

    ll ans = rs[4][0];

    for (int i = 0; i < 6; i++)
        for (int j = 0; j < 6; j++)
            rs[i][j] = 0;

    return was[idx] = ans;
}

const int N = 1e6 + 128;
ll pref[N], x[N];
ll v[N];
int pt = 0;

void solve() {
    x[0] = 0;
    x[1] = 1;
    x[2] = 2;
    x[3] = 3;
    x[4] = 4;
    pt = 5;

    for (int i = 0; pt < N; i++) {
        ll val = x[i];
        add_self(val, 2 * x[i + 1]);
        add_self(val, 3 * x[i + 2]);
        add_self(val, 4 * x[i + 3]);
        add_self(val, 5 * x[i + 4]);
        x[pt++] = (val);
    }
//
//    for (auto& c : x)
//        cout << c << ' ';
//    cout << '\n';
//
//    for (int c = 0; c < (int)x.size(); c++) {
//        cout << get(c) << ' ';
//    }
//    cout << '\n';
    int n, q;
    cin >> n >> q;

    for (int i = 1; i <= n; i++)
        cin >> v[i], pref[i] = (x[v[i]] + pref[i - 1]) % MOD;

    while (q--) {
        int type, l, r;
        cin >> type >> l >> r;
        assert(l == r);

        if (type == 1) {
            cout << (pref[r] - pref[l - 1] + MOD) % MOD << '\n';
//            ll times = v[l] / MOD;
//            v[l] -= MOD * times;
//            cout << (get(v[l] + times)) << '\n';
        } else {
            ll val;
            cin >> val;
            v[l] += val;
        }
    }
}

main() {
    boost;
    ini[0][0] = 0;
    ini[1][0] = 1;
    ini[2][0] = 2;
    ini[3][0] = 3;
    ini[4][0] = 4;
    ini[5][0] = 0;

//    const int x = 24;
//
//    for (int c = 0; c < 5; c++) {
//        watch(get(x + c * MOD));
//        watch(get(x + c));
//    }
//    return 0;

//    set <int> cyclic;
//    for (int i = 0; i < 1e5; i++) {
//        int val = get(i);
//        if (cyclic.count(val)) {
//            watch(i);
//        }
//        cyclic.insert(val);
//    }
//    return 0;

    solve();
    return 0;
}
