#pragma once
#include"ones.h"
#include<bits/stdc++.h>

using namespace std;
int K;
vector<int> positions;

void DNC(int l, int r){
    if (positions.size() == K)
        return;
    assert(l <= r);
    int rez = hasOnes(l, r);
    if (rez == 0) return;
    if (l == r){
        positions.push_back(l);
        return;
    }
    int mid = (l + r) / 2;
    DNC(l, mid);
    DNC(mid + 1, r);
}

void decomp(int l, int r){
    //cerr << "New entry of decomp: l and r: " << l << " " << r << "\n";
    if (positions.size() == K)
        return;
    assert(l <= r);
    if (l == r){
        positions.push_back(l);
        return;
    }
    int len = r - l + 1;
    int slen = (int)((double)sqrt(len));
    int i = l, rez;
    for (i = l; i + slen - 1 <= r; i+= slen){
        rez = hasOnes(i, i + slen - 1);
        //cerr << "in for: l: " << l << " r: " << r << " slen: " << slen << " i: " << i << " rez: " << rez << "\n";
        if (rez) decomp(i, i + slen - 1);
    }
    if (i <= r){
        rez = hasOnes(i, r);
        if (rez) decomp(i, r);
    } 
}
    

vector<int> guessOnes(int n,int k){
    positions.clear();
    K = k;
    /*for (int i = 1; i <= n && positions.size() < k; ++i)
        if (hasOnes(i, i)) positions.push_back(i);*/
    //cerr << hasOnes(1,5) << "\n";
    //DNC(1, n);
    decomp(1, n);
    return positions;
}