#include<bits/stdc++.h>
using namespace std;
const int maxn = (1<<17), mod = 1e8 + 543;
int x [(int)(1e6+10)];
int t [maxn * 2];
int a [maxn];
int n, q;

inline void speed(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

inline void init_positive(){
    x[0] = 0;
    x[1] = 1;
    x[2] = 2;
    x[3] = 3;
    x[4] = 4;
    for (int i = 5; i <= (int)(1e6); ++i){
        /*x[i] = (5 * x[i - 1]) % mod;
        x[i] = (x[i] + 4 * (x[i - 2]) % mod) % mod;
        x[i] = (x[i] + 3 * (x[i - 3]) % mod) % mod;
        x[i] = (x[i] + 2 * (x[i - 4]) % mod) % mod;
        x[i] = (x[i] + x[i - 5]) % mod;*/
        x[i] = 5 * x[i - 1];
        x[i] += 4 * x[i - 2];
        x[i] += 3 * x[i - 3];
        x[i] += 2 * x[i - 4];
        x[i] += x[i - 5];
        x[i] %= mod;
    }
}

inline void compute(int i){
    t[i] = (t[i * 2] + t[i * 2 + 1]) % mod;
}

void build_tree(int i, int l, int r){
    if (l == r){
        t[i] = x[a[l]];
        return;
    }
    int mid = (l + r) / 2;
    build_tree(i * 2, l, mid);
    build_tree(i * 2 + 1, mid + 1, r);
    compute(i);
}

int query(int i, int l, int r, int ql, int qr){
    if (l == ql && r == qr){
        return t[i];
    }
    int mid = (l + r) / 2;
    if (qr <= mid)
        return query(i * 2, l, mid, ql, qr);
    if (mid < ql)
        return query(i * 2 + 1, mid + 1, r, ql, qr);
    return (query(i * 2, l, mid, ql, mid) +
            query(i * 2 + 1, mid + 1, r, mid + 1, qr));
}

inline void update(int i, int l, int r, int pos, int value){
    if (l == r){
        a[l] += value;
        t[i] = x[a[l]];
        return;
    }
    int mid = (l + r) / 2;
    if (pos <= mid)
        update(i * 2, l, mid, pos, value);
    else update(i * 2 + 1, mid + 1, r, pos, value);
    compute(i);
}

int main(){
    speed();
    init_positive();
    //cout << x[7] << "\n";
    cin >> n >> q;
    for (int i = 1; i <= n; ++i)
        cin >> a[i];
    init_positive();
    build_tree(1, 1, n);
    //cerr << "build tree done\n";
    while(q){
        int t, l, r;
        cin >> t >> l >> r;
        if (t == 1) cout << query(1, 1, n, l, r) << "\n";
        else if (t == 2){
            int value;
            cin >> value;
            update(1, 1, n, l, value);
        }
        else exit(1);
        //cerr << "answered query\n";
        --q;
    }
    return 0;
}