#include "puzzle.h"
#include <bits/stdc++.h>

using namespace std;

const int maxn = 48;

struct Isle
{
    int x,y,e;
    Isle(){};
    Isle(int xi, int yi, int ei)
    {
        x = xi;
        y = yi;
        e = ei;
    }
};

double LIMIT;
int r,c,a[maxn][maxn];
Isle dir[4] = {{-1,0,0},{0,1,0},{1,0,0},{0,-1,0}};

bool stana;
int sz;
vector<Isle>v;

vector<vector<int> > puzz;

void init(int numSubtests, double timeLimit)
{
    LIMIT = timeLimit;
}

bool cmp1(Isle p1, Isle p2)
{
    return p1.e > p2.e;
}

bool can_tek(Isle beg, int idx)
{
    if(idx==0)
    {
        for(int i = beg.x - 1; i >= 0; i--)
        {
            if(puzz[i][beg.y]<0) return false;
            if(puzz[i][beg.y]>0) return true;
        }
    }
    if(idx==1)
    {
        for(int j = beg.y + 1; j < c; j++)
        {
            if(puzz[beg.x][j]<0) return false;
            if(puzz[beg.x][j]>0) return true;
        }
    }
    if(idx==2)
    {
        for(int i = beg.x + 1; i < r; i++)
        {
            if(puzz[i][beg.y]<0) return false;
            if(puzz[i][beg.y]>0) return true;
        }
    }
    if(idx==3)
    {
        for(int j = beg.y - 1; j >= 0; j--)
        {
            if(puzz[beg.x][j]<0) return false;
            if(puzz[beg.x][j]>0) return true;
        }
    }
    return false;
}

bool paint(Isle beg, int idx, int ch)
{
    if(idx%2) ch = -2*ch;
    else if(ch) ch = -2*ch + 1;
    if(idx==0)
    {
        for(int i = beg.x - 1; i >= 0; i--)
        {
            if(puzz[i][beg.y])
            {
                if(puzz[i][beg.y]<0)
                    for(int z = beg.x - 1; z > i; z--) puzz[z][beg.y] = 0;

                return puzz[i][beg.y]>0;
            }
            puzz[i][beg.y] = ch;
        }
    }
    if(idx==1)
    {
        for(int j = beg.y + 1; j < c; j++)
        {
            if(puzz[beg.x][j])
            {
                if(puzz[beg.x][j]<0)
                    for(int z = beg.y + 1; z < j; z++) puzz[z][beg.y] = 0;

                return puzz[beg.x][j]>0;
            }
            puzz[beg.x][j] = ch;
        }
    }
    if(idx==2)
    {
        for(int i = beg.x + 1; i < r; i++)
        {
            if(puzz[i][beg.y])
            {
                if(puzz[i][beg.y]<0)
                    for(int z = beg.x + 1; z < i; z++) puzz[z][beg.y] = 0;

                return puzz[i][beg.y]>0;
            }
            puzz[i][beg.y] = ch;
        }
    }
    if(idx==3)
    {
        for(int j = beg.y - 1; j >= 0; j--)
        {
            if(puzz[beg.x][j])
            {
                if(puzz[beg.x][j]<0)
                    for(int z = beg.y - 1; z > j; z--) puzz[z][beg.y] = 0;

                return puzz[beg.x][j]>0;
            }
            puzz[beg.x][j] = ch;
        }
    }
    return false;
}

void erase_paint(Isle beg, int idx, int ch)
{
    if(idx%2) ch = -2*ch;
    else if(ch) ch = -2*ch + 1;
    if(idx==0)
    {
        for(int i = beg.x - 1; i >= 0; i--)
        {
            if(puzz[i][beg.y]==ch) puzz[i][beg.y] = 0;
            else return;
        }
    }
    if(idx==1)
    {
        for(int j = beg.y + 1; j < c; j++)
        {
            if(puzz[beg.x][j]==ch) puzz[beg.x][j] = 0;
            else return;
        }
    }
    if(idx==2)
    {
        for(int i = beg.x + 1; i < r; i++)
        {
            if(puzz[i][beg.y]==ch) puzz[i][beg.y] = 0;
            else return;
        }
    }
    if(idx==3)
    {
        for(int j = beg.y - 1; j >= 0; j--)
        {
            if(puzz[beg.x][j]==ch) puzz[beg.x][j] = 0;
            else return;
        }
    }
}
void rec(int pos)
{
    Isle tek = v[pos];
    for(int i = 0; i < 4; i++) ///romove izlishni e-ta;
    {
        Isle nb;
        nb.x = tek.x + dir[i].x;
        nb.y = tek.y + dir[i].y;
        if(nb.x>=0&&nb.x<r&&nb.y>=0&&nb.y<c&&puzz[nb.x][nb.y])
        {
            if((-puzz[nb.x][nb.y])%2==i%2)
            {
                if(puzz[nb.x][nb.y]>-3) tek.e -= 1;
                else tek.e -= 2;
            }
        }
    }
    int f[4] = {0,0,0,0};
    for(int i = 0; i < 4; i++) f[i] = can_tek(tek,i);
    vector<int>v;
    for(int i = 0; i < 4; i++)
    {
        if(!f[i]) continue;
        v.push_back(i);
    }
    while(true)
    {
        int sum = 0;
        for(int idx : v)
        {
            f[idx] = rand()%3;
            sum += f[idx];
        }
        if(sum==tek.e)
        {
            bool moga = true;
            for(int z = 0; z < v.size(); z++)
            {
                int idx = v[z];
                moga &= paint(tek,idx,f[idx]);
                if(!moga)
                {
                    for(int zi = 0; zi < z; zi++)
                    {
                        idx = v[zi];
                        erase_paint(tek,idx,f[idx]);
                    }
                    break;
                }
            }
            if(moga)
            {
                if(pos<sz-1) rec(pos+1);
                if(!stana)
                {
                    for(int zi = 0; zi < v.size(); zi++)//////////////////////
                    {
                        int idx = v[zi];
                        erase_paint(tek,idx,f[idx]);
                    }
                }
                else return;
            }
        }
    }
}

bool solve(std::vector<std::vector<int>>& puzzle)
{
    if(timePassed()>LIMIT) return false;
    ///CLEAR VSICHKOOoooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
    v.clear();
    stana = false;
    puzz = puzzle;
    ///
    r = puzzle.size();
    for(int i = 0; i < r; i++)
    {
        c = puzzle[i].size();
        for(int j = 0; j < c; j++)
        {
            a[i][j] = puzzle[i][j];
            if(a[i][j]) v.push_back({i,j,a[i][j]});
        }
    }
    sort(v.begin(),v.end(),cmp1);
    sz = v.size();
    rec(0);
    return true;
}
