#include <bits/stdc++.h>
#define MAXN 100008
#define MAXX 1000008
#define endl '\n'
using namespace std;
int a[MAXN];
const int mod = 100000543;
int x[MAXX];

void build()
{
    for (int i=0; i<=MAXX-6; i++)
    {
        int p = i + (i & -i);
        if ( p <= MAXX-6 )
        {
            x[p] = ((long long)x[p] + x[i]) % mod;
          //  //cerr << "x[" << p << "]=" << x[p] << endl;
            x[p] %= mod;
        }
    }
}
int sum(int i)
{
    int ret = 0;
    while ( i > 0 )///
    {
        ret = ((long long)ret + x[i] ) % mod;
   //    ret %= mod;
        i -= (i & -i);
    }
    return ret;
}
int query(int l, int r)
{
    //cerr <<  sum(r) << " "<< sum(l-1) << endl;
    int ret = sum(r) - sum(l-1);
    if ( ret < 0 ) ret += mod;
    return ret;
}
int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, q;
    cin >> n >> q;
    for (int i=1; i<=n; i++) cin >> a[i];

    x[0] = 0;
    x[1] = 1;
    x[2] = 2;
    x[3] = 3;
    x[4] = 4;

    for (int k=5; k<MAXX-5; k++)
    {
        x[k] = ( 5LL*x[k-1] + 4*x[k-2] + 3*x[k-3] + 2*x[k-4] + 1*x[k-5]) % mod;;
      //  x[k] %= mod;
    }
    build();

    for (int h=0; h<q; h++)
    {
        int t, l, r;
        cin >> t >> l >> r;
        int ans = query(a[l], a[r]);
        cout << ans << endl;
    }
}
/**
1 1
1
1 1 1
--------------
1
*/
