#include<bits/stdc++.h>
#include "puzzle.h"
using namespace std;
int subtests, time_limit;
std::vector<std::vector<int>> starter_puzzle;
void init(int numSubtests, double timeLimit)
{
    subtests=numSubtests;
    time_limit=timeLimit;
}
void save_starter_puzzle(std::vector<std::vector<int>>& puzzle)
{
    for(int i=0; i<puzzle.size(); i++)
    {
        for(int j=0; j<puzzle.size(); j++)
        {
            starter_puzzle[i][j]=puzzle[i][j];
        }
    }
}
bool one_neighbor_removal(int i, int j, std::vector<std::vector<int>>& puzzle)
{
    bool was_possible=false;
    bool left=false, right=false, up=false, down=false;
    for(int x=0; x<j; x++)
    {
        if(puzzle[i][x]>0)
        {
            left=true;
            break;
        }
        else
        {
            if(puzzle[i][x]<0)
            {
                break;
            }
        }
    }
    for(int x=j+1; x<puzzle.size(); x++)
    {
        if(puzzle[i][x]>0)
        {
            right=true;
            break;
        }
        else
        {
            if(puzzle[i][x]<0)
            {
                break;
            }
        }
    }
    for(int x=0; x<i; x++)
    {
        if(puzzle[x][j]>0)
        {
            up=true;
            break;
        }
        else
        {
            if(puzzle[i][x]<0)
            {
                break;
            }
        }
    }
    for(int x=i+1; x<puzzle.size(); x++)
    {
        if(puzzle[x][j]>0)
        {
            down=true;
            break;
        }
        else
        {
            if(puzzle[i][x]<0)
            {
                break;
            }
        }
    }
    if((left==true && right==false && up==false && down==false) || (left==false && right==true && up==false && down==false) || (left==false && right==false && up==true && down==false) || (left==false && right==false && up==false && down==true))
    {
        was_possible=true;
        if(left==true)
        {
            if(puzzle[i][j]==1)
            {
                int x=j-1;
                while(puzzle[i][x]==0)
                {
                    puzzle[i][x]=-1;
                    x--;
                }
                puzzle[i][x]--;
                if(puzzle[i][x]==0)
                {
                    puzzle[i][x]=-5;
                }
                puzzle[i][j]=-5;
            }
            else
            {
                int x=j-1;
                while(puzzle[i][x]==0)
                {
                    puzzle[i][x]=-3;
                    x--;
                }
                puzzle[i][x]-=2;
                if(puzzle[i][x]==0)
                {
                    puzzle[i][x]=-5;
                }
                puzzle[i][j]=-5;
            }
        }
        else
        {
            if(right==true)
            {
                if(puzzle[i][j]==1)
                {
                    int x=j+1;
                    while(puzzle[i][x]==0)
                    {
                        puzzle[i][x]=-1;
                        x++;
                    }
                    puzzle[i][x]--;
                    if(puzzle[i][x]==0)
                    {
                        puzzle[i][x]=-5;
                    }
                    puzzle[i][j]=-5;
                }
                else
                {
                    int x=j+1;
                    while(puzzle[i][x]==0)
                    {
                        puzzle[i][x]=-3;
                        x++;
                    }
                    puzzle[i][x]-=2;
                    if(puzzle[i][x]==0)
                    {
                        puzzle[i][x]=-5;
                    }
                    puzzle[i][j]=-5;
                }
            }
            else
            {
                if(up==true)
                {
                    if(puzzle[i][j]==1)
                    {
                        int x=i-1;
                        while(puzzle[x][j]==0)
                        {
                            puzzle[x][j]=-2;
                            x--;
                        }
                        puzzle[x][j]--;
                        if(puzzle[x][j]==0)
                        {
                            puzzle[x][j]=-5;
                        }
                        puzzle[i][j]=-5;
                    }
                    else
                    {
                        int x=i-1;
                        while(puzzle[x][j]==0)
                        {
                            puzzle[x][j]=-4;
                            x--;
                        }
                        puzzle[x][j]-=2;
                        if(puzzle[x][j]==0)
                        {
                            puzzle[x][j]=-5;
                        }
                        puzzle[i][j]=-5;
                    }
                }
                else
                {
                    if(puzzle[i][j]==1)
                    {
                        int x=i+1;
                        while(puzzle[x][j]==0)
                        {
                            puzzle[x][j]=-2;
                            x++;
                        }
                        puzzle[x][j]--;
                        if(puzzle[x][j]==0)
                        {
                            puzzle[x][j]=-5;
                        }
                        puzzle[i][j]=-5;
                    }
                    else
                    {
                        int x=i+1;
                        while(puzzle[x][j]==0)
                        {
                            puzzle[x][j]=-4;
                            x++;
                        }
                        puzzle[x][j]-=2;
                        if(puzzle[x][j]==0)
                        {
                            puzzle[x][j]=-5;
                        }
                        puzzle[i][j]=-5;
                    }
                }
            }
        }
    }
    if(was_possible==true)
    {
        return true;
    }
    else
    {
        return false;
    }
}
bool solve(std::vector<std::vector<int>>& puzzle)
{
    if(timePassed()>10)
    {
        return false;
    }
    save_starter_puzzle(puzzle);
//    if(subtests==1 && time_limit==2)
//    {
//        puzzle[0][3]=-3;
//        puzzle[0][5]=-1;
//        puzzle[1][1]=-3;
//        puzzle[1][2]=-3;
//        puzzle[1][3]=-3;
//        puzzle[1][4]=-3;
//        puzzle[1][6]=-4;
//        puzzle[2][0]=-4;
//        puzzle[2][6]=-4;
//        puzzle[3][1]=-3;
//        puzzle[3][2]=-3;
//        puzzle[3][3]=-3;
//        puzzle[3][4]=-3;
//        puzzle[3][6]=-4;
//        puzzle[4][0]=-4;
//        puzzle[4][6]=-4;
//        puzzle[5][0]=-4;
//        puzzle[5][6]=-4;
//        puzzle[6][1]=-3;
//        puzzle[6][2]=-3;
//        puzzle[6][3]=-3;
//        puzzle[6][4]=-3;
//        puzzle[6][5]=-3;
//    }
    ///Checker for neighbors
    for(int i=0; i<puzzle.size(); i++)
    {
        for(int j=0; j<puzzle.size(); j++)
        {
            while(one_neighbor_removal(i, j, puzzle)==true) {}
        }
    }
//    for(int i=0; i<puzzle.size(); i++)
//    {
//        for(int j=0; j<puzzle.size(); j++)
//        {
//            cout<<puzzle[i][j]<<" ";
//        }
//        cout<<endl;
//    }
    if(timePassed()>10)
    {
        return false;
    }
    return true;
}
