#include <iostream>

using namespace std;

const int mod = 1e8 + 543;
const int MAXN = 100005;
long long dp[MAXN], n;
long long a[MAXN], q;

speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void read()
{
    cin >> n >> q;

    for(int i = 0 ; i < n ; i++)
    {
        cin >> a[i];
    }
}

void fillDp()
{
    dp[0] = 0;

    for(int i = 1 ; i < 5 ; i++)
    {
        dp[i] = i;
    }

    for(int i = 5 ; i <= MAXN; i++)
    {
        dp[i] = (dp[i - 5]) + ((2 * dp[i - 4]) % mod) + ((3 * dp[i - 3]) % mod) + ((4 * dp[i - 2]) % mod) + ((5 * dp[i - 1]) % mod);
    }
}

void readQueries()
{
    int type;
    int l ,r, val;

    for(int i = 1 ; i < q ; i++)
    {
        cin >> type;

        if(type == 1)
        {
            cin >> l >> r;
            cout << dp[l] <<endl;
        }

        if(type == 2)
        {
            cin >> l >> r >> val;
        }

    }
}

int main()
{
    speed();
    read();
    fillDp();
    readQueries();
}
