#include<bits/stdc++.h>
#include "puzzle.h"
using namespace std;

double tl;
int ns;
void init(int numSubtests, double timeLimit)
{
    ns = numSubtests;
    tl = timeLimit;
}
vector < pair <int, int> > g;
vector < pair <int, int> > pairs;

int all, p[50], paths[10][10], id[10][10];

vector < int > u[50];
int used[50];
void dfs(int beg)
{
    used[beg] = 1;
    int nb;
    for (int i = 0; i < u[beg].size(); ++ i)
    {
        nb = u[beg][i];
        if(!used[nb])
            dfs(nb);
    }
}

bool get_around(int xx, int yy)
{
    int curr = 0;
    if(xx > 0)curr += paths[xx-1][yy];
    if(yy > 0)curr += paths[xx][yy-1];
    curr += paths[xx][yy+1];
    curr += paths[xx+1][yy];
    return (curr == -paths[xx][yy]);
}
int flag = 0;
void check()
{
    for (int i = 0; i < g.size(); ++ i)
        used[i] = 0;
    for (int i = 0; i < all; ++ i)
        u[i].clear();

    int xx1, yy1, xx2, yy2;
    for (int i = 0 ; i < pairs.size(); ++ i)
    {
        int id1 = pairs[i].first;
        xx1 = g[id1].first;
        yy1 = g[id1].second;

        int id2 = pairs[i].second;
        xx2 = g[id2].first;
        yy2 = g[id2].second;
        u[id1].push_back(id2);
        u[id2].push_back(id1);
        if(xx1 == xx2)
        {
            for (int j = yy1+1; j < yy2; ++ j)
            {
                if(paths[xx1][j] <= -1)
                    paths[xx1][j] += p[i];
                if(paths[xx1][j] > 2)return;
            }
        }
        else
        {
            for (int j = xx1+1; j < xx2; ++ j)
            {
                if(paths[j][yy1] <= -1)
                    paths[j][yy1] += p[i];
                if(paths[j][yy1] > 2)return;
            }
        }
    }
    dfs(0);
    for (int i = 0; i < all; ++ i)
        if(!used[i])return;
    for (int i = 0; i < g.size(); ++ i)
        if(!get_around(g[i].first, g[i].second))return;

    flag = 0;
    for (int i = 0; i < pairs.size(); ++ i)
    {
        if(!p[i])continue;
        int id1 = pairs[i].first;
        xx1 = g[id1].first;
        yy1 = g[id1].second;

        int id2 = pairs[i].second;
        xx2 = g[id2].first;
        yy2 = g[id2].second;
        if(xx1 == xx2)
        {
            for (int j = yy1+1; j < yy2; ++ j)
            {
                if(p[i] == 1)paths[xx1][j] = -1;
                else paths[xx1][j] = -3;
            }
        }
        else
        {
            for (int j = xx1+1; j < xx2; ++ j)
            {
                 if(p[i] == 1)paths[j][yy1] = -2;
                else paths[j][yy1] = -4;
            }
        }
    }
    flag = 1;
}
void gen(int pos, int cnt)
{
    if(pos == pairs.size() && cnt > g.size()-1)
    {
        check();
        return;
    }
    if(pairs.size() - pos + cnt < g.size()-1)return;
    p[pos] = 1;
    if(flag)return;
    gen(pos+1, cnt+1);
    p[pos] = 0;
     if(flag)return;
    gen(pos+1, cnt);
    p[pos] = 2;
    gen(pos+1, cnt+1);
}
vector < vector < int > > anss;
bool solve(std::vector<std::vector<int>>& puzzle)
{
    g.clear();
    pairs.clear();

    memset(paths, 0, sizeof(paths));
    memset(id, 0, sizeof(id));
    for (int i = 0; i < 7; ++ i)
    {
        for (int j = 0; j < 7; ++ j)
        {
            if(!puzzle[i][j])continue;
            g.push_back(make_pair(i, j));
            id[i][j] = g.size()-1;
            paths[i][j] = -puzzle[i][j];
        }
    }
    all = g.size();
    for (int i = 0; i < 7; ++ i)
    {
        int last = -1;
        for (int j = 0; j < 7; ++ j)
        {
            if(puzzle[i][j])
            {
                if(last == -1)last = id[i][j];
                else
                {
                    pairs.push_back(make_pair(last, id[i][j]));
                    last = id[i][j];
                }
            }
        }
    }
    for (int j = 0; j < 7; ++ j)
    {
        int last = -1;
        for (int i = 0; i < 7; ++ i)
        {
            if(puzzle[i][j])
            {
                if(last == -1)last = id[i][j];
                else
                {
                    pairs.push_back(make_pair(last, id[i][j]));
                    last = id[i][j];
                }
            }
        }
    }
    gen(0, 0);
    for(int i = 0; i < 7; ++ i)
    {
        for (int j = 0; j < 7; ++ j)
        {
            if(!puzzle[i][j])puzzle[i][j] = paths[i][j];
        }
    }
    return true;
}
