#include <iostream>
#include "ones.h"
#include <vector>
using namespace std;

vector <int> ans;

void binary(int l, int r)
{
    if(l==r)
    {
        if(hasOnes(l, r))
        {
            ans.push_back(l);
        }
        return;
    }
    else
    {
        int mid=(l+r)/2;
        if(hasOnes(l, mid))
        {
            binary(l, mid);
        }
        if(hasOnes(mid+1, r))
        {
            binary(mid+1, r);
        }
    }
}

vector<int> guessOnes(int n, int k)
{
    ans.clear();
    int p=n/k;
    for(int i=1; i<=n; i+=p)
    {
        if(hasOnes(i, min(i+p-1, n)))
        {
            binary(i, min(i+p-1, n));
        }
    }
    return ans;
}
