#include <bits/stdc++.h>
#include "ones.h"
#ifdef __LOCAL__
    #include "Lgrader.cpp"
#endif // __LOCAL__
#define endl '\n'

using namespace std;

struct State
{
    int l, r;
    State(){}
    State(int l, int r)
        :l(l), r(r){}
};
vector<int> guessOnes(int n, int k)
{

    vector <int> res;

    queue <State> q;
    q.push({1, n});

    while (!q.empty())
    {
        int l = q.front().l;
        int r = q.front().r;

        bool f = hasOnes(l, r);
        q.pop();


        if (l == r)
        {
            if (f == true)
                res.push_back(l);

            continue;
        }

        if (f == 0)
            continue;

        int length = sqrt((r-l+1));

        for (int i = 0; i <= length; i++)
        {
            int newLeft = l + i*length;
            int newRight = newLeft+length-1;

            if (i == length)
                newRight = r;


            if (newLeft > newRight)
                continue;

            q.push({newLeft, newRight});

            //cout << newLeft << " " << newRight << endl;
        }

    }

    sort(res.begin(), res.end());

    return res;
}

/*
19000 3 1
1 97 1323
*/
