#include <iostream>

using namespace std;

#define MAX_N 1000003
#define M 100000543
#define ll long long

int n, q;
ll a[MAX_N];
ll sum[MAX_N];

ll vals[MAX_N];

ll x(int index) {
    if (index < 5) return index;
    if (vals[index]) return vals[index];
    vals[index] = (5*x(index-1) + 4*x(index-2) + 3*x(index-3) + 2*x(index-4) + 1*x(index-5)) % M;
    return vals[index];
}

int main() {
    cin >> n >> q;

    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    for (int i = 1; i <= n; i++) {
        sum[i] = sum[i - 1] + x(a[i - 1]);
        sum[i] %= M;
//        cout << sum[i] << endl;
    }

    for (int i = 0; i < q; i++) {
        int type, l, r, value;
        cin >> type >> l >> r;
        l--; r--;
        if (type == 1) {
            ll val = sum[r + 1] - sum[l];
            if (val < 0) val += M;
            cout << val << endl;
        }
        else if (type == 2) {
            cin >> value;
            if (l == r) {
                a[l] += value;
            }
        }
    }
}

