#include "ones.h"

#include <iostream>
#include <vector>

using namespace std;

void find_ones(int l, int r, int k, vector<int> &result) {
    int mid = (l + r) / 2;

    if (hasOnes(l, mid)) {
        if (l == mid) {
            result.push_back(l);
            
            return;
        }

        find_ones(l, mid, k, result);
    }

    if ((int) result.size() == k) {
        return;
    }

    if (hasOnes(mid + 1, r)) {
        if (mid + 1 == r) {
            result.push_back(r);

            return;
        }

        find_ones(mid + 1, r, k, result);
    }
}

vector<int> guessOnes(int n, int k) {
    vector<int> result;

    find_ones(1, n, k, result);

    return result;
}
