#include "ones.h"

#include <iostream>
#include <vector>
#include <algorithm>
#include <chrono>
#include <random>

using namespace std;

const auto p1 = std::chrono::system_clock::now();
const auto p2 = p1.time_since_epoch().count();

mt19937 generator(p2);

void find_ones(int l, int r, int k, vector<int> &result) {
    if (l > r) {
        return;
    }

    int decider = uniform_int_distribution<int>(0, 44)(generator);

    int pivot = decider % 45 == 46 ? uniform_int_distribution<int>(l, r -1)(generator) : ((l + r) / 2);

    if (hasOnes(pivot + 1, r)) {
        if (pivot + 1 == r) {
            result.push_back(r);
        } else { 
            find_ones(pivot + 1, r, k, result);
        }
    }

    if ((int) result.size() == k) {
        return;
    }

    if (hasOnes(l, pivot)) {
        if (l == pivot) {
            result.push_back(l);
        } else {
            find_ones(l, pivot, k, result);
        }
    }
}

void find_ones_pivots(int l, int r, vector<int> &pivots, int k, vector<int> &result) {
    if (l > r) {
        return;
    }

    int mid = (l + r) / 2;

    
}

vector<int> guessOnes(int n, int k) {
    vector<int> result;

    int intervalSIze = n / (k / 4);

    vector<int> pivots;

    for (int i = 1; i <= n; i += intervalSIze) {
        pivots.push_back(i);
    }

    if (pivots.back() != n) {
        pivots.push_back(n);
    }

    if (hasOnes(1, 1)) {
        result.push_back(1);
    }

    for (int i = 1; i < (int) pivots.size() and (int) result.size() < k; ++i) {
        if (hasOnes(pivots[i], pivots[i])) {
            result.push_back(pivots[i]);
        }

        int l = pivots[i - 1] + 1;
        int r = pivots[i] - 1;

        if (l > r) {
            continue;
        }

        if (l == r) {
            if (hasOnes(l, r)) {
                result.push_back(l);
            }

            continue;
        }

        find_ones(l, r, k, result);
    }

    sort(result.begin(), result.end());

    return result;
}