#include<iostream>
#include<vector>
#include<string>
#include<cmath>
#include<algorithm>
#include "ones.h"
//#include"Lgrader.cpp"
using namespace std;


bool hasOnes(int l, int r);

int firstOne(int l, int r){
    int mid = (l+r)/2;
    if(hasOnes(l, l)){
        return l;
    }
    while(l!=r-1){
        if(hasOnes(l, mid)){
            r = mid;
        }else{
            l = mid;
        }
        mid = (r+l)/2;
    }
    return r;
}
int lastOne(int l, int r){
    int mid = (l+r)/2;
    if(hasOnes(r, r)){
        return r;
    }
    while(l!=r-1){
        if(hasOnes(mid, r)){
            l = mid;
        }else{
            r = mid;
        }
        mid = (r+l)/2;
    }
    return l;
}

vector<int> guessOnes(int n, int k){
    vector<int> seq;
    int dokudeSme = 1;
    int dokudeSmeNazad = n;
    for(int i=0; i<k/2; i++){
        int fo = firstOne(dokudeSme, dokudeSmeNazad);
        int lo = lastOne(dokudeSme, dokudeSmeNazad);
        //cout<<fo<<"\n";
        seq.push_back(fo);
        seq.push_back(lo);
        dokudeSme = fo+1;
        dokudeSmeNazad = lo-1;
    }
    sort(seq.begin(), seq.end());
    return seq;
}

/*
10
4
2
1 3 5 9
3 4 5 6
*/
/*int main(){

    return 0;
}*/
