#include<bits/stdc++.h>
using namespace std;
const int M = 100000543;
int N, Q;
int masiv[1000000];
int indexi[1000000];
int calc(int n)
{
    if(n < 5)
    {
        return n;
    }
    int A = 0;
    int B = 1;
    int C = 2;
    int D = 3;
    int E = 4;
    int ans = 0;
    for(int i = 5; i < n; i++)
    {
        ans = (((((5 * E)% M + 4 * D) % M + 3 * C) % M + B) % M + A) % M;
        A = B;
        B = C;
        C = D;
        D = E;
        E = ans;
    }
    return ans;
}
int build(int nach, int kraj, int index)
{
    if(nach == kraj)
    {
        masiv[index] = calc(indexi[nach]);
        return masiv[index];
    }
    int mid = (nach + kraj - 1) / 2;
    masiv[index] = (build(nach, mid, mid*2) + build(mid+1, kraj, mid*2+1)) % M;
    return masiv[index];
}
int query(int l, int r, int nach, int kraj, int index)
{
    if(nach <= l and nach <= r and kraj <= r and kraj >= l)
    {
        return masiv[index];
    }
    int mid = (nach + kraj - 1) / 2;
    return (query(l, r, nach, mid, mid*2) + query(l, r, mid+1, kraj, mid*2+1)) % M;
}
int update(int l, int r, int nach, int kraj, int index, int v)
{
    if(nach == kraj)
    {
        indexi[nach] += v;
        masiv[index] = calc(indexi[nach]);
        return masiv[index];
    }
    if(kraj < l or nach > r)
    {
        return masiv[index];
    }
    int mid = (nach + kraj - 1) / 2;
    masiv[index] = (update(l, r, nach, mid, mid*2, v) + update(l, r, mid+1, kraj, mid*2+1, v)) % M;
    return masiv[index];
}
int main ()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> N >> Q;
    for(int i = 1; i <= N; i++)
    {
        cin >> indexi[i];
    }
    build(1, N, 0);
    for(int i = 0; i < Q; i++)
    {
        int A, l, r, v;
        cin >> A >> l >> r;
        if(A == 1)
        {
            cout << query(l, r, 1, N, 0) << endl;
        }
        else
        {
            cin >> v;
            update(l, r, 1, N, 0, v);
        }
    }
    return 0;
}

