#pragma GCC Optimize("Ofast")
#pragma GCC target("sse4")
#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN=1e5+5;
const int MOD=1e8+543;

struct Query
{
    int type;
    int l,r;
    int val;
};

int sum(int a,int b)
{
    int c=a+b;
    if(c>=MOD) c-=MOD;
    return c;
}

int mult(int a,int b)
{
    return (long long)a*b%MOD;
}

int n,q;
int a[MAXN];
int b[MAXN];
Query qr[2*MAXN];
bool used[MOD+5];
int x[6];
map<int,int> m;

int main()
{
ios::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);

cin>>n>>q;
for(int i=1;i<=n;i++)
{
    cin>>a[i];
    used[a[i]]=1;
    b[i]=a[i];
}

for(int i=0;i<q;i++)
{
    cin>>qr[i].type>>qr[i].l>>qr[i].r;
    if(qr[i].type==2) cin>>qr[i].val;
}

for(int i=0;i<q;i++)
{
    if(qr[i].type==2)
    {
        b[qr[i].l]+=qr[i].val;
        if(b[qr[i].l]<0) b[qr[i].l]+=(MOD-1);
        b[qr[i].l]%=(MOD-1);
        used[b[qr[i].l]]=1;
    }
}

x[0]=0;
x[1]=1;
x[2]=2;
x[3]=3;
x[4]=4;
for(int i=0;i<5;i++)
    if(used[i]) m[i]=i;
for(int i=5;i<MOD-1;i++)
{
    x[5]=5*x[4]+4*x[3]+3*x[2]+2*x[1]+x[0];
    x[5]%=MOD;
    if(used[i]) m[i]=x[5];
    for(int j=0;j<5;j++) x[j]=x[j+1];
}

for(int i=0;i<q;i++)
{
    if(qr[i].type==1)
    {
        cout<<m[a[qr[i].l]]<<endl;
    }
    else
    {
        a[qr[i].l]+=qr[i].val;
        if(a[qr[i].l]<0) a[qr[i].l]+=MOD-1;
        a[qr[i].l]%=(MOD-1);
    }
}

return 0;
}
