#include <bits/stdc++.h>
#include "Lgrader.cpp"
#include "ones.h"
using namespace std;

//int main(){
//    srand(time(0));
//    for(int i = 0; i < 10; i++){
//        cout << rand()%2 << ' ';
//    }
//}

vector<int> recurse(int left, int right, int k){
    if(left == right){
        if(hasOnes(left, right)){
            return {left};
        }else{
            return {};
        }
    }
    if(k == 0){ return {}; }

    vector<int> ret;

    int mid = (left+right)/2;
    bool bleft = hasOnes(left, mid), bright = hasOnes(mid+1, right);
    if(bleft){
        vector<int> call = recurse(left, mid, k);
        k -= call.size();
        for(int i : call){ ret.push_back(i); }
    }
    if(bright){
        vector<int> call = recurse(mid+1, right, k);
        for(int i : call){ ret.push_back(i); }
    }
    return ret;
}

vector<int> guessOnes(int n, int k){
    vector<int> loc;
    int lastIdx = 1;
    int step = k;
    for(; (lastIdx+step-1) <= n; lastIdx += step){
        if(hasOnes(lastIdx, lastIdx+step-1)){
            loc.push_back(lastIdx);
        }
    }
    vector<int> ret;
    for(int i = 0; i < loc.size(); i++){
        vector<int> call = recurse(loc[i], loc[i]+step-1, step);
        for(int idx : call){
            ret.push_back(idx);
        }
    }
    vector<int> call = recurse(lastIdx, n, step);
    for(int idx : call){
        ret.push_back(idx);
    }
    return ret;
}
