#include "ones.h"
#include <bits/stdc++.h>
using namespace std;

const int MAXN = 1e5 + 3;
bool used[MAXN];
vector <int> ans;
int K;

void rec(int L, int R)
{
    if (L >= R)
        return;

    int bucket = max(1, (R - L + 1) / 3);

    for (int i = L; i <= R; i += bucket)
    {
        int x = min(i + bucket - 1, R);
        if (K > 0 && hasOnes(i, x))
        {
            if (i == x && !used[i])
            {
                ans.push_back(i);
                used[i] = 1;
                K--;
            }
            else rec(i, x);
        }
    }
}

std::vector<int> guessOnes(int n, int k)
{
    K = k;

    memset(used, 0, sizeof(used));
    ans.clear();
    rec(1, n);

    if (ans.size() > k) exit(1);

    sort(ans.begin(), ans.end());
    return ans;
}
