#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXN = 1e5 + 3;
const int MAXA = 1e6 + 3;
const int mod = 1e8 + 543;
long long a[MAXN];
long long maxValue = 0;
long long x[MAXA+1] = {0, 1, 2, 3, 4};
long long pref[MAXN];
int n, q;

long long getX(int k)
{
    if (x[k]) return x[k];
    if (k >= 0 && k <= 4) return k;

    long long ret = 0;

    ret += 5LL * getX(k-1); ret %= mod;
    ret += 4LL * getX(k-2); ret %= mod;
    ret += 3LL * getX(k-3); ret %= mod;
    ret += 2LL * getX(k-4); ret %= mod;
    ret += 1LL * getX(k-5); ret %= mod;

    return x[k] = ret;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> q;
    for (int i = 1; i <= n; i++)
    {
        cin >> a[i];
        maxValue = max(maxValue, a[i]);
    }

    getX(maxValue);

    for (int i = 1; i <= n; i++)
    {
        pref[i] = x[a[i]] + pref[i-1];
    }

    for (int i = 0; i < q; i++)
    {
        int type, l, r;
        cin >> type >> l >> r;

        if (type == 1)
        {
            cout << (pref[r] - pref[l-1] + mod) % mod << endl;
        }
    }

    return 0;
}
