#include<bits/stdc++.h>
#define MAXN 100001
#define MOD 100000543
#define int long long
using namespace std;
long long n, q, ind[MAXN];
unordered_map<long long, long long> ans;
struct Matrix
{
    long long mat[60][5][5], aux[5][5];
    void init1()
    {
        mat[0][0][0] = 5;mat[0][0][1] = 4;mat[0][0][2] = 3;mat[0][0][3] = 2;mat[0][0][4] = 1;
        mat[0][1][0] = 1;mat[0][1][1] = 0;mat[0][1][2] = 0;mat[0][1][3] = 0;mat[0][1][4] = 0;
        mat[0][2][0] = 0;mat[0][2][1] = 1;mat[0][2][2] = 0;mat[0][2][3] = 0;mat[0][2][4] = 0;
        mat[0][3][0] = 0;mat[0][3][1] = 0;mat[0][3][2] = 1;mat[0][3][3] = 0;mat[0][3][4] = 0;
        mat[0][4][0] = 0;mat[0][4][1] = 0;mat[0][4][2] = 0;mat[0][4][3] = 1;mat[0][4][4] = 0;
    }
    void init()
    {
        aux[0][0] = 5;aux[0][1] = 4;aux[0][2] = 3;aux[0][3] = 2;aux[0][4] = 1;
        aux[1][0] = 1;aux[1][1] = 0;aux[1][2] = 0;aux[1][3] = 0;aux[1][4] = 0;
        aux[2][0] = 0;aux[2][1] = 1;aux[2][2] = 0;aux[2][3] = 0;aux[2][4] = 0;
        aux[3][0] = 0;aux[3][1] = 0;aux[3][2] = 1;aux[3][3] = 0;aux[3][4] = 0;
        aux[4][0] = 0;aux[4][1] = 0;aux[4][2] = 0;aux[4][3] = 1;aux[4][4] = 0;
    }
    void buildMat()
    {
        for(int i = 1; i < 60; i ++)
        {
            this->mulAux(i);
        }
    }
    void mulMat(int dim)
    {
        long long answer[5][5] = {{0, 0, 0 ,0 ,0},{0, 0, 0 ,0 ,0},{0, 0, 0 ,0 ,0},{0, 0, 0 ,0 ,0},{0, 0, 0 ,0 ,0}};
        for(int i = 0; i < 5; i ++)
        {
            for(int j = 0; j < 5; j ++)
            {
                for(int k = 0; k < 5; k ++)
                {
                    answer[i][j] = (answer[i][j] + (aux[i][k] * mat[dim][k][j]) % MOD) % MOD;
                }
            }
        }
        for(int i = 0; i < 5; i ++)
        {
            for(int j = 0; j < 5; j ++)
            {
                aux[i][j] = answer[i][j];
            }
        }
    }
    void mulAux(long long dim)
    {
        for(int i = 0; i < 5; i ++)
        {
            for(int j = 0; j < 5; j ++)
            {
                for(int k = 0; k < 5; k ++)
                {
                    mat[dim][i][j] = (mat[dim][i][j] + (mat[dim - 1][i][k] * mat[dim - 1][k][j]) % MOD) % MOD;
                }
            }
        }
    }
}m;
void update(long long k)
{
    if(ans[k] || k == 0) return;
    long long HH = k;
    m.init();
    k -= 5;
    int pw = 0;
    while(k)
    {
        if(k & 1)
        {
            m.mulMat(pw);
        }
        pw ++;
        k /= 2;
    }
    ans[HH] = (m.aux[0][0] * 4 + m.aux[0][1] * 3 + m.aux[0][2] * 2 + m.aux[0][3]) % MOD;
}
void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n>>q;
    for(int i = 0; i < n; i ++)
    {
        cin>>ind[i];
        update(ind[i]);
    }
    for(int i = 0; i < q; i ++)
    {
        int t, l, r, d;
        cin>>t>>l>>r;
        l --;
        r --;
        if(t == 1)
        {
            update(ind[l]);
            cout<<ans[ind[l]]<<'\n';
        }
        else
        {
            cin>>d;
            ind[l] += d;
        }
    }
}
signed main()
{
    ans[0]=0;ans[1]=1;ans[2]=2;ans[3]=3;ans[4]=4;
    m.init1();
    m.buildMat();
    read();
    return 0;
}
/*
1 3
1
1 1 1
2 1 1 6
1 1 1
*/
