#include<bits/stdc++.h>
#define MAXN 100002
using namespace std;
long long n,q,a[MAXN],aa[MAXN];
struct query{
    long long l,r,value,type;
};
long long m[1000001];
query qs[2*MAXN];
long long tree[4*MAXN];
long long mod=100000543;
void build(long long curr,long long l,long long r){
    if(l==r){
        tree[curr]=m[a[l]];
        return;
    }
    long long mid=(l+r)/2;
    build(curr*2,l,mid);
    build(curr*2+1,mid+1,r);
    tree[curr]=(tree[curr*2]+tree[curr*2+1])%mod;
}
void update(long long curr,long long l,long long r,long long ql,long long st){
    if(ql==l && l==r){
        a[l]+=st;
        tree[curr]=m[a[l]];
        return;
    }
    long long mid=(l+r)/2;
    if(mid>=ql) update(curr*2,l,mid,ql,st);
    else if(mid+1<=ql) update(curr*2+1,mid+1,r,ql,st);
    tree[curr]=(tree[curr*2]+tree[curr*2+1])%mod;
}
long long ans(long long curr,long long l,long long r,long long ql,long long qr){
    if(ql<=l && r<=qr){
        return tree[curr];
    }
    long long mid=(l+r)/2;
    long long st=0;
    if(mid>=ql) st+=ans(curr*2,l,mid,ql,qr);
    else if(mid+1<=qr) st+=ans(curr*2+1,mid+1,r,ql,qr);
    return st%mod;
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    long long mx=-mod;
    cin>>n>>q;
    for(long long i=0;i<n;i++){
        cin>>a[i];
        aa[i]=a[i];
        mx=max(mx,a[i]);
    }
    for(long long i=0;i<q;i++){
        long long type,l,r;
        cin>>type>>l>>r;
        qs[i].l=l;
        qs[i].r=r;
        qs[i].type=type;
        l--;
        if(type==2){
            long long val;
            cin>>val;
            qs[i].value=val;
            aa[l]+=val;
            mx=max(mx,aa[l]);
        }
    }
    long long st[5],ind=0,sum=10,rlsum=40;
    for(long long i=0;i<=mx;i++){
        if(i<5) st[ind]=i;
        else{
            long long cur=st[ind];
            st[ind]=rlsum;
            rlsum=(rlsum+mod-sum+5*rlsum)%mod;
            sum=(sum+mod-cur+st[ind])%mod;
        }
        m[i]=st[ind];
        ind++;
        if(ind==5) ind=0;
    }
    build(1,0,n);
    for(long long i=0;i<q;i++){
        if(qs[i].type==1){
            cout<<ans(1,0,n,qs[i].l-1,qs[i].r-1)<<"\n";
        }else{
            update(1,0,n,qs[i].l-1,qs[i].value);
        }
    }
    return 0;
}

