#include "ones.h"
#include <bits/stdc++.h>

using namespace std;

vector<int> ans;

int firstOne(int from, int to)
{
    int l = from;
    int r = to;

    while (l <= r)
    {
        int mid = (l + r) / 2;

        if (hasOnes(from, mid) == false)
        {
            l = mid + 1;
        }
        else
        {
            r = mid - 1;
        }
    }

    return l;
}

int lastOne(int from, int to)
{
    int l = from;
    int r = to;

    while (l <= r)
    {
        int mid = (l + r) / 2;

        if (hasOnes(mid, to) == true)
        {
            l = mid + 1;
        }
        else
        {
            r = mid - 1;
        }
    }

    return r;
}

void dnc(int l, int r, int k)
{
    if (l > r)
    {
        return;
    }

    if (ans.size() == k || hasOnes(l, r) == false)
    {
        return;
    }

    int first = firstOne(l, r);
    int last = lastOne(first + 1, r);

    ans.push_back(first);

    if (first == last)
    {
        return;
    }

    ans.push_back(last);

    if (ans.size() == k)
    {
        return;
    }

    //cout << "on " << l << " " << r << " :: " << first << " " << last << endl;

    ++first;
    --last;

    if (first > last)
    {
        return;
    }

    int len = last - first + 1;

    int BLOCK_SIZE = len / (k - int(ans.size()));

    if (BLOCK_SIZE == 0)
    {
        int mid = (first + last) / 2;

        dnc(first, mid, k);
        dnc(mid + 1, last, k);

        return;
    }

    int cntBlocks = (len - 1) / BLOCK_SIZE + 1;

    for (int i = 1; i <= cntBlocks; ++i)
    {
        int from = first + (i - 1) * BLOCK_SIZE;
        int to = min(last, from + BLOCK_SIZE - 1);
        dnc(from, to, k);
    }
}

vector<int> guessOnes(int n, int k)
{
    ans.clear();

    dnc(1, n, k);

    sort(ans.begin(), ans.end());

    /*for (auto pos : ans)
    {
        cout << pos << ' ';
    }

    cout << endl;*/

    return ans;
}
