#include "ones.h"
#include <bits/stdc++.h>

using namespace std;

vector<int> ans;

int firstOne(int from, int to)
{
    int l = from;
    int r = to;

    while (l <= r)
    {
        int mid = (l + r) / 2;

        if (hasOnes(from, mid) == false)
        {
            l = mid + 1;
        }
        else
        {
            r = mid - 1;
        }
    }

    return l;
}

int lastOne(int from, int to)
{
    int l = from;
    int r = to;

    while (l <= r)
    {
        int mid = (l + r) / 2;

        if (hasOnes(mid, to) == true)
        {
            l = mid + 1;
        }
        else
        {
            r = mid - 1;
        }
    }

    return r;
}


void dnc(int l, int r, int k)
{
    if (l > r)
    {
        return;
    }

    if (ans.size() == k || hasOnes(l, r) == false)
    {
        return;
    }

    int first = firstOne(l, r);
    int last = lastOne(first + 1, r);;

    //cout << l << " " << r << " :: " << first << " " << last << endl;

    ans.push_back(first);

    if (first != last)
    {
        ans.push_back(last);
    }
    else
    {
        return;
    }

    ++first;
    --last;

    int fr1 = firstOne(first, last);
    int sc1 = lastOne(fr1 + 1, last);

    if (fr1 > last)
    {
        return;
    }

    int mid = (first + last) / 2;

    if (abs(mid - fr1) < abs(mid - sc1))
    {
        mid = fr1;
    }
    else
    {
        mid = sc1;
    }

    ans.push_back(mid);

    dnc(first, mid - 1, k);
    dnc(mid + 1, last, k);
}

vector<int> guessOnes(int n, int k)
{
    ans.clear();
    dnc(1, n, k);
    sort(ans.begin(), ans.end());
    return ans;
}
