#include <bits/stdc++.h>

using namespace std;

const int maxn = 1000005;
const long long mod = 1e8 + 543;

int n, q;

int a[maxn];

long long seq[maxn];
long long pref[maxn];

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> q;

    for (int i = 1; i <= n; ++i)
    {
        cin >> a[i];
    }

    seq[0] = 0;
    seq[1] = 1;
    seq[2] = 2;
    seq[3] = 3;
    seq[4] = 4;

    for (int i = 5; i <= 1000000; ++i)
    {
        seq[i] = (5 * seq[i - 1] + 4 * seq[i - 2] + 3 * seq[i - 3] + 2 * seq[i - 4] + seq[i - 5]) % mod;
    }

    for (int i = 1; i <= 1000000; ++i)
    {
        pref[i] = pref[i - 1] + seq[a[i]];

        if (pref[i] >= mod)
        {
            pref[i] -= mod;
        }
    }

    while (q--)
    {
        int t, l, r;
        cin >> t >> l >> r;

        long long ans = pref[r] - pref[l - 1];
        if (ans < 0) ans += mod;

        cout << ans << "\n";
    }

    return 0;
}
