#include "ones.h"
#include <iostream>

std::vector <int> guessOnes(int n, int k)
{
    std::vector <int> sol;
    sol.reserve(k);

    int from = 1;
    while (sol.size() < k)
    {
        int bucketSize = (n + 1 - from) / (1.5 * (k - sol.size()));

        int pw = 0;
        while ((1 << pw) < bucketSize) pw++;
        bucketSize = (1 << pw) - 1;

        int to = std::min(n, from + bucketSize + 1);
        if (!hasOnes(from, to))
        {
            from = to + 1;
            continue;
        }

        int l = from - 1, r = to, mid;
        while (l < r - 1)
        {
            mid = (l + r) / 2;
            if (!hasOnes(from, mid)) l = mid;
            else r = mid;
        }

        sol.push_back(r);
        from = r + 1;
    }

    return sol;
}