#include "ones.h"
#include <vector>
#include <iostream>
#include <utility>
#include <algorithm>
#include <random>
#include <iomanip>
#include <numeric>
#include <cstring>
#include <bits/stdc++.h>
using namespace std;

#define out( x ) #x << " = " << x << "  "

#ifndef LOCAL
#define cerr if( false ) cerr
#endif

typedef long long ll;
typedef long double ld;

const int MAX_N = 1e6 + 42;
const int mod = 1e9 + 7;


static const int N = 1e5 + 3;

static int n, k, n_tests;
static int input[N];

static long long number_of_queries;
bool hasOnes(int l,int r)
{
	cerr << out( l ) << out( r ) << endl;
    number_of_queries++;

    if(1>l || l>n || 1>r || r>n || l>r)
    {
        std::cout << "Your program made an invalid query." << std::endl;
        exit(0);
    }

    return input[r] != input[l-1];
}

std::vector<int> guessOnes(int n, int k){
	std::vector< int > nas;
	bool state = hasOnes;
	int ind = 1;
	while( ind <= n ){
		cerr << out( state ) << out( ind ) << endl;
		if( state ){
			if( hasOnes( ind, ind ) ){
			       	nas.push_back( ind );
			}else state ^= 1;
			ind ++;
		}else{

			int l = ind-1, r = n +1;
			while( l != r-1 ){
				int m = ( l + r ) >> 1;
				if( hasOnes( ind, m ) ) r = m;
				else l = m;
			}

			ind = l +1;
			state ^= 1;
		}
	}

	for( auto j : nas ) cerr << j << " ";
	cerr << endl;

	return nas;
}