#include "ones.h"
#include <vector>
#include <iostream>
#include <utility>
#include <algorithm>
#include <random>
#include <iomanip>
#include <numeric>
#include <cstring>
#include <bits/stdc++.h>
using namespace std;

#define out( x ) #x << " = " << x << "  "

#ifndef LOCAL
#define cerr if( false ) cerr
#endif

typedef long long ll;
typedef long double ld;

const int MAX_N = 1e6 + 42;
const int mod = 1e9 + 7;


static const int N = 1e5 + 3;

static int n, k, n_tests;
static int input[N];



mt19937 gen( 420 );
int randNum( int lb, int ub ){
	std::uniform_int_distribution< int > dist( lb, ub );
	return dist( gen );
}

std::vector<int> guessOnes(int n, int k){
	std::vector< int > nas;

	std::vector< int > indLeft( n );
	std::iota( indLeft.begin(), indLeft.end(), 1 );

	while( !indLeft.empty() ){
		int R = randNum( 0, indLeft.size()-1 );
		int currInd = indLeft[R];
		if( hasOnes( currInd, currInd ) ){
			nas.push_back( currInd );
			//auto it = find( indLeft.begin(), indLeft.end(), indLeft[R] );
			cerr << " rem " << out( indLeft[R] ) << endl;
			//if( it != indLeft.end () ) indLeft.erase( it );
			std::swap( indLeft[R], indLeft[indLeft.size()-1] );
			indLeft.pop_back();
		}else{
			int l = currInd-1, r = n +1;
			while( l != r-1 ){
				int m = ( l + r ) >> 1;
				if( hasOnes( currInd, m ) ) r = m;
				else l = m;
			}

			for( int j=currInd ; j <= l ; j++ ){
				auto it = find( indLeft.begin(), indLeft.end(), j );
				cerr << " rem " << out( j ) << endl;
				if( it != indLeft.end() ) indLeft.erase( it );
			}
		}

		for( auto j : indLeft ) cerr << j << " ";
		cerr << endl;
		if( nas.size() >= k ) break;
	}

	std::sort( nas.begin(), nas.end() );

	for( auto j : nas ) cerr << j << " ";
	cerr << endl;

	return nas;
}
