#include "ones.h"
#include <vector>
#include <iostream>
#include <utility>
#include <algorithm>
#include <random>
#include <iomanip>
#include <numeric>
#include <cstring>
#include <bits/stdc++.h>
using namespace std;

#define out( x ) #x << " = " << x << "  "

#ifndef LOCAL
#define cerr if( false ) cerr
#endif

typedef long long ll;
typedef long double ld;

const int MAX_N = 1e6 + 42;
const int mod = 1e9 + 7;



static const int N = 1e5 + 3;

static int n, k, n_tests;
static int input[N];



mt19937 gen( 159 );
int randNum( int lb, int ub ){
    std::uniform_int_distribution< int > dist( lb, ub );
    return dist( gen );
}

bool use[MAX_N];
std::vector<int> guessOnes(int n, int k){


    for( int i=0 ; i <= n ; i++ ) use[i] = false;

    std::vector< int > nas;

    std::vector< int > indLeft( n );
    std::iota( indLeft.begin(), indLeft.end(), 1 );
    std::shuffle( indLeft.begin(), indLeft.end(), gen );

    //while( !indLeft.empty() ){
    std::set< int > remInd;
    int left = n;
    int add = ( n - k ) / k;
    for( int i=0 ; i < n ; i++ ){
        if( ( n - i ) + nas.size() == k ){
            for( int j=i ; j < n ; j++ ) nas.push_back( indLeft[j] );
            break;
        }

	if( left + nas.size() == k ){
		cerr << " anansko " << endl;
		for( int j=1 ; j <= n ; j++ ) if( !use[j] ) nas.push_back( j );
		break;
	}

        int currInd = indLeft[i];
        if( use[currInd] ) continue;

        cerr <<  out( currInd ) << endl;
        if( hasOnes( currInd, currInd ) ){
            cerr << " ONE " << endl;
            nas.push_back( currInd );
            use[currInd] = true;
	    if( !use[currInd] ) left --;
            remInd.insert( currInd );
        }else{
            cerr << " BS " << endl;
            int l = currInd-1, r = n + 1;
            auto it = remInd.lower_bound( currInd );
            if( it != remInd.end() ){
                r = *it;
            }

	    if( hasOnes( currInd, std::min( n, currInd + add ) ) ) r = std::min( n +1, currInd + add );

            while( l != r-1 ){
                int m = ( l + r ) >> 1;
                if( hasOnes( currInd, m ) ) r = m;
                else l = m;
            }

            cerr << " add " << out( l + 1 ) << endl;
            if( !use[l+1] and l+1 <= n ){
		left --;
                use[l+1] = true;
                if( l+1 <= n ) nas.push_back( l+1 );
            }

            remInd.insert( l +1 );

            cerr << " rem " << out( currInd ) << out( l ) << endl;
            for( int j=currInd ; j <= l ; j++ ){
		if( !use[j] ) left --;
                use[j] = true;
            }


            l = 0; r = currInd + 1;
            it = remInd.lower_bound( currInd );
            if( it == remInd.end() or it == remInd.begin() ) l = 0;
            else{
                       it = prev( it );
                l = *it;
            }
	    if( hasOnes( std::max( 1, currInd - add ), currInd ) ) l = std::max( 0, currInd - add );
            while( l != r-1 ){
                int m = ( l + r) >> 1;
                if( hasOnes( m, currInd ) ) l = m;
                else r = m;
            }

            cerr << " add " << out( l ) << endl;
            if( !use[l] and l > 0 ){
		left --;
                use[l] = true;
                if( l > 0 ) nas.push_back( l );
            }
            remInd.insert( l );

            cerr << " rem " << out( r ) << out( currInd ) << endl;
            for( int j=r ; j <= currInd ; j ++ ){
		if( !use[j] ) left --;
                use[j] = true;
            }

        }

        if( nas.size() >= k ) break;
    }

    std::sort( nas.begin(), nas.end() );

    for( auto j : nas ) cerr << j << " ";
    cerr << endl;

    return nas;
}