#include<bits/stdc++.h>
#include "ones.h"
using namespace std;

struct event{
    int from,to;

    inline friend bool operator < (event fr,event sc){
        return fr.to-fr.from < sc.to-sc.from;
    }
}curr;

int bucket,total;
vector<int> sol;
priority_queue< event > v;

void solve(int l,int r){
    if(l==r){
        sol.push_back(l);
        return;
    }

    int mid=(l+r)/2;

    if(hasOnes(l,mid))solve(l,mid);
    else solve(mid+1,r);
}

int lg(int x){
    if(x==1)return 0;
    return lg(x/2)+1;
}

bool cmp(pair<int,int> fr,pair<int,int> sc){
    return fr.second-fr.first > sc.second-sc.first;
}

vector<int> guessOnes(int n, int k){

    bucket=n/k/sqrt(2);
    sol.clear();

    for(int i=1;i<=n;i+=bucket){
        if(v.size()==k)break;

        if(hasOnes(i,min(i+bucket-1,n))){
            v.push({i,min(i+bucket-1,n)});
        }
    }

    while(v.size()<k){

        curr=v.top();
        v.pop();

        int mid=(curr.from+curr.to)/2;

        if(hasOnes(curr.from,mid)){
            v.push({curr.from,mid});

            if(hasOnes(mid+1,curr.to))v.push({mid+1,curr.to});
        }else{
            v.push({mid+1,curr.to});
        }
    }

    while(!v.empty()){
        solve(v.top().from,v.top().to);
        v.pop();
    }

    sort(sol.begin(),sol.end());

    return sol;
}

/**
100000 10 1
13268 20602 34506 49070 50972 65407 79725 82387 92386 100000

*/
