#include "ones.h"

#include <vector>
#include <iostream>
#include <utility>
#include <algorithm>
#include <random>
#include <iomanip>
#include <numeric>
#include <cstring>
#include <queue>
using namespace std;
#define ll long long
#define pii pair<int, int>
#define mpr make_pair

vector<int> guessOnes(int n, int k) {
	vector<int> v;
	queue<pii> q;
	q.push(mpr(1, n));
	while (!q.empty()) {
		pii p = q.front();
		q.pop();
		int l = p.first, r = p.second;
		if (l == r) {
			bool f = hasOnes(l, r);
			if (f) v.push_back(l);
			continue;
		}
		int m = (l + r) / 2;
		bool f = hasOnes(l, m);
		if (f) {
			if (l == m) {
				v.push_back(l);
			}
			else {
				q.push(mpr(l, m));
			}
		}
		f = hasOnes(m + 1, r);
		if (f) {
			q.push(mpr(m + 1, r));
		}
	}
	sort(v.begin(), v.end());
	return v;
	/*int l = 1, r = n;
	int l0 = 1;
	int r0 = n;
	for (int i = 1; i <= k; i += 2) {
		while (l != r) {
			int m = (l + r) / 2;
			bool f = hasOnes(l0, m);
			if (f) {
				r = m;
			}
			else {
				l = m + 1;
			}
		}
		v.push_back(l);
		++l;
		l0 = l;
		r = r0;
		if (i != k) {
			while (l != r) {
				int m = ceil((double)(l + r) / 2.0);
				bool f = hasOnes(m, r0);
				if (f) {
					l = m;
				}
				else {
					r = m - 1;
				}
			}
			v.push_back(l);
			--r;
			r0 = r;
			l = l0;
		}
	}
	sort(v.begin(), v.end());
	return v;*/
}