#include <vector>
#include <iostream>
#include <algorithm>
#include <random>
#include <iomanip>
#include <string>
#include <map>
#include <assert.h>
#include <set>
using namespace std;

#define ll long long
#define mod 100000543

const int N = 1000005;
ll a[N];
ll pref[N];

int main() {
	int n, q;
	cin >> n >> q;
	map<int, int> mp;
	vector<ll> x(10000000), g0(10000000), g1(10000000), g2(10000000), g3(10000000), g4(10000000);
	for (int i = 0; i <= 4; ++i) x[i] = i;
	int k = mod + 1000;
	for (int i = 5; i <= 999995; ++i) {
		x[i] = (5ll * x[i - 1] + 4ll * x[i - 2] + 3ll * x[i - 3] + 2ll * x[i - 4] + x[i - 5]) % mod;
	}
	for (int i = 1; i <= n; ++i) {
		cin >> a[i];
		a[i] = x[a[i]];
		pref[i] = pref[i - 1] + a[i];
		pref[i] %= mod;
	}
	while (q--) {
		int type, l, r;
		cin >> type >> l >> r;
		assert(type == 1);
		cout << (pref[r] - pref[l - 1] + 10ll * mod) % mod << "\n";
	}
}