#include<iostream>
#include<vector>
#include<algorithm>

#include "ones.h"

//#include "Lgrader.cpp"

using namespace std;
using ll = long long;

void check(int l,int r,int k,vector<int>&ans){
	if(ans.size()==k) return;
	if(l==r) {
		int c = hasOnes(l,r);
		if(c) ans.push_back(l);
		return;
	}
	bool c = hasOnes(l,r);
	int mid = (l+r)/2;
	if(c){
		check(l,mid,k,ans);
		check(mid+1,r,k,ans);
	}
}

vector<int> guessOnes(int n,int k){
	vector<int>ans;
	if(k>=1000){
		check(1,n/2,k,ans);
		if(ans.size()!=k)check(n/2+1,n,k,ans);
		sort(ans.begin(),ans.end());
	}
	else{
		int ind = 1;
    		int f = 0;
    		while(f != k){
        		int l = ind-1,r=n;
        		while(l+1<r){
            			int mid = (l+r)/2;
            			int query  = hasOnes(ind,mid);
            			if(query) r = mid;
            			else l = mid;
        		}
        		ans.push_back(r);
        		ind = r+1;
        		f++;
    		}
	}
	return ans;
}
