#include <bits/stdc++.h>
#include "puzzle.h"
#define pb push_back
#define ff first
#define ss second
using namespace std;
typedef long long ll;
typedef vector<int> VI;
typedef pair<int, int> PII;
typedef vector<PII> VPI;
typedef vector<VI> VVI;
typedef vector<ll> VL;
typedef pair<ll, ll> PLL;
typedef vector<PLL> VPL;

void init(int numSubtests, double timeLimit) {
}

int n, m;
VVI table;

int get(int i, int j, char dir) {
	if (dir == 'U') {
		for (int i1 = i-1; i1 >= 0; i1--) if (table[i1][j] != 0) return table[i1][j];
		return -1;
	}
	if (dir == 'D') {
		for (int i1 = i+1; i1 < n; i1++) if (table[i1][j] != 0) return table[i1][j];
		return -1;
	}
	if (dir == 'L') {
		for (int j1 = j-1; j1 >= 0; j1--) if (table[i][j1] != 0) return table[i][j1];
		return -1;
	}
	if (dir == 'R') {
		for (int j1 = j+1; j1 < m; j1++) if (table[i][j1] != 0) return table[i][j1];
		return -1;
	}
	return -1;
}
// -1 horizonakan
// -2 horizonakan krknaki
// -3 uxxahayac
// -4 uxxahayac krknaki
void most(int i, int j, char dir, bool krknaki) {
	table[i][j]--;
	if (krknaki) table[i][j]--;

	if (dir == 'U') {
		for (int i1 = i-1; i1 >= 0; i1--) {
			if (table[i1][j] != 0) {
				table[i1][j]--;
				if (krknaki) table[i1][j]--;
				return;
			}
			if (krknaki) table[i1][j] = -4;
			else table[i1][j] = -2;
		}
	}
	if (dir == 'D') {
		for (int i1 = i+1; i1 < n; i1++) {
			if (table[i1][j] != 0) {
				table[i1][j]--;
				if (krknaki) table[i1][j]--;
				return;
			}
			if (krknaki) table[i1][j] = -4;
			else table[i1][j] = -2;
		}
	}
	if (dir == 'L') {
		for (int j1 = j-1; j1 >= 0; j1--) {
			if (table[i][j1] != 0) {
				table[i][j1]--;
				if (krknaki) table[i][j1]--;
				return;
			}
			if (krknaki) table[i][j1] = -3;
			else table[i][j1] = -1;
		}
	}
	if (dir == 'R') {
		for (int j1 = j+1; j1 < m; j1++) {
			if (table[i][j1] != 0) {
				table[i][j1]--;
				if (krknaki) table[i][j1]--;
				return;
			}
			if (krknaki) table[i][j1] = -3;
			else table[i][j1] = -1;
		}
	}
}

bool solve(VVI& puzzle) {
	table = puzzle;
	n = table.size();
	m = table[0].size();

	int mx = 100;
	while (mx--) {
		bool br = true;
		for (int i = 0; i < n; i++) for (int j = 0; j < m; j++) if (table[i][j] > 0) { br = false;
			int u, d, r, l;
			u = min(max(get(i, j, 'U'), 0), 2);
			d = min(max(get(i, j, 'D'), 0), 2);
			r = min(max(get(i, j, 'R'), 0), 2);
			l = min(max(get(i, j, 'L'), 0), 2);
			if (u + d + r + l == table[i][j]) {
				if (u == 1) most(i, j, 'U', false);
				else if (u == 2) most(i, j, 'U', true);
				if (d == 1) most(i, j, 'D', false);
				else if (d == 2) most(i, j, 'D', true);
				if (r == 1) most(i, j, 'R', false);
				else if (r == 2) most(i, j, 'R', true);
				if (l == 1) most(i, j, 'L', false);
				else if (l == 2) most(i, j, 'L', true);
			}
		}
		if (br) break;
	}

	/* cout << endl; */
	/* for (int i = 0; i < n; i++) { */
	/* 	for (int j = 0; j < m; j++) { */
	/* 		cout << table[i][j] << " "; */
	/* 	} */
	/* 	cout << endl; */
	/* } */
	/* cout << "IMERS VSYO" << endl; */
	
	if (mx == 0) return false;

	for (int i = 0; i < n; i++) for (int j = 0; j < m; j++) puzzle[i][j] += table[i][j];
	return true;
}

