#include <bits/stdc++.h>
#include "puzzle.h"
#define pb push_back
#define ff first
#define ss second
using namespace std;
typedef long long ll;
typedef vector<int> VI;
typedef pair<int, int> PII;
typedef vector<PII> VPI;
typedef vector<VI> VVI;
typedef vector<ll> VL;
typedef pair<ll, ll> PLL;
typedef vector<PLL> VPL;

void init(int numSubtests, double timeLimit) {
}

int get(VVI& table, int i, int j, char dir) {
	int n = table.size();
	int m = table[0].size();
	if (dir == 'U') {
		for (int i1 = i-1; i1 >= 0; i1--) if (table[i1][j] != 0) return table[i1][j];
		return -1;
	}
	if (dir == 'D') {
		for (int i1 = i+1; i1 < n; i1++) if (table[i1][j] != 0) return table[i1][j];
		return -1;
	}
	if (dir == 'L') {
		for (int j1 = j-1; j1 >= 0; j1--) if (table[i][j1] != 0) return table[i][j1];
		return -1;
	}
	if (dir == 'R') {
		for (int j1 = j+1; j1 < m; j1++) if (table[i][j1] != 0) return table[i][j1];
		return -1;
	}
	return -1;
}
void most(VVI& table, int i, int j, char dir, bool krknaki) {
	int n = table.size();
	int m = table[0].size();
	table[i][j]--;
	if (krknaki) table[i][j]--;

	if (dir == 'U') {
		for (int i1 = i-1; i1 >= 0; i1--) {
			if (table[i1][j] != 0) {
				table[i1][j]--;
				if (krknaki) table[i1][j]--;
				return;
			}
			if (krknaki) table[i1][j] = -4;
			else table[i1][j] = -2;
		}
	}
	if (dir == 'D') {
		for (int i1 = i+1; i1 < n; i1++) {
			if (table[i1][j] != 0) {
				table[i1][j]--;
				if (krknaki) table[i1][j]--;
				return;
			}
			if (krknaki) table[i1][j] = -4;
			else table[i1][j] = -2;
		}
	}
	if (dir == 'L') {
		for (int j1 = j-1; j1 >= 0; j1--) {
			if (table[i][j1] != 0) {
				table[i][j1]--;
				if (krknaki) table[i][j1]--;
				return;
			}
			if (krknaki) table[i][j1] = -3;
			else table[i][j1] = -1;
		}
	}
	if (dir == 'R') {
		for (int j1 = j+1; j1 < m; j1++) {
			if (table[i][j1] != 0) {
				table[i][j1]--;
				if (krknaki) table[i][j1]--;
				return;
			}
			if (krknaki) table[i][j1] = -3;
			else table[i][j1] = -1;
		}
	}
}
VVI mostret(VVI table, int i, int j, char dir, bool krknaki) {
	most(table, i, j, dir, krknaki);
	return table;
}

bool prcav(VVI& table) {
	int n = table.size();
	int m = table[0].size();
	for (int i = 0; i < n; i++) for (int j = 0; j < m; j++) if (table[i][j] > 0) return false;
	return true;
}

void level1(VVI& table) {
	int n = table.size();
	int m = table[0].size();
	while (true) {
		bool gtav = false;
		for (int i = 0; i < n; i++) for (int j = 0; j < m; j++) if (table[i][j] > 0) {
			int u, d, r, l;
			u = min(max(get(table, i, j, 'U'), 0), 2);
			d = min(max(get(table, i, j, 'D'), 0), 2);
			r = min(max(get(table, i, j, 'R'), 0), 2);
			l = min(max(get(table, i, j, 'L'), 0), 2);
			if (u + d + r + l == table[i][j]) {
				gtav = true;
				if (u == 1) most(table, i, j, 'U', false);
				else if (u == 2) most(table, i, j, 'U', true);
				if (d == 1) most(table, i, j, 'D', false);
				else if (d == 2) most(table, i, j, 'D', true);
				if (r == 1) most(table, i, j, 'R', false);
				else if (r == 2) most(table, i, j, 'R', true);
				if (l == 1) most(table, i, j, 'L', false);
				else if (l == 2) most(table, i, j, 'L', true);
			}
		}
		if (gtav == false) return;
	}
}

void prnt(VVI& table) {
	int n = table.size();
	int m = table[0].size();
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cout << table[i][j] << " ";
		}
		cout << endl;
	}
}

void level2(VVI& table) {
	int n = table.size();
	int m = table[0].size();
	for (int i = 0; i < n; i++) for (int j = 0; j < m; j++) if (table[i][j] > 0) {
		int u, d, r, l;
		u = min(max(get(table, i, j, 'U'), 0), 2);
		d = min(max(get(table, i, j, 'D'), 0), 2);
		r = min(max(get(table, i, j, 'R'), 0), 2);
		l = min(max(get(table, i, j, 'L'), 0), 2);
		if (u + d + r + l == table[i][j]+1) {
			if (u) {
				VVI t = table;
				if (u == 2) most(t, i, j, 'U', false);
				if (d) most(t, i, j, 'D', d-1);
				if (r) most(t, i, j, 'R', r-1);
				if (l) most(t, i, j, 'L', l-1);
				level1(t);
				if (prcav(t)) {
					/* cout << "AAA " << i+1 << " " << j+1 << 'U' << endl; */
					table = t;
					return;
				}
			}
			if (d) {
				VVI t = table;
				if (u) most(t, i, j, 'U', u-1);
				if (d == 2) most(t, i, j, 'D', false);
				if (r) most(t, i, j, 'R', r-1);
				if (l) most(t, i, j, 'L', l-1);
				level1(t);
				if (prcav(t)) {
					/* cout << "AAA " << i+1 << " " << j+1 << 'D' << endl; */
					table = t;
					return;
				}
			}
			if (r) {
				VVI t = table;
				if (u) most(t, i, j, 'U', u-1);
				if (d) most(t, i, j, 'D', d-1);
				if (r == 2) most(t, i, j, 'R', false);
				if (l) most(t, i, j, 'L', l-1);

				/* cout << "after R" << endl; */
				/* prnt(t); */
				/* cout << endl; */

				level1(t);

				if (prcav(t)) {
					/* cout << "AAA " << i+1 << " " << j+1 << 'R' << endl; */
					table = t;
					return;
				}
			}
			if (l) {
				VVI t = table;
				if (u) most(t, i, j, 'U', u-1);
				if (d) most(t, i, j, 'D', d-1);
				if (r) most(t, i, j, 'R', r-1);
				if (l == 2) most(t, i, j, 'L', false);
				level1(t);
				if (prcav(t)) {
					/* cout << "AAA " << i+1 << " " << j+1 << 'L' << endl; */
					table = t;
					return;
				}
			}
			return;
		}
	}
}

bool solve(VVI& puzzle) {
	VVI table = puzzle;
	int n = table.size();
	int m = table[0].size();

	level1(table);
	if (!prcav(table)) {
		level2(table);
	}
	if (!prcav(table)) {
		level2(table);
	}
	if (!prcav(table)) {
		level2(table);
	}
	if (!prcav(table)) {
		level2(table);
	}
	if (!prcav(table)) {
		level2(table);
	}
	if (!prcav(table)) {
		level2(table);
	}
	if (!prcav(table)) {
		level2(table);
	}
	if (!prcav(table)) {
		level2(table);
	}
	if (!prcav(table)) {
		level2(table);
	}
	if (!prcav(table)) {
		level2(table);
	}

	/* cout << endl; */
	/* prnt(table); */
	/* cout << "IMERS VSYO" << endl; */
	
	for (int i = 0; i < n; i++) for (int j = 0; j < m; j++) puzzle[i][j] += table[i][j];
	return true;
}

