#include "puzzle.h"
#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <cmath>
#include <algorithm>
#include <unordered_map>
#include <unordered_set>
using namespace std;
using vi = vector<int>;
#define ll long long
#define pii pair<int,int>
#define ff first
#define ss second
#define pub push_back
#define all(x) (x).begin(), (x).end()

void init(int numSubtests, double timeLimit) {

}

const int N = 20;
int pos[N][N], id[N][N], edge[N][N];
vector<pii> adj[N][N];
int n, m;

bool check() {

}

void rec(int i, int j) {
	int x = id[i][j];
	vector<pii> nodes;
	for (auto to : adj[i][j]) {
		int y = id[to.ff][to.ss];
		if (!edge[x][y]) {
			nodes.pub({ to.ff,to.ss });
		}
	}
	if (!nodes.size()) {
		bool f = check();
		if (f) return;
	}
}

bool solve(vector<vector<int>>& puzzle) {
	n = puzzle.size(), m = puzzle[0].size();
	int cnt = 0, x = 0, y = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (puzzle[i][j]) {
				pos[i][j] = puzzle[i][j];
				id[i][j] = ++cnt;
				x = i, y = j;
			}
			for (int i1 = i - 1; i1 >= 0; --i1) {
				if (!puzzle[i1][j]) continue;
				adj[i][j].pub({ i1,j });
				adj[i1][j].pub({ i,j });
				break;
			}
			for (int j1 = j - 1; j1 >= 0; --j1) {
				if (!puzzle[i][j1]) continue;
				adj[i][j].pub({ i,j1 });
				adj[i][j1].pub({ i,j });
			}
		}
	}
	if (cnt <= 1) return true;
	rec(x, y);
}