#include <vector>
#include <algorithm>
#include <iostream>
using namespace std;
bool hasOnes(int l, int r);

vector<int>res;

void bin(int l, int r, int k)
{
    //cout << "q " << l << ' ' << r << endl;
    if (res.size() == k)
        return;
    if (l == r)
    {
        res.push_back(l);
        return;
    }
    int middle = (l + r) / 2;
    bool a, b, c, d, e;
    a = hasOnes(l, middle);
    b = hasOnes(middle + 1, r);
    if (a)
    {
        bin(l, middle, k);
    }
    if (b)
    {
        bin(middle + 1, r, k);
    }
}
void find(int n, int k)
{
    int l, r;
    l = 1; r = 10000;
    while (r <= n)
    {
        if (hasOnes(l, r))
        {
            bin(l, r, k);
        }
        if (r == n)
            break;
        l = r + 1;
        r = l + 9999;
        if (r > n)
            r = n;
    }
}
std::vector<int> guessOnes(int n, int k)
{
    res.erase(res.begin(), res.end());
    int l, r;
    l = 1;
    r = n;
    if (n == 1)
    {
        if (k == 1)
        {
            res.push_back(1);
            return res;
        }
        else return res;
    }
    find(n, k);
    sort(res.begin(), res.end());
    k = res.size();
    /*for (int i = 0; i < k; i++)
        cout << res[i] << ' ';*/
    return res;
}