#include "ones.h"

#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <vector>
#include <utility>
#include <random>
#include <numeric>
#include <cstring>
#include <set>
using namespace std;

typedef long long ll;

#define pb push_back
#define mpr make_pair
#define sz(x) (int(x.size()))
#define all(x) (x).begin(), (x).end()
#define clr(x) (x).clear()

mt19937 rnf(109);

bool ok[100005];

vector<int> ans;

int kk;

void rec(int l, int r)
{
	if (sz(ans) == kk) return;

	if (!hasOnes(l, r)) return;

	if (l == r) {
		ans.pb(l);
		return;
	}

	int m = (l + r) / 2;

	rec(l, m);
	rec(m + 1, r);

	return;
}

vector<int> guessOnes(int n, int k)
{
	int i, j;

	kk = k;

	clr(ans);

	for (i = 0; i <= n + 1; i++) ok[i] = 0;

	int l, r, m;

	int e = n / k / 2;

	for (i = 1; i <= n; i += e) {
		rec(i, min(i + e - 1, n));

		if (sz(ans) == k) break;
	}

	sort(all(ans));

	return ans;
}