#include <iostream>
#include "puzzle.h"
#include <math.h>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <string>
#include <cstring>
#include <iomanip>
#include <bitset>

#define ll long long
#define fr first
#define sc second
#define pb push_back

using namespace std;

double tl = 0;
const int N = 100;

struct NODE {
	int tox, syun, u, v;
};

NODE b[100];
int cnt;

void init(int numSubtests, double timeLimit) {
	tl = timeLimit;
}

vector<int> vsyun[N], vtox[N], vec[N];
vector<pair<int, int>> indexz1;
int qan[N][N];
bool fl = false;
int bl[N];


void rec(int ind) {
	for (int i = 0; i < vec[ind].size(); ++i) {
		if (bl[vec[ind][i]] != 0) {
			if (ind == cnt) {
				fl = true;
				for (int i = 0; i < indexz1.size(); ++i) {
					if (qan[indexz1[i].fr][indexz1[i].sc] != 0) {
						fl = false;
						break;
					}
				}
				if (fl == true) {
					return;
				}
			}
			else {
				rec(ind + 1);
			}
			return;
		}
	}
	if (b[ind].syun ==  -1) {
		for (int j = 1; j <= 2; ++j) {
			if (qan[b[ind].tox][b[ind].u] - j >= 0 && qan[b[ind].tox][b[ind].v] - j >= 0) {
				qan[b[ind].tox][b[ind].u] -= j;
				qan[b[ind].tox][b[ind].v] -= j;
				bl[ind] = j;
				if (ind == cnt) {
					fl = true;
					for (int i = 0; i < indexz1.size(); ++i) {
						if (qan[indexz1[i].fr][indexz1[i].sc] != 0) {
							fl = false;
							break;
						}
					}
					if (fl == true) {
						return;
					}
					else {
						bl[ind] = 0;
						qan[b[ind].tox][b[ind].u] += j;
						qan[b[ind].tox][b[ind].v] += j;
					}
				}
				else {
					rec(ind + 1);
					if (fl == true) {
						return;
					}
					else {
						bl[ind] = 0;
						qan[b[ind].tox][b[ind].u] += j;
						qan[b[ind].tox][b[ind].v] += j;
					}
				}
			}
		}
		if (ind == cnt) {
			fl = true;
			for (int i = 0; i < indexz1.size(); ++i) {
				if (qan[indexz1[i].fr][indexz1[i].sc] != 0) {
					fl = false;
					break;
				}
			}
			return;
		}
		rec(ind + 1);
	}
	else {
		for (int j = 1; j <= 2; ++j) {
			if (qan[b[ind].u][b[ind].syun] - j >= 0 && qan[b[ind].v][b[ind].syun] - j >= 0) {
				qan[b[ind].u][b[ind].syun] -= j;
				qan[b[ind].v][b[ind].syun] -= j;
				bl[ind] = j;
				if (ind == cnt) {
					fl = true;
					for (int i = 0; i < indexz1.size(); ++i) {
						if (qan[indexz1[i].fr][indexz1[i].sc] != 0) {
							fl = false;
							break;
						}
					}
					if (fl == true) {
						return;
					}
					else {
						bl[ind] = 0;
						qan[b[ind].u][b[ind].syun] += j;
						qan[b[ind].v][b[ind].syun] += j;
					}
				}
				else {
					rec(ind + 1);
					if (fl == true) {
						return;
					}
					else {
						bl[ind] = 0;
						qan[b[ind].u][b[ind].syun] += j;
						qan[b[ind].v][b[ind].syun] += j;
					}
				}
			}
		}
		if (ind == cnt) {
			fl = true;
			for (int i = 0; i < indexz1.size(); ++i) {
				if (qan[indexz1[i].fr][indexz1[i].sc] != 0) {
					fl = false;
					break;
				}
			}
			return;
		}
		rec(ind + 1);
	}
}

bool solve(std::vector<std::vector<int>>& puzzle) {
	cnt = 0;
	int n = puzzle.size();
	int m = puzzle[0].size();
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			qan[i][j] = puzzle[i][j];
			if (puzzle[i][j] != 0) {
				vtox[i].pb(j);
				indexz1.pb({ i,j });
				vsyun[j].pb(i);
			}
		}
	}
	//cout << "ASCDS" << endl;
	for (int i = 0; i < n; ++i) {
		sort(vtox[i].begin(), vtox[i].end());
	}
	for (int i = 0; i < m; ++i) {
		sort(vsyun[i].begin(), vsyun[i].end());
	}
	cnt = 0;
	//cout << "barev" << endl;
	for (int i = 0; i < n; ++i) {
		//cout << "iiii" << " " << i << " " << vtox[i].size() << endl;
		if (vtox[i].size() >= 2) {
			for (int k = 0; k < vtox[i].size() - 1; ++k) {
				++cnt;
				NODE node;
				node.tox = i;
				node.syun = -1;
				node.u = vtox[i][k];
				node.v = vtox[i][k + 1];
				b[cnt] = node;
			}
		}
	}
	//cout << "karen" << endl;
	for (int i = 0; i < m; ++i) {
		if (vsyun[i].size() >= 2) {
			for (int k = 0; k < vsyun[i].size() - 1; ++k) {
				++cnt;
				NODE node;
				node.tox = -1;
				node.syun = i;
				node.u = vsyun[i][k];
				node.v = vsyun[i][k + 1];
				b[cnt] = node;
			}
		}
	}
	//cout << "AAA" << endl;
	for (int i = 1; i <= cnt-1; ++i) {
		for (int j = i+1; j <= cnt; ++j) {
			if (b[i].syun == -1 && b[j].syun == -1) {
				continue;
			}
			if (b[i].tox == -1 && b[j].tox == -1) {
				continue;
			}
			int l1 = b[i].u, r1 = b[i].v, l2 = b[j].u, r2 = b[j].v;
			if (b[i].syun == -1) {
				if (l1 < b[j].syun && b[j].syun < r1 && l2 < b[i].tox && b[i].tox < r2) {
					vec[i].pb(j);
					vec[j].pb(i);
					continue;
				}
			}
			else {
				if (l1 < b[j].tox && b[j].tox < r1 && l2 < b[i].syun && b[i].syun < r2) {
					vec[i].pb(j);
					vec[j].pb(i);
					continue;
				}
			}
		}
	}
	//cout << "SDDS" << endl;
	rec(1);
	//cout << fl << endl;
	for (int i = 1; i <= cnt; ++i) {
		if (bl[i] != 0) {
			if (b[i].syun == -1) {
				for (int j = b[i].u + 1; j <= b[i].v - 1; ++j) {
					puzzle[b[i].tox][j] = -bl[i];
					//cout << puzzle[b[i].tox][j] << " " << b[i].tox << " " << j << endl;
				}
			}
			else {
				for (int j = b[i].u + 1; j <= b[i].v - 1; ++j) {
					//puzzle[j][b[i].syun] = -(bl[i] + 2);
					cout << puzzle[j][b[i].syun] << " " << j << " " << b[i].syun << endl;
				}
			}
		}
	}
	return true;
}
