#include "ones.h"
#include <bits/stdc++.h>

#define ll long long
#define endl "\n"

using namespace std;
mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
ll search(ll l, ll r)
{
    if (l == r)
        return l;
    if (r - l + 1 <= 200)
    {
        ll st = l;
        while (l <= r)
        {
            ll mid = (l + r) >> 1;
            if (hasOnes(st, mid))
                r = mid - 1;
            else
                l = mid + 1;
        }
        return ++r;
    }
    ll B = sqrt(r - l + 1);
    while (!hasOnes(l, min(l + B - 1, r)))
        l += B;
    return search(l, min(l + B - 1, r));
}
std::vector<int> guessOnes(int n, int k)
{
    vector<int> ans;
    ll B = 500;
    for (ll i = 0; i < k; i++)
    {
        ll st = ans.empty() ? 1 : ans.back() + 1;
        ans.push_back(search(st, n));
    }
    return ans;
}