#include <bits/stdc++.h>
#include "ones.h"

using namespace std;

const int LOG = 13;
const int B = 8192;

vector<int> ans;

void find(int l, int r)
{
    if (l == r)
    {
        ans.push_back(l);
        return;
    }
    int mid = (l + r) >> 1;
    if (hasOnes(l, mid)) find(l, mid);
    if (hasOnes(mid + 1, r)) find(mid + 1, r);
}

vector<int> guessOnes(int n, int k)
{
    int cur = 1;
    ans.clear();
    while (ans.size() < k && cur <= n)
    {
        int l = cur, r = min(n, cur + B - 1);
        if (hasOnes(l, r))
        {
            find(l, r);
        }
        cur = r + 1;
    }
    return ans;
}
