#include <bits/stdc++.h>
#include "ones.h"

using namespace std;

mt19937 rng(time(NULL));

vector<int> guessOnes(int n,int k) {

    vector<int> ans;

    function<void (int , int)> func = [&](int l , int r) -> void {
        if (ans.size() == k) {
            return;
        }
        int ind = l;
        while (ind <= r) {
            int _l = ind , _r = r , best = r + 1;
            while (_l <= _r) {
                int mid = (_l + _r) / 2;
                if (hasOnes(_l , mid) == true) {
                    _r = mid - 1;
                    best = mid;
                } else {
                    _l = mid + 1;
                }
            }
            if (best <= r) {
                ans.push_back(best);
            }
            ind = best + 1;
        }
    };

    int block =47;
    for (int i = 0;i < n / block;i ++) {
        if (ans.size() == k) {
            break;
        }
        int l = i * block + 1 , r = min(n , (i + 1) * block);
        if (i == n / block - 1) {
            r = n;
        }
        if (hasOnes(l , r) == false) {
            continue;
        }
        func(l , r);
        ///cerr << l << " " << r << "\n";
    }
    sort(ans.begin() , ans.end());
    // for (auto i : ans) {
    //     cerr << i << " ";
    // }
    // cerr << "\n";
    return ans;
}