//#include "Lgrader.cpp"
#include "ones.h"
#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define pii pair<int, int>
#define F first
#define S second
#define all(v) v.begin(), v.end()

vector<int>ans;
map<int, int>m;
vector<int>sifirla;
queue<pair<int, int>>q;
vector<pair<int, int>>leaves;

int sz=0, kk;

void bfs(int a, int b){
    q.push({a, b});
    while(!q.empty()){
        if(sz==kk){
            break;
        }
        int l=q.front().first;
        int r=q.front().second;
        q.pop();
        if(l+1==r){
            leaves.pb({l, r});
            sz++;
            continue;
        }
        int mid=(l+r)/2;
        if(hasOnes(l, mid)){
            q.push({l, mid});
        }
        if(hasOnes(mid+1, r)){
            q.push({mid+1, r});
        }
    }
}

vector<int> guessOnes(int n, int k){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    ans.clear();

    int l=1, r=n;
    kk=k;

    bfs(l, r);

    for(pii i : leaves){
        if(hasOnes(i.F, i.F)){
            ans.pb(i.F);
        }
        else{
            ans.pb(i.S);
        }
    }

    sort(all(ans));

    return ans;
}
