#include "puzzle.h"
#include <bits/stdc++.h>
using namespace std;
double MX=0;
double till=0;
void init(int subt, double tl) {
	MX-=0.2;
	MX=tl/subt;	
	till=MX;
}
const int N=210;
int v[N], cc[N];
vector<int> gg[N];
int g[N][N];
int n;
struct DS {
	int _N;
	vector<int> e;
	int cc=0;
	DS(int _nn) { 
		_N=_nn;
		cc=_nn;
		e=vector<int>(_N, -1);
	}
	int get(int x) {
		if(e[x]<0)return x;
		return e[x]=get(e[x]);
	}
	void unite(int a, int b) {
		a=get(a),b=get(b);
		if(a==b)return;
		if(-e[a]>-e[b])swap(a,b);
		e[b]+=e[a];
		e[a]=b;
		cc--;
	}
};
int eval() {
	memset(cc, 0, sizeof cc);
	int sum=0;
	for(int i = 0;i<n;i++) {
		int cnt=0;
		for(int j=0;j<n;j++){
			cnt+=g[i][j]+g[j][i];
		}
		cc[i]=cnt;
		sum+=abs(cc[i]-v[i]);
	}
 return sum;

}
long double P(int nw, int old, long double temp) {
	if(nw < old)return 1;
	return exp(((double)old-nw)/temp);
}
mt19937 rng(chrono::steady_clock().now().time_since_epoch().count());

bool solve(vector<vector<int>> &pp) {
	n=0;
	vector<pair<int,int>> tmp;
	for(int i = 0;i<pp.size();i++) {
		for(int j = 0;j<pp[i].size();j++) {
			if(pp[i][j]) {
				v[n]=pp[i][j];
				tmp.push_back({i,j});
				n++;		
			}
		}
	}
	for(int c=0;c<n;c++) {
		auto i = tmp[c];
		int sml1=-1, sml2=-1, bg1=-1, bg2=-1;
		for(int k = 0;k<n;k++) { 
			auto j=tmp[k];
			if(i==j)continue;
			if(i.first!=j.first and i.second!=j.second)continue;
			if(j.first<i.first and (sml1==-1 or j.first>tmp[sml1].first))sml1=k;
			if(j.first>i.first and (bg1==-1 or j.first<tmp[bg1].first))bg1=k;
			if(j.second<i.second and (sml1==-1 or j.second>tmp[sml1].second))sml2=k;
			if(j.second>i.second and (bg2==-1 or j.second<tmp[bg1].second))bg2=k;
		}
		if(sml1>=0)gg[c].push_back(sml1);
		if(sml2>=0)gg[c].push_back(sml2);
		if(bg1>=0)gg[c].push_back(bg1);
		if(bg2>=0)gg[c].push_back(bg2);
	}

	memset(g, 0, sizeof g);
	for(int _=0;_<1;_++) {
		for(int i= 0;i<n;i++) {
			for(int c:gg[i]) {
				g[i][c]=rng()%2;
			}
		}
		long double old=eval();
		long double temp=100;
		while(timePassed()<(till)*(_+1)) {
			int a=rng()%n;	
			if(gg[a].size()==0)continue;
			int b=rng()%gg[a].size();
			b=gg[a][b];
			if(rng()%2)swap(a,b);
			g[a][b]^=1;
			int op=g[a][b];
			if(op==0)op=-1;
			int nw = old;
			nw-=abs(v[a]-cc[a]);
			nw-=abs(v[b]-cc[b]);
			cc[a]+=op;
			cc[b]+=op;
			nw+=abs(v[a]-cc[a]);
			nw+=abs(v[b]-cc[b]);
			double rn = rng()%1001;
			rn/=1000;
			if(P(nw, old, temp)>=rn) {
				old=nw;
			}
			else {
				nw-=abs(v[a]-cc[a]);
				nw-=abs(v[b]-cc[b]);
				cc[a]-=op;
				cc[b]-=op;
				nw+=abs(v[a]-cc[a]);
				nw+=abs(v[b]-cc[b]);
				g[a][b]^=1;
			}
			if(old==0)break;
			temp*=0.99;
		}
		if(old==0)break;
	}
	till+=MX;
	for(int i = 0;i<n;i++) {
		for(int j = i+1;j<n;j++) {
			if(g[i][j] and g[j][i]) {
				if(tmp[i].first==tmp[j].first) {
					for(int kk = tmp[i].second+1;kk<tmp[j].second;kk++) {
						pp[tmp[i].first][kk]=-3;
					}
				}
				else {
					for(int kk = tmp[i].first+1;kk<tmp[j].first;kk++) {
						pp[kk][tmp[i].second]=-4;
					}
				}
			}
			else if(g[i][j] or g[j][i]) {
				if(tmp[i].first==tmp[j].first) {
					for(int kk = tmp[i].second+1;kk<tmp[j].second;kk++) {
						pp[tmp[i].first][kk]=-1;
					}
				}
				else {
					for(int kk = tmp[i].first+1;kk<tmp[j].first;kk++) {
						pp[kk][tmp[i].second]=-2;
					}
				}
			}
		}
	}
	for(int i = 0;i<n;i++) {
		gg[i].clear();
	}
	if(eval()==0)return 1;
	return 0;
}
