#include <bits/stdc++.h>
using namespace std;
#define int long long
const long long mod=1e8+543;
vector<vector<int>> mult(vector<vector<int>> a, vector<vector<int>> b) {
	int n = a.size();
	vector<vector<int>> res(n, vector<int> (n));
	for(int i = 0;i<n;i++) {
		for(int j = 0;j<n;j++) {
			for(int k = 0;k<n;k++) {
				res[i][j]+=a[i][k]*b[k][j];
			}
		}
	}
	return res;
}
long long get(long long x) {
	if(x<0) {
		return -1;
	}
	else {
		if(x<=4)return x;
		vector<vector<int>> base(4, vector<int> (4));
		base = {
			{5,4,3,2,1},
			{1,0,0,0,0},
			{0,1,0,0,0},
			{0,0,1,0,0},
			{0,0,0,1,0},
		};
		vector<vector<int>> res={
			{4,0,0,0,0},
			{3,0,0,0,0},
			{2,0,0,0,0},
			{1,0,0,0,0},
			{0,0,0,0,0}
		};
		x-=4;
		vector<vector<int>> rr={
			{1,0,0,0,0},
			{0,1,0,0,0},
			{0,0,1,0,0},
			{0,0,0,1,0},
			{0,0,0,0,1},
		};
		while(x>0) {
			if(x&1) {
				rr=mult(rr, base);
			}
			base=mult(base, base);
			x>>=1;
		}
		rr=mult(rr, res);
		return rr[0][0];
	}
}
signed main () {
	cin.tie(0)->sync_with_stdio(0);
	int n, q;
	cin >> n >> q;
	int a[n];
	for(int i = 0;i<n;i++)cin >> a[i];
	while(q--) {
		int t;
		cin >> t;
		if(t==1) {
			int l, r;
			cin >> l >> r;
			long long sum=0;
			for(int i = l-1;i<r;i++) {
				sum=(sum+get(a[i]))%mod;
			}
			cout << sum << "\n";
		}
		else {
			int l, r, val;
			cin >> l >> r >> val;
			for(int i = l-1;i<r;i++) {
				a[i]+=val;
			}
		}
	}
}
