#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include "ones.h"

using namespace __gnu_pbds; 
using namespace std;

#define ll long long
#define pii pair<int, int>
#define oo 1e9
#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

int N, K;
const int BLOCK = 100;

bool ask(int l, int r){
    return hasOnes((l - 1) * BLOCK + 1, min(r * BLOCK, N));
}

vector<int> guessOnes(int n, int k){
    N = n, K = k;
    vector<int> ones;
    int j = 1;
    int endb = (n + BLOCK - 1) / BLOCK;
    while(j <= endb){
        if(ones.size() == k) break;
        int l = j, r = endb;
        while(l < r){
            int mid = (l + r) / 2;
            if(ask(j, mid)){
                r = mid;
            }
            else{
                l = mid + 1;
            }
        }
        j = l;
        int i = (j - 1) * BLOCK + 1;
        int e = min(j * BLOCK, n);
        while(i <= e){
            l = i, r = e;
            if(ones.size() == k) break;
            if(!hasOnes(i, e)){
                break;
            }
            while(l < r){
                int mid = (l + r) / 2;
                if(hasOnes(i, mid)){
                    r = mid;
                }
                else{
                    l = mid + 1;
                }
            }
            ones.push_back(l);
            if(ones.size() == k) break;
            i = l + 1;
        }
        j++;
    }
    return ones;
}
