#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include "ones.h"

using namespace std;

vector<int> res;

void dfs(int l, int r, int k) {
    if(l == r) {
        res.push_back(l);
        return;
    }
    int mid = (l + r) / 2;
    if(hasOnes(l, mid)) dfs(l, mid, k);
    if(hasOnes(mid + 1, r)) dfs(mid + 1, r, k);
}

vector<int> guessOnes(int n, int k) {
    dfs(1, n, k);
    sort(res.begin(), res.end());

    return res;
}