#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include "ones.h"

using namespace std;

vector<int> res;

void dfs(int l, int r, int k) {
    //cout << l << " " << r << "\n";
    if(l > r) return;
    if(l == r) {
        res.push_back(l + 1);
        return;
    }
    int mid = (l + r) / 2, f = hasOnes(l + 1, mid + 1);
    if(!f) dfs(mid + 1, r, k);
    else {
        dfs(l, mid, k);
        if(hasOnes(mid + 2, r + 1)) dfs(mid + 1, r, k);
    }
}

vector<int> guessOnes(int n, int k) {
    res.clear();
    if(k) dfs(0, n - 1, k);
    sort(res.begin(), res.end());

    return res;
}