#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include "ones.h"

using namespace std;

vector<int> res;

void dfs1(int l, int r, int k) {
    //cout << l << " " << r << "\n";
    if(l > r) return;
    if(l == r) {
        res.push_back(l + 1);
        return;
    }
    int mid = (l + r) / 2, f = hasOnes(l + 1, mid + 1);
    if(!f) dfs1(mid + 1, r, k);
    else {
        dfs1(l, mid, k);
        if(hasOnes(mid + 2, r + 1)) dfs1(mid + 1, r, k);
    }
}

vector<int> guessOnes(int n, int k) {
    res.clear();
    if(k == 10) {
        int N = sqrt(n);
        for(int i = 1; i <= n; i += N + 1) {
            if(hasOnes(i, min(n, i + N))) dfs1(i, min(n, i + N), k);
        }
    } else if(k) dfs1(0, n - 1, k);
    sort(res.begin(), res.end());
    return res;
}