#include <bits/stdc++.h>
#include "puzzle.h"

using namespace std;


void init(int numSubtests, double timeLimit)
{
	return;
}

int inc[205];

bool check_path(int a, int b, int c, int d, vector<vector<int>>&puzzle)
{
	if(a != c && b != d)	return false;
	if(a == c)
	{
		if(b < d)
		{
			for(int i = b+1; i < d; i++)
			{
				if(puzzle[a][i])	return false;
			}
		}
		else{
			for(int i = d+1; i < b; i++)
			{
				if(puzzle[a][i])	return false;
			}
		}
	}
	else{
		if(a < c)
		{
			for(int i = a+1; i < c; i++)
			{
				if(puzzle[i][b])	return false;
			}
		}
		else{
			for(int i = c+1; i < a; i++)
			{
				if(puzzle[i][b])	return false;
			}
		}
	}
	return true;
}

void add_path(int a, int b, int c, int d, int x, vector<vector<int>>&puzzle)
{
	if(a != c && b != d)	assert(0);
	if(a == c)
	{
		if(b < d)
		{
			for(int i = b+1; i < d; i++)
			{
				if(puzzle[a][i])	assert(0);
				puzzle[a][i] = -1-2*x;
			}
		}
		else{
			for(int i = d+1; i < b; i++)
			{
				if(puzzle[a][i])	assert(0);
				puzzle[a][i] = -1-2*x;
			}
		}
	}
	else{
		if(a < c)
		{
			for(int i = a+1; i < c; i++)
			{
				if(puzzle[i][b])	assert(0);
				puzzle[i][b] = -2-2*x;
			}
		}
		else{
			for(int i = c+1; i < a; i++)
			{
				if(puzzle[i][b])	assert(0);
				puzzle[i][b] = -2-2*x;
			}
		}
	}
}


void rem_path(int a, int b, int c, int d, vector<vector<int>>&puzzle)
{
	if(a != c && b != d)	assert(0);
	if(a == c)
	{
		if(b < d)
		{
			for(int i = b+1; i < d; i++)
			{
				if(!puzzle[a][i])	assert(0);
				puzzle[a][i] = 0;
			}
		}
		else{
			for(int i = d+1; i < b; i++)
			{
				if(!puzzle[a][i])	assert(0);
				puzzle[a][i] = 0;
			}
		}
	}
	else{
		if(a < c)
		{
			for(int i = a+1; i < c; i++)
			{
				if(!puzzle[i][b])	assert(0);
				puzzle[i][b] = 0;
			}
		}
		else{
			for(int i = c+1; i < a; i++)
			{
				if(!puzzle[i][b])	assert(0);
				puzzle[i][b] = 0;
			}
		}
	}
}

bool dfs(vector<vector<int>>& puzzle, vector<array<int, 3>>&v, int idx)
{
	if(idx == v.size())
	{
		return true;
	}
	int sz = v.size()-idx;
	for(int i = 0; i < (1ll << sz); i++)
	{
		if(__builtin_popcount(i)+inc[idx] > v[idx][0])	continue;
		if(__builtin_popcount(i)*2+inc[idx] < v[idx][0])	continue;
		bool valid = true;
		vector<int> o;
		for(int j = idx; j < sz+idx; j++)
		{
			if(!((1ll << j)&i))	continue;
			if(inc[j] == v[j][0])	
			{
				valid = false;
				continue;
			}
			if(!check_path(v[idx][1], v[idx][2], v[j][1], v[j][2], puzzle))
			{
				valid = false;
				break;
			}
			o.push_back(j);
		}
		if(!valid)	continue;
		for(int i = 0; i < (1ll << o.size()); i++)
		{
			int gh = __builtin_popcount(i);
			if(gh+o.size()+inc[idx] != v[idx][0])	continue;
			for(int j = 0; j < o.size(); j++)
			{
				inc[o[j]]++;
				if((1ll << j)&i)	inc[o[j]]++;
				add_path(v[idx][1], v[idx][2], v[o[j]][1], v[o[j]][2], ((1ll << j)&i), puzzle);
			}
			if(dfs(puzzle, v, idx+1))	return true;
			for(int j = 0; j < o.size(); j++)
			{
				inc[o[j]]--;
				if((1ll << j)&i)	inc[o[j]]--;
				rem_path(v[idx][1], v[idx][2], v[o[j]][1], v[o[j]][2], puzzle);
			}
		}
	}
	return false;
}

bool solve(vector<vector<int>>& puzzle)
{
	int n = puzzle.size();
	int m = puzzle[0].size();
	vector<array<int, 3>> v;
	for(int i = 0; i < n; i++)
	{
		for(int j = 0; j < m; j++)
		{
			if(puzzle[i][j])	v.push_back({puzzle[i][j], i, j});
		}
	}
	sort(v.rbegin(), v.rend());
	dfs(puzzle, v, 0);
	return true;
}