#include <bits/stdc++.h>

using namespace std;

const int MOD = 1e8+543, N = 1e6+5;


long long f[N];
vector<vector<int>> pos, neg;

vector<vector<int>> mul(vector<vector<int>> &a, vector<vector<int>> &b)
{
	vector<vector<int>> ans;
	ans = vector<vector<int>> (5, vector<int> (5));
	for(int i = 0; i < 5; i++)
	{
		for(int j = 0; j < 5; j++)
		{
			for(int k = 0; k < 5; k++)
			{
				ans[i][j] = (ans[i][j]+(ans[i][k]*ans[k][j])%MOD)%MOD;
			}
		}
	}
	return ans;
}

int eval(int x)
{
	if(x >= 0 && x <= 4)	return x;
	vector<vector<int>> cur, mu;
	if(x < 0)	
	{
		return -1;
	}
	mu = pos; 	
	cur = vector<vector<int>> (5, vector<int> (5));
	for(int i = 0; i < 5; i++)	cur[i][i] = 1;
	while(x)
	{
		if((x&1))
		{
			cur = mul(cur, mu);
		}
		mu = mul(mu, mu);
		x >>= 1;
	}
	return cur[0][0];
}

int main()
{
	pos = vector<vector<int>> (5, vector<int> (5));
	pos[0][0] = 5;
	pos[1][0] = 4;
	pos[2][0] = 3;
	pos[3][0] = 2;
	pos[4][0] = 1;
	pos[1][1] = 1;
	pos[2][2] = 1;
	pos[3][3] = 1;
	pos[4][4] = 1;
	for(int i = 0; i < 5; i++)	f[i] = i;
	for(int i = 5; i <= 1000000; i++)
	{
		f[i] = 5*f[i-1]+4*f[i-2]+3*f[i-3]+2*f[i-4]+f[i-5];
		f[i] %= MOD;
		// cout << f[i] << ' ';
		// cout << eval(i) << '\n';
	}
	int n, q;
	cin >> n >> q;
	vector<int> v(n+1);
	for(int i = 1; i <= n; i++)
	{
		cin >> v[i];
		v[i] = f[v[i]];
		// cout << v[i] << ' ';
		v[i] += v[i-1];
	}
	while(q--)
	{
		int t;
		cin >> t;
		if(t == 1)
		{
			int l, r;
			cin >> l >> r;
			// long long ans = 0;
			// for(int i = l; i <= r; i++)
			// {
				// ans = (ans+f(v[i]))%MOD;
			// }
			cout << (v[r]-v[l-1]+MOD)%MOD << '\n';
		}
		else{
			// int l, r, val;
			// cin >> l >> r >> val;
			// for(int i = l; i <= r; i++)
			// {
				// v[i] += val;
			// }
		}
	}
}
