#include <bits/stdc++.h>

using namespace std;

const int MOD = 1e8+543, N = 1e6+5;

long long seg[N];
vector<vector<long long>> pos, neg;
vector<vector<long long>> pwrs[62];

vector<long long> mul(vector<long long> &a, vector<vector<long long>> &b)
{
	vector<long long> ans(5);
	for(int j = 0; j < 5; j++)
	{
		for(int k = 0; k < 5; k++)
		{
			ans[j] = (ans[j]+(a[k]*b[k][j])%MOD)%MOD;
		}
	}
	return ans;
}

vector<vector<long long>> mul(vector<vector<long long>> &a, vector<vector<long long>> &b)
{
    vector<vector<long long>> ans;
    ans = vector<vector<long long>> (5, vector<long long> (5));
    for(int i = 0; i < 5; i++)
    {
        for(int j = 0; j < 5; j++)
        {
            for(int k = 0; k < 5; k++)
            {
                ans[i][j] = (ans[i][j]+(a[i][k]*b[k][j])%MOD)%MOD;
            }
        }
    }
    return ans;
}

int eval(int x)
{
	if(x >= 0 && x <= 4)	return x;
	if(x < 0)	
	{
		return -1;
	}
	vector<long long> cur(5);
	x -= 4;
	for(int i = 0; i < 5; i++)	cur[i] = 4-i;
	for(int i = 0; i < 62; i++)
	{
		if(!x)	break;
		if(!(x&(1ll << i)))	continue;
		cur = mul(cur, pwrs[i]);
		x ^= (1ll << i);
	}
	return cur[0];
}

int main()
{
	pos = vector<vector<long long>> (5, vector<long long> (5));
	pos[0][0] = 5;
	pos[1][0] = 4;
	pos[2][0] = 3;
	pos[3][0] = 2;
	pos[4][0] = 1;
	pos[0][1] = 1;
	pos[1][2] = 1;
	pos[2][3] = 1;
	pos[3][4] = 1;
	pwrs[0] = pos;
	for(int i = 1; i < 62; i++)
	{
		pwrs[i] = mul(pwrs[i-1], pwrs[i-1]);
	}
	int n, q;
	cin >> n >> q;
	vector<long long> v(n+1);
	for(int i = 1; i <= n; i++)
	{
		cin >> v[i];
		v[i] = eval(v[i]);
		v[i] += v[i-1];
		v[i] %= MOD;
	}
	while(q--)
	{
		int t;
		cin >> t;
		if(t == 1)
		{
			int l, r;
			cin >> l >> r;
			// long long ans = 0;
			// for(int i = l; i <= r; i++)
			// {
				// ans = (ans+f(v[i]))%MOD;
			// }
			cout << (v[r]-v[l-1]+MOD)%MOD << '\n';
		}
		else{
			// int l, r, val;
			// cin >> l >> r >> val;
			// for(int i = l; i <= r; i++)
			// {
				// v[i] += val;
			// }
		}
	}
}
