#include <bits/stdc++.h>
using namespace std;
#define int long long
long long mod = 1e8 + 543;
vector<vector<int>> mat = {{0,1,0,0,0},{0,0,1,0,0},{0,0,0,1,0},{0,0,0,0,1},{1,2,3,4,5}};
vector<vector<int>> mul(vector<vector<int>> a,vector<vector<int>> b){
    vector<vector<int>> c(a.size(),vector<int>(b[0].size(),0));
    for(int i = 0;i<a.size();i++){
        for(int j = 0;j<b[0].size();j++){
            long long ans = 0;
            for(int e = 0;e<a[0].size();e++){
                ans+=(a[i][e]*b[e][j])%mod;
                if(ans>=mod)ans-=mod;
            }
            c[i][j] = ans;
        }
    }
    return c;
}
vector<vector<int>> qpow(vector<vector<int>> a,int b){
    if(b==0){
        vector<vector<int>> iden(a.size(),vector<int>(a[0].size(),0));
        for(int i = 0;i<a.size();i++){
            for(int j = 0;j<a[0].size();j++){
                if(i==j)iden[i][j] = 1;
                else iden[i][j] = 0;
            }
        }
        return iden;
    }
    vector<vector<int>> h = qpow(a,b/2);
    h = mul(h,h);
    if(b&1)return mul(h,a);
    return h;
}
vector<vector<long long>> seg[400001],lazy[400001];
void build(int p,int l,int r){
    lazy[p] = {{1,0,0,0,0},{0,1,0,0,0},{0,0,1,0,0},{0,0,0,1,0},{0,0,0,0,1}};
    if(l==r){
        seg[p] = {{0},{1},{2},{3},{4}};
        return ;
    }
    int md = (l+r)/2;
    build(p*2,l,md);
    build(p*2+1,md+1,r);
    seg[p] = {{seg[p*2][0][0]+seg[p*2+1][0][0]},{seg[p*2][1][0]+seg[p*2+1][1][0]},{seg[p*2][2][0]+seg[p*2+1][2][0]},{seg[p*2][3][0]+seg[p*2+1][3][0]},{seg[p*2][4][0]+seg[p*2+1][4][0]}};
}
void prop(int p,int l,int r){
    seg[p] = mul(lazy[p],seg[p]);
    if(l!=r){
        lazy[p*2] = mul(lazy[p],lazy[p*2]);
        lazy[p*2+1] = mul(lazy[p],lazy[p*2+1]);
    }
    lazy[p] = {{1,0,0,0,0},{0,1,0,0,0},{0,0,1,0,0},{0,0,0,1,0},{0,0,0,0,1}};
}
void update(int p,int l,int r,int lq,int rq,vector<vector<long long>> lol){
    prop(p,l,r);
    if(l>=lq&&r<=rq){
        lazy[p] = mul(lazy[p],lol);
        prop(p,l,r);
        return ;
    }
    if(r<lq||l>rq)return ;
    int md = (l+r)/2;
    update(p*2,l,md,lq,rq,lol);
    update(p*2+1,md+1,r,lq,rq,lol);
    seg[p] = {{seg[p*2][0][0]+seg[p*2+1][0][0]},{seg[p*2][1][0]+seg[p*2+1][1][0]},{seg[p*2][2][0]+seg[p*2+1][2][0]},{seg[p*2][3][0]+seg[p*2+1][3][0]},{seg[p*2][4][0]+seg[p*2+1][4][0]}};
}
long long query(int p,int l,int r,int lq,int rq){
    if(l>=lq&&r<=rq)return seg[p][0][0];
    if(r<lq||l>rq)return 0;
    int md = (l+r)/2;
    return query(p*2,l,md,lq,rq)+query(p*2+1,md+1,r,lq,rq);
}
signed main(){
    int n,q;
    cin>>n>>q;
    int arr[n+1];
    for(int i = 1;i<=n;i++){
        cin>>arr[i];
    }
    build(1,1,n);
    for(int i = 1;i<=n;i++){
        update(1,1,n,i,i,qpow(mat,arr[i]));
    }
    while(q--){
        int ty;cin>>ty;
        if(ty==1){
            int l,r;
            cin>>l>>r;
            cout<<query(1,1,n,l,r)<<endl;
        }else {
            int l,r,va;
            cin>>l>>r>>va;
            update(1,1,n,l,r,qpow(mat,va));
        }
    }
}