#include <bits/stdc++.h>
using namespace std;
#pragma GCC optimize("Ofast")
long long mod = 1e8 + 543;
int mat[5][5];
int c1[5][1];
int c2[5][5];
int lol[5][5];
void mul1(int a[][5],int b[][1]){
    for(int i = 0;i<5;i++){
        for(int j = 0;j<1;j++){
            c1[i][j] = 0;
            for(int e = 0;e<5;e++){
                c1[i][j]+=(1ll*a[i][e]*b[e][j])%mod;
                if(c1[i][j]>=mod)c1[i][j]-=mod;
            }
        }
    }
}
void mul2(int a[][5],int b[][5]){
    for(int i = 0;i<5;i++){
        for(int j = 0;j<5;j++){
            c2[i][j] = 0;
            for(int e = 0;e<5;e++){
                c2[i][j]+=(1ll*a[i][e]*b[e][j])%mod;
                if(c2[i][j]>=mod)c2[i][j]-=mod;
            }
        }
    }
}
int lazy[400001][5][5];

int seg[400001][5][1];
bool in[400001];
void build(int32_t p,int32_t l,int32_t r){
    for(int i = 0;i<5;i++){
        for(int j = 0;j<5;j++){
            lazy[p][i][j] = (i==j);
        }
    }
    if(l==r){
        seg[p][0][0] = 0;
        seg[p][1][0] = 1;
        seg[p][2][0] = 2;
        seg[p][3][0] = 3;
        seg[p][4][0] = 4;
        return ;
    }
    int md = (l+r)>>1;
    build(p<<1,l,md);
    build(p<<1|1,md+1,r);
    seg[p][0][0] = seg[p<<1][0][0]+seg[p<<1|1][0][0];
    if(seg[p][0][0]>=mod)seg[p][0][0]-=mod;
    seg[p][1][0] = seg[p<<1][1][0]+seg[p<<1|1][1][0];
    if(seg[p][1][0]>=mod)seg[p][1][0]-=mod;
    seg[p][2][0] = seg[p<<1][2][0]+seg[p<<1|1][2][0];
    if(seg[p][2][0]>=mod)seg[p][2][0]-=mod;
    seg[p][3][0] = seg[p<<1][3][0]+seg[p<<1|1][3][0];
    if(seg[p][3][0]>=mod)seg[p][3][0]-=mod;
    seg[p][4][0] = seg[p<<1][4][0]+seg[p<<1|1][4][0];
    if(seg[p][4][0]>=mod)seg[p][4][0]-=mod;
}
void prop(int32_t p,int32_t l,int32_t r){
    if(!in[p])return ;
    mul1(lazy[p],seg[p]);
    seg[p][0][0] = c1[0][0];
    seg[p][1][0] = c1[1][0];
    seg[p][2][0] = c1[2][0];
    seg[p][3][0] = c1[3][0];
    seg[p][4][0] = c1[4][0];
    if(l!=r){
        mul2(lazy[p],lazy[p<<1]);
        swap(lazy[p<<1],c2);
        in[p<<1] = 1;
        in[p<<1|1] = 1;
        mul2(lazy[p],lazy[p<<1|1]);
        swap(lazy[p<<1|1],c2);
    }
    for(int i = 0;i<5;i++){
        for(int j = 0;j<5;j++){
            if(i!=j)lazy[p][i][j] = 0;
            else lazy[p][i][j] = 1;
        }
    }
    in[p] = 0;
}
void update(int p,int l,int r,int lq,int rq){
    if(l>=lq&&r<=rq){
        mul2(lazy[p],lol);
        swap(lazy[p],c2);
        in[p] = 1;
        prop(p,l,r);
        return ;
    }
    prop(p,l,r);
    if(r<lq||l>rq)return ;
    int md = (l+r)>>1;
    update(p<<1,l,md,lq,rq);
    update(p<<1|1,md+1,r,lq,rq);
    seg[p][0][0] = seg[p<<1][0][0]+seg[p<<1|1][0][0];
    if(seg[p][0][0]>=mod)seg[p][0][0]-=mod;
    seg[p][1][0] = seg[p<<1][1][0]+seg[p<<1|1][1][0];
    if(seg[p][1][0]>=mod)seg[p][1][0]-=mod;
    seg[p][2][0] = seg[p<<1][2][0]+seg[p<<1|1][2][0];
    if(seg[p][2][0]>=mod)seg[p][2][0]-=mod;
    seg[p][3][0] = seg[p<<1][3][0]+seg[p<<1|1][3][0];
    if(seg[p][3][0]>=mod)seg[p][3][0]-=mod;
    seg[p][4][0] = seg[p<<1][4][0]+seg[p<<1|1][4][0];
    if(seg[p][4][0]>=mod)seg[p][4][0]-=mod;
}    
long long query(int p,int l,int r,int lq,int rq){
    if(l>=lq&&r<=rq){
        prop(p,l,r);
        return seg[p][0][0];
    }
    if(r<lq||l>rq)return 0;
    prop(p,l,r);
    int md = (l+r)>>1;
    return (query(p*2,l,md,lq,rq)+query(p*2+1,md+1,r,lq,rq));
}
int svol[28][5][5];
int nah[28][256][5][5];
signed main(){
    ios_base::sync_with_stdio(false);cin.tie(0);
    mat[0][1] = 1;
    mat[1][2] = 1;
    mat[2][3] = 1;
    mat[3][4] = 1;
    mat[4][0] = 1;
    mat[4][1] = 2;
    mat[4][2] = 3;
    mat[4][3] = 4;
    mat[4][4] = 5;
    int n,q;cin>>n>>q;
    int arr[n+1];
    for(int i = 1;i<=n;i++){
        cin>>arr[i];
    }
    build(1,1,n);
    for(int e1 = 0;e1<5;e1++)for(int e2 = 0;e2<5;e2++)svol[0][e1][e2] = mat[e1][e2];
    for(int i = 1;i<28;i++){
        mul2(svol[i-1],svol[i-1]);
        for(int e1 = 0;e1<5;e1++)for(int e2 = 0;e2<5;e2++)svol[i][e1][e2] = c2[e1][e2];
    }
    for(int i = 0;i<28;i+=8){
        for(int j = 0;j<(1<<8);j++){
            for(int e1 = 0;e1<5;e1++)for(int e2 = 0;e2<5;e2++)nah[i][j][e1][e2] = (e1==e2);
            for(int e = i;e<i+8;e++){
                if(j&(1<<(e-i))){
                    mul2(svol[e],nah[i][j]);
                    swap(c2,nah[i][j]);        
                }
            }
        }
    }
    for(int i = 1;i<=n;i++){
        for(int e1 = 0;e1<5;e1++)for(int e2 = 0;e2<5;e2++)lol[e1][e2] = (e1==e2);
        int msb = arr[i];
        for(int e = 0;e<28;e+=8){
            mul2(nah[e][msb&255],lol);
            swap(c2,lol);
            msb>>=8;
        }
        update(1,1,n,i,i);
    }
    while(q--){
        int ty;cin>>ty;
        if(ty==1){
            int l,r;
            cin>>l>>r;
            cout<<query(1,1,n,l,r)%mod<<"\n";
        }else{
            int l,r,va;
            cin>>l>>r>>va;
            for(int e1 = 0;e1<5;e1++)for(int e2 = 0;e2<5;e2++)lol[e1][e2] = (e1==e2);
            int msb = va;
            for(int e = 0;e<28;e+=8){
                mul2(nah[e][msb&255],lol);
                swap(c2,lol);
                msb>>=8;
            }
            update(1,1,n,l,r);           
        }
    }
}