#include "bits/stdc++.h"
using namespace std;
typedef long long ll;
#define row vector<int>
#define matrix vector<row>
const ll mod=1e8+543;
ll mul(ll a,ll b){
    return a%mod*(b%mod)%mod;
}
int add(int a,int b){
    return (a+b)%mod;
}
matrix identity(int n){
    matrix ret(n,row(n));
    for(int i=0;i<n;i++)ret[i][i]=1;
    return ret;
}
matrix multiply(matrix a,matrix b){
    int n=a.size();
    matrix ret(n,row(n));
    for(int i=0;i<n;i++){
        for(int j=0;j<n;j++){
            for(int k=0;k<n;k++){
                ret[i][j]=add(ret[i][j],mul(a[i][k],b[k][j]));
            }
        }
    }
    return ret;
}
matrix power(matrix a,ll k){
    if(k==0)return identity(6);
    if(k==1)return a;
    matrix r=power(a,k/2);
    if(k&1){
        return multiply(multiply(r,r),a);
    }
    else{
        return multiply(r,r);
    }
}
int get(ll n){
    if(n<5){
        return n;
    }
    matrix a(6,row(6)),b(6,row(6));
    for(int i=0;i<5;i++)a[0][i]=i;
    a[0][5]=40;
    for(int i=0;i<5;i++)b[i+1][i]=1;
    for(int i=1;i<6;i++)b[i][5]=i;
    a=multiply(a,power(b,n-5));
    return a[0][5];
}
int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);      cout.tie(0);
    int n,q;cin>>n>>q;
    vector<ll>arr(n+1);
    for(int i=1;i<=n;i++)cin>>arr[i];
    int type,l,r,value;
    while(q--){
        cin>>type>>l>>r;
        if(type==1){
            cout<<get(arr[l])<<"\n";
        }
        else{
            cin>>value;
            arr[l]+=value;
        }
    }
}