#include <bits/stdc++.h>
using namespace std;
#define ll long long
const ll MOD = 1e8 + 543; 
ll add(ll a, ll b) {
	if ((a += b) >= MOD) a -= MOD;
	return a;
}
ll mul(ll a, ll b) {
	return a * b % MOD;
}
ll sub(ll a, ll b) {
	if ((a -= b) < 0) a += MOD;
	return a;
}
const int MAXN = 1e6 + 6;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, q;
	cin >> n >> q;
	vector<int> a(n + 1);
	for (int i = 1; i <= n; ++i) cin >> a[i];
	vector<ll> sequence(MAXN), pref(n + 1);
	pref[0] = 0;
	for (int i = 0; i < 5; ++i) sequence[i] = i;
	for (int i = 5; i < MAXN; ++i) {
		for (int j = 1; j <= 5; ++j) {
			sequence[i] = add(sequence[i], mul(j, sequence[i + j - 6]));
		}
	}
	for (int i = 1; i <= n; ++i) pref[i] = add(pref[i - 1], sequence[a[i]]);
	while (q--) {
		int t;
		cin >> t;
		assert(t == 1);
		int l, r;
		cin >> l >> r;
		ll ans = pref[r];
		if (l) ans = sub(ans, pref[l - 1]);
		cout << ans << '\n';
	}
}