#include <bits/stdc++.h>
#include "puzzle.h"
#ifdef MINA
#include "Lgrader.cpp"
#endif
using namespace std;
#define ll long long
#define sz(x) (int) x.size()

void init(int numSubtests, double timeLimit) {

}
map<pair<array<ll, 4>, vector<int>>, pair<bool, int>> mem;
vector<vector<int>> a, c;
int Down[105][105], Right[105][105], idx[105][105];
vector<int> format(vector<int> v) {
	int cur = 0;
	map<int, int> val;
	vector<int> ret = v;
	for (int i = 0; i < sz(v); i++) {
		if (val.find(v[i]) == val.end()) {
			val[v[i]] = cur++;
		}
		ret[i] = val[v[i]];
	}
	return ret;
}
pair<bool, int> f(int i, int j, int cntleft, ll msk, vector<int> comps) {
	comps = format(comps);
	if (i == sz(a)) {
		pair<bool, int> ret = make_pair(msk == 0, -1);
		for (auto &val : comps) {
			ret.first &= val == 0;
		}
		return ret;
	}
	pair<array<ll, 4>, vector<int>> state = make_pair((array<ll, 4>) {i, j, cntleft, msk}, comps);
	if (mem.find(state) != mem.end()) {
		return mem[state];
	}
	if (j == sz(a[i])) {
		if (cntleft) return mem[state] = make_pair(0, -1);
		return mem[state] = f(i + 1, 0, 0, msk, comps);
	}
	int cntup = (msk >> (2 * j)) & 3;
	pair<bool, int> mx = {0, -1};
	if (a[i][j]) {
		for (int cntright = 0; cntright <= 2; cntright++) {
			ll cntdown = a[i][j] - cntleft - cntup - cntright;
			if (cntdown < 0 || cntdown > 2) continue;
			vector<int> newcomps = comps;
			if (cntright) {
				if (Right[i][j] == -1) continue;
				int old = comps[Right[i][j]];
				for (auto &val : newcomps) {
					if (val == old) {
						val = comps[idx[i][j]];
					}
				}
			}
			if (cntdown) {
				if (Down[i][j] == -1) continue;
				int old = comps[Down[i][j]];
				for (auto &val : newcomps) {
					if (val == old) {
						val = comps[idx[i][j]];
					}
				}
			}
			ll newmsk = (msk & (~(3ll << (2 * j)))) | (cntdown << (2 * j));
			mx = max(mx, make_pair(f(i, j + 1, cntright, newmsk, newcomps).first, cntright));
		}
		return mem[state] = mx;
	} else {
		if (cntleft && cntup) {
			return mem[state] = make_pair(0, -1);
		}
		return mem[state] = f(i, j + 1, cntleft, msk, comps);
	}
}
void build(int i, int j, int cntleft, ll msk, vector<int> comps) {
	comps = format(comps);
	if (i == sz(a)) {
		return;
	}
	pair<array<ll, 4>, vector<int>> state = make_pair((array<ll, 4>) {i, j, cntleft, msk}, comps);
	if (j == sz(a[i])) {
		build(i + 1, 0, 0, msk, comps);
		return;
	}
	ll cntup = (msk >> (2 * j)) & 3;
	pair<bool, int> mx = mem[state];
	if (a[i][j]) {
		int cntright = mx.second;
		ll cntdown = a[i][j] - cntleft - cntup - cntright;
		vector<int> newcomps = comps;
		if (cntright) {
			int old = comps[Right[i][j]];
			for (auto &val : newcomps) {
				if (val == old) {
					val = comps[idx[i][j]];
				}
			}
		}
		if (cntdown) {
			int old = comps[Down[i][j]];
			for (auto &val : newcomps) {
				if (val == old) {
					val = comps[idx[i][j]];
				}
			}
		}
		ll newmsk = (msk & (~(3ll << (2 * j)))) | (cntdown << (2 * j));
		build(i, j + 1, cntright, newmsk, newcomps);
	} else {
		if (cntleft == 1) {
			c[i][j] = -1;
		} else if (cntleft == 2) {
			c[i][j] = -3;
		}
		if (cntup == 1) {
			c[i][j] = -2;
		} else if (cntup == 2) {
			c[i][j] = -4;
		}
		build(i, j + 1, cntleft, msk, comps);
	}
}
bool solve(vector<vector<int>> &b) {
	c = a = b;
	mem.clear();

	int cnt = 0;
	for (int i = 0; i < sz(a); i++) {
		for (int j = 0; j < sz(a[i]); j++) {
			idx[i][j] = cnt++;
		}
	}
	vector<int> comps(cnt);
	for (int i = 0; i < cnt; i++) {
		comps[i] = 0;
	}
	for (int i = 0; i < sz(a); i++) {
		int lst = -1;
		for (int j = sz(a[i]) - 1; j >= 0; j--) {
			Right[i][j] = lst;
			if (a[i][j] != 0) {
				lst = idx[i][j];
			}
		}
	}
	for (int j = 0; j < sz(a[0]); j++) {
		int lst = -1;
		for (int i = sz(a) - 1; i >= 0; i--) {
			Down[i][j] = lst;
			if (a[i][j] != 0) {
				lst = idx[i][j];
			}
		}
	}
	pair<bool, int> val = f(0, 0, 0, 0, comps);
// 	cout << val.first << endl;
	assert(val.first);
	build(0, 0, 0, 0, comps);
	for (int i = 0; i < sz(a); i++) {
		for (int j = 0; j < sz(a[i]); j++) {
			b[i][j] = c[i][j];
		}
	}
	return 1;
}
