#include <bits/stdc++.h>
#define dbg(x) cout << (#x) << " : " << x << endl
#define dbeg(x) cout << (#x) << " : " << x << " "
#define sz(x) int(x.size())
#define fs first
#define sc second
#define LOOP(n) for(int rp=0;rp<n;rp++)
#define pb push_back
#define all(x) x.begin(),x.end()
using namespace std;
typedef long long ll;
const int SZ=1e5+7;
const ll INF=1e18+7;
int MOD=1e8+543;
mt19937_64 rng(time(0));
int rnd(int l,int r){
    return uniform_int_distribution<int>(l,r)(rng);
}
int getN(){
    int x;cin >> x;
    return x;
}
int add(int x,int y){
    x+=y;if(x>=MOD)x-=MOD;
    return x;
}
int sub(int x,int y){
    x-=y;if(x<0)x+=MOD;
    return x;
}
int mul(int x,int y){
    ll z=(x*1ll*y);
    if(z>=MOD)z%=MOD;
    return z;
}
int pwr(int a,ll b){
    int ans=1;
    while(b>0){
        if(b&1)ans=mul(ans,a);
        a=mul(a,a),b>>=1;
    }
    return ans;
}
int inv(int a){
    return pwr(a,MOD-2);
}
vector<vector<int>>I(int n){
    vector<vector<int>>a(n,vector<int>(n,0));
    for(int i=0;i<n;i++)a[i][i]=1;
    return a;
}
vector<vector<int>>rmv(vector<vector<int>>&a,int x,int y){
    int n=sz(a);
    vector<vector<int>>b(n-1,vector<int>(n-1,0));
    for(int i=0;i<n;i++){
        for(int j=0;j<n;j++){
            if(i==x||j==y)continue;
            b[i-int(i>x)][j-int(j>y)]=a[i][j];
        }
    }
    return b;
}
int DET(vector<vector<int>>&a){
    int n=sz(a),D=0;
    vector<vector<int>>c;
    if(n==1)return a[0][0];
    for(int i=0;i<n;i++){
        c=rmv(a,0,i);
        D+=((i&1)?-1:1)*a[0][i]*DET(c);
    }
    return D;
}
vector<vector<int>>COF(vector<vector<int>>&a){
    int n=sz(a);
    vector<vector<int>>c(n,vector<int>(n,0)),z;
    for(int i=0;i<n;i++){
        for(int j=0;j<n;j++){
            z=rmv(a,i,j);
            c[i][j]=(((i+j)&1)?-1:1)*DET(z);
        }
    }
    return c;
}
vector<vector<int>>addm(vector<vector<int>>&a,vector<vector<int>>&b){
    int n=sz(a),m=sz(a[0]);
    vector<vector<int>>c(n,vector<int>(m,0));
    for(int i=0;i<n;i++){
        for(int j=0;j<m;j++){
            c[i][j]=add(a[i][j],b[i][j]);
        }
    }
    return c;
}
vector<vector<int>>mulm(vector<vector<int>>&a,vector<vector<int>>&b){
    int n=sz(a),m=sz(b[0]),k=sz(a[0]);
    vector<vector<int>>c(n,vector<int>(m,0));
    for(int i=0;i<n;i++){
        for(int l=0;l<k;l++){
            if(a[i][l]==0)continue;
            for(int j=0;j<m;j++){
                if(b[l][j]==0)continue;
                c[i][j]=add(c[i][j],mul(a[i][l],b[l][j]));
            }
        }
    }
    return c;
}
vector<vector<int>>A,B;
int n,q;
vector<vector<int>>/*sg[SZ*2],lz[SZ*2],*/a[SZ];
vector<vector<int>>pwrm(ll b){
    vector<vector<int>>a=A;
    int n=sz(a);
    if(b<0)b=-b,a=B;
    vector<vector<int>>ans=I(n);
    while(b>0){
        if(b&1)ans=mulm(ans,a);
        a=mulm(a,a),b>>=1;
    }
    return ans;
}
int main(){
    ios_base::sync_with_stdio(0);cin.tie(0);
    A={{0,0,0,0,1},
      {1,0,0,0,2},
      {0,1,0,0,3},
      {0,0,1,0,4},
      {0,0,0,1,5}};
    //fill(sg,sg+SZ*2,vector<vector<int>>(5,vector<int>(5,0)));
    //fill(lz,lz+SZ*2,vector<vector<int>>(5,vector<int>(5,0)));
    B=COF(A);
    for(int i=0;i<5;i++){
        for(int j=0;j<i;j++)swap(B[i][j],B[j][i]);
    }
    for(int i=0;i<5;i++){
        for(int j=0;j<5;j++)B[i][j]=add(B[i][j],MOD);
    }
    cin >> n >> q;
    for(int i=0;i<n;i++){
        a[i]=pwrm(getN());
        if(i)a[i]=addm(a[i],a[i-1]);
    }
    LOOP(q){
        int T,l,r;cin >> T >> l >> r;l--,r--;
        if(T==1){
            int ans=0;
            /*for(int i=l;i<=r;i++){
                LOOP(5)ans=add(ans,mul(a[i][rp][0],rp));
            }*/
            LOOP(5)ans=add(ans,mul(a[r][rp][0],rp));
            if(--l>=0)LOOP(5)ans=add(ans,mul(a[l][rp][0],rp));
            cout << ans << "\n";
        }
        else{
            int vl;cin >> vl;
            vector<vector<int>>C=pwrm(vl);
            for(int i=l;i<=r;i++){
                a[i]=mulm(a[i],C);
            }
            //cout << "DONE" << endl;
        }
    }
    return 0;
}

