#include <bits/stdc++.h>
#define vi vector <int>
#define int long long
#define MOD 1000000543
#define pb push_back
#define MAXN 100000
using namespace std;
struct arr{
	int p[6][6];
};
arr mult(arr a,arr b){
	arr res;
	for (int i=1;i<=5;i++){
		for (int j=1;j<=5;j++){
			res.p[i][j]=0;
			for (int k=1;k<=5;k++){
				res.p[i][j]+=(a.p[k][j]*b.p[i][k])%MOD;
				res.p[i][j]%=MOD;
			}
		}
	}
	return res;
}
arr binpow(arr a,int b){
	arr res=a;
	b--;
	while (b>0){
		if (b&1)res=mult(res,a);
		a=mult(a,a);
		b>>=1;
	}
	return res;
}
arr I;
arr Plus;
arr Minus;
arr pwr(arr a,int x){
	if (x==0)return a;
	if (x>0){
		return mult(a,binpow(Plus,x));
	}
	if (x<0){
		return mult(a,binpow(Minus,-x));
	}
}
arr add(arr a,arr b){
	arr res;
	for (int i=1;i<=5;i++){
		for (int j=1;j<=5;j++){
			res.p[i][j]=(a.p[i][j]+b.p[i][j])%MOD;
		}
	}
	return res;
}
arr t[4*MAXN+1];
arr lazy[4*MAXN+1];
arr II,III;
void build(int v,int tl,int tr,arr a[]){
	lazy[v]=II;
	if (tl==tr){
		t[v]=a[tl];
	}else{
		int tm=(tl+tr)/2;
		build(v*2,tl,tm,a);
		build(v*2+1,tm+1,tr,a);
		t[v]=add(t[v*2],t[v*2+1]);
	}
}
void push(int v){
	t[2*v]=mult(t[2*v],lazy[v]);
	t[2*v+1]=mult(t[2*v+1],lazy[v]);
	lazy[v]=mult(lazy[2*v],lazy[v]);
	lazy[2*v]=mult(lazy[2*v+1],lazy[v]);
	lazy[v]=II;
}
arr query(int v,int tl,int tr,int l,int r){
	if (l>r)return III;
	if (tl==l && tr==r)return t[v];
	push(v);
	int tm=(tl+tr)/2;
	return add(query(v*2,tl,tm,l,min(r,tm)),query(v*2+1,tm+1,tr,max(l,tm+1),r));
}
void up(int v,int tl,int tr,int l,int r,arr val){
	if (l>r)return;
	if (tl==l && tr==r){
		t[v]=mult(t[v],val);
		lazy[v]=mult(lazy[v],val);
	}else{
		push(v);
		int tm=(tl+tr)/2;
		up(v*2,tl,tm,l,min(r,tm),val);
		up(v*2+1,tm+1,tr,max(l,tm+1),r,val);
	}
}
signed main(){
	int n,q;
	cin>>n>>q;
	for (int i=1;i<=5;i++)II.p[1][i]=(i==1);
	for (int i=1;i<=5;i++)II.p[2][i]=(i==2);
	for (int i=1;i<=5;i++)II.p[3][i]=(i==3);
	for (int i=1;i<=5;i++)II.p[4][i]=(i==4);
	for (int i=1;i<=5;i++)II.p[5][i]=(i==5);
	for (int i=1;i<=5;i++)III.p[1][i]=0;
	for (int i=1;i<=5;i++)III.p[2][i]=0;
	for (int i=1;i<=5;i++)III.p[3][i]=0;
	for (int i=1;i<=5;i++)III.p[4][i]=0;
	for (int i=1;i<=5;i++)III.p[5][i]=0;
	for (int i=1;i<=5;i++)I.p[1][i]=4;
	for (int i=1;i<=5;i++)I.p[2][i]=3;
	for (int i=1;i<=5;i++)I.p[3][i]=2;
	for (int i=1;i<=5;i++)I.p[4][i]=1;
	for (int i=1;i<=5;i++)I.p[5][i]=0;
	for (int i=1;i<=5;i++)Plus.p[1][i]=5-i+1;
	for (int i=1;i<=5;i++)Plus.p[2][i]=(i==1);
	for (int i=1;i<=5;i++)Plus.p[3][i]=(i==2);
	for (int i=1;i<=5;i++)Plus.p[4][i]=(i==3);
	for (int i=1;i<=5;i++)Plus.p[5][i]=(i==4);

	for (int i=1;i<=5;i++)Minus.p[1][i]=(i==2);
	for (int i=1;i<=5;i++)Minus.p[2][i]=(i==3);
	for (int i=1;i<=5;i++)Minus.p[3][i]=(i==4);
	for (int i=1;i<=5;i++)Minus.p[4][i]=(i==5);
	for (int i=2;i<=5;i++)Minus.p[5][i]=(-7+i+MOD)%MOD;
	Minus.p[5][1]=1;
	arr a[n+1];
	for (int i=1;i<=n;i++){
		int x;
		cin>>x;
		a[i]=pwr(I,x-4);
	}
	build(1,1,n,a);
	while (q--){
		int tp;
		cin>>tp;
		if (tp==1){
			int l,r;
			cin>>l>>r;
			cout<<query(1,1,n,l,r).p[1][1]<<'\n';
		}else{
			int l,r,val;
			cin>>l>>r>>val;
			if (val>0)up(1,1,n,l,r,binpow(Plus,val));
			if (val<0)up(1,1,n,l,r,binpow(Minus,-val));
		}
	}
}