#include<iostream>
#include<vector>
using namespace std;

int m=1e8+543;

int n, q, l, r, mode, added;

int mod(long long a){
	while(a<0){
		a+=m;
	}
	return a%m;
}

struct coeff{
	long long c0=0;
	long long c1=0;
	long long c2=0;
	long long c3=0;
	long long c4=0;
	int getval(){
		return mod(this->c1+2*this->c2+3*this->c3+4*this->c4);
	}
};

vector<int> a;

coeff ad[45][5], su[45][5];

coeff add(coeff a, long long b){
	coeff ans;
	long long p=1<<22;
	p<<=22;
	int i=44;
	if(b<0){
		b*=-1;
		while(p!=0){
			if(p&b){
				ans.c0=mod(
					su[i][0].c0*a.c0+
					su[i][1].c0*a.c1+
					su[i][2].c0*a.c2+
					su[i][3].c0*a.c3+
					su[i][4].c0*a.c4);
				ans.c1=mod(
					su[i][0].c1*a.c0+
					su[i][1].c1*a.c1+
					su[i][2].c1*a.c2+
					su[i][3].c1*a.c3+
					su[i][4].c1*a.c4);
				ans.c2=mod(
					su[i][0].c2*a.c0+
					su[i][1].c2*a.c1+
					su[i][2].c2*a.c2+
					su[i][3].c2*a.c3+
					su[i][4].c2*a.c4);
				ans.c3=mod(
					su[i][0].c3*a.c0+
					su[i][1].c3*a.c1+
					su[i][2].c3*a.c2+
					su[i][3].c3*a.c3+
					su[i][4].c3*a.c4);
				ans.c4=mod(
					su[i][0].c4*a.c0+
					su[i][1].c4*a.c1+
					su[i][2].c4*a.c2+
					su[i][3].c4*a.c3+
					su[i][4].c4*a.c4);
				a=ans;
			}
			p>>=1;
			i--;
		}
	}else{
		while(p!=0){
			if(p&b){
				ans.c0=mod(
					ad[i][0].c0*a.c0+
					ad[i][1].c0*a.c1+
					ad[i][2].c0*a.c2+
					ad[i][3].c0*a.c3+
					ad[i][4].c0*a.c4);
				ans.c1=mod(
					ad[i][0].c1*a.c0+
					ad[i][1].c1*a.c1+
					ad[i][2].c1*a.c2+
					ad[i][3].c1*a.c3+
					ad[i][4].c1*a.c4);
				ans.c2=mod(
					ad[i][0].c2*a.c0+
					ad[i][1].c2*a.c1+
					ad[i][2].c2*a.c2+
					ad[i][3].c2*a.c3+
					ad[i][4].c2*a.c4);
				ans.c3=mod(
					ad[i][0].c3*a.c0+
					ad[i][1].c3*a.c1+
					ad[i][2].c3*a.c2+
					ad[i][3].c3*a.c3+
					ad[i][4].c3*a.c4);
				ans.c4=mod(
					ad[i][0].c4*a.c0+
					ad[i][1].c4*a.c1+
					ad[i][2].c4*a.c2+
					ad[i][3].c4*a.c3+
					ad[i][4].c4*a.c4);
				a=ans;
			}
			p>>=1;
			i--;
		}
	}
	return a;
}

struct Node{
	Node(int l, int r){
		this->llim=l;
		this->rlim=r;
		if(l!=r){
			this->lchild=new Node(l, (l+r)/2);
			this->rchild=new Node((l+r)/2+1, r);
			this->val.c0=mod(this->lchild->val.c0+this->rchild->val.c0);
			this->val.c1=mod(this->lchild->val.c1+this->rchild->val.c1);
			this->val.c2=mod(this->lchild->val.c2+this->rchild->val.c2);
			this->val.c3=mod(this->lchild->val.c3+this->rchild->val.c3);
			this->val.c4=mod(this->lchild->val.c4+this->rchild->val.c4);
		}else{
			this->val.c0=1;
			this->val.c1=0;
			this->val.c2=0;
			this->val.c3=0;
			this->val.c4=0;
			this->val=add(this->val, a[l]);
		}
	}
	coeff val;
	int llim;
	int rlim;
	long long shouldadd=0;
	Node* rchild=NULL;
	Node* lchild=NULL;
	void update(int l, int r, int amount){
		if(this->shouldadd!=0){
			if(this->rchild!=NULL){
				this->rchild->shouldadd+=this->shouldadd;
				this->lchild->shouldadd+=this->shouldadd;
			}
			this->val=add(this->val, this->shouldadd);
			this->shouldadd=0;
		}
		if(l==this->llim && r==this->rlim){
			if(this->lchild!=NULL){
				this->lchild->shouldadd+=amount;
				this->rchild->shouldadd+=amount;
			}
			this->val=add(this->val, amount);
			return;
		}
		if(l>this->lchild->rlim){
			this->rchild->update(l, r, amount);
			this->lchild->update(this->lchild->llim, this->lchild->rlim, 0);
		}else{
			if(r<this->rchild->llim){
				this->rchild->update(this->rchild->llim, this->rchild->rlim, 0);
				this->lchild->update(l, r, amount);
			}else{
				this->lchild->update(l, this->lchild->rlim, amount);
				this->rchild->update(this->rchild->llim, r, amount);
			}
		}
		this->val.c0=mod(this->lchild->val.c0+this->rchild->val.c0);
		this->val.c1=mod(this->lchild->val.c1+this->rchild->val.c1);
		this->val.c2=mod(this->lchild->val.c2+this->rchild->val.c2);
		this->val.c3=mod(this->lchild->val.c3+this->rchild->val.c3);
		this->val.c4=mod(this->lchild->val.c4+this->rchild->val.c4);
	}
	int query(int l, int r){
		if(this->shouldadd!=0){
			if(this->rchild!=NULL){
				this->rchild->shouldadd+=this->shouldadd;
				this->lchild->shouldadd+=this->shouldadd;
			}
			this->val=add(this->val, this->shouldadd);
			this->shouldadd=0;
		}
		if(l==this->llim && r==this->rlim){
			return this->val.getval();
		}
		if(l>this->lchild->rlim){
			return this->rchild->query(l, r);
		}
		if(r<this->rchild->llim){
			return this->lchild->query(l, r);
		}
		return mod(this->lchild->query(l, this->lchild->rlim)+this->rchild->query(this->rchild->llim, r));
	}
};

Node* root=NULL;

int main(){
	ad[0][0].c1=1;
	ad[0][1].c2=1;
	ad[0][2].c3=1;
	ad[0][3].c4=1;
	ad[0][4].c0=1;
	ad[0][4].c1=2;
	ad[0][4].c2=3;
	ad[0][4].c3=4;
	ad[0][4].c4=5;
	for(int i=1; i<45; i++){
		for(int j=0; j<5; j++){
			ad[i][j]=add(ad[i-1][j], 1<<(i-1));
		}
	}
	su[0][0].c0=-2;
	su[0][0].c1=-3;
	su[0][0].c2=-4;
	su[0][0].c3=-5;
	su[0][0].c4=1;
	su[0][1].c0=1;
	su[0][2].c1=1;
	su[0][3].c2=1;
	su[0][4].c3=1;
	for(int i=1; i<45; i++){
		for(int j=0; j<5; j++){
			su[i][j]=add(su[i-1][j], 0-1<<(i-1));
		}
	}

	scanf("%d%d", &n, &q);
	a.reserve(n);
	for(int i=0; i<n; i++){
		scanf("%d", &a[i]);
	}
	root=new Node(0, n-1);
	// printf("%d", root->query(0, 0));
	while(q--){
		scanf("%d%d%d", &mode, &l, &r);
		l--;
		r--;
		if(mode==1){
			printf("%d\n", root->query(l, r));
			// printf("raw coefficients: %d, %d, %d, %d, %d;\n", root->val.c0, root->val.c1, root->val.c2, root->val.c3, root->val.c4);
		}else{
			scanf("%d", &added);
			root->update(l, r, added);
		}
	}
}