#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <iomanip>
#include <cassert>
#include <chrono>
#include <queue>

#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define lb lower_bound
#define ub upper_bound

using namespace std;

typedef long long ll;
typedef double ld;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef set<int> si;
typedef vector<si> vsi;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef vector<char> vc;
typedef vector<vc> vvc;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
typedef vector<vpi> vvpi;
typedef set<pi> spi;
typedef vector<spi> vspi;

template<typename t> bool minravno(t& a, t b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> bool maxravno(t& a, t b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> void input(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cin >> a[k];
}
template<typename t> void print(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cout << a[k] << '\n';
}

const int INF = 1e18, MAXN = 1e6 + 10, MOD = (int)1e8 + 543;

int x[MAXN];

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n, q;
	cin >> n >> q;
	vi a(n + 1);
	input(a, 1);
	x[0] = 0;
	x[1] = 1;
	x[2] = 2;
	x[3] = 3;
	x[4] = 4;
	for (int i = 5; i < MAXN; ++i) {
		x[i] = x[i - 1] * 5 + x[i - 2] * 4 + x[i - 3] * 3 + x[i - 4] * 2 + x[i - 5] * 1;
		x[i] %= MOD;
	}
	vi p(n + 1, 0);
	for (int i = 1; i <= n; ++i)
		p[i] = (p[i - 1] + x[a[i]]) % MOD;
	while (q--) {
		int t, l, r;
		cin >> t >> l >> r;
		cout << (p[r] - p[l - 1] + MOD) % MOD << '\n';;
	}

	return 0;
}