#prag\
ma GCC optimize("O3,unroll-loops")
#prag\
ma GCC target("avx,avx2,bmi,sse,sse3,popcnt")

#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int MOD = int(1e8) + 543;

void madd(int &x, int y) {
    if ((x += y) >= MOD) {
        x -= MOD;
    }
}

using mat = int[5][5];

mat neut, prv, nxt;

constexpr int F = 1 << 15;

mat powers[2][F + 1];
mat fpower[2][F];

void mult(mat a, mat b, mat res) {
    for (int i = 0; i < 5; ++i) {
        for (int j = 0; j < 5; ++j) {
            ll sum = 0;
            for (int k = 0; k < 5; ++k) {
                sum += ll(a[i][k]) * b[k][j];
            }
            res[i][j] = sum % MOD;
        }
        continue;
        for (int k = 0; k < 5; ++k) {
            if (a[i][k]) {
                for (int j = 0; j < 5; ++j) {
//                    if (b[k][j]) {
                        res[i][j] = (res[i][j] + ll(a[i][k]) * b[k][j]) % MOD;
//                    }
                }
            }
        }
    }
//    return res;
}

void mult2(mat a, mat b) {
    static mat tmp;
    memcpy(tmp, b, sizeof(tmp));
    mult(a, tmp, b);
}

void power(int side, int b, mat res) {
    int full = b >> 15;
    int rem = b & (F - 1);
    mult(fpower[side][full], powers[side][rem], res);
}

mat t[1 << 18], tag[1 << 18];
int here[1 << 18];
int sz = 1;

void tapply(int x, mat tg) {
    mult2(tg, t[x]);
    mult2(tg, tag[x]);
    here[x] = true;
}

void push(int x) {
    if (here[x]) {
        tapply(x << 1, tag[x]);
        tapply(x << 1 | 1, tag[x]);
        memcpy(tag[x], neut, sizeof(tag[x]));
        here[x] = false;
    }
}

void pull(int x) {
    for (int i = 0; i < 5; ++i) {
        for (int j = 0; j < 5; ++j) {
            t[x][i][j] = t[x << 1][i][j] + t[x << 1 | 1][i][j];
            if (t[x][i][j] >= MOD) {
                t[x][i][j] -= MOD;
            }
        }
    }
//    t[x] = t[x << 1] + t[x << 1 | 1];
}

void init(int n, vector<int> a) {
    sz = 1 << __lg(n) + !!(n & (n - 1));
    for (int i = 0; i < 2 * sz; ++i) {
        memset(t[i], 0, sizeof(t[i]));
    }
    for (int i = 0; i < 2 * sz; ++i) {
        memcpy(tag[i], neut, sizeof(tag[i]));
        here[i] = false;
    }
    for (int i = 0; i < n; ++i) {
        (a[i] >= 0 ? power(0, a[i], t[i + sz]) : power(1, -a[i], t[i + sz]));
    }
    for (int i = sz - 1; i > 0; --i) {
        pull(i);
    }
}

void rangeApply(int l, int r, mat tg, int x = 1, int lx = 0, int rx = sz) {
    if (l >= rx || lx >= r) {
        return;
    }
    if (l <= lx && rx <= r) {
        return tapply(x, tg);
    }
    int mid = lx + rx >> 1;
    push(x);
    rangeApply(l, r, tg, x << 1, lx, mid);
    rangeApply(l, r, tg, x << 1 | 1, mid, rx);
    pull(x);
}

mat result{};

void rangeSum(int l, int r, int x = 1, int lx = 0, int rx = sz) {
    if (l >= rx || lx >= r) {
        return;
    }
    if (l <= lx && rx <= r) {
//        for (int i = 4; i < 5; ++i) {
            for (int j = 0; j < 5; ++j) {
                madd(result[4][j], t[x][4][j]);
            }
//        }
        return;
    }
    push(x);
    int mid = lx + rx >> 1;
    rangeSum(l, r, x << 1, lx, mid);
    rangeSum(l, r, x << 1 | 1, mid, rx);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    for (int i = 0; i < 5; ++i) {
        neut[i][i] = 1;
    }

    array<array<int, 5>, 5> nxtt, prvv;
    nxtt[0] = {5, 4, 3, 2, 1};
    nxtt[1] = {1, 0, 0, 0, 0};
    nxtt[2] = {0, 1, 0, 0, 0};
    nxtt[3] = {0, 0, 1, 0, 0};
    nxtt[4] = {0, 0, 0, 1, 0};

    prvv[0] = {0, 1, 0, 0, 0};
    prvv[1] = {0, 0, 1, 0, 0};
    prvv[2] = {0, 0, 0, 1, 0};
    prvv[3] = {0, 0, 0, 0, 1};
    prvv[4] = {1, MOD - 5, MOD - 4, MOD - 3, MOD - 2};

    for (int i = 0; i < 5; ++i) {
        for (int j = 0; j < 5; ++j) {
            nxt[i][j] = nxtt[i][j];
            prv[i][j] = prvv[i][j];
        }
    }

    for (int f = 0; f < 2; ++f) {
        auto now = f == 0 ? nxt : prv;
        memcpy(powers[f][0], neut, sizeof(neut));
//        powers[f][0] = neut;
        for (int i = 1; i < size(powers[f]); ++i) {
            mult(powers[f][i - 1], now, powers[f][i]);
        }
    }
    for (int f = 0; f < 2; ++f) {
        auto now = powers[f][F];
        memcpy(fpower[f][0], neut, sizeof(neut));
//        fpower[f][0] = neut;
        for (int i = 1; i < size(fpower[f]); ++i) {
            mult(fpower[f][i - 1], now, fpower[f][i]);
        }
    }

    int n, q;
    cin >> n >> q;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    init(n, a);

    while (q--) {
        int type, l, r;
        cin >> type >> l >> r;
        --l;
        if (type == 1) {
            for (int j = 0; j < 5; ++j) {
                result[4][j] = 0;
            }
            rangeSum(l, r);
            int ans = 0;
            for (int k = 0; k < 5; ++k) {
                madd(ans, 1LL * (4 - k) * result[4][k] % MOD);
            }
            cout << ans << '\n';
        } else {
            int v;
            cin >> v;
            mat mul{};
            (v >= 0 ? power(0, v, mul) : power(1, -v, mul));
            rangeApply(l, r, mul);
        }
    }

    return 0;
}