#include <bits/stdc++.h>
// #include "ones.h"
using namespace std;
using ll = long long;
const ll mod = 1e8 + 543;

vector<vector<ll>> merge(vector<vector<ll>> a, vector<vector<ll>> b) {
    vector<vector<ll>> ans(a.size(), vector<ll>(b.size()));
    for (int i = 0; i < a.size(); i++) {
        for (int j = 0; j < b[0].size(); j++) {
            for (int k = 0; k < b.size(); k++) {
                ans[i][j] += (a[i][k] * b[k][j]) % mod;
                ans[i][j] %= mod;
            }
        }
    }
    return ans;
}
map<ll, vector<vector<ll>>> cl;
vector<vector<ll>> ed = {{1, 0, 0, 0, 0}, {0, 1, 0, 0, 0}, {0, 0, 1, 0, 0}, {0, 0, 0, 1, 0}, {0, 0, 0, 0, 1}};
vector<vector<ll>> binpow(vector<vector<ll>> a, ll step) {
    if (step == 0) {
        return {{1, 0, 0, 0, 0}, {0, 1, 0, 0, 0}, {0, 0, 1, 0, 0}, {0, 0, 0, 1, 0}, {0, 0, 0, 0, 1}};
    }
    if (step == 1) {
        return a;
    }
    // if (cl.find(step) != cl.end()) {
    //     return cl[step];
    // }
    vector<vector<ll>> b = binpow(a, step / 2);
    b = merge(b, b);
    if (step % 2) {
        b = merge(b, a);
    }
    // cl[step] = b;
    return b;
}
struct node {
    vector<ll> pred;
};
vector<vector<ll>> per = {{0, 0, 0, 0, 1}, {1, 0, 0, 0, 2}, {0, 1, 0, 0, 3}, {0, 0, 1, 0, 4}, {0, 0, 0, 1, 5}};
node operator+(node a, node b) {
    for (int j = 0; j < 5; j++) {
        a.pred[j] = (a.pred[j] + b.pred[j]) % mod;
    }
    return a;
}
node nei = {{0, 0, 0, 0, 0}};
vector<ll> prec;
struct segtree {
    vector<node> tr;
    vector<vector<vector<ll>>> add;
    ll sz = 1;
    segtree(ll n, vector<ll>& a) {
        while (sz < n) {
            sz *= 2;
        }
        tr.resize(2 * sz - 1);
        add.resize(2 * sz - 1, ed);
        for (int i = sz - 1; i < 2 * sz - 1; i++) {
            tr[i] = nei;
            if (i - (sz - 1) < n) {
                tr[i].pred[1] = prec[a[i - (sz - 1)]];
            }
        }
        for (int i = sz - 2; i > -1; i--) {
            tr[i] = tr[2 * i + 1] + tr[2 * i + 2];
        }
        assert(false);
    }

    void plus(int v, int l, int r, int lseg, int rseg, vector<vector<ll>>& x) {
        if (lseg <= l && r <= rseg) {
            add[v] = merge(add[v], x);
            vector<ll> nw(5);
            for (int j = 0; j < 5; j++) {
                for (int i = 0; i < 5; i++) {
                    nw[j] += x[j][i] * tr[v].pred[i];
                    nw[j] %= mod;
                }
            }
            tr[v].pred = nw;
            return;
        }
        if (r <= lseg || rseg <= l) {
            return;
        }
        int mid = (r + l) / 2;
        plus(2 * v + 1, l, mid, lseg, rseg, x);
        plus(2 * v + 2, mid, r, lseg, rseg, x);
        tr[v] = tr[2 * v + 1] + tr[2 * v + 2];
        vector<ll> nw(5);
        for (int j = 0; j < 5; j++) {
            for (int i = 0; i < 5; i++) {
                nw[j] += add[v][j][i] * tr[v].pred[i];
                nw[j] %= mod;
            }
        }
        tr[v].pred = nw;
    }

    void plus(int lseg, int rseg, vector<vector<ll>>& x) {
        plus(0, 0, sz, lseg, rseg, x);
    }

    node sum(int v, int l, int r, int lseg, int rseg) {
        if (lseg <= l && r <= rseg) {
            return tr[v];
        }
        if (r <= lseg || rseg <= l) {
            return nei;
        }
        int mid = (r + l) / 2;
        node m1 = sum(2 * v + 1, l, mid, lseg, rseg);
        node m2 = sum(2 * v + 2, mid, r, lseg, rseg);
        m1 = m1 + m2;
        // vector<ll> nw(5);
        // for (int j = 0; j < 5; j++) {
        //     for (int i = 0; i < 5; i++) {
        //         nw[j] += add[v][j][i] * m1.pred[i];
        //         nw[j] %= mod;
        //     }
        // }
        // m1.pred = nw;
        return m1;
    }

    node sum(int lseg, int rseg) {
        return sum(0, 0, sz, lseg, rseg);
    }
};

void solve() {
    ll n, q;
    cin >> n >> q;
    vector<ll> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    prec.resize(1e6 + 1, 0);
    prec[0] = 0;
    prec[1] = 1;
    prec[2] = 2;
    prec[3] = 3;
    prec[4] = 4;
    for (int j = 5; j <= 1e6; j++) {
        prec[j] = (5 * prec[j - 1] + 4 * prec[j - 2] + 3 * prec[j - 3] + 2 * prec[j - 4] + prec[j - 5]) % mod;
    }
    segtree mach(n, a);
    for (int i = 0; i < q; i++) {
        ll t, l, r, x;
        cin >> t >> l >> r;
        l--;
        if (t == 1) {
            node g = mach.sum(l, r);
            ll ans = 0;
            for (int j = 0; j < 5; j++) {
                ans = (ans + g.pred[j] * (j)) % mod;
            }
            cout << ans << "\n";
        } else {
            cin >> x;
            vector<vector<ll>> add = binpow(per, x);
            mach.plus(l, r, add);
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}