#include <bits/stdc++.h>
// #include "ones.h"
using namespace std;
using ll = long long;
const ll mod = 1e8 + 543;
array<ll, 5> nei = {0, 0, 0, 0, 0};
array<array<ll, 5>, 5> merge(array<array<ll, 5>, 5> a, array<array<ll, 5>, 5> b) {
    array<array<ll, 5>, 5> ans = {nei, nei, nei, nei, nei};
    for (int i = 0; i < 5; i++) {
        for (int j = 0; j < 5; j++) {
            for (int k = 0; k < 5; k++) {
                ans[i][j] += (a[i][k] * b[k][j]) % mod;
                ans[i][j] %= mod;
            }
        }
    }
    return ans;
}
vector<array<ll, 5>> prec;
array<array<ll, 5>, 5> ed = {array<ll, 5>{1, 0, 0, 0, 0}, array<ll, 5>{0, 1, 0, 0, 0}, {0, 0, 1, 0, 0}, {0, 0, 0, 1, 0}, {0, 0, 0, 0, 1}};
array<array<ll, 5>, 5> binpow(array<array<ll, 5>, 5> a, ll step) {
    if (step == 0) {
        return {array<ll, 5>{1, 0, 0, 0, 0}, array<ll, 5>{0, 1, 0, 0, 0}, {0, 0, 1, 0, 0}, {0, 0, 0, 1, 0}, {0, 0, 0, 0, 1}};
    }
    if (step == 1) {
        return a;
    }
    if (step <= prec.size() - 5) {
        array<array<ll, 5>, 5> ans;
        for (int i = 0; i < 5; i++) {
            for (int j = 0; j < 5; j++) {
                ans[i][j] = prec[step + j][i];
            }
        }
        return ans;
    }
    // if (cl.find(step) != cl.end()) {
    //     return cl[step];
    // }
    array<array<ll, 5>, 5> b = binpow(a, step / 2);
    b = merge(b, b);
    if (step % 2) {
        b = merge(b, a);
    }
    // cl[step] = b;
    return b;
}

array<array<ll, 5>, 5> binpow2(array<array<ll, 5>, 5> a, ll step) {
    if (step == 0) {
        return {array<ll, 5>{1, 0, 0, 0, 0}, array<ll, 5>{0, 1, 0, 0, 0}, {0, 0, 1, 0, 0}, {0, 0, 0, 1, 0}, {0, 0, 0, 0, 1}};
    }
    if (step == 1) {
        return a;
    }
    // if (cl.find(step) != cl.end()) {
    //     return cl[step];
    // }
    array<array<ll, 5>, 5> b = binpow2(a, step / 2);
    b = merge(b, b);
    if (step % 2) {
        b = merge(b, a);
    }
    // cl[step] = b;
    return b;
}
array<array<ll, 5>, 5> per = {array<ll, 5>{0, 0, 0, 0, 1}, array<ll, 5>{1, 0, 0, 0, 2}, {0, 1, 0, 0, 3}, {0, 0, 1, 0, 4}, {0, 0, 0, 1, 5}};
array<ll, 5> operator+(array<ll, 5> a, array<ll, 5> b) {
    for (int j = 0; j < 5; j++) {
        a[j] = (a[j] + b[j]) % mod;
    }
    return a;
}
struct segtree {
    vector<array<ll, 5>> tr;
    vector<array<array<ll, 5>, 5>> add;
    ll sz = 1;
    segtree(ll n, vector<ll>& a) {
        while (sz < n) {
            sz *= 2;
        }
        tr.resize(2 * sz - 1);
        add.resize(2 * sz - 1, ed);
        for (int i = sz - 1; i < 2 * sz - 1; i++) {
            tr[i] = nei;
            if (i - (sz - 1) < n) {
                array<array<ll, 5>, 5> g = binpow(per, a[i - (sz - 1)]);
                for (int j = 0; j < 5; j++) {
                    tr[i][j] = g[j][0];
                }
            }
        }
        for (int i = sz - 2; i > -1; i--) {
            tr[i] = tr[2 * i + 1] + tr[2 * i + 2];
        }
        // assert(false);
    }

    void plus(int v, int l, int r, int lseg, int rseg, array<array<ll, 5>, 5>& x) {
        if (lseg <= l && r <= rseg) {
            add[v] = merge(add[v], x);
            array<ll, 5> nw;
            for (int j = 0; j < 5; j++) {
                for (int i = 0; i < 5; i++) {
                    nw[j] += x[j][i] * tr[v][i];
                    nw[j] %= mod;
                }
            }
            tr[v] = nw;
            return;
        }
        if (r <= lseg || rseg <= l) {
            return;
        }
        int mid = (r + l) / 2;
        plus(2 * v + 1, l, mid, lseg, rseg, x);
        plus(2 * v + 2, mid, r, lseg, rseg, x);
        tr[v] = tr[2 * v + 1] + tr[2 * v + 2];
        array<ll, 5> nw;
        for (int j = 0; j < 5; j++) {
            for (int i = 0; i < 5; i++) {
                nw[j] += add[v][j][i] * tr[v][i];
                nw[j] %= mod;
            }
        }
        tr[v] = nw;
    }

    void plus(int lseg, int rseg, array<array<ll, 5>, 5>& x) {
        plus(0, 0, sz, lseg, rseg, x);
    }

    array<ll, 5> sum(int v, int l, int r, int lseg, int rseg) {
        if (lseg <= l && r <= rseg) {
            return tr[v];
        }
        if (r <= lseg || rseg <= l) {
            return nei;
        }
        int mid = (r + l) / 2;
        array<ll, 5> m1 = sum(2 * v + 1, l, mid, lseg, rseg);
        array<ll, 5> m2 = sum(2 * v + 2, mid, r, lseg, rseg);
        m1 = m1 + m2;
        vector<ll> nw(5);
        for (int j = 0; j < 5; j++) {
            for (int i = 0; i < 5; i++) {
                nw[j] += add[v][j][i] * m1[i];
                nw[j] %= mod;
            }
        }
        m1 = nw;
        return m1;
    }

    array<ll, 5> sum(int lseg, int rseg) {
        return sum(0, 0, sz, lseg, rseg);
    }
};
mt19937 rd(33);
void solve() {
    ll n, q;
    cin >> n >> q;
    vector<ll> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    prec.resize(1e6 + 1);
    prec[0] = {1, 0, 0, 0, 0};
    prec[1] = {0, 1, 0, 0, 0};
    prec[2] = {0, 0, 1, 0, 0};
    prec[3] = {0, 0, 0, 1, 0};
    prec[4] = {0, 0, 0, 0, 1};
    for (int j = 5; j <= 1e6; j++) {
        for (int i = 0; i < 5; i++) {
            prec[j][i] = (5 * prec[j - 1][i] + 4 * prec[j - 2][i] + 3 * prec[j - 3][i] + 2 * prec[j - 4][i] + prec[j - 5][i]) % mod;
        }
    }
    // for (int g = 0; g < 1e4; g++) {
    //     ll f = 5;
    //     cout << f << endl;
    //     auto x = binpow(per, f);
    //     auto y = binpow2(per, f);
    //     assert(x == y);
    // }
    segtree mach(n, a);
    for (int i = 0; i < q; i++) {
        ll t, l, r, x;
        cin >> t >> l >> r;
        l--;
        if (t == 1) {
            array<ll, 5> g = mach.sum(l, r);
            ll ans = 0;
            for (int j = 0; j < 5; j++) {
                ans = (ans + g[j] * (j)) % mod;
            }
            cout << ans << "\n";
        } else {
            cin >> x;
            auto add = binpow(per, x);
            mach.plus(l, r, add);
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}