#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <unordered_map>
#include <iomanip>
#include <time.h>
#include <cstring>
#include <map>
#include <unordered_set>
#include <random>
#include <chrono>
#include <stack>
#include <deque>
#include <queue>
#include <sstream>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned short us;

const ll MAX = 100000543;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, q;
    cin >> n >> q;
    vector<ll> a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    vector<ll> x(1000001);
    x[1] = 1;
    x[2] = 2;
    x[3] = 3;
    x[4] = 4;
    vector<ll> pref(n + 1);
    for (int i = 5; i <= 1000000; ++i)
    {
        x[i] = x[i - 1] * 5 + x[i - 2] * 4 + x[i - 3] * 3 + x[i - 4] * 2 + x[i - 5];
        x[i] %= MAX;
    }
    for (int i = 1; i <= n; ++i)
    {
        pref[i] = pref[i - 1] + x[a[i - 1]];
        pref[i] %= MAX;
    }
    for (int i = 0; i < q; ++i)
    {
        int t, l, r;
        cin >> t >> l >> r;
        ll result = pref[r] - pref[l - 1];
        if (result < 0)
            result += MAX;
        cout << result << '\n';
    }
    return 0;
}
