#include<bits/stdc++.h>
using namespace std;

using ll = long long;

int mod = 1e8 + 543;

using mat = array<array<ll, 5>, 5>;
using mat2 = array<ll, 5>;
mat null() {
    mat res;
    for (int i = 0; i < 5; ++i) {
        for (int j = 0; j < 5; ++j) {
            res[i][j] = 0;
        }
    }
    return move(res);
}
mat e() {
    mat res;
    for (int i = 0; i < 5; ++i) {
        for (int j = 0; j < 5; ++j) {
            res[i][j] = i == j;
        }
    }
    return move(res);
}
mat operator*(mat& a, mat& b) {
    mat c = null();
    for (int i = 0; i < 5; ++i) {
        for (int j = 0; j < 5; ++j) {
            for (int k = 0; k < 5; ++k) {
                c[i][k] += a[i][j] * b[j][k];
            }
        }
    }
    for (int i = 0; i < 5; ++i) {
        for (int j = 0; j < 5; ++j) {
            c[i][j] %= mod;
        }
    }
    return c;
}
mat2 operator+(mat2& a, mat2& b) {
    mat2 c;
    for (int i = 0; i < 5; ++i) {
        c[i] = (a[i] + b[i]);
        if (c[i] >= mod) c[i] -= mod;
    }
    return c;
}
mat2 operator*(mat2 bim, mat bam) {
    mat2 res;
    res.fill(0);
    for (int i = 0; i < 5; ++i) {
        for (int j = 0; j < 5; ++j) {
            res[j] += bim[i] * bam[i][j];
        }
    }
    for (int i = 0; i < 5; ++i) res[i] %= mod;
    return res;
}
mat nxt, prv;
mat2 start;
mat power(mat m, long long b) {
    mat res = e();
    for (; b; b >>= 1, m = m * m) if (b & 1) res = res * m;
    return res;
}
mat get(long long x) {
    if (x < 0) return power(prv, -x);
    else return power(nxt, x);
}
const int N = 1e5;
int n;
//mat2 tr[4 * N];
//mat upd[4 * N];
//
//void apply(int node, mat m) {
//    tr[node] = tr[node] * m;
//    upd[node] = upd[node] * m;
//}
//
//void update(int ql, int qr, mat m, int node = 1, int l = 0, int r = n - 1) {
//    if (r < ql || qr < l) return;
//    if (ql <= l && r <= qr) {
//        apply(node, m);
//        return;
//    }
//    apply(node << 1, upd[node]);
//    apply(node << 1 | 1, upd[node]);
//    upd[node] = e();
//    int mid = (l + r) / 2;
//    update(ql, qr, m, node << 1, l, mid);
//    update(ql, qr, m, node << 1, mid + 1, r);
//    tr[node] = tr[node << 1] + tr[node << 1 | 1];
//}
//
//int get(int ql, int qr, int node = 1, int l = 0, int r = n - 1) {
//    if (r < ql || qr < l) return 0;
//    if (ql <= l && r <= qr) {
//        return tr[node][0];
//    }
//    apply(node << 1, upd[node]);
//    apply(node << 1 | 1, upd[node]);
//    upd[node] = e();
//    int mid = (l + r) / 2;
//    return add(get(ql, qr, node << 1, l, mid), get(ql, qr, node << 1 | 1, mid + 1, r));
//}
mat2 a[N];
int main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    for (int i = 0; i < 5; ++i) {
        for (int j = 0; j < 5; ++j) {
            if (j == 4) nxt[i][j] = i + 1;
            else nxt[i][j] = j == i - 1;
        }
    }
    for (int i = 0; i < 5; ++i) {
        for (int j = 0; j < 5; ++j) {
            if (j == 0) {
                prv[i][j] = i < 4 ? -(i + 2) + mod : 1;
            } else {
                prv[i][j] = j == i + 1;
            }
        }
    }
    iota(start.begin(), start.end(), 0);
    int q;
    cin >> n >> q;
//    fill(tr, tr + 4 * n, start);
//    fill(upd, upd + 4 * n, e());
    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        a[i] = start * get(x);
    }
    while (q--) {
        int type, k;
        cin >> type >> k >> k;
        --k;
        if (type == 1) {
            cout << a[k][0] << '\n';
        } else {
            int x;
            cin >> x;
            a[k] = a[k] * get(x);
        }
//        int type;
//        cin >> type;
//        if (type == 1) {
//            int l, r;
//            cin >> l >> r;
//            --l, --r;
//            cout << get(l, r) << '\n';
//        } else {
//            int l, r, x;
//            cin >> l >> r >> x;
//            --l, --r;
//            update(l, r, get(x));
//        }
    }
}