#include <bits/stdc++.h>
#include "ones.h"

#define PB push_back
#define MP make_pair
#define F first
#define S second
#define ve vector
//#define endl '\n'
#define all(x) x.begin(),x.end()
#define sz(x) ll(x.size())

using namespace std;
typedef int ll;
typedef pair<ll,ll> pll;
mt19937_64 gen(chrono::steady_clock::now().time_since_epoch().count());
const ll INF=2e9+2;
//const ll N=1e6+2;

ve<int> guessOnes(int n, int k)
{
    ve<int> ans;
    ll pos=1;
    
    for(ll i=0;i<k;i++)
    {
        ll step=((n-i)+(k-i)-1)/(k-i);
        ll l=pos,r=min(n,pos+step);
        bool ok=0;
        
        while(l<r)
        {
            ll mid=(l+r)/2;
            
            if(hasOnes(pos,mid))
            {
                ok=1;
                r=mid;
            }
            
            else l=mid+1;
        }
        
        if(!ok)
        {
            l=pos, r=n;
            
            while(l<r)
            {
                ll mid=(l+r)/2;
                if(hasOnes(pos,mid)) r=mid;
                else l=mid+1;
            }
        }
        
        ans.PB(l);
        pos=l+1;
    }
    
    return ans;
}

#ifdef LOCAL
#include <vector>
#include <iostream>
#include <utility>
#include <algorithm>
#include <random>
#include <iomanip>
#include <numeric>
#include <cstring>

static const int N = 1e5 + 3;

static int n, k, n_tests;
static int input[N];

static long long number_of_queries;

static std::vector<int> readOnes()
{
    for(int i=1;i<=n;i++)
        input[i]=0;

    std::vector<int> _ones(k,0);

    for(int i=0;i<k;i++)
    {
        std::cin>>_ones[i];
        input[_ones[i]]=1;
    }

    for(int i=1;i<=n;i++)input[i]+=input[i-1];

    sort(_ones.begin(),_ones.end());

    return _ones;
}

bool hasOnes(int l,int r)
{
    number_of_queries++;

    if(1>l || l>n || 1>r || r>n || l>r)
    {
        std::cout << "Your program made an invalid query." << std::endl;
        exit(0);
    }

    return input[r] != input[l-1];
}

static long long runOneTest(){
    number_of_queries = 0;

    std::vector<int> _ones = readOnes();

    std::vector<int> guess = guessOnes(n,k);

    if(_ones != guess)
    {
        std::cout << "Your program returned an incorrect answer." << std::endl;
        exit(0);
    }

    std::cout << "Your program successfully returned the correct positions and used " << number_of_queries << " queries." << std::endl;

    return number_of_queries;
}

int main(){
    std::cin >> n >> k >> n_tests;

    long long sum_queries = 0;
    for(int i = 0; i < n_tests; ++i)
        sum_queries = sum_queries + runOneTest();

    std::cout << "Your program successfully returned the correct positions and used " << sum_queries << " queries in total." << std::endl;
}
#endif // LOCAL
