#include <bits/stdc++.h>

#ifdef LOCAL
#include "Lgrader1.cpp"
#else
#include "puzzle.h"
#endif // LOCAL

#define pb push_back
#define pii pair < int, int >
#define F first
#define S second
#define veve vector < vector < int > >
//#define int long long

using namespace std;

const int mod = 100000543;
const int N = 100001;

double TL;

void init(int numSubtests, double timeLimit)
{
    TL = timeLimit;
}

bool solve(veve &puzzle)
{
    veve cpy = puzzle;
    int n = puzzle.size(), m = puzzle[0].size();
    while (true)
    {
        bool fl = 0, fl1 = 0;
        for (int i = 0; i < n; i++)
            for (int j = 0; j < m; j++)
            {
                if (puzzle[i][j] <= 0) continue;
                fl1 = 1;
                int x1 = 2, x2 = 2, x3 = 2, x4 = 2;
                int i1 = i - 1;
                while (i1 >= 0 && cpy[i1][j] == 0 && (puzzle[i1][j] == 0 || puzzle[i1][j] == -2))
                {
                    if (puzzle[i1][j] == -2) x1 = 1;
                    i1--;
                }
                if (i1 >= 0 && puzzle[i1][j] > 0) x1 = min({x1, 2, puzzle[i1][j], puzzle[i][j]});
                    else x1 = 0;
                i1 = i + 1;
                while (i1 < n && cpy[i1][j] == 0 && (puzzle[i1][j] == 0 || puzzle[i1][j] == -2))
                {
                    if (puzzle[i1][j] == -2) x2 = 1;
                    i1++;
                }
                if (i1 < n && puzzle[i1][j] > 0) x2 = min({x2, 2, puzzle[i1][j], puzzle[i][j]});
                    else x2 = 0;
                int j1 = j - 1;
                while (j1 >= 0 && cpy[i][j1] == 0 && (puzzle[i][j1] == 0 || puzzle[i][j1] == -1))
                {
                    if (puzzle[i][j1] == 2) x3 = 1;
                    j1--;
                }
                if (j1 >= 0 && puzzle[i][j1] > 0) x3 = min({x3, 2, puzzle[i][j1], puzzle[i][j]});
                    else x3 = 0;
                j1 = j + 1;
                while (j1 >= 0 && cpy[i][j1] == 0 && (puzzle[i][j1] == 0 || puzzle[i][j1] == -1))
                {
                    if (puzzle[i][j1] == 2) x4 = 1;
                    j1++;
                }
                if (j1 < m && puzzle[i][j1] > 0) x4 = min({x4, 2, puzzle[i][j1], puzzle[i][j]});
                    else x4 = 0;
                if (i == 0 && j == 6) cerr << puzzle[i][j] << ' ' << x1 << ' ' << x2 << ' ' << x3 << ' ' << x4 << endl;
                if (puzzle[i][j] - x2 - x3 - x4 > 0 && x1 > 0)
                {
                    int val = min(x1, puzzle[i][j] - x2 - x3 - x4);
                    ///cerr << i << ' ' << j << ' ' << val << ' ' << "up" << endl;
                    fl = 1;
                    puzzle[i][j] -= val;
                    i1 = i - 1;
                    while (i1 >= 0 && puzzle[i1][j] <= 0)
                    {
                        if (puzzle[i1][j] == 0) puzzle[i1][j] = -2 * val;
                            else puzzle[i1][j] -= 2;
                        i1--;
                    }
                    puzzle[i1][j] -= val;
                    x1 -= val;
                }
                if (puzzle[i][j] - x1 - x3 - x4 > 0 && x2 > 0)
                {
                    int val = min(x2, puzzle[i][j] - x1 - x3 - x4);
                    ///cerr << i << ' ' << j << ' ' << val << ' ' << "down" << endl;
                    fl = 1;
                    puzzle[i][j] -= val;
                    i1 = i + 1;
                    while (i1 < n && puzzle[i1][j] <= 0)
                    {
                        if (puzzle[i1][j] == 0) puzzle[i1][j] = -2 * val;
                            else puzzle[i1][j] -= 2;
                        i1++;
                    }
                    puzzle[i1][j] -= val;
                    x2 -= val;
                }
                if (puzzle[i][j] - x1 - x2 - x4 > 0 && x3 > 0)
                {
                    int val = min(x3, puzzle[i][j] - x1 - x2 - x4);
                    ///cerr << i << ' ' << j << ' ' << val << ' ' << "left" << endl;
                    fl = 1;
                    puzzle[i][j] -= val;
                    j1 = j - 1;
                    while (j1 >= 0 && puzzle[i][j1] <= 0)
                    {
                        if (puzzle[i][j1] == 0) puzzle[i][j1] = -2 * val + 1;
                            else puzzle[i][j1] -= 2;
                        j1--;
                    }
                    puzzle[i][j1] -= val;
                    x3 -= val;
                }
                if (puzzle[i][j] - x1 - x2 - x3 > 0 && x4 > 0)
                {
                    int val = min(x4, puzzle[i][j] - x1 - x2 - x3);
                    ///cerr << i << ' ' << j << ' ' << val << ' ' << "right" << endl;
                    fl = 1;
                    puzzle[i][j] -= val;
                    j1 = j + 1;
                    while (j1 < m && puzzle[i][j1] <= 0)
                    {
                        if (puzzle[i][j1] == 0) puzzle[i][j1] = -2 * val + 1;
                            else puzzle[i][j1] -= 2;
                        j1++;
                    }
                    puzzle[i][j1] -= val;
                    x4 -= val;
                }
            }
        if (fl1 == 0) break;
        if (fl == 1) continue;
        for (int i = 0; i < n; i++)
                for (int j = 0; j < m; j++)
                    if (cpy[i][j] > 0) puzzle[i][j] = cpy[i][j];
            return false;
        bool ff = 0;
        for (int i = 0; i < n; i++)
            for (int j = 0; j < m; j++)
            {
                if (puzzle[i][j] <= 0 || ff == 1) continue;
                int x1 = 0, x2 = 0, x3 = 0, x4 = 0;
                int i1 = i - 1;
                while (i1 >= 0 && puzzle[i1][j] == 0)
                    i1--;
                if (i1 >= 0 && puzzle[i1][j] > 0) x1++;
                i1 = i + 1;
                while (i1 < n && puzzle[i1][j] == 0)
                    i1++;
                if (i1 < n && puzzle[i1][j] > 0) x2++;
                int j1 = j - 1;
                while (j1 >= 0 && puzzle[i][j1] == 0)
                    j1--;
                if (j1 >= 0 && puzzle[i][j1] > 0) x3++;
                j1 = j + 1;
                while (j1 < m && puzzle[i][j1] == 0)
                    j1++;
                if (j1 < m && puzzle[i][j1] > 0) x4++;
                if (x1 + x2 + x3 + x4 == 0) continue;
                puzzle[i][j]--;
                if (x1 == 1)
                {
                    i1 = i - 1;
                    while (i1 >= 0 && puzzle[i1][j] == 0)
                    {
                        puzzle[i1][j] = -2;
                        i1--;
                    }
                    puzzle[i1][j]--;
                    ff = 1;
                    break;
                }
                if (x2 == 1)
                {
                    i1 = i + 1;
                    while (i1 < n && puzzle[i1][j] == 0)
                    {
                        puzzle[i1][j] = -2;
                        i1++;
                    }
                    puzzle[i1][j]--;
                    ff = 1;
                    break;
                }
                if (x3 == 1)
                {
                    j1 = j - 1;
                    while (j1 >= 0 && puzzle[i][j1] == 0)
                    {
                        puzzle[i][j1] = -1;
                        j1--;
                    }
                    puzzle[i][j1]--;
                    ff = 1;
                    break;
                }
                if (x4 == 1)
                {
                    j1 = j + 1;
                    while (j1 < m && puzzle[i][j1] == 0)
                    {
                        puzzle[i][j1] = -1;
                        j1++;
                    }
                    puzzle[i][j1]--;
                    ff = 1;
                    break;
                }
            }
        if (clock() > 5000)
        {
            for (int i = 0; i < n; i++)
                for (int j = 0; j < m; j++)
                    if (cpy[i][j] > 0) puzzle[i][j] = cpy[i][j];
            return true;
        }
    }
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            if (cpy[i][j] > 0) puzzle[i][j] = cpy[i][j];
    #ifdef LOCAL
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
            cout << puzzle[i][j] << ' ';
        cout << endl;
    }
    #endif
    return true;
}

/**
1 2
7 7
0 0 2 0 3 0 3
4 0 0 0 0 2 0
0 0 0 0 0 0 0
6 0 0 0 0 2 0
0 0 0 0 0 0 0
0 0 0 0 0 0 0
4 0 0 0 0 0 4
**/
