#include <bits/stdc++.h>

#define pb push_back
#define pii pair < int, int >
#define F first
#define S second
#define veve vector < vector < int > >
#define int long long

using namespace std;

const int mod = 100000543;
const int N = 100001;

vector < int > rec(int x)
{
    if (x == 0) return {0, 0, 0, 0, 1};
    if (x == 1) return {0, 0, 0, 1, 0};
    if (x == 2) return {0, 0, 1, 0, 0};
    if (x == 3) return {0, 1, 0, 0, 0};
    if (x == 4) return {1, 0, 0, 0, 0};
    vector < int > ans(5);
    vector < int > v1 = rec(x - 1);
    vector < int > v2 = rec(x - 2);
    vector < int > v3 = rec(x - 3);
    vector < int > v4 = rec(x - 4);
    vector < int > v5 = rec(x - 5);
    int num = 0;
    for (int i = 0; i < 5; i++)
    {
        ans[i] = v1[i] * 5 + v2[i] * 4 + v3[i] * 3 + v4[i] * 2 + v5[i];
        ans[i] %= mod;
        num += (ans[i] * (4 - i));
    }
    //cerr << x << ' ' << ans[4] << ' ' << ans[3] - ans[4] << endl;
    return ans;
}

void umn(veve &A, veve B)
{
    veve C;
    if (A.size() == 2)
    {
        C = {{0, 0}, {0, 0}};
        C[0][0] = (A[0][0] * B[0][0] + A[0][1] * B[1][0]) % mod;
        C[0][1] = (A[0][0] * B[0][1] + A[0][1] * B[1][1]) % mod;
        C[1][0] = (A[1][0] * B[0][0] + A[1][1] * B[1][0]) % mod;
        C[1][1] = (A[1][0] * B[0][1] + A[1][1] * B[1][1]) % mod;
    }
    else
    {
        C = {{0, 0}};
        C[0][0] = (A[0][0] * B[0][0] + A[0][1] * B[1][0]) % mod;
        C[0][1] = (A[0][0] * B[0][1] + A[0][1] * B[1][1]) % mod;
    }
    A = C;
}

void bp_mat(veve &A, int st)
{
    veve B = A, ans = {{1, 0}, {0, 1}};
    int cur = 1;
    while (st > 0)
    {
        if ((st & cur) > 0)
        {
            st -= cur;
            umn(ans, B);
        }
        umn(B, B);
        cur *= 2;
    }
    A = ans;
}

void upd_mat(veve &A, int x)
{
    vector < vector < int > > B = {{5, 1}, {4, 0}};
    bp_mat(B, x);
    umn(A, B);
}

struct segtree
{
    veve T[N * 4];
    int lazy[N * 4];
    void build(int v, int l, int r, vector < int > &vec)
    {
        if (l == r)
        {
            T[v] = {{1, 0}};
            upd_mat(T[v], vec[l]);
            return;
        }
        int mid = (l + r) / 2;
        build(v * 2, l, mid, vec);
        build(v * 2 + 1, mid + 1, r, vec);
        T[v][0][0] = (T[v * 2][0][0] + T[v * 2 + 1][0][0]) % mod;
        T[v][0][1] = (T[v * 2][0][0] + T[v * 2 + 1][0][1]) % mod;
    }
    void push(int v)
    {
        if (lazy[v] == 0) return;
        upd_mat(T[v], lazy[v]);
        if (v * 2 < N * 4) lazy[v * 2] += lazy[v];
        if (v * 2 + 1 < N * 4) lazy[v * 2 + 1] += lazy[v];
        lazy[v] = 0;
    }
    void upd(int v, int l, int r, int vl, int vr, int x)
    {
        push(v);
        if (r < vl || vr < l) return;
        if (l <= vl && vr <= r)
        {
            lazy[v] += x;
            push(v);
            return;
        }
        int mid = (vl + vr) / 2;
        upd(v * 2, l, r, vl, mid, x);
        upd(v * 2 + 1, l, r, mid + 1, vr, x);
        T[v][0][0] = (T[v * 2][0][0] + T[v * 2 + 1][0][0]) % mod;
        T[v][0][1] = (T[v * 2][0][0] + T[v * 2 + 1][0][1]) % mod;
    }
    int get(int v, int l, int r, int vl, int vr)
    {
        if (r < vl || vr < l) return 0;
        if (l <= vl && vr <= r)
        {
            int x = T[v][0][0], y = T[v][0][1], cur = x, ans = 0;
            for (int i = 1; i <= 4; i++)
            {
                cur = (cur + x + y) % mod;
                ans = (ans + cur * i) % mod;
            }
            return ans;
        }
        int mid = (vl + vr) / 2;
        return (get(v * 2, l, r, vl, mid) + get(v * 2 + 1, l, r, mid + 1, vr)) % mod;
    }
};

segtree T;

int x[1000001];

int32_t main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    for (int i = 0; i < 5; i++)
        x[i] = i;
    for (int i = 5; i <= 1000000; i++)
        x[i] = (x[i - 1] * 5 + x[i - 2] * 4 + x[i - 3] * 3 + x[i - 4] * 2 + x[i - 5]) % mod;
    int n, q;
    cin >> n >> q;
    int a[n];
    for (int i = 0; i < n; i++)
        cin >> a[i];
    for (int i = 0; i < n; i++)
        a[i] = x[a[i]];
    for (int i = 1; i < n; i++)
        a[i] = (a[i] + a[i - 1]) % mod;
    while (q--)
    {
        int l, r;
        cin >> l >> r;
        l--;r--;
        cout << (a[r] - (l > 0) * a[l - 1] + mod) % mod << '\n';
    }
}
