#include <bits/stdc++.h>
#define int long long
#define pb push_back

using namespace std;

typedef long long ll;

const int M = 1e8 + 543;
const int M1 = 60;
const int N = 1e5 + 100;

ll* pw[M1];

ll base_matr[25] = {
    5, 4, 3, 2, 1,
    1, 0, 0, 0, 0,
    0, 1, 0, 0, 0,
    0, 0, 1, 0, 0,
    0, 0, 0, 1, 0
};

ll single_matrix[25] = {
    1, 0, 0, 0, 0,
    0, 1, 0, 0, 0,
    0, 0, 1, 0, 0,
    0, 0, 0, 1, 0,
    0, 0, 0, 0, 1
};

ll c[25];

ll base_dp[25] = {
    4, 0, 0, 0, 0,
    3, 0, 0, 0, 0,
    2, 0, 0, 0, 0,
    1, 0, 0, 0, 0,
    0, 0, 0, 0, 0
};

void cpy(ll *a, ll *b) {
    for (int i = 0; i < 25; i++) a[i] = b[i];
}

ll *matrix_mult(ll *a, ll *b) {
    for (int i = 0; i < 25; i++) c[i] = 0;
    for (int i = 0; i < 5; i++)
        for (int j = 0; j < 5; j++) {
            c[i * 5 + j] = 0;
            for (int k = 0; k < 5; k++) c[i * 5 + j] += a[i * 5 + k] * b[k * 5 + j];
            c[i* 5 + j] %= M;
        }
    return c;
}

ll ans[25];
ll *binpow(ll y) {
    cpy(ans, single_matrix);
    for (int i = 0; y > 0; i++) {
        if (y & 1) cpy(ans, matrix_mult(pw[i], ans));
        y /= 2;
    }
    return ans;
}

ll pref_sum[N];

int dpn(ll n) {
    if (n < 5) {
        return n;
    }
    return matrix_mult(binpow(n - 4), base_dp)[0];
}

ll a[N];

void init() {
    pw[0] = (ll*)calloc(sizeof(ll), 25);
    cpy(pw[0], base_matr);
    for (int i = 1; i < M1; i++) {
            pw[i] = (ll*)calloc(sizeof(ll), 25);
            cpy(pw[i], matrix_mult(pw[i - 1], pw[i - 1]));
    }
}

main()
{
    ios_base::sync_with_stdio(0);
    iostream::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    init();
    int n, q;
    cin >> n >> q;

    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < q; i++) {
        int t;
        cin >> t;
        if (t == 1) {
            ll l, r;
            cin >> l >> r;
            cout << dpn(a[--l]) << "\n";
        } else {
            ll l, r, val;
            cin >> l >> r >> val;
            a[--l] += val;
        }
    }
}
