#include <bits/stdc++.h>
using namespace std;

const int mod = 100000543;
const int maxn = 100005;

int n, q, a[maxn], x[mod + 1], t[maxn];

void add(int v, int val) {
    for (int i = v; i <= n; i += i & -i)
        t[i] = (t[i] + val + mod) % mod;
}

int get(int r) {
    int res = 0;
    for (int i = r; i >= 1; i -= i & -i)
        res = (res + t[i]) % mod;
    return res;
}

int get(int l, int r) {
    return (get(r) - get(l - 1) + mod) % mod;
}

int main() {
    ios::sync_with_stdio(false); cin.tie(0);
    for (int i = 0; i <= 4; i++)
        x[i] = i;
    for (int k = 0; k <= mod - 5; k++)
        x[k + 5] = (0ll + 1ll * x[k + 4] * 5 + 1ll * x[k + 3] * 4 + 1ll * x[k + 2] * 3 + 1ll * x[k + 1] * 2 + x[k]) % mod;
    cin >> n >> q;
    for (int i = 1; i <= n; i++)
        cin >> a[i];
    for (int i = 1; i <= n; i++)
        add(i, x[a[i]]);
    while (q--) {
        int qt, l, r;
        cin >> qt >> l >> r;
        if (qt == 1) {
            cout << get(l, r) << '\n';
        }
        else {
            add(l, -x[a[l]]);
            int val;
            cin >> val;
            a[l] += val;
            if (a[l] >= mod - 1)
                a[l] -= mod - 1;
            add(l, x[a[l]]);
        }
    }
}
