#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()

using namespace std;
typedef long long ll;

const int maxn = 1e5 + 1;
const int maxA = 1e6 + 1;
const int MOD = 1e8 + 543;

int add(int a, int b) {
    (a += b) %= MOD;
}

int mul(int a, int b) {
    return 1LL * a * b % MOD;
}

int precalc[maxA];

int main() {
    for (int i = 0; i <= 4; i++) {
        precalc[i] = i;
    }

    for (int i = 5; i < maxA; i++) {
        for (int j = 1; j <= 5; j++) {
            precalc[i] = add(precalc[i], mul(precalc[i - 6 + j], j));
        }
    }

    int n, Q;
    cin >> n >> Q;

    vector<int> a(n);
    vector<int> pref(n + 1);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        if (a[i] >= maxA) {
            assert(false);
        }
        pref[i + 1] = add(precalc[a[i]], pref[i]);
    }

    while (Q--) {
        int a, b, c;
        cin >> a >> b >> c;
        if (a == 1) {
            cout << add(pref[c], -pref[b - 1]) << '\n';
        } else {
            assert(false);
        }
    }


    return 0;
}
