#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
#define int long long
const int mod = 1e8 + 543;
const int MAX = 1e5 + 7;

int add(int a, int b) {
    return (a + b >= mod ? a + b - mod : a + b);
}

int del(int a, int b) {
    return (a - b < 0 ? a - b + mod : a - b);
}

int mul(int a, int b) {
    return (1ll * a * b % mod);
}

void solve() {
    vector<int> x(1e6 + 7, 0);
    for (int i = 0; i <= 4; i++) x[i] = i;
    for (int i = 0; i <= 1e6; i++) {
        x[i + 5] = add(x[i], mul(5, x[i + 4]));
        x[i + 5] = add(x[i], mul(4, x[i + 3]));
        x[i + 5] = add(x[i], mul(3, x[i + 2]));
        x[i + 5] = add(x[i], mul(2, x[i + 1]));
        x[i + 5] = add(x[i], mul(1, x[i + 0]));
    }
    int n, q;
    cin >> n >> q;
    vector<int> a(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        a[i] = x[a[i]];
    }
    vector<int> pref(n + 1, 0);
    for (int i = 1; i <= n; i++) {
        pref[i] = add(pref[i - 1], a[i]);
    }
    while (q--) {
        int T;
        cin >> T;
        int l, r;
        cin >> l >> r;
        cout << del(pref[r], pref[l - 1]);
    }
}

int32_t main() {
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    #endif // LOCAL
    ios_base::sync_with_stdio(0); cin.tie(0);
    int t = 1;
    // cin >> t;
    while (t--) solve();
}
