#include <bits/stdc++.h>
#include "puzzle.h"

#define sz(x) (int)x.size()

using namespace std;

constexpr int N = 201;
constexpr int M = 50;

struct Have{
    int a, b, dir;
};

int n, m;
int num_sub, need[N], now[N], who[M][M], timer, info[N * 4], field[M][M], puz1[M][M];
pair<int, int> where[N * 4];
double tl;
vector<Have> have;
bool found_ans = false;

void init(int _num_sub, double _tl) {
    tl = _tl;
    num_sub = _num_sub;
}

void check() {
    for (int i = 0; i <= timer; i ++)
        if (need[i] != now[i])
            return;
        for (int i = 0; i < n; i ++)
            for (int j = 0; j < m; j ++)
            field[i][j] = puz1[i][j];
    for (int ind = 0; ind < have.size(); ind ++) {
        if (!info[ind])
            continue;
        if (have[ind].dir == 0) {
            int r = where[have[ind].a].first;
            int c1 = where[have[ind].a].second;
            int c2 = where[have[ind].b].second;
            for (int j = c1 + 1; j < c2; j ++) {
                if (field[r][j] != 0)
                    return;
                field[r][j] = -info[ind];
            }
        } else {
            int r1 = where[have[ind].a].first;
            int r2 = where[have[ind].b].first;
            int c = where[have[ind].b].second;
            for (int j = r1 + 1; j < r2; j ++) {
                if (field[j][c] != 0)
                    return;
                field[j][c] = -info[ind];
            }
        }
    }
    for (int i = 0; i < n; i ++)
        for (int j = 0; j < m; j ++)
            puz1[i][j] = field[i][j];
    found_ans = true;
}

void bin(int step) {
    if (step == have.size()) {
        check();
        return;
    }
    if (found_ans)
        return;

    for (int i = 1; i <= 3; i ++) {
        int wei = i < 3 ? i : 0;
        int a = have[step].a;
        int b = have[step].b;
        int dir = have[step].dir;
        int brid;
        if (wei == 0)
            brid = 0;
        else if (wei == 1)
            brid = have[step].dir + 1;
        else if (wei == 2) {
            brid = have[step].dir + 1 + 2;
        }
        bool can = true;
        if (need[a] - now[a] < wei)
            continue;
        if (need[b] - now[b] < wei)
            continue;

        now[a] += wei;
        now[b] += wei;

        info[step] = brid;
        bin(step + 1);
        if (found_ans)
            return;
        now[a] -= wei;
        now[b] -= wei;
    }
}

bool solve(vector<vector<int>>& puz) {
    n = sz(puz);
    m = sz(puz[0]);
    fill_n(need, N, 0);
    fill_n(now, N, 0);
    found_ans = false;
    timer = 1;
    for (int i = 0; i < n; i ++)
        for (int j = 0; j < m; j ++) {
            field[i][j] = puz1[i][j] = puz[i][j];
            if (puz[i][j]) {
                who[i][j] = timer;
                need[timer] = puz[i][j];
                where[timer ++] = {i, j};
            } else {
                who[i][j] = 0;
            }
        }
    have.clear();
    for (int i = 0; i < n; i ++) {
        for (int j = 0; j < m; j ++) {
            if (who[i][j] != 0) {
                for (int t = i + 1; t < n; t ++) {
                    if (who[t][j] != 0) {
                        have.push_back({who[i][j], who[t][j], 1});
                        break;
                    }
                }
                for (int t = j + 1; t < m; t ++) {
                    if (who[i][t] != 0) {
                        have.push_back({who[i][j], who[i][t], 0});
                        break;
                    }
                }
            }
        }
    }
    bin(0);


    for (int i = 0; i < n; i ++)
        for (int j = 0; j < m; j ++)
            puz[i][j] = puz1[i][j];
//    for (int i = 0; i < n; i ++) {
//        for (int j = 0; j < m; j ++)
//            cerr << puz1[i][j] << ' ';
//        cout << '\n';
//    }
    return true;
}
