#include <bits/stdc++.h>

using namespace std;

#define int long long
#define vec vector
#define pb push_back()
#define all(x) (x).begin(), (x).end()
#define f first
#define s second
#define sz(x) (int)x.size()

const int mod = 1e8 + 543;
const int N = 2e5 + 5;
int n, q, a[N];

vec<vec<int>> pls = {{0, 0, 0, 0, 1}, {1, 0, 0, 0, 2}, {0, 1, 0, 0, 3}, {0, 0, 1, 0, 4}, {0, 0, 0, 1, 5}};
vec<vec<int>> mns = {{0, 0, 0, 0, 1}, {1, 0, 0, 0, mod - 5}, {0, 1, 0, 0, mod - 4}, {0, 0, 1, 0, mod - 3}, {0, 0, 0, 1, mod - 2}};
vec<vec<int>> base;
unordered_map<int, int> mapka;
const int MN = 1e15;

struct tr {
    int x[5][5];

    tr(vec<vec<int>> mat) {
        for (int i = 0; i < 5; i++) {
            for (int j = 0; j < 5; j++) {
                if (i < sz(mat) && j < sz(mat[0])) {
                    x[i][j] = mat[i][j];
                } else {
                    x[i][j] = 0;
                }
            }
        }
    }

    tr() {
        for (int i = 0; i < 5; i++) {
            for (int j = 0; j < 5; j++) {
                x[i][j] = 0;
            }
        }
    }
} BASE, PLS, mat[N];

tr mult(tr a, tr b) {
    tr res;

    for (int i = 0; i < 5; i++) {
        for (int j = 0; j < 5; j++) {
            for (int l = 0; l < 5; l++) {
                (res.x[i][j] += a.x[i][l] * b.x[l][j]) %= mod;
            }
        }
    }

    return res;
}

tr I(int k) {
    tr res;
    for (int i = 0; i < 5; i++) {
        res.x[i][i] = 1;
    }
    return res;
}

tr bin_pow(tr a, int x) {
    if (x == 0) {
        return I(5);
    }
    if (x & 1) {
        return mult(a, bin_pow(a, x - 1));
    }
    tr half = bin_pow(a, x / 2);
    return mult(half, half);
}

tr get(int i) {
    tr res;
    if (i < 1000001) {
        return tr({{mapka[i - 4], mapka[i - 3], mapka[i - 2], mapka[i - 1], mapka[i]}});
    }
    return mult(BASE, bin_pow(PLS, i - 4));
}

void solve() {
    base = {{0, 1, 2, 3, 4}};
    BASE = tr(base);
    PLS = tr(pls);
    mapka[0] = 0;
    mapka[1] = 1;
    mapka[2] = 2;
    mapka[3] = 3;
    mapka[4] = 4;
    mapka[-1] = (-22 + mod) % mod;
    mapka[-2] = 33;
    mapka[-3] = (mapka[2] - 5 * mapka[1] - 4 * mapka[0] - 3 * mapka[-1] - 2 * mapka[-2] + 10 * mod) % mod;
    mapka[-4] = (mapka[1] - 5 * mapka[0] - 4 * mapka[-1] - 3 * mapka[-2] - 2 * mapka[-3] + 10 * mod) % mod;
    for (int i = 5; i < 1000001; i++) {
        mapka[i] = (5 * mapka[i - 1] + 4 * mapka[i - 2] + 3 * mapka[i - 3] + 2 * mapka[i - 4] + 1 * mapka[i - 5]) % mod;
    }
    cin >> n >> q;
    vec<int> p(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        mat[i] = get(a[i]);
        p[i] = (mat[i].x[0][4] + p[i - 1]) % mod;
    }

    while (q--) {
        int type;
        cin >> type;

        if (type == 1) {
            int l, r;
            cin >> l >> r;
            if (l == r) {
                cout << mat[l].x[0][4];
            } else {
                cout << (p[r] - p[l - 1] + mod) % mod;
            }
            cout << '\n';
        } else {
            int l, r, val;
            cin >> l >> r >> val;
            if (l == r && val >= 0) {
                mat[l] = mult(mat[l], bin_pow(PLS, val));
            }
        }
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();

    return 0;
}
