#include <bits/stdc++.h>
#define endl '\n'
#define int ll
#define ve vector
#define pb push_back
#define F first
#define S second
#define all(x) x.begin(),x.end()

using namespace std;

typedef long long ll;

const int mod = int(1e8 + 543);
const int N = int(1e5 + 10);

array <int , 5> start_x = {100000521 , 0 , 1 , 2 , 3};

struct Matrix
{
	array <array <int , 5> , 5> a;
	Matrix()
	{
		for(int i = 0;i < 5;++ i)
		{
			for(int j = 0;j < 5;++ j)
			{
				a[i][j] = 0;
			}
		}
	}
	Matrix(int nul)
	{
		if(nul == 0)
		{
			for(int i = 0;i < 5;++ i)
			{
				for(int j = 0;j < 5;++ j)
				{
					a[i][j] = 0;
				}
			}
		}
		if(nul == 1)
		{
			for(int i = 0;i < 5;++ i)
			{
				for(int j = 0;j < 5;++ j)
				{
					a[i][j] = 0;
				}
				a[i][i] = 1;
			}
		}
	}
	Matrix operator*(const Matrix &other)
	{
		Matrix ans = Matrix(0);
		for(int i = 0;i < 5;++ i)
		{
			for(int j = 0;j < 5;++ j)
			{
				for(int k = 0;k < 5;++ k)
				{
					ans.a[i][j] += (a[i][k] * other.a[k][j]) % mod;
				}
				ans.a[i][j] %= mod;
			}
		}
		return ans;
	}
};

Matrix bin_pow(int b)
{
    Matrix ans = Matrix(1);
    Matrix a = Matrix(0);
    if(b > 0)
    {
        a.a[1][0] = 1;
        a.a[2][1] = 1;
        a.a[3][2] = 1;
        a.a[4][3] = 1;
        a.a[0][4] = 1;
        a.a[1][4] = 2;
        a.a[2][4] = 3;
        a.a[3][4] = 4;
        a.a[4][4] = 5;
    }
    else
    {
        a.a[0][1] = 1;
        a.a[1][2] = 1;
        a.a[2][3] = 1;
        a.a[3][4] = 1;
        a.a[4][0] = 1;
        a.a[3][0] = -5;
        a.a[2][0] = -4;
        a.a[1][0] = -3;
        a.a[0][0] = -2;
    }
    b = abs(b);
    while(b != 0)
    {
        if(b % 2)
        {
            ans = ans * a;
        }
        a = a * a;
        b /= 2;
    }
    return ans;
}


struct node
{
	array <int , 5> a;
	node()
	{
		fill(all(a) , 0);
	}
};

node t[N * 4];
int lazy[N * 4];

void upd_matrix(int v , int need)
{
	int b = need;
	Matrix answer = Matrix(1);
	Matrix a = Matrix(0);
	if(b > 0)
	{
		a.a[1][0] = 1;
		a.a[2][1] = 1;
		a.a[3][2] = 1;
		a.a[4][3] = 1;
		a.a[0][4] = 1;
		a.a[1][4] = 2;
		a.a[2][4] = 3;
		a.a[3][4] = 4;
		a.a[4][4] = 5;
	}
	else
	{
		a.a[0][1] = 1;
		a.a[1][2] = 1;
		a.a[2][3] = 1;
		a.a[3][4] = 1;
		a.a[4][0] = 1;
		a.a[3][0] = -5;
		a.a[2][0] = -4;
		a.a[1][0] = -3;
		a.a[0][0] = -2;
	}
	b = abs(b);
	while(b != 0)
	{
		if(b % 2)
		{
			answer = answer * a;
		}
		a = a * a;
		b /= 2;
	}
	node ans = node();
	for(int i = 0;i < 1;++ i)
	{
		for(int j = 0;j < 5;++ j)
		{
			for(int k = 0;k < 5;++ k)
			{
				ans.a[j] += (t[v].a[k] * answer.a[k][j] + mod) % mod;
				ans.a[j] += mod;
				ans.a[j] %= mod;
			}
		}
	}
	/**for(int i = 0;i < 5;++ i)
	{
		for(int j = 0;j < 5;++ j)
		{
			cerr << now.a[i][j] << ' ';
		}
		cerr << endl;
	}
	cerr << endl;**/
	t[v] = ans;
	return;
}

void push(int v , int cl , int cr)
{
	if(lazy[v] == 0)
	{
		return;
	}
	upd_matrix(v , lazy[v]);
	if(cl != cr)
	{
		lazy[v * 2] += lazy[v];
		lazy[v * 2 + 1] += lazy[v];
	}
	lazy[v] = 0;
	return;///done
}

void upd(int v , int cl , int cr , int l , int r , int x)
{
	///cerr << v << endl;
	push(v , cl , cr);
	if(cl > r || cr < l)
	{
		return;
	}
	if(cl >= l && cr <= r)
	{
		lazy[v] = x;
		push(v , cl , cr);
		return;
	}
	ll mid = (cl + cr) / 2;
	upd(v * 2 , cl , mid , l , r , x);
	upd(v * 2 + 1 , mid + 1 , cr , l , r , x);
	for(int j = 0;j < 5;++ j)
	{
		t[v].a[j] = (t[v * 2].a[j] + t[v * 2 + 1].a[j] + mod) % mod;
	}
}

ll get(int v , int cl , int cr , int l , int r)
{
	push(v , l , cr);
	if(cl > r || cr < l)
	{
		return 0;
	}
	if(cl >= l && cr <= r)
	{
		return t[v].a[4];
	}
	ll mid = (cl + cr) / 2;
	return (get(v * 2 , cl , mid , l , r) + get(v * 2 + 1 , mid + 1 , cr , l , r)) % mod;
}

int a[N] , st;

int32_t main()
{
	
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	#ifdef LOCAL
		freopen("input.txt" , "r" , stdin);
		freopen("output.txt" , "w" , stdout);
	#endif // LOCAL
	/**for(int i = 0;i < 5;++i)
	{
		start[i] = i;
	}
	for(int i = 0;i < mod;++ i)
	{
		ll x = start[4];
		for(int i = 0;i < 4;++ i)
		{
			x -= start[i] * (i + 2);
			x += mod;
			x %= mod;
		}
		for(int i = 4;i >= 1;-- i)
		{
			start[i] = start[i - 1];
		}
		start[0] = x;
		///cout << x << endl;
	}
	for(int i = 0;i < 5;++ i)
	{
		cout << start[i] << ' ';
	}
	reverse(all(start));
	**/
	int n , q;
	cin >> n >> q;
	for(int i = 0;i < n;++ i)
	{
		a[i] = 4;
	}
	while((1 << st) < n)
	{
		++ st;
	}
	for(int i = 0;i < n;++ i)
	{
		ll x;
		cin >> x;
		for(int j = 0;j < 5;++ j)
		{
			t[i + (1 << st)].a[j] = j;
		}
		upd_matrix(i + (1 << st) , x - a[i]);
		/**for(int j = 0;j < 5;++ j)
		{
			cout << t[i + (1 << st)].a[j] << ' ';
		}
		cout << endl;**/
	}
	for(int i = (1 << st) - 1;i > 0;-- i)
	{
		for(int j = 0;j < 5;++ j)
		{
			t[i].a[j] = ((t[i * 2].a[j] + t[i * 2 + 1].a[j]) % mod + mod) % mod;
		}
	}
	while(q --)
	{
		int type;
		cin >> type;
		if(type == 1)
		{
			ll l , r;
			cin >> l >> r;
			-- l;
			-- r;
			cout << get(1 , 0 , (1 << st) - 1 , l , r) << endl;
		}
		else
		{
			ll l , r , x;
			cin >> l >> r >> x;
			-- l;
			-- r;
			upd(1 , 0 , (1 << st) - 1 , l , r , x);
		}
	}
	return 0;
}

