#include <bits/stdc++.h>
#include "puzzle.h"


using namespace std;
#define int long long
using ll = long long;
using ld = long double;
const ll INF = 1e9, N = 1e6 + 100, MOD = 1e8 + 543, K = 20;
mt19937 rnd(232234);

int nums, tl;

void init(int numSubtests, double timeLimit) {
    nums = numSubtests;
    tl = timeLimit;
}

struct edge{
    int x1, y1, x2, y2;
};
vector<edge> ed;
vector<std::vector<int>> a, p;
bool f = 0;

bool to_paint(edge e, int clr) {
    auto [x1, y1, x2, y2] = e;
    for (int i = x1 + 1; i < x2; i++) {
        for (int j = y1 + 1; j < y2; j++) {
            if (a[i][j] != 0 && clr != 0) {
                for (int i2 = x1 + 1; i2 <= i; i2++) {
                    for (int j2 = y1 + 1; j2 <= j; j2++) {
                        if (i == i2 && j == j2) break;
                        a[i2][j2] = 0;
                    }
                }
            }
            a[i][j] = clr;
        }
    }
    return 1;
}
int n, m;

bool check() {
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (p[i][j] != 0) {
                int sum = 0;
                if (i != 0)
                    sum += abs(a[i - 1][j]) / 2;
                if (j != 0)
                    sum += abs(a[i][j - 1]);
                if (i != n - 1)
                    sum += abs(a[i + 1][j]) / 2;
                if (j != m - 1)
                    sum += abs(a[i][j + 1]);
                if (sum != p[i][j]) return 0;
            }
        }
    }
    return 1;
}

void rec(int id) {
    if (id + 1 == ed.size()) {
        if (check()) {
            f = 1;
            return;
        }
    }
    rec(id + 1);
    if (f) return;
    if (ed[id].x1 == ed[id].x2) {
        bool f2 = to_paint(ed[id], -1);
        if (f2) {
            if (id + 1 == ed.size()) {
                if (check()) {
                    f = 1;
                    return;
                }
            } else {
                rec(id + 1);
                if (f) return;
            }
            to_paint(ed[id], 0);
        }
        f2 = to_paint(ed[id], -2);
        if (f2) {
            if (id + 1 == ed.size()) {
                if (check()) {
                    f = 1;
                    return;
                }
            } else {
                rec(id + 1);
                if (f) return;
            }
            to_paint(ed[id], 0);
        }
    }
    else {
        bool f2 = to_paint(ed[id], -3);
        if (f2) {
            if (id + 1 == ed.size()) {
                if (check()) {
                    f = 1;
                    return;
                }
            } else {
                rec(id + 1);
                if (f) return;
            }
            to_paint(ed[id], 0);
        }
        f2 = to_paint(ed[id], -4);
        if (f2) {
            if (id + 1 == ed.size()) {
                if (check()) {
                    f = 1;
                    return;
                }
            } else {
                rec(id + 1);
                if (f) return;
            }
            to_paint(ed[id], 0);
        }
    }

}
bool solve(std::vector<std::vector<int>>& puzzle) {
    a = puzzle;
    p = puzzle;
    f = 0;
    ed.clear();
    n = a.size(), m = a[0].size();
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][j] != 0) {
                int j2 = j + 1;
                while (j2 < m && a[i][j2] == 0)
                    j2++;
                if (j2 != m) {
                    ed.push_back({i, j, i, j2});
                }int i2 = i + 1;
                while (i2 < n && a[i2][j] == 0)
                    i2++;
                if (i2 != n) {
                    ed.push_back({i, j, i2, j});
                }
            }
        }
    }
    rec(0);
    return 1;
}

