#include <bits/stdc++.h>
#include "puzzle.h"


using namespace std;
//#define int long long
using ll = long long;
using ld = long double;
const ll INF = 1e9, N = 1e6 + 100, MOD = 1e8 + 543, K = 20;
mt19937 rnd(232234);


void init(int numSubtests, double timeLimit) {

}

struct edge{
    int x1, y1, x2, y2;
};
vector<edge> ed;
vector<std::vector<int>> a, p;
bool f = 0;
int n, m;

bool to_paint(edge e, int clr) {
    auto [x1, y1, x2, y2] = e;
    if (x1 == x2) {
        for (int j = y1 + 1; j < y2; j++) {
            if (a[x1][j] != 0 && clr != 0) {
                for (int j2 = y1 + 1; j2 < j; j2++) {
                    a[x1][j2] = 0;
                }
                return 0;
            }
            a[x1][j] = clr;
        }

    } else {
        for (int i = x1 + 1; i < x2; i++) {
            if (a[i][y1] != 0 && clr != 0) {
                for (int i2 = x1 + 1; i2 < i; i2++) {
                    a[i2][y1] = 0;
                }
                return 0;
            }
            a[i][y1] = clr;
        }
    }
    return 1;
}


vector<pair<int, int>> pr = {{0,  1},
                             {1,  0},
                             {-1, 0},
                             {0,  -1}};
vector<vector<int>> used;

void dfs(int x, int y) {
    used[x][y] = 1;
    for (auto [xp, yp]: pr) {
        int x2 = x + xp, y2 = y + yp;
        if (x2 < 0 || x2 >= n || y2 < 0 || y2 >= m || used[x2][y2] || a[x2][y2] == 0) continue;
        dfs(x2, y2);
    }
}

bool check() {
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (p[i][j] >= 0) {
                int sum = 0;
                if (i != 0 && abs(a[i - 1][j]) > 2 && a[i - 1][j] < 0)
                    sum += abs(a[i - 1][j]) / 2;
                if (j != 0 && abs(a[i][j - 1]) <= 2 && a[i][j - 1] < 0)
                    sum += abs(a[i][j - 1]);
                if (i != n - 1 && abs(a[i + 1][j]) > 2 && a[i + 1][j] < 0)
                    sum += abs(a[i + 1][j]) / 2;
                if (j != m - 1 && abs(a[i][j + 1]) <= 2 && a[i][j + 1] < 0)
                    sum += abs(a[i][j + 1]);
                if (sum != p[i][j]) return 0;
            }
        }
    }
    used.assign(n, vector<int>(m, 0));
    bool f3 = 1;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (p[i][j] > 0) {
                if (f3) {
                    dfs(i, j);
                    f3 = 0;
                }
                if (!used[i][j]) return 0;

            }
        }
    }
    return 1;
}


void rec(int id) {
    if (id + 1 == ed.size()) {
        if (check()) {
            f = 1;
            return;
        }
    } else {
        rec(id + 1);
        if (f) return;
    }

    if (ed[id].x1 == ed[id].x2) {
        bool f2 = to_paint(ed[id], -1);
        if (f2) {
            if (id + 1 == ed.size()) {
                if (check()) {
                    f = 1;
                    return;
                }
            } else {
                rec(id + 1);
                if (f) return;
            }
            to_paint(ed[id], 0);
        }
        f2 = to_paint(ed[id], -2);
        if (f2) {
            if (id + 1 == ed.size()) {
                if (check()) {
                    f = 1;
                    return;
                }
            } else {
                rec(id + 1);
                if (f) return;
            }
            to_paint(ed[id], 0);
        }
    } else {
        bool f2 = to_paint(ed[id], -3);
        if (f2) {
            if (id + 1 == ed.size()) {
                if (check()) {
                    f = 1;
                    return;
                }
            } else {
                rec(id + 1);
                if (f) return;
            }
            to_paint(ed[id], 0);
        }
        f2 = to_paint(ed[id], -4);
        if (f2) {
            if (id + 1 == ed.size()) {
                if (check()) {
                    f = 1;
                    return;
                }
            } else {
                rec(id + 1);
                if (f) return;
            }
            to_paint(ed[id], 0);
        }
    }

}

bool solve(std::vector<std::vector<int>> &puzzle) {
    a = puzzle;
    p = puzzle;
    f = 0;
    ed.clear();
    n = a.size(), m = a[0].size();
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][j] != 0) {
                int j2 = j + 1;
                while (j2 < m && a[i][j2] == 0)
                    j2++;
                if (j2 != m) {
                    ed.push_back({i, j, i, j2});
                }
                int i2 = i + 1;
                while (i2 < n && a[i2][j] == 0)
                    i2++;
                if (i2 != n) {
                    ed.push_back({i, j, i2, j});
                }
            }
        }
    }
    rec(0);

    puzzle = a;
    return 1;
}

