#include "ones.h"

#include <bits/stdc++.h>

#include <random>

using namespace std;

bool hasOnes(int l, int r);

vector<int> guessOnes(int n, int k) {
    int cn = n / k;
    vector<pair<int, int>> z;
    for (int i = 0; i < k; i += cn) {
        z.push_back({i, i + cn - 1});
    }
    z.back().second = n - 1;
    shuffle(z.begin(), z.end(), std::mt19937(std::random_device()()));
    vector<int> ans;
    int cnt = k;
    for (int i = 0; i < z.size() && cnt; ++i) {
        int L = z[i].first, R = z[i].second;
        int id = L;
        while (id <= R && cnt) {
            if (!hasOnes(id + 1, R + 1))break;
            int l = id - 1;
            int r = R;
            while (l + 1 < r) {
                int mid = (l + r) / 2;
                if (!hasOnes(id + 1, mid + 1)) {
                    l = mid;
                } else {
                    r = mid;
                }
            }
            ans.push_back(r + 1);
            id = r + 1;
            cnt--;
        }
    }
    return ans;
}