#include <bits/stdc++.h>
#include "puzzle.h"

using namespace std;
#define ll long long
#define pb push_back
#define F first
#define S second
#define all(x) x.begin(),x.end()

void init(int numSubtests, double timeLimit) {

}

const int N = 50;
vector<vector<int>> a, b;

void draw(int i, int j, int x, int y, int cnt = 3) {
    if (cnt == 3) {
        cnt = min(b[i][j], b[x][y]);
        cnt = min(cnt, 2);
    }
    if(cnt==0){
        return;
    }
    b[i][j] -= cnt;
    b[x][y] -= cnt;
    if (i == x) {
        int r = max(j, y);
        for (int k = min(j, y) + 1; k < r; ++k) {
            if (cnt == 1) {
                a[i][k] = -1;
            } else {
                a[i][k] = -3;
            }
        }
    } else if (j == y) {
        int r = max(i, x);
        for (int k = min(i, x) + 1; k < r; ++k) {
            if (cnt == 1) {
                a[k][j] = -2;
            } else {
                a[k][j] = -4;
            }
        }
    } else {
        assert(false);
    }
}

vector<vector<int>> l, r, u, d;

void calc() {
    int n = a.size();
    int m = a[0].size();
    l = a;
    r = a;
    u = a;
    d = a;
    for (int i = 0; i < n; ++i) {
        int last = -1;
        for (int j = 0; j < m; ++j) {
            if (a[i][j] < 0) {
                last = -1;
            } else if (a[i][j] > 0) {
                l[i][j] = last;
                last = j;
            }
        }
        last = -1;
        for (int j = m - 1; j >= 0; --j) {
            if (a[i][j] < 0) {
                last = -1;
            } else if (a[i][j] > 0) {
                r[i][j] = last;
                last = j;
            }
        }
    }
    for (int j = 0; j < m; ++j) {
        int last = -1;
        for (int i = 0; i < n; ++i) {
            if (a[i][j] < 0) {
                last = -1;
            } else if (a[i][j] > 0) {
                u[i][j] = last;
                last = i;
            }
        }
        last = -1;
        for (int i = n - 1; i >= 0; --i) {
            if (a[i][j] < 0) {
                last = -1;
            } else if (a[i][j] > 0) {
                d[i][j] = last;
                last = i;
            }
        }
    }
}


vector<pair<int, int>> must, v2;

bool anymust(vector<pair<int, int>> &v) {
    must.clear();
    v2.clear();
    for (auto [i, j]: v) {
        int sum = 0;
        int cnt = 0;
        if (l[i][j] != -1) {
            sum += min(2, b[i][l[i][j]]);
            ++cnt;
        }
        if (r[i][j] != -1) {
            sum += min(2, b[i][r[i][j]]);
            ++cnt;
        }
        if (u[i][j] != -1) {
            sum += min(2, b[u[i][j]][j]);
            ++cnt;
        }
        if (d[i][j] != -1) {
            sum += min(2, b[d[i][j]][j]);
            ++cnt;
        }
        if (sum == b[i][j] || (b[i][j] == 1 && cnt == 1)) {
//            cerr << i << " " << j << endl;
            must.pb({i, j});
        } else {
            v2.pb({i, j});
        }
    }
    if(must.empty()){
        return false;
    }
    return true;
}

bool solve(std::vector<std::vector<int>> &puzzle) {
    a = puzzle;
    int n = a.size();
    int m = a[0].size();
    vector<pair<int, int>> v;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (a[i][j] != 0) {
                v.pb({i, j});
            }
        }
    }
    b = a;
    calc();
    while (!v.empty() && anymust(v)) {
        for (auto [i, j]: must) {
            if (l[i][j] != -1) {
                draw(i, j, i, l[i][j]);
            }
            if (r[i][j] != -1) {
                draw(i, j, i, r[i][j]);
            }
            if (d[i][j] != -1) {
                draw(i, j, d[i][j], j);
            }
            if (u[i][j] != -1) {
                draw(i, j, u[i][j], j);
            }
        }
        v = v2;
//        for(int i=0;i<n;++i){
//            for(int j=0;j<m;++j){
//                cerr << a[i][j] << ' ';
//            }
//            cerr << "\n";
//        }
        calc();
    }
    puzzle = a;
    return true;
}