#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

#define ios ios_base::sync_with_stdio(false); cin.tie(0);
#define F first
#define S second
#define int long long
#define endl '\n'
using namespace std;
using namespace __gnu_pbds;
const int N = 5, mod = 1e8 + 543;
const vector<int> d = {0, 1, 2, 3, 4};
const vector<vector<int>> bs = {{1, 0, 0, 0, 0},
                                {0, 1, 0, 0, 0},
                                {0, 0, 1, 0, 0},
                                {0, 0, 0, 1, 0},
                                {0, 0, 0, 0, 1}};
const vector<vector<int>> A = {{0, 0, 0, 0, 1},
                               {1, 0, 0, 0, 2},
                               {0, 1, 0, 0, 3},
                               {0, 0, 1, 0, 4},
                               {0, 0, 0, 1, 5}};
const vector<vector<int>> rA = {{mod - 2, 1, 0, 0, 0},
                                {mod - 3, 0, 1, 0, 0},
                                {mod - 4, 0, 0, 1, 0},
                                {mod - 5, 0, 0, 0, 1},
                                {1,       0, 0, 0, 0}};
vector<int> b(N);
vector<vector<int>> ff;

inline void per(vector<vector<int>> f, vector<vector<int>> &s) {
    for (int j = 0; j < N; j++) {
        fill(b.begin(), b.end(), 0);
        for (int i = 0; i < N; i++) {
            for (int k = 0; k < N; k++)
                b[k] += f[k][i] * s[i][j] % mod;
        }
        for (int i = 0; i < N; i++)
            s[i][j] = b[i] % mod;
    }
}

void up(int x, vector<vector<int>> &M) {
    if (x == 1) {
        M = A;
        return;
    }
    up(x / 2, M);
    per(M, M);
    if (x % 2 == 1)
        per(A, M);
}

void nup(int x, vector<vector<int>> &M) {
    if (x == 1) {
        M = rA;
        return;
    }
    nup(x / 2, M);
    per(M, M);
    if (x % 2 == 1)
        per(rA, M);
}

const int R = 1 << 17, C = 27;
vector<int> fl;
vector<vector<int>> t;
vector<vector<vector<int>>> st1, st2;
inline void getM(int x, vector<vector<int>> &M){
    M = bs;
    if(x == 0)
        return;
    bool was = false;
    if(x < 0){
        was = true;
        x *= -1;
    }
    for(int i = C - 1; i >= 0; i --){
        if((1<<i) & x) {
            if(!was)
                per(st1[i], M);
            else
                per(st2[i], M);
        }
    }
}
inline void build() {
    for (int i = R - 1; i >= 0; i--) {
        for (int j = 0; j < N; j++)
            t[i][j] = (t[2 * i][j] + t[2 * i + 1][j]) % mod;
    }
}

inline void push(int v) {
    if (fl[v] == 0)
        return;
    getM(fl[v], ff);
    for (int k = 2 * v; k <= 2 * v + 1; k++) {
        fill(b.begin(), b.end(), 0);
        for (int j = 0; j < N; j++) {
            for (int i = 0; i < N; i++)
                b[j] += t[k][i] * ff[i][j] % mod;
            b[j] %= mod;
        }
        t[k] = b;
        fl[k] += fl[v];
    }
    fl[v] = 0;
}

int get(int ql, int qr, int l = 0, int r = R - 1, int v = 1) {
    if (ql > r || l > qr)
        return 0;
    if (ql <= l && r <= qr)
        return t[v][N - 1];
    push(v);
    int m = (l + r) / 2;
    return (get(ql, qr, l, m, 2 * v) + get(ql, qr, m + 1, r, 2 * v + 1)) % mod;
}

void update(int x, int ql, int qr, int l = 0, int r = R - 1, int v = 1) {
    if (ql > r || l > qr)
        return;
    if (ql <= l && r <= qr) {
        fill(b.begin(), b.end(), 0);
        for (int j = 0; j < N; j++) {
            for (int i = 0; i < N; i++)
                b[j] += t[v][i] * ff[i][j] % mod;
            b[j] %= mod;
        }
        t[v] = b;
        fl[v] += x;
        return;
    }
    push(v);
    int m = (l + r) / 2;
    update(x, ql, qr, l, m, 2 * v);
    update(x, ql, qr, m + 1, r, 2 * v + 1);
    for (int i = 0; i < N; i++)
        t[v][i] = (t[2 * v][i] + t[2 * v + 1][i]) % mod;
}

inline void solve() {
    t.resize(2 * R, vector<int>(N));
    fl.resize(2 * R);
    st1.resize(C, vector<vector<int>> (N, vector<int> (N)));
    st2.resize(C, vector<vector<int>> (N, vector<int> (N)));
    for(int i = 0; i < C; i ++){
        st1[i] = bs;
        up((1<<i), st1[i]);
    }
    ff = bs;
    for(int i = 0; i < C; i ++){
        st2[i] = bs;
        nup((1<<i), st2[i]);
    }
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        a[i] -= 4;
        if (a[i] == 0) {
            t[i + R] = d;
            continue;
        }
        getM(a[i], ff);
        for (int j = 0; j < N; j++) {
            for (int k = 0; k < N; k++)
                t[i + R][j] += d[k] * ff[k][j] % mod;
            t[i + R][j] %= mod;
        }
    }
    build();
    while (q--) {
        int type, l, r;
        cin >> type >> l >> r;
        l--, r--;
        if (type == 1) {
            cout << get(l, r) << endl;
        } else {
            int x;
            cin >> x;
            if (x != 0) {
                getM(x, ff);
                update(x, l, r);
            }
        }
    }
}

signed main() {
    ios
    solve();
}