#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#define ios ios_base::sync_with_stdio(false); cin.tie(0);
#define F first
#define S second
#define int long long
#define endl '\n'
using namespace std;
using namespace __gnu_pbds;
const int N = 5, mod = 1e8 + 543, L = 1e4 + 800;
const vector<int> d = {0, 1, 2, 3, 4};
const vector<vector<int>> bs = {{1, 0, 0, 0, 0},
                                {0, 1, 0, 0, 0},
                                {0, 0, 1, 0, 0},
                                {0, 0, 0, 1, 0},
                                {0, 0, 0, 0, 1}};
const vector<vector<int>> A = {{0, 0, 0, 0, 1},
                               {1, 0, 0, 0, 2},
                               {0, 1, 0, 0, 3},
                               {0, 0, 1, 0, 4},
                               {0, 0, 0, 1, 5}};
const vector<vector<int>> rA = {{mod - 2, 1, 0, 0, 0},
                                {mod - 3, 0, 1, 0, 0},
                                {mod - 4, 0, 0, 1, 0},
                                {mod - 5, 0, 0, 0, 1},
                                {1,       0, 0, 0, 0}};
vector<int> b(N);
vector<vector<int>> ff;
inline void per(vector<vector<int>> f, vector<vector<int>> &s) {
    for (int j = 0; j < N; j++) {
        fill(b.begin(), b.end(), 0);
        for (int i = 0; i < N; i++) {
            for (int k = 0; k < N; k++)
                b[k] += f[k][i] * s[i][j];
        }
        for (int i = 0; i < N; i++)
            s[i][j] = b[i] % mod;
    }
}
const int R = 1 << 17;
vector<int> fl;
vector<vector<vector<int>>> upd;
vector<vector<int>> t;
vector<vector<vector<int>>> fst, sst, fst2, sst2;
inline void getM(int x, vector<vector<int>> &M) {
    M = bs;
    if (x == 0)
        return;
    if (x > 0) {
        if (x / L != 0)
            M = sst[x / L - 1];
        per(fst[x % L], M);
    } else {
        x *= -1;
        if (x / L != 0)
            M = sst2[x / L - 1];
        per(fst2[x % L], M);
    }
}
inline void build() {
    for (int i = R - 1; i >= 0; i--) {
        for (int j = 0; j < N; j++)
            t[i][j] = (t[2 * i][j] + t[2 * i + 1][j]) % mod;
    }
}
inline void push(int v) {
    if (fl[v] == 0)
        return;
    for (int k = 2 * v; k <= 2 * v + 1; k++) {
        fill(b.begin(), b.end(), 0);
        for (int j = 0; j < N; j++) {
            for (int i = 0; i < N; i++)
                b[j] += t[k][i] * upd[v][i][j];
            b[j] %= mod;
        }
        t[k] = b;
        if(fl[k] == 0)
            upd[k] = upd[v];
        else
            per(upd[v], upd[k]);
        fl[k] += fl[v];
    }
    upd[v] = bs;
    fl[v] = 0;
}
int get(int ql, int qr, int l = 0, int r = R - 1, int v = 1) {
    if (ql > r || l > qr)
        return 0;
    if (ql <= l && r <= qr)
        return t[v][N - 1];
    push(v);
    int m = (l + r) / 2;
    return (get(ql, qr, l, m, 2 * v) + get(ql, qr, m + 1, r, 2 * v + 1)) % mod;
}
void update(int x, int ql, int qr, int l = 0, int r = R - 1, int v = 1) {
    if (ql > r || l > qr)
        return;
    if (ql <= l && r <= qr) {
        fill(b.begin(), b.end(), 0);
        for (int j = 0; j < N; j++) {
            for (int i = 0; i < N; i++)
                b[j] += t[v][i] * ff[i][j];
            b[j] %= mod;
        }
        t[v] = b;
        if(fl[v] == 0){
            upd[v] = ff;
        }else
            per(ff, upd[v]);
        fl[v] += x;
        return;
    }
    push(v);
    int m = (l + r) / 2;
    update(x, ql, qr, l, m, 2 * v);
    update(x, ql, qr, m + 1, r, 2 * v + 1);
    for (int i = 0; i < N; i++)
        t[v][i] = (t[2 * v][i] + t[2 * v + 1][i]) % mod;
}
inline void solve() {
    t.resize(2 * R, vector<int>(N));
    fl.resize(2 * R);
    fst.resize(L, bs);
    upd.resize(2 * R, bs);
    fst2.resize(L, bs);
    for(int i = 1; i < L; i ++){
        fst[i] = fst[i - 1];
        fst2[i] = fst2[i - 1];
        per(rA, fst2[i]);
        per(A, fst[i]);
    }
    sst.resize(mod / L + 1, bs);
    sst2.resize(mod / L + 1, bs);
    sst[0] = fst.back();
    sst2[0] = fst2.back();
    per(rA, sst2[0]);
    per(A, sst[0]);
    for(int i = 1; i <= mod / L ;i ++){
        sst[i] = sst[i - 1];
        sst2[i] = sst2[i - 1];
        per(sst[0], sst[i]);
        per(sst2[0], sst2[i]);
    }
    ff = bs;
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        a[i] -= 4;
        if (a[i] == 0) {
            t[i + R] = d;
            continue;
        }
        getM(a[i], ff);
        for (int j = 0; j < N; j++) {
            for (int k = 0; k < N; k++)
                t[i + R][j] += d[k] * ff[k][j];
            t[i + R][j] %= mod;
        }
    }
    build();
    while (q--) {
        int type, l, r;
        cin >> type >> l >> r;
        l--, r--;
        if (type == 1) {
            cout << get(l, r) << endl;
        } else {
            int x;
            cin >> x;
            if (x != 0) {
                getM(x, ff);
                update(x, l, r);
            }
        }
    }
}
signed main() {
    ios
    solve();
}