#include <bits/stdc++.h>
#include "puzzle.h"

using namespace std;

#define ll long long
#define F first
#define S second
mt19937 rnd(100);


void init(int numSubtests, double timeLimit) {

}

vector<vector<int>> arr1, cnt, ost;
vector<vector<int>> U, L, D, R;

void upd(int a, int b);

void fl(int i, int j, int cn) {
    int x0 = j, y0 = i;
    for (int h = 0; h < L[y0][x0]; ++h) {
        j--;
        arr1[i][j] = -cn;
    }

    cnt[y0][x0]--;
    ost[y0][x0] -= cn;
    cnt[y0][x0 - L[y0][x0] - 1]--;
    ost[y0][x0 - L[y0][x0] - 1] -= cn;
    R[y0][x0 - L[y0][x0] - 1] = -1;
    ll a = y0, b = x0 - L[y0][x0] - 1;
    L[y0][x0] = -1;
    upd(a, b);
}

void fr(int i, int j, int cn) {
    int x0 = j, y0 = i;
    for (int h = 0; h < R[y0][x0]; ++h) {
        j++;
        arr1[i][j] = -cn;
    }

    cnt[y0][x0]--;
    ost[y0][x0] -= cn;
    cnt[y0][x0 + R[y0][x0] + 1]--;
    ost[y0][x0 + R[y0][x0] + 1] -= cn;
    L[y0][x0 + R[y0][x0] + 1] = -1;
    ll a = y0, b = x0 + R[y0][x0] + 1;
    R[y0][x0] = -1;
    upd(a, b);
}

void fu(int i, int j, int cn) {
    int x0 = j, y0 = i;
    for (int h = 0; h < U[y0][x0]; ++h) {
        i--;
        arr1[i][j] = -2 - cn;
    }

    cnt[y0][x0]--;
    ost[y0][x0] -= cn;
    cnt[y0 - U[y0][x0] - 1][x0]--;
    ost[y0 - U[y0][x0] - 1][x0] -= cn;
    D[y0 - U[y0][x0] - 1][x0] = -1;
    ll a = y0 - U[y0][x0] - 1, b = x0;
    U[y0][x0] = -1;
    upd(a, b);
}

void fd(int i, int j, int cn) {
    int x0 = j, y0 = i;
    for (int h = 0; h < D[y0][x0]; ++h) {
        i++;
        arr1[i][j] = -2 - cn;
    }

    cnt[y0][x0]--;
    ost[y0][x0] -= cn;
    cnt[y0 + D[y0][x0] + 1][x0]--;
    ost[y0 + D[y0][x0] + 1][x0] -= cn;
    U[y0 + D[y0][x0] + 1][x0] = -1;
    ll a = y0 + D[y0][x0] + 1, b = x0;
    D[y0][x0] = -1;
    upd(a, b);
}

void upd(int i, int j) {
    if (ost[i][j] > 0 && ost[i][j] == cnt[i][j] * 2) {
        if (U[i][j] != -1) {
            fu(i, j, 2);
        }
        if (D[i][j] != -1) {
            fd(i, j, 2);
        }
        if (L[i][j] != -1) {
            fl(i, j, 2);
        }
        if (R[i][j] != -1) {
            fr(i, j, 2);
        }
    }

    if (ost[i][j] > 0 && (L[i][j] != -1) + (R[i][j] != -1) + (U[i][j] != -1) + (D[i][j] != -1) == 1) {
        if (L[i][j] != -1)
            fl(i, j, ost[i][j]);
        if (R[i][j] != -1)
            fr(i, j, ost[i][j]);
        if (U[i][j] != -1)
            fu(i, j, ost[i][j]);
        if (D[i][j] != -1)
            fd(i, j, ost[i][j]);
    }
}

bool solve(vector<vector<int>> &arr) {
    arr1 = ost = arr;
    int n = arr.size();
    int m = arr[0].size();
    cnt.assign(n, *new vector<int>(m));
    U.assign(n, *new vector<int>(m, -1));
    D = U, R = U, L = U;
    for (int i = 0; i < n; ++i) {
        int last = -1;
        for (int j = 0; j < m; ++j) {
            if (arr[i][j] > 0) {
                if (last != -1) {
                    L[i][j] = j - last - 1;
                    R[i][last] = j - last - 1;
                    cnt[i][j]++;
                    cnt[i][last]++;
                }
                last = j;
            }
        }
    }

    for (int i = 0; i < m; ++i) {
        int last = -1;
        for (int j = 0; j < n; ++j) {
            if (arr[j][i] > 0) {
                if (last != -1) {
                    U[j][i] = j - last - 1;
                    D[last][i] = j - last - 1;
                    cnt[j][i]++;
                    cnt[last][i]++;
                }
                last = j;
            }
        }
    }

    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j)
            upd(i, j);

    arr = arr1;
    return 1;
}

/*
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    ll n, m;
    cin >> n >> m >> n >> m;
    vector<vector<int>> arr(n, *new vector<int>(m));
    for (auto &i: arr)
        for (auto &j: i)
            cin >> j;

    solve(arr);
    for (auto &i: arr) {
        for (int j: i)
            cout << (j == -1 ? "-" : j == -2 ? "=" : j == -3 ? "|" : j == -4 ? "#" : to_string(j)) << ' ';
        cout << '\n';
    }
}*/
/*

*/
/*

*/
/*

*/
/*

*/
