#include <bits/stdc++.h>
#include "puzzle.h"

using namespace std;
#define ll long long
#define F first
#define S second
mt19937 rnd(100);

void init(int numSubtests, double timeLimit) {
}

vector<vector<int>> arr1, cnt, ost;
vector<vector<int>> U, L, D, R;

void upd(int a, int b);

void fl(int i, int j, int cn) {
    if (L[i][j] == -1)
        return;
    int x0 = j, y0 = i;
    bool ok = 1;
    for (int h = 0; h < L[y0][x0]; ++h) {
        j--;
        ok = ok && !arr1[i][j];
    }
    j = x0, i = y0;
    if (ok)
        for (int h = 0; h < L[y0][x0]; ++h) {
            j--;
            arr1[i][j] = -cn;
        }
    cnt[y0][x0] -= min(1, (int) (cn || !ok));
    if (ok)
        ost[y0][x0] -= cn;
    cnt[y0][x0 - L[y0][x0] - 1] -= min(1, (int) (cn || !ok));
    if (ok)
        ost[y0][x0 - L[y0][x0] - 1] -= cn;
    if (cn || !ok)
        R[y0][x0 - L[y0][x0] - 1] = -1;
    ll a = y0, b = x0 - L[y0][x0] - 1;
    if (cn || !ok)
        L[y0][x0] = -1;
    if (cn || !ok)
        upd(a, b);
}

void fr(int i, int j, int cn) {
    if (R[i][j] == -1)
        return;
    int x0 = j, y0 = i;
    bool ok = 1;
    for (int h = 0; h < R[y0][x0]; ++h) {
        j++;
        ok = ok && !arr1[i][j];
    }
    j = x0, i = y0;
    if (ok)
        for (int h = 0; h < R[y0][x0]; ++h) {
            j++;
            arr1[i][j] = -cn;
        }
    cnt[y0][x0] -= min(1, (int) (cn || !ok));
    if (ok)
        ost[y0][x0] -= cn;
    cnt[y0][x0 + R[y0][x0] + 1] -= min(1, (int) (cn || !ok));
    if (ok)
        ost[y0][x0 + R[y0][x0] + 1] -= cn;
    if (cn || !ok)
        L[y0][x0 + R[y0][x0] + 1] = -1;
    ll a = y0, b = x0 + R[y0][x0] + 1;
    if (cn || !ok)
        R[y0][x0] = -1;
    if (cn || !ok)
        upd(a, b);
}

void fu(int i, int j, int cn) {
    if (U[i][j] == -1)
        return;
    int x0 = j, y0 = i;
    bool ok = 1;
    for (int h = 0; h < U[y0][x0]; ++h) {
        i--;
        ok = ok && !arr1[i][j];
    }
    j = x0, i = y0;
    if (ok)
        for (int h = 0; h < U[y0][x0]; ++h) {
            i--;
            if (cn)
                arr1[i][j] = -2 - cn;
        }
    cnt[y0][x0] -= min(1, (int) (cn || !ok));
    if (ok)
        ost[y0][x0] -= cn;
    cnt[y0 - U[y0][x0] - 1][x0] -= min(1, (int) (cn || !ok));
    if (ok)
        ost[y0 - U[y0][x0] - 1][x0] -= cn;
    if (cn || !ok)
        D[y0 - U[y0][x0] - 1][x0] = -1;
    ll a = y0 - U[y0][x0] - 1, b = x0;
    if (cn || !ok)
        U[y0][x0] = -1;
    if (cn || !ok)
        upd(a, b);
}

void fd(int i, int j, int cn) {
    if (D[i][j] == -1)
        return;
    int x0 = j, y0 = i;
    bool ok = 1;
    for (int h = 0; h < D[y0][x0]; ++h) {
        i++;
        ok = ok && !arr1[i][j];
    }
    j = x0, i = y0;
    if (ok)
        for (int h = 0; h < D[y0][x0]; ++h) {
            i++;
            if (cn)
                arr1[i][j] = -2 - cn;
        }
    cnt[y0][x0] -= min(1, (int) (cn || !ok));
    if (ok)
        ost[y0][x0] -= cn;
    cnt[y0 + D[y0][x0] + 1][x0] -= min(1, (int) (cn || !ok));
    if (ok)
        ost[y0 + D[y0][x0] + 1][x0] -= cn;
    if (cn || !ok)
        U[y0 + D[y0][x0] + 1][x0] = -1;
    ll a = y0 + D[y0][x0] + 1, b = x0;
    if (cn || !ok)
        D[y0][x0] = -1;
    if (cn || !ok)
        upd(a, b);
}

pair<int, int> gl(int i, int j) {
    if (L[i][j] == -1)
        return {-1, -1};
    return {i, j - L[i][j] - 1};
}

pair<int, int> gr(int i, int j) {
    if (R[i][j] == -1)
        return {-1, -1};
    return {i, j + R[i][j] + 1};
}

pair<int, int> gu(int i, int j) {
    if (U[i][j] == -1)
        return {-1, -1};
    return {i - U[i][j] - 1, j};
}

pair<int, int> gd(int i, int j) {
    if (D[i][j] == -1)
        return {-1, -1};
    return {i + D[i][j] + 1, j};
}

int ff(pair<ll, ll> pos) {
    if (pos.F == -1)
        return 0;
    return ost[pos.F][pos.S] + 1 == cnt[pos.F][pos.S] * 2;
}

int cnt1(pair<ll, ll> pos) {
    if (pos.F == -1)
        return 0;
    return min(2, ost[pos.F][pos.S]);
}

void upd(int i, int j) {
    fl(i, j, 0);
    fu(i, j, 0);
    fr(i, j, 0);
    fd(i, j, 0);

    if (ost[i][j] + 1 == cnt[i][j] * 2) {
        if (L[i][j] != -1 && ost[i][j - L[i][j] - 1] == 1)
            fl(i, j, 1);
        if (R[i][j] != -1 && ost[i][j + R[i][j] + 1] == 1)
            fr(i, j, 1);
        if (U[i][j] != -1 && ost[i - U[i][j] - 1][j] == 1)
            fu(i, j, 1);
        if (D[i][j] != -1 && ost[i + D[i][j] + 1][j] == 1)
            fd(i, j, 1);
    }

    if (ost[i][j] > 0 && ost[i][j] == cnt1(gl(i, j)) + cnt1(gr(i, j)) + cnt1(gu(i, j)) + cnt1(gd(i, j))) {
        fu(i, j, cnt1(gu(i, j)));
        fd(i, j, cnt1(gd(i, j)));
        fl(i, j, cnt1(gl(i, j)));
        fr(i, j, cnt1(gr(i, j)));
    }

    if (ost[i][j] > 0 && (L[i][j] != -1) + (R[i][j] != -1) + (U[i][j] != -1) + (D[i][j] != -1) == 1) {
        fl(i, j, ost[i][j]);
        fr(i, j, ost[i][j]);
        fu(i, j, ost[i][j]);
        fd(i, j, ost[i][j]);
    }

    if (arr1[i][j] && !ost[i][j]) {
        if (L[i][j] != -1) {
            cnt[i][j - L[i][j] - 1]--;
            cnt[i][j]--;
            R[i][j - L[i][j] - 1] = -1;
            ll a = i, b = j - L[i][j] - 1;
            L[i][j] = -1;
            upd(a, b);
        }
        if (R[i][j] != -1) {
            cnt[i][j + R[i][j] + 1]--;
            cnt[i][j]--;
            L[i][j + R[i][j] + 1] = -1;
            ll a = i, b = j + R[i][j] + 1;
            R[i][j] = -1;
            upd(a, b);
        }
        if (U[i][j] != -1 && ost[i - U[i][j] - 1][j] == 1) {
            cnt[i - U[i][j] - 1][j]--;
            cnt[i][j]--;
            D[i - U[i][j] - 1][j] = -1;
            ll a = i - U[i][j] - 1, b = j;
            U[i][j] = -1;
            upd(a, b);
        }
        if (D[i][j] != -1 && ost[i + D[i][j] + 1][j] == 1) {
            cnt[i + D[i][j] + 1][j]--;
            cnt[i][j]--;
            U[i + D[i][j] + 1][j] = -1;
            ll a = i + D[i][j] + 1, b = j;
            D[i][j] = -1;
            upd(a, b);
        }
    }

    if (L[i][j] != -1) {
        auto u = gu(i, j);
        auto d = gd(i, j);
        auto r = gr(i, j);
        auto l = gl(i, j);
        int can = ost[i][j] - (ff(u) + ff(d) + ff(r));
        if (can < 2 && ff(l))
            fl(i, j, 1);
    }

    if (R[i][j] != -1) {
        auto u = gu(i, j);
        auto d = gd(i, j);
        auto r = gr(i, j);
        auto l = gl(i, j);
        int can = ost[i][j] - (ff(u) + ff(d) + ff(l));
        if (can < 2 && ff(r))
            fr(i, j, 1);
    }

    if (U[i][j] != -1) {
        auto u = gu(i, j);
        auto d = gd(i, j);
        auto r = gr(i, j);
        auto l = gl(i, j);
        int can = ost[i][j] - (ff(l) + ff(d) + ff(r));
        if (can < 2 && ff(u))
            fu(i, j, 1);
    }

    if (D[i][j] != -1) {
        auto u = gu(i, j);
        auto d = gd(i, j);
        auto r = gr(i, j);
        auto l = gl(i, j);
        int can = ost[i][j] - (ff(u) + ff(l) + ff(r));
        if (can < 2 && ff(d))
            fd(i, j, 1);
    }
}

int n, m;

void aaaa() {
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j)
            if (ost[i][j])
                upd(i, j);
}

bool solve(vector<vector<int>> &arr) {
    arr1 = ost = arr;
    n = arr.size();
    m = arr[0].size();
    cnt.assign(n, *new vector<int>(m));
    U.assign(n, *new vector<int>(m, -1));
    D = U, R = U, L = U;
    for (int i = 0; i < n; ++i) {
        int last = -1;
        for (int j = 0; j < m; ++j) {
            if (arr[i][j] > 0) {
                if (last != -1) {
                    L[i][j] = j - last - 1;
                    R[i][last] = j - last - 1;
                    cnt[i][j]++;
                    cnt[i][last]++;
                }
                last = j;
            }
        }
    }
    for (int i = 0; i < m; ++i) {
        int last = -1;
        for (int j = 0; j < n; ++j) {
            if (arr[j][i] > 0) {
                if (last != -1) {
                    U[j][i] = j - last - 1;
                    D[last][i] = j - last - 1;
                    cnt[j][i]++;
                    cnt[last][i]++;
                }
                last = j;
            }
        }
    }

    auto h1 = ost;
    do {
        h1 = ost;
        aaaa();
    } while (h1 != ost);


    arr = arr1;

    ll h = 0;
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j)
            h += ost[i][j];

    return !h;
}
/*
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    ll n, m, q;
    cin >> q >> q;
    while (q--) {
        cin >> n >> m;
        vector<vector<int>> arr(n, *new vector<int>(m));
        for (auto &i: arr)
            for (auto &j: i)
                cin >> j;
        solve(arr);
        for (auto &i: arr) {
            for (int j: i)
                cout << (j == -1 ? "-" : j == -2 ? "=" : j == -3 ? "|" : j == -4 ? "#" : to_string(j)) << ' ';
            cout << '\n';
        }
        cout << '\n';
    }
}*/
/*
1 1
7 7
2 0 0 0 5 0 3
0 0 2 0 0 0 0
0 0 0 0 0 0 2
0 0 0 0 0 0 0
4 0 5 0 0 0 2
0 0 0 0 2 0 0
1 0 1 0 0 0 1

*/
/*

*/
/*

*/
/*

*/
