#include "ones.h"

using namespace std;

vector<int> guessOnes(int n, int k) {
    vector<int> ans;
    int stl = 0;
    if (k * log2(n) >= n) {
        for(int i = 0; i < n; ++i) {
            if (hasOnes(i + 1, i + 1)) {
                ans.push_back(i + 1);
            }
        }
        return ans;
    }
    for(int i = 0; i < k; ++i) {
        int l = stl - 1, r = n;
        while(r - l > 1) {
            int m = (l + r) / 2;
            if (hasOnes(stl + 1, m + 1)) {
                r = m;
            } else {
                l = m;
            }
        }
        ans.push_back(r + 1);
        stl = r + 1;
    }
    return ans;
}
