#include "ones.h"
using namespace std;

vector<int> guessOnes(int n, int k) {
    vector<int> ans;
    int stl = 0;

    while(stl < n && (int)ans.size() < k) {
        if (hasOnes(stl + 1, min(n, stl + 255))) {
            int l = stl - 1, r = min(n, stl + 255);
            while(r - l > 1) {
                int m = (l + r) / 2;
                if (hasOnes(stl + 1, m + 1)) {
                    r = m;
                } else {
                    l = m;
                }
            }
            ans.push_back(r + 1);
            stl = r + 1;
        } else {
            stl += 255;
        }

    }
    return ans;
}
