
#include "park.h"
#include <map>
using namespace std;

vector<vector<int>> ghor, gver;

void init(int numSubtests, double timeLimit) {

}

bool solve(std::vector<std::vector<int>>& puzzle) {
    int n = (int)puzzle.size(), m = (int)puzzle[0].size();
    ghor.resize(n * m);
    gver.resize(n * m);
    vector<pair<int, int>> phor, pver;
    map<pair<int, int>, int> mphor, mpver;
    for(int i = 0; i < n; ++i) {
        int lst = -1;
        for(int j = 0; j < m; ++j) {
            if (puzzle[i][j] != 0 && lst != -1) {
                ghor[i * m + lst].push_back(i * m + j);
                mphor[{i * m + lst, i * m + j}] = (int)phor.size();
                phor.push_back({i * m + lst, i * m + j});

                lst = j;
            }
            if (puzzle[i][j] != 0 && lst == -1) {
                lst = j;
            }
        }
    }
    for(int i = 0; i < m; ++i) {
        int lst = -1;
        for(int j = 0; j < n; ++j) {
            if (puzzle[j][i] != 0 && lst != -1) {
                gver[j * m + lst].push_back(j * m + i);
                mpver[{j * m + lst, j * m + i}] = (int)pver.size();
                pver.push_back({j * m + lst, j * m + i});
                lst = i;
            }
            if (puzzle[j][i] != 0 && lst == -1) {
                lst = i;
            }
        }
    }
    if ((int)phor.size() <= (int)pver.size()) {

        for(int k = 0; k < (1 << (int)phor.size()); ++k) {
            for(int l = 0; l < (1 << (int)phor.size()); ++l) {
                vector<vector<int>> gg = puzzle;
                int ch = 0, ok = 1;
                for(int i = 0; i < (int)phor.size(); ++i) {
                    if (k == 1 && l == 0) {
                        int xi = phor[i].first / m, yi = phor[i].first % m;
                        int xi1 = phor[i].second / m, yi1 = phor[i].second % m;
                        gg[xi][yi]--;
                        gg[xi1][yi1]--;
                    } else if (k == 1 && l == 1) {
                        int xi = phor[i].first / m, yi = phor[i].first % m;
                        int xi1 = phor[i].second / m, yi1 = phor[i].second % m;
                        gg[xi][yi] -= 2;
                        gg[xi1][yi1] -= 2;
                    }
                }
                for(int i = 0; i < (int)pver.size(); ++i) {
                    int xi = pver[i].first / m, yi = pver[i].first % m;
                    int xi1 = pver[i].second / m, yi1 = pver[i].second % m;
                    if (gg[xi][yi] > 2 || gg[xi][yi] < 0) {
                        ok = 0;
                        break;
                    }
                    gg[xi1][yi1] -= gg[xi][yi];
                    gg[xi][yi] = 0;
                }
                for(int i = 0; i < n; ++i) {
                    for(int j = 0; j < m; ++j) {
                        if (gg[i][j] != 0) {
                            ok = 0;
                            break;
                        }
                    }
                    if (!ok) {
                        break;
                    }
                }
                if (ok) {
                    gg = puzzle;
                    for(int i = 0; i < (int)phor.size(); ++i) {
                        if (k == 1 && l == 0) {
                            for(int j = phor[i].first + 1; j < phor[i].second; ++j) {
                                int xi = j / m, yi = j % m;
                                puzzle[xi][yi] = -1;
                            }
                            int xi = phor[i].first / m, yi = phor[i].first % m;
                            int xi1 = pver[i].second / m, yi1 = pver[i].second % m;
                            gg[xi][yi]--;
                            gg[xi1][yi1]--;
                        } else if (k == 1 && l == 1) {
                            for(int j = phor[i].first + 1; j < phor[i].second; ++j) {
                                int xi = j / m, yi = j % m;
                                puzzle[xi][yi] = -2;
                            }
                            int xi = phor[i].first / m, yi = phor[i].first % m;
                            int xi1 = pver[i].second / m, yi1 = pver[i].second % m;
                            gg[xi][yi] -= 2;
                            gg[xi1][yi1] -= 2;
                        }
                    }
                    for(int i = 0; i < (int)pver.size(); ++i) {
                        int xi = pver[i].first / m, yi = pver[i].first % m;
                        int xi1 = pver[i].second / m, yi1 = pver[i].second % m;
                        if (gg[xi][yi] > 2 || gg[xi][yi] < 0) {
                            ok = 0;
                            break;
                        }
                        int f = gg[xi][yi];
                        if (f == 1) {
                            for(int j = pver[i].first + m; j < pver[i].second; j += m) {
                                int xi = j / m, yi = j % m;
                                puzzle[xi][yi] = -3;
                            }
                        } else {
                            for(int j = pver[i].first + m; j < pver[i].second; j += m) {
                                int xi = j / m, yi = j % m;
                                puzzle[xi][yi] = -4;
                            }
                        }
                        gg[xi1][yi1] -= gg[xi][yi];
                        gg[xi][yi] = 0;
                    }
                    return true;
                }
            }
        }

    } else {
        swap(phor, pver);
        for(int k = 0; k < (1 << (int)phor.size()); ++k) {
            for(int l = 0; l < (1 << (int)phor.size()); ++l) {
                vector<vector<int>> gg = puzzle;
                int ch = 0, ok = 1;
                for(int i = 0; i < (int)phor.size(); ++i) {
                    if (k == 1 && l == 0) {
                        int xi = phor[i].first / m, yi = phor[i].first % m;
                        int xi1 = phor[i].second / m, yi1 = phor[i].second % m;
                        gg[xi][yi]--;
                        gg[xi1][yi1]--;
                    } else if (k == 1 && l == 1) {
                        int xi = phor[i].first / m, yi = phor[i].first % m;
                        int xi1 = phor[i].second / m, yi1 = phor[i].second % m;
                        gg[xi][yi] -= 2;
                        gg[xi1][yi1] -= 2;
                    }
                }
                for(int i = 0; i < (int)pver.size(); ++i) {
                    int xi = pver[i].first / m, yi = pver[i].first % m;
                    int xi1 = pver[i].second / m, yi1 = pver[i].second % m;
                    if (gg[xi][yi] > 2 || gg[xi][yi] < 0) {
                        ok = 0;
                        break;
                    }
                    gg[xi1][yi1] -= gg[xi][yi];
                    gg[xi][yi] = 0;
                }
                for(int i = 0; i < n; ++i) {
                    for(int j = 0; j < m; ++j) {
                        if (gg[i][j] != 0) {
                            ok = 0;
                            break;
                        }
                    }
                    if (!ok) {
                        break;
                    }
                }
                if (ok) {
                    gg = puzzle;
                    for(int i = 0; i < (int)phor.size(); ++i) {
                        if (k == 1 && l == 0) {
                            for(int j = phor[i].first + m; j < phor[i].second; j += m) {
                                int xi = j / m, yi = j % m;
                                puzzle[xi][yi] = -1;
                            }
                            int xi = phor[i].first / m, yi = phor[i].first % m;
                            int xi1 = pver[i].second / m, yi1 = pver[i].second % m;
                            gg[xi][yi]--;
                            gg[xi1][yi1]--;
                        } else if (k == 1 && l == 1) {
                            for(int j = phor[i].first + m; j < phor[i].second; j += m) {
                                int xi = j / m, yi = j % m;
                                puzzle[xi][yi] = -2;
                            }
                            int xi = phor[i].first / m, yi = phor[i].first % m;
                            int xi1 = pver[i].second / m, yi1 = pver[i].second % m;
                            gg[xi][yi] -= 2;
                            gg[xi1][yi1] -= 2;
                        }
                    }
                    for(int i = 0; i < (int)pver.size(); ++i) {
                        int xi = pver[i].first / m, yi = pver[i].first % m;
                        int xi1 = pver[i].second / m, yi1 = pver[i].second % m;
                        if (gg[xi][yi] > 2 || gg[xi][yi] < 0) {
                            ok = 0;
                            break;
                        }
                        int f = gg[xi][yi];
                        if (f == 1) {
                            for(int j = pver[i].first + 1; j < pver[i].second; j += 1) {
                                int xi = j / m, yi = j % m;
                                puzzle[xi][yi] = -1;
                            }
                        } else {
                            for(int j = pver[i].first + 1; j < pver[i].second; j++) {
                                int xi = j / m, yi = j % m;
                                puzzle[xi][yi] = -2;
                            }
                        }
                        gg[xi1][yi1] -= gg[xi][yi];
                        gg[xi][yi] = 0;
                    }
                    return true;
                }
            }
        }
    }
    return false;
}
