#include <iostream>
#include <string>
#include <sstream>
#include <cmath>
#include <memory.h>
#include <algorithm>
#include <stack>
#include <deque>
#include <iomanip>
#include <stdio.h>
#include <queue>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <ctime>
#include <cstdlib>
#include <cassert>
#include <iterator>
#include <chrono>
#include <array>
#include <bitset>
using namespace std;

mt19937 rnd(157);

#include "ones.h"


void rec(int l, int r, vector<int>& ans, int k) {
    if (l == r) {
        ans.push_back(l);
        return;
    }
    if (ans.size() == k)
        return;
    int m = (l + r) / 2;

    int rn = rnd() % 2;
    if (rn & 1) {
        bool fl = hasOnes(l, m);
        if (fl) {
            rec(l, m, ans, k);
            if (ans.size() != k) {
                fl = hasOnes(m + 1, r);
                if (fl)
                    rec(m + 1, r, ans, k);
            }
        }
        else {
            rec(m + 1, r, ans, k);
        }
    }
    else {
        bool fl = hasOnes(m + 1, r);
        if (fl) {
            rec(m + 1, r, ans, k);
            if (ans.size() != k) {
                fl = hasOnes(l, m);
                if (fl)
                    rec(l, m, ans, k);
            }
        }
        else {
            rec(l, m, ans, k);
        }
    }
}

void rec1(int l, int r, vector<int>& ans, int k) {
    queue<pair<int, int>> q;
    q.push({ l,r });
    while (!q.empty()) {
        int l = q.front().first, r = q.front().second;
        q.pop();

        if (ans.size() == k)
            break;

        if (r - l + 1 <= k) {
            /*rec(l, r, ans, k);
            continue;*/

            for (int i = l; i <= r; i++) {
                if (hasOnes(i, i))
                    ans.push_back(i);
            }
            continue;
        }
        int id = l;
        while (true) {
            int rr = min(id + k - 1, r);
            if (hasOnes(id, rr)) {
                q.push({ id,rr });
            }
            id = rr + 1;
            if (id > r)
                break;
        }
    }
}

vector<int> guessOnes(int n, int k) {
    vector<int> ans;
    if (k > 100)
        rec1(1, n, ans, k);
    else
        rec(1, n, ans, k);
    sort(ans.begin(), ans.end());
    return ans;
}
