
#include "ones.h"

#include <bits/stdc++.h>
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <random>


using namespace std;

#define endl '\n'
//#define int long long

void solve(int l, int r, vector<int> &a) {

    if (l > r) return;

    bool f = hasOnes(l, r);
    if (f == 0) return;
    if (l == r) {
        a.push_back(l);
        return;
    }

    int m = (l + r) / 2;
    solve(l, m, a);
    solve(m + 1, r, a);
}

vector<int> guessOnes(int n, int k) {
    vector<int> ans;
    solve(1, n, ans);

    sort(ans.begin(), ans.end());

    return ans;
}

/*signed main()
{
    ios_base::sync_with_stdio();
    cin.tie(0);
    cout.tie(0);
    cout << setprecision(17);
    srand(time(0));

    //freopen("hull.in", "r", stdin);
    //freopen("hull.out", "w", stdout);

    int n, k;
    cin >> n >> k;

    vector<int> pos(k);
    for (int i = 0; i < k; i++) cin >> pos[i];

    vector<int> ans = guessOnes(n, k);

    for (auto it : ans) cout << ans << " ";

    return 0;
}
*/
