
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using vll = vector<ll>;
using vvll = vector<vll>;
ll sz = 5;
const ll MOD = 1e8 + 543;
vvll MAT = { {5,4,3,2,1},{1,0,0,0,0},{0,1,0,0,0},{0,0,1,0,0},{0,0,0,1,0} };
vvll mull(vvll a, vvll b) {
    ll x = a.size(), y = b[0].size();
    vvll c(x, vll(y));
    for (ll i = 0; i < x; i++) {
        for (ll j = 0; j < y; j++) {
            for (ll w = 0; w < x; w++) {
                c[i][j] += a[i][w] * b[w][j];
                c[i][j] %= MOD;
            }
        }
    }
    return c;
}

vvll pw(vvll x, ll y) {
    vvll ret(sz, vll(sz));
    for (ll i = 0; i < sz; i++) ret[i][i] = 1;

    while (y) {
        if (y % 2) {
            ret = mull(ret, x);
        }
        x = mull(x, x);
        y /= 2;
    }
    return ret;
}

ll len = MOD+1;
int main()
{
    ios_base::sync_with_stdio(false); cin.tie(0);
    ll n, q; cin >> n >> q;
    vector<ll> a(n);
    for (ll i = 0; i < n; i++) cin >> a[i];
    vll u(len);
    for (ll i = 0; i < 5; i++) {
        u[i] = i;
    }
    for (ll i = 5; i < len; i++) {
        u[i] = u[i - 1] * 5 + u[i - 2] * 4 + u[i - 3] * 3 + u[i - 4] * 2 + u[i - 5];
        u[i] %= MOD;
    }
    while (q--) {
        ll k1; cin >> k1;
        if (k1 == 1) {
            ll k2, k3; cin >> k2 >> k3;
            k2--, k3--;
            ll ans = 0;
            for (ll i = k2; i <= k3; i++) {
                if (a[i] < len) {
                    ans += u[a[i]];
                }
                else {
                    vll temp = pw(MAT, a[i] - 4)[0];
                    ll plus = 0;
                    plus += temp[0] * 4 + temp[1] * 3 + temp[2] * 2 + temp[3] * 1;
                    ans += plus;
                }
            }
            cout << ans << '\n';
        }
        else {
            ll k2, k3, k4; cin >> k2 >> k3 >> k4;
            k2--, k3--;
            for (ll i = k2; i <= k3; i++) {
                a[i] += k4;
            }
        }
    }
}

/*

1 5
1
1 1 1
2 1 1 -2
1 1 1
2 1 1 8
1 1 1

*/