using namespace std;
#include <vector>
#define vi vector<int>
#include <iostream>
#define ll long long
#define vll vector<ll>
const int m = 1e8 + 543;
const int siz = 2e5 + 2;
ll a[siz];
vector<vi> pre[30];
const vector<vi> uni = { {1,0,0,0,0,},
             {0,1,0,0,0,},
             {0,0,1,0,0,},
            {0,0,0,1,0,},
            {0,0,0,0,1,}, };

ll x[] = { 0,1,2,3,4 };

void mul(vector<vi>& v1, vector<vi>& v2) {
    int ar[5][5];
    for (int i = 0; i < 5; i++)for (int j = 0; j < 5; j++) {

        ar[i][j] = v1[i][j];
        v1[i][j] = 0;
    }
    for (int j = 0; j < 5; j++) {
        for (int k = 0; k < 5; k++) {
            ll t = ar[j][k];
            for (int i = 0; i < 5; i++) {
                v1[i][k] += (t * v2[i][j]) % m;
            }
        }
    }
    for (int i = 0; i < 5; i++) {
        for (int j = 0; j < 5; j++) {
            v1[i][j] %= m;
        }
    }
}
vi get(vi v, vector<vi>&w) {
    vi ans(5);
    for (int i = 0; i < 5; i++) {
        for (int j = 0; j < 5; j++) {
            ll k = w[i][j];
            ans[i] += (k * v[j]) % m;
        }
    }
    for (int i = 0; i < 5; i++)ans[i] %= m;
    return ans;
}
void calc(int dis, vi& b) {
    ll nei[5]; for (int j = 0; j < 5; j++)nei[j] = 0;
    for (int k = 0; k < 30; k++) {
        if ((dis / (1 << k)) % 2) {
            for (int j = 0; j < 5; j++) {
                for (int t = 0; t < 5; t++) {
                    ll f = b[t];
                    nei[j] += (pre[k][j][t] * f) % m;
                }
            }
            for (int j = 0; j < 5; j++) {
                b[j] = (nei[j]) % m;
                nei[j] = 0;
            }
        }
    }

}
struct node {
    int l, r, mid;
    bool f;
    vi sum; vector<vi> p;
    node* sl, * sr;
    node(int li, int ri) {
        l = li, r = ri, mid = (l + r) / 2, f = 0;
        p = uni;
        if (l < r) {
            sum.resize(1);
            sl = new node(l, mid);
            sr = new node(mid + 1, r);
            for (int i = 0; i < 1; i++) {
                sum[0] = (sl->sum[0] + sr->sum[0]) % m;
            }
        }
        else {
            sum = { 0,1,2,3,4 };
            calc(a[l], sum);
        }
    }
    void push() {
        return;
        sum = get(sum, p);
        if (l < r) {
            mul(sl->p, p);
            mul(sr->p, p);
            sl->f = 1;
            sr->f = 1;
        }
        f = 0;
        p = uni;
    }
    ll query(int a, int b) {
        if (a > r || b < l)return 0;
        //push();
        if (a <= l && b >= r)return sum[0];
        return (sl->query(a, b) + sr->query(a, b)) % m;
    }
    void up(int a, int b, int val) {
        if (a > r || b < l)return;
        if (a <= l && b >= r) {
            for (int k = 0; k < 30; k++) {
                if ((val / (1 << k)) % 2) {
                    sum = get(sum, pre[k]);
                }
            }
            //push();
        }
        else {
            //push();
            sl->up(a, b, val);
            sr->up(a, b, val);
            sum[0] = sl->sum[0] + sr->sum[0];
        }
    }
};
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    pre[0] = { { 0,1,0,0,0, },
    { 0,0,1,0,0, },
    { 0,0,0,1,0, },
    { 0,0,0,0,1,},
    {1,2,3,4,5 } };
    for (int k = 1; k < 30; k++) {
        vector<vi> vec1 = pre[k - 1], vec2 = pre[k - 1];
        mul(vec1, vec2);
        pre[k] = vec1;
    }

    int n, q;
    cin >> n >> q;
    for (int i = 0; i < n; i++)cin >> a[i];
    for (int i = 0; i < n; i++) {
        a[i] = (a[i] + m - 1) % (m - 1);
    }
    node* seg = new node(0, n - 1);

    for (int i = 0; i < q; i++) {
        int t; cin >> t;
        int l, r; cin >> l >> r;
        l--, r--;
        if (t == 1) {
            cout << seg->query(l, r);
            if (i != q - 1)cout << "\n";
        }
        else {
            int val;
            cin >> val;
            val = (val + m - 1) % (m - 1);
            //vector<vi> mat = uni;
            /*for (int k = 0; k < 30; k++) {
                if ((val / (1 << k)) % 2) {
                    mul(mat, pre[k]);
                }
            }*/
            seg->up(l, r, val);
        }
    }
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
