#include<iostream>
#include<vector>
#include<queue>
#include<algorithm>
#include "ones.h"
using namespace std;
typedef int ll;
typedef pair<ll, ll> pll;

/*void check(ll l, ll r, vector<ll>& v, ll k) {
	if (v.size() == k) return;
	if (l > r) return;
	if (hasOnes(l, r)) {
		if (l == r) v.push_back(l);
		else {
			ll mid = (l + r) / 2;
			check(l, mid, v, k);
			check(mid+1, r, v, k);
		}
	}
}*/

vector<int> guessOnes(int n, int k) {
	vector<int> v;
	queue<pll> q; q.push({ 1, n });
	while (q.size() && v.size() < k) {
		ll a = q.front().first, b = q.front().second; q.pop();
		if (hasOnes(a, b)) {
			if (a == b) v.push_back(a);
			for (ll i = a; i <= b; i += max((b - a + 1) / 5, 1)) q.push({ i, i + max((b - a + 1) / 5, 1) - 1 });
		}
	}
	sort(v.begin(), v.end());
	return v;
}