#include <bits/stdc++.h>
#include <array>
using namespace std;
typedef long long ll;
#define rep(i,s,e) for(ll i=s;i<e;i++)
#define all(a) a.begin(),a.end()
const ll mod = 1e8 + 543;
/*
vector<vector<ll>>ip5(5, vector<ll>(5));
vector<vector<ll>>in5(5, vector<ll>(5));
vector<vector<ll>>i5(5, vector<ll>(5));

vector<ll>mvec(vector<vector<ll>> mat, vector<ll> vec) {
    vector<ll>ans(5, 0);
    rep(i, 0, 5) {
        rep(j, 0, 5) {
            ans[i] += ((mat[i][j] * vec[j]) % mod + mod) % mod;
            ans[i] %= mod;
        }
    }
    return ans;
}

vector<vector<ll>>mmat(vector<vector<ll>>& mat1, vector<vector<ll>>& mat2) {
    vector<vector<ll>>ans(5, vector<ll>(5, 0));
    rep(i, 0, 5) {
        rep(j, 0, 5) {
            rep(k, 0, 5) {
                ans[i][j] += ((mat1[i][k] * mat2[k][j]) % mod + mod % mod);
                ans[i][j] %= mod;
            }
        }
    }
    return ans;
}

vector<vector<ll>>binpow(vector<vector<ll>>&mat, ll hez) {
    if (hez == 0) return i5;
    if (hez == 1) return mat;
    vector<vector<ll>>ans = binpow(mat, hez / 2);
    ans = mmat(ans, ans);
    if (hez % 2) ans = mmat(mat, ans);
    return ans;
}


struct Seg {
    ll l, r, mid, add = 0;
    vector<ll>val = { 0,0,0,0,0 };
    Seg* lp = NULL, * rp = NULL;
    Seg(ll l, ll r) :l(l), r(r), mid((l + r) / 2) {
        if (l != r) {
            lp = new Seg(l, mid);
            rp = new Seg(mid + 1, r);
        }
    }
    //אולי פה לא טוב
    void pull() {
        rep(i, 0, 5) val[i] = (lp->val[i] + rp->val[i]) % mod;
    }
    void push() {
        vector<vector<ll>>mat;
        if (add > 0)
            mat = binpow(ip5, add);
        if (add < 0)
            mat = binpow(in5, -add);
        if (add != 0) {
            lp->val = mvec(mat, lp->val);
            rp->val = mvec(mat, rp->val);
            lp->add += add;
            rp->add += add;
            add = 0;
        }
    }
    void upd(ll a, ll b, ll v) {
        if (a <= l and r <= b) {
            vector<vector<ll>>mat;
            if (v > 0)
                mat = binpow(ip5, v);
            if (v < 0)
                mat = binpow(in5, -v);
            val = mvec(mat, val);
            add += v;
            return;
        }
        if (a > r or b < l) return;
        lp->upd(a, b, v);
        rp->upd(a, b, v);
        pull();
    }
    void set(ll a, vector<ll>v) {
        if (l == r and r == a) {
            val = v;
            return;
        }
        if (a <= mid) lp->set(a, v);
        else rp->set(a, v);
        pull();
    }
    ll query(ll a, ll b) {
        if (a <= l and r <= b)
            return val[4];
        if (a > r or b < l)
            return 0;
        push();
        return (lp->query(a, b) + rp->query(a, b)) % mod;
    }
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    ll n, q;
    cin >> n >> q;
    vector<pair<ll,int>>a(n);
    rep(i, 0, n) {
        cin >> a[i].first;
        a[i].second = i;
    }
    sort(all(a));
    
    vector<ll>base = { -4,-3,33,-22,0 };

    rep(i, 0, 4) ip5[i][i + 1] = 1;
    rep(i, 0, 5) ip5[4][i] = i + 1;

    rep(i, 1, 5) in5[i][i - 1] = 1;
    in5[0] = { -2,-3,-4,-5,1 };

    rep(i, 0, 5) i5[i][i] = 1;

    Seg seg(0, n - 1);
    
    vector<ll>cur = base;
    if (a[0].first < 0)
        cur = mvec(binpow(in5, -a[0].first),cur);
    if (a[0].first > 0)
        cur = mvec(binpow(ip5, a[0].first), cur);
    seg.set(a[0].second, cur);
    rep(i, 1, n) {
        int hez = a[i].first - a[i - 1].first;
        vector<vector<ll>>mat = binpow(ip5, hez);
        cur = mvec(mat, cur);
        seg.set(a[i].second, cur);
    }
    
    while (q--) {
        ll t;
        cin >> t;
        if (t == 1) {
            ll l, r;
            cin >> l >> r;
            l--, r--;
            cout << (seg.query(l, r)) << "\n";
        }
        else {
            ll l, r, v;
            cin >> l >> r >> v;
            l--, r--;
            seg.upd(l, r, v);
        }
    }
    return 0;
}*/

#include "ones.h"
vector<int>ans;
int le = 0;
void dp(int l, int r) {
    if (le == 0) return;
    if (l == r) {
        ans.push_back(l);
        le--;
        return;
    }
    int mid = (l + r) / 2;
    srand(time(nullptr));
    int ran = rand() % 2;
    if (ran == 0) {
        if (hasOnes(l, mid)) {
            dp(l, mid);
            if (le != 0 and hasOnes(mid + 1, r))
                dp(mid + 1, r);
        }
        else
            dp(mid + 1, r);
    }
    else {
        if (hasOnes(mid+1,r)) {
            dp(mid+1, r);
            if (le != 0 and hasOnes(l, mid))
                dp(l, mid);
        }
        else
            dp(l, mid);
    }
}

vector<int> guessOnes(int n, int k) {
    /*
    vector<int>vec(n);
    rep(i, 0, n) vec[i] = i + 1;
    srand(time(nullptr));
    random_shuffle(all(vec));
    */
    ans.clear();
    le = k;
    dp(1, n);
    sort(all(ans));
    return ans;
}

/*

static const int N = 1e5 + 3;

static int n, k, n_tests;
static int input[N];

static long long number_of_queries;

static std::vector<int> readOnes()
{
    for (int i = 1; i <= n; i++)
        input[i] = 0;

    std::vector<int> _ones(k, 0);

    for (int i = 0; i < k; i++)
    {
        std::cin >> _ones[i];
        input[_ones[i]] = 1;
    }

    for (int i = 1; i <= n; i++)input[i] += input[i - 1];

    sort(_ones.begin(), _ones.end());

    return _ones;
}

bool hasOnes(int l, int r)
{
    number_of_queries++;

    if (1 > l || l > n || 1 > r || r > n || l > r)
    {
        std::cout << "Your program made an invalid query." << std::endl;
        exit(0);
    }

    return input[r] != input[l - 1];
}

static long long runOneTest() {
    number_of_queries = 0;

    std::vector<int> _ones = readOnes();

    std::vector<int> guess = guessOnes(n, k);

    if (_ones != guess)
    {
        std::cout << "Your program returned an incorrect answer." << std::endl;
        exit(0);
    }

    std::cout << "Your program successfully returned the correct positions and used " << number_of_queries << " queries." << std::endl;

    return number_of_queries;
}

int main() {
    std::cin >> n >> k >> n_tests;

    long long sum_queries = 0;
    for (int i = 0; i < n_tests; ++i)
        sum_queries = sum_queries + runOneTest();

    std::cout << "Your program successfully returned the correct positions and used " << sum_queries << " queries in total." << std::endl;
}*/