#include <cmath>
#include <vector>
#include "ones.h"
using namespace std;
//half
int N;
bool hasOne(int a,int b) {
    if(b>N) b=N;
    return hasOnes(a,b);
}
void binary(int a,int b,vector<int> &res) {
    if(a+1==b) {
        res.push_back(a);
        return;
    }
    int mid = (a+b)/2;
    if(hasOne(a,mid-1)) {
        binary(a,mid,res);
    }
    if(hasOne(mid,b-1)) {
        binary(mid,b,res);
    }
}
vector<int> guessOnes(int n, int k) {
    vector<int> res;
    N=n;
    int i =1;
    while(i<n&&res.size()!=k){
        int l = k-res.size();
        double d = (n-l)/((double)l);
        int u = min((int)(floor(log2(d))+1),n-i);
        if(hasOne(i,i+u-1)) binary(i,i+u,res);
        i+=u;
    }
    return res;
}