#include <bits/stdc++.h>
#include "ones.h"
using namespace std;


vector<int> naive(int s, int e, int n, int k) {
    int count = 0, cur = s;
    vector<int> ans(k);
    while (count < k) {
        int lo = cur, hi = e;
        while (lo < hi) {
          int mid = (lo+hi)/2;
          if (hasOnes(cur, mid)) hi = mid;
          else lo = mid+1;
        }
        ans[count++] = lo;
        cur = lo+1;
    }
    return ans;
}
vector<int> guess(int start, int end, int sz, int k) {
    if (start == end) return {start};
    bool right = hasOnes(start, start + sz / 2 -1);
    vector<int> ans;
    if (right) {
        vector<int> temp = guess(start, start + sz / 2-1, sz / 2, k);
        for (int i : temp) ans.push_back(i);
    }
    if (ans.size() < k && hasOnes(start+sz/2, end)) {
        vector<int> temp = guess(start+sz/2, end, sz-sz/2, k);
        for (int i : temp) ans.push_back(i);
    }

    return ans;
}
vector<int> iter(int start, int end, int sz, int k) {
    queue<pair<int,int>> q;
    q.push({start, end});
    while (q.size() < k) {
        auto [s, e] = q.front();
        q.pop();
        if (s == e) {
            q.push({s,e});
            q.pop();
            continue;
        }
        int sz = e-s+1;
        if (hasOnes(s, s + sz/2)) q.push({s,s+sz/2});
        if (hasOnes(s+sz/2+1, e)) q.push({s+sz/2+1, e});
    }
    vector<pair<int,int>> ranges;
    while (!q.empty()) {
        ranges.push_back(q.front()); q.pop();
    }
    vector<int> ans;
    for (pair<int,int> p : ranges) {
        ans.push_back(naive(p.first, p.second, sz, 1)[0]);
    }
    return ans;
}
vector<int> guessOnes(int n, int k) {
    return iter(1, n, n, k);
}