#include <bits/stdc++.h>

using namespace std;

typedef int ll;
typedef vector<ll> v;
typedef vector<v> vv;
typedef vector<vv> vvv;
typedef pair<ll,ll> p;
typedef vector<p> vp;
typedef vector<vp> vvp;
typedef vector<vvp> vvvp;
typedef pair<ll, p> tri;
typedef vector<tri> vtri;
typedef vector<vtri> vvtri;
typedef vector<vvtri> vvvtri;

#define f first
#define s second
#define pb push_back
#define eb emplace_back
#define all(v) (v).begin(),(v).end()

const ll INF = 1e18;
const ll mod = 1e8 + 543;

#include "ones.h"

void solve(vector<int> &res, ll min, ll max, ll k)
{
    if (min == max)
    {
        res.pb(min);
        return;
    }
    ll mid = (min + max) / 2;
    if (hasOnes(min, mid))
    {
        solve(res, min, mid, k);
        if (res.size() < k && hasOnes(mid + 1, max)) solve(res, mid + 1, max, k);
    }
    else solve(res, mid + 1, max, k);
}

vector<int> guessOnes(int n, int k)
{
    ll size = n / k / 4;
    v positions;
    for (ll i = 1; i <= n; i += size)
    {
        if (hasOnes(i, i + size - 1)) positions.pb(i);
    }
    vector<int> res;
    ll bonus = 0;
    for (ll x : positions)
    {
        vector<int> cur;
        solve(cur, x, x + size - 1, k - bonus - positions.size() + 1);
        bonus += cur.size() - 1;
        for (auto x : cur) res.pb(x);
    }
    return res;
}
/*
static const int N = 1e5 + 3;

static int n, k, n_tests;
static int input[N];

static long long number_of_queries;

static std::vector<int> readOnes()
{
    for(int i=1;i<=n;i++)
        input[i]=0;

    std::vector<int> _ones(k,0);

    for(int i=0;i<k;i++)
    {
        std::cin>>_ones[i];
        input[_ones[i]]=1;
    }

    for(int i=1;i<=n;i++)input[i]+=input[i-1];

    sort(_ones.begin(),_ones.end());

    return _ones;
}

bool hasOnes(int l,int r)
{
    number_of_queries++;

    if(1>l || l>n || 1>r || r>n || l>r)
    {
        std::cout << "Your program made an invalid query." << std::endl;
        exit(0);
    }

    return input[r] != input[l-1];
}

static long long runOneTest(){
    number_of_queries = 0;

    std::vector<int> _ones = readOnes();

    std::vector<int> guess = guessOnes(n,k);

    if(_ones != guess)
    {
        std::cout << "Your program returned an incorrect answer." << std::endl;
        exit(0);
    }

    std::cout << "Your program successfully returned the correct positions and used " << number_of_queries << " queries." << std::endl;

    return number_of_queries;
}

int main(){
    std::cin >> n >> k >> n_tests;

    long long sum_queries = 0;
    for(int i = 0; i < n_tests; ++i)
        sum_queries = sum_queries + runOneTest();

    std::cout << "Your program successfully returned the correct positions and used " << sum_queries << " queries in total." << std::endl;
}
/**/