#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

const ll md = 1e8 + 543;

vector<ll> x;
vector<ll> a;



struct seg
{
    ll v, l, r, m;
    //ll lazy;
    seg *ls, *rs;

    seg(ll lp, ll rp)
    {
        l = lp;
        r = rp;
        m = (l + r) >> 1;
        
        if (l == r)
        {
            v = x[a[l-1]];
            ls = nullptr;
            rs = nullptr;

            return ;
        }

        ls = new seg(l, m);
        rs = new seg(m + 1, r);

        v = (ls->v + rs->v) % md;
    }


    // void push()
    // {
    //     if (l == r)
    //     {
    //         a[l] += lazy;
    //         v = x[a[l]];

    //         return ;
    //     }

    //     ls->lazy += lazy;
    //     rs->lazy += lazy;

    //     lazy = 0;
    // }


    // void update(ll lp, ll rp, ll value)
    // {
    //     if (lp > r || rp < l) return ;
    //     if (lp <= l && r <= rp) lazy += value;

    //     ls->update(lp, rp, value);
    //     rs->update(lp, rp, value);
    // }


    ll query(ll lp, ll rp)
    {
        if (lp > r || rp < l) return 0;
        if (lp <= l && r <= rp) return v;

        return (ls->query(lp, rp) + rs->query(lp, rp)) % md;
    }
};



void setup()
{
    x.resize(1e6 + 10);
    for (ll i = 0; i < 5; i++) x[i] = i;

    for (ll i = 5; i < 1e6 + 5; i++) 
    {
        ll t = (5 * x[i - 1]) % md;
        t += (4 * x[i - 2]) % md;
        t %= md;
        t += (3 * x[i - 3]) % md;
        t %= md;
        t += (2 * x[i - 4]) % md;
        t %= md;
        t += x[i - 5];
        t %= md;

        x[i] = t;
    }
}



int main()
{
    ll n, q, l, r;

    cin >> n >> q;

    setup();
    a.resize(n);

    for (ll i = 0; i < n; i++) cin >> a[i];

    seg tr(1, n);

    while (q--)
    {
        cin >> l;
        cin >> l >> r;

        cout << tr.query(l, r) << '\n';
    }


    return 0;
}