#include <iostream>
#include <vector>
#include <cmath>
#include "ones.h"
using namespace std;

std::vector<int> guessOnes(int n, int k) {
    vector<int> res(k);


    int idx = 0, i = 1;
    int d = (n - k) / k;

    for (; i <= n - d && idx < k; i += d + 1) {
        if (hasOnes(i, i + d))
            for (int j = i; j <= i + d; ++j)
                if (hasOnes(j,j))
                    res[idx++] = j;
    }


    return res;
}
