#include <bits/stdc++.h>

#include "ones.h"

using namespace std;

#define all(x) x.begin(), x.end()
#define ar array
#define pb push_back
#define ln '\n'
//#define int long long

using i64 = long long;

template <class F, class _S>
bool chmin(F &u, const _S &v){
    bool flag = false;
    if ( u > v ){
        u = v; flag |= true;
    }
    return flag;
}

template <class F, class _S>
bool chmax(F &u, const _S &v){
    bool flag = false;
    if ( u < v ){
        u = v; flag |= true;
    }
    return flag;
}

vector <int> guessOnes(int n, int k){
    vector <int> ret;
    if ( k >= 1000 ){
        auto dfs = [&](auto dfs, int l, int r) -> void{
            if ( l == r ){
                ret.pb(l);
                return;
            }
            int md = (l + r) >> 1;
            if ( hasOnes(l, md) ){
                dfs(dfs, l, md);
            }
            if ( hasOnes(md + 1, r) ){
                dfs(dfs, md + 1, r);
            }
        };
        dfs(dfs, 1, n);
    } else{
        int lst = 1;
        for ( int i = 1; i <= k; i++ ){
            int l = lst, r = n;
            while ( l < r ){
                int md = (l + r) >> 1;
                if ( hasOnes(lst, md) ){
                    r = md;
                } else l = md + 1;
            }
            ret.pb(l);
            lst = l + 1;
        }
    }
    return ret;
}


