#include <bits/stdc++.h>

#include "ones.h"

using namespace std;

#define all(x) x.begin(), x.end()
#define ar array
#define pb push_back
#define ln '\n'
//#define int long long

using i64 = long long;

template <class F, class _S>
bool chmin(F &u, const _S &v){
    bool flag = false;
    if ( u > v ){
        u = v; flag |= true;
    }
    return flag;
}

template <class F, class _S>
bool chmax(F &u, const _S &v){
    bool flag = false;
    if ( u < v ){
        u = v; flag |= true;
    }
    return flag;
}

vector <int> guessOnes(int n, int k){
    vector <int> ret;
    auto dfs = [&](auto dfs, int l, int r) -> void{
        if ( r - l + 1 <= 500 ){
            int lst = l;
            while ( true ){
                if ( !hasOnes(lst, r) ) break;
                int L = lst, R = r;
                while ( L < R ){
                    int md = (L + R) >> 1;
                    if ( hasOnes(lst, md) ){
                        R = md;
                    } else L = md + 1;
                }
                ret.pb(L);
                lst = L + 1;
            } return;
        }
        if ( l == r ){
            ret.pb(l);
            return;
        }
        int md = (l + r) >> 1;
        if ( hasOnes(l, md) ){
            dfs(dfs, l, md);
        }
        if ( hasOnes(md + 1, r) ){
            dfs(dfs, md + 1, r);
        }
    };
    dfs(dfs, 1, n);
    return ret;
}


