#include <bits/stdc++.h>

#include "ones.h"

using namespace std;

#define all(x) x.begin(), x.end()
#define ar array
#define pb push_back
#define ln '\n'
//#define int long long

using i64 = long long;

template <class F, class _S>
bool chmin(F &u, const _S &v){
    bool flag = false;
    if ( u > v ){
        u = v; flag |= true;
    }
    return flag;
}

template <class F, class _S>
bool chmax(F &u, const _S &v){
    bool flag = false;
    if ( u < v ){
        u = v; flag |= true;
    }
    return flag;
}

vector <int> guessOnes(int n, int k){
    vector <int> ret;
    auto solve = [&](int L, int R){
        int lst = L;
        while ( k > 0 && lst <= R && hasOnes(lst, R) ){
            int l = lst, r = R;
            while ( l < r ){
                int md = (l + r) >> 1;
                if ( hasOnes(lst, md) ){
                    r = md;
                } else l = md + 1;
            } k--;
            ret.pb(l);
            lst = l + 1;
        }
    };
    auto f = [&](int n){
        int l = 1, r = n, cnt = 0;
        while ( l < r ){
            int md = (l + r) >> 1;
            cnt++;
            if ( md - l + 1 >= r - md ){
                r = md;
            } else l = md + 1;
        }
        return cnt;
    };
    int opt = 1e9, ans = -1;
    for ( int i = 1; i <= n; i++ ){
        if ( n % i ) continue;
        int x = n / i, j = f(x);
        if ( chmin(opt, j * k) ){
            ans = i;
        }
    }
    int lst = 1, b = n / ans;
    while ( lst <= n ){
        solve(lst, min(lst + b - 1, n));
        lst += b;
    }
    return ret;
}


