#include <bits/stdc++.h>

typedef long long ll;

int n;
const int M = 1e+8 + 543;

std::vector < std::vector < std::vector < int > > > power(50, { { 1, 0, 0, 0, 0 },
                                                                { 0, 1, 0, 0, 0 },
                                                                { 0, 0, 1, 0, 0 },
                                                                { 0, 0, 0, 1, 0 },
                                                                { 0, 0, 0, 0, 1 } });

inline int add(int a, int b) {
    return a + b >= M ? a + b - M : a + b;
}

int t[100001];

inline int getPref(int id) {
    int sum = 0;

    for (; id > 0; id -= id & -id)
        sum = add(sum, t[id]);

    return sum;
}

inline void update(int id, int val) {
    for (; id <= n; id += id & -id)
        t[id] = add(t[id], val);
}

inline int getX(ll id) {
    if (id < 0)
        return M - 22;

    if (id < 5)
        return id;

    int ans[5], res[5];

    for (int i = 0; i < 5; i++)
        ans[i] = 4 - i;

    memset(res, 0, sizeof(res));

    id -= 4;

    for (int p = 49; p >= 0; p--)
        if (id >> p & 1) {
            memset(res, 0, sizeof(res));

            for (int j = 0; j < 5; j++)
                for (int k = 0; k < 5; k++)
                    res[j] = add(res[j], (ll)ans[k] * power[p][k][j] % M);

            for (int j = 0; j < 5; j++)
                ans[j] = res[j];
        }

    return ans[0];
}

int main() {
    std::ios::sync_with_stdio(0); std::cin.tie(0);

    power[0] = { { 5, 1, 0, 0, 0 },
                 { 4, 0, 1, 0, 0 },
                 { 3, 0, 0, 1, 0 },
                 { 2, 0, 0, 0, 1 },
                 { 1, 0, 0, 0, 0 } };

    std::vector < std::vector < int > > res(5, std::vector < int >(5));

    for (int p = 1; p < 50; p++) {
        for (int i = 0; i < 5; i++)
            for (int j = 0; j < 5; j++)
                res[i][j] = 0;

        for (int i = 0; i < 5; i++)
            for (int j = 0; j < 5; j++)
                for (int k = 0; k < 5; k++)
                    res[i][j] = (res[i][j] + (ll)power[p - 1][i][k] * power[p - 1][k][j]) % M;

        power[p] = res;
    }

    int q; std::cin >> n >> q;

    std::vector < ll > a(n + 1);

    for (int i = 1; i <= n; i++) {
        std::cin >> a[i];

        update(i, getX(a[i]));
    }

    for (int qi = 1, type, l, r, val; qi <= q; qi++) {
        std::cin >> type;

        if (type == 1) {
            std::cin >> l >> r;

            std::cout << add(0, add(getPref(r), M - getPref(l - 1))) << "\n";
        } else {
            std::cin >> l >> r >> val;

            update(l, add(0, M - getX(a[l])));
            a[l] += val;
            update(l, getX(a[l]));
        }
    }
}
