#include "ones.h"
#include <bits/stdc++.h>
using namespace std;
const int UND = 1e9 + 7;
vector<int> idx;
bool hasOnes(int l, int r);


int f(int l, int r, int need){
    if(l > r) return 0;
    if(!need) return 0;
    
    if(need == UND && !hasOnes(l + 1, r + 1)) return 0;
    if(l == r){
        idx.push_back(l);
        return 1;
    }
    int mid = (l + r)>>1;
    int c1, c2;
    if(need == UND){
        c1 = f(l, mid, UND);
        c2 = f(mid+1, r, UND);
    }else{
       c1 = f(l, mid, UND);
       c2 = f(mid+1, r, need - c1);
    }
    return c1 + c2;
}

vector<int> guessOnes(int n, int k){
    
    idx.clear();
    vector<int> ans;
    
    if(k >= 500){
        int c = f(0, n-1, k);
        for(auto i : idx) ans.push_back(i+1);
    }else{
        int start = 1;
        while(start <= n){
            if(start == n){
                if(hasOnes(start, start)){
                    ans.push_back(start);
                }
                break;
            }
            int l = start - 1, r = n + 1;
            while(l + 1 < r){
                int mid = (l + r)>>1;
                if(hasOnes(l, mid)){
                    r = mid;
                }else l = mid;
            }
            if(r <= n){
                ans.push_back(r);
            }
            start = r + 1;
        }
    }
    
    return ans;
}

