#include <bits/stdc++.h>
//#include "Lgrader.cpp"
#include "ones.h"
using namespace std;
#define all(x) x.begin(), x.end()
#define size(x) (int)x.size()

template<class S, class T>
bool chmin(S &a, const T &b) {
  return a > b ? (a = b) == b : false;
}
template<class S, class T>
bool chmax(S &a, const T &b) {
  return a < b ? (a = b) == b : false;
}

vector<int> guessOnes(int n, int k) {
  vector<int> res;
  if (k >= 5000) {
    int b = sqrt(n);
    function<void(int, int)> search = [&](int l, int r) {
      if (size(res) == k)
        return;
      if (l == r) {
        res.push_back(r);
        return;
      }
      int dir = abs(rand()) % 2;
      int mid = (l + r) / 2;
      if (dir) {
        if (hasOnes(mid + 1, r)) {
          search(mid + 1, r);
          if (size(res) == k)
            return;
          if (hasOnes(l, mid))
            search(l, mid);
        } else search(l, mid);
      } else {
        if (hasOnes(l, mid)) {
          search(l, mid);
          if (size(res) == k)
            return;
          if (hasOnes(mid + 1, r))
            search(mid + 1, r);
        } else search(mid + 1, r);
      }
    };
    for (int i = 1; i <= n; i += b) {
      if (size(res) == k) break;
      if (hasOnes(i, min(i + b - 1, n)))
        search(i, min(i + b - 1, n));
    }
    sort(all(res));
  } else if (k >= 100) {
    auto search = [&](int i, int r) {
      int lo = i - 1, hi = r;
      while (lo + 1 < hi) {
        int mid = (lo + hi) / 2;
        if (hasOnes(i, mid)) hi = mid;
        else lo = mid;
      }
      return hi;
    };
    int b = sqrt(n);
    for (int i = 1; i <= n; i += b) {
      if (size(res) == k) break;
      int j = i;
      while (j <= min(i + b - 1, n) && hasOnes(j, min(i + b - 1, n))) {
        int next = search(j, min(i + b - 1, n));
        res.push_back(next);
        j = next + 1;
      }
    }
  } else {
    auto search = [&](int i, int r) {
      int lo = i - 1, hi = r;
      while (lo + 1 < hi) {
        int mid = (lo + hi) / 2;
        if (hasOnes(i, mid)) hi = mid;
        else lo = mid;
      }
      return hi;
    };
    int i = 1;
    while (size(res) < k) {
      int next = search(i, n - k + size(res) + 1);
      res.push_back(next);
      i = next + 1;
    }
  }
  return res;
}
