#include <iostream>
#include <algorithm>
#include <vector>
#include <array>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <list>
#include <chrono>
#include <random>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <iomanip>
#include <bitset>
#include <cassert>
#include "ones.h"

using namespace std;

std::vector<int> guessOnes(int n, int k)
{
    int last = 1;
    vector<int> ans;
    while(ans.size() < k)
    {
        int l = last, r = min(n, last+64767);
        while(l <= r)
        {
            int mid = l+r>>1;
            bool got = hasOnes(last, mid);
            if(got)
            {
                r = mid-1;
            }
            else
            {
                l = mid+1;
            }
        }
        ans.push_back(l);
        last = l+1;
    }
    return ans;
}
