#include <iostream>
#include <algorithm>
#include <vector>
#include <array>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <list>
#include <chrono>
#include <random>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <iomanip>
#include <bitset>
#include <cassert>

#define MOD 100000543
#define int long long

using namespace std;

array<int, 25> M = {0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 1, 2, 3, 4, 5};

vector<array<int, 25>> p;

array<int, 25> mult(array<int, 25> A, array<int, 25> B)
{
    array<int, 25> C = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
    for(int i = 0; i < 5; i++)
    {
        for(int j = 0; j < 5; j++)
        {
            for(int k = 0; k < 5; k++)
            {
                C[i*5+k]+=(A[i*5+j]*B[j*5+k])%MOD;
            }
        }
    }
    for(int i = 0; i < 5; i++)
    {
        for(int j = 0; j < 5; j++)
        {
            C[i*5+j]%=MOD;
        }
    }
    return C;
}



int32_t main()
{
    p.push_back(M);
    while(p.size() < 30)
    {
        p.push_back(mult(p.back(), p.back()));
    }
    int n, q;
    cin >> n >> q;
    vector<array<int, 25>> a(n+1);
    for(int i = 1; i <= n; i++)
    {
        int ai;
        cin >> ai;
        array<int, 25> res = {1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1};
        int power = 0;
        while(ai > 0)
        {
            if(ai%2 == 1)
            {
                res = mult(res, p[power]);
            }
            power++;
            ai/=2;
        }
        a[i] = res;
    }
    for(int i = 0; i < q; i++)
    {
        int type, l, r;
        cin >> type >> l >> r;
        if(type == 1)
        {
            cout << (a[l][1]+2*a[l][2]+3*a[l][3]+4*a[l][4])%MOD << endl;
        }
        else
        {
            int value;
            cin >> value;
            array<int, 25> res = {1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1};
            int power = 0;
            while(value > 0)
            {
                if(value%2 == 1)
                {
                    res = mult(res, p[power]);
                }
                power++;
                value/=2;
            }
            a[l] = mult(a[l], res);
        }
    }
    cout << endl;
}
