//             _
//   ^ ^      //
// >(O_O)<___//
//   \ __ __  \
//    \\ \\ \\\\

//#include "park.h"
#include <bits/stdc++.h>
using namespace std;

#pragma GCC optimize("O3")
#pragma GCC target("popcnt")

//#define int long long
#define forn(i,n) for(int i=0; i<n; ++i)
#define pb push_back
#define vii(a,n) vector<int>a(n);forn(i,n)cin>>a[i];
#define pi pair<int,int>
#define f first
#define s second

void init(int numSubtests, double timeLimit);

bool solve(vector<vector<int>>& puzzle) {

	int n=puzzle.size();
	auto a = puzzle;
	auto ans = a;
	queue<pi> q;

	vector<vector<int>> deg(n,vector<int>(n,0));
	auto vis = deg;

	forn(i,n) {
		forn(j,n) {
			if (!a[i][j]) continue;
			int s=0;
			for(int z=i-1; z>=0; --z) {
				if (a[z][j]) {
					s+=min(a[z][j],2); break;
				}
			}
			for(int z=i+1; z<n; ++z) {
				if (a[z][j]) {
					s+=min(a[z][j],2); break;
				}
			}
			for(int z=j-1; z>=0; --z) {
				if (a[i][z]) {
					s+=min(a[i][z],2); break;
				}
			}
			for(int z=j+1; z<n; ++z) {
				if (a[i][z]) {
					s+=min(a[i][z],2); break;
				}
			}
			deg[i][j]=s;
			if (deg[i][j]==a[i][j]) q.push({i,j});
			assert(deg[i][j] >= a[i][j]);
		}
	}

	int k=0; forn(i,n) forn(j,n) k+=!!a[i][j];

	forn(it,k) {
		pi ok = {-1,-1};
		forn(i,n) {
			forn(j,n) {
				if (!puzzle[i][j]) continue;
				if (vis[i][j]) continue;
				if (!a[i][j]) {ok={i,j}; continue;}
				int s=0;
				for(int z=i-1; z>=0; --z) {
					if (ans[z][j]<0) break;
					if (vis[z][j]) break;
					if (puzzle[z][j]) {
						s+=min(a[z][j],2); break;
					}
				}
				for(int z=i+1; z<n; ++z) {
					if (ans[z][j]<0) break;
					if (vis[z][j]) break;
					if (puzzle[z][j]) {
						s+=min(a[z][j],2); break;
					}
				}
				for(int z=j-1; z>=0; --z) {
					if (ans[i][z]<0) break;
					if (vis[i][z]) break;
					if (puzzle[i][z]) {
						s+=min(a[i][z],2); break;
					}
				}
				for(int z=j+1; z<n; ++z) {
					if (ans[i][z]<0) break;
					if (vis[i][z]) break;
					if (puzzle[i][z]) {
						s+=min(a[i][z],2); break;
					}
				}
				if (s==a[i][j]) {
					ok={i,j};
				}
			}
		}
		if (ok.f==-1) return false;
		//cout<<"??? "<<it<<": "<<ok.f<<' '<<ok.s<<'\n';
		int i=ok.f, j=ok.s;
		vis[i][j]=1;
		if (!a[i][j]) continue;
		for(int z=i-1; z>=0; --z) {
			if (ans[z][j]<0) break;
			if (vis[z][j]) break;
			if (puzzle[z][j]) {
				int t=min({a[z][j],a[i][j],2});
				for(int q=i-1; q>z; --q) ans[q][j]=-2-t;
				a[i][j]-=t;
				a[z][j]-=t;
				break;
			}
		}
		for(int z=i+1; z<n; ++z) {
			if (ans[z][j]<0) break;
			if (vis[z][j]) break;
			if (puzzle[z][j]) {
				int t=min({a[z][j],a[i][j],2});
				for(int q=i+1; q<z; ++q) ans[q][j]=-2-t;
				a[i][j]-=t;
				a[z][j]-=t;
				break;
			}
		}
		for(int z=j-1; z>=0; --z) {
			if (ans[i][z]<0) break;
			if (vis[i][z]) break;
			if (puzzle[i][z]) {
				int t=min({a[i][z],a[i][j],2});
				for(int q=j-1; q>z; --q) ans[i][q]=-t;
				a[i][j]-=t;
				a[i][z]-=t;
				break;
			}
		}
		for(int z=j+1; z<n; ++z) {
			if (ans[i][z]<0) break;
			if (vis[i][z]) break;
			if (puzzle[i][z]) {
				int t=min({a[i][z],a[i][j],2});
				for(int q=j+1; q<z; ++q) ans[i][q]=-t;
				a[i][j]-=t;
				a[i][z]-=t;
				break;
			}
		}
	}
	forn(i,n) forn(j,n) puzzle[i][j]=ans[i][j];

	return true;
}