//             _
//   ^ ^      //
// >(O_O)<___//
//   \ __ __  \
//    \\ \\ \\\\

#include "puzzle.h"
#include <bits/stdc++.h>
using namespace std;

#pragma GCC optimize("O3")
#pragma GCC target("popcnt")

//#define int long long
#define forn(i,n) for(int i=0; i<n; ++i)
#define pb push_back
#define vii(a,n) vector<int>a(n);forn(i,n)cin>>a[i];
#define pi pair<int,int>
#define f first
#define s second

double TL;	
void init(int numSubtests, double timeLimit) {
	TL=timeLimit;
}

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
#define all(x) x.begin(),x.end()

int _try(vector<vector<int>>& puzzle) {
    int n=puzzle.size();
    auto a = puzzle;
    auto ans = a;

    vector<vector<int>> vis(n,vector<int>(n,0));

    int k=0; forn(i,n) forn(j,n) k+=!!a[i][j];

    forn(it,k) {
        pi ok = {-1,-1};
        forn(i,n) {
            forn(j,n) {
                if (!puzzle[i][j]) continue;
                if (vis[i][j]) continue;
                if (!a[i][j]) {ok={i,j}; continue;}
                int s=0;
                for(int z=i-1; z>=0; --z) {
                    if (ans[z][j]<0) break;
                    if (vis[z][j]) break;
                    if (puzzle[z][j]) {
                        s+=min({a[i][j],a[z][j],2}); break;
                    }
                }
                for(int z=i+1; z<n; ++z) {
                    if (ans[z][j]<0) break;
                    if (vis[z][j]) break;
                    if (puzzle[z][j]) {
                        s+=min({a[i][j],a[z][j],2}); break;
                    }
                }
                for(int z=j-1; z>=0; --z) {
                    if (ans[i][z]<0) break;
                    if (vis[i][z]) break;
                    if (puzzle[i][z]) {
                        s+=min({a[i][j],a[i][z],2}); break;
                    }
                }
                for(int z=j+1; z<n; ++z) {
                    if (ans[i][z]<0) break;
                    if (vis[i][z]) break;
                    if (puzzle[i][z]) {
                        s+=min({a[i][j],a[i][z],2}); break;
                    }
                }
                if (s < a[i][j]) return 0;
                if (s==a[i][j]) {
                    ok={i,j};
                }
            }
        }
        if (ok.f==-1) {
        	int best=-1;
            forn(i,n) forn(j,n) {
                if (!puzzle[i][j]) continue;
                if (vis[i][j]) continue;
                int S=(rng()%555555);
                if (S > best) {
                	ok={i,j}; best=S;
                }
            }
        }

        int i=ok.f, j=ok.s;
        vis[i][j]=1;
        if (!a[i][j]) continue;

        vector<int> p; forn(itt,4) p.pb(itt); //shuffle(all(p),rng);

        for(auto&X:p) {
            if (X==0) for(int z=i-1; z>=0; --z) {
                if (ans[z][j]<0) break;
                if (vis[z][j]) break;
                if (puzzle[z][j]) {
                    int t=min({a[z][j],a[i][j],2});
                    if (!t) break;
                    for(int q=i-1; q>z; --q) ans[q][j]=-2*t;
                    a[i][j]-=t;
                    a[z][j]-=t;
                    break;
                }
            }
            if (X==1) for(int z=i+1; z<n; ++z) {
                if (ans[z][j]<0) break;
                if (vis[z][j]) break;
                if (puzzle[z][j]) {
                    int t=min({a[z][j],a[i][j],2});
                    if (!t) break;
                    for(int q=i+1; q<z; ++q) ans[q][j]=-2*t;
                    a[i][j]-=t;
                    a[z][j]-=t;
                    break;
                }
            }
            if (X==2) for(int z=j-1; z>=0; --z) {
                if (ans[i][z]<0) break;
                if (vis[i][z]) break;
                if (puzzle[i][z]) {
                    int t=min({a[i][z],a[i][j],2});
                    if (!t) break;
                    for(int q=j-1; q>z; --q) ans[i][q]=-2*t+1;
                    a[i][j]-=t;
                    a[i][z]-=t;
                    break;
                }
            }
            if (X==3) for(int z=j+1; z<n; ++z) {
                if (ans[i][z]<0) break;
                if (vis[i][z]) break;
                if (puzzle[i][z]) {
                    int t=min({a[i][z],a[i][j],2});
                    if (!t) break;
                    for(int q=j+1; q<z; ++q) ans[i][q]=-2*t+1;
                    a[i][j]-=t;
                    a[i][z]-=t;
                    break;
                }
            }
        }
        if (a[i][j]) return 0;
    }
    forn(i,n) forn(j,n) if (a[i][j]) return 0;
    forn(i,n) forn(j,n) puzzle[i][j]=ans[i][j];
    return 1;
}

bool solve(vector<vector<int>>& puzzle) {

    vector<vector<int>> save=puzzle;
    vector<vector<int>> ans=puzzle;
    int n=ans.size();
    int z;
    double last=0;
    double avg=0;
    while (TL-timePassed() > 2*avg) {
        z=_try(ans);
        if (!avg) avg=timePassed()-last;
        avg=sqrt(avg*(timePassed()-last));
        last=timePassed();
        if (z) break;
        forn(i,n) forn(j,n) ans[i][j]=save[i][j];
    }
    if (!z) return 0;
    forn(i,n) forn(j,n) puzzle[i][j]=ans[i][j];

    return true;
}