//             _
//   ^ ^      //
// >(O_O)<___//
//   \ __ __  \
//    \\ \\ \\\\

#include <bits/stdc++.h>
using namespace std;

#pragma GCC optimize("O3")
#pragma GCC target("popcnt")

#define int long long
#define forn(i,n) for(int i=0; i<n; ++i)
#define pb push_back
#define vii(a,n) vector<int>a(n);forn(i,n)cin>>a[i];

const int M=1e8+543;

int x[1000005];

struct matrix {
	int a[5][5];
	matrix(vector<vector<int>>b) {
		forn(i,5) forn(j,5) a[i][j]=b[i][j];
	}
	matrix() {
		forn(i,5) forn(j,5) a[i][j]=0;
		forn(i,5) a[i][i]=1;
	}
};
void mult(matrix&ret, matrix a, matrix b) {
	//cout<<"? multiplying\n";
	//cout<<"A:\n";
	//forn(i,5) {
	//	forn(j,5) cout<<a.a[i][j]<<' '; cout<<'\n';
	//}
	//cout<<"B:\n";
	//forn(i,5) {
	//	forn(j,5) cout<<b.a[i][j]<<' '; cout<<'\n';
	//}
	forn(i,5) forn(j,5) {
		ret.a[i][j]=0;
		forn(t,5) ret.a[i][j]+=a.a[t][j]*b.a[i][t];
		ret.a[i][j]%=M;
	}
	//cout<<"Ret:\n";
	//forn(i,5) {
	//	forn(j,5) cout<<ret.a[i][j]<<' '; cout<<'\n';
	//}
}
matrix pw(matrix a, int b) {
	matrix ret;
	while (b) {
		if (b&1) {
			mult(ret,ret,a);
		}
		mult(a,a,a);
		b>>=1;
	}
	return ret;
}

struct BIT {
	vector<int> t; int n;
	BIT(int n) {
		this->n=n; t.assign(n,0);
	}
	void add(int i, int x) {
		for(;i<n;i=i|(i+1)) t[i]=(t[i]+M+x)%M;
	}
	int sum(int r) {
		int q=0;
		for(;r>=0;r=(r&(r+1))-1) q=(q+t[r])%M;
		return q;
	}
};

void solve() {

	int n,q; cin>>n>>q;
	vii(a,n);
	vector<vector<int>> z1 = {{0,0,0,0,0},{1,0,0,0,0},{2,0,0,0,0},{3,0,0,0,0},{4,0,0,0,0}};
	vector<vector<int>> z2 = {{0,1,0,0,0},{0,0,1,0,0},{0,0,0,1,0},{0,0,0,0,1},{1,2,3,4,5}};
	matrix x0(z1);
	matrix step(z2);
	BIT ft(n);
	vector<int> x(n);
	forn(i,n) {
		matrix m;
		//cout<<i<<":\n";
		//forn(f,5) {
		//	forn(s,5) cout<<m.a[f][s]<<' '; cout<<'\n';
		//}
		//cout<<a[i]<<" - \n";
		auto z = pw(step,a[i]);
		//forn(f,5) {
		//	forn(s,5) cout<<z.a[f][s]<<' '; cout<<'\n';
		//}
		mult(m,x0,z);
		x[i]=m.a[0][0];
		//cout<<"? "<<x[i]<<'\n';
		ft.add(i,x[i]);
	}
	forn(it,q) {
		int t; cin>>t;
		if (t&1) {
			int l,r; cin>>l>>r; --l, --r;
			cout<<(M+ft.sum(r)-ft.sum(l-1))%M<<'\n';
		} else {
			int l,r,v; cin>>l>>r>>v; --l, --r;
			for(int i=l; i<=r; ++i) {
				ft.add(i,-x[i]);
				a[i]+=v;
				matrix m;
				auto z = pw(z2,a[i]);
				mult(m,z1,z);
				x[i]=m.a[0][0];
				ft.add(i,x[i]);
			}
		}
	}

}

int32_t main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	solve();
}