						///~~~L0TA~~~///
#include <bits/stdc++.h>
using namespace std;
#define N 100000
#define M 100000543
#define append push_back
map<int,vector<vector<long long>>> x;
map<int,vector<vector<long long>>> y;
void matrix_mul(int n,int m){
	long long o,r;
	x[n+m].clear();
	y[n+m].clear();
	vector<long long> p,q;
	for(int i=0;i<5;i++){
		p.clear();
		q.clear();
		for(int j=0;j<5;j++){
			for(int k=o=r=0;k<5;k++){
				o+=(x[n][i][k]*x[m][k][j])%M;
				r+=(y[n][i][k]*y[m][k][j])%M;
				o%=M;
				r%=M;
			}
			p.append(o);
			q.append(r);
		}
		x[n+m].append(p);
		y[n+m].append(q);
	}
}
void pwr(int n){
	if(!x[n].empty()) return;
	int m=n/2;
	pwr(m);
	matrix_mul(m,m);
	if(2*m<n) matrix_mul(n-1,1);
}
int get_x(int n){
	int o=0;
	if(n==0)
		return o;
	pwr(abs(n));
	if(n<0){
		for(int i=0;i<5;i++){
			o+=(i*y[-n][i][0])%M;
			o%=M;
		}
	}
	else{
		for(int i=0;i<5;i++){
			o+=(i*x[n][i][0])%M;
			o%=M;
		}
	}
	return o;
}
int a[N];
int seg[4*N];
int lazy[4*N];
void build(int v=1,int s=0,int e=N){
	if(e-s==1){
		seg[v]=get_x(a[s]);
		return;
	}
	int mid,rc,lc;
	mid=(s+e)/2;
	rc=2*v+1;
	lc=2*v;
	build(lc,s,mid);
	build(rc,mid,e);
	seg[v]=(seg[lc]+seg[rc])%M;
}
int get(int l,int r,int v=1,int s=0,int e=N){
	if(r<=s || e<=l || s>=e) return 0;
	if(l<=s && e<=r) return seg[v];
	int mid,rc,lc;
	mid=(s+e)/2;
	rc=2*v+1;
	lc=2*v;
	return (get(l,r,lc,s,mid)+get(l,r,rc,mid,e))%M;
}
void update(int l,int r,int val,int v=1,int s=0,int e=N){
	if(e-s==1){
		a[s]+=val;
		seg[v]=get_x(a[s]);
		return;
	}
	int mid,rc,lc;
	mid=(s+e)/2;
	rc=2*v+1;
	lc=2*v;
	if(l<mid) update(l,r,val,lc,s,mid);
	else update(l,r,val,rc,mid,e);
	seg[v]=(seg[lc]+seg[rc])%M;
}
void solve(int n,int m){
	int o,p,q,r;
	build();
	while(m--){
		cin>>o>>p>>q;
		if(o==1){
			cout<<get(p-1,q)<<'\n';
		}
		else{
			cin>>r;
			update(p-1,q,r);
		}
	}
}
int main(){
	ios::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	int n,m;
	cin>>n>>m;
	x[1]={{0,0,0,0,1},
		  {1,0,0,0,2},
		  {0,1,0,0,3},
		  {0,0,1,0,4},
		  {0,0,0,1,5},};
	y[1]={{M-2,1,0,0,0},
		  {M-3,0,1,0,0},
		  {M-4,0,0,1,0},
		  {M-5,0,0,0,1},
		  { 1,0,0,0,0},};
	for(int i=0;i<n;i++)
		cin>>a[i];
	solve(n,m);
	return 0;
}