#include <bits/stdc++.h>
using namespace std;
const long long N=1e5+2;
long long a[N];
long long mod=1e8+543;
vector<vector<long long>> iden(5,vector<long long>(5));
vector<vector<long long>> mat(5,vector<long long>(5));

vector<vector<long long>> flp(5,vector<long long>(1));

vector<vector<long long>> mul(vector<vector<long long>>& a,vector<vector<long long>>& b) // O(125)
{
	long long np=a.size();
	long long mp=b[0].size();
	long long xp=b.size();
	vector<vector<long long>> ans(np,vector<long long>(mp));
	for(long long i=0;i<np;i++)
		for(long long j=0;j<mp;j++)
			for(long long k=0;k<xp;k++)
				ans[i][j]=(ans[i][j]+((a[i][k]*b[k][j])%mod))%mod;
	return ans;
}
vector<vector<long long>> square_it(vector<vector<long long>>& a) // O(125)
{
	long long np=a.size();
	long long mp=a[0].size();
	vector<vector<long long>> ans(np,vector<long long>(mp));
	for(long long i=0;i<np;i++)
	{
			ans[i][0]=(ans[i][0]+((a[i][0]*a[0][0])%mod))%mod;
			ans[i][0]=(ans[i][0]+((a[i][1]*a[1][0])%mod))%mod;
			ans[i][0]=(ans[i][0]+((a[i][2]*a[2][0])%mod))%mod;
			ans[i][0]=(ans[i][0]+((a[i][3]*a[3][0])%mod))%mod;
			ans[i][0]=(ans[i][0]+((a[i][4]*a[4][0])%mod))%mod;

			ans[i][1]=(ans[i][1]+((a[i][0]*a[0][1])%mod))%mod;
			ans[i][1]=(ans[i][1]+((a[i][1]*a[1][1])%mod))%mod;
			ans[i][1]=(ans[i][1]+((a[i][2]*a[2][1])%mod))%mod;
			ans[i][1]=(ans[i][1]+((a[i][3]*a[3][1])%mod))%mod;
			ans[i][1]=(ans[i][1]+((a[i][4]*a[4][1])%mod))%mod;

			ans[i][2]=(ans[i][2]+((a[i][0]*a[0][2])%mod))%mod;
			ans[i][2]=(ans[i][2]+((a[i][1]*a[1][2])%mod))%mod;
			ans[i][2]=(ans[i][2]+((a[i][2]*a[2][2])%mod))%mod;
			ans[i][2]=(ans[i][2]+((a[i][3]*a[3][2])%mod))%mod;
			ans[i][2]=(ans[i][2]+((a[i][4]*a[4][2])%mod))%mod;

			ans[i][3]=(ans[i][3]+((a[i][0]*a[0][3])%mod))%mod;
			ans[i][3]=(ans[i][3]+((a[i][1]*a[1][3])%mod))%mod;
			ans[i][3]=(ans[i][3]+((a[i][2]*a[2][3])%mod))%mod;
			ans[i][3]=(ans[i][3]+((a[i][3]*a[3][3])%mod))%mod;
			ans[i][3]=(ans[i][3]+((a[i][4]*a[4][3])%mod))%mod;

			ans[i][4]=(ans[i][4]+((a[i][0]*a[0][4])%mod))%mod;
			ans[i][4]=(ans[i][4]+((a[i][1]*a[1][4])%mod))%mod;
			ans[i][4]=(ans[i][4]+((a[i][2]*a[2][4])%mod))%mod;
			ans[i][4]=(ans[i][4]+((a[i][3]*a[3][4])%mod))%mod;
			ans[i][4]=(ans[i][4]+((a[i][4]*a[4][4])%mod))%mod;
	}
	return ans;
}
vector<vector<long long>> pow_raise(vector<vector<long long>>&mat,long long& pw)
{
	if(pw==0)
	{
		return iden;
	}
	else if(pw==1)
	{
		return mat;
	}
	else
	{
		long long k=pw/2;
		vector<vector<long long>> ans=pow_raise(mat,k);
		ans=mul(ans,ans);
		if(pw%2)
			ans=mul(ans,mat);
		return ans;
	}
}
const long long MX=1e18;
map<long long,long long> tp;
long long val(long long x)
{
	if(x<=4)
		return x;
	if(tp.find(x)!=tp.end())
		return tp[x];
	long long wdyw=x-4;
	if(x>MX)
		exit(-1);
	vector<vector<long long>> matpow=pow_raise(mat,wdyw);
	vector<vector<long long>> ntx=mul(matpow,flp);
	tp[x]=ntx[4][0];
	return ntx[4][0];
}
int main()
{
	cin.tie(0);
	cout.tie(0);
	ios::sync_with_stdio(0);
	for(long long i=0;i<5;i++)
	{
		iden[i][i]=1;
		flp[i][0]=i;
	}
	for(long long i=0;i<5;i++)
	{
		for(long long j=0;j<5;j++)
		{
			if(j==(i+1))
			{
				mat[i][j]=1;
			}
			else
			{
				if(i==4)
				{
					mat[i][j]=j+1;
				}
				else
				{
					mat[i][j]=0;
				}
			}
		}
	}
	long long n=1,q=2e5;
	cin>>n>>q;
	for(long long i=1;i<=n;i++)
		cin>>a[i];
	while(q--)
	{
		long long t,l=1,r=1;
		cin>>t>>l>>r;
		if(t==1)
		{
			cout<<val(a[l])<<'\n';
		}
		else
		{
			long long vp;
			cin>>vp;	
			a[l]+=vp;
		}
	}
}