#include <bits/stdc++.h>
#include "ones.h"
using namespace std;

int myn, myk, mymoves, found, cur;
vector<int> ans;

void findall(int l, int r){
    int store = r;
    while (l != r){
        int mid = (l + r) / 2;
        if (hasOnes(l, mid))
            r = mid;
        else
            l = mid + 1;
    }

    ans.push_back(l);

    r = store;
    if (found != myk and cur < 1 and l + 1 <= r and hasOnes(l + 1, r)){
        found++;
        cur++;
        findall(l + 1, r);
    }
}

vector<int> guessOnes(int N, int K){
    myn = N;
    myk = K;

    ans.clear();
    mymoves = 0;
    found = 0;

    int block_sz = myn / (2 * myk);

    vector<pair<int, int>> blocks, que;
    for (int i = 1; i <= myn;){
        int r = min(i + block_sz - 1, myn);
        blocks.push_back({i, r});
        i += block_sz;
    }

    for (int i = 0; i < blocks.size(); i ++){
        int l = blocks[i].first;
        int r = blocks[i].second;

        if (hasOnes(l, r)){
            found++;
            que.push_back({l, r});
        }
    }

    for (auto [l, r] : que){
        cur = 0;
        findall(l, r);
    }

    return ans;
}

/*
#include <bits/stdc++.h>
#include "Lgrader.cpp"
using namespace std;

int myn, myk, mymoves;
vector<int> ans;
queue<pair<int, int>> q;

void bfs(){
    while (q.size() != myk){
        auto p = q.front();
        q.pop();

        int l = p.first;
        int r = p.second;
    
        if (l == r){
            q.push({l, r});
            continue;
        }

        int mid = (l + r) / 2;
        mymoves++;
        if (hasOnes(l, mid)){
            mymoves++;
            q.push({l, mid});
            if (hasOnes(mid + 1, r))
                q.push({mid + 1, r});
        }
        else
            q.push({mid + 1, r});
    }
    cout << "--" << mymoves << endl;

    while (q.size()){
        auto p = q.front();
        q.pop();

        int l = p.first;
        int r = p.second;

        while (l != r){
            int mid = (l + r) / 2;
            mymoves++;
            if (hasOnes(l, mid))
                r = mid;
            else
                l = mid + 1;
        }

        ans.push_back(l);
    }

    cout << "--" << mymoves << endl;
}

vector<int> guessOnes(int N, int K){
    myn = N;
    myk = K;

    int block_sz = myn / (2 * myk);

    vector<pair<int, int>> blocks;
    for (int i = 1; i <= myn;){
        int r = min(i + block_sz - 1, myn);
        blocks.push_back({i, r});
        i += block_sz;
    }

    ans.clear();
    mymoves = 0;
    for (int i = 0; i < blocks.size(); i ++){
        int l = blocks[i].first;
        int r = blocks[i].second;

        bool have = hasOnes(l, r);
        mymoves++;
        
        if (!have) continue;

        q.push({l, r});
    }

    cout << "--" << mymoves << endl;

    bfs();

    sort(ans.begin(), ans.end());
    return ans;
}
*/