#include <iostream>
using namespace std;

#define f first
#define s second
#define mn(a,b) min(a,b)
#define mx(a,b) max(a,b)
#define ll long long
#define N  int(1e8+1)
#define mod  int(1e8+543)
int pre_Calculation[N];
int prefix[N];
void update(int l,int value,int n)
{
	while(l<=n)
	{
		prefix[l] += value;
		l += l&-l;
	}
}
int query(int l){
	int Total = 0 ;
	while(l>0)
	{
		Total=(Total+prefix[l])%mod;;
		Total%=mod;
		l-=l&-l;
	}
	return Total;
}
void solve()
{
	int n,q;
	cin >> n >> q;
	int a[n+1];
	for(int i =1  ;i  <= n ; i ++)
	{
		cin >> a[i];
		update(i,pre_Calculation[a[i]],n);
	}
	while(q -- )
	{
	    int type;
	    cin >> type;
	    if(type == 1)
	    {
	        int l,r;
	        cin >> l>>r;
	        long long Total = 0;
	        cout << (query(r) - query(l-1) + mod )%mod << endl;
	    }
	    else
	    {

	        int l,r,x;
	        cin >> l >> r >> x;

	        for(int i = l;i<=r;i++)a[i]+=x;
	        update(l,pre_Calculation[a[l]] - pre_Calculation[a[l]-x],n);
	    }
	}
}
int main()
{
	  ios::sync_with_stdio(false); cin.tie(0), cout.tie(0);

   for(int i =1 ; i <=4;i++)
   	{
   		pre_Calculation[i]=i;
   	}
   for(int i = 5 ;  i < N;i++)
   {
   	 ll total = 0 ;
   	 int Z = 5;
   	 for(int j = i-1 ;j>=i-5;j--)
   	 {
   	 	total +=1ll* pre_Calculation[j]*Z;
   	 	Z--;
   	 	total%=mod;
   	 }
   	 pre_Calculation[i] = total;
   }

		solve();
	return 0;
	}