#include <bits/stdc++.h>
#include "ones.h"

using namespace std;

const int nmax = 1e5;

int K;
bool sel[nmax + 5];

bool h[nmax + 5];

void brut(int l, int r, int k)
{
    int last = l - 1;
    for(int i=1; i<=k; i++)
    {
        int st = last + 1;
        int dr = r;
        int poz = last;
        while(st <= dr)
        {
            int mij = (st + dr) >> 1;
            if(hasOnes(st, mij))
            {
                dr = mij - 1;
            }
            else
            {
                poz = mij;
                st = mij + 1;
            }
        }
        if(poz == r)
        {
            break;
        }
        sel[poz + 1] = true;
        last = poz + 1;
    }
}

void divide(int n, int k)
{
    queue<pair<pair<int,int>,int>> q;
    q.push({{1, n}, k});
    while(!q.empty())
    {
        int st = q.front().first.first;
        int dr = q.front().first.second;
        k = q.front().second;
        q.pop();
        if(st == dr)
        {
            sel[st] = true;
            continue;
        }
        if(k <= K / 2)
        {
            brut(st, dr, k);
            continue;
        }
        int nr_split = 2 * k;
        int sz = (dr - st + 1) / nr_split;
        sz = max(sz, 1);
        int nr_buck = 0;
        for(int i=st; i<=dr; i+=sz)
        {
            ++nr_buck;
            h[nr_buck] = false;
        }
        int cnt = 0;
        int nr = 0;
        for(int i=st; i<=dr; i+=sz)
        {
            ++cnt;
            bool ok = hasOnes(i, min(dr, i + sz - 1));
            if(ok)
            {
                h[cnt] = true;
                ++nr;
            }
            if(nr == k)
            {
                break;
            }
        }
        cnt = 0;
        for(int i=st; i<=dr; i+=sz)
        {
            ++cnt;
            if(h[cnt])
            {
                q.push({{i, min(dr, i + sz - 1)}, k - nr + 1});
            }
        }
    }
}

vector<int> guessOnes(int n, int k)
{
    K = k;
    /*if(k <= 500)
    {
        vector<int> rez;
        int last = 0;
        for(int i=1;i<=k;i++)
        {
            int st = last + 1;
            int dr = n;
            int poz = last;
            while(st <= dr)
            {
                int mij = (st + dr) >> 1;
                if(hasOnes(st, mij))
                {
                    dr = mij - 1;
                }
                else
                {
                    poz = mij;
                    st = mij + 1;
                }
            }
            rez.push_back(poz + 1);
            last = poz + 1;
        }
        return rez;
    }
    */
    for(int i=1; i<=n; i++)
    {
        sel[i] = false;
    }
    divide(n, k);
    vector<int> rez;
    for(int i=1; i<=n; i++)
    {
        if(sel[i])
        {
            rez.push_back(i);
        }
    }
    return rez;
}
