#include <bits/stdc++.h>

#include "puzzle.h"

using namespace std;

void init(int numSubtests, double timeLimit){

}

int n,m;
int puzzle[50][50];
int sol[50][50];

///stanga jos dreapta sus

int dx[]={0,1,0,-1};
int dy[]={1,0,-1,0};

int opposite[] = {2,4,0,1};

int bridge[4][3] = {
    {0,-1,-3},
    {0,-2,-4},
    {0,-1,-3},
    {0,-2,-4}
};

int u[5];

int det(int i,int j){

    int x = puzzle[i][j];

    for(int l=0;l<4;l++){
        u[l] = 0;

        int newi = i+dx[l];
        int newj = j+dy[l];

        if(0<=newi && newi<n && 0<= newj && newj < m){

            if(puzzle[newi][newj] == bridge[l][1]){
                u[l] = 1;
                x--;
            }else if(puzzle[newi][newj] == bridge[l][2]){
                u[l] = 2;
                x-=2;
            }
        }
    }

    //cout<<x<<'\n';

    return x;

}

bool bkt(int i,int j);
bool bkt2(int i,int j,int x,int pas);


bool bkt2(int i,int j,int x,int pas,int val[4]){

    if(pas == 4){

        if(x!=0){
            return false;
        }
        //cout<<"!";

        /*for(int l=0;l<=3;l++){
            cout<<val[l]<<" ";
        }cout<<'\n';

        for(int ii=0;ii<n;ii++){
            for(int jj=0;jj<m;jj++){
                cout<<puzzle[ii][jj]<<" ";
            }cout<<'\n';
        }cout<<'\n';*/

        for(int l=0;l<=3;l++){

            if(val[l] == 0){

                continue;
            }

            int newi = i+dx[l];
            int newj = j+dy[l];

            while(puzzle[newi][newj] == 0 && 0<= newi && newi<n && 0<= newj && newj <m){
                newi += dx[l];
                newj += dy[l];
            }

            if(!(puzzle[newi][newj] > 0 && 0<= newi && newi<n && 0<= newj && newj <m)){

                return false;
            }
        }

        for(int l=0;l<=3;l++){

            if(val[l] == 0){
                continue;
            }

            int newi = i+dx[l];
            int newj = j+dy[l];

            while(puzzle[newi][newj] == 0){
                puzzle[newi][newj] = bridge[l][val[l]];
                newi += dx[l];
                newj += dy[l];
            }
        }

        //cout<<i<<" "<<j<<" "<<x<<'\n';
        /*cout<<"("<<puzzle[i][j]<<") "<<i<<" "<<j<<" = \n";
        for(int l=0;l<4;l++){
            cout<<u[l]<<" ";
        }cout<<'\n';
        for(int l=0;l<4;l++){
            cout<<val[l]<<" ";
        }cout<<'\n';
        cout<<'\n';*/

        /*cout<<i<<" "<<j<<'\n';
        for(int ii=0;ii<n;ii++){
            for(int jj=0;jj<m;jj++){
                cout<<puzzle[ii][jj]<<" ";
            }cout<<'\n';
        }cout<<'\n';*/


        if(j == m-1){
            if(bkt(i+1,0)){
                return 1;
            }
        }else{
            if(bkt(i,j+1)){
                return 1;
            }
        }

        for(int l=0;l<=3;l++){

            if(val[l] == 0){
                continue;
            }

            int newi = i+dx[l];
            int newj = j+dy[l];

            while(puzzle[newi][newj] <= 0){
                puzzle[newi][newj] = 0;
                newi += dx[l];
                newj += dy[l];
            }
        }


        return false;
    }

    if(u[pas]!=0){
        if(bkt2(i,j,x,pas+1,val)){
            return true;
        }
    }

    for(int l=0;l<=2;l++){
        val[pas] = l;

        if(bkt2(i,j,x-l,pas+1,val)){
            return true;
        }
    }

    return false;

}

bool bkt(int i,int j){

    //cout<<i<<" "<<j<<'\n';

    if(i == n){
        //cout<<i<<" "<<n<<" !!! "<<(i==n)<<'\n';

        //cout<<"!";

        for(int ii=0;ii<n;ii++){
            for(int jj=0;jj<m;jj++){
                sol[i][j] = puzzle[i][j];
            }
        }

        return 1;
    }

    if(i == 3 && j == 0){
        //cout<<puzzle[i][j]<<"...\n";
    }

    if(puzzle[i][j] > 0){

        //cout<<i<<" "<<j<<'\n';

        int x = det(i,j);

        if(x<0){
            return 0;
        }

        int val[4];
        for(int i=0;i<=3;i++){
            val[i] = 0;
        }

        if(bkt2(i,j,x,0,val)){
            return 1;
        }

    }else{

        if(j == m-1){
            if(bkt(i+1,0)){
                return 1;
            }
        }else{
            if(bkt(i,j+1)){
                return 1;
            }
        }

    }

    return 0;
}


bool solve(std::vector<std::vector<int>>& puzz){

    n = puzz.size();
    m = puzz[0].size();

    for(int i=0;i<n;i++){
        for(int j=0;j<m;j++){
            puzzle[i][j] = puzz[i][j];
        }
    }

    /*for(int i=0;i<n;i++){
        for(int j=0;j<m;j++){
            cout<<puzzle[i][j]<<" ";
        }cout<<'\n';
    }*/

    //cout<<n<<" "<<m<<'\n'<<'\n';

    if(!bkt(0,0)){
        cout<<":(";
    }

    for(int i=0;i<n;i++){
        for(int j=0;j<m;j++){
            puzz[i][j] = puzzle[i][j];
            //cout<<puzzle[i][j]<<" ";
        }
    }

    return 1;
}

/**

1 2
7 7
0 0 2 0 3 0 3
4 0 0 0 0 2 0
0 0 0 0 0 0 0
6 0 0 0 0 2 0
0 0 0 0 0 0 0
0 0 0 0 0 0 0
4 0 0 0 0 0 4

**/

