#include <bits/stdc++.h>

#define DIM 100000
#define MOD 100000543

using namespace std;

struct nod{
    int x[5];
    int xbonus[5];

    int val;
    int det;
}aint[4*DIM+5];

int n,q;
int v[DIM+5];

struct info{
    int type;
    int st;
    int dr;
    int add;
}u[2*DIM+5];

int val;

void inmultire(int sol[5][5],int a[5][5],int b[5][5]){

    for(int i=0;i<5;i++){
        for(int j=0;j<5;j++){
            sol[i][j] = 0;
            for(int k=0;k<5;k++){
                sol[i][j] = (1ll*sol[i][j] + (1ll*a[i][k]*b[k][j])%MOD)%MOD;
            }
        }
    }
}

void copiere(int a[5][5],int b[5][5]){
    for(int i=0;i<5;i++){
        for(int j=0;j<5;j++){
            a[i][j] = b[i][j];
        }
    }
}

//void det(int p,int x[5]){
int det(int p){

    if(p <= 4){
        return p;
    }
    p-=4;

    int mat[5][5] = {
        {5,4,3,2,1},
        {1,0,0,0,0},
        {0,1,0,0,0},
        {0,0,1,0,0},
        {0,0,0,1,0}
    };

    int sol[5][5] = {
        //{x[4],x[3],x[2],x[1],x[0]},
        {1,0,0,0,0},
        {0,1,0,0,0},
        {0,0,1,0,0},
        {0,0,0,1,0},
        {0,0,0,0,1}
    };
    int tmp[5][5];

    while(p!=0){
        if(p%2==1){
            inmultire(tmp,sol,mat);
            copiere(sol,tmp);
        }
        p/=2;
        inmultire(tmp,mat,mat);
        copiere(mat,tmp);
    }

    int add = 0;
    for(int i=0,j=4;i<=4;i++,j--){
        add = (1ll*add + (1ll*sol[0][i] * j)%MOD )%MOD;
    }
    return add;
}

void build(int nod,int st,int dr){
    if(st == dr){
        //cin>>val;

        aint[nod].val = v[st];
        aint[nod].det = det(v[st]);

        /*if(val<=4){
            aint[nod].xbonus[val]++;
        }else{
            for(int i=4;i>=0;i--){
                aint[nod].x[i] = i;
            }
            //det(val-5,aint[nod].x);
        }*/

        return;
    }

    int mid = (st+dr)/2;

    build(2*nod,st,mid);
    build(2*nod+1,mid+1,dr);

    aint[nod].det = (1ll*aint[2*nod].det + aint[2*nod+1].det)%MOD;
}

int querySum = 0;
void query(int nod,int st,int dr,int a,int b){
    if(1<=st && dr <= b){
        querySum = (1ll*querySum + aint[nod].det)%MOD;

        return;
    }

    int mid = (st+dr)/2;

    if(a<=mid){
        query(2*nod,st,mid,a,b);
    }
    if(mid+1<=b){
        query(2*nod+1,mid+1,dr,a,b);
    }
}

void update(int nod,int st,int dr,int a,int b,int add){
    if(st == dr){
        aint[nod].val = (1ll*aint[nod].val + add)%MOD;
        aint[nod].det = det(aint[nod].val);
        return;
    }

    int mid = (st+dr)/2;

    if(a<=mid){
        update(2*nod,st,mid,a,b,add);
    }
    if(mid+1<=b){
        update(2*nod+1,mid+1,dr,a,b,add);
    }

    aint[nod].val = (1ll*aint[2*nod].val + aint[2*nod+1].val)%MOD;
}

int sp[DIM+5];
int rez[1000005];
void cazParticular(){

    for(int i=0;i<=4;i++){
        rez[i] = i;
    }
    for(int i=5;i<=1000000;i++){
        rez[i] = (1ll*5*rez[i-1] + 4*rez[i-2] + 3*rez[i-3] + 2*rez[i-4] + rez[i-5])%MOD;
    }

    sp[0] = 0;
    for(int i=1;i<=n;i++){
        sp[i] = sp[i-1];
        sp[i] = (1ll*sp[i] + 1ll*rez[v[i]])%MOD;
    }

    for(int i=1;i<=q;i++){
        cout<<(1ll*MOD + 1ll*sp[u[i].dr] - 1ll*sp[u[i].st-1])%MOD<<'\n';
    }

}

int main()
{
    cin>>n>>q;
    for(int i=1;i<=n;i++){
        cin>>v[i];
    }

    bool ok = 1;
    for(int i=1;i<=q;i++){
        cin>>u[i].type>>u[i].st>>u[i].dr;
        if(u[i].type == 2){
            cin>>u[i].add;
           // cout<<"EE";
            ok = 0;
        }
    }
    //cout<<ok<<"!!!\n";

    if(ok){
        cazParticular();
        return 0;
    }

    build(1,1,n);

    for(int i=1;i<=q;i++){
        if(u[i].type == 1){
            querySum = 0;
            query(1,1,n,u[i].st,u[i].dr);
            cout<<querySum<<"\n";
        }else{
            update(1,1,n,u[i].st,u[i].dr,u[i].add);
        }
    }
    return 0;
}
