#include "ones.h"
#include <algorithm>
#include <queue>

std::vector <int> guessOnes( int n, int k ) {

    std::vector <int> v;

    if ( k * 2 < n ) {

        std::queue< std::pair<int, int>> q;

        q.push({1, n / 4});
        q.push({n / 4 + 1, n / 2});
        q.push({n / 2 + 1, 3 * n / 4});
        q.push({3 * n / 4 + 1, n});

        while ( q.size() != 0 && v.size() < k ) {

            int st = q.front().first;
            int dr = q.front().second;

            q.pop();

            if ( hasOnes(st, dr) == 1 ) {
                if ( st == dr )
                    v.push_back(st);
                else {
                    q.push ({st, (st + dr) / 2});
                    q.push ({(st + dr) / 2 + 1, dr});
                }
            }
        }

        sort ( v.begin(), v.end() );
    }

    else {
        for ( int i = 1; i <= n && v.size() < k; i++ ) {
            if ( hasOnes (i, i) == true )
                v.push_back (i);
        }
    }

    return v;
}
