#include "ones.h"
#include <algorithm>
#include <queue>

std::vector <int> guessOnes( int n, int k ) {

    std::vector <int> v;

    if ( k * 2 < n ) {

        std::queue< std::pair<int, int>> q;

        int x = 16;

        if ( k > 50 )
            x = 64;
        if ( k > 100 )
            x = 256;
        if ( k > 200 )
            x = 512;
        if ( k > 500 )
            x = 1024;

        int st = 1, dr = n / x;

        while ( dr != n ) {
            q.push({st, dr});
            st = dr + 1;

            dr = dr + n / x;

            if ( dr > n )
                dr = n;
        }

        q.push({st, dr});

        while ( q.size() != 0 && v.size() < k ) {

            int st = q.front().first;
            int dr = q.front().second;

            q.pop();

            if ( hasOnes(st, dr) == 1 ) {
                if ( st == dr )
                    v.push_back(st);
                else {
                    q.push ({st, (st + dr) / 2});
                    q.push ({(st + dr) / 2 + 1, dr});
                }
            }
        }

        sort ( v.begin(), v.end() );
    }

    else {
        for ( int i = 1; i <= n && v.size() < k; i++ ) {
            if ( hasOnes (i, i) == true )
                v.push_back (i);
        }
    }

    return v;
}
