#include <bits/stdc++.h>
#include "ones.h"

using namespace std;

int lg2(int x) {
    return 31 - __builtin_clz(x);
}

vector<int> positions;

int find_first_in_range(int posl, int posr, int rem, int n, int k) {
    //>= pos
    int p = n / k * 15;

    int st = posl;
    int dr = min(posr, posl + p);
    int first = 0;

    while (st <= dr) {
        int mij = (st + dr) / 2;
        if (hasOnes(posl, mij)) {
            first = mij;
            dr = mij - 1;
        } else {
            st = mij + 1;
        }
    }
    return first;
}

const double threshold = 1e-6;

int find_last_in_range(int posl, int posr, int rem, int n, int k) {

    int p = n / k * 15;

    int st = max(posl, posr - p);
    int dr = posr;
    int last = 0;

    while (st <= dr) {
        int mij = (st + dr) / 2;
        if (hasOnes(mij, posr)) {
            last = mij;
            st = mij + 1;
        } else {
            dr = mij - 1;
        }
    }
    return last;
}

vector<int> guessOnes(int n, int k) {
    positions.clear();

    int p = find_first_in_range(1, n, k, n, k);
    int u = find_last_in_range(p + 1, n, k - 1, n, k);

    positions.push_back(p);
    positions.push_back(u);

    for (int i = 3; i <= k; i++) {
        if (i & 1) {
            int t = find_first_in_range(p + 1, u - 1, k - i + 1, n ,k);
            positions.push_back(t);
            p = t;
        } else {
            int t = find_last_in_range(p + 1, u - 1, k - i + 1, n, k);
            positions.push_back(t);
            u = t;
        }
    }

    sort(positions.begin(), positions.end());

    return positions;
}
