#include <bits/stdc++.h>
#pragma GCC optimize("O2")
#pragma GCC optimize("unroll-loops")

using namespace std;
using ll = long long;

const ll MOD = 1e8 + 543;
const int NMAX = 1e5 + 5;
const int QMAX = 2e5 + 5;

//ll x[NMAX];

ll matsus[5][5];
ll matjos[5][5];

ll val[NMAX + 5][5];
ll a[NMAX + 5];
int n, q;

///MATRIX STUFF BEGIN

void constructSus() {
    matsus[1 - 1][2 - 1] = 1;
    matsus[2 - 1][3 - 1] = 1;
    matsus[3 - 1][4 - 1] = 1;
    matsus[4 - 1][5 - 1] = 1;


    matsus[5 - 1][1 - 1] = 1;
    matsus[5 - 1][2 - 1] = 2;
    matsus[5 - 1][3 - 1] = 3;
    matsus[5 - 1][4 - 1] = 4;
    matsus[5 - 1][5 - 1] = 5;
}

void constructJos() {
    matjos[1 - 1][1 - 1] = (-2 + MOD) % MOD;
    matjos[1 - 1][2 - 1] = (-3 + MOD) % MOD;
    matjos[1 - 1][3 - 1] = (-4 + MOD) % MOD;
    matjos[1 - 1][4 - 1] = (-5 + MOD) % MOD;
    matjos[1 - 1][5 - 1] = 1;


    matjos[2 - 1][1 - 1] = 1;
    matjos[3 - 1][2 - 1] = 1;
    matjos[4 - 1][3 - 1] = 1;
    matjos[5 - 1][4 - 1] = 1;
}

void inmSelf(ll a[5][5]) {
    ll b[5][5];

    for (int i = 0; i < 5; i++)
        for (int j = 0; j < 5; j++)
            b[i][j] = 0;

    for (int i = 0; i < 5; i++)
        for (int k = 0; k < 5; k++)
            for (int j = 0; j < 5; j++)
                b[i][j] += a[i][k] * a[k][j];
    for (int i = 0; i < 5; i++)
        for (int j = 0; j < 5; j++)
            a[i][j] = b[i][j] % MOD;
    // a devine a * a
}

void inmSame(ll a[5][5], ll b[5][5]) {
    ll c[5][5];
    for (int i = 0; i < 5; i++)
        for (int j = 0; j < 5; j++)
            c[i][j] = 0;

    for (int i = 0; i < 5; i++)
        for (int k = 0; k < 5; k++)
            for (int j = 0; j < 5; j++)
                c[i][j] += a[i][k] * b[k][j];
    for (int i = 0; i < 5; i++)
        for (int j = 0; j < 5; j++)
            a[i][j] = c[i][j] % MOD;
    //a devine a * b
}

void inm(ll a[5][5], ll b[5], ll c[5]) {
    for (int i = 0; i < 5; i++)
        c[i] = 0;

    for (int i = 0; i < 5; i++) {
        for (int k = 0; k < 5; k++) {
            //j = 0
            c[i] += a[i][k] * b[k];
        }
        c[i] %= MOD;
    }
    //c devine a * b
}

void InmSus(int idx, int v) {
    ll r[5][5];
    for (int i = 0; i < 5; i++)
        for (int j = 0; j < 5; j++)
            r[i][j] = 0;
    r[0][0] = r[1][1] = r[2][2] = r[3][3] = r[4][4] = 1;

    //r - matricea de identitate

    ll ma[5][5]; // matsus
    for (int i = 0; i < 5; i++)
        for (int j = 0; j < 5; j++)
            ma[i][j] = matsus[i][j];
    while (v > 0) {
        if (v & 1) {
            inmSame(r, ma);

        }
        inmSelf(ma);
        v >>= 1;
    }

    ll nval[5];

    inm(r, val[idx], nval);

    for (int i = 0; i < 5; i++)
        val[idx][i] = nval[i];
}

void InmJos(int idx, int v) {
    ll r[5][5];

    for (int i = 0; i < 5; i++)
        for (int j = 0; j < 5; j++)
            r[i][j] = 0;

    r[0][0] = r[1][1] = r[2][2] = r[3][3] = r[4][4] = 1;

    //r - matricea de identitate

    ll ma[5][5]; // matsus
    for (int i = 0; i < 5; i++)
        for (int j = 0; j < 5; j++)
            ma[i][j] = matjos[i][j];
    while (v > 0) {
        if (v & 1) {
            inmSame(r, ma);
        }
        inmSelf(ma);
        v >>= 1;
    }

    ll nval[5];

    inm(r, val[idx], nval);

    for (int i = 0; i < 5; i++)
        val[idx][i] = nval[i];
}

///MATRIX STUFF END

int query(int l, int r) {
    return 0;
}

void update(int l, int r, int v) {

}

void solve() {
    constructSus();
    constructJos();

    cin >> n >> q;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        val[i][0] = 0;
        val[i][1] = 1;
        val[i][2] = 2;
        val[i][3] = 3;
        val[i][4] = 4;
        if (a[i] > 4)
            InmSus(i, a[i] - 4);
        else if (a[i] < 4)
            InmJos(i, 4 - a[i]);
    }

    for (int i = 1; i <= q; i++) {
        int tip;
        cin >> tip;
        if (tip == 1) {
            int l, r;
            cin >> l >> r;
            cout << query(l, r) << '\n';
        } else {
            int l, r, v;
            cin >> l >> r >> v;
            update(l, r, v);
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}
