#include <bits/stdc++.h>
#define debug(x) cerr << #x << " " << x << "\n"
#define debugs(x) cerr << #x << " " << x << " "

using namespace std;
typedef long long ll;
typedef pair <int, int> pii;

const int NMAX = 100001;
const int BLOCK = 1001;
const int MOD = 100000543;
const int INF = 1e9;
const int VALMAX = MOD;

#include "ones.h"

vector <int> sol;
int K;

void divide(int st, int dr) {
    if(st > dr) return;
    if(st == dr){
        if(hasOnes(st, dr)){
            sol.push_back(st);
        }
        return;
    }
    int mid = st + (st + dr) / 3;
    int r = mid, pas = (1 << (int)log2(mid - st + 1));
    while(pas) {
        if(r - pas >= st && !hasOnes(r - pas, r))
            r -= pas;
        pas /= 2;
    }
    if(r == mid) {
        if(!hasOnes(r, r))
            r--;
    } else {
        r--;
    }
    if(r >= st) {
        sol.push_back(r);
        divide(st, r - 1);
    }
    if(sol.size() == K)
        return;
    r = mid + 1, pas = (1 << (int)log2(dr - mid));
    while(pas) {
        if(r + pas <= dr && !hasOnes(r, r + pas))
            r += pas;
        pas /= 2;
    }
    if(r == mid + 1) {
        if(!hasOnes(r, r))
            r++;
    } else {
        r++;
    }
    if(r <= dr) {
        sol.push_back(r);
        divide(r + 1, dr);
    }
}

vector<int> guessOnes(int n,int k) {
    sol.clear();
    K = k;
    int dr = n, acum = 0;
    divide(1, n);
    sort(sol.begin(), sol.end());
    return sol;
}
