#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
#define debug(x) cerr << #x << " " << x << "\n"
#define debugs(x) cerr << #x << " " << x << " "

using namespace std;
typedef long long ll;
typedef pair <int, int> pii;

const int NMAX = 100001;
const int BLOCK = 20;
const int MOD = 100000543;
const int VALMAX = MOD;

int v[NMAX];

struct ura{
    int a, b, c, d, e;
};

vector <pair <int, ura> > valori;

int compute(int unde){
    if(unde >= 0 && unde <= 4)
        return unde;
    int last = 0, pas = (1 << 22);
    while(pas){
        if(last + pas < valori.size() && valori[last + pas].first < unde)
            last += pas;
        pas /= 2;
    }
    int a = valori[last].second.a, b = valori[last].second.b, c = valori[last].second.c, d = valori[last].second.d, e = valori[last].second.e;
    for(int i = valori[last].first + 1; i <= unde; i++){
        int x = (e * 5 % MOD + d * 4 % MOD + c * 3 % MOD + b * 2 % MOD + a)%MOD;
        swap(a, b);
        swap(b, c);
        swap(c, d);
        swap(d, e);
        e = x;
    }
    return e;
}

int main()
{
    #ifdef HOME
    ifstream cin(".in");
    ofstream cout(".out");
    #endif // HOME
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, q, i;
    cin >> n >> q;

    int a = 0, b = 1, c = 2, d = 3, e = 4;
    for(i = 5; i < VALMAX; i++){
        int x = (e * 5 % MOD + d * 4 % MOD + c * 3 % MOD + b * 2 % MOD + a)%MOD;
        swap(a, b);
        swap(b, c);
        swap(c, d);
        swap(d, e);
        e = x;
        if(i % BLOCK == 0 || i == 5){
            valori.push_back({i, {a, b, c, d, e}});
        }
    }
    for(i = 1; i <= n; i++){
        cin >> v[i];
        v[i] = compute(v[i]);
        v[i] += v[i - 1];
        if(v[i] >= MOD) v[i] -= MOD;
    }
    for(i = 1; i <= q; i++){
        int l, r, t;
        cin >> t >> l >> r;
        cout << (v[r] - v[l - 1] + MOD) % MOD << "\n";
    }
    return 0;
}
