#include <bits/stdc++.h>
#define debug(x) cerr << #x << " " << x << "\n"
#define debugs(x) cerr << #x << " " << x << " "

#define int ll

using namespace std;
typedef long long ll;
typedef pair <int, int> pii;

const int NMAX = 100001;
const int BLOCK = 1001;
const int MOD = 100000543;
const int INF = 1e9;
const int VALMAX = MOD;

int v[NMAX];
int rec[5][5];

void add(int &x, int val) {
    while(val < 0)
        val += MOD;
    x += val;
    x %= MOD;
}

int prod[5][5];
int rez[5][5];
int mat[5][5];

void ridica(int put) {
    for(int i = 0; i < 5; i++) {
        for(int j = 0; j < 5; j++) {
            prod[i][j] = (i == j);
        }
    }
    while(put) {
        if(put%2) {
            for(int i = 0; i < 5; i++) {
                for(int j = 0; j < 5; j++) {
                    rez[i][j] = 0;
                    for(int k = 0; k < 5; k++) {
                        add(rez[i][j], (1LL * prod[i][k] * mat[k][j]));
                    }
                    rez[i][j] %= MOD;
                }
            }
            for(int i = 0; i < 5; i++) {
                for(int j = 0; j < 5; j++) prod[i][j] = rez[i][j];
            }
        }
        for(int i = 0; i < 5; i++) {
            for(int j = 0; j < 5; j++) {
                rez[i][j] = 0;
                for(int k = 0; k < 5; k++) {
                    add(rez[i][j], (1LL * mat[i][k] * mat[k][j]));
                }
                                    rez[i][j] %= MOD;

            }
        }
        for(int i = 0; i < 5; i++) {
            for(int j = 0; j < 5; j++) mat[i][j] = rez[i][j];
        }
        put /= 2;
    }
}

int compute(int cv) {
    if(cv >= 0 && cv <= 4)
        return cv;
    for(int i = 0; i < 5; i++) {
        for(int j = 0; j < 5; j++) {
            mat[i][j] = rec[i][j];
            //debug(rec[i][j]);
        }
    }
    ridica(cv);
    int total = 0;
    add(total, ((1LL * prod[0][0] * (-22)) + (1LL * prod[0][4] * (-5)) + (1LL * prod[0][1] * (33)) + (1LL * prod[0][3] * (-4)) + (1LL * prod[0][2] * (-3))) % MOD);
    return total;
}

signed main() {
#ifdef HOME
    ifstream cin(".in");
    ofstream cout(".out");
#endif // HOME
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, q, i;
    cin >> n >> q;
    rec[0][0] = 5;
    rec[0][1] = 4;
    rec[0][2] = 3;
    rec[0][3] = 2;
    rec[0][4] = 1;
    rec[1][0] = 1;
    rec[2][1] = 1;
    rec[3][2] = 1;
    rec[4][3] = 1;
    for(i = 1; i <= n; i++) {
        cin >> v[i];
        v[i]++;
       // update(1, 1, n, i, i, v[i]);
    }
    for(i = 1; i <= q; i++) {
        int l, r, t, vl;
        cin >> t >> l >> r;
        if(t == 1) {
            cout << compute(v[l]) << "\n";
        } else {
            int vl;
            cin >> vl;
            v[l] += vl;
            v[l] %= MOD;
        }
    }
    return 0;
}
