#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#define debug(x) cerr << #x << " " << x << "\n"
#define debugs(x) cerr << #x << " " << x << " "

#define int ll

using namespace std;
typedef long long ll;
typedef pair <ll, ll> pii;

const ll NMAX = 100001;
const ll BLOCK = 1001;
const ll MOD = 100000543;
const ll INF = 1e9;
const ll VALMAX = MOD;

ll v[NMAX];
ll rec[5][5];

void add(ll &x, ll val) {
    x += val;
    if(x >= MOD)
        x -= MOD;
}

ll prod[5][5];
ll rez[5][5];
ll rez2[5][5];
ll mat[5][5];

void ridica(ll put) {
    for(int i = 0; i < 5; i++) {
        for(int j = 0; j < 5; j++) {
            prod[i][j] = (i == j);
        }
    }
    while(put) {
        for(int i = 0; i < 5; i++) {
            for(int j = 0; j < 5; j++) {
                rez[i][j] = rez2[i][j] = 0;
                for(int k = 0; k < 5; k++) {
                    add(rez2[i][j], (1LL * mat[i][k] * mat[k][j]));
                    add(rez[i][j], (1LL * prod[i][k] * mat[k][j]));
                }
                rez[i][j] %= MOD;
                rez2[i][j] %= MOD;
            }
        }
        if(put%2) {
            for(int i = 0; i < 5; i++) {
                for(int j = 0; j < 5; j++) prod[i][j] = rez[i][j];
            }
        }
        for(int i = 0; i < 5; i++) {
            for(int j = 0; j < 5; j++) mat[i][j] = rez2[i][j];
        }
        put /= 2;
    }
}

unordered_map <int, int> mp;

ll compute(int cv) {
    if(mp.find(cv) != mp.end())
        return mp[cv];
    if(cv >= 0 && cv <= 4)
        return cv;
    for(int i = 0; i < 5; i++) {
        for(int j = 0; j < 5; j++) {
            mat[i][j] = rec[i][j];
        }
    }
    ridica(cv - 4);
    ll total = 0;
    add(total, ((1LL * prod[0][0] * 4) + (1LL * prod[0][1] * 3) + (1LL * prod[0][3] * 1) + (1LL * prod[0][2] * 2)) % MOD);
    return mp[cv] = total;
}

signed main() {
    #ifdef HOME
    ifstream cin(".in");
    #endif // HOME
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, q, i;
    cin >> n >> q;
    rec[0][0] = 5;
    rec[0][1] = 4;
    rec[0][2] = 3;
    rec[0][3] = 2;
    rec[0][4] = 1;
    rec[1][0] = 1;
    rec[2][1] = 1;
    rec[3][2] = 1;
    rec[4][3] = 1;
    for(i = 1; i <= n; i++) {
        cin >> v[i];
        // update(1, 1, n, i, i, v[i]);
    }
    for(i = 1; i <= q; i++) {
        ll l, r, t, vl;
        cin >> t >> l >> r;
        if(t == 1) {
            cout << compute(v[l]) << "\n";
        } else {
            ll vl;
            cin >> vl;
            v[l] += vl;
        }
    }
    return 0;
}
