#include "ones.h"
#include <bits/stdc++.h>
using namespace std;


vector<int> guessOnes(int n, int k) {

    deque<int> a, b;
    vector <int> ret;

    int Start, End;

    Start = 1;
    End = n;

    while (Start <= End) {

        if (Start == End) {

            if (hasOnes(Start, End))
                a.push_back(Start);
            break;
        }

        int pos = -1;
        int l = Start, r = End, pos1 = -1, pos2 = -1;

        while (l <= r) {

            int m = (l + r) >> 1;

            if (hasOnes(Start, m)) {

                pos1 = m;
                r = m - 1;
            }
            else
                l = m + 1;
        }

        if (pos1 == -1)
            break;

        l = pos1;
        r = End;

        while (l <= r) {

            int m = (l + r) >> 1;

            if (hasOnes(m, End)) {

                pos2 = m;
                l = m + 1;
            }
            else
                r = m - 1;
        }

        if (pos1 == pos2) {

            a.push_back(pos1);
            break;
        }

        a.push_back(pos1);
        b.push_front(pos2);

        Start = pos1 + 1;
        End = pos2 - 1;
    }

    for (auto i : a)
        ret.push_back(i);
    for (auto i : b)
        ret.push_back(i);

    return ret;
}