#include <bits/stdc++.h>
using namespace std;

ifstream fin("number.in");
ofstream fout("number.out");

const int mod = 1e8 + 543;

int A[6][6], B[6][6], C[6][6], D[6][6];
int n, q, a[100001];

inline void cpy(int A[6][6], int B[6][6]) {

    for (int i = 1; i <= 5; i++)
        for (int j = 1; j <= 5; j++)
            A[i][j] = B[i][j];
}

inline void multi(int A[6][6],  int B[6][6], int C[6][6]) {

    for (int i = 1; i <= 5; i++)
        for (int j = 1; j <= 5; j++)
            C[i][j] = 0;

    for (int i = 1; i <= 5; i++)
        for (int j = 1; j <= 5; j++)
            for (int k = 1; k <= 5; k++) {

                C[i][j] += 1LL * A[i][k] * B[k][j] % mod;

                if (C[i][j] >= mod)
                    C[i][j] -= mod;
            }
}

void power(int x) {

    if (x == 0) {

        for (int i = 1; i <= 5; i++)
            for (int j = 1; j <= 5; j++)
                A[i][j] = (i == j);
        return;
    }

    power(x >> 1);
    multi(A, A, B);
    cpy(A, B);

    if (x & 1) {

        multi(A, C, B);
        cpy(A, B);
    }
}

inline int sub(int k) {

    if (k <= 4)
        return k;

    power(k - 4);

    int ret = 0;

    for (int j = 1; j <= 5; j++) {

        ret += 1LL * (5 - j) * A[j][1] % mod;

        if (ret >= mod)
            ret -= mod;
    }

    return ret;
}

int main() {

    C[1][1] = 5;

    for (int i = 2; i <= 5; i++)
        C[i][1] = C[i - 1][1] - 1;

    for (int j = 2; j <= 5; j++)
        C[j - 1][j] = 1;

    cin >> n >> q;

    for (int i = 1; i <= n; i++) {

        cin >> a[i], a[i] = sub(a[i]);
        a[i] += a[i - 1];

        if (a[i] >= mod)
            a[i] -= mod;
    }

    for (int i = 1; i <= q; i++) {

        int type, l, r;
        cin >> type >> l >> r;

        int aux = a[r] - a[l - 1];
        if (aux < 0)
            aux += mod;
        cout << aux << '\n';
    }

    return 0;
}
