#include <bits/stdc++.h>
using namespace std;

const int mod = 1e8 + 543;
int A[6][6], B[6][6], C[6][6], D[6][6];
int n, q;

struct node{

    int val, idx;
};

node a[100001];

bool cmp1(node a, node b) {

    return a.val < b.val;
}

bool cmp2(node a, node b) {

    return a.idx < b.idx;
}

inline void cpy(int A[6][6], int B[6][6]) {
    for (int i = 1; i <= 5; i++)
        for (int j = 1; j <= 5; j++)
            A[i][j] = B[i][j];
}

inline void multi(int A[6][6], int B[6][6], int C[6][6]) {

    for (int i = 1; i <= 5; i++)
        for (int j = 1; j <= 5; j++)
            C[i][j] = 0;
    for (int i = 1; i <= 5; i++)
        for (int j = 1; j <= 5; j++)
            for (int k = 1; k <= 5; k++) {
                C[i][j] += 1LL * A[i][k] * B[k][j] % mod;
                if (C[i][j] >= mod)
                    C[i][j] -= mod;
            }
}

void power(int x) {

    if (x == 0) {
        for (int i = 1; i <= 5; i++)
            for (int j = 1; j <= 5; j++)
                A[i][j] = (i == j);
        return;
    }

    power(x >> 1);
    multi(A, A, B);
    cpy(A, B);
    if (x & 1) {
        multi(A, C, B);
        cpy(A, B);
    }
}

inline int sub() {

    int ret = 0;

    for (int j = 1; j <= 5; j++) {
        ret += 1LL * (5 - j) * D[j][1] % mod;
        if (ret >= mod)
            ret -= mod;
    }
    return ret;
}

int main() {

    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    C[1][1] = 5;
    for (int i = 2; i <= 5; i++)
        C[i][1] = C[i - 1][1] - 1;
    for (int j = 2; j <= 5; j++)
        C[j - 1][j] = 1;

    cin >> n >> q;

    for (int i = 1; i <= n; i++)
        cin >> a[i].val, a[i].idx = i;

    sort(a + 1, a + n + 1, cmp1);

    power(0);
    cpy(D, A);
    int last = 0;

    for (int i = 1; i <= n; i++) {

        if (a[i].val <= 4) {

            continue;
        }

        int aux = a[i].val - 4 - last;

        power(aux);

        multi(D, A, B);
        cpy(D, B);

        a[i].val = sub();
    }

    sort(a + 1, a + n + 1, cmp2);

    for (int i = 1; i <= n; i++)
        a[i].val = (a[i - 1].val + a[i].val) % mod;

    for (int i = 1; i <= q; i++) {
        
        int type, l, r;
        cin >> type >> l >> r;
        int aux = a[r].val - a[l - 1].val;
        if (aux < 0)
            aux += mod;
        cout << aux << '\n';
    }
    return 0;
}