#include <bits/stdc++.h>

using namespace std;

#define nmax  100001
#define mod 100000543
#define maxlg 30
#define int long long
int v[nmax];
int ans[nmax][5];
int mat[5][5], mataux[5][5];
int vaux[5];
int matp2[maxlg][5][5], rez[5][5];
int aint[4*nmax], sp[nmax];

void init( int l, int r, int poz ) {
    if( l == r )
        aint[poz] = ans[l][0];
    else {
        init( l, (l + r) / 2, 2 * poz );
        init( (l + r) / 2 + 1, r , 2 * poz + 1);
        aint[poz] = aint[2*poz] + aint[2*poz+1];
        aint[poz] %= mod;
    }
}

void update( int l, int r, int lq, int poz ) {
    if( l <= lq && lq <= r ) {
        if( l == r )
            aint[poz] = ans[l][0];
        else {
            update( l, (l + r) / 2, lq, 2 * poz );
            update( (l + r) / 2 + 1, r , lq, 2 * poz + 1);
            aint[poz] = aint[2*poz] + aint[2*poz + 1];
            aint[poz] %= mod;
        }
    }
}

int query( int l, int r, int lq, int rq, int poz ) {
    //cout << l << "l " << r << "r " << aint[poz] << "\n";
    if( lq <= l && r <= rq )
        return aint[poz];
    else if( lq > r || rq < l )
        return 0;
    return (query( l, (l + r) / 2, lq, rq, 2 * poz ) + query( (l + r) / 2 + 1, r, lq, rq, 2 * poz + 1 )) % mod;
}

void inmultire5_5( int x[5][5], const int y[5][5] ) {
    int i, j, p;
    for( i = 0; i < 5; i++ )
        for( j = 0; j < 5; j++ ) {
            mataux[i][j]= 0;
            for( p = 0; p < 5; p++ ) {
                mataux[i][j] += x[i][p] * y[p][j];
                mataux[i][j] %= mod;
            }
        }
    for( i = 0; i < 5; i++ )
        for( j = 0; j < 5; j++ )
            x[i][j] = mataux[i][j];
}

void inmultire1_5( int x[5], const int y[5][5] ) {
    int i, j, p;
    for( j = 0; j < 5; j++ ) {
        vaux[j] = 0;
        for( p = 0; p < 5; p++ ) {
            vaux[j] += x[p] * y[p][j];
            vaux[j] %= mod;
        }
    }
    for( i = 0; i < 5; i++ )
        x[i] = vaux[i];
}

void find_mataux() {
    int i, j, k, p;
    for( i = 0; i < 5; i++ )
        for( j = 0; j < 5; j++ )
            matp2[0][i][j] = mat[i][j];
    for( k = 1; k < maxlg; k++ ) {
        for( i = 0; i < 5; i++ )
            for( j = 0; j < 5; j++ ) {
                mataux[i][j]= 0;
                for( p = 0; p < 5; p++ ) {
                    mataux[i][j] += matp2[k-1][i][p] * matp2[k-1][p][j];
                    mataux[i][j] %= mod;
                }
            }
        for( i = 0; i < 5; i++ )
            for( j = 0; j < 5; j++ )
                matp2[k][i][j] = mataux[i][j];
        /*cout << k << "fct\n";
        for( i = 0; i < 5; i++ ) {
            for( j = 0; j < 5; j++ )
                cout << matp2[k][i][j] << " ";
            cout << "\n";
        }*/
    }


}

void find_element( int a, int vect[] ) {
    int k = 0, i, j;
    for( i = 0; i < 5; i++ )
        for( j = 0; j < 5; j++ )
            rez[i][j] = 0;
    for( i = 0; i < 5; i++ )
        rez[i][i] = 1;
    while( a > 0 ) {
        if( a % 2 == 1 )
            inmultire5_5( rez, matp2[k] );
        a /= 2;
        /*cout << k << "\n";
        for( i = 0; i < 5; i++ ) {
            for( j = 0; j < 5; j++ )
                cout << rez[i][j] << " ";
            cout << "\n";
        }*/
        k++;
    }
    inmultire1_5( vect, rez );
}

signed main()
{
    int n, q, i, l, r, val, j, type, rez;
    mat[1][0] = 1;
    mat[2][1] = 1;
    mat[3][2] = 1;
    mat[4][3] = 1;
    mat[0][4] = 1;
    mat[1][4] = 2;
    mat[2][4] = 3;
    mat[3][4] = 4;
    mat[4][4] = 5;

    cin >> n >> q;
    find_mataux();

    for( i = 1; i <= n; i++ ) {
        cin >> v[i];
        for( j = 0; j < 5; j++ )
            ans[i][j] = j;
        find_element( v[i], ans[i] );
        sp[i] = (sp[i-1] + ans[i][0]) % mod;
        /*cout << sp[i - 1] << "sp   " << ans[i][0] << " " << sp[i];
        cout << "ans ";
        for( j = 0; j < 5; j++ )
            cout << ans[i][j] << " ";
        cout << "\n";*/

    }
    init( 1, n, 1 );
    for( i = 0; i < q; i++ ) {
        cin >> type >> l >> r;
        if( type == 1 ) {
            cout << query( 1, n, l, r, 1 ) << "\n";
        } else {
            cin >> val;
            for( j = l; j <= r; j++ ) {
                find_element( val, ans[j] );
                update( 1, n, j, 1 );
            }
        }
    }
    return 0;
}
