#include "ones.h"


#include <cmath>

void divimp2(int st,int dr,std::vector<int>& v)
{
    if(st==dr)
    {
        v.push_back(st);
        return;
    }
    if(st>dr)
        return;
    int mid = (st+dr)/2;
    bool x = hasOnes(st,mid);
    if(!x)
        divimp2(mid+1,dr,v);
    else
    {
        bool y = hasOnes(mid+1,dr);
        divimp2(st,mid,v);
        if(y)   divimp2(mid+1,dr,v);
    }
}

void divimp(int st,int dr,std::vector<int>& v)
{
    if(dr-st +1 <= 30)
    {
        divimp2(st,dr,v);
        return;
    }
    if(st>dr)
        return;
    int bl = std::max(29,(int)sqrt(dr-st+1));
    int x = st;
    while(x<=dr)
    {
        int y = std::min(dr,x + bl);
        if(hasOnes(x,y))
            divimp(x,y,v);
        x = y + 1;
    }
}

/**
20 10 1
1 2 3 6 8 9 13 14 18 20
**/


#include <algorithm>

std::vector<int> guessOnes(int n,int k)
{
    std::vector <int> sol;

    divimp(1,n,sol);

    sort(sol.begin(),sol.end());
    return sol;
}
