#include <vector>
#include <iostream>
#include <cmath>
#include "ones.h"

using namespace std;

bool hasOnes (int l, int r);

std::vector<int> guessInterval(int n, int st, int dr) {
  int l  = st;
  vector<int>sol;
  while (l <= dr) {
    int p;
    for (p = 0; (1 << p) <= dr - l + 1; p++);
    p--;
    int ans = 0;
    for (int pas = (1 << p); pas; (pas >>= 1))
      if (l + ans + pas <= dr && !hasOnes(l, l + ans + pas)) {
        ans += pas;
      }
    if (l + ans == dr) break;
     if (ans) {
      l = l + ans + 2;
      sol.push_back(l-1);

    }
    else {
      if (hasOnes(l, l)) {
        sol.push_back(l);
        l++;
      }
      else {
        sol.push_back(l + 1);
        l += 2;
      }
    }
  }
  return sol;
}

std::vector<int> guessOnes(int n,int k) {
  int ans = 1e9, B = 0;
  for (int i = 1; i <= n; i++)
    if (ans > k * (int)log2(1.0 * i) + n / i)
      B = i, ans = k * (int)log2(1.0 * i) + n / i;
  vector<int>sol;
  for (int i = 1; i <= n; i += B) {
    if (hasOnes(i, min(n, i + B - 1))) {
      auto idk = guessInterval(n, i, min(n, i + B - 1));
      for (auto it : idk)
        sol.push_back(it);
    }
  }
  return sol;
}