#include <vector>
#include <iostream>
#include <cmath>
#include <cassert>
#include "ones.h"

using namespace std;

bool hasOnes (int l, int r);

vector<int>S;

std::vector<int> guessInterval(int n, int k, int st, int dr) {
  int l  = st;
  vector<int>sol;
  while (l <= dr && S.size() + sol.size() < k) {
    int p;
    for (p = 0; (1 << p) <= dr - l + 1; p++);
    p--;
    int ans = 0;
    for (int pas = (1 << p); pas; (pas >>= 1))
      if (l + ans + pas <= dr && !hasOnes(l, l + ans + pas)) {
        ans += pas;
      }
    if (l + ans == dr) break;
     if (ans) {
      l = l + ans + 2;
      sol.push_back(l-1);

    }
    else {
      if (hasOnes(l, l)) {
        sol.push_back(l);
        l++;
      }
      else {
        sol.push_back(l + 1);
        l += 2;
      }
    }
  }
 
  return sol;
}

std::vector<int> guessOnes(int n,int k) {
  S.clear();

  if (k >= 500 || k <= 20) {
    int l = 1;
    for (int i = 1; i <= k; i++) {
      int p;
      for (p = 0; (1 << p) <= n - l + 1; p++);
      p--;
      int ans = 0;
      for (int pas = (1 << p); pas; (pas >>= 1))
        if (l + ans + pas <= n && !hasOnes(l, l + ans + pas)) {
          ans += pas;
        }
      if (ans) {
        l = l + ans + 2;
        S.push_back(l-1);

      }
      else {
        if (hasOnes(l, l)) {
          S.push_back(l);
          l++;
        }
        else {
          S.push_back(l + 1);
          l += 2;
        }
      }
    }
    return S;
  }
  int ans = 1e9, B = 0;
  for (int i = 1; i <= n; i++)
    if (ans > k * (int)log2(1.0 * i) + n / i)
      B = i, ans = k * (int)log2(1.0 * i) + n / i;
  B = 10000;
  for (int i = 1; i <= n && S.size() < k; i += B) {
    if (hasOnes(i, min(n, i + B - 1))) {
      auto idk = guessInterval(n, k, i, min(n, i + B - 1));
      for (auto it : idk)
        S.push_back(it);
    }
  }
  
  return S;
}