#include <iostream>

using namespace std;
using ll=long long;
const ll mod=1e8+543;
const int NMAX=1e5+505,NN=5e5+505;
ll aux[6][6],aux2[6];
int ex[6][6],ar[NN][6],lazy[NN][6][6],aa[6][6],mat[6][6],mat2[6][6];
int ok[NMAX];
void mul(int a[6][6],int b[6][6])
{
    for (int i=1;i<=5;++i)
        for (int j=1;j<=5;++j)
        aux[i][j]=0;
    for (int i=1;i<=5;++i)
        for (int j=1;j<=5;++j)
        for (int k=1;k<=5;++k)
        aux[i][j]+=1LL*a[i][k]*b[k][j];
    for (int i=1;i<=5;++i)
        for (int j=1;j<=5;++j)
        b[i][j]=aux[i][j]%mod;
}
void mul2(int a[6][6],int b[6])
{
    for (int i=1;i<=5;++i)
        aux2[i]=0;
    for (int i=1;i<=5;++i)
        for (int k=1;k<=5;++k)
        aux2[i]+=1LL*a[i][k]*b[k];
    for (int i=1;i<=5;++i)
        b[i]=aux2[i]%mod;
}
void lgput(int t,int b)
{
    if (t==1)
    {
        for (int i=1;i<=5;++i)
            for (int j=1;j<=5;++j)
            aa[i][j]=mat[i][j];
    }
    else
    {
        for (int i=1;i<=5;++i)
            for (int j=1;j<=5;++j)
            aa[i][j]=mat2[i][j];
    }
    for (int i=1;i<=5;++i)
        for (int j=1;j<=5;++j)
        ex[i][j]=0;
    for (int i=1;i<=5;++i)
        ex[i][i]=1;
    while (b)
    {
        if (b%2==1) {mul(aa,ex);}
        mul(aa,aa);
        b/=2;
    }
}
void propag(int st,int dr,int nod)
{
    if (ok[nod]==1) return ;
    ok[nod]=0;
    mul2(lazy[nod],ar[nod*2]);
    mul2(lazy[nod],ar[nod*2+1]);
    mul(lazy[nod],lazy[nod*2]);
    mul(lazy[nod],lazy[nod*2+1]);
    for (int i=1;i<=5;++i)
        for (int j=1;j<=5;++j)
        lazy[nod][i][j]=0;
    for (int i=1;i<=5;++i)
        lazy[nod][i][i]=1;
}
void egal(int nod,int ex[6][6])
{
    mul2(ex,ar[nod]);
    mul(ex,lazy[nod]);
}
int mods(int a,int b)
{
    if (a+b>mod) return a+b-mod;
    return a+b;
}
void ssm(int a,int b,int c)
{
    for (int i=1;i<=5;++i)
        ar[a][i]=mods(ar[b][i],ar[c][i]);
}
void update(int st,int dr,int nod,int qa,int qb)
{
    propag(st,dr,nod);
    if (qa<=st&&dr<=qb)
    {
        egal(nod,ex);
        if (st!=dr) ok[nod]=1;
        return ;
    }
    int mij=(st+dr)/2;
    if (qa<=mij) update(st,mij,nod*2,qa,qb);
    if (qb>mij) update(mij+1,dr,nod*2+1,qa,qb);
    ssm(nod,nod*2,nod*2+1);
}
ll query(int st,int dr,int nod,int qa,int qb)
{
    propag(st,dr,nod);
    if (qa<=st&&dr<=qb)
        return ar[nod][1];
    int mij=(st+dr)/2;
    ll ras1=0,ras2=0;
    if (qa<=mij) ras1=query(st,mij,nod*2,qa,qb);
    if (qb>mij) ras2=query(mij+1,dr,nod*2+1,qa,qb);
    return mods(ras1,ras2);
}
void upda(int st,int dr,int val,int n)
{
    if (val==0) return ;
    if (val>0)
    {
        lgput(1,val);
    }
    else
    {
        lgput(2,-val);
    }
    update(1,n,1,st,dr);
}
void upd(int st,int dr,int nod)
{
    if (st==dr)
    {
        for (int i=1;i<=5;++i)
            ar[nod][i]=i-1;
        for (int i=1;i<=5;++i)
            lazy[nod][i][i]=1;
        return ;
    }
    int mij=(st+dr)/2;
    upd(st,mij,nod*2);
    upd(mij+1,dr,nod*2+1);
    ssm(nod,nod*2,nod*2+1);
}
int main()
{
    for (int i=1;i<=4;++i)
        mat[i][i+1]=1;
    for (int i=1;i<=5;++i)
        mat[5][i]=i;
    for (int i=2;i<=5;++i)
        mat2[i][i-1]=1;
    for (int i=1;i<=4;++i)
        mat2[1][i]=(-i-1)+mod;
    mat2[1][5]=1;
    ios_base::sync_with_stdio(NULL);
    cin.tie(0);
    cout.tie(0);
    int n,q;
    cin>>n>>q;
    upd(1,n,1);
    for (int i=1;i<=n;++i)
    {
        int x;
        cin>>x;
        upda(i,i,x,n);
    }
    for (int i=1;i<=q;++i)
    {
        int tip,st,dr,val;
        cin>>tip>>st>>dr;
        if (tip==2) cin>>val;
        if (tip==2) upda(st,dr,val,n);
        else cout<<(query(1,n,1,st,dr)%mod+mod)%mod<<'\n';
    }
    return 0;
}
