#include "ones.h"
#include <bits/stdc++.h>
#define all(x) (x).begin(),(x).end()

using namespace std;
using ll = long long;

// #define int ll
#define sz(x) ((int)(x).size())

using pii = pair<int,int>;
using tii = tuple<int,int,int>;

int query(int l, int r) {
    // cerr << l + 1 << ' ' << r + 1 << '\n';
    return hasOnes(l, r);
}

vector<int> sol;

deque<pii> st;
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

void divide(int l, int r, int& k) {
	st.emplace_back(l, r);
	
	auto push = [&](int a, int b) {
		if(rng() % 5 == 0) st.emplace_front(a, b);
		else st.emplace_back(a, b);
	};
	
	while(!st.empty()) {
		auto [l, r] = st.front();
		st.pop_front();
		if(l == r) {
			sol.emplace_back(l);
			continue;
		}
		int mid = l + r >> 1;
		bool a;
		if(a = (query(l, mid)))
			push(l, mid);
		if(!a || (sz(st) < k && query(mid + 1, r)))
			push(mid + 1, r);
	}
	return;
}

std::vector<int> guessOnes(int n,int k) {
    sol.clear();
    divide(1, n, k);
    sort(all(sol));
    return sol;
}
