#include "ones.h"
#include <bits/stdc++.h>
#define all(x) (x).begin(),(x).end()

using namespace std;
using ll = long long;

// #define int ll
#define sz(x) ((int)(x).size())

using pii = pair<int,int>;
using tii = tuple<int,int,int>;

int query(int l, int r) {
    // cerr << l + 1 << ' ' << r + 1 << '\n';
    return hasOnes(l, r);
}

vector<int> sol;

auto cmp = [](pii a, pii b) { return a.second - a.first < b.second - b.first; };

priority_queue<pii, vector<pii>, decltype(cmp)> st(cmp);
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

void divide(int l, int r, int& k) {
	st.emplace(l, r);
	
	auto push = [&](int a, int b) {
		st.emplace(a, b);
		// cerr << a << ' ' << b << '\n';
	};
	
	while(!st.empty()) {
		auto [l, r] = st.top();
		st.pop();
		if(l == r) {
			sol.emplace_back(l);
			continue;
		}
		int mid = l + r >> 1;
		
		int rem = k - sz(st) + 1;
		int R = (r - l + rem) / rem;
		
		// cerr << l << ' ' << r << '\t' << R << '\n';
		
		bool sofar = 0;
		for(int i = l; i <= r; i += R) {
			int a = i, b = min(r, i + R - 1);
			if(b == r && !sofar) push(a, b);
			else {
				if(query(a, b))
					sofar = 1,
					push(a, b);
			}
		}
		
		// if(a = (query(l, mid)))
			// push(l, mid);
		// if(!a || (sz(st) < k && query(mid + 1, r)))
			// push(mid + 1, r);
	}
	return;
}

std::vector<int> guessOnes(int n,int k) {
    sol.clear();
    divide(1, n, k);
    sort(all(sol));
    return sol;
}
