#include "ones.h"
#include <bits/stdc++.h>
#define all(x) (x).begin(),(x).end()

using namespace std;
using ll = long long;

// #define int ll
#define sz(x) ((int)(x).size())

using pii = pair<int,int>;
using tii = tuple<int,int,int>;

int query(int l, int r) {
    // cerr << l + 1 << ' ' << r + 1 << '\n';
    return hasOnes(l, r);
}

vector<int> sol;

auto cmp = [](pii a, pii b) { return a.second - a.first < b.second - b.first; };

priority_queue<pii, vector<pii>, decltype(cmp)> st(cmp);
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

int optimal_mid(int l, int r, int k) { 
	// if(k <= 10)
	if(r - l <= 6) return l + r >> 1;
	double T = pow(.5, 1./(double)(sqrt(k)));
	return min(r, max(l, (int)round((double)l * T + (double)r * (1. - T))));
}

void divide(int l, int r, int& k) {
	auto push = [&](int a, int b) {
		st.emplace(a, b);
		// cerr << a << ' ' << b << '\n';
	};
	
	int B = optimal_mid(l, r, k - sz(st)) - l + 1;
	for(int i = l; i <= r; i += B) {
		B = optimal_mid(i, r, k - sz(st)) - i + 1;
		int a = i, b = min(r, i + B - 1);
		if(query(a, b)) push(a, b);
	}
	// push(l, r);
	
	
	while(!st.empty()) {
		auto [l, r] = st.top();
		st.pop();
		if(l == r) {
			sol.emplace_back(l);
			k--;
			continue;
		}
		int mid = l + r >> 1, a = l, b = mid, c = mid + 1, d = r;
		if(rng() % 2) swap(a, c), swap(b, d);
		bool T;
		if((T = query(a, b))) push(a, b);
		if(!T || (sz(st) < k && query(c, d))) push(c, d);
		
		// int rem = min((int)ceil(sqrt(k)), k - sz(st) + 1);
		// int R = (r - l + rem) / rem;
		
		// cerr << l << ' ' << r << '\t' << R << '\n';
		
		// bool sofar = 0;
		// for(int i = l; i <= r; i += R) {
			// int a = i, b = min(r, i + R - 1);
			// if(b == r && !sofar) push(a, b);
			// else {
				// if(query(a, b))
					// sofar = 1,
					// push(a, b);
			// }
		// }
		
		// if(a = (query(l, mid)))
			// push(l, mid);
		// if(!a || (sz(st) < k && query(mid + 1, r)))
			// push(mid + 1, r);
	}
	return;
}

std::vector<int> guessOnes(int n,int k) {
    sol.clear();
    divide(1, n, k);
    sort(all(sol));
    return sol;
}
