#include <fstream>
#include <vector>
#include <algorithm>

using namespace std;
ifstream cin("a.in");
ofstream cout("a.out");
long long a[200005];
long long mod=1e8+543;
long long mat[60][10][10];
long long invs[60][10][10];
void afis(vector<long long>vec)
{
  for(long long i=0;i<vec.size();i++)
  {
    cout<<vec[i]%mod<<" ";
  }
  cout<<'\n';
}
long long ans[10];
void mlt(vector<long long> &vec,long long pwer)
{
  long long i,j;
  long long sum;
  for(i=1;i<=5;i++)
  {
    ans[i-1]=0;
    for(j=1;j<=5;j++)
        ans[i-1]+=1ll*vec[j-1]*mat[pwer][i][j];
    ans[i-1]%=mod;
  }
  for(i=0;i<=4;i++)
    vec[i]=ans[i];
}
void mlt2(vector<long long> &vec,long long pwer)
{
  long long i,j;
  long long sum;
  for(i=1;i<=5;i++)
  {
    ans[i-1]=0;
    for(j=1;j<=5;j++)
        ans[i-1]+=1ll*vec[j-1]*invs[pwer][i][j];
    ans[i-1]%=mod;
  }
  for(i=0;i<=4;i++)
    vec[i]=ans[i];
}
void multiply(long long pw)
{
  long long i,j,z;
  long long sum;
  for(i=1;i<=5;i++)
  {
      for(j=1;j<=5;j++)
      {
         sum=0;
         for(z=1;z<=5;z++)
         {
           sum+=1ll*mat[pw-1][i][z]*mat[pw-1][z][j];
         }
         sum%=mod;
         mat[pw][i][j]=sum;
      }
  }
}
void multiply2(long long pw)
{
  long long i,j,z;
  long long sum;
  for(i=1;i<=5;i++)
  {
      for(j=1;j<=5;j++)
      {
         sum=0;
         for(z=1;z<=5;z++)
         {
           sum+=1ll*invs[pw-1][i][z]*invs[pw-1][z][j];
         }
         sum%=mod;
         invs[pw][i][j]=sum;
      }
  }
}
void sclar(vector<long long>&a,long long exp,long long tip)
{
  long long cnt=1;
  if(tip==1)
  {
    swap(a[0],a[4]);
    swap(a[1],a[3]);
    while(exp)
    {
      if(exp%2==1)
      {
        mlt(a,cnt);
      }
      cnt++;
      exp=exp/2;
    }
    swap(a[0],a[4]);
    swap(a[1],a[3]);
  }
  else
  {
    while(exp)
    {
      if(exp%2==1)
      {
        mlt2(a,cnt);
      }
      cnt++;
      exp=exp/2;
    }
  }
  long long penis=a[0];
}
long long lz[600005];
vector<long long> coef[600005];
void build(long long node,long long st,long long dr)
{
  if(st!=dr)
  {
    long long mij=(st+dr)/2;
    build(node*2,st,mij);
    build(node*2+1,mij+1,dr);
    for(long long i=0;i<=4;i++)
    {
      coef[node].push_back((1ll*coef[node*2][i]+coef[node*2+1][i])%mod);
    }
    return;
  }
  for(long long i=0;i<=4;i++)
  {
    coef[node].push_back(i);
  }
}
void push_lazy(long long node,long long st,long long dr)
{
  if(lz[node]!=0)
  {
   // cout<<"penis";
    if(lz[node]>0)
      sclar(coef[node],lz[node],1);
    else
      sclar(coef[node],abs(lz[node]),-1);
    if(st!=dr)
    {
      lz[node*2]+=lz[node];
      lz[node*2+1]+=lz[node];
    }
    lz[node]=0;
  }
}
void update(long long node,long long st,long long dr,long long qst,long long qdr,long long val)
{
  push_lazy(node,st,dr);
  if(st>dr || st>qdr|| qst>dr ||qst>qdr)
  {
    return ;
  }
  if(qst<=st && dr<=qdr)
  {
    lz[node]=val;
    push_lazy(node,st,dr);
    return;
  }
  long long mij=(st+dr)/2;
  update(node*2,st,mij,qst,qdr,val);
  update(node*2+1,mij+1,dr,qst,qdr,val);
  for(long long i=0;i<=4;i++)
  {
    coef[node][i]=(1ll*coef[node*2][i]+coef[node*2+1][i])%mod;
  }
}
long long qr(long long node,long long st,long long dr,long long qst,long long qdr)
{
  push_lazy(node,st,dr);
  if(st>dr || st>qdr|| qst>dr ||qst>qdr)
  {
    return 0;
  }
  if(qst<=st && dr<=qdr)
  {
    long long trilulilu=coef[node][0];
    return coef[node][0];
  }
  long long mij=(st+dr)/2;
  return(qr(node*2,st,mij,qst,qdr)+qr(node*2+1,mij+1,dr,qst,qdr))%mod;
}
long long val[200005];
long long spar[200005];
signed  main()
{
    long long n,i,j,k,l,q;
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin>>n>>q;
    for(i=1;i<=5;i++)
    {
        mat[1][1][i]=6-i;
    }
    mat[1][2][1]=1;
    mat[1][3][2]=1;
    mat[1][4][3]=1;
    mat[1][5][4]=1;
    for(i=1;i<=5;i++)
    {
      invs[1][1][i]=mod-(i+1);
    }
    invs[1][1][5]=1;
    invs[1][2][1]=1;
    invs[1][3][2]=1;
    invs[1][4][3]=1;
    invs[1][5][4]=1;
    for(i=2;i<=55;i++)
    {
      multiply(i);
    }
    for(i=2;i<=55;i++)
    {
      multiply2(i);
    }
    build(1,1,n);
    for(i=1;i<=n;i++)
    {
      cin>>a[i];
     // cout<<val[i]<<" ";
      update(1,1,n,i,i,a[i]);
    }
    //cout<<'\n';
    long long tip,r;
    long long x;
   // cout<<(74654015+504263975)%mod;
  //  cout<<(93517136+43049138)%mod;
    for(i=1;i<=q;i++)
    {
      cin>>tip;
      if(tip==2)
      {
        cin>>l>>r>>x;
        update(1,1,n,l,r,x);
      }
      else
      {
        cin>>l>>r;
        cout<<qr(1,1,n,l,r)%mod<<'\n';
       // cout<<(spar[r]-spar[l-1]+mod*mod)%mod<<'\n';
      }
    }
    return 0;
}
