#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
//ifstream cin("a.in");
//ofstream cout("a.out");
#define  mlc __attribute__((target("avx2"),optimize("O3","unroll-loops")))
int a[200005];
long long mod=1e8+543;
int mat[60][10][10];
int invs[60][10][10];
void afis(vector<int>vec)
{
  for(int i=0;i<vec.size();i++)
  {
    cout<<vec[i]%mod<<" ";
  }
  cout<<'\n';
}
long long ans[10];
void mlt(vector<int> &vec,int pwer)
{
  int i,j;
  for(i=1;i<=5;i++)
  {
    ans[i-1]=0;
    for(j=1;j<=5;j++)
        ans[i-1]+=1ll*vec[j-1]*mat[pwer][i][j];
    ans[i-1]%=mod;
  }
  for(i=0;i<=4;i++)
    vec[i]=ans[i];
}
void mlt2(vector<int> &vec,int pwer)
{
  int i,j;
  for(i=1;i<=5;i++)
  {
    ans[i-1]=0;
    for(j=1;j<=5;j++)
        ans[i-1]+=1ll*vec[j-1]*invs[pwer][i][j];
    ans[i-1]%=mod;
  }
  for(i=0;i<=4;i++)
    vec[i]=ans[i];
}
void multiply(int pw)
{
  int i,j,z;
  long long sum;
  for(i=1;i<=5;i++)
  {
      for(j=1;j<=5;j++)
      {
         sum=0;
         for(z=1;z<=5;z++)
         {
           sum+=1ll*mat[pw-1][i][z]*mat[pw-1][z][j];
         }
         sum%=mod;
         mat[pw][i][j]=sum;
      }
  }
}
void multiply2(int pw)
{
  int i,j,z;
  long long sum;
  for(i=1;i<=5;i++)
  {
      for(j=1;j<=5;j++)
      {
         sum=0;
         for(z=1;z<=5;z++)
         {
           sum+=1ll*invs[pw-1][i][z]*invs[pw-1][z][j];
         }
         sum%=mod;
         invs[pw][i][j]=sum;
      }
  }
}
int lz[600005];
int coef[600005][7];
mlc void mltc(int node,int pwer)
{
  int i,j;
  for(i=1;i<=5;i++)
  {
    ans[i-1]=0;
    for(j=1;j<=5;j++)
        ans[i-1]+=1ll*coef[node][j-1]*mat[pwer][i][j];
    ans[i-1]%=mod;
  }
  for(i=0;i<=4;i++)
    coef[node][i]=ans[i];
}
mlc void mlt2c(int node,int pwer)
{
  int i,j;
  for(i=1;i<=5;i++)
  {
    ans[i-1]=0;
    for(j=1;j<=5;j++)
        ans[i-1]+=1ll*coef[node][j-1]*invs[pwer][i][j];
    ans[i-1]%=mod;
  }
  for(i=0;i<=4;i++)
    coef[node][i]=ans[i];
}
void sclar(int node,long long exp,int tip)
{
  int cnt=1;
  exp=exp%mod;
  if(tip==1)
  {
    swap(coef[node][0],coef[node][4]);
    swap(coef[node][1],coef[node][3]);
    while(exp)
    {
      if(exp%2==1)
      {
        mltc(node,cnt);
      }
      cnt++;
      exp=exp/2;
    }
    swap(coef[node][0],coef[node][4]);
    swap(coef[node][1],coef[node][3]);
  }
  else
  {
    while(exp)
    {
      if(exp%2==1)
      {
        mlt2c(node,cnt);
      }
      cnt++;
      exp=exp/2;
    }
  }
}
void build(int node,int st,int dr)
{
  if(st!=dr)
  {
    int mij=(st+dr)/2;
    build(node*2,st,mij);
    build(node*2+1,mij+1,dr);
    for(int i=0;i<=4;i++)
    {
      coef[node][i]=(1ll*coef[node*2][i]+coef[node*2+1][i])%mod;
    }
    return;
  }
  for(int i=0;i<=4;i++)
  {
    coef[node][i]=i;
  }
}
void push_lazy(int node,int st,int dr)
{
  if(lz[node]!=0)
  {
   // cout<<"penis";
    if(lz[node]>0)
      sclar(node,lz[node],1);
    else
      sclar(node,abs(lz[node]),-1);
    if(st!=dr)
    {
      lz[node*2]+=lz[node];
      lz[node*2+1]+=lz[node];
    }
    lz[node]=0;
  }
}
void update(int node,int st,int dr,int qst,int qdr,int val)
{
  push_lazy(node,st,dr);
  if(st>dr || st>qdr|| qst>dr ||qst>qdr)
  {
    return ;
  }
  if(qst<=st && dr<=qdr)
  {
    lz[node]=val;
    push_lazy(node,st,dr);
    return;
  }
  int mij=(st+dr)/2;
  update(node*2,st,mij,qst,qdr,val);
  update(node*2+1,mij+1,dr,qst,qdr,val);
  for(int i=0;i<=4;i++)
  {
    coef[node][i]=(1ll*coef[node*2][i]+coef[node*2+1][i])%mod;
  }
}
int qr(int node,int st,int dr,int qst,int qdr)
{
  push_lazy(node,st,dr);
  if(st>dr || st>qdr|| qst>dr ||qst>qdr)
  {
    return 0;
  }
  if(qst<=st && dr<=qdr)
  {
    int trilulilu=coef[node][0];
    return coef[node][0];
  }
  int mij=(st+dr)/2;
  return(qr(node*2,st,mij,qst,qdr)+qr(node*2+1,mij+1,dr,qst,qdr))%mod;
}
int val[200005];
int spar[200005];
signed  main()
{
    int n,i,j,k,l,q;
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin>>n>>q;
    for(i=1;i<=5;i++)
    {
        mat[1][1][i]=6-i;
    }
    mat[1][2][1]=1;
    mat[1][3][2]=1;
    mat[1][4][3]=1;
    mat[1][5][4]=1;
    for(i=1;i<=5;i++)
    {
      invs[1][1][i]=mod-(i+1);
    }
    invs[1][1][5]=1;
    invs[1][2][1]=1;
    invs[1][3][2]=1;
    invs[1][4][3]=1;
    invs[1][5][4]=1;
    for(i=2;i<=58;i++)
    {
      multiply(i);
    }
    for(i=2;i<=58;i++)
    {
      multiply2(i);
    }
    build(1,1,n);
    for(i=1;i<=n;i++)
    {
      cin>>a[i];
     // cout<<val[i]<<" ";
      update(1,1,n,i,i,a[i]);
    }
    //cout<<'\n';
    int tip,r;
    int x;
   // cout<<(74654015+504263975)%mod;
  //  cout<<(93517136+43049138)%mod;
    for(i=1;i<=q;i++)
    {
      cin>>tip;
      if(tip==2)
      {
        cin>>l>>r>>x;
        update(1,1,n,l,r,x);
      }
      else
      {
        cin>>l>>r;
        cout<<qr(1,1,n,l,r)%mod<<'\n';
       // cout<<(spar[r]-spar[l-1]+mod*mod)%mod<<'\n';
      }
    }
    return 0;
}
