#include "ones.h"
#include <iostream>
#include <time.h>
#include <random>

#define vt vector
#define pb push_back

using namespace std;

mt19937 rng(time(0));

int gen(int l, int r){
    return (rng() % (r - l + 1)) + l;
}

int find_first(int l, int r){
    int st = l, dr = r, ans = -1;
    while(st <= dr){
        int mid = gen(st, dr);
        if(hasOnes(l, mid)){
            ans = mid;
            dr = mid - 1;
        }else{
            st = mid + 1;
        }
    }
    return ans;
}

vector<int> guessOnes(int n,int k){
    vt <int> ans;
    int last = 0;
    for(int i = 1; i <= k; i++){
        ans.pb(find_first(last + 1, n));
        last = ans.back();
    }
    return ans;
}

/*
7 2 1
2 5
*/
