#include "ones.h"

using namespace std;

int findLeftmost(int l, int r) {
    if (l == r)
        return l;
    int mij((l + r) / 2);
    if (hasOnes(l, mij))
        return findLeftmost(l, mij);
    else
        return findLeftmost(mij + 1, r);
}

vector < int > guessOnes(int n, int k) {
    vector < int > ans;
    int last(0);
    while (k--) {
        int one = findLeftmost(last + 1, n);
        ans.push_back(one);
        last = one;
    }
    return ans;
}
