#include "ones.h"
#include <random>
#include <cmath>
#include <algorithm>
#include <iterator>
#include <iostream>

using namespace std;

int BUBUBANGA = 4;

int findLeftmost(int l, int r) {
    if (l == r)
        return l;
    int mij((l + r) / 2);
    if (hasOnes(l, mij))
        return findLeftmost(l, mij);
    else
        return findLeftmost(mij + 1, r);
}

vector < int > guessOnes(int n, int k) {
    BUBUBANGA = sqrt((n / k) * 16.0 / 10);
    vector < int > ans;
    vector < pair < int, int > > posibil;
    for (int i = 1; i < n; i += BUBUBANGA) {
        int j = min(n, i + BUBUBANGA - 1);
        if (!hasOnes(i, j))
            continue;
        int one = findLeftmost(i, j);
        ans.push_back(one), k--;
        if (one < j)
            posibil.push_back({one + 1, j});
    }
    random_shuffle(posibil.begin(), posibil.end());
    while (k) {
//        cout << posibil.back().first << ' ' << posibil.back().second << '\n';
        if (hasOnes(posibil.back().first, posibil.back().second)) {
            for (int i = posibil.back().first; i <= posibil.back().second; ++i)
                if (hasOnes(i, i))
                    ans.push_back(i), k--;
        }
        posibil.pop_back();
    }
    sort(ans.begin(), ans.end());
    return ans;
}
