#include <iostream>
#include <vector>
#include <assert.h>
#include <algorithm>
#include <bits/stdc++.h>
using namespace std;

const int NMAX = 1e5; // for now, modifica cand trimiti
const int LOG = 17;

bool hasOnes(int l,int r);

vector<int> ans;
int nn, kk;

struct ura {
  int l, r, maxy;
} st[LOG * NMAX]; // stiva de recursivitate
int ptr;

void solve(int l, int r, int maxy) {
  st[++ptr] = {l, r, maxy};
  while (ptr >= 0) {
    auto x = st[ptr--];

    l = x.l;
    r = x.r;
    maxy = x.maxy;

    if (l == r) {
      ans.push_back(l);
      if (ans.size() == kk)
        break;
      continue;
    }

    if (maxy == 1) {
      int mij = (l + r) / 2;
      if (hasOnes(l, mij))
        st[++ptr] = {l, mij, maxy};
      else
        st[++ptr] = {mij + 1, r, maxy};
    } else {
      /// impart in k + 1 secvente
      int k = maxy + 1, a = l, q, cnt = 0;
      int old_ptr = ptr;
      for (int i = 0; i < k; i++) {
        q = a + (r - a + 1) / (k - i);
        q = min(q, r);
        if (i == k - 1)
          q = r;
       // assert(a <= q);
        if (a <= q && hasOnes(a, q)) {
          st[++ptr] = {.l = a, .r = q, .maxy = q - a + 1};
          cnt++;
        }

        a = q + 1;
      }

      old_ptr++;
      while (old_ptr <= ptr) {
        st[old_ptr].maxy = min(st[old_ptr].maxy, maxy - (cnt - 1));
        old_ptr++;
      }
    }

  }
}


vector<int> guessOnes(int n,int k) {
  nn = n, kk = k;
  ans.clear();
  ptr = 0;
  solve(1, n, k);
  sort(ans.begin(), ans.end());
  return ans;
}

/*
10 5 1
1 3 7 4 6

1 0 1 1 0 1 1 0 0 0
*/

/*
10 3 1
2 6 10

0 1 0 0 0 1 0 0 0 1
*/
