// bellik eden zatlary oka tazeden
#include  <bits/stdc++.h>
using namespace std;
const int N = 1e8 + 5;
const int NN = 1e5 + 5;
#define ll long long
ll md = 1e8 + 543;
ll a[NN], b[N], n, q, jogap;
ll st[5 * NN];
// memora gowy edip seret
// segment tree-da size-yny 5 kopelmek etmeli

void update (int idx, int l, int r, int x, ll val) {
	if (l == r) {
		st[idx] = val; 
		st[idx] %= md;
		return;
	}
	int mid = (l + r) / 2;
	if (x <= mid) update (idx * 2, l, mid, x, val);
	else update (idx * 2 + 1, mid + 1, r, x, val);
	st[idx] = st[idx * 2] + st[idx * 2 + 1];
	st[idx] %= md;
}


void cykar (int idx, int l, int r, int x, int y) {
	if (x <= l and r <= y) {
		jogap += st[idx];
		jogap %= md;
		return;
	}
	if (x > r or l > y) return;
	int mid = (l + r) / 2;
	cykar (idx * 2, l, mid, x, y);
	cykar (idx * 2 + 1, mid + 1, r, x, y);
}

int main () {
	ios::sync_with_stdio(0);cin.tie(0);cout.tie(0);
	cin >> n >> q;
	for (int i = 1; i <= n; ++i) {
		cin >> a[i];
	}
	for (int i = 0; i <= 4; ++i) {
		b[i] = i;
	}
	for (int i = 5; i < N; ++i) {
		ll sum = 5LL * b[i - 1];
		sum %= md;
		sum += 4LL * b[i - 2];
		sum %= md;
		sum += 3LL * b[i - 3];
		sum %= md;
		sum += 2LL * b[i - 4];
		sum %= md;
		sum += 1LL * b[i - 5];
		sum %= md;
		b[i] = sum;
	}
	for (int i = 1; i <= n; ++i) {
		update (1, 1, n, i, b[a[i]]);
	}
	//  sonurrak 5 balam al onda l==r daldir
	
	while ( q-- ) {
		int type, l, r;
		cin >> type >> l >> r;
		//minus bolsa ustune md goshmaly
		if (type == 2) {
			ll val;
			cin >> val;
			a[l] += val;
			update (1, 1, n, l, val);
		}
		else {
			jogap = 0;
			cykar (1, 1, n, l, r);
			while (jogap < 0) jogap += md;
			cout << jogap << "\n";
		}
	}
}
/*
4 3
0 2 4 6
1 1 4 
2 3 3 1
1 2 3




4 3
0 2 4 6
1 1 4 
1 3 3
1 2 3


236
42
*/