#include <bits/stdc++.h>
using namespace std;
bool hasOnes(int l,int r);


/*
when k is large, we want initially to divide by a lot, and then divide by 2
*/

int choose_bs_thresh(int tk) {
    if (tk < 100 || tk > 2000) return 30000;
    return 10000;
}

int choose_mid(int k, int density_, int l, int r) {
    if (r - l < choose_bs_thresh(k)) 
        return (r + l) / 2; 
    k = max(k, 5);
    int density = (r - l + k - 1) / k;
    int length = r - l;
    int expected_to_be = l + round(1.5 * density_);
    return min(r - (r - l) / 3, expected_to_be);
}

vector<int> guessOnes(int n,int k) {
    int ik = k;
    srand(time(0));
    vector<int> res;
    int ptr = 1;
    while (ptr <= n && k > 0) {
        while (k > 0 && hasOnes(ptr, ptr)) {
            res.push_back(ptr);
            ++ptr;
            --k;
        }
        if (k == 0) break;
        int low = ptr, high = n;
        int density = (high - low + k - 1) / k;
        auto go = [&] (int point) {
            if (point - low < 2 * (n - point)) {
                if (hasOnes(ptr, point)) high = point;
                else low = point;
                return true;
            }
            return false;
        };
        if (!go(low + density))
            if (!go(low + 2 * density))
                go(low + 3 * density);
        while (high - low > 1) {
            // int div = (high - low > 1000 ?)
            // div = 4;
            int mid = choose_mid(k, density, low, high);
            if (hasOnes(ptr, mid)) high = mid;
            else low = mid;
        }
        res.push_back(high);
        ptr = high + 1;
        --k;
    }
    return res;
}
