#include <bits/stdc++.h>

#include "ones.h"
#include "Lgrader.cpp"

using namespace std;

vector<int> guessOnes(int n, int k) {
    vector<int> ans;

    int i = 1;
    int cur = 0;

    while (cur < k) {
        int m = ((n - i + 1) / (k - cur));
        m = (1 << ((int)log2(m) + 1)) - 1;
        if (i + m - 1 < n && !hasOnes(i, i + m - 1)) {
            i += m;
            continue;
        }
        int l = i, r = min(i + m - 1, n);

        bool found = false;

        while (l <= r) {
            int mid = (l + r) / 2;
            if (hasOnes(i, mid)) {
                r = mid - 1;
                found = true;
            }
            else {
                l = mid + 1;
            }
        }

        if (found) {
            ans.push_back(r + 1);
            cur++;
            i = r + 2;
        }
        else {
            i = r + 1;
        }
        
    }

    return ans;
}