#include <bits/stdc++.h>

#define ll long long
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define watch(x) cout << (#x) << " : " << x << '\n'
#define boost ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

using namespace std;

const int MOD = 1e8 + 543;
const int N = 1e5 + 128;
ll v[N];

#define matrix vector<vector<ll>>

void add_self(ll& a, ll b) {
    b += MOD;
    b %= MOD;
    a = (a + b) % MOD;
}

void mult(matrix& a, matrix b) {
    int n = (int)a.size(), m = (int)a[0].size(), p = (int)b.size(), hm = (int)b[0].size();
    assert(m == p);
    matrix res(n, vector<ll>(hm));
    for (int i = 0; i < n; i++)
        for (int j = 0; j < hm; j++)
            for (int k = 0; k < m; k++)
                add_self(res[i][j], a[i][k] * b[k][j]);
    a = res;
}

matrix binpow(matrix a, ll n) {
    assert((int)a.size() == (int)a[0].size());
    int sz = (int)a.size();
    matrix res(sz, vector<ll>(sz));
    for (int i = 0; i < sz; i++)
        res[i][i] = 1;

    while (n) {
        if (n & 1)
            mult(res, a);
        mult(a, a);
        n >>= 1;
    }

    return res;
}

void print(matrix a) {
    for (int i = 0; i < (int)a.size(); i++, cout << '\n')
        for (int j = 0; j < (int)a[0].size(); j++)
            cout << a[i][j] << ' ';
}

matrix a = { {0},
             {1},
             {2},
             {3},
             {4},
             {0} };

matrix i = { {0, 1, 0, 0, 0, 0},
             {0, 0, 1, 0, 0, 0},
             {0, 0, 0, 1, 0, 0},
             {0, 0, 0, 0, 1, 0},
             {1, 2, 3, 4, 5, 0},
             {0, 0, 0, 0, 1, 1} };

ll get(ll idx) {
    if (idx <= 4)
        return idx;
    matrix tr = i;
    tr = binpow(tr, idx - 4);
    mult(tr, a);
    return tr[4][0];
}

void solve() {
//    vector <int> x{0, 1, 2, 3, 4};
//
//    for (int i = 0; i < 20; i++) {
//        ll val = x[i];
//        add_self(val, 2 * x[i + 1]);
//        add_self(val, 3 * x[i + 2]);
//        add_self(val, 4 * x[i + 3]);
//        add_self(val, 5 * x[i + 4]);
//        x.push_back(val);
//    }
//
//    for (auto& c : x)
//        cout << c << ' ';
//    cout << '\n';
//
//    for (int c = 0; c < (int)x.size(); c++) {
//        cout << get(c) << ' ';
//    }
//    cout << '\n';
    int n, q;
    cin >> n >> q;

    for (int i = 1; i <= n; i++)
        cin >> v[i];

    while (q--) {
        int type, l, r;
        cin >> type >> l >> r;
        assert(l == r);

        if (type == 1) {
            cout << (get(v[l])%MOD + MOD) % MOD << '\n';
        } else {
            ll val;
            cin >> val;
            v[l] += val;
        }
    }
}

main() {
    boost;
    solve();
    return 0;
}
